#ifndef included_ANL_CodeGenerationI_IOR_FileOutput_stub
#include "ANL/CodeGenerationI/IOR/FileOutput/FileOutput.hh"
#endif

void
ANL::CodeGenerationI::IOR::FileOutput::addReference()
throw (
  ::SIDL::NullIORException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDL::BaseInterface::addReference()");
    throw e;
  }
  if (d_weak_reference) return;
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  // Dispatch to IOR
  (*(d_self->d_epv->f_addReference))(d_self);
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

void
ANL::CodeGenerationI::IOR::FileOutput::deleteReference()
throw (
  ::SIDL::NullIORException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDL::BaseInterface::deleteReference()");
    throw e;
  }
  if (d_weak_reference) return;
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  // Dispatch to IOR
  (*(d_self->d_epv->f_deleteReference))(d_self);
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

bool
ANL::CodeGenerationI::IOR::FileOutput::isSame(
  /*in*/ ::SIDL::BaseInterface iobj)
throw (
  ::SIDL::NullIORException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDL::BaseInterface::isSame()");
    throw e;
  }
  // Return value setup
  bool _result;
  SIDL_bool _local__result;
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_isSame))(d_self, /*in*/ iobj._get_ior());
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
  _result = (_local__result != FALSE);
  return _result;
}

::SIDL::BaseInterface
ANL::CodeGenerationI::IOR::FileOutput::queryInterface(
  /*in*/ std::string name)
throw (
  ::SIDL::NullIORException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDL::BaseInterface::queryInterface()");
    throw e;
  }
  // Return value setup
  ::SIDL::BaseInterface _result;
  struct SIDL_BaseInterface__object * _local__result;
  // Pack arguments for dispatch to IOR
  char *_local_name = NULL;
  if (name.c_str()) {
    _local_name = (char *) malloc(strlen(name.c_str())+1);
    strcpy(_local_name, name.c_str());
  }
  // Exception handling setup
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_queryInterface))(d_self, /*in*/ _local_name);
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  if (_local_name) {::free((void *) _local_name);}
  // Return value cleanup
  _result = ::SIDL::BaseInterface(_local__result);
  if (_result._not_nil()) {
    _result.deleteReference();
  }
  return _result;
}

bool
ANL::CodeGenerationI::IOR::FileOutput::isInstanceOf(
  /*in*/ std::string name)
throw (
  ::SIDL::NullIORException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDL::BaseInterface::isInstanceOf()");
    throw e;
  }
  // Return value setup
  bool _result;
  SIDL_bool _local__result;
  // Pack arguments for dispatch to IOR
  char *_local_name = NULL;
  if (name.c_str()) {
    _local_name = (char *) malloc(strlen(name.c_str())+1);
    strcpy(_local_name, name.c_str());
  }
  // Exception handling setup
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_isInstanceOf))(d_self, /*in*/ _local_name);
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  if (_local_name) {::free((void *) _local_name);}
  // Return value cleanup
  _result = (_local__result != FALSE);
  return _result;
}

std::string
ANL::CodeGenerationI::IOR::FileOutput::getRoot(
  /*in*/ std::string purpose)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::FileOutput::getRoot()");
    throw e;
  }
  // Return value setup
  std::string _result;
  char * _local__result;
  // Pack arguments for dispatch to IOR
  char *_local_purpose = NULL;
  if (purpose.c_str()) {
    _local_purpose = (char *) malloc(strlen(purpose.c_str())+1);
    strcpy(_local_purpose, purpose.c_str());
  }
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_getRoot))(d_self, /*in*/ _local_purpose, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  if (_local_purpose) {::free((void *) _local_purpose);}
  // Return value cleanup
  _result = _local__result;
  if (_local__result) {::free((void *) _local__result);}
  return _result;
}

void
ANL::CodeGenerationI::IOR::FileOutput::setRoot(
  /*in*/ std::string purpose,
  /*in*/ std::string path)
throw (
  ::SIDLLanguage::VisitorException,
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::FileOutput::setRoot()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  char *_local_purpose = NULL;
  if (purpose.c_str()) {
    _local_purpose = (char *) malloc(strlen(purpose.c_str())+1);
    strcpy(_local_purpose, purpose.c_str());
  }
  char *_local_path = NULL;
  if (path.c_str()) {
    _local_path = (char *) malloc(strlen(path.c_str())+1);
    strcpy(_local_path, path.c_str());
  }
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_setRoot))(d_self, /*in*/ _local_purpose, /*in*/ _local_path, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDLLanguage.VisitorException")) != 0) {
      struct SIDLLanguage_VisitorException__object *_realtype = reinterpret_cast< struct SIDLLanguage_VisitorException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDLLanguage::VisitorException(_realtype, false);
    }
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  if (_local_purpose) {::free((void *) _local_purpose);}
  if (_local_path) {::free((void *) _local_path);}
  // Return value cleanup
}

bool
ANL::CodeGenerationI::IOR::FileOutput::getOutputSource()
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::FileOutput::getOutputSource()");
    throw e;
  }
  // Return value setup
  bool _result;
  SIDL_bool _local__result;
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_getOutputSource))(d_self, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
  _result = (_local__result != FALSE);
  return _result;
}

void
ANL::CodeGenerationI::IOR::FileOutput::setOutputSource(
  /*in*/ bool outputSource)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::FileOutput::setOutputSource()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  SIDL_bool _local_outputSource = (outputSource != FALSE);
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_setOutputSource))(d_self, /*in*/ _local_outputSource, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

::SIDLLanguage::Splicer
ANL::CodeGenerationI::IOR::FileOutput::getSplicer()
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::FileOutput::getSplicer()");
    throw e;
  }
  // Return value setup
  ::SIDLLanguage::Splicer _result;
  struct SIDLLanguage_Splicer__object * _local__result;
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_getSplicer))(d_self, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
  _result = ::SIDLLanguage::Splicer(_local__result);
  if (_result._not_nil()) {
    _result.deleteReference();
  }
  return _result;
}

void
ANL::CodeGenerationI::IOR::FileOutput::setSplicer(
  /*in*/ ::SIDLLanguage::Splicer splicer)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::FileOutput::setSplicer()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_setSplicer))(d_self, /*in*/ splicer._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

::SIDLLanguage::Code
ANL::CodeGenerationI::IOR::FileOutput::getCodeOutput()
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::FileOutput::getCodeOutput()");
    throw e;
  }
  // Return value setup
  ::SIDLLanguage::Code _result;
  struct SIDLLanguage_Code__object * _local__result;
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_getCodeOutput))(d_self, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
  _result = ::SIDLLanguage::Code(_local__result);
  if (_result._not_nil()) {
    _result.deleteReference();
  }
  return _result;
}

void
ANL::CodeGenerationI::IOR::FileOutput::setCodeOutput(
  /*in*/ ::SIDLLanguage::Code output)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::FileOutput::setCodeOutput()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_setCodeOutput))(d_self, /*in*/ output._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

::SIDL::array< std::string >
ANL::CodeGenerationI::IOR::FileOutput::getOutputFiles()
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::FileOutput::getOutputFiles()");
    throw e;
  }
  // Return value setup
  ::SIDL::array< std::string > _result;
  struct SIDL_string__array * _local__result;
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_getOutputFiles))(d_self, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
  _result._set_ior(_local__result);
  return _result;
}

void
ANL::CodeGenerationI::IOR::FileOutput::clearOutputFiles()
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::FileOutput::clearOutputFiles()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_clearOutputFiles))(d_self, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

::SIDL::array< ::SIDLLanguage::AST >
ANL::CodeGenerationI::IOR::FileOutput::getRepository()
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Visitor::getRepository()");
    throw e;
  }
  // Return value setup
  ::SIDL::array< ::SIDLLanguage::AST > _result;
  struct SIDLLanguage_AST__array * _local__result;
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_getRepository))(d_self, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
  _result._set_ior(_local__result);
  return _result;
}

void
ANL::CodeGenerationI::IOR::FileOutput::setRepository(
  /*in*/ ::SIDL::array< ::SIDLLanguage::AST > repository)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Visitor::setRepository()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_setRepository))(d_self, /*in*/ repository._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

void
ANL::CodeGenerationI::IOR::FileOutput::visitAST(
  /*in*/ ::SIDLLanguage::AST node)
throw (
  ::SIDLLanguage::VisitorException,
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Visitor::visitAST()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_visitAST))(d_self, /*in*/ node._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDLLanguage.VisitorException")) != 0) {
      struct SIDLLanguage_VisitorException__object *_realtype = reinterpret_cast< struct SIDLLanguage_VisitorException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDLLanguage::VisitorException(_realtype, false);
    }
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

void
ANL::CodeGenerationI::IOR::FileOutput::visitSpecification(
  /*in*/ ::SIDLLanguage::Specification node)
throw (
  ::SIDLLanguage::VisitorException,
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Visitor::visitSpecification()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_visitSpecification))(d_self, /*in*/ node._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDLLanguage.VisitorException")) != 0) {
      struct SIDLLanguage_VisitorException__object *_realtype = reinterpret_cast< struct SIDLLanguage_VisitorException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDLLanguage::VisitorException(_realtype, false);
    }
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

void
ANL::CodeGenerationI::IOR::FileOutput::visitVersion(
  /*in*/ ::SIDLLanguage::Version node)
throw (
  ::SIDLLanguage::VisitorException,
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Visitor::visitVersion()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_visitVersion))(d_self, /*in*/ node._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDLLanguage.VisitorException")) != 0) {
      struct SIDLLanguage_VisitorException__object *_realtype = reinterpret_cast< struct SIDLLanguage_VisitorException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDLLanguage::VisitorException(_realtype, false);
    }
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

void
ANL::CodeGenerationI::IOR::FileOutput::visitPackage(
  /*in*/ ::SIDLLanguage::Package node)
throw (
  ::SIDLLanguage::VisitorException,
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Visitor::visitPackage()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_visitPackage))(d_self, /*in*/ node._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDLLanguage.VisitorException")) != 0) {
      struct SIDLLanguage_VisitorException__object *_realtype = reinterpret_cast< struct SIDLLanguage_VisitorException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDLLanguage::VisitorException(_realtype, false);
    }
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

void
ANL::CodeGenerationI::IOR::FileOutput::visitInterface(
  /*in*/ ::SIDLLanguage::Interface node)
throw (
  ::SIDLLanguage::VisitorException,
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Visitor::visitInterface()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_visitInterface))(d_self, /*in*/ node._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDLLanguage.VisitorException")) != 0) {
      struct SIDLLanguage_VisitorException__object *_realtype = reinterpret_cast< struct SIDLLanguage_VisitorException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDLLanguage::VisitorException(_realtype, false);
    }
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

void
ANL::CodeGenerationI::IOR::FileOutput::visitClass(
  /*in*/ ::SIDLLanguage::Class node)
throw (
  ::SIDLLanguage::VisitorException,
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Visitor::visitClass()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_visitClass))(d_self, /*in*/ node._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDLLanguage.VisitorException")) != 0) {
      struct SIDLLanguage_VisitorException__object *_realtype = reinterpret_cast< struct SIDLLanguage_VisitorException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDLLanguage::VisitorException(_realtype, false);
    }
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

void
ANL::CodeGenerationI::IOR::FileOutput::visitMethod(
  /*in*/ ::SIDLLanguage::Method node)
throw (
  ::SIDLLanguage::VisitorException,
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Visitor::visitMethod()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_visitMethod))(d_self, /*in*/ node._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDLLanguage.VisitorException")) != 0) {
      struct SIDLLanguage_VisitorException__object *_realtype = reinterpret_cast< struct SIDLLanguage_VisitorException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDLLanguage::VisitorException(_realtype, false);
    }
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

void
ANL::CodeGenerationI::IOR::FileOutput::visitType(
  /*in*/ ::SIDLLanguage::Type node)
throw (
  ::SIDLLanguage::VisitorException,
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Visitor::visitType()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_visitType))(d_self, /*in*/ node._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDLLanguage.VisitorException")) != 0) {
      struct SIDLLanguage_VisitorException__object *_realtype = reinterpret_cast< struct SIDLLanguage_VisitorException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDLLanguage::VisitorException(_realtype, false);
    }
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

void
ANL::CodeGenerationI::IOR::FileOutput::visitEnumeration(
  /*in*/ ::SIDLLanguage::Enumeration node)
throw (
  ::SIDLLanguage::VisitorException,
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Visitor::visitEnumeration()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_visitEnumeration))(d_self, /*in*/ node._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDLLanguage.VisitorException")) != 0) {
      struct SIDLLanguage_VisitorException__object *_realtype = reinterpret_cast< struct SIDLLanguage_VisitorException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDLLanguage::VisitorException(_realtype, false);
    }
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

void
ANL::CodeGenerationI::IOR::FileOutput::visitEnumerator(
  /*in*/ ::SIDLLanguage::Enumerator node)
throw (
  ::SIDLLanguage::VisitorException,
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Visitor::visitEnumerator()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_visitEnumerator))(d_self, /*in*/ node._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDLLanguage.VisitorException")) != 0) {
      struct SIDLLanguage_VisitorException__object *_realtype = reinterpret_cast< struct SIDLLanguage_VisitorException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDLLanguage::VisitorException(_realtype, false);
    }
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

void
ANL::CodeGenerationI::IOR::FileOutput::visitArray(
  /*in*/ ::SIDLLanguage::Array node)
throw (
  ::SIDLLanguage::VisitorException,
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Visitor::visitArray()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_visitArray))(d_self, /*in*/ node._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDLLanguage.VisitorException")) != 0) {
      struct SIDLLanguage_VisitorException__object *_realtype = reinterpret_cast< struct SIDLLanguage_VisitorException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDLLanguage::VisitorException(_realtype, false);
    }
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

void
ANL::CodeGenerationI::IOR::FileOutput::visitParameter(
  /*in*/ ::SIDLLanguage::Parameter node)
throw (
  ::SIDLLanguage::VisitorException,
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Visitor::visitParameter()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_visitParameter))(d_self, /*in*/ node._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDLLanguage.VisitorException")) != 0) {
      struct SIDLLanguage_VisitorException__object *_realtype = reinterpret_cast< struct SIDLLanguage_VisitorException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDLLanguage::VisitorException(_realtype, false);
    }
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

void
ANL::CodeGenerationI::IOR::FileOutput::visitComment(
  /*in*/ ::SIDLLanguage::Comment node)
throw (
  ::SIDLLanguage::VisitorException,
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Visitor::visitComment()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_visitComment))(d_self, /*in*/ node._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDLLanguage.VisitorException")) != 0) {
      struct SIDLLanguage_VisitorException__object *_realtype = reinterpret_cast< struct SIDLLanguage_VisitorException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDLLanguage::VisitorException(_realtype, false);
    }
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

const ::ANL::CodeGenerationI::IOR::FileOutput::ext_t *::ANL::CodeGenerationI::IOR::FileOutput::s_ext;

const ::ANL::CodeGenerationI::IOR::FileOutput::ext_t *::ANL::CodeGenerationI::IOR::FileOutput::_get_ext() throw (::SIDL::NullIORException) {
  if (!s_ext) {
#ifdef SIDL_STATIC_LIBRARY
      s_ext = ANL_CodeGenerationI_IOR_FileOutput__externals();
#else
      const ext_t *(*dll_f)(void) = (const ext_t *(*)(void)) ::SIDL::Loader::lookupSymbol("ANL_CodeGenerationI_IOR_FileOutput__externals");

      s_ext = (dll_f ? (*dll_f)() : NULL);
      if (!s_ext) {
        ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();

        e.setMessage("Cannot find implementation for ANL.CodeGenerationI.IOR.FileOutput; add library to SIDL_DLL_PATH");
        throw e;
      }
#endif
  }
  return s_ext;
}

