#ifndef included_ANL_SIDL_Query_PackageLocator_stub
#include "ANL/SIDL/Query/PackageLocator/PackageLocator.hh"
#endif

void
ANL::SIDL::Query::PackageLocator::setPackageIdentifier(
  /*in*/ std::string identifier)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::ANL::SIDL::Query::PackageLocator::setPackageIdentifier()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  char *_local_identifier = NULL;
  if (identifier.c_str()) {
    _local_identifier = (char *) malloc(strlen(identifier.c_str())+1);
    strcpy(_local_identifier, identifier.c_str());
  }
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_setPackageIdentifier))(d_self, /*in*/ _local_identifier, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  if (_local_identifier) {::free((void *) _local_identifier);}
  // Return value cleanup
}

std::string
ANL::SIDL::Query::PackageLocator::getPackageIdentifier()
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::ANL::SIDL::Query::PackageLocator::getPackageIdentifier()");
    throw e;
  }
  // Return value setup
  std::string _result;
  char * _local__result;
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_getPackageIdentifier))(d_self, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
  _result = _local__result;
  if (_local__result) {::free((void *) _local__result);}
  return _result;
}

bool
ANL::SIDL::Query::PackageLocator::hasPackage()
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::ANL::SIDL::Query::PackageLocator::hasPackage()");
    throw e;
  }
  // Return value setup
  bool _result;
  SIDL_bool _local__result;
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_hasPackage))(d_self, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
  _result = (_local__result != FALSE);
  return _result;
}

::SIDLLanguage::Package
ANL::SIDL::Query::PackageLocator::getPackage()
throw (
  ::SIDLLanguage::VisitorException,
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::ANL::SIDL::Query::PackageLocator::getPackage()");
    throw e;
  }
  // Return value setup
  ::SIDLLanguage::Package _result;
  struct SIDLLanguage_Package__object * _local__result;
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_getPackage))(d_self, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDLLanguage.VisitorException")) != 0) {
      struct SIDLLanguage_VisitorException__object *_realtype = reinterpret_cast< struct SIDLLanguage_VisitorException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDLLanguage::VisitorException(_realtype, false);
    }
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
  _result = ::SIDLLanguage::Package(_local__result);
  if (_result._not_nil()) {
    _result.deleteReference();
  }
  return _result;
}

void
ANL::SIDL::Query::PackageLocator::visitPackage(
  /*in*/ ::SIDLLanguage::Package node)
throw (
  ::SIDLLanguage::VisitorException,
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::ANL::SIDL::Query::PackageLocator::visitPackage()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_visitPackage))(d_self, /*in*/ node._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDLLanguage.VisitorException")) != 0) {
      struct SIDLLanguage_VisitorException__object *_realtype = reinterpret_cast< struct SIDLLanguage_VisitorException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDLLanguage::VisitorException(_realtype, false);
    }
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

void
ANL::SIDL::Query::PackageLocator::addReference()
throw (
  ::SIDL::NullIORException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDL::BaseInterface::addReference()");
    throw e;
  }
  if (d_weak_reference) return;
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  // Dispatch to IOR
  (*(d_self->d_epv->f_addReference))(d_self);
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

void
ANL::SIDL::Query::PackageLocator::deleteReference()
throw (
  ::SIDL::NullIORException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDL::BaseInterface::deleteReference()");
    throw e;
  }
  if (d_weak_reference) return;
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  // Dispatch to IOR
  (*(d_self->d_epv->f_deleteReference))(d_self);
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

bool
ANL::SIDL::Query::PackageLocator::isSame(
  /*in*/ ::SIDL::BaseInterface iobj)
throw (
  ::SIDL::NullIORException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDL::BaseInterface::isSame()");
    throw e;
  }
  // Return value setup
  bool _result;
  SIDL_bool _local__result;
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_isSame))(d_self, /*in*/ iobj._get_ior());
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
  _result = (_local__result != FALSE);
  return _result;
}

::SIDL::BaseInterface
ANL::SIDL::Query::PackageLocator::queryInterface(
  /*in*/ std::string name)
throw (
  ::SIDL::NullIORException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDL::BaseInterface::queryInterface()");
    throw e;
  }
  // Return value setup
  ::SIDL::BaseInterface _result;
  struct SIDL_BaseInterface__object * _local__result;
  // Pack arguments for dispatch to IOR
  char *_local_name = NULL;
  if (name.c_str()) {
    _local_name = (char *) malloc(strlen(name.c_str())+1);
    strcpy(_local_name, name.c_str());
  }
  // Exception handling setup
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_queryInterface))(d_self, /*in*/ _local_name);
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  if (_local_name) {::free((void *) _local_name);}
  // Return value cleanup
  _result = ::SIDL::BaseInterface(_local__result);
  if (_result._not_nil()) {
    _result.deleteReference();
  }
  return _result;
}

bool
ANL::SIDL::Query::PackageLocator::isInstanceOf(
  /*in*/ std::string name)
throw (
  ::SIDL::NullIORException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDL::BaseInterface::isInstanceOf()");
    throw e;
  }
  // Return value setup
  bool _result;
  SIDL_bool _local__result;
  // Pack arguments for dispatch to IOR
  char *_local_name = NULL;
  if (name.c_str()) {
    _local_name = (char *) malloc(strlen(name.c_str())+1);
    strcpy(_local_name, name.c_str());
  }
  // Exception handling setup
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_isInstanceOf))(d_self, /*in*/ _local_name);
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  if (_local_name) {::free((void *) _local_name);}
  // Return value cleanup
  _result = (_local__result != FALSE);
  return _result;
}

::SIDL::array< ::SIDLLanguage::AST >
ANL::SIDL::Query::PackageLocator::getRepository()
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Visitor::getRepository()");
    throw e;
  }
  // Return value setup
  ::SIDL::array< ::SIDLLanguage::AST > _result;
  struct SIDLLanguage_AST__array * _local__result;
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_getRepository))(d_self, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
  _result._set_ior(_local__result);
  return _result;
}

void
ANL::SIDL::Query::PackageLocator::setRepository(
  /*in*/ ::SIDL::array< ::SIDLLanguage::AST > repository)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Visitor::setRepository()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_setRepository))(d_self, /*in*/ repository._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

void
ANL::SIDL::Query::PackageLocator::visitAST(
  /*in*/ ::SIDLLanguage::AST node)
throw (
  ::SIDLLanguage::VisitorException,
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Visitor::visitAST()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_visitAST))(d_self, /*in*/ node._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDLLanguage.VisitorException")) != 0) {
      struct SIDLLanguage_VisitorException__object *_realtype = reinterpret_cast< struct SIDLLanguage_VisitorException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDLLanguage::VisitorException(_realtype, false);
    }
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

void
ANL::SIDL::Query::PackageLocator::visitSpecification(
  /*in*/ ::SIDLLanguage::Specification node)
throw (
  ::SIDLLanguage::VisitorException,
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Visitor::visitSpecification()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_visitSpecification))(d_self, /*in*/ node._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDLLanguage.VisitorException")) != 0) {
      struct SIDLLanguage_VisitorException__object *_realtype = reinterpret_cast< struct SIDLLanguage_VisitorException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDLLanguage::VisitorException(_realtype, false);
    }
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

void
ANL::SIDL::Query::PackageLocator::visitVersion(
  /*in*/ ::SIDLLanguage::Version node)
throw (
  ::SIDLLanguage::VisitorException,
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Visitor::visitVersion()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_visitVersion))(d_self, /*in*/ node._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDLLanguage.VisitorException")) != 0) {
      struct SIDLLanguage_VisitorException__object *_realtype = reinterpret_cast< struct SIDLLanguage_VisitorException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDLLanguage::VisitorException(_realtype, false);
    }
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

void
ANL::SIDL::Query::PackageLocator::visitInterface(
  /*in*/ ::SIDLLanguage::Interface node)
throw (
  ::SIDLLanguage::VisitorException,
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Visitor::visitInterface()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_visitInterface))(d_self, /*in*/ node._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDLLanguage.VisitorException")) != 0) {
      struct SIDLLanguage_VisitorException__object *_realtype = reinterpret_cast< struct SIDLLanguage_VisitorException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDLLanguage::VisitorException(_realtype, false);
    }
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

void
ANL::SIDL::Query::PackageLocator::visitClass(
  /*in*/ ::SIDLLanguage::Class node)
throw (
  ::SIDLLanguage::VisitorException,
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Visitor::visitClass()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_visitClass))(d_self, /*in*/ node._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDLLanguage.VisitorException")) != 0) {
      struct SIDLLanguage_VisitorException__object *_realtype = reinterpret_cast< struct SIDLLanguage_VisitorException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDLLanguage::VisitorException(_realtype, false);
    }
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

void
ANL::SIDL::Query::PackageLocator::visitMethod(
  /*in*/ ::SIDLLanguage::Method node)
throw (
  ::SIDLLanguage::VisitorException,
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Visitor::visitMethod()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_visitMethod))(d_self, /*in*/ node._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDLLanguage.VisitorException")) != 0) {
      struct SIDLLanguage_VisitorException__object *_realtype = reinterpret_cast< struct SIDLLanguage_VisitorException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDLLanguage::VisitorException(_realtype, false);
    }
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

void
ANL::SIDL::Query::PackageLocator::visitType(
  /*in*/ ::SIDLLanguage::Type node)
throw (
  ::SIDLLanguage::VisitorException,
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Visitor::visitType()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_visitType))(d_self, /*in*/ node._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDLLanguage.VisitorException")) != 0) {
      struct SIDLLanguage_VisitorException__object *_realtype = reinterpret_cast< struct SIDLLanguage_VisitorException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDLLanguage::VisitorException(_realtype, false);
    }
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

void
ANL::SIDL::Query::PackageLocator::visitEnumeration(
  /*in*/ ::SIDLLanguage::Enumeration node)
throw (
  ::SIDLLanguage::VisitorException,
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Visitor::visitEnumeration()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_visitEnumeration))(d_self, /*in*/ node._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDLLanguage.VisitorException")) != 0) {
      struct SIDLLanguage_VisitorException__object *_realtype = reinterpret_cast< struct SIDLLanguage_VisitorException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDLLanguage::VisitorException(_realtype, false);
    }
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

void
ANL::SIDL::Query::PackageLocator::visitEnumerator(
  /*in*/ ::SIDLLanguage::Enumerator node)
throw (
  ::SIDLLanguage::VisitorException,
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Visitor::visitEnumerator()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_visitEnumerator))(d_self, /*in*/ node._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDLLanguage.VisitorException")) != 0) {
      struct SIDLLanguage_VisitorException__object *_realtype = reinterpret_cast< struct SIDLLanguage_VisitorException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDLLanguage::VisitorException(_realtype, false);
    }
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

void
ANL::SIDL::Query::PackageLocator::visitArray(
  /*in*/ ::SIDLLanguage::Array node)
throw (
  ::SIDLLanguage::VisitorException,
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Visitor::visitArray()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_visitArray))(d_self, /*in*/ node._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDLLanguage.VisitorException")) != 0) {
      struct SIDLLanguage_VisitorException__object *_realtype = reinterpret_cast< struct SIDLLanguage_VisitorException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDLLanguage::VisitorException(_realtype, false);
    }
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

void
ANL::SIDL::Query::PackageLocator::visitParameter(
  /*in*/ ::SIDLLanguage::Parameter node)
throw (
  ::SIDLLanguage::VisitorException,
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Visitor::visitParameter()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_visitParameter))(d_self, /*in*/ node._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDLLanguage.VisitorException")) != 0) {
      struct SIDLLanguage_VisitorException__object *_realtype = reinterpret_cast< struct SIDLLanguage_VisitorException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDLLanguage::VisitorException(_realtype, false);
    }
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

void
ANL::SIDL::Query::PackageLocator::visitComment(
  /*in*/ ::SIDLLanguage::Comment node)
throw (
  ::SIDLLanguage::VisitorException,
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Visitor::visitComment()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_visitComment))(d_self, /*in*/ node._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDLLanguage.VisitorException")) != 0) {
      struct SIDLLanguage_VisitorException__object *_realtype = reinterpret_cast< struct SIDLLanguage_VisitorException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDLLanguage::VisitorException(_realtype, false);
    }
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

const ::ANL::SIDL::Query::PackageLocator::ext_t *::ANL::SIDL::Query::PackageLocator::s_ext;

const ::ANL::SIDL::Query::PackageLocator::ext_t *::ANL::SIDL::Query::PackageLocator::_get_ext() throw (::SIDL::NullIORException) {
  if (!s_ext) {
#ifdef SIDL_STATIC_LIBRARY
      s_ext = ANL_SIDL_Query_PackageLocator__externals();
#else
      const ext_t *(*dll_f)(void) = (const ext_t *(*)(void)) ::SIDL::Loader::lookupSymbol("ANL_SIDL_Query_PackageLocator__externals");

      s_ext = (dll_f ? (*dll_f)() : NULL);
      if (!s_ext) {
        ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();

        e.setMessage("Cannot find implementation for ANL.SIDL.Query.PackageLocator; add library to SIDL_DLL_PATH");
        throw e;
      }
#endif
  }
  return s_ext;
}

