#ifndef included_ANL_SIDLCompilerI_SIDLCompiler_stub
#include "ANL/SIDLCompilerI/SIDLCompiler/SIDLCompiler.hh"
#endif

void
ANL::SIDLCompilerI::SIDLCompiler::addReference()
throw (
  ::SIDL::NullIORException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDL::BaseInterface::addReference()");
    throw e;
  }
  if (d_weak_reference) return;
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  // Dispatch to IOR
  (*(d_self->d_epv->f_addReference))(d_self);
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

void
ANL::SIDLCompilerI::SIDLCompiler::deleteReference()
throw (
  ::SIDL::NullIORException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDL::BaseInterface::deleteReference()");
    throw e;
  }
  if (d_weak_reference) return;
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  // Dispatch to IOR
  (*(d_self->d_epv->f_deleteReference))(d_self);
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

bool
ANL::SIDLCompilerI::SIDLCompiler::isSame(
  /*in*/ ::SIDL::BaseInterface iobj)
throw (
  ::SIDL::NullIORException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDL::BaseInterface::isSame()");
    throw e;
  }
  // Return value setup
  bool _result;
  SIDL_bool _local__result;
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_isSame))(d_self, /*in*/ iobj._get_ior());
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
  _result = (_local__result != FALSE);
  return _result;
}

::SIDL::BaseInterface
ANL::SIDLCompilerI::SIDLCompiler::queryInterface(
  /*in*/ std::string name)
throw (
  ::SIDL::NullIORException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDL::BaseInterface::queryInterface()");
    throw e;
  }
  // Return value setup
  ::SIDL::BaseInterface _result;
  struct SIDL_BaseInterface__object * _local__result;
  // Pack arguments for dispatch to IOR
  char *_local_name = NULL;
  if (name.c_str()) {
    _local_name = (char *) malloc(strlen(name.c_str())+1);
    strcpy(_local_name, name.c_str());
  }
  // Exception handling setup
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_queryInterface))(d_self, /*in*/ _local_name);
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  if (_local_name) {::free((void *) _local_name);}
  // Return value cleanup
  _result = ::SIDL::BaseInterface(_local__result);
  if (_result._not_nil()) {
    _result.deleteReference();
  }
  return _result;
}

bool
ANL::SIDLCompilerI::SIDLCompiler::isInstanceOf(
  /*in*/ std::string name)
throw (
  ::SIDL::NullIORException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDL::BaseInterface::isInstanceOf()");
    throw e;
  }
  // Return value setup
  bool _result;
  SIDL_bool _local__result;
  // Pack arguments for dispatch to IOR
  char *_local_name = NULL;
  if (name.c_str()) {
    _local_name = (char *) malloc(strlen(name.c_str())+1);
    strcpy(_local_name, name.c_str());
  }
  // Exception handling setup
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_isInstanceOf))(d_self, /*in*/ _local_name);
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  if (_local_name) {::free((void *) _local_name);}
  // Return value cleanup
  _result = (_local__result != FALSE);
  return _result;
}

::SIDLLanguage::AST
ANL::SIDLCompilerI::SIDLCompiler::parse(
  /*in*/ std::string buf)
throw (
  ::SIDLLanguage::ParserException,
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Parser::parse()");
    throw e;
  }
  // Return value setup
  ::SIDLLanguage::AST _result;
  struct SIDLLanguage_AST__object * _local__result;
  // Pack arguments for dispatch to IOR
  char *_local_buf = NULL;
  if (buf.c_str()) {
    _local_buf = (char *) malloc(strlen(buf.c_str())+1);
    strcpy(_local_buf, buf.c_str());
  }
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_parse))(d_self, /*in*/ _local_buf, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDLLanguage.ParserException")) != 0) {
      struct SIDLLanguage_ParserException__object *_realtype = reinterpret_cast< struct SIDLLanguage_ParserException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDLLanguage::ParserException(_realtype, false);
    }
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  if (_local_buf) {::free((void *) _local_buf);}
  // Return value cleanup
  _result = ::SIDLLanguage::AST(_local__result);
  if (_result._not_nil()) {
    _result.deleteReference();
  }
  return _result;
}

::SIDLLanguage::AST
ANL::SIDLCompilerI::SIDLCompiler::parseFile(
  /*in*/ std::string filename)
throw (
  ::SIDLLanguage::ParserException,
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Parser::parseFile()");
    throw e;
  }
  // Return value setup
  ::SIDLLanguage::AST _result;
  struct SIDLLanguage_AST__object * _local__result;
  // Pack arguments for dispatch to IOR
  char *_local_filename = NULL;
  if (filename.c_str()) {
    _local_filename = (char *) malloc(strlen(filename.c_str())+1);
    strcpy(_local_filename, filename.c_str());
  }
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_parseFile))(d_self, /*in*/ _local_filename, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDLLanguage.ParserException")) != 0) {
      struct SIDLLanguage_ParserException__object *_realtype = reinterpret_cast< struct SIDLLanguage_ParserException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDLLanguage::ParserException(_realtype, false);
    }
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  if (_local_filename) {::free((void *) _local_filename);}
  // Return value cleanup
  _result = ::SIDLLanguage::AST(_local__result);
  if (_result._not_nil()) {
    _result.deleteReference();
  }
  return _result;
}

const ::ANL::SIDLCompilerI::SIDLCompiler::ext_t *::ANL::SIDLCompilerI::SIDLCompiler::s_ext;

const ::ANL::SIDLCompilerI::SIDLCompiler::ext_t *::ANL::SIDLCompilerI::SIDLCompiler::_get_ext() throw (::SIDL::NullIORException) {
  if (!s_ext) {
#ifdef SIDL_STATIC_LIBRARY
      s_ext = ANL_SIDLCompilerI_SIDLCompiler__externals();
#else
      const ext_t *(*dll_f)(void) = (const ext_t *(*)(void)) ::SIDL::Loader::lookupSymbol("ANL_SIDLCompilerI_SIDLCompiler__externals");

      s_ext = (dll_f ? (*dll_f)() : NULL);
      if (!s_ext) {
        ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();

        e.setMessage("Cannot find implementation for ANL.SIDLCompilerI.SIDLCompiler; add library to SIDL_DLL_PATH");
        throw e;
      }
#endif
  }
  return s_ext;
}

