#ifndef included_ANL_SplicerI_Splicer_stub
#include "ANL/SplicerI/Splicer/Splicer.hh"
#endif

bool
ANL::SplicerI::Splicer::getDoTransfer()
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::ANL::SplicerI::Splicer::getDoTransfer()");
    throw e;
  }
  // Return value setup
  bool _result;
  SIDL_bool _local__result;
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_getDoTransfer))(d_self, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
  _result = (_local__result != FALSE);
  return _result;
}

void
ANL::SplicerI::Splicer::setDoTransfer(
  /*in*/ bool doTransfer)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::ANL::SplicerI::Splicer::setDoTransfer()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  SIDL_bool _local_doTransfer = (doTransfer != FALSE);
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_setDoTransfer))(d_self, /*in*/ _local_doTransfer, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

::ANL::SplicerI::TransferMode__enum
ANL::SplicerI::Splicer::getTransferMode()
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::ANL::SplicerI::Splicer::getTransferMode()");
    throw e;
  }
  // Return value setup
  ::ANL::SplicerI::TransferMode__enum _result;
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _result = (*(d_self->d_epv->f_getTransferMode))(d_self, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
  return _result;
}

void
ANL::SplicerI::Splicer::setTransferMode(
  /*in*/ ::ANL::SplicerI::TransferMode__enum transferMode)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::ANL::SplicerI::Splicer::setTransferMode()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_setTransferMode))(d_self, /*in*/ transferMode, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

void
ANL::SplicerI::Splicer::addReference()
throw (
  ::SIDL::NullIORException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDL::BaseInterface::addReference()");
    throw e;
  }
  if (d_weak_reference) return;
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  // Dispatch to IOR
  (*(d_self->d_epv->f_addReference))(d_self);
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

void
ANL::SplicerI::Splicer::deleteReference()
throw (
  ::SIDL::NullIORException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDL::BaseInterface::deleteReference()");
    throw e;
  }
  if (d_weak_reference) return;
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  // Dispatch to IOR
  (*(d_self->d_epv->f_deleteReference))(d_self);
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

bool
ANL::SplicerI::Splicer::isSame(
  /*in*/ ::SIDL::BaseInterface iobj)
throw (
  ::SIDL::NullIORException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDL::BaseInterface::isSame()");
    throw e;
  }
  // Return value setup
  bool _result;
  SIDL_bool _local__result;
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_isSame))(d_self, /*in*/ iobj._get_ior());
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
  _result = (_local__result != FALSE);
  return _result;
}

::SIDL::BaseInterface
ANL::SplicerI::Splicer::queryInterface(
  /*in*/ std::string name)
throw (
  ::SIDL::NullIORException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDL::BaseInterface::queryInterface()");
    throw e;
  }
  // Return value setup
  ::SIDL::BaseInterface _result;
  struct SIDL_BaseInterface__object * _local__result;
  // Pack arguments for dispatch to IOR
  char *_local_name = NULL;
  if (name.c_str()) {
    _local_name = (char *) malloc(strlen(name.c_str())+1);
    strcpy(_local_name, name.c_str());
  }
  // Exception handling setup
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_queryInterface))(d_self, /*in*/ _local_name);
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  if (_local_name) {::free((void *) _local_name);}
  // Return value cleanup
  _result = ::SIDL::BaseInterface(_local__result);
  if (_result._not_nil()) {
    _result.deleteReference();
  }
  return _result;
}

bool
ANL::SplicerI::Splicer::isInstanceOf(
  /*in*/ std::string name)
throw (
  ::SIDL::NullIORException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDL::BaseInterface::isInstanceOf()");
    throw e;
  }
  // Return value setup
  bool _result;
  SIDL_bool _local__result;
  // Pack arguments for dispatch to IOR
  char *_local_name = NULL;
  if (name.c_str()) {
    _local_name = (char *) malloc(strlen(name.c_str())+1);
    strcpy(_local_name, name.c_str());
  }
  // Exception handling setup
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_isInstanceOf))(d_self, /*in*/ _local_name);
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  if (_local_name) {::free((void *) _local_name);}
  // Return value cleanup
  _result = (_local__result != FALSE);
  return _result;
}

void
ANL::SplicerI::Splicer::parse(
  /*in*/ std::string filename,
  /*in*/ std::string language,
  /*in*/ ::SIDLLanguage::AST node)
throw (
  ::SIDLLanguage::CodeGeneratorException,
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Splicer::parse()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  char *_local_filename = NULL;
  if (filename.c_str()) {
    _local_filename = (char *) malloc(strlen(filename.c_str())+1);
    strcpy(_local_filename, filename.c_str());
  }
  char *_local_language = NULL;
  if (language.c_str()) {
    _local_language = (char *) malloc(strlen(language.c_str())+1);
    strcpy(_local_language, language.c_str());
  }
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_parse))(d_self, /*in*/ _local_filename, /*in*/ _local_language, /*in*/ node._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDLLanguage.CodeGeneratorException")) != 0) {
      struct SIDLLanguage_CodeGeneratorException__object *_realtype = reinterpret_cast< struct SIDLLanguage_CodeGeneratorException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDLLanguage::CodeGeneratorException(_realtype, false);
    }
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  if (_local_filename) {::free((void *) _local_filename);}
  if (_local_language) {::free((void *) _local_language);}
  // Return value cleanup
}

std::string
ANL::SplicerI::Splicer::getLabel(
  /*in*/ std::string name)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Splicer::getLabel()");
    throw e;
  }
  // Return value setup
  std::string _result;
  char * _local__result;
  // Pack arguments for dispatch to IOR
  char *_local_name = NULL;
  if (name.c_str()) {
    _local_name = (char *) malloc(strlen(name.c_str())+1);
    strcpy(_local_name, name.c_str());
  }
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_getLabel))(d_self, /*in*/ _local_name, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  if (_local_name) {::free((void *) _local_name);}
  // Return value cleanup
  _result = _local__result;
  if (_local__result) {::free((void *) _local__result);}
  return _result;
}

std::string
ANL::SplicerI::Splicer::splice(
  /*in*/ ::SIDLLanguage::AST node,
  /*in*/ std::string language,
  /*in*/ std::string name,
  /*in*/ std::string defaultCode)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Splicer::splice()");
    throw e;
  }
  // Return value setup
  std::string _result;
  char * _local__result;
  // Pack arguments for dispatch to IOR
  char *_local_language = NULL;
  if (language.c_str()) {
    _local_language = (char *) malloc(strlen(language.c_str())+1);
    strcpy(_local_language, language.c_str());
  }
  char *_local_name = NULL;
  if (name.c_str()) {
    _local_name = (char *) malloc(strlen(name.c_str())+1);
    strcpy(_local_name, name.c_str());
  }
  char *_local_defaultCode = NULL;
  if (defaultCode.c_str()) {
    _local_defaultCode = (char *) malloc(strlen(defaultCode.c_str())+1);
    strcpy(_local_defaultCode, defaultCode.c_str());
  }
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_splice))(d_self, /*in*/ node._get_ior(), /*in*/ _local_language, /*in*/ _local_name, /*in*/ _local_defaultCode, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  if (_local_language) {::free((void *) _local_language);}
  if (_local_name) {::free((void *) _local_name);}
  if (_local_defaultCode) {::free((void *) _local_defaultCode);}
  // Return value cleanup
  _result = _local__result;
  if (_local__result) {::free((void *) _local__result);}
  return _result;
}

const ::ANL::SplicerI::Splicer::ext_t *::ANL::SplicerI::Splicer::s_ext;

const ::ANL::SplicerI::Splicer::ext_t *::ANL::SplicerI::Splicer::_get_ext() throw (::SIDL::NullIORException) {
  if (!s_ext) {
#ifdef SIDL_STATIC_LIBRARY
      s_ext = ANL_SplicerI_Splicer__externals();
#else
      const ext_t *(*dll_f)(void) = (const ext_t *(*)(void)) ::SIDL::Loader::lookupSymbol("ANL_SplicerI_Splicer__externals");

      s_ext = (dll_f ? (*dll_f)() : NULL);
      if (!s_ext) {
        ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();

        e.setMessage("Cannot find implementation for ANL.SplicerI.Splicer; add library to SIDL_DLL_PATH");
        throw e;
      }
#endif
  }
  return s_ext;
}

