#ifndef included_SIDLLanguage_CompilerException_stub
#include "SIDLLanguage/CompilerException/CompilerException.hh"
#endif

std::string
SIDLLanguage::CompilerException::getMessage()
throw (
  ::SIDL::NullIORException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDL::BaseException::getMessage()");
    throw e;
  }
  // Return value setup
  std::string _result;
  char * _local__result;
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_getMessage))(d_self);
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
  _result = _local__result;
  if (_local__result) {::free((void *) _local__result);}
  return _result;
}

void
SIDLLanguage::CompilerException::setMessage(
  /*in*/ std::string message)
throw (
  ::SIDL::NullIORException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDL::BaseException::setMessage()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  char *_local_message = NULL;
  if (message.c_str()) {
    _local_message = (char *) malloc(strlen(message.c_str())+1);
    strcpy(_local_message, message.c_str());
  }
  // Exception handling setup
  // Dispatch to IOR
  (*(d_self->d_epv->f_setMessage))(d_self, /*in*/ _local_message);
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  if (_local_message) {::free((void *) _local_message);}
  // Return value cleanup
}

std::string
SIDLLanguage::CompilerException::getStackTrace()
throw (
  ::SIDL::NullIORException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDL::BaseException::getStackTrace()");
    throw e;
  }
  // Return value setup
  std::string _result;
  char * _local__result;
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_getStackTrace))(d_self);
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
  _result = _local__result;
  if (_local__result) {::free((void *) _local__result);}
  return _result;
}

void
SIDLLanguage::CompilerException::addToStackTrace(
  /*in*/ std::string traceline)
throw (
  ::SIDL::NullIORException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDL::BaseException::addToStackTrace()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  char *_local_traceline = NULL;
  if (traceline.c_str()) {
    _local_traceline = (char *) malloc(strlen(traceline.c_str())+1);
    strcpy(_local_traceline, traceline.c_str());
  }
  // Exception handling setup
  // Dispatch to IOR
  (*(d_self->d_epv->f_addToStackTrace))(d_self, /*in*/ _local_traceline);
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  if (_local_traceline) {::free((void *) _local_traceline);}
  // Return value cleanup
}

void
SIDLLanguage::CompilerException::addToTrace(
  /*in*/ std::string filename,
  /*in*/ int32_t lineno,
  /*in*/ std::string methodname)
throw (
  ::SIDL::NullIORException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDL::BaseException::addToTrace()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  char *_local_filename = NULL;
  if (filename.c_str()) {
    _local_filename = (char *) malloc(strlen(filename.c_str())+1);
    strcpy(_local_filename, filename.c_str());
  }
  char *_local_methodname = NULL;
  if (methodname.c_str()) {
    _local_methodname = (char *) malloc(strlen(methodname.c_str())+1);
    strcpy(_local_methodname, methodname.c_str());
  }
  // Exception handling setup
  // Dispatch to IOR
  (*(d_self->d_epv->f_addToTrace))(d_self, /*in*/ _local_filename, /*in*/ lineno, /*in*/ _local_methodname);
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  if (_local_filename) {::free((void *) _local_filename);}
  if (_local_methodname) {::free((void *) _local_methodname);}
  // Return value cleanup
}

void
SIDLLanguage::CompilerException::addReference()
throw (
  ::SIDL::NullIORException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDL::BaseInterface::addReference()");
    throw e;
  }
  if (d_weak_reference) return;
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  // Dispatch to IOR
  (*(d_self->d_epv->f_addReference))(d_self);
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

void
SIDLLanguage::CompilerException::deleteReference()
throw (
  ::SIDL::NullIORException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDL::BaseInterface::deleteReference()");
    throw e;
  }
  if (d_weak_reference) return;
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  // Dispatch to IOR
  (*(d_self->d_epv->f_deleteReference))(d_self);
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

bool
SIDLLanguage::CompilerException::isSame(
  /*in*/ ::SIDL::BaseInterface iobj)
throw (
  ::SIDL::NullIORException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDL::BaseInterface::isSame()");
    throw e;
  }
  // Return value setup
  bool _result;
  SIDL_bool _local__result;
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_isSame))(d_self, /*in*/ iobj._get_ior());
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
  _result = (_local__result != FALSE);
  return _result;
}

::SIDL::BaseInterface
SIDLLanguage::CompilerException::queryInterface(
  /*in*/ std::string name)
throw (
  ::SIDL::NullIORException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDL::BaseInterface::queryInterface()");
    throw e;
  }
  // Return value setup
  ::SIDL::BaseInterface _result;
  struct SIDL_BaseInterface__object * _local__result;
  // Pack arguments for dispatch to IOR
  char *_local_name = NULL;
  if (name.c_str()) {
    _local_name = (char *) malloc(strlen(name.c_str())+1);
    strcpy(_local_name, name.c_str());
  }
  // Exception handling setup
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_queryInterface))(d_self, /*in*/ _local_name);
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  if (_local_name) {::free((void *) _local_name);}
  // Return value cleanup
  _result = ::SIDL::BaseInterface(_local__result);
  if (_result._not_nil()) {
    _result.deleteReference();
  }
  return _result;
}

bool
SIDLLanguage::CompilerException::isInstanceOf(
  /*in*/ std::string name)
throw (
  ::SIDL::NullIORException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDL::BaseInterface::isInstanceOf()");
    throw e;
  }
  // Return value setup
  bool _result;
  SIDL_bool _local__result;
  // Pack arguments for dispatch to IOR
  char *_local_name = NULL;
  if (name.c_str()) {
    _local_name = (char *) malloc(strlen(name.c_str())+1);
    strcpy(_local_name, name.c_str());
  }
  // Exception handling setup
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_isInstanceOf))(d_self, /*in*/ _local_name);
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  if (_local_name) {::free((void *) _local_name);}
  // Return value cleanup
  _result = (_local__result != FALSE);
  return _result;
}

const ::SIDLLanguage::CompilerException::ext_t *::SIDLLanguage::CompilerException::s_ext;

const ::SIDLLanguage::CompilerException::ext_t *::SIDLLanguage::CompilerException::_get_ext() throw (::SIDL::NullIORException) {
  if (!s_ext) {
#ifdef SIDL_STATIC_LIBRARY
      s_ext = SIDLLanguage_CompilerException__externals();
#else
      const ext_t *(*dll_f)(void) = (const ext_t *(*)(void)) ::SIDL::Loader::lookupSymbol("SIDLLanguage_CompilerException__externals");

      s_ext = (dll_f ? (*dll_f)() : NULL);
      if (!s_ext) {
        ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();

        e.setMessage("Cannot find implementation for SIDLLanguage.CompilerException; add library to SIDL_DLL_PATH");
        throw e;
      }
#endif
  }
  return s_ext;
}

