#ifndef included_SIDLLanguage_Method_stub
#include "SIDLLanguage/Method/Method.hh"
#endif

::SIDLLanguage::Type
SIDLLanguage::Method::getReturnType()
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Method::getReturnType()");
    throw e;
  }
  // Return value setup
  ::SIDLLanguage::Type _result;
  struct SIDLLanguage_Type__object * _local__result;
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_getReturnType))(d_self->d_object, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
  _result = ::SIDLLanguage::Type(_local__result);
  if (_result._not_nil()) {
    _result.deleteReference();
  }
  return _result;
}

void
SIDLLanguage::Method::setReturnType(
  /*in*/ ::SIDLLanguage::Type type)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Method::setReturnType()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_setReturnType))(d_self->d_object, /*in*/ type._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

::SIDL::array< ::SIDLLanguage::Class >
SIDLLanguage::Method::getExceptions()
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Method::getExceptions()");
    throw e;
  }
  // Return value setup
  ::SIDL::array< ::SIDLLanguage::Class > _result;
  struct SIDLLanguage_Class__array * _local__result;
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_getExceptions))(d_self->d_object, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
  _result._set_ior(_local__result);
  return _result;
}

void
SIDLLanguage::Method::setExceptions(
  /*in*/ ::SIDL::array< ::SIDLLanguage::Class > exceptions)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Method::setExceptions()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_setExceptions))(d_self->d_object, /*in*/ exceptions._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

void
SIDLLanguage::Method::addExceptions(
  /*in*/ ::SIDL::array< ::SIDLLanguage::Class > exceptions)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Method::addExceptions()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_addExceptions))(d_self->d_object, /*in*/ exceptions._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

bool
SIDLLanguage::Method::getStatic()
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Method::getStatic()");
    throw e;
  }
  // Return value setup
  bool _result;
  SIDL_bool _local__result;
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_getStatic))(d_self->d_object, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
  _result = (_local__result != FALSE);
  return _result;
}

void
SIDLLanguage::Method::setStatic(
  /*in*/ bool isStatic)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Method::setStatic()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  SIDL_bool _local_isStatic = (isStatic != FALSE);
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_setStatic))(d_self->d_object, /*in*/ _local_isStatic, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

bool
SIDLLanguage::Method::getFinal()
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Method::getFinal()");
    throw e;
  }
  // Return value setup
  bool _result;
  SIDL_bool _local__result;
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_getFinal))(d_self->d_object, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
  _result = (_local__result != FALSE);
  return _result;
}

void
SIDLLanguage::Method::setFinal(
  /*in*/ bool isFinal)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Method::setFinal()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  SIDL_bool _local_isFinal = (isFinal != FALSE);
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_setFinal))(d_self->d_object, /*in*/ _local_isFinal, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

bool
SIDLLanguage::Method::getAbstract()
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Method::getAbstract()");
    throw e;
  }
  // Return value setup
  bool _result;
  SIDL_bool _local__result;
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_getAbstract))(d_self->d_object, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
  _result = (_local__result != FALSE);
  return _result;
}

void
SIDLLanguage::Method::setAbstract(
  /*in*/ bool isAbstract)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Method::setAbstract()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  SIDL_bool _local_isAbstract = (isAbstract != FALSE);
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_setAbstract))(d_self->d_object, /*in*/ _local_isAbstract, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

bool
SIDLLanguage::Method::getInternal()
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Method::getInternal()");
    throw e;
  }
  // Return value setup
  bool _result;
  SIDL_bool _local__result;
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_getInternal))(d_self->d_object, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
  _result = (_local__result != FALSE);
  return _result;
}

void
SIDLLanguage::Method::setInternal(
  /*in*/ bool isInternal)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Method::setInternal()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  SIDL_bool _local_isInternal = (isInternal != FALSE);
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_setInternal))(d_self->d_object, /*in*/ _local_isInternal, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

::SIDL::array< std::string >
SIDLLanguage::Method::getTemplateIdentifiers()
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Method::getTemplateIdentifiers()");
    throw e;
  }
  // Return value setup
  ::SIDL::array< std::string > _result;
  struct SIDL_string__array * _local__result;
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_getTemplateIdentifiers))(d_self->d_object, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
  _result._set_ior(_local__result);
  return _result;
}

void
SIDLLanguage::Method::setTemplateIdentifiers(
  /*in*/ ::SIDL::array< std::string > templateIds)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Method::setTemplateIdentifiers()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_setTemplateIdentifiers))(d_self->d_object, /*in*/ templateIds._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

void
SIDLLanguage::Method::accept(
  /*in*/ ::SIDLLanguage::Visitor visitor)
throw (
  ::SIDLLanguage::ASTException,
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::accept()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_accept))(d_self->d_object, /*in*/ visitor._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDLLanguage.ASTException")) != 0) {
      struct SIDLLanguage_ASTException__object *_realtype = reinterpret_cast< struct SIDLLanguage_ASTException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDLLanguage::ASTException(_realtype, false);
    }
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

std::string
SIDLLanguage::Method::getIdentifier()
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::getIdentifier()");
    throw e;
  }
  // Return value setup
  std::string _result;
  char * _local__result;
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_getIdentifier))(d_self->d_object, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
  _result = _local__result;
  if (_local__result) {::free((void *) _local__result);}
  return _result;
}

void
SIDLLanguage::Method::setIdentifier(
  /*in*/ std::string identifier)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::setIdentifier()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  char *_local_identifier = NULL;
  if (identifier.c_str()) {
    _local_identifier = (char *) malloc(strlen(identifier.c_str())+1);
    strcpy(_local_identifier, identifier.c_str());
  }
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_setIdentifier))(d_self->d_object, /*in*/ _local_identifier, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  if (_local_identifier) {::free((void *) _local_identifier);}
  // Return value cleanup
}

std::string
SIDLLanguage::Method::getFullIdentifier()
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::getFullIdentifier()");
    throw e;
  }
  // Return value setup
  std::string _result;
  char * _local__result;
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_getFullIdentifier))(d_self->d_object, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
  _result = _local__result;
  if (_local__result) {::free((void *) _local__result);}
  return _result;
}

::SIDLLanguage::AST
SIDLLanguage::Method::getParent()
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::getParent()");
    throw e;
  }
  // Return value setup
  ::SIDLLanguage::AST _result;
  struct SIDLLanguage_AST__object * _local__result;
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_getParent))(d_self->d_object, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
  _result = ::SIDLLanguage::AST(_local__result);
  if (_result._not_nil()) {
    _result.deleteReference();
  }
  return _result;
}

void
SIDLLanguage::Method::setParent(
  /*in*/ ::SIDLLanguage::AST parent)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::setParent()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_setParent))(d_self->d_object, /*in*/ parent._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

::SIDL::array< ::SIDLLanguage::AST >
SIDLLanguage::Method::getChildren()
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::getChildren()");
    throw e;
  }
  // Return value setup
  ::SIDL::array< ::SIDLLanguage::AST > _result;
  struct SIDLLanguage_AST__array * _local__result;
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_getChildren))(d_self->d_object, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
  _result._set_ior(_local__result);
  return _result;
}

void
SIDLLanguage::Method::setChildren(
  /*in*/ ::SIDL::array< ::SIDLLanguage::AST > children)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::setChildren()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_setChildren))(d_self->d_object, /*in*/ children._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

void
SIDLLanguage::Method::addChildren(
  /*in*/ ::SIDL::array< ::SIDLLanguage::AST > children)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::addChildren()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_addChildren))(d_self->d_object, /*in*/ children._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

::SIDL::array< ::SIDLLanguage::AST >
SIDLLanguage::Method::getDependencies()
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::getDependencies()");
    throw e;
  }
  // Return value setup
  ::SIDL::array< ::SIDLLanguage::AST > _result;
  struct SIDLLanguage_AST__array * _local__result;
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_getDependencies))(d_self->d_object, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
  _result._set_ior(_local__result);
  return _result;
}

void
SIDLLanguage::Method::setDependencies(
  /*in*/ ::SIDL::array< ::SIDLLanguage::AST > dependencies)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::setDependencies()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_setDependencies))(d_self->d_object, /*in*/ dependencies._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

void
SIDLLanguage::Method::addDependency(
  /*in*/ ::SIDLLanguage::AST dependency)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::addDependency()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_addDependency))(d_self->d_object, /*in*/ dependency._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

::SIDL::array< ::SIDLLanguage::Comment >
SIDLLanguage::Method::getComments()
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::getComments()");
    throw e;
  }
  // Return value setup
  ::SIDL::array< ::SIDLLanguage::Comment > _result;
  struct SIDLLanguage_Comment__array * _local__result;
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_getComments))(d_self->d_object, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
  _result._set_ior(_local__result);
  return _result;
}

void
SIDLLanguage::Method::setComments(
  /*in*/ ::SIDL::array< ::SIDLLanguage::Comment > comments)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::setComments()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_setComments))(d_self->d_object, /*in*/ comments._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

void
SIDLLanguage::Method::addComments(
  /*in*/ ::SIDL::array< ::SIDLLanguage::Comment > comments)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::addComments()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_addComments))(d_self->d_object, /*in*/ comments._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

::SIDL::array< ::SIDLLanguage::Code >
SIDLLanguage::Method::getCode(
  /*in*/ std::string language)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::getCode()");
    throw e;
  }
  // Return value setup
  ::SIDL::array< ::SIDLLanguage::Code > _result;
  struct SIDLLanguage_Code__array * _local__result;
  // Pack arguments for dispatch to IOR
  char *_local_language = NULL;
  if (language.c_str()) {
    _local_language = (char *) malloc(strlen(language.c_str())+1);
    strcpy(_local_language, language.c_str());
  }
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_getCode))(d_self->d_object, /*in*/ _local_language, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  if (_local_language) {::free((void *) _local_language);}
  // Return value cleanup
  _result._set_ior(_local__result);
  return _result;
}

void
SIDLLanguage::Method::setCode(
  /*in*/ ::SIDL::array< ::SIDLLanguage::Code > code)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::setCode()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_setCode))(d_self->d_object, /*in*/ code._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

void
SIDLLanguage::Method::addCode(
  /*in*/ ::SIDLLanguage::Code code)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::addCode()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_addCode))(d_self->d_object, /*in*/ code._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

bool
SIDLLanguage::Method::hasCodeBlock(
  /*in*/ std::string language,
  /*in*/ std::string label)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::hasCodeBlock()");
    throw e;
  }
  // Return value setup
  bool _result;
  SIDL_bool _local__result;
  // Pack arguments for dispatch to IOR
  char *_local_language = NULL;
  if (language.c_str()) {
    _local_language = (char *) malloc(strlen(language.c_str())+1);
    strcpy(_local_language, language.c_str());
  }
  char *_local_label = NULL;
  if (label.c_str()) {
    _local_label = (char *) malloc(strlen(label.c_str())+1);
    strcpy(_local_label, label.c_str());
  }
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_hasCodeBlock))(d_self->d_object, /*in*/ _local_language, /*in*/ _local_label, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  if (_local_language) {::free((void *) _local_language);}
  if (_local_label) {::free((void *) _local_label);}
  // Return value cleanup
  _result = (_local__result != FALSE);
  return _result;
}

::SIDLLanguage::Code
SIDLLanguage::Method::getCodeBlock(
  /*in*/ std::string language,
  /*in*/ std::string label)
throw (
  ::SIDLLanguage::CodeGeneratorException,
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::getCodeBlock()");
    throw e;
  }
  // Return value setup
  ::SIDLLanguage::Code _result;
  struct SIDLLanguage_Code__object * _local__result;
  // Pack arguments for dispatch to IOR
  char *_local_language = NULL;
  if (language.c_str()) {
    _local_language = (char *) malloc(strlen(language.c_str())+1);
    strcpy(_local_language, language.c_str());
  }
  char *_local_label = NULL;
  if (label.c_str()) {
    _local_label = (char *) malloc(strlen(label.c_str())+1);
    strcpy(_local_label, label.c_str());
  }
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_getCodeBlock))(d_self->d_object, /*in*/ _local_language, /*in*/ _local_label, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDLLanguage.CodeGeneratorException")) != 0) {
      struct SIDLLanguage_CodeGeneratorException__object *_realtype = reinterpret_cast< struct SIDLLanguage_CodeGeneratorException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDLLanguage::CodeGeneratorException(_realtype, false);
    }
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  if (_local_language) {::free((void *) _local_language);}
  if (_local_label) {::free((void *) _local_label);}
  // Return value cleanup
  _result = ::SIDLLanguage::Code(_local__result);
  if (_result._not_nil()) {
    _result.deleteReference();
  }
  return _result;
}

::SIDLLanguage::Code
SIDLLanguage::Method::removeCodeBlock(
  /*in*/ std::string language,
  /*in*/ std::string label)
throw (
  ::SIDLLanguage::CodeGeneratorException,
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::removeCodeBlock()");
    throw e;
  }
  // Return value setup
  ::SIDLLanguage::Code _result;
  struct SIDLLanguage_Code__object * _local__result;
  // Pack arguments for dispatch to IOR
  char *_local_language = NULL;
  if (language.c_str()) {
    _local_language = (char *) malloc(strlen(language.c_str())+1);
    strcpy(_local_language, language.c_str());
  }
  char *_local_label = NULL;
  if (label.c_str()) {
    _local_label = (char *) malloc(strlen(label.c_str())+1);
    strcpy(_local_label, label.c_str());
  }
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_removeCodeBlock))(d_self->d_object, /*in*/ _local_language, /*in*/ _local_label, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDLLanguage.CodeGeneratorException")) != 0) {
      struct SIDLLanguage_CodeGeneratorException__object *_realtype = reinterpret_cast< struct SIDLLanguage_CodeGeneratorException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDLLanguage::CodeGeneratorException(_realtype, false);
    }
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  if (_local_language) {::free((void *) _local_language);}
  if (_local_label) {::free((void *) _local_label);}
  // Return value cleanup
  _result = ::SIDLLanguage::Code(_local__result);
  if (_result._not_nil()) {
    _result.deleteReference();
  }
  return _result;
}

::SIDL::array< ::SIDLLanguage::Attribute >
SIDLLanguage::Method::getAttributes()
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::getAttributes()");
    throw e;
  }
  // Return value setup
  ::SIDL::array< ::SIDLLanguage::Attribute > _result;
  struct SIDLLanguage_Attribute__array * _local__result;
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_getAttributes))(d_self->d_object, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
  _result._set_ior(_local__result);
  return _result;
}

void
SIDLLanguage::Method::setAttributes(
  /*in*/ ::SIDL::array< ::SIDLLanguage::Attribute > attributes)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::setAttributes()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_setAttributes))(d_self->d_object, /*in*/ attributes._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

bool
SIDLLanguage::Method::hasAttribute(
  /*in*/ std::string name)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::hasAttribute()");
    throw e;
  }
  // Return value setup
  bool _result;
  SIDL_bool _local__result;
  // Pack arguments for dispatch to IOR
  char *_local_name = NULL;
  if (name.c_str()) {
    _local_name = (char *) malloc(strlen(name.c_str())+1);
    strcpy(_local_name, name.c_str());
  }
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_hasAttribute))(d_self->d_object, /*in*/ _local_name, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  if (_local_name) {::free((void *) _local_name);}
  // Return value cleanup
  _result = (_local__result != FALSE);
  return _result;
}

void
SIDLLanguage::Method::addAttribute(
  /*in*/ ::SIDLLanguage::Attribute attribute)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::addAttribute()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_addAttribute))(d_self->d_object, /*in*/ attribute._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

::SIDLLanguage::Attribute
SIDLLanguage::Method::deleteAttribute(
  /*in*/ std::string name)
throw (
  ::SIDLLanguage::ASTException,
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::deleteAttribute()");
    throw e;
  }
  // Return value setup
  ::SIDLLanguage::Attribute _result;
  struct SIDLLanguage_Attribute__object * _local__result;
  // Pack arguments for dispatch to IOR
  char *_local_name = NULL;
  if (name.c_str()) {
    _local_name = (char *) malloc(strlen(name.c_str())+1);
    strcpy(_local_name, name.c_str());
  }
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_deleteAttribute))(d_self->d_object, /*in*/ _local_name, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDLLanguage.ASTException")) != 0) {
      struct SIDLLanguage_ASTException__object *_realtype = reinterpret_cast< struct SIDLLanguage_ASTException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDLLanguage::ASTException(_realtype, false);
    }
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  if (_local_name) {::free((void *) _local_name);}
  // Return value cleanup
  _result = ::SIDLLanguage::Attribute(_local__result);
  if (_result._not_nil()) {
    _result.deleteReference();
  }
  return _result;
}

::SIDLLanguage::Attribute
SIDLLanguage::Method::getAttribute(
  /*in*/ std::string name)
throw (
  ::SIDLLanguage::ASTException,
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::getAttribute()");
    throw e;
  }
  // Return value setup
  ::SIDLLanguage::Attribute _result;
  struct SIDLLanguage_Attribute__object * _local__result;
  // Pack arguments for dispatch to IOR
  char *_local_name = NULL;
  if (name.c_str()) {
    _local_name = (char *) malloc(strlen(name.c_str())+1);
    strcpy(_local_name, name.c_str());
  }
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_getAttribute))(d_self->d_object, /*in*/ _local_name, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDLLanguage.ASTException")) != 0) {
      struct SIDLLanguage_ASTException__object *_realtype = reinterpret_cast< struct SIDLLanguage_ASTException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDLLanguage::ASTException(_realtype, false);
    }
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  if (_local_name) {::free((void *) _local_name);}
  // Return value cleanup
  _result = ::SIDLLanguage::Attribute(_local__result);
  if (_result._not_nil()) {
    _result.deleteReference();
  }
  return _result;
}

void
SIDLLanguage::Method::addReference()
throw (
  ::SIDL::NullIORException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDL::BaseInterface::addReference()");
    throw e;
  }
  if (d_weak_reference) return;
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  // Dispatch to IOR
  (*(d_self->d_epv->f_addReference))(d_self->d_object);
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

void
SIDLLanguage::Method::deleteReference()
throw (
  ::SIDL::NullIORException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDL::BaseInterface::deleteReference()");
    throw e;
  }
  if (d_weak_reference) return;
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  // Dispatch to IOR
  (*(d_self->d_epv->f_deleteReference))(d_self->d_object);
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

bool
SIDLLanguage::Method::isSame(
  /*in*/ ::SIDL::BaseInterface iobj)
throw (
  ::SIDL::NullIORException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDL::BaseInterface::isSame()");
    throw e;
  }
  // Return value setup
  bool _result;
  SIDL_bool _local__result;
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_isSame))(d_self->d_object, /*in*/ iobj._get_ior());
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
  _result = (_local__result != FALSE);
  return _result;
}

::SIDL::BaseInterface
SIDLLanguage::Method::queryInterface(
  /*in*/ std::string name)
throw (
  ::SIDL::NullIORException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDL::BaseInterface::queryInterface()");
    throw e;
  }
  // Return value setup
  ::SIDL::BaseInterface _result;
  struct SIDL_BaseInterface__object * _local__result;
  // Pack arguments for dispatch to IOR
  char *_local_name = NULL;
  if (name.c_str()) {
    _local_name = (char *) malloc(strlen(name.c_str())+1);
    strcpy(_local_name, name.c_str());
  }
  // Exception handling setup
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_queryInterface))(d_self->d_object, /*in*/ _local_name);
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  if (_local_name) {::free((void *) _local_name);}
  // Return value cleanup
  _result = ::SIDL::BaseInterface(_local__result);
  if (_result._not_nil()) {
    _result.deleteReference();
  }
  return _result;
}

bool
SIDLLanguage::Method::isInstanceOf(
  /*in*/ std::string name)
throw (
  ::SIDL::NullIORException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDL::BaseInterface::isInstanceOf()");
    throw e;
  }
  // Return value setup
  bool _result;
  SIDL_bool _local__result;
  // Pack arguments for dispatch to IOR
  char *_local_name = NULL;
  if (name.c_str()) {
    _local_name = (char *) malloc(strlen(name.c_str())+1);
    strcpy(_local_name, name.c_str());
  }
  // Exception handling setup
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_isInstanceOf))(d_self->d_object, /*in*/ _local_name);
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  if (_local_name) {::free((void *) _local_name);}
  // Return value cleanup
  _result = (_local__result != FALSE);
  return _result;
}

const ::SIDLLanguage::Method::ext_t *::SIDLLanguage::Method::s_ext;

const ::SIDLLanguage::Method::ext_t *::SIDLLanguage::Method::_get_ext() throw (::SIDL::NullIORException) {
  if (!s_ext) {
#ifdef SIDL_STATIC_LIBRARY
      s_ext = SIDLLanguage_Method__externals();
#else
      const ext_t *(*dll_f)(void) = (const ext_t *(*)(void)) ::SIDL::Loader::lookupSymbol("SIDLLanguage_Method__externals");

      s_ext = (dll_f ? (*dll_f)() : NULL);
      if (!s_ext) {
        ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();

        e.setMessage("Cannot find implementation for SIDLLanguage.Method; add library to SIDL_DLL_PATH");
        throw e;
      }
#endif
  }
  return s_ext;
}

