// Get rid of this crap
#include "sidl_config.h"

#ifndef included_SIDL_cxx_hh
#include "SIDL_cxx.hh"
#endif

#ifndef included_SIDLLanguage_Parser_IOR
#include "SIDLLanguage/Parser_IOR/Parser_IOR.h"
#endif

// Forward declaration
namespace SIDLLanguage {
  // Symbol "SIDLLanguage.Parser"
  class Parser;
} // end namespace SIDLLanguage

// Array specialization
namespace SIDL {
  template<>
  class array< ::SIDLLanguage::Parser >;
} // end namespace SIDL

#ifndef included_SIDLLanguage_Parser_stub
#define included_SIDLLanguage_Parser_stub

//
// Includes for all method dependencies
//
#ifndef included_SIDL_Loader_stub
#include "SIDL/Loader/Loader.hh"
#endif
#ifndef included_SIDLLanguage_AST_stub
#include "SIDLLanguage/AST/AST.hh"
#endif
#ifndef included_SIDLLanguage_ParserException_stub
#include "SIDLLanguage/ParserException/ParserException.hh"
#endif
#ifndef included_SIDL_NullIORException_stub
#include "SIDL/NullIORException/NullIORException.hh"
#endif
#ifndef included_SIDL_BaseException_stub
#include "SIDL/BaseException/BaseException.hh"
#endif
#ifndef included_SIDL_BaseInterface_stub
#include "SIDL/BaseInterface/BaseInterface.hh"
#endif

namespace SIDLLanguage {
  // Symbol "SIDLLanguage.Parser"
  class Parser : public ::SIDL::StubBase {

  // Type definitions 
  public:
    typedef struct SIDLLanguage_Parser__object ior_t;
    typedef struct SIDLLanguage_Parser__external ext_t;

  private:
    // Pointer to IOR
    ior_t *d_self;

    // Weak references which do not add/deleteRef() (used by Impl)
    bool d_weak_reference;

    // Pointer to function table (DLL loadable symbols) which is shared among instances
    static const ext_t *s_ext;

  // Constructors/Destructors 
  public:
    // Default constructor
    Parser() : d_self(0), d_weak_reference(false) {}

    // Default destructor
    virtual ~Parser() {
      if (d_self != 0) {
        deleteReference();
      }
    }

    // Copy constructor
    Parser(const Parser& original) {
      d_self = const_cast< ior_t * >(original.d_self);
      d_weak_reference = original.d_weak_reference;
      if (d_self != 0) {
        addReference();
      }
    }

    // Assignment operator
    Parser& operator=(const Parser& rhs) {
      if (d_self != rhs.d_self) {
        if (d_self != 0) {
          deleteReference();
        }
        d_self = const_cast< ior_t * >(rhs.d_self);
        d_weak_reference = rhs.d_weak_reference;
        if (d_self != 0) {
          addReference();
        }
      }
      return *this;
    }

  // Casting Operators 
  public:
    // Conversion from IOR to C++ class
    Parser(Parser::ior_t *ior) : d_self(ior), d_weak_reference(false) {
      if (d_self != 0) {
        addReference();
      }
    }

    // Alternate constructor which does not call addReference()
    //   also sets d_weak_reference = isWeak
    //   used by Impl (fixes bug #275)
    Parser(Parser::ior_t *ior, bool isWeak) : d_self(ior), d_weak_reference(isWeak) {}

    // Conversion from a StubBase
    Parser(const ::SIDL::StubBase& base) {
      d_self = reinterpret_cast< ior_t * >(base._cast("SIDLLanguage.Parser"));
      d_weak_reference = false;
      if (d_self != 0) {
        addReference();
      }
    }

  // Binding specific methods 
  public:
    ior_t *_get_ior() {return d_self;}

    const ior_t *_get_ior() const {return d_self;}

    bool _is_nil() const {return(d_self == 0);}

    bool _not_nil() const {return(d_self != 0);}

    bool operator!() const {return(d_self == 0);}

    static const ext_t *_get_ext() throw (::SIDL::NullIORException);

  public:
    virtual void *_cast(const char *type) const {
      void *ptr = 0;

      if (d_self != 0) {
        ptr = reinterpret_cast< void * >((*d_self->d_epv->f__cast_ior)(d_self->d_object, type));
      }
      return ptr;
    }

  // User defined methods 
  public:
    ::SIDLLanguage::AST
    SIDLLanguage::Parser::parse(
      /*in*/ std::string buf)
    throw (
      ::SIDLLanguage::ParserException,
      ::SIDL::NullIORException,
      ::SIDL::BaseException)
    ;
    
    ::SIDLLanguage::AST
    SIDLLanguage::Parser::parseFile(
      /*in*/ std::string filename)
    throw (
      ::SIDLLanguage::ParserException,
      ::SIDL::NullIORException,
      ::SIDL::BaseException)
    ;
    
    void
    SIDLLanguage::Parser::addReference()
    throw (
      ::SIDL::NullIORException)
    ;
    
    void
    SIDLLanguage::Parser::deleteReference()
    throw (
      ::SIDL::NullIORException)
    ;
    
    bool
    SIDLLanguage::Parser::isSame(
      /*in*/ ::SIDL::BaseInterface iobj)
    throw (
      ::SIDL::NullIORException)
    ;
    
    ::SIDL::BaseInterface
    SIDLLanguage::Parser::queryInterface(
      /*in*/ std::string name)
    throw (
      ::SIDL::NullIORException)
    ;
    
    bool
    SIDLLanguage::Parser::isInstanceOf(
      /*in*/ std::string name)
    throw (
      ::SIDL::NullIORException)
    ;
    
  }; // end class Parser
} // end namespace SIDLLanguage

// Array specialization
namespace SIDL {
  template <>
  class array< ::SIDLLanguage::Parser > : public array_mixin<struct SIDLLanguage_Parser__array, struct SIDLLanguage_Parser__object *, ::SIDLLanguage::Parser> {
  public:
    // Default constructor
    array() : array_mixin<struct SIDLLanguage_Parser__array, struct SIDLLanguage_Parser__object *, ::SIDLLanguage::Parser>() {}

    // Constructor/Casting operator
    array(struct SIDLLanguage_Parser__array *src) : array_mixin<struct SIDLLanguage_Parser__array, struct SIDLLanguage_Parser__object *, ::SIDLLanguage::Parser>(src) {}
  };
}

#endif /*included_SIDLLanguage_Parser_stub*/
