#ifndef included_SIDLLanguage_Type_stub
#include "SIDLLanguage/Type/Type.hh"
#endif

bool
SIDLLanguage::Type::getBaseType()
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Type::getBaseType()");
    throw e;
  }
  // Return value setup
  bool _result;
  SIDL_bool _local__result;
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_getBaseType))(d_self->d_object, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
  _result = (_local__result != FALSE);
  return _result;
}

void
SIDLLanguage::Type::setBaseType(
  /*in*/ bool baseType)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::Type::setBaseType()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  SIDL_bool _local_baseType = (baseType != FALSE);
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_setBaseType))(d_self->d_object, /*in*/ _local_baseType, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

void
SIDLLanguage::Type::accept(
  /*in*/ ::SIDLLanguage::Visitor visitor)
throw (
  ::SIDLLanguage::ASTException,
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::accept()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_accept))(d_self->d_object, /*in*/ visitor._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDLLanguage.ASTException")) != 0) {
      struct SIDLLanguage_ASTException__object *_realtype = reinterpret_cast< struct SIDLLanguage_ASTException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDLLanguage::ASTException(_realtype, false);
    }
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

std::string
SIDLLanguage::Type::getIdentifier()
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::getIdentifier()");
    throw e;
  }
  // Return value setup
  std::string _result;
  char * _local__result;
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_getIdentifier))(d_self->d_object, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
  _result = _local__result;
  if (_local__result) {::free((void *) _local__result);}
  return _result;
}

void
SIDLLanguage::Type::setIdentifier(
  /*in*/ std::string identifier)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::setIdentifier()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  char *_local_identifier = NULL;
  if (identifier.c_str()) {
    _local_identifier = (char *) malloc(strlen(identifier.c_str())+1);
    strcpy(_local_identifier, identifier.c_str());
  }
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_setIdentifier))(d_self->d_object, /*in*/ _local_identifier, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  if (_local_identifier) {::free((void *) _local_identifier);}
  // Return value cleanup
}

std::string
SIDLLanguage::Type::getFullIdentifier()
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::getFullIdentifier()");
    throw e;
  }
  // Return value setup
  std::string _result;
  char * _local__result;
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_getFullIdentifier))(d_self->d_object, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
  _result = _local__result;
  if (_local__result) {::free((void *) _local__result);}
  return _result;
}

::SIDLLanguage::AST
SIDLLanguage::Type::getParent()
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::getParent()");
    throw e;
  }
  // Return value setup
  ::SIDLLanguage::AST _result;
  struct SIDLLanguage_AST__object * _local__result;
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_getParent))(d_self->d_object, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
  _result = ::SIDLLanguage::AST(_local__result);
  if (_result._not_nil()) {
    _result.deleteReference();
  }
  return _result;
}

void
SIDLLanguage::Type::setParent(
  /*in*/ ::SIDLLanguage::AST parent)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::setParent()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_setParent))(d_self->d_object, /*in*/ parent._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

::SIDL::array< ::SIDLLanguage::AST >
SIDLLanguage::Type::getChildren()
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::getChildren()");
    throw e;
  }
  // Return value setup
  ::SIDL::array< ::SIDLLanguage::AST > _result;
  struct SIDLLanguage_AST__array * _local__result;
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_getChildren))(d_self->d_object, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
  _result._set_ior(_local__result);
  return _result;
}

void
SIDLLanguage::Type::setChildren(
  /*in*/ ::SIDL::array< ::SIDLLanguage::AST > children)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::setChildren()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_setChildren))(d_self->d_object, /*in*/ children._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

void
SIDLLanguage::Type::addChildren(
  /*in*/ ::SIDL::array< ::SIDLLanguage::AST > children)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::addChildren()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_addChildren))(d_self->d_object, /*in*/ children._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

::SIDL::array< ::SIDLLanguage::AST >
SIDLLanguage::Type::getDependencies()
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::getDependencies()");
    throw e;
  }
  // Return value setup
  ::SIDL::array< ::SIDLLanguage::AST > _result;
  struct SIDLLanguage_AST__array * _local__result;
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_getDependencies))(d_self->d_object, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
  _result._set_ior(_local__result);
  return _result;
}

void
SIDLLanguage::Type::setDependencies(
  /*in*/ ::SIDL::array< ::SIDLLanguage::AST > dependencies)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::setDependencies()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_setDependencies))(d_self->d_object, /*in*/ dependencies._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

void
SIDLLanguage::Type::addDependency(
  /*in*/ ::SIDLLanguage::AST dependency)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::addDependency()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_addDependency))(d_self->d_object, /*in*/ dependency._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

::SIDL::array< ::SIDLLanguage::Comment >
SIDLLanguage::Type::getComments()
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::getComments()");
    throw e;
  }
  // Return value setup
  ::SIDL::array< ::SIDLLanguage::Comment > _result;
  struct SIDLLanguage_Comment__array * _local__result;
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_getComments))(d_self->d_object, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
  _result._set_ior(_local__result);
  return _result;
}

void
SIDLLanguage::Type::setComments(
  /*in*/ ::SIDL::array< ::SIDLLanguage::Comment > comments)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::setComments()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_setComments))(d_self->d_object, /*in*/ comments._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

void
SIDLLanguage::Type::addComments(
  /*in*/ ::SIDL::array< ::SIDLLanguage::Comment > comments)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::addComments()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_addComments))(d_self->d_object, /*in*/ comments._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

::SIDL::array< ::SIDLLanguage::Code >
SIDLLanguage::Type::getCode(
  /*in*/ std::string language)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::getCode()");
    throw e;
  }
  // Return value setup
  ::SIDL::array< ::SIDLLanguage::Code > _result;
  struct SIDLLanguage_Code__array * _local__result;
  // Pack arguments for dispatch to IOR
  char *_local_language = NULL;
  if (language.c_str()) {
    _local_language = (char *) malloc(strlen(language.c_str())+1);
    strcpy(_local_language, language.c_str());
  }
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_getCode))(d_self->d_object, /*in*/ _local_language, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  if (_local_language) {::free((void *) _local_language);}
  // Return value cleanup
  _result._set_ior(_local__result);
  return _result;
}

void
SIDLLanguage::Type::setCode(
  /*in*/ ::SIDL::array< ::SIDLLanguage::Code > code)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::setCode()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_setCode))(d_self->d_object, /*in*/ code._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

void
SIDLLanguage::Type::addCode(
  /*in*/ ::SIDLLanguage::Code code)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::addCode()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_addCode))(d_self->d_object, /*in*/ code._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

bool
SIDLLanguage::Type::hasCodeBlock(
  /*in*/ std::string language,
  /*in*/ std::string label)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::hasCodeBlock()");
    throw e;
  }
  // Return value setup
  bool _result;
  SIDL_bool _local__result;
  // Pack arguments for dispatch to IOR
  char *_local_language = NULL;
  if (language.c_str()) {
    _local_language = (char *) malloc(strlen(language.c_str())+1);
    strcpy(_local_language, language.c_str());
  }
  char *_local_label = NULL;
  if (label.c_str()) {
    _local_label = (char *) malloc(strlen(label.c_str())+1);
    strcpy(_local_label, label.c_str());
  }
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_hasCodeBlock))(d_self->d_object, /*in*/ _local_language, /*in*/ _local_label, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  if (_local_language) {::free((void *) _local_language);}
  if (_local_label) {::free((void *) _local_label);}
  // Return value cleanup
  _result = (_local__result != FALSE);
  return _result;
}

::SIDLLanguage::Code
SIDLLanguage::Type::getCodeBlock(
  /*in*/ std::string language,
  /*in*/ std::string label)
throw (
  ::SIDLLanguage::CodeGeneratorException,
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::getCodeBlock()");
    throw e;
  }
  // Return value setup
  ::SIDLLanguage::Code _result;
  struct SIDLLanguage_Code__object * _local__result;
  // Pack arguments for dispatch to IOR
  char *_local_language = NULL;
  if (language.c_str()) {
    _local_language = (char *) malloc(strlen(language.c_str())+1);
    strcpy(_local_language, language.c_str());
  }
  char *_local_label = NULL;
  if (label.c_str()) {
    _local_label = (char *) malloc(strlen(label.c_str())+1);
    strcpy(_local_label, label.c_str());
  }
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_getCodeBlock))(d_self->d_object, /*in*/ _local_language, /*in*/ _local_label, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDLLanguage.CodeGeneratorException")) != 0) {
      struct SIDLLanguage_CodeGeneratorException__object *_realtype = reinterpret_cast< struct SIDLLanguage_CodeGeneratorException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDLLanguage::CodeGeneratorException(_realtype, false);
    }
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  if (_local_language) {::free((void *) _local_language);}
  if (_local_label) {::free((void *) _local_label);}
  // Return value cleanup
  _result = ::SIDLLanguage::Code(_local__result);
  if (_result._not_nil()) {
    _result.deleteReference();
  }
  return _result;
}

::SIDLLanguage::Code
SIDLLanguage::Type::removeCodeBlock(
  /*in*/ std::string language,
  /*in*/ std::string label)
throw (
  ::SIDLLanguage::CodeGeneratorException,
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::removeCodeBlock()");
    throw e;
  }
  // Return value setup
  ::SIDLLanguage::Code _result;
  struct SIDLLanguage_Code__object * _local__result;
  // Pack arguments for dispatch to IOR
  char *_local_language = NULL;
  if (language.c_str()) {
    _local_language = (char *) malloc(strlen(language.c_str())+1);
    strcpy(_local_language, language.c_str());
  }
  char *_local_label = NULL;
  if (label.c_str()) {
    _local_label = (char *) malloc(strlen(label.c_str())+1);
    strcpy(_local_label, label.c_str());
  }
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_removeCodeBlock))(d_self->d_object, /*in*/ _local_language, /*in*/ _local_label, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDLLanguage.CodeGeneratorException")) != 0) {
      struct SIDLLanguage_CodeGeneratorException__object *_realtype = reinterpret_cast< struct SIDLLanguage_CodeGeneratorException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDLLanguage::CodeGeneratorException(_realtype, false);
    }
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  if (_local_language) {::free((void *) _local_language);}
  if (_local_label) {::free((void *) _local_label);}
  // Return value cleanup
  _result = ::SIDLLanguage::Code(_local__result);
  if (_result._not_nil()) {
    _result.deleteReference();
  }
  return _result;
}

::SIDL::array< ::SIDLLanguage::Attribute >
SIDLLanguage::Type::getAttributes()
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::getAttributes()");
    throw e;
  }
  // Return value setup
  ::SIDL::array< ::SIDLLanguage::Attribute > _result;
  struct SIDLLanguage_Attribute__array * _local__result;
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_getAttributes))(d_self->d_object, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
  _result._set_ior(_local__result);
  return _result;
}

void
SIDLLanguage::Type::setAttributes(
  /*in*/ ::SIDL::array< ::SIDLLanguage::Attribute > attributes)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::setAttributes()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_setAttributes))(d_self->d_object, /*in*/ attributes._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

bool
SIDLLanguage::Type::hasAttribute(
  /*in*/ std::string name)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::hasAttribute()");
    throw e;
  }
  // Return value setup
  bool _result;
  SIDL_bool _local__result;
  // Pack arguments for dispatch to IOR
  char *_local_name = NULL;
  if (name.c_str()) {
    _local_name = (char *) malloc(strlen(name.c_str())+1);
    strcpy(_local_name, name.c_str());
  }
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_hasAttribute))(d_self->d_object, /*in*/ _local_name, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  if (_local_name) {::free((void *) _local_name);}
  // Return value cleanup
  _result = (_local__result != FALSE);
  return _result;
}

void
SIDLLanguage::Type::addAttribute(
  /*in*/ ::SIDLLanguage::Attribute attribute)
throw (
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::addAttribute()");
    throw e;
  }
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  (*(d_self->d_epv->f_addAttribute))(d_self->d_object, /*in*/ attribute._get_ior(), &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

::SIDLLanguage::Attribute
SIDLLanguage::Type::deleteAttribute(
  /*in*/ std::string name)
throw (
  ::SIDLLanguage::ASTException,
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::deleteAttribute()");
    throw e;
  }
  // Return value setup
  ::SIDLLanguage::Attribute _result;
  struct SIDLLanguage_Attribute__object * _local__result;
  // Pack arguments for dispatch to IOR
  char *_local_name = NULL;
  if (name.c_str()) {
    _local_name = (char *) malloc(strlen(name.c_str())+1);
    strcpy(_local_name, name.c_str());
  }
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_deleteAttribute))(d_self->d_object, /*in*/ _local_name, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDLLanguage.ASTException")) != 0) {
      struct SIDLLanguage_ASTException__object *_realtype = reinterpret_cast< struct SIDLLanguage_ASTException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDLLanguage::ASTException(_realtype, false);
    }
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  if (_local_name) {::free((void *) _local_name);}
  // Return value cleanup
  _result = ::SIDLLanguage::Attribute(_local__result);
  if (_result._not_nil()) {
    _result.deleteReference();
  }
  return _result;
}

::SIDLLanguage::Attribute
SIDLLanguage::Type::getAttribute(
  /*in*/ std::string name)
throw (
  ::SIDLLanguage::ASTException,
  ::SIDL::NullIORException,
  ::SIDL::BaseException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDLLanguage::AST::getAttribute()");
    throw e;
  }
  // Return value setup
  ::SIDLLanguage::Attribute _result;
  struct SIDLLanguage_Attribute__object * _local__result;
  // Pack arguments for dispatch to IOR
  char *_local_name = NULL;
  if (name.c_str()) {
    _local_name = (char *) malloc(strlen(name.c_str())+1);
    strcpy(_local_name, name.c_str());
  }
  // Exception handling setup
  SIDL_BaseException__object *_exception = 0;
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_getAttribute))(d_self->d_object, /*in*/ _local_name, &_exception);
  // Exception handling cleanup
  if (_exception != 0) {
    void *_p;
  
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDLLanguage.ASTException")) != 0) {
      struct SIDLLanguage_ASTException__object *_realtype = reinterpret_cast< struct SIDLLanguage_ASTException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDLLanguage::ASTException(_realtype, false);
    }
    if ((_p = (*(_exception->d_epv->f__cast_ior))(_exception, "SIDL.BaseException")) != 0) {
      struct SIDL_BaseException__object *_realtype = reinterpret_cast< struct SIDL_BaseException__object * >(_p);
      // Note that this alternate constructor does not increment the reference count
      throw ::SIDL::BaseException(_realtype, false);
    }
  }
  // Unpack arguments from dispatch to IOR
  if (_local_name) {::free((void *) _local_name);}
  // Return value cleanup
  _result = ::SIDLLanguage::Attribute(_local__result);
  if (_result._not_nil()) {
    _result.deleteReference();
  }
  return _result;
}

void
SIDLLanguage::Type::addReference()
throw (
  ::SIDL::NullIORException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDL::BaseInterface::addReference()");
    throw e;
  }
  if (d_weak_reference) return;
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  // Dispatch to IOR
  (*(d_self->d_epv->f_addReference))(d_self->d_object);
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

void
SIDLLanguage::Type::deleteReference()
throw (
  ::SIDL::NullIORException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDL::BaseInterface::deleteReference()");
    throw e;
  }
  if (d_weak_reference) return;
  // Return value setup
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  // Dispatch to IOR
  (*(d_self->d_epv->f_deleteReference))(d_self->d_object);
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
}

bool
SIDLLanguage::Type::isSame(
  /*in*/ ::SIDL::BaseInterface iobj)
throw (
  ::SIDL::NullIORException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDL::BaseInterface::isSame()");
    throw e;
  }
  // Return value setup
  bool _result;
  SIDL_bool _local__result;
  // Pack arguments for dispatch to IOR
  // Exception handling setup
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_isSame))(d_self->d_object, /*in*/ iobj._get_ior());
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  // Return value cleanup
  _result = (_local__result != FALSE);
  return _result;
}

::SIDL::BaseInterface
SIDLLanguage::Type::queryInterface(
  /*in*/ std::string name)
throw (
  ::SIDL::NullIORException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDL::BaseInterface::queryInterface()");
    throw e;
  }
  // Return value setup
  ::SIDL::BaseInterface _result;
  struct SIDL_BaseInterface__object * _local__result;
  // Pack arguments for dispatch to IOR
  char *_local_name = NULL;
  if (name.c_str()) {
    _local_name = (char *) malloc(strlen(name.c_str())+1);
    strcpy(_local_name, name.c_str());
  }
  // Exception handling setup
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_queryInterface))(d_self->d_object, /*in*/ _local_name);
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  if (_local_name) {::free((void *) _local_name);}
  // Return value cleanup
  _result = ::SIDL::BaseInterface(_local__result);
  if (_result._not_nil()) {
    _result.deleteReference();
  }
  return _result;
}

bool
SIDLLanguage::Type::isInstanceOf(
  /*in*/ std::string name)
throw (
  ::SIDL::NullIORException)
{
  if (d_self == 0) {
    ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();
  
    e.setMessage("Null IOR pointer in ::SIDL::BaseInterface::isInstanceOf()");
    throw e;
  }
  // Return value setup
  bool _result;
  SIDL_bool _local__result;
  // Pack arguments for dispatch to IOR
  char *_local_name = NULL;
  if (name.c_str()) {
    _local_name = (char *) malloc(strlen(name.c_str())+1);
    strcpy(_local_name, name.c_str());
  }
  // Exception handling setup
  // Dispatch to IOR
  _local__result = (*(d_self->d_epv->f_isInstanceOf))(d_self->d_object, /*in*/ _local_name);
  // Exception handling cleanup
  // Unpack arguments from dispatch to IOR
  if (_local_name) {::free((void *) _local_name);}
  // Return value cleanup
  _result = (_local__result != FALSE);
  return _result;
}

const ::SIDLLanguage::Type::ext_t *::SIDLLanguage::Type::s_ext;

const ::SIDLLanguage::Type::ext_t *::SIDLLanguage::Type::_get_ext() throw (::SIDL::NullIORException) {
  if (!s_ext) {
#ifdef SIDL_STATIC_LIBRARY
      s_ext = SIDLLanguage_Type__externals();
#else
      const ext_t *(*dll_f)(void) = (const ext_t *(*)(void)) ::SIDL::Loader::lookupSymbol("SIDLLanguage_Type__externals");

      s_ext = (dll_f ? (*dll_f)() : NULL);
      if (!s_ext) {
        ::SIDL::NullIORException e = ::SIDL::NullIORException::_create();

        e.setMessage("Cannot find implementation for SIDLLanguage.Type; add library to SIDL_DLL_PATH");
        throw e;
      }
#endif
  }
  return s_ext;
}

