// Get rid of this crap
#include "sidl_config.h"

#ifndef included_SIDL_cxx_hh
#include "SIDL_cxx.hh"
#endif

#ifndef included_SIDLLanguage_Type_IOR
#include "SIDLLanguage/Type_IOR/Type_IOR.h"
#endif

// Forward declaration
namespace SIDLLanguage {
  // Symbol "SIDLLanguage.Type"
  class Type;
} // end namespace SIDLLanguage

// Array specialization
namespace SIDL {
  template<>
  class array< ::SIDLLanguage::Type >;
} // end namespace SIDL

#ifndef included_SIDLLanguage_Type_stub
#define included_SIDLLanguage_Type_stub

//
// Includes for all method dependencies
//
#ifndef included_SIDL_Loader_stub
#include "SIDL/Loader/Loader.hh"
#endif
#ifndef included_SIDL_NullIORException_stub
#include "SIDL/NullIORException/NullIORException.hh"
#endif
#ifndef included_SIDL_BaseException_stub
#include "SIDL/BaseException/BaseException.hh"
#endif
#ifndef included_SIDLLanguage_Visitor_stub
#include "SIDLLanguage/Visitor/Visitor.hh"
#endif
#ifndef included_SIDLLanguage_ASTException_stub
#include "SIDLLanguage/ASTException/ASTException.hh"
#endif
#ifndef included_SIDLLanguage_AST_stub
#include "SIDLLanguage/AST/AST.hh"
#endif
#ifndef included_SIDLLanguage_Comment_stub
#include "SIDLLanguage/Comment/Comment.hh"
#endif
#ifndef included_SIDLLanguage_Code_stub
#include "SIDLLanguage/Code/Code.hh"
#endif
#ifndef included_SIDLLanguage_CodeGeneratorException_stub
#include "SIDLLanguage/CodeGeneratorException/CodeGeneratorException.hh"
#endif
#ifndef included_SIDLLanguage_Attribute_stub
#include "SIDLLanguage/Attribute/Attribute.hh"
#endif
#ifndef included_SIDL_BaseInterface_stub
#include "SIDL/BaseInterface/BaseInterface.hh"
#endif

namespace SIDLLanguage {
  // Symbol "SIDLLanguage.Type"
  class Type : public ::SIDL::StubBase {

  // Type definitions 
  public:
    typedef struct SIDLLanguage_Type__object ior_t;
    typedef struct SIDLLanguage_Type__external ext_t;

  private:
    // Pointer to IOR
    ior_t *d_self;

    // Weak references which do not add/deleteRef() (used by Impl)
    bool d_weak_reference;

    // Pointer to function table (DLL loadable symbols) which is shared among instances
    static const ext_t *s_ext;

  // Constructors/Destructors 
  public:
    // Default constructor
    Type() : d_self(0), d_weak_reference(false) {}

    // Default destructor
    virtual ~Type() {
      if (d_self != 0) {
        deleteReference();
      }
    }

    // Copy constructor
    Type(const Type& original) {
      d_self = const_cast< ior_t * >(original.d_self);
      d_weak_reference = original.d_weak_reference;
      if (d_self != 0) {
        addReference();
      }
    }

    // Assignment operator
    Type& operator=(const Type& rhs) {
      if (d_self != rhs.d_self) {
        if (d_self != 0) {
          deleteReference();
        }
        d_self = const_cast< ior_t * >(rhs.d_self);
        d_weak_reference = rhs.d_weak_reference;
        if (d_self != 0) {
          addReference();
        }
      }
      return *this;
    }

  // Casting Operators 
  public:
    // Conversion from IOR to C++ class
    Type(Type::ior_t *ior) : d_self(ior), d_weak_reference(false) {
      if (d_self != 0) {
        addReference();
      }
    }

    // Alternate constructor which does not call addReference()
    //   also sets d_weak_reference = isWeak
    //   used by Impl (fixes bug #275)
    Type(Type::ior_t *ior, bool isWeak) : d_self(ior), d_weak_reference(isWeak) {}

    // Conversion from a StubBase
    Type(const ::SIDL::StubBase& base) {
      d_self = reinterpret_cast< ior_t * >(base._cast("SIDLLanguage.Type"));
      d_weak_reference = false;
      if (d_self != 0) {
        addReference();
      }
    }

  // Binding specific methods 
  public:
    ior_t *_get_ior() {return d_self;}

    const ior_t *_get_ior() const {return d_self;}

    bool _is_nil() const {return(d_self == 0);}

    bool _not_nil() const {return(d_self != 0);}

    bool operator!() const {return(d_self == 0);}

    static const ext_t *_get_ext() throw (::SIDL::NullIORException);

  public:
    virtual void *_cast(const char *type) const {
      void *ptr = 0;

      if (d_self != 0) {
        ptr = reinterpret_cast< void * >((*d_self->d_epv->f__cast_ior)(d_self->d_object, type));
      }
      return ptr;
    }

  // User defined methods 
  public:
    bool
    SIDLLanguage::Type::getBaseType()
    throw (
      ::SIDL::NullIORException,
      ::SIDL::BaseException)
    ;
    
    void
    SIDLLanguage::Type::setBaseType(
      /*in*/ bool baseType)
    throw (
      ::SIDL::NullIORException,
      ::SIDL::BaseException)
    ;
    
    void
    SIDLLanguage::Type::accept(
      /*in*/ ::SIDLLanguage::Visitor visitor)
    throw (
      ::SIDLLanguage::ASTException,
      ::SIDL::NullIORException,
      ::SIDL::BaseException)
    ;
    
    std::string
    SIDLLanguage::Type::getIdentifier()
    throw (
      ::SIDL::NullIORException,
      ::SIDL::BaseException)
    ;
    
    void
    SIDLLanguage::Type::setIdentifier(
      /*in*/ std::string identifier)
    throw (
      ::SIDL::NullIORException,
      ::SIDL::BaseException)
    ;
    
    std::string
    SIDLLanguage::Type::getFullIdentifier()
    throw (
      ::SIDL::NullIORException,
      ::SIDL::BaseException)
    ;
    
    ::SIDLLanguage::AST
    SIDLLanguage::Type::getParent()
    throw (
      ::SIDL::NullIORException,
      ::SIDL::BaseException)
    ;
    
    void
    SIDLLanguage::Type::setParent(
      /*in*/ ::SIDLLanguage::AST parent)
    throw (
      ::SIDL::NullIORException,
      ::SIDL::BaseException)
    ;
    
    ::SIDL::array< ::SIDLLanguage::AST >
    SIDLLanguage::Type::getChildren()
    throw (
      ::SIDL::NullIORException,
      ::SIDL::BaseException)
    ;
    
    void
    SIDLLanguage::Type::setChildren(
      /*in*/ ::SIDL::array< ::SIDLLanguage::AST > children)
    throw (
      ::SIDL::NullIORException,
      ::SIDL::BaseException)
    ;
    
    void
    SIDLLanguage::Type::addChildren(
      /*in*/ ::SIDL::array< ::SIDLLanguage::AST > children)
    throw (
      ::SIDL::NullIORException,
      ::SIDL::BaseException)
    ;
    
    ::SIDL::array< ::SIDLLanguage::AST >
    SIDLLanguage::Type::getDependencies()
    throw (
      ::SIDL::NullIORException,
      ::SIDL::BaseException)
    ;
    
    void
    SIDLLanguage::Type::setDependencies(
      /*in*/ ::SIDL::array< ::SIDLLanguage::AST > dependencies)
    throw (
      ::SIDL::NullIORException,
      ::SIDL::BaseException)
    ;
    
    void
    SIDLLanguage::Type::addDependency(
      /*in*/ ::SIDLLanguage::AST dependency)
    throw (
      ::SIDL::NullIORException,
      ::SIDL::BaseException)
    ;
    
    ::SIDL::array< ::SIDLLanguage::Comment >
    SIDLLanguage::Type::getComments()
    throw (
      ::SIDL::NullIORException,
      ::SIDL::BaseException)
    ;
    
    void
    SIDLLanguage::Type::setComments(
      /*in*/ ::SIDL::array< ::SIDLLanguage::Comment > comments)
    throw (
      ::SIDL::NullIORException,
      ::SIDL::BaseException)
    ;
    
    void
    SIDLLanguage::Type::addComments(
      /*in*/ ::SIDL::array< ::SIDLLanguage::Comment > comments)
    throw (
      ::SIDL::NullIORException,
      ::SIDL::BaseException)
    ;
    
    ::SIDL::array< ::SIDLLanguage::Code >
    SIDLLanguage::Type::getCode(
      /*in*/ std::string language)
    throw (
      ::SIDL::NullIORException,
      ::SIDL::BaseException)
    ;
    
    void
    SIDLLanguage::Type::setCode(
      /*in*/ ::SIDL::array< ::SIDLLanguage::Code > code)
    throw (
      ::SIDL::NullIORException,
      ::SIDL::BaseException)
    ;
    
    void
    SIDLLanguage::Type::addCode(
      /*in*/ ::SIDLLanguage::Code code)
    throw (
      ::SIDL::NullIORException,
      ::SIDL::BaseException)
    ;
    
    bool
    SIDLLanguage::Type::hasCodeBlock(
      /*in*/ std::string language,
      /*in*/ std::string label)
    throw (
      ::SIDL::NullIORException,
      ::SIDL::BaseException)
    ;
    
    ::SIDLLanguage::Code
    SIDLLanguage::Type::getCodeBlock(
      /*in*/ std::string language,
      /*in*/ std::string label)
    throw (
      ::SIDLLanguage::CodeGeneratorException,
      ::SIDL::NullIORException,
      ::SIDL::BaseException)
    ;
    
    ::SIDLLanguage::Code
    SIDLLanguage::Type::removeCodeBlock(
      /*in*/ std::string language,
      /*in*/ std::string label)
    throw (
      ::SIDLLanguage::CodeGeneratorException,
      ::SIDL::NullIORException,
      ::SIDL::BaseException)
    ;
    
    ::SIDL::array< ::SIDLLanguage::Attribute >
    SIDLLanguage::Type::getAttributes()
    throw (
      ::SIDL::NullIORException,
      ::SIDL::BaseException)
    ;
    
    void
    SIDLLanguage::Type::setAttributes(
      /*in*/ ::SIDL::array< ::SIDLLanguage::Attribute > attributes)
    throw (
      ::SIDL::NullIORException,
      ::SIDL::BaseException)
    ;
    
    bool
    SIDLLanguage::Type::hasAttribute(
      /*in*/ std::string name)
    throw (
      ::SIDL::NullIORException,
      ::SIDL::BaseException)
    ;
    
    void
    SIDLLanguage::Type::addAttribute(
      /*in*/ ::SIDLLanguage::Attribute attribute)
    throw (
      ::SIDL::NullIORException,
      ::SIDL::BaseException)
    ;
    
    ::SIDLLanguage::Attribute
    SIDLLanguage::Type::deleteAttribute(
      /*in*/ std::string name)
    throw (
      ::SIDLLanguage::ASTException,
      ::SIDL::NullIORException,
      ::SIDL::BaseException)
    ;
    
    ::SIDLLanguage::Attribute
    SIDLLanguage::Type::getAttribute(
      /*in*/ std::string name)
    throw (
      ::SIDLLanguage::ASTException,
      ::SIDL::NullIORException,
      ::SIDL::BaseException)
    ;
    
    void
    SIDLLanguage::Type::addReference()
    throw (
      ::SIDL::NullIORException)
    ;
    
    void
    SIDLLanguage::Type::deleteReference()
    throw (
      ::SIDL::NullIORException)
    ;
    
    bool
    SIDLLanguage::Type::isSame(
      /*in*/ ::SIDL::BaseInterface iobj)
    throw (
      ::SIDL::NullIORException)
    ;
    
    ::SIDL::BaseInterface
    SIDLLanguage::Type::queryInterface(
      /*in*/ std::string name)
    throw (
      ::SIDL::NullIORException)
    ;
    
    bool
    SIDLLanguage::Type::isInstanceOf(
      /*in*/ std::string name)
    throw (
      ::SIDL::NullIORException)
    ;
    
  }; // end class Type
} // end namespace SIDLLanguage

// Array specialization
namespace SIDL {
  template <>
  class array< ::SIDLLanguage::Type > : public array_mixin<struct SIDLLanguage_Type__array, struct SIDLLanguage_Type__object *, ::SIDLLanguage::Type> {
  public:
    // Default constructor
    array() : array_mixin<struct SIDLLanguage_Type__array, struct SIDLLanguage_Type__object *, ::SIDLLanguage::Type>() {}

    // Constructor/Casting operator
    array(struct SIDLLanguage_Type__array *src) : array_mixin<struct SIDLLanguage_Type__array, struct SIDLLanguage_Type__object *, ::SIDLLanguage::Type>(src) {}
  };
}

#endif /*included_SIDLLanguage_Type_stub*/
