#define ANL_SIDLCompilerI_IOR_INTERNAL 1

#include "SIDLObjA.h"
#include "SIDLPyArrays.h"
#include "Numeric/arrayobject.h"

#ifndef included_ANL_SIDLCompilerI_IOR_stub
#include "ANL/SIDLCompilerI/IOR_Module.h"
#endif
#ifndef included_ANL_SIDLCompilerI_IOR_IOR
#include "ANL/SIDLCompilerI/IOR_IOR/IOR_IOR.h"
#endif
//
// Includes for all method dependencies
//
#ifndef included_SIDL_Loader_IOR
#include "SIDL/Loader_IOR/Loader_IOR.h"
#endif
#ifndef included_SIDL_NullIORException_stub
#include "SIDL/NullIORException_Module.h"
#endif
#ifndef included_SIDL_BaseInterface_stub
#include "SIDL/BaseInterface_Module.h"
#endif
#ifndef included_SIDL_BaseException_stub
#include "SIDL/BaseException_Module.h"
#endif


static const struct ANL_SIDLCompilerI_IOR__external * _epv = NULL;

static PyObject *
ANL_SIDLCompilerI_IOR_addReference(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct ANL_SIDLCompilerI_IOR__object *_self_ior = ((struct ANL_SIDLCompilerI_IOR__object *) SIDL_Cast(_self, "ANL.SIDLCompilerI.IOR"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for addReference");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in addReference()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_addReference))(_self_ior  );
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
ANL_SIDLCompilerI_IOR_deleteReference(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct ANL_SIDLCompilerI_IOR__object *_self_ior = ((struct ANL_SIDLCompilerI_IOR__object *) SIDL_Cast(_self, "ANL.SIDLCompilerI.IOR"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for deleteReference");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in deleteReference()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_deleteReference))(_self_ior  );
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
ANL_SIDLCompilerI_IOR_isSame(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct ANL_SIDLCompilerI_IOR__object *_self_ior = ((struct ANL_SIDLCompilerI_IOR__object *) SIDL_Cast(_self, "ANL.SIDLCompilerI.IOR"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  SIDL_bool _result;
  int _local__result;
  /* Pack arguments for dispatch to IOR */
  struct SIDL_BaseInterface__object * iobj = NULL;
  static char *_kwlist[] = {
    (char *) "iobj",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "O&", _kwlist,
    (void *) SIDL_BaseInterface__convert, &iobj
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for isSame");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in isSame()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_isSame))(_self_ior  , /*in*/ iobj);
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _local__result = (_result != FALSE);
  _return_value = Py_BuildValue(
     (char *) "i",
    _local__result
  );
  SIDL_BaseInterface__deref(iobj);
  return _return_value;
}

static PyObject *
ANL_SIDLCompilerI_IOR_queryInterface(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct ANL_SIDLCompilerI_IOR__object *_self_ior = ((struct ANL_SIDLCompilerI_IOR__object *) SIDL_Cast(_self, "ANL.SIDLCompilerI.IOR"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseInterface__object * _result = NULL;
  /* Pack arguments for dispatch to IOR */
  char * name;
  static char *_kwlist[] = {
    (char *) "name",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "z", _kwlist,
    &name
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for queryInterface");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in queryInterface()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_queryInterface))(_self_ior  , /*in*/ name);
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "O&",
    (void *) SIDL_BaseInterface__wrap, _result
  );
  return _return_value;
}

static PyObject *
ANL_SIDLCompilerI_IOR_isInstanceOf(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct ANL_SIDLCompilerI_IOR__object *_self_ior = ((struct ANL_SIDLCompilerI_IOR__object *) SIDL_Cast(_self, "ANL.SIDLCompilerI.IOR"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  SIDL_bool _result;
  int _local__result;
  /* Pack arguments for dispatch to IOR */
  char * name;
  static char *_kwlist[] = {
    (char *) "name",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "z", _kwlist,
    &name
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for isInstanceOf");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in isInstanceOf()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_isInstanceOf))(_self_ior  , /*in*/ name);
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _local__result = (_result != FALSE);
  _return_value = Py_BuildValue(
     (char *) "i",
    _local__result
  );
  return _return_value;
}

static PyObject *
ANL_SIDLCompilerI_IOR_getName(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct ANL_SIDLCompilerI_IOR__object *_self_ior = ((struct ANL_SIDLCompilerI_IOR__object *) SIDL_Cast(_self, "ANL.SIDLCompilerI.IOR"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  char * _result;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for getName");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in getName()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_getName))(_self_ior  , &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "z",
    _result
  );
  free((void *) _result);
  return _return_value;
}

static PyObject *
ANL_SIDLCompilerI_IOR_setName(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct ANL_SIDLCompilerI_IOR__object *_self_ior = ((struct ANL_SIDLCompilerI_IOR__object *) SIDL_Cast(_self, "ANL.SIDLCompilerI.IOR"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  char * name;
  static char *_kwlist[] = {
    (char *) "name",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "z", _kwlist,
    &name
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for setName");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in setName()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_setName))(_self_ior  , /*in*/ name, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
ANL_SIDLCompilerI_IOR_getPathExtension(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct ANL_SIDLCompilerI_IOR__object *_self_ior = ((struct ANL_SIDLCompilerI_IOR__object *) SIDL_Cast(_self, "ANL.SIDLCompilerI.IOR"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  char * _result;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for getPathExtension");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in getPathExtension()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_getPathExtension))(_self_ior  , &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "z",
    _result
  );
  free((void *) _result);
  return _return_value;
}

static PyObject *
ANL_SIDLCompilerI_IOR_setPathExtension(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct ANL_SIDLCompilerI_IOR__object *_self_ior = ((struct ANL_SIDLCompilerI_IOR__object *) SIDL_Cast(_self, "ANL.SIDLCompilerI.IOR"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  char * pathExtension;
  static char *_kwlist[] = {
    (char *) "pathExtension",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "z", _kwlist,
    &pathExtension
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for setPathExtension");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in setPathExtension()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_setPathExtension))(_self_ior  , /*in*/ pathExtension, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
ANL_SIDLCompilerI_IOR_getEmbedded(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct ANL_SIDLCompilerI_IOR__object *_self_ior = ((struct ANL_SIDLCompilerI_IOR__object *) SIDL_Cast(_self, "ANL.SIDLCompilerI.IOR"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  SIDL_bool _result;
  int _local__result;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for getEmbedded");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in getEmbedded()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_getEmbedded))(_self_ior  , &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _local__result = (_result != FALSE);
  _return_value = Py_BuildValue(
     (char *) "i",
    _local__result
  );
  return _return_value;
}

static PyObject *
ANL_SIDLCompilerI_IOR_setEmbedded(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct ANL_SIDLCompilerI_IOR__object *_self_ior = ((struct ANL_SIDLCompilerI_IOR__object *) SIDL_Cast(_self, "ANL.SIDLCompilerI.IOR"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  SIDL_bool isEmbedded;
  int _local_isEmbedded;
  static char *_kwlist[] = {
    (char *) "isEmbedded",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "i", _kwlist,
    &_local_isEmbedded
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for setEmbedded");
    return _return_value;
  }
  isEmbedded = (_local_isEmbedded != FALSE);
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in setEmbedded()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_setEmbedded))(_self_ior  , /*in*/ isEmbedded, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
ANL_SIDLCompilerI_IOR_getUseSplicer(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct ANL_SIDLCompilerI_IOR__object *_self_ior = ((struct ANL_SIDLCompilerI_IOR__object *) SIDL_Cast(_self, "ANL.SIDLCompilerI.IOR"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  SIDL_bool _result;
  int _local__result;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for getUseSplicer");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in getUseSplicer()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_getUseSplicer))(_self_ior  , &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _local__result = (_result != FALSE);
  _return_value = Py_BuildValue(
     (char *) "i",
    _local__result
  );
  return _return_value;
}

static PyObject *
ANL_SIDLCompilerI_IOR_setUseSplicer(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct ANL_SIDLCompilerI_IOR__object *_self_ior = ((struct ANL_SIDLCompilerI_IOR__object *) SIDL_Cast(_self, "ANL.SIDLCompilerI.IOR"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  SIDL_bool useSplicer;
  int _local_useSplicer;
  static char *_kwlist[] = {
    (char *) "useSplicer",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "i", _kwlist,
    &_local_useSplicer
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for setUseSplicer");
    return _return_value;
  }
  useSplicer = (_local_useSplicer != FALSE);
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in setUseSplicer()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_setUseSplicer))(_self_ior  , /*in*/ useSplicer, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
ANL_SIDLCompilerI_IOR_getGenerateMethods(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct ANL_SIDLCompilerI_IOR__object *_self_ior = ((struct ANL_SIDLCompilerI_IOR__object *) SIDL_Cast(_self, "ANL.SIDLCompilerI.IOR"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  SIDL_bool _result;
  int _local__result;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for getGenerateMethods");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in getGenerateMethods()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_getGenerateMethods))(_self_ior  , &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _local__result = (_result != FALSE);
  _return_value = Py_BuildValue(
     (char *) "i",
    _local__result
  );
  return _return_value;
}

static PyObject *
ANL_SIDLCompilerI_IOR_setGenerateMethods(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct ANL_SIDLCompilerI_IOR__object *_self_ior = ((struct ANL_SIDLCompilerI_IOR__object *) SIDL_Cast(_self, "ANL.SIDLCompilerI.IOR"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  SIDL_bool generateMethods;
  int _local_generateMethods;
  static char *_kwlist[] = {
    (char *) "generateMethods",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "i", _kwlist,
    &_local_generateMethods
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for setGenerateMethods");
    return _return_value;
  }
  generateMethods = (_local_generateMethods != FALSE);
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in setGenerateMethods()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_setGenerateMethods))(_self_ior  , /*in*/ generateMethods, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
ANL_SIDLCompilerI_IOR_getCheckIOR(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct ANL_SIDLCompilerI_IOR__object *_self_ior = ((struct ANL_SIDLCompilerI_IOR__object *) SIDL_Cast(_self, "ANL.SIDLCompilerI.IOR"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  SIDL_bool _result;
  int _local__result;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for getCheckIOR");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in getCheckIOR()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_getCheckIOR))(_self_ior  , &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _local__result = (_result != FALSE);
  _return_value = Py_BuildValue(
     (char *) "i",
    _local__result
  );
  return _return_value;
}

static PyObject *
ANL_SIDLCompilerI_IOR_setCheckIOR(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct ANL_SIDLCompilerI_IOR__object *_self_ior = ((struct ANL_SIDLCompilerI_IOR__object *) SIDL_Cast(_self, "ANL.SIDLCompilerI.IOR"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  SIDL_bool checkIOR;
  int _local_checkIOR;
  static char *_kwlist[] = {
    (char *) "checkIOR",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "i", _kwlist,
    &_local_checkIOR
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for setCheckIOR");
    return _return_value;
  }
  checkIOR = (_local_checkIOR != FALSE);
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in setCheckIOR()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_setCheckIOR))(_self_ior  , /*in*/ checkIOR, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
ANL_SIDLCompilerI_IOR_getUseSelf(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct ANL_SIDLCompilerI_IOR__object *_self_ior = ((struct ANL_SIDLCompilerI_IOR__object *) SIDL_Cast(_self, "ANL.SIDLCompilerI.IOR"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  SIDL_bool _result;
  int _local__result;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for getUseSelf");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in getUseSelf()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_getUseSelf))(_self_ior  , &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _local__result = (_result != FALSE);
  _return_value = Py_BuildValue(
     (char *) "i",
    _local__result
  );
  return _return_value;
}

static PyObject *
ANL_SIDLCompilerI_IOR_setUseSelf(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct ANL_SIDLCompilerI_IOR__object *_self_ior = ((struct ANL_SIDLCompilerI_IOR__object *) SIDL_Cast(_self, "ANL.SIDLCompilerI.IOR"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  SIDL_bool useSelf;
  int _local_useSelf;
  static char *_kwlist[] = {
    (char *) "useSelf",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "i", _kwlist,
    &_local_useSelf
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for setUseSelf");
    return _return_value;
  }
  useSelf = (_local_useSelf != FALSE);
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in setUseSelf()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_setUseSelf))(_self_ior  , /*in*/ useSelf, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
ANL_SIDLCompilerI_IOR_getEmulateExceptions(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct ANL_SIDLCompilerI_IOR__object *_self_ior = ((struct ANL_SIDLCompilerI_IOR__object *) SIDL_Cast(_self, "ANL.SIDLCompilerI.IOR"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  SIDL_bool _result;
  int _local__result;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for getEmulateExceptions");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in getEmulateExceptions()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_getEmulateExceptions))(_self_ior  , &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _local__result = (_result != FALSE);
  _return_value = Py_BuildValue(
     (char *) "i",
    _local__result
  );
  return _return_value;
}

static PyObject *
ANL_SIDLCompilerI_IOR_setEmulateExceptions(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct ANL_SIDLCompilerI_IOR__object *_self_ior = ((struct ANL_SIDLCompilerI_IOR__object *) SIDL_Cast(_self, "ANL.SIDLCompilerI.IOR"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  SIDL_bool emulateExceptions;
  int _local_emulateExceptions;
  static char *_kwlist[] = {
    (char *) "emulateExceptions",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "i", _kwlist,
    &_local_emulateExceptions
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for setEmulateExceptions");
    return _return_value;
  }
  emulateExceptions = (_local_emulateExceptions != FALSE);
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in setEmulateExceptions()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_setEmulateExceptions))(_self_ior  , /*in*/ emulateExceptions, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
ANL_SIDLCompilerI_IOR_getIORDispatch(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct ANL_SIDLCompilerI_IOR__object *_self_ior = ((struct ANL_SIDLCompilerI_IOR__object *) SIDL_Cast(_self, "ANL.SIDLCompilerI.IOR"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  SIDL_bool _result;
  int _local__result;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for getIORDispatch");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in getIORDispatch()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_getIORDispatch))(_self_ior  , &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _local__result = (_result != FALSE);
  _return_value = Py_BuildValue(
     (char *) "i",
    _local__result
  );
  return _return_value;
}

static PyObject *
ANL_SIDLCompilerI_IOR_setIORDispatch(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct ANL_SIDLCompilerI_IOR__object *_self_ior = ((struct ANL_SIDLCompilerI_IOR__object *) SIDL_Cast(_self, "ANL.SIDLCompilerI.IOR"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  SIDL_bool iorDispatch;
  int _local_iorDispatch;
  static char *_kwlist[] = {
    (char *) "iorDispatch",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "i", _kwlist,
    &_local_iorDispatch
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for setIORDispatch");
    return _return_value;
  }
  iorDispatch = (_local_iorDispatch != FALSE);
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in setIORDispatch()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_setIORDispatch))(_self_ior  , /*in*/ iorDispatch, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
ANL_SIDLCompilerI_IOR_IOR(
  PyObject *_ignored,
  PyObject *_args,
  PyObject *_kwdict
)
{
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct ANL_SIDLCompilerI_IOR__object * _result = NULL;
  /* Pack arguments for dispatch to IOR */
  struct ANL_SIDLCompilerI_IOR__object * optarg = NULL;
  static char *_kwlist[] = {
    (char *) "optarg",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "|O&", _kwlist,
    (void *) ANL_SIDLCompilerI_IOR__convert, &optarg
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for IOR");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  /* Implementation code */
  if (optarg) {
    (*(optarg->d_epv->f_addReference))(optarg);
  } else {
    optarg = (*(_epv->createObject))();
  }
  /* Since we may merely up the reference count and return the argument, add an extra reference */
  ANL_SIDLCompilerI_IOR__addRef(optarg);
  _result = optarg;  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "O&",
    (void *) ANL_SIDLCompilerI_IOR__wrap, _result
  );
  ANL_SIDLCompilerI_IOR__deref(optarg);
  return _return_value;
}

static PyMethodDef _IORModuleMethods[] = {
  {(char *) "IOR", (PyCFunction) ANL_SIDLCompilerI_IOR_IOR, (METH_VARARGS | METH_KEYWORDS), (char *) "IOR(in IOR optarg)\n\
RETURNS\n\
  ANL.SIDLCompilerI.IOR _result\n\
Constructor and/or cast method for ANL.SIDLCompilerI.IOR\n\
"},
  {NULL, NULL}
};

static PyMethodDef _IORObjectMethods[] = {
  {(char *) "addReference", (PyCFunction) ANL_SIDLCompilerI_IOR_addReference, (METH_VARARGS | METH_KEYWORDS), (char *) "addReference()\n\
RETURNS\n\
   None\n\
// Add one to the intrinsic reference count in the underlying object.\n\
// Object in <code>SIDL</code> have an intrinsic reference count.\n\
// Objects continue to exist as long as the reference count is\n\
// positive. Clients should call this method whenever they\n\
// create another ongoing reference to an object or interface.\n\
// \n\
// This does not have a return value because there is no language\n\
// independent type that can refer to an interface or a\n\
// class.\n\
"},
  {(char *) "deleteReference", (PyCFunction) ANL_SIDLCompilerI_IOR_deleteReference, (METH_VARARGS | METH_KEYWORDS), (char *) "deleteReference()\n\
RETURNS\n\
   None\n\
// Decrease by one the intrinsic reference count in the underlying\n\
// object, and delete the object if the reference is non-positive.\n\
// Objects in <code>SIDL</code> have an intrinsic reference count.\n\
// Clients should call this method whenever they remove a\n\
// reference to an object or interface.\n\
"},
  {(char *) "isSame", (PyCFunction) ANL_SIDLCompilerI_IOR_isSame, (METH_VARARGS | METH_KEYWORDS), (char *) "isSame(in BaseInterface iobj)\n\
RETURNS\n\
  bool _result\n\
// Return true if and only if <code>obj</code> refers to the same\n\
// object as this object.\n\
"},
  {(char *) "queryInterface", (PyCFunction) ANL_SIDLCompilerI_IOR_queryInterface, (METH_VARARGS | METH_KEYWORDS), (char *) "queryInterface(in string name)\n\
RETURNS\n\
  SIDL.BaseInterface _result\n\
// Check whether the object can support the specified interface or\n\
// class.  If the <code>SIDL</code> type name in <code>name</code>\n\
// is supported, then a reference to that object is returned with the\n\
// reference count incremented.  The callee will be responsible for\n\
// calling <code>deleteReference</code> on the returned object.  If\n\
// the specified type is not supported, then a null reference is\n\
// returned.\n\
"},
  {(char *) "isInstanceOf", (PyCFunction) ANL_SIDLCompilerI_IOR_isInstanceOf, (METH_VARARGS | METH_KEYWORDS), (char *) "isInstanceOf(in string name)\n\
RETURNS\n\
  bool _result\n\
// Return whether this object is an instance of the specified type.\n\
// The string name must be the <code>SIDL</code> type name.  This\n\
// routine will return <code>true</code> if and only if a cast to\n\
// the string type name would succeed.\n\
"},
  {(char *) "getName", (PyCFunction) ANL_SIDLCompilerI_IOR_getName, (METH_VARARGS | METH_KEYWORDS), (char *) "getName()\n\
RETURNS\n\
  string _result\n\
// Get the purpose name\n\
"},
  {(char *) "setName", (PyCFunction) ANL_SIDLCompilerI_IOR_setName, (METH_VARARGS | METH_KEYWORDS), (char *) "setName(in string name)\n\
RETURNS\n\
   None\n\
// Set the purpose name\n\
"},
  {(char *) "getPathExtension", (PyCFunction) ANL_SIDLCompilerI_IOR_getPathExtension, (METH_VARARGS | METH_KEYWORDS), (char *) "getPathExtension()\n\
RETURNS\n\
  string _result\n\
// Get the suggested path extension\n\
"},
  {(char *) "setPathExtension", (PyCFunction) ANL_SIDLCompilerI_IOR_setPathExtension, (METH_VARARGS | METH_KEYWORDS), (char *) "setPathExtension(in string pathExtension)\n\
RETURNS\n\
   None\n\
// Set the suggested path extension\n\
"},
  {(char *) "getEmbedded", (PyCFunction) ANL_SIDLCompilerI_IOR_getEmbedded, (METH_VARARGS | METH_KEYWORDS), (char *) "getEmbedded()\n\
RETURNS\n\
  bool _result\n\
// Get the flag indicating whether functions should be defined inline\n\
"},
  {(char *) "setEmbedded", (PyCFunction) ANL_SIDLCompilerI_IOR_setEmbedded, (METH_VARARGS | METH_KEYWORDS), (char *) "setEmbedded(in bool isEmbedded)\n\
RETURNS\n\
   None\n\
// Set the flag indicating whether functions should be defined inline\n\
"},
  {(char *) "getUseSplicer", (PyCFunction) ANL_SIDLCompilerI_IOR_getUseSplicer, (METH_VARARGS | METH_KEYWORDS), (char *) "getUseSplicer()\n\
RETURNS\n\
  bool _result\n\
// Get the flag indicating whether splicer blocks should be generated\n\
"},
  {(char *) "setUseSplicer", (PyCFunction) ANL_SIDLCompilerI_IOR_setUseSplicer, (METH_VARARGS | METH_KEYWORDS), (char *) "setUseSplicer(in bool useSplicer)\n\
RETURNS\n\
   None\n\
// Set the flag indicating whether splicer blocks should be generated\n\
"},
  {(char *) "getGenerateMethods", (PyCFunction) ANL_SIDLCompilerI_IOR_getGenerateMethods, (METH_VARARGS | METH_KEYWORDS), (char *) "getGenerateMethods()\n\
RETURNS\n\
  bool _result\n\
// Get the flag indicating whether method bodies are autogenerated\n\
"},
  {(char *) "setGenerateMethods", (PyCFunction) ANL_SIDLCompilerI_IOR_setGenerateMethods, (METH_VARARGS | METH_KEYWORDS), (char *) "setGenerateMethods(in bool generateMethods)\n\
RETURNS\n\
   None\n\
// Set the flag indicating whether method bodies are autogenerated\n\
"},
  {(char *) "getCheckIOR", (PyCFunction) ANL_SIDLCompilerI_IOR_getCheckIOR, (METH_VARARGS | METH_KEYWORDS), (char *) "getCheckIOR()\n\
RETURNS\n\
  bool _result\n\
// Get the flag indicating whether the IOR pointer should be checked\n\
"},
  {(char *) "setCheckIOR", (PyCFunction) ANL_SIDLCompilerI_IOR_setCheckIOR, (METH_VARARGS | METH_KEYWORDS), (char *) "setCheckIOR(in bool checkIOR)\n\
RETURNS\n\
   None\n\
// Set the flag indicating whether the IOR pointer should be checked\n\
"},
  {(char *) "getUseSelf", (PyCFunction) ANL_SIDLCompilerI_IOR_getUseSelf, (METH_VARARGS | METH_KEYWORDS), (char *) "getUseSelf()\n\
RETURNS\n\
  bool _result\n\
// Get the flag indicating whether an initial self argument should be added to the dispatch call\n\
"},
  {(char *) "setUseSelf", (PyCFunction) ANL_SIDLCompilerI_IOR_setUseSelf, (METH_VARARGS | METH_KEYWORDS), (char *) "setUseSelf(in bool useSelf)\n\
RETURNS\n\
   None\n\
// Set the flag indicating whether an initial self argument should be added to the dispatch call\n\
"},
  {(char *) "getEmulateExceptions", (PyCFunction) ANL_SIDLCompilerI_IOR_getEmulateExceptions, (METH_VARARGS | METH_KEYWORDS), (char *) "getEmulateExceptions()\n\
RETURNS\n\
  bool _result\n\
// Get the flag indicating whether exceptions are emulated with extra arguments\n\
"},
  {(char *) "setEmulateExceptions", (PyCFunction) ANL_SIDLCompilerI_IOR_setEmulateExceptions, (METH_VARARGS | METH_KEYWORDS), (char *) "setEmulateExceptions(in bool emulateExceptions)\n\
RETURNS\n\
   None\n\
// Set the flag indicating whether exceptions are emulated with extra arguments\n\
"},
  {(char *) "getIORDispatch", (PyCFunction) ANL_SIDLCompilerI_IOR_getIORDispatch, (METH_VARARGS | METH_KEYWORDS), (char *) "getIORDispatch()\n\
RETURNS\n\
  bool _result\n\
// Get the flag indicating whether dispatch occurs to the IOR or the implementation\n\
"},
  {(char *) "setIORDispatch", (PyCFunction) ANL_SIDLCompilerI_IOR_setIORDispatch, (METH_VARARGS | METH_KEYWORDS), (char *) "setIORDispatch(in bool iorDispatch)\n\
RETURNS\n\
   None\n\
// Set the flag indicating whether dispatch occurs to the IOR or the implementation\n\
"},
  {NULL, NULL}
};

ANL_SIDLCompilerI_IOR__wrap_RETURN
ANL_SIDLCompilerI_IOR__wrap ANL_SIDLCompilerI_IOR__wrap_PROTO {
  if (!sidlobj) {
    return Py_None;
  } else {
    return SIDL_Object_Create(sidlobj->d_epv->f__cast_ior(sidlobj, "ANL.SIDLCompilerI.IOR"), _IORObjectMethods, SIDL_PyStealRef);
  }
}

ANL_SIDLCompilerI_IOR__weakRef_RETURN
ANL_SIDLCompilerI_IOR__weakRef ANL_SIDLCompilerI_IOR__weakRef_PROTO {
  return SIDL_Object_Create(sidlobj->d_epv->f__cast_ior(sidlobj, "ANL.SIDLCompilerI.IOR"), _IORObjectMethods, SIDL_PyWeakRef);
}

ANL_SIDLCompilerI_IOR__deref_RETURN
ANL_SIDLCompilerI_IOR__deref ANL_SIDLCompilerI_IOR__deref_PROTO {
  if (sidlobj) {
    (*(sidlobj->d_epv->f_deleteReference))(sidlobj);
  }
}

ANL_SIDLCompilerI_IOR__newRef_RETURN
ANL_SIDLCompilerI_IOR__newRef ANL_SIDLCompilerI_IOR__newRef_PROTO {
  return SIDL_Object_Create(sidlobj->d_epv->f__cast_ior(sidlobj, "ANL.SIDLCompilerI.IOR"), _IORObjectMethods, SIDL_PyNewRef);
}

ANL_SIDLCompilerI_IOR__addRef_RETURN
ANL_SIDLCompilerI_IOR__addRef ANL_SIDLCompilerI_IOR__addRef_PROTO {
  if (sidlobj) {
    (*(sidlobj->d_epv->f_addReference))(sidlobj);
  }
}

ANL_SIDLCompilerI_IOR__convert_RETURN
ANL_SIDLCompilerI_IOR__convert ANL_SIDLCompilerI_IOR__convert_PROTO {
  *sidlobj = SIDL_Cast(obj, "ANL.SIDLCompilerI.IOR");
  if (*sidlobj) {
    (*((*sidlobj)->d_epv->f_addReference))((*sidlobj));
  } else if (obj != Py_None) {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ANL.SIDLCompilerI.IOR");
    return 0;
  }
  return 1;
}

static int
_convertPython(void *sidlarray, const int *ind, PyObject *pyobj) {
  struct ANL_SIDLCompilerI_IOR__object *sidlobj;

  if (ANL_SIDLCompilerI_IOR__convert(pyobj, &sidlobj)) {
    (*_epv->setElement)((struct ANL_SIDLCompilerI_IOR__array *) sidlarray, ind, sidlobj);
    return 0;
  }
  return 1;
}

ANL_SIDLCompilerI_IOR__convert_python_array_RETURN
ANL_SIDLCompilerI_IOR__convert_python_array ANL_SIDLCompilerI_IOR__convert_python_array_PROTO {
  PyObject *pya    = PyArray_FromObject(obj, PyArray_OBJECT, 0, 0);
  int       result = 0;

  *sidlarray = NULL;
  if (pya) {
    if (PyArray_OBJECT == ((PyArrayObject *) pya)->descr->type_num) {
      int dimen, *lower, *upper, *stride;

      if (SIDL_array__extract_python_info(pya, &dimen, &lower, &upper, &stride)) {
        *sidlarray = (*_epv->createArray)(dimen, lower, upper);
        free(lower);
        free(upper);
        free(stride);
        result = SIDL_array__convert_python(pya, dimen, *sidlarray, _convertPython);
        if (*sidlarray && !result) {
          (*_epv->destroyArray)(*sidlarray);
          *sidlarray = NULL;
        }
      }
    }
    Py_DECREF(pya);
  }
  return result;
}

static int
_convertSIDL(void *sidlarray, const int *ind, PyObject **dest) {
  struct ANL_SIDLCompilerI_IOR__object *sidlobj = (*_epv->getElement)((struct ANL_SIDLCompilerI_IOR__array *) sidlarray, ind);

  *dest = ANL_SIDLCompilerI_IOR__wrap(sidlobj);
  return (*dest == NULL);
}

ANL_SIDLCompilerI_IOR__convert_sidl_array_RETURN
ANL_SIDLCompilerI_IOR__convert_sidl_array ANL_SIDLCompilerI_IOR__convert_sidl_array_PROTO {
  PyObject *pya = NULL;

  if (sidlarray) {
    const int dimen   = (*_epv->getDimen)(sidlarray);
    int      *lower   = (int *) malloc(dimen * sizeof(int));
    int      *upper   = (int *) malloc(dimen * sizeof(int));
    int      *numElem = (int *) malloc(dimen * sizeof(int));
    int       i;

    for(i = 0; i < dimen; i++) {
      lower[i]   = (*_epv->getLower)(sidlarray, i);
      upper[i]   = (*_epv->getUpper)(sidlarray, i);
      numElem[i] = upper[i] - lower[i] + 1;
    }
    pya = PyArray_FromDims(dimen, numElem, PyArray_OBJECT);;
    if (pya) {
      if (!SIDL_array__convert_sidl(pya, dimen, lower, upper, numElem, sidlarray, _convertSIDL)) {
        Py_DECREF(pya);
        pya = NULL;
      }
    }
    free(lower);
    free(upper);
    free(numElem);
  }
  return pya;
}

ANL_SIDLCompilerI_IOR__destroy_sidl_array_RETURN
ANL_SIDLCompilerI_IOR__destroy_sidl_array ANL_SIDLCompilerI_IOR__destroy_sidl_array_PROTO {
  if (sidlarray) {
    (*_epv->destroyArray)(sidlarray);
  }
}

void initIOR(void) {
  PyObject *module, *dict, *c_api;
  static void *ExternalAPI[ANL_SIDLCompilerI_IOR__API_NUM];
  struct ANL_SIDLCompilerI_IOR__external * (*_extFunc)(void) = NULL;
  module = Py_InitModule((char *) "IOR", _IORModuleMethods);
  _extFunc = (struct ANL_SIDLCompilerI_IOR__external * (*)(void)) SIDL_Loader__externals()->getStaticEPV()->f_lookupSymbol("ANL_SIDLCompilerI_IOR__externals");
  if (_extFunc) {
    _epv = (*_extFunc)();
  }
  if (!_epv) {
    PyErr_SetString(PyExc_TypeError, "Cannot load SIDL implementation for ANL.SIDLCompilerI.IOR");
    return;
  }
  dict = PyModule_GetDict(module);
  ExternalAPI[ANL_SIDLCompilerI_IOR__wrap_NUM] = ANL_SIDLCompilerI_IOR__wrap;
  ExternalAPI[ANL_SIDLCompilerI_IOR__convert_NUM] = ANL_SIDLCompilerI_IOR__convert;
  ExternalAPI[ANL_SIDLCompilerI_IOR__convert_python_array_NUM] = ANL_SIDLCompilerI_IOR__convert_python_array;
  ExternalAPI[ANL_SIDLCompilerI_IOR__convert_sidl_array_NUM] = ANL_SIDLCompilerI_IOR__convert_sidl_array;
  ExternalAPI[ANL_SIDLCompilerI_IOR__destroy_sidl_array_NUM] = ANL_SIDLCompilerI_IOR__destroy_sidl_array;
  ExternalAPI[ANL_SIDLCompilerI_IOR__weakRef_NUM] = ANL_SIDLCompilerI_IOR__weakRef;
  ExternalAPI[ANL_SIDLCompilerI_IOR__deref_NUM] = ANL_SIDLCompilerI_IOR__deref;
  ExternalAPI[ANL_SIDLCompilerI_IOR__newRef_NUM] = ANL_SIDLCompilerI_IOR__newRef;
  ExternalAPI[ANL_SIDLCompilerI_IOR__addRef_NUM] = ANL_SIDLCompilerI_IOR__addRef;
  import_SIDLObjA();
  if (PyErr_Occurred()) {
    PyErr_SetString(PyExc_ImportError, "Cannot import SIDLObjA module");
    return;
  }
  c_api = PyCObject_FromVoidPtr((void *) ExternalAPI, NULL);
  PyDict_SetItemString(dict, (char *) "_C_API", c_api);
  Py_XDECREF(c_api);
  if (PyErr_Occurred()) {
    PyErr_SetString(PyExc_TypeError, "Cannot initialize Python module ANL.SIDLCompilerI.IOR");
    return;
  }
  import_SIDLPyArrays();
  if (PyErr_Occurred()) {
    PyErr_SetString(PyExc_ImportError, "Cannot import SIDLPyArrays module");
    return;
  }
  import_array();
  if (PyErr_Occurred()) {
    PyErr_SetString(PyExc_ImportError, "Cannot import Numeric Python array module");
    return;
  }
  SIDL_NullIORException__import();
  SIDL_BaseInterface__import();
  SIDL_BaseException__import();
}
