#define ANL_SIDLCompilerI_SIDLCompiler_INTERNAL 1

#include "SIDLObjA.h"
#include "SIDLPyArrays.h"
#include "Numeric/arrayobject.h"

#ifndef included_ANL_SIDLCompilerI_SIDLCompiler_stub
#include "ANL/SIDLCompilerI/SIDLCompiler_Module.h"
#endif
#ifndef included_ANL_SIDLCompilerI_SIDLCompiler_IOR
#include "ANL/SIDLCompilerI/SIDLCompiler_IOR/SIDLCompiler_IOR.h"
#endif
//
// Includes for all method dependencies
//
#ifndef included_SIDL_Loader_IOR
#include "SIDL/Loader_IOR/Loader_IOR.h"
#endif
#ifndef included_SIDL_NullIORException_stub
#include "SIDL/NullIORException_Module.h"
#endif
#ifndef included_SIDL_BaseInterface_stub
#include "SIDL/BaseInterface_Module.h"
#endif
#ifndef included_SIDLLanguage_AST_stub
#include "SIDLLanguage/AST_Module.h"
#endif
#ifndef included_SIDLLanguage_ParserException_stub
#include "SIDLLanguage/ParserException_Module.h"
#endif
#ifndef included_SIDL_BaseException_stub
#include "SIDL/BaseException_Module.h"
#endif


static const struct ANL_SIDLCompilerI_SIDLCompiler__external * _epv = NULL;

static PyObject *
ANL_SIDLCompilerI_SIDLCompiler_addReference(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct ANL_SIDLCompilerI_SIDLCompiler__object *_self_ior = ((struct ANL_SIDLCompilerI_SIDLCompiler__object *) SIDL_Cast(_self, "ANL.SIDLCompilerI.SIDLCompiler"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for addReference");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in addReference()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_addReference))(_self_ior  );
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
ANL_SIDLCompilerI_SIDLCompiler_deleteReference(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct ANL_SIDLCompilerI_SIDLCompiler__object *_self_ior = ((struct ANL_SIDLCompilerI_SIDLCompiler__object *) SIDL_Cast(_self, "ANL.SIDLCompilerI.SIDLCompiler"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for deleteReference");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in deleteReference()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_deleteReference))(_self_ior  );
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
ANL_SIDLCompilerI_SIDLCompiler_isSame(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct ANL_SIDLCompilerI_SIDLCompiler__object *_self_ior = ((struct ANL_SIDLCompilerI_SIDLCompiler__object *) SIDL_Cast(_self, "ANL.SIDLCompilerI.SIDLCompiler"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  SIDL_bool _result;
  int _local__result;
  /* Pack arguments for dispatch to IOR */
  struct SIDL_BaseInterface__object * iobj = NULL;
  static char *_kwlist[] = {
    (char *) "iobj",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "O&", _kwlist,
    (void *) SIDL_BaseInterface__convert, &iobj
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for isSame");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in isSame()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_isSame))(_self_ior  , /*in*/ iobj);
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _local__result = (_result != FALSE);
  _return_value = Py_BuildValue(
     (char *) "i",
    _local__result
  );
  SIDL_BaseInterface__deref(iobj);
  return _return_value;
}

static PyObject *
ANL_SIDLCompilerI_SIDLCompiler_queryInterface(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct ANL_SIDLCompilerI_SIDLCompiler__object *_self_ior = ((struct ANL_SIDLCompilerI_SIDLCompiler__object *) SIDL_Cast(_self, "ANL.SIDLCompilerI.SIDLCompiler"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseInterface__object * _result = NULL;
  /* Pack arguments for dispatch to IOR */
  char * name;
  static char *_kwlist[] = {
    (char *) "name",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "z", _kwlist,
    &name
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for queryInterface");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in queryInterface()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_queryInterface))(_self_ior  , /*in*/ name);
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "O&",
    (void *) SIDL_BaseInterface__wrap, _result
  );
  return _return_value;
}

static PyObject *
ANL_SIDLCompilerI_SIDLCompiler_isInstanceOf(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct ANL_SIDLCompilerI_SIDLCompiler__object *_self_ior = ((struct ANL_SIDLCompilerI_SIDLCompiler__object *) SIDL_Cast(_self, "ANL.SIDLCompilerI.SIDLCompiler"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  SIDL_bool _result;
  int _local__result;
  /* Pack arguments for dispatch to IOR */
  char * name;
  static char *_kwlist[] = {
    (char *) "name",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "z", _kwlist,
    &name
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for isInstanceOf");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in isInstanceOf()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_isInstanceOf))(_self_ior  , /*in*/ name);
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _local__result = (_result != FALSE);
  _return_value = Py_BuildValue(
     (char *) "i",
    _local__result
  );
  return _return_value;
}

static PyObject *
ANL_SIDLCompilerI_SIDLCompiler_parse(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct ANL_SIDLCompilerI_SIDLCompiler__object *_self_ior = ((struct ANL_SIDLCompilerI_SIDLCompiler__object *) SIDL_Cast(_self, "ANL.SIDLCompilerI.SIDLCompiler"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDLLanguage_AST__object * _result = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  char * buf;
  static char *_kwlist[] = {
    (char *) "buf",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "z", _kwlist,
    &buf
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for parse");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in parse()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_parse))(_self_ior  , /*in*/ buf, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDLLanguage_ParserException__object *_ex0;
    struct SIDL_BaseException__object *_ex1;
  
    if (!found && (_ex0 = (struct SIDLLanguage_ParserException__object *) SIDL_PyExceptionCast(_exception, "SIDLLanguage.ParserException"))) {
      PyObject *obj = SIDLLanguage_ParserException__wrap(_ex0);
  
      PyErr_SetObject(SIDLLanguage_ParserException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found && (_ex1 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex1);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "O&",
    (void *) SIDLLanguage_AST__wrap, _result
  );
  return _return_value;
}

static PyObject *
ANL_SIDLCompilerI_SIDLCompiler_parseFile(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct ANL_SIDLCompilerI_SIDLCompiler__object *_self_ior = ((struct ANL_SIDLCompilerI_SIDLCompiler__object *) SIDL_Cast(_self, "ANL.SIDLCompilerI.SIDLCompiler"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDLLanguage_AST__object * _result = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  char * filename;
  static char *_kwlist[] = {
    (char *) "filename",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "z", _kwlist,
    &filename
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for parseFile");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in parseFile()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_parseFile))(_self_ior  , /*in*/ filename, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDLLanguage_ParserException__object *_ex0;
    struct SIDL_BaseException__object *_ex1;
  
    if (!found && (_ex0 = (struct SIDLLanguage_ParserException__object *) SIDL_PyExceptionCast(_exception, "SIDLLanguage.ParserException"))) {
      PyObject *obj = SIDLLanguage_ParserException__wrap(_ex0);
  
      PyErr_SetObject(SIDLLanguage_ParserException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found && (_ex1 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex1);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "O&",
    (void *) SIDLLanguage_AST__wrap, _result
  );
  return _return_value;
}

static PyObject *
ANL_SIDLCompilerI_SIDLCompiler_SIDLCompiler(
  PyObject *_ignored,
  PyObject *_args,
  PyObject *_kwdict
)
{
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct ANL_SIDLCompilerI_SIDLCompiler__object * _result = NULL;
  /* Pack arguments for dispatch to IOR */
  struct ANL_SIDLCompilerI_SIDLCompiler__object * optarg = NULL;
  static char *_kwlist[] = {
    (char *) "optarg",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "|O&", _kwlist,
    (void *) ANL_SIDLCompilerI_SIDLCompiler__convert, &optarg
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for SIDLCompiler");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  /* Implementation code */
  if (optarg) {
    (*(optarg->d_epv->f_addReference))(optarg);
  } else {
    optarg = (*(_epv->createObject))();
  }
  /* Since we may merely up the reference count and return the argument, add an extra reference */
  ANL_SIDLCompilerI_SIDLCompiler__addRef(optarg);
  _result = optarg;  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "O&",
    (void *) ANL_SIDLCompilerI_SIDLCompiler__wrap, _result
  );
  ANL_SIDLCompilerI_SIDLCompiler__deref(optarg);
  return _return_value;
}

static PyMethodDef _SIDLCompilerModuleMethods[] = {
  {(char *) "SIDLCompiler", (PyCFunction) ANL_SIDLCompilerI_SIDLCompiler_SIDLCompiler, (METH_VARARGS | METH_KEYWORDS), (char *) "SIDLCompiler(in SIDLCompiler optarg)\n\
RETURNS\n\
  ANL.SIDLCompilerI.SIDLCompiler _result\n\
Constructor and/or cast method for ANL.SIDLCompilerI.SIDLCompiler\n\
"},
  {NULL, NULL}
};

static PyMethodDef _SIDLCompilerObjectMethods[] = {
  {(char *) "addReference", (PyCFunction) ANL_SIDLCompilerI_SIDLCompiler_addReference, (METH_VARARGS | METH_KEYWORDS), (char *) "addReference()\n\
RETURNS\n\
   None\n\
// Add one to the intrinsic reference count in the underlying object.\n\
// Object in <code>SIDL</code> have an intrinsic reference count.\n\
// Objects continue to exist as long as the reference count is\n\
// positive. Clients should call this method whenever they\n\
// create another ongoing reference to an object or interface.\n\
// \n\
// This does not have a return value because there is no language\n\
// independent type that can refer to an interface or a\n\
// class.\n\
"},
  {(char *) "deleteReference", (PyCFunction) ANL_SIDLCompilerI_SIDLCompiler_deleteReference, (METH_VARARGS | METH_KEYWORDS), (char *) "deleteReference()\n\
RETURNS\n\
   None\n\
// Decrease by one the intrinsic reference count in the underlying\n\
// object, and delete the object if the reference is non-positive.\n\
// Objects in <code>SIDL</code> have an intrinsic reference count.\n\
// Clients should call this method whenever they remove a\n\
// reference to an object or interface.\n\
"},
  {(char *) "isSame", (PyCFunction) ANL_SIDLCompilerI_SIDLCompiler_isSame, (METH_VARARGS | METH_KEYWORDS), (char *) "isSame(in BaseInterface iobj)\n\
RETURNS\n\
  bool _result\n\
// Return true if and only if <code>obj</code> refers to the same\n\
// object as this object.\n\
"},
  {(char *) "queryInterface", (PyCFunction) ANL_SIDLCompilerI_SIDLCompiler_queryInterface, (METH_VARARGS | METH_KEYWORDS), (char *) "queryInterface(in string name)\n\
RETURNS\n\
  SIDL.BaseInterface _result\n\
// Check whether the object can support the specified interface or\n\
// class.  If the <code>SIDL</code> type name in <code>name</code>\n\
// is supported, then a reference to that object is returned with the\n\
// reference count incremented.  The callee will be responsible for\n\
// calling <code>deleteReference</code> on the returned object.  If\n\
// the specified type is not supported, then a null reference is\n\
// returned.\n\
"},
  {(char *) "isInstanceOf", (PyCFunction) ANL_SIDLCompilerI_SIDLCompiler_isInstanceOf, (METH_VARARGS | METH_KEYWORDS), (char *) "isInstanceOf(in string name)\n\
RETURNS\n\
  bool _result\n\
// Return whether this object is an instance of the specified type.\n\
// The string name must be the <code>SIDL</code> type name.  This\n\
// routine will return <code>true</code> if and only if a cast to\n\
// the string type name would succeed.\n\
"},
  {(char *) "parse", (PyCFunction) ANL_SIDLCompilerI_SIDLCompiler_parse, (METH_VARARGS | METH_KEYWORDS), (char *) "parse(in string buf)\n\
RETURNS\n\
  SIDLLanguage.AST _result\n\
// Parse the SIDL and return an AST object\n\
"},
  {(char *) "parseFile", (PyCFunction) ANL_SIDLCompilerI_SIDLCompiler_parseFile, (METH_VARARGS | METH_KEYWORDS), (char *) "parseFile(in string filename)\n\
RETURNS\n\
  SIDLLanguage.AST _result\n\
// Parse the SIDL file and return an AST object\n\
"},
  {NULL, NULL}
};

ANL_SIDLCompilerI_SIDLCompiler__wrap_RETURN
ANL_SIDLCompilerI_SIDLCompiler__wrap ANL_SIDLCompilerI_SIDLCompiler__wrap_PROTO {
  if (!sidlobj) {
    return Py_None;
  } else {
    return SIDL_Object_Create(sidlobj->d_epv->f__cast_ior(sidlobj, "ANL.SIDLCompilerI.SIDLCompiler"), _SIDLCompilerObjectMethods, SIDL_PyStealRef);
  }
}

ANL_SIDLCompilerI_SIDLCompiler__weakRef_RETURN
ANL_SIDLCompilerI_SIDLCompiler__weakRef ANL_SIDLCompilerI_SIDLCompiler__weakRef_PROTO {
  return SIDL_Object_Create(sidlobj->d_epv->f__cast_ior(sidlobj, "ANL.SIDLCompilerI.SIDLCompiler"), _SIDLCompilerObjectMethods, SIDL_PyWeakRef);
}

ANL_SIDLCompilerI_SIDLCompiler__deref_RETURN
ANL_SIDLCompilerI_SIDLCompiler__deref ANL_SIDLCompilerI_SIDLCompiler__deref_PROTO {
  if (sidlobj) {
    (*(sidlobj->d_epv->f_deleteReference))(sidlobj);
  }
}

ANL_SIDLCompilerI_SIDLCompiler__newRef_RETURN
ANL_SIDLCompilerI_SIDLCompiler__newRef ANL_SIDLCompilerI_SIDLCompiler__newRef_PROTO {
  return SIDL_Object_Create(sidlobj->d_epv->f__cast_ior(sidlobj, "ANL.SIDLCompilerI.SIDLCompiler"), _SIDLCompilerObjectMethods, SIDL_PyNewRef);
}

ANL_SIDLCompilerI_SIDLCompiler__addRef_RETURN
ANL_SIDLCompilerI_SIDLCompiler__addRef ANL_SIDLCompilerI_SIDLCompiler__addRef_PROTO {
  if (sidlobj) {
    (*(sidlobj->d_epv->f_addReference))(sidlobj);
  }
}

ANL_SIDLCompilerI_SIDLCompiler__convert_RETURN
ANL_SIDLCompilerI_SIDLCompiler__convert ANL_SIDLCompilerI_SIDLCompiler__convert_PROTO {
  *sidlobj = SIDL_Cast(obj, "ANL.SIDLCompilerI.SIDLCompiler");
  if (*sidlobj) {
    (*((*sidlobj)->d_epv->f_addReference))((*sidlobj));
  } else if (obj != Py_None) {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ANL.SIDLCompilerI.SIDLCompiler");
    return 0;
  }
  return 1;
}

static int
_convertPython(void *sidlarray, const int *ind, PyObject *pyobj) {
  struct ANL_SIDLCompilerI_SIDLCompiler__object *sidlobj;

  if (ANL_SIDLCompilerI_SIDLCompiler__convert(pyobj, &sidlobj)) {
    (*_epv->setElement)((struct ANL_SIDLCompilerI_SIDLCompiler__array *) sidlarray, ind, sidlobj);
    return 0;
  }
  return 1;
}

ANL_SIDLCompilerI_SIDLCompiler__convert_python_array_RETURN
ANL_SIDLCompilerI_SIDLCompiler__convert_python_array ANL_SIDLCompilerI_SIDLCompiler__convert_python_array_PROTO {
  PyObject *pya    = PyArray_FromObject(obj, PyArray_OBJECT, 0, 0);
  int       result = 0;

  *sidlarray = NULL;
  if (pya) {
    if (PyArray_OBJECT == ((PyArrayObject *) pya)->descr->type_num) {
      int dimen, *lower, *upper, *stride;

      if (SIDL_array__extract_python_info(pya, &dimen, &lower, &upper, &stride)) {
        *sidlarray = (*_epv->createArray)(dimen, lower, upper);
        free(lower);
        free(upper);
        free(stride);
        result = SIDL_array__convert_python(pya, dimen, *sidlarray, _convertPython);
        if (*sidlarray && !result) {
          (*_epv->destroyArray)(*sidlarray);
          *sidlarray = NULL;
        }
      }
    }
    Py_DECREF(pya);
  }
  return result;
}

static int
_convertSIDL(void *sidlarray, const int *ind, PyObject **dest) {
  struct ANL_SIDLCompilerI_SIDLCompiler__object *sidlobj = (*_epv->getElement)((struct ANL_SIDLCompilerI_SIDLCompiler__array *) sidlarray, ind);

  *dest = ANL_SIDLCompilerI_SIDLCompiler__wrap(sidlobj);
  return (*dest == NULL);
}

ANL_SIDLCompilerI_SIDLCompiler__convert_sidl_array_RETURN
ANL_SIDLCompilerI_SIDLCompiler__convert_sidl_array ANL_SIDLCompilerI_SIDLCompiler__convert_sidl_array_PROTO {
  PyObject *pya = NULL;

  if (sidlarray) {
    const int dimen   = (*_epv->getDimen)(sidlarray);
    int      *lower   = (int *) malloc(dimen * sizeof(int));
    int      *upper   = (int *) malloc(dimen * sizeof(int));
    int      *numElem = (int *) malloc(dimen * sizeof(int));
    int       i;

    for(i = 0; i < dimen; i++) {
      lower[i]   = (*_epv->getLower)(sidlarray, i);
      upper[i]   = (*_epv->getUpper)(sidlarray, i);
      numElem[i] = upper[i] - lower[i] + 1;
    }
    pya = PyArray_FromDims(dimen, numElem, PyArray_OBJECT);;
    if (pya) {
      if (!SIDL_array__convert_sidl(pya, dimen, lower, upper, numElem, sidlarray, _convertSIDL)) {
        Py_DECREF(pya);
        pya = NULL;
      }
    }
    free(lower);
    free(upper);
    free(numElem);
  }
  return pya;
}

ANL_SIDLCompilerI_SIDLCompiler__destroy_sidl_array_RETURN
ANL_SIDLCompilerI_SIDLCompiler__destroy_sidl_array ANL_SIDLCompilerI_SIDLCompiler__destroy_sidl_array_PROTO {
  if (sidlarray) {
    (*_epv->destroyArray)(sidlarray);
  }
}

void initSIDLCompiler(void) {
  PyObject *module, *dict, *c_api;
  static void *ExternalAPI[ANL_SIDLCompilerI_SIDLCompiler__API_NUM];
  struct ANL_SIDLCompilerI_SIDLCompiler__external * (*_extFunc)(void) = NULL;
  module = Py_InitModule((char *) "SIDLCompiler", _SIDLCompilerModuleMethods);
  _extFunc = (struct ANL_SIDLCompilerI_SIDLCompiler__external * (*)(void)) SIDL_Loader__externals()->getStaticEPV()->f_lookupSymbol("ANL_SIDLCompilerI_SIDLCompiler__externals");
  if (_extFunc) {
    _epv = (*_extFunc)();
  }
  if (!_epv) {
    PyErr_SetString(PyExc_TypeError, "Cannot load SIDL implementation for ANL.SIDLCompilerI.SIDLCompiler");
    return;
  }
  dict = PyModule_GetDict(module);
  ExternalAPI[ANL_SIDLCompilerI_SIDLCompiler__wrap_NUM] = ANL_SIDLCompilerI_SIDLCompiler__wrap;
  ExternalAPI[ANL_SIDLCompilerI_SIDLCompiler__convert_NUM] = ANL_SIDLCompilerI_SIDLCompiler__convert;
  ExternalAPI[ANL_SIDLCompilerI_SIDLCompiler__convert_python_array_NUM] = ANL_SIDLCompilerI_SIDLCompiler__convert_python_array;
  ExternalAPI[ANL_SIDLCompilerI_SIDLCompiler__convert_sidl_array_NUM] = ANL_SIDLCompilerI_SIDLCompiler__convert_sidl_array;
  ExternalAPI[ANL_SIDLCompilerI_SIDLCompiler__destroy_sidl_array_NUM] = ANL_SIDLCompilerI_SIDLCompiler__destroy_sidl_array;
  ExternalAPI[ANL_SIDLCompilerI_SIDLCompiler__weakRef_NUM] = ANL_SIDLCompilerI_SIDLCompiler__weakRef;
  ExternalAPI[ANL_SIDLCompilerI_SIDLCompiler__deref_NUM] = ANL_SIDLCompilerI_SIDLCompiler__deref;
  ExternalAPI[ANL_SIDLCompilerI_SIDLCompiler__newRef_NUM] = ANL_SIDLCompilerI_SIDLCompiler__newRef;
  ExternalAPI[ANL_SIDLCompilerI_SIDLCompiler__addRef_NUM] = ANL_SIDLCompilerI_SIDLCompiler__addRef;
  import_SIDLObjA();
  if (PyErr_Occurred()) {
    PyErr_SetString(PyExc_ImportError, "Cannot import SIDLObjA module");
    return;
  }
  c_api = PyCObject_FromVoidPtr((void *) ExternalAPI, NULL);
  PyDict_SetItemString(dict, (char *) "_C_API", c_api);
  Py_XDECREF(c_api);
  if (PyErr_Occurred()) {
    PyErr_SetString(PyExc_TypeError, "Cannot initialize Python module ANL.SIDLCompilerI.SIDLCompiler");
    return;
  }
  import_SIDLPyArrays();
  if (PyErr_Occurred()) {
    PyErr_SetString(PyExc_ImportError, "Cannot import SIDLPyArrays module");
    return;
  }
  import_array();
  if (PyErr_Occurred()) {
    PyErr_SetString(PyExc_ImportError, "Cannot import Numeric Python array module");
    return;
  }
  SIDL_NullIORException__import();
  SIDL_BaseInterface__import();
  SIDLLanguage_AST__import();
  SIDLLanguage_ParserException__import();
  SIDL_BaseException__import();
}
