#define ANL_SplicerI_Splicer_INTERNAL 1

#include "SIDLObjA.h"
#include "SIDLPyArrays.h"
#include "Numeric/arrayobject.h"

#ifndef included_ANL_SplicerI_Splicer_stub
#include "ANL/SplicerI/Splicer_Module.h"
#endif
#ifndef included_ANL_SplicerI_Splicer_IOR
#include "ANL/SplicerI/Splicer_IOR/Splicer_IOR.h"
#endif
//
// Includes for all method dependencies
//
#ifndef included_SIDL_Loader_IOR
#include "SIDL/Loader_IOR/Loader_IOR.h"
#endif
#ifndef included_SIDL_NullIORException_stub
#include "SIDL/NullIORException_Module.h"
#endif
#ifndef included_SIDL_BaseException_stub
#include "SIDL/BaseException_Module.h"
#endif
#ifndef included_SIDL_BaseInterface_stub
#include "SIDL/BaseInterface_Module.h"
#endif
#ifndef included_SIDLLanguage_AST_stub
#include "SIDLLanguage/AST_Module.h"
#endif
#ifndef included_SIDLLanguage_CodeGeneratorException_stub
#include "SIDLLanguage/CodeGeneratorException_Module.h"
#endif


static const struct ANL_SplicerI_Splicer__external * _epv = NULL;

static PyObject *
ANL_SplicerI_Splicer_getDoTransfer(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct ANL_SplicerI_Splicer__object *_self_ior = ((struct ANL_SplicerI_Splicer__object *) SIDL_Cast(_self, "ANL.SplicerI.Splicer"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  SIDL_bool _result;
  int _local__result;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for getDoTransfer");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in getDoTransfer()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_getDoTransfer))(_self_ior  , &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _local__result = (_result != FALSE);
  _return_value = Py_BuildValue(
     (char *) "i",
    _local__result
  );
  return _return_value;
}

static PyObject *
ANL_SplicerI_Splicer_setDoTransfer(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct ANL_SplicerI_Splicer__object *_self_ior = ((struct ANL_SplicerI_Splicer__object *) SIDL_Cast(_self, "ANL.SplicerI.Splicer"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  SIDL_bool doTransfer;
  int _local_doTransfer;
  static char *_kwlist[] = {
    (char *) "doTransfer",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "i", _kwlist,
    &_local_doTransfer
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for setDoTransfer");
    return _return_value;
  }
  doTransfer = (_local_doTransfer != FALSE);
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in setDoTransfer()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_setDoTransfer))(_self_ior  , /*in*/ doTransfer, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
ANL_SplicerI_Splicer_getTransferMode(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct ANL_SplicerI_Splicer__object *_self_ior = ((struct ANL_SplicerI_Splicer__object *) SIDL_Cast(_self, "ANL.SplicerI.Splicer"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  enum ANL_SplicerI_TransferMode__enum _result;
  long _local__result;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for getTransferMode");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in getTransferMode()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_getTransferMode))(_self_ior  , &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _local__result = _result;
  _return_value = Py_BuildValue(
     (char *) "l",
    _local__result
  );
  return _return_value;
}

static PyObject *
ANL_SplicerI_Splicer_setTransferMode(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct ANL_SplicerI_Splicer__object *_self_ior = ((struct ANL_SplicerI_Splicer__object *) SIDL_Cast(_self, "ANL.SplicerI.Splicer"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  enum ANL_SplicerI_TransferMode__enum transferMode;
  long _local_transferMode;
  static char *_kwlist[] = {
    (char *) "transferMode",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "l", _kwlist,
    &_local_transferMode
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for setTransferMode");
    return _return_value;
  }
  transferMode = _local_transferMode;
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in setTransferMode()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_setTransferMode))(_self_ior  , /*in*/ transferMode, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
ANL_SplicerI_Splicer_addReference(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct ANL_SplicerI_Splicer__object *_self_ior = ((struct ANL_SplicerI_Splicer__object *) SIDL_Cast(_self, "ANL.SplicerI.Splicer"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for addReference");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in addReference()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_addReference))(_self_ior  );
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
ANL_SplicerI_Splicer_deleteReference(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct ANL_SplicerI_Splicer__object *_self_ior = ((struct ANL_SplicerI_Splicer__object *) SIDL_Cast(_self, "ANL.SplicerI.Splicer"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for deleteReference");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in deleteReference()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_deleteReference))(_self_ior  );
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
ANL_SplicerI_Splicer_isSame(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct ANL_SplicerI_Splicer__object *_self_ior = ((struct ANL_SplicerI_Splicer__object *) SIDL_Cast(_self, "ANL.SplicerI.Splicer"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  SIDL_bool _result;
  int _local__result;
  /* Pack arguments for dispatch to IOR */
  struct SIDL_BaseInterface__object * iobj = NULL;
  static char *_kwlist[] = {
    (char *) "iobj",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "O&", _kwlist,
    (void *) SIDL_BaseInterface__convert, &iobj
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for isSame");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in isSame()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_isSame))(_self_ior  , /*in*/ iobj);
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _local__result = (_result != FALSE);
  _return_value = Py_BuildValue(
     (char *) "i",
    _local__result
  );
  SIDL_BaseInterface__deref(iobj);
  return _return_value;
}

static PyObject *
ANL_SplicerI_Splicer_queryInterface(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct ANL_SplicerI_Splicer__object *_self_ior = ((struct ANL_SplicerI_Splicer__object *) SIDL_Cast(_self, "ANL.SplicerI.Splicer"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseInterface__object * _result = NULL;
  /* Pack arguments for dispatch to IOR */
  char * name;
  static char *_kwlist[] = {
    (char *) "name",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "z", _kwlist,
    &name
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for queryInterface");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in queryInterface()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_queryInterface))(_self_ior  , /*in*/ name);
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "O&",
    (void *) SIDL_BaseInterface__wrap, _result
  );
  return _return_value;
}

static PyObject *
ANL_SplicerI_Splicer_isInstanceOf(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct ANL_SplicerI_Splicer__object *_self_ior = ((struct ANL_SplicerI_Splicer__object *) SIDL_Cast(_self, "ANL.SplicerI.Splicer"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  SIDL_bool _result;
  int _local__result;
  /* Pack arguments for dispatch to IOR */
  char * name;
  static char *_kwlist[] = {
    (char *) "name",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "z", _kwlist,
    &name
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for isInstanceOf");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in isInstanceOf()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_isInstanceOf))(_self_ior  , /*in*/ name);
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _local__result = (_result != FALSE);
  _return_value = Py_BuildValue(
     (char *) "i",
    _local__result
  );
  return _return_value;
}

static PyObject *
ANL_SplicerI_Splicer_parse(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct ANL_SplicerI_Splicer__object *_self_ior = ((struct ANL_SplicerI_Splicer__object *) SIDL_Cast(_self, "ANL.SplicerI.Splicer"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  char * filename;
  char * language;
  struct SIDLLanguage_AST__object * node = NULL;
  static char *_kwlist[] = {
    (char *) "filename",
    (char *) "language",
    (char *) "node",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "zzO&", _kwlist,
    &filename,
    &language,
    (void *) SIDLLanguage_AST__convert, &node
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for parse");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in parse()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_parse))(_self_ior  , /*in*/ filename, /*in*/ language, /*in*/ node, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDLLanguage_CodeGeneratorException__object *_ex0;
    struct SIDL_BaseException__object *_ex1;
  
    if (!found && (_ex0 = (struct SIDLLanguage_CodeGeneratorException__object *) SIDL_PyExceptionCast(_exception, "SIDLLanguage.CodeGeneratorException"))) {
      PyObject *obj = SIDLLanguage_CodeGeneratorException__wrap(_ex0);
  
      PyErr_SetObject(SIDLLanguage_CodeGeneratorException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found && (_ex1 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex1);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  SIDLLanguage_AST__deref(node);
  return _return_value;
}

static PyObject *
ANL_SplicerI_Splicer_getLabel(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct ANL_SplicerI_Splicer__object *_self_ior = ((struct ANL_SplicerI_Splicer__object *) SIDL_Cast(_self, "ANL.SplicerI.Splicer"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  char * _result;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  char * name;
  static char *_kwlist[] = {
    (char *) "name",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "z", _kwlist,
    &name
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for getLabel");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in getLabel()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_getLabel))(_self_ior  , /*in*/ name, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "z",
    _result
  );
  free((void *) _result);
  return _return_value;
}

static PyObject *
ANL_SplicerI_Splicer_splice(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct ANL_SplicerI_Splicer__object *_self_ior = ((struct ANL_SplicerI_Splicer__object *) SIDL_Cast(_self, "ANL.SplicerI.Splicer"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  char * _result;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  struct SIDLLanguage_AST__object * node = NULL;
  char * language;
  char * name;
  char * defaultCode;
  static char *_kwlist[] = {
    (char *) "node",
    (char *) "language",
    (char *) "name",
    (char *) "defaultCode",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "O&zzz", _kwlist,
    (void *) SIDLLanguage_AST__convert, &node,
    &language,
    &name,
    &defaultCode
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for splice");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in splice()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_splice))(_self_ior  , /*in*/ node, /*in*/ language, /*in*/ name, /*in*/ defaultCode, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "z",
    _result
  );
  SIDLLanguage_AST__deref(node);
  free((void *) _result);
  return _return_value;
}

static PyObject *
ANL_SplicerI_Splicer_Splicer(
  PyObject *_ignored,
  PyObject *_args,
  PyObject *_kwdict
)
{
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct ANL_SplicerI_Splicer__object * _result = NULL;
  /* Pack arguments for dispatch to IOR */
  struct ANL_SplicerI_Splicer__object * optarg = NULL;
  static char *_kwlist[] = {
    (char *) "optarg",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "|O&", _kwlist,
    (void *) ANL_SplicerI_Splicer__convert, &optarg
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for Splicer");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  /* Implementation code */
  if (optarg) {
    (*(optarg->d_epv->f_addReference))(optarg);
  } else {
    optarg = (*(_epv->createObject))();
  }
  /* Since we may merely up the reference count and return the argument, add an extra reference */
  ANL_SplicerI_Splicer__addRef(optarg);
  _result = optarg;  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "O&",
    (void *) ANL_SplicerI_Splicer__wrap, _result
  );
  ANL_SplicerI_Splicer__deref(optarg);
  return _return_value;
}

static PyMethodDef _SplicerModuleMethods[] = {
  {(char *) "Splicer", (PyCFunction) ANL_SplicerI_Splicer_Splicer, (METH_VARARGS | METH_KEYWORDS), (char *) "Splicer(in Splicer optarg)\n\
RETURNS\n\
  ANL.SplicerI.Splicer _result\n\
Constructor and/or cast method for ANL.SplicerI.Splicer\n\
"},
  {NULL, NULL}
};

static PyMethodDef _SplicerObjectMethods[] = {
  {(char *) "getDoTransfer", (PyCFunction) ANL_SplicerI_Splicer_getDoTransfer, (METH_VARARGS | METH_KEYWORDS), (char *) "getDoTransfer()\n\
RETURNS\n\
  bool _result\n\
// Retrieve the flag determining whether an implementation transfer will be done\n\
"},
  {(char *) "setDoTransfer", (PyCFunction) ANL_SplicerI_Splicer_setDoTransfer, (METH_VARARGS | METH_KEYWORDS), (char *) "setDoTransfer(in bool doTransfer)\n\
RETURNS\n\
   None\n\
// Retrieve the flag determining whether an implementation transfer will be done\n\
"},
  {(char *) "getTransferMode", (PyCFunction) ANL_SplicerI_Splicer_getTransferMode, (METH_VARARGS | METH_KEYWORDS), (char *) "getTransferMode()\n\
RETURNS\n\
  ANL.SplicerI.TransferMode _result\n\
// Retrieve the transfer mode\n\
"},
  {(char *) "setTransferMode", (PyCFunction) ANL_SplicerI_Splicer_setTransferMode, (METH_VARARGS | METH_KEYWORDS), (char *) "setTransferMode(in TransferMode transferMode)\n\
RETURNS\n\
   None\n\
// Set the transfer mode\n\
"},
  {(char *) "addReference", (PyCFunction) ANL_SplicerI_Splicer_addReference, (METH_VARARGS | METH_KEYWORDS), (char *) "addReference()\n\
RETURNS\n\
   None\n\
// Add one to the intrinsic reference count in the underlying object.\n\
// Object in <code>SIDL</code> have an intrinsic reference count.\n\
// Objects continue to exist as long as the reference count is\n\
// positive. Clients should call this method whenever they\n\
// create another ongoing reference to an object or interface.\n\
// \n\
// This does not have a return value because there is no language\n\
// independent type that can refer to an interface or a\n\
// class.\n\
"},
  {(char *) "deleteReference", (PyCFunction) ANL_SplicerI_Splicer_deleteReference, (METH_VARARGS | METH_KEYWORDS), (char *) "deleteReference()\n\
RETURNS\n\
   None\n\
// Decrease by one the intrinsic reference count in the underlying\n\
// object, and delete the object if the reference is non-positive.\n\
// Objects in <code>SIDL</code> have an intrinsic reference count.\n\
// Clients should call this method whenever they remove a\n\
// reference to an object or interface.\n\
"},
  {(char *) "isSame", (PyCFunction) ANL_SplicerI_Splicer_isSame, (METH_VARARGS | METH_KEYWORDS), (char *) "isSame(in BaseInterface iobj)\n\
RETURNS\n\
  bool _result\n\
// Return true if and only if <code>obj</code> refers to the same\n\
// object as this object.\n\
"},
  {(char *) "queryInterface", (PyCFunction) ANL_SplicerI_Splicer_queryInterface, (METH_VARARGS | METH_KEYWORDS), (char *) "queryInterface(in string name)\n\
RETURNS\n\
  SIDL.BaseInterface _result\n\
// Check whether the object can support the specified interface or\n\
// class.  If the <code>SIDL</code> type name in <code>name</code>\n\
// is supported, then a reference to that object is returned with the\n\
// reference count incremented.  The callee will be responsible for\n\
// calling <code>deleteReference</code> on the returned object.  If\n\
// the specified type is not supported, then a null reference is\n\
// returned.\n\
"},
  {(char *) "isInstanceOf", (PyCFunction) ANL_SplicerI_Splicer_isInstanceOf, (METH_VARARGS | METH_KEYWORDS), (char *) "isInstanceOf(in string name)\n\
RETURNS\n\
  bool _result\n\
// Return whether this object is an instance of the specified type.\n\
// The string name must be the <code>SIDL</code> type name.  This\n\
// routine will return <code>true</code> if and only if a cast to\n\
// the string type name would succeed.\n\
"},
  {(char *) "parse", (PyCFunction) ANL_SplicerI_Splicer_parse, (METH_VARARGS | METH_KEYWORDS), (char *) "parse(in string filename, in string language, in AST node)\n\
RETURNS\n\
   None\n\
// Retrieves code blocks from a source file, and load them into an AST node\n\
"},
  {(char *) "getLabel", (PyCFunction) ANL_SplicerI_Splicer_getLabel, (METH_VARARGS | METH_KEYWORDS), (char *) "getLabel(in string name)\n\
RETURNS\n\
  string _result\n\
// Get the code block label corresponding to a given splicer name\n\
"},
  {(char *) "splice", (PyCFunction) ANL_SplicerI_Splicer_splice, (METH_VARARGS | METH_KEYWORDS), (char *) "splice(in AST node, in string language, in string name, in string defaultCode)\n\
RETURNS\n\
  string _result\n\
// Return the code block corresponding to the splicer name, or the defaultCode\n\
"},
  {NULL, NULL}
};

ANL_SplicerI_Splicer__wrap_RETURN
ANL_SplicerI_Splicer__wrap ANL_SplicerI_Splicer__wrap_PROTO {
  if (!sidlobj) {
    return Py_None;
  } else {
    return SIDL_Object_Create(sidlobj->d_epv->f__cast_ior(sidlobj, "ANL.SplicerI.Splicer"), _SplicerObjectMethods, SIDL_PyStealRef);
  }
}

ANL_SplicerI_Splicer__weakRef_RETURN
ANL_SplicerI_Splicer__weakRef ANL_SplicerI_Splicer__weakRef_PROTO {
  return SIDL_Object_Create(sidlobj->d_epv->f__cast_ior(sidlobj, "ANL.SplicerI.Splicer"), _SplicerObjectMethods, SIDL_PyWeakRef);
}

ANL_SplicerI_Splicer__deref_RETURN
ANL_SplicerI_Splicer__deref ANL_SplicerI_Splicer__deref_PROTO {
  if (sidlobj) {
    (*(sidlobj->d_epv->f_deleteReference))(sidlobj);
  }
}

ANL_SplicerI_Splicer__newRef_RETURN
ANL_SplicerI_Splicer__newRef ANL_SplicerI_Splicer__newRef_PROTO {
  return SIDL_Object_Create(sidlobj->d_epv->f__cast_ior(sidlobj, "ANL.SplicerI.Splicer"), _SplicerObjectMethods, SIDL_PyNewRef);
}

ANL_SplicerI_Splicer__addRef_RETURN
ANL_SplicerI_Splicer__addRef ANL_SplicerI_Splicer__addRef_PROTO {
  if (sidlobj) {
    (*(sidlobj->d_epv->f_addReference))(sidlobj);
  }
}

ANL_SplicerI_Splicer__convert_RETURN
ANL_SplicerI_Splicer__convert ANL_SplicerI_Splicer__convert_PROTO {
  *sidlobj = SIDL_Cast(obj, "ANL.SplicerI.Splicer");
  if (*sidlobj) {
    (*((*sidlobj)->d_epv->f_addReference))((*sidlobj));
  } else if (obj != Py_None) {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type ANL.SplicerI.Splicer");
    return 0;
  }
  return 1;
}

static int
_convertPython(void *sidlarray, const int *ind, PyObject *pyobj) {
  struct ANL_SplicerI_Splicer__object *sidlobj;

  if (ANL_SplicerI_Splicer__convert(pyobj, &sidlobj)) {
    (*_epv->setElement)((struct ANL_SplicerI_Splicer__array *) sidlarray, ind, sidlobj);
    return 0;
  }
  return 1;
}

ANL_SplicerI_Splicer__convert_python_array_RETURN
ANL_SplicerI_Splicer__convert_python_array ANL_SplicerI_Splicer__convert_python_array_PROTO {
  PyObject *pya    = PyArray_FromObject(obj, PyArray_OBJECT, 0, 0);
  int       result = 0;

  *sidlarray = NULL;
  if (pya) {
    if (PyArray_OBJECT == ((PyArrayObject *) pya)->descr->type_num) {
      int dimen, *lower, *upper, *stride;

      if (SIDL_array__extract_python_info(pya, &dimen, &lower, &upper, &stride)) {
        *sidlarray = (*_epv->createArray)(dimen, lower, upper);
        free(lower);
        free(upper);
        free(stride);
        result = SIDL_array__convert_python(pya, dimen, *sidlarray, _convertPython);
        if (*sidlarray && !result) {
          (*_epv->destroyArray)(*sidlarray);
          *sidlarray = NULL;
        }
      }
    }
    Py_DECREF(pya);
  }
  return result;
}

static int
_convertSIDL(void *sidlarray, const int *ind, PyObject **dest) {
  struct ANL_SplicerI_Splicer__object *sidlobj = (*_epv->getElement)((struct ANL_SplicerI_Splicer__array *) sidlarray, ind);

  *dest = ANL_SplicerI_Splicer__wrap(sidlobj);
  return (*dest == NULL);
}

ANL_SplicerI_Splicer__convert_sidl_array_RETURN
ANL_SplicerI_Splicer__convert_sidl_array ANL_SplicerI_Splicer__convert_sidl_array_PROTO {
  PyObject *pya = NULL;

  if (sidlarray) {
    const int dimen   = (*_epv->getDimen)(sidlarray);
    int      *lower   = (int *) malloc(dimen * sizeof(int));
    int      *upper   = (int *) malloc(dimen * sizeof(int));
    int      *numElem = (int *) malloc(dimen * sizeof(int));
    int       i;

    for(i = 0; i < dimen; i++) {
      lower[i]   = (*_epv->getLower)(sidlarray, i);
      upper[i]   = (*_epv->getUpper)(sidlarray, i);
      numElem[i] = upper[i] - lower[i] + 1;
    }
    pya = PyArray_FromDims(dimen, numElem, PyArray_OBJECT);;
    if (pya) {
      if (!SIDL_array__convert_sidl(pya, dimen, lower, upper, numElem, sidlarray, _convertSIDL)) {
        Py_DECREF(pya);
        pya = NULL;
      }
    }
    free(lower);
    free(upper);
    free(numElem);
  }
  return pya;
}

ANL_SplicerI_Splicer__destroy_sidl_array_RETURN
ANL_SplicerI_Splicer__destroy_sidl_array ANL_SplicerI_Splicer__destroy_sidl_array_PROTO {
  if (sidlarray) {
    (*_epv->destroyArray)(sidlarray);
  }
}

void initSplicer(void) {
  PyObject *module, *dict, *c_api;
  static void *ExternalAPI[ANL_SplicerI_Splicer__API_NUM];
  struct ANL_SplicerI_Splicer__external * (*_extFunc)(void) = NULL;
  module = Py_InitModule3((char *) "Splicer", _SplicerModuleMethods, (char *) "// Implementation of the Babel splicer technology\n\
");
  _extFunc = (struct ANL_SplicerI_Splicer__external * (*)(void)) SIDL_Loader__externals()->getStaticEPV()->f_lookupSymbol("ANL_SplicerI_Splicer__externals");
  if (_extFunc) {
    _epv = (*_extFunc)();
  }
  if (!_epv) {
    PyErr_SetString(PyExc_TypeError, "Cannot load SIDL implementation for ANL.SplicerI.Splicer");
    return;
  }
  dict = PyModule_GetDict(module);
  ExternalAPI[ANL_SplicerI_Splicer__wrap_NUM] = ANL_SplicerI_Splicer__wrap;
  ExternalAPI[ANL_SplicerI_Splicer__convert_NUM] = ANL_SplicerI_Splicer__convert;
  ExternalAPI[ANL_SplicerI_Splicer__convert_python_array_NUM] = ANL_SplicerI_Splicer__convert_python_array;
  ExternalAPI[ANL_SplicerI_Splicer__convert_sidl_array_NUM] = ANL_SplicerI_Splicer__convert_sidl_array;
  ExternalAPI[ANL_SplicerI_Splicer__destroy_sidl_array_NUM] = ANL_SplicerI_Splicer__destroy_sidl_array;
  ExternalAPI[ANL_SplicerI_Splicer__weakRef_NUM] = ANL_SplicerI_Splicer__weakRef;
  ExternalAPI[ANL_SplicerI_Splicer__deref_NUM] = ANL_SplicerI_Splicer__deref;
  ExternalAPI[ANL_SplicerI_Splicer__newRef_NUM] = ANL_SplicerI_Splicer__newRef;
  ExternalAPI[ANL_SplicerI_Splicer__addRef_NUM] = ANL_SplicerI_Splicer__addRef;
  import_SIDLObjA();
  if (PyErr_Occurred()) {
    PyErr_SetString(PyExc_ImportError, "Cannot import SIDLObjA module");
    return;
  }
  c_api = PyCObject_FromVoidPtr((void *) ExternalAPI, NULL);
  PyDict_SetItemString(dict, (char *) "_C_API", c_api);
  Py_XDECREF(c_api);
  if (PyErr_Occurred()) {
    PyErr_SetString(PyExc_TypeError, "Cannot initialize Python module ANL.SplicerI.Splicer");
    return;
  }
  import_SIDLPyArrays();
  if (PyErr_Occurred()) {
    PyErr_SetString(PyExc_ImportError, "Cannot import SIDLPyArrays module");
    return;
  }
  import_array();
  if (PyErr_Occurred()) {
    PyErr_SetString(PyExc_ImportError, "Cannot import Numeric Python array module");
    return;
  }
  SIDL_NullIORException__import();
  SIDL_BaseException__import();
  SIDL_BaseInterface__import();
  SIDLLanguage_AST__import();
  SIDLLanguage_CodeGeneratorException__import();
}
