#define SIDLLanguage_Code_INTERNAL 1

#include "SIDLObjA.h"
#include "SIDLPyArrays.h"
#include "Numeric/arrayobject.h"

#ifndef included_SIDLLanguage_Code_stub
#include "SIDLLanguage/Code_Module.h"
#endif
#ifndef included_SIDLLanguage_Code_IOR
#include "SIDLLanguage/Code_IOR/Code_IOR.h"
#endif
//
// Includes for all method dependencies
//
#ifndef included_SIDL_Loader_IOR
#include "SIDL/Loader_IOR/Loader_IOR.h"
#endif
#ifndef included_SIDL_NullIORException_stub
#include "SIDL/NullIORException_Module.h"
#endif
#ifndef included_SIDL_BaseException_stub
#include "SIDL/BaseException_Module.h"
#endif
#ifndef included_SIDLLanguage_CodeGeneratorException_stub
#include "SIDLLanguage/CodeGeneratorException_Module.h"
#endif
#ifndef included_SIDL_BaseInterface_stub
#include "SIDL/BaseInterface_Module.h"
#endif


static const struct SIDLLanguage_Code__external * _epv = NULL;

static PyObject *
SIDLLanguage_Code_getLanguage(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Code__object *_self_ior = ((struct SIDLLanguage_Code__object *) SIDL_Cast(_self, "SIDLLanguage.Code"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  char * _result;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for getLanguage");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in getLanguage()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_getLanguage))(_self_ior->d_object  , &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "z",
    _result
  );
  free((void *) _result);
  return _return_value;
}

static PyObject *
SIDLLanguage_Code_setLanguage(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Code__object *_self_ior = ((struct SIDLLanguage_Code__object *) SIDL_Cast(_self, "SIDLLanguage.Code"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  char * language;
  static char *_kwlist[] = {
    (char *) "language",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "z", _kwlist,
    &language
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for setLanguage");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in setLanguage()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_setLanguage))(_self_ior->d_object  , /*in*/ language, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
SIDLLanguage_Code_getLabel(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Code__object *_self_ior = ((struct SIDLLanguage_Code__object *) SIDL_Cast(_self, "SIDLLanguage.Code"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  char * _result;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for getLabel");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in getLabel()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_getLabel))(_self_ior->d_object  , &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "z",
    _result
  );
  free((void *) _result);
  return _return_value;
}

static PyObject *
SIDLLanguage_Code_setLabel(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Code__object *_self_ior = ((struct SIDLLanguage_Code__object *) SIDL_Cast(_self, "SIDLLanguage.Code"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  char * label;
  static char *_kwlist[] = {
    (char *) "label",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "z", _kwlist,
    &label
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for setLabel");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in setLabel()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_setLabel))(_self_ior->d_object  , /*in*/ label, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
SIDLLanguage_Code_getSource(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Code__object *_self_ior = ((struct SIDLLanguage_Code__object *) SIDL_Cast(_self, "SIDLLanguage.Code"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  char * _result;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for getSource");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in getSource()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_getSource))(_self_ior->d_object  , &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "z",
    _result
  );
  free((void *) _result);
  return _return_value;
}

static PyObject *
SIDLLanguage_Code_setSource(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Code__object *_self_ior = ((struct SIDLLanguage_Code__object *) SIDL_Cast(_self, "SIDLLanguage.Code"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  char * source;
  static char *_kwlist[] = {
    (char *) "source",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "z", _kwlist,
    &source
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for setSource");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in setSource()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_setSource))(_self_ior->d_object  , /*in*/ source, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
SIDLLanguage_Code_getTabLevel(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Code__object *_self_ior = ((struct SIDLLanguage_Code__object *) SIDL_Cast(_self, "SIDLLanguage.Code"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  int32_t _result;
  int _local__result;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for getTabLevel");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in getTabLevel()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_getTabLevel))(_self_ior->d_object  , &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _local__result = _result;
  _return_value = Py_BuildValue(
     (char *) "l",
    _local__result
  );
  return _return_value;
}

static PyObject *
SIDLLanguage_Code_setTabLevel(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Code__object *_self_ior = ((struct SIDLLanguage_Code__object *) SIDL_Cast(_self, "SIDLLanguage.Code"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  int32_t tabLevel;
  int _local_tabLevel;
  static char *_kwlist[] = {
    (char *) "tabLevel",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "l", _kwlist,
    &_local_tabLevel
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for setTabLevel");
    return _return_value;
  }
  tabLevel = _local_tabLevel;
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in setTabLevel()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_setTabLevel))(_self_ior->d_object  , /*in*/ tabLevel, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
SIDLLanguage_Code_increaseTabLevel(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Code__object *_self_ior = ((struct SIDLLanguage_Code__object *) SIDL_Cast(_self, "SIDLLanguage.Code"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for increaseTabLevel");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in increaseTabLevel()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_increaseTabLevel))(_self_ior->d_object  , &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDLLanguage_CodeGeneratorException__object *_ex0;
    struct SIDL_BaseException__object *_ex1;
  
    if (!found && (_ex0 = (struct SIDLLanguage_CodeGeneratorException__object *) SIDL_PyExceptionCast(_exception, "SIDLLanguage.CodeGeneratorException"))) {
      PyObject *obj = SIDLLanguage_CodeGeneratorException__wrap(_ex0);
  
      PyErr_SetObject(SIDLLanguage_CodeGeneratorException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found && (_ex1 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex1);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
SIDLLanguage_Code_decreaseTabLevel(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Code__object *_self_ior = ((struct SIDLLanguage_Code__object *) SIDL_Cast(_self, "SIDLLanguage.Code"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for decreaseTabLevel");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in decreaseTabLevel()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_decreaseTabLevel))(_self_ior->d_object  , &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDLLanguage_CodeGeneratorException__object *_ex0;
    struct SIDL_BaseException__object *_ex1;
  
    if (!found && (_ex0 = (struct SIDLLanguage_CodeGeneratorException__object *) SIDL_PyExceptionCast(_exception, "SIDLLanguage.CodeGeneratorException"))) {
      PyObject *obj = SIDLLanguage_CodeGeneratorException__wrap(_ex0);
  
      PyErr_SetObject(SIDLLanguage_CodeGeneratorException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found && (_ex1 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex1);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
SIDLLanguage_Code_indent(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Code__object *_self_ior = ((struct SIDLLanguage_Code__object *) SIDL_Cast(_self, "SIDLLanguage.Code"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for indent");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in indent()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_indent))(_self_ior->d_object  , &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
SIDLLanguage_Code_write(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Code__object *_self_ior = ((struct SIDLLanguage_Code__object *) SIDL_Cast(_self, "SIDLLanguage.Code"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  char * s;
  static char *_kwlist[] = {
    (char *) "s",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "z", _kwlist,
    &s
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for write");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in write()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_write))(_self_ior->d_object  , /*in*/ s, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
SIDLLanguage_Code_println(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Code__object *_self_ior = ((struct SIDLLanguage_Code__object *) SIDL_Cast(_self, "SIDLLanguage.Code"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  char * s;
  static char *_kwlist[] = {
    (char *) "s",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "z", _kwlist,
    &s
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for println");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in println()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_println))(_self_ior->d_object  , /*in*/ s, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
SIDLLanguage_Code_close(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Code__object *_self_ior = ((struct SIDLLanguage_Code__object *) SIDL_Cast(_self, "SIDLLanguage.Code"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for close");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in close()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_close))(_self_ior->d_object  , &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
SIDLLanguage_Code_addReference(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Code__object *_self_ior = ((struct SIDLLanguage_Code__object *) SIDL_Cast(_self, "SIDLLanguage.Code"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for addReference");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in addReference()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_addReference))(_self_ior->d_object  );
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
SIDLLanguage_Code_deleteReference(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Code__object *_self_ior = ((struct SIDLLanguage_Code__object *) SIDL_Cast(_self, "SIDLLanguage.Code"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for deleteReference");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in deleteReference()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_deleteReference))(_self_ior->d_object  );
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
SIDLLanguage_Code_isSame(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Code__object *_self_ior = ((struct SIDLLanguage_Code__object *) SIDL_Cast(_self, "SIDLLanguage.Code"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  SIDL_bool _result;
  int _local__result;
  /* Pack arguments for dispatch to IOR */
  struct SIDL_BaseInterface__object * iobj = NULL;
  static char *_kwlist[] = {
    (char *) "iobj",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "O&", _kwlist,
    (void *) SIDL_BaseInterface__convert, &iobj
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for isSame");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in isSame()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_isSame))(_self_ior->d_object  , /*in*/ iobj);
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _local__result = (_result != FALSE);
  _return_value = Py_BuildValue(
     (char *) "i",
    _local__result
  );
  SIDL_BaseInterface__deref(iobj);
  return _return_value;
}

static PyObject *
SIDLLanguage_Code_queryInterface(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Code__object *_self_ior = ((struct SIDLLanguage_Code__object *) SIDL_Cast(_self, "SIDLLanguage.Code"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseInterface__object * _result = NULL;
  /* Pack arguments for dispatch to IOR */
  char * name;
  static char *_kwlist[] = {
    (char *) "name",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "z", _kwlist,
    &name
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for queryInterface");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in queryInterface()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_queryInterface))(_self_ior->d_object  , /*in*/ name);
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "O&",
    (void *) SIDL_BaseInterface__wrap, _result
  );
  return _return_value;
}

static PyObject *
SIDLLanguage_Code_isInstanceOf(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Code__object *_self_ior = ((struct SIDLLanguage_Code__object *) SIDL_Cast(_self, "SIDLLanguage.Code"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  SIDL_bool _result;
  int _local__result;
  /* Pack arguments for dispatch to IOR */
  char * name;
  static char *_kwlist[] = {
    (char *) "name",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "z", _kwlist,
    &name
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for isInstanceOf");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in isInstanceOf()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_isInstanceOf))(_self_ior->d_object  , /*in*/ name);
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _local__result = (_result != FALSE);
  _return_value = Py_BuildValue(
     (char *) "i",
    _local__result
  );
  return _return_value;
}

static PyObject *
SIDLLanguage_Code_Code(
  PyObject *_ignored,
  PyObject *_args,
  PyObject *_kwdict
)
{
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDLLanguage_Code__object * _result = NULL;
  /* Pack arguments for dispatch to IOR */
  struct SIDLLanguage_Code__object * optarg = NULL;
  static char *_kwlist[] = {
    (char *) "optarg",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "|O&", _kwlist,
    (void *) SIDLLanguage_Code__convert, &optarg
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for Code");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  /* Implementation code */
  if (optarg) {
    (*(optarg->d_epv->f_addReference))(optarg->d_object);
  }
  /* Since we may merely up the reference count and return the argument, add an extra reference */
  SIDLLanguage_Code__addRef(optarg);
  _result = optarg;  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "O&",
    (void *) SIDLLanguage_Code__wrap, _result
  );
  SIDLLanguage_Code__deref(optarg);
  return _return_value;
}

static PyMethodDef _CodeModuleMethods[] = {
  {(char *) "Code", (PyCFunction) SIDLLanguage_Code_Code, (METH_VARARGS | METH_KEYWORDS), (char *) "Code(in Code optarg)\n\
RETURNS\n\
  SIDLLanguage.Code _result\n\
Constructor and/or cast method for SIDLLanguage.Code\n\
"},
  {NULL, NULL}
};

static PyMethodDef _CodeObjectMethods[] = {
  {(char *) "getLanguage", (PyCFunction) SIDLLanguage_Code_getLanguage, (METH_VARARGS | METH_KEYWORDS), (char *) "getLanguage()\n\
RETURNS\n\
  string _result\n\
// Retrieve the source language\n\
"},
  {(char *) "setLanguage", (PyCFunction) SIDLLanguage_Code_setLanguage, (METH_VARARGS | METH_KEYWORDS), (char *) "setLanguage(in string language)\n\
RETURNS\n\
   None\n\
// Set the source language\n\
"},
  {(char *) "getLabel", (PyCFunction) SIDLLanguage_Code_getLabel, (METH_VARARGS | METH_KEYWORDS), (char *) "getLabel()\n\
RETURNS\n\
  string _result\n\
// Retrieve the code block label\n\
"},
  {(char *) "setLabel", (PyCFunction) SIDLLanguage_Code_setLabel, (METH_VARARGS | METH_KEYWORDS), (char *) "setLabel(in string label)\n\
RETURNS\n\
   None\n\
// Set the code block label\n\
"},
  {(char *) "getSource", (PyCFunction) SIDLLanguage_Code_getSource, (METH_VARARGS | METH_KEYWORDS), (char *) "getSource()\n\
RETURNS\n\
  string _result\n\
// Retrieve the source itself\n\
"},
  {(char *) "setSource", (PyCFunction) SIDLLanguage_Code_setSource, (METH_VARARGS | METH_KEYWORDS), (char *) "setSource(in string source)\n\
RETURNS\n\
   None\n\
// Set the source itself\n\
"},
  {(char *) "getTabLevel", (PyCFunction) SIDLLanguage_Code_getTabLevel, (METH_VARARGS | METH_KEYWORDS), (char *) "getTabLevel()\n\
RETURNS\n\
  int _result\n\
// Retrieve the current number of tabs\n\
"},
  {(char *) "setTabLevel", (PyCFunction) SIDLLanguage_Code_setTabLevel, (METH_VARARGS | METH_KEYWORDS), (char *) "setTabLevel(in int tabLevel)\n\
RETURNS\n\
   None\n\
// Set the current number of tabs\n\
"},
  {(char *) "increaseTabLevel", (PyCFunction) SIDLLanguage_Code_increaseTabLevel, (METH_VARARGS | METH_KEYWORDS), (char *) "increaseTabLevel()\n\
RETURNS\n\
   None\n\
// Increase the current number of tabs by one\n\
"},
  {(char *) "decreaseTabLevel", (PyCFunction) SIDLLanguage_Code_decreaseTabLevel, (METH_VARARGS | METH_KEYWORDS), (char *) "decreaseTabLevel()\n\
RETURNS\n\
   None\n\
// Decrease the current number of tabs by one\n\
"},
  {(char *) "indent", (PyCFunction) SIDLLanguage_Code_indent, (METH_VARARGS | METH_KEYWORDS), (char *) "indent()\n\
RETURNS\n\
   None\n\
// Write the current indenting\n\
"},
  {(char *) "write", (PyCFunction) SIDLLanguage_Code_write, (METH_VARARGS | METH_KEYWORDS), (char *) "write(in string s)\n\
RETURNS\n\
   None\n\
// Write the string with no indenting\n\
"},
  {(char *) "println", (PyCFunction) SIDLLanguage_Code_println, (METH_VARARGS | METH_KEYWORDS), (char *) "println(in string s)\n\
RETURNS\n\
   None\n\
// Write the string with indenting and a newline\n\
"},
  {(char *) "close", (PyCFunction) SIDLLanguage_Code_close, (METH_VARARGS | METH_KEYWORDS), (char *) "close()\n\
RETURNS\n\
   None\n\
// Close the code stream, releasing any resources it might be using\n\
"},
  {(char *) "addReference", (PyCFunction) SIDLLanguage_Code_addReference, (METH_VARARGS | METH_KEYWORDS), (char *) "addReference()\n\
RETURNS\n\
   None\n\
// Add one to the intrinsic reference count in the underlying object.\n\
// Object in <code>SIDL</code> have an intrinsic reference count.\n\
// Objects continue to exist as long as the reference count is\n\
// positive. Clients should call this method whenever they\n\
// create another ongoing reference to an object or interface.\n\
// \n\
// This does not have a return value because there is no language\n\
// independent type that can refer to an interface or a\n\
// class.\n\
"},
  {(char *) "deleteReference", (PyCFunction) SIDLLanguage_Code_deleteReference, (METH_VARARGS | METH_KEYWORDS), (char *) "deleteReference()\n\
RETURNS\n\
   None\n\
// Decrease by one the intrinsic reference count in the underlying\n\
// object, and delete the object if the reference is non-positive.\n\
// Objects in <code>SIDL</code> have an intrinsic reference count.\n\
// Clients should call this method whenever they remove a\n\
// reference to an object or interface.\n\
"},
  {(char *) "isSame", (PyCFunction) SIDLLanguage_Code_isSame, (METH_VARARGS | METH_KEYWORDS), (char *) "isSame(in BaseInterface iobj)\n\
RETURNS\n\
  bool _result\n\
// Return true if and only if <code>obj</code> refers to the same\n\
// object as this object.\n\
"},
  {(char *) "queryInterface", (PyCFunction) SIDLLanguage_Code_queryInterface, (METH_VARARGS | METH_KEYWORDS), (char *) "queryInterface(in string name)\n\
RETURNS\n\
  SIDL.BaseInterface _result\n\
// Check whether the object can support the specified interface or\n\
// class.  If the <code>SIDL</code> type name in <code>name</code>\n\
// is supported, then a reference to that object is returned with the\n\
// reference count incremented.  The callee will be responsible for\n\
// calling <code>deleteReference</code> on the returned object.  If\n\
// the specified type is not supported, then a null reference is\n\
// returned.\n\
"},
  {(char *) "isInstanceOf", (PyCFunction) SIDLLanguage_Code_isInstanceOf, (METH_VARARGS | METH_KEYWORDS), (char *) "isInstanceOf(in string name)\n\
RETURNS\n\
  bool _result\n\
// Return whether this object is an instance of the specified type.\n\
// The string name must be the <code>SIDL</code> type name.  This\n\
// routine will return <code>true</code> if and only if a cast to\n\
// the string type name would succeed.\n\
"},
  {NULL, NULL}
};

SIDLLanguage_Code__wrap_RETURN
SIDLLanguage_Code__wrap SIDLLanguage_Code__wrap_PROTO {
  if (!sidlobj) {
    return Py_None;
  } else {
    return SIDL_Object_Create(sidlobj->d_epv->f__cast_ior(sidlobj->d_object, "SIDLLanguage.Code"), _CodeObjectMethods, SIDL_PyStealRef);
  }
}

SIDLLanguage_Code__weakRef_RETURN
SIDLLanguage_Code__weakRef SIDLLanguage_Code__weakRef_PROTO {
  return SIDL_Object_Create(sidlobj->d_epv->f__cast_ior(sidlobj->d_object, "SIDLLanguage.Code"), _CodeObjectMethods, SIDL_PyWeakRef);
}

SIDLLanguage_Code__deref_RETURN
SIDLLanguage_Code__deref SIDLLanguage_Code__deref_PROTO {
  if (sidlobj) {
    (*(sidlobj->d_epv->f_deleteReference))(sidlobj->d_object);
  }
}

SIDLLanguage_Code__newRef_RETURN
SIDLLanguage_Code__newRef SIDLLanguage_Code__newRef_PROTO {
  return SIDL_Object_Create(sidlobj->d_epv->f__cast_ior(sidlobj->d_object, "SIDLLanguage.Code"), _CodeObjectMethods, SIDL_PyNewRef);
}

SIDLLanguage_Code__addRef_RETURN
SIDLLanguage_Code__addRef SIDLLanguage_Code__addRef_PROTO {
  if (sidlobj) {
    (*(sidlobj->d_epv->f_addReference))(sidlobj->d_object);
  }
}

SIDLLanguage_Code__convert_RETURN
SIDLLanguage_Code__convert SIDLLanguage_Code__convert_PROTO {
  *sidlobj = SIDL_Cast(obj, "SIDLLanguage.Code");
  if (*sidlobj) {
    (*((*sidlobj)->d_epv->f_addReference))((*sidlobj)->d_object);
  } else if (obj != Py_None) {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type SIDLLanguage.Code");
    return 0;
  }
  return 1;
}

static int
_convertPython(void *sidlarray, const int *ind, PyObject *pyobj) {
  struct SIDLLanguage_Code__object *sidlobj;

  if (SIDLLanguage_Code__convert(pyobj, &sidlobj)) {
    (*_epv->setElement)((struct SIDLLanguage_Code__array *) sidlarray, ind, sidlobj);
    return 0;
  }
  return 1;
}

SIDLLanguage_Code__convert_python_array_RETURN
SIDLLanguage_Code__convert_python_array SIDLLanguage_Code__convert_python_array_PROTO {
  PyObject *pya    = PyArray_FromObject(obj, PyArray_OBJECT, 0, 0);
  int       result = 0;

  *sidlarray = NULL;
  if (pya) {
    if (PyArray_OBJECT == ((PyArrayObject *) pya)->descr->type_num) {
      int dimen, *lower, *upper, *stride;

      if (SIDL_array__extract_python_info(pya, &dimen, &lower, &upper, &stride)) {
        *sidlarray = (*_epv->createArray)(dimen, lower, upper);
        free(lower);
        free(upper);
        free(stride);
        result = SIDL_array__convert_python(pya, dimen, *sidlarray, _convertPython);
        if (*sidlarray && !result) {
          (*_epv->destroyArray)(*sidlarray);
          *sidlarray = NULL;
        }
      }
    }
    Py_DECREF(pya);
  }
  return result;
}

static int
_convertSIDL(void *sidlarray, const int *ind, PyObject **dest) {
  struct SIDLLanguage_Code__object *sidlobj = (*_epv->getElement)((struct SIDLLanguage_Code__array *) sidlarray, ind);

  *dest = SIDLLanguage_Code__wrap(sidlobj);
  return (*dest == NULL);
}

SIDLLanguage_Code__convert_sidl_array_RETURN
SIDLLanguage_Code__convert_sidl_array SIDLLanguage_Code__convert_sidl_array_PROTO {
  PyObject *pya = NULL;

  if (sidlarray) {
    const int dimen   = (*_epv->getDimen)(sidlarray);
    int      *lower   = (int *) malloc(dimen * sizeof(int));
    int      *upper   = (int *) malloc(dimen * sizeof(int));
    int      *numElem = (int *) malloc(dimen * sizeof(int));
    int       i;

    for(i = 0; i < dimen; i++) {
      lower[i]   = (*_epv->getLower)(sidlarray, i);
      upper[i]   = (*_epv->getUpper)(sidlarray, i);
      numElem[i] = upper[i] - lower[i] + 1;
    }
    pya = PyArray_FromDims(dimen, numElem, PyArray_OBJECT);;
    if (pya) {
      if (!SIDL_array__convert_sidl(pya, dimen, lower, upper, numElem, sidlarray, _convertSIDL)) {
        Py_DECREF(pya);
        pya = NULL;
      }
    }
    free(lower);
    free(upper);
    free(numElem);
  }
  return pya;
}

SIDLLanguage_Code__destroy_sidl_array_RETURN
SIDLLanguage_Code__destroy_sidl_array SIDLLanguage_Code__destroy_sidl_array_PROTO {
  if (sidlarray) {
    (*_epv->destroyArray)(sidlarray);
  }
}

void initCode(void) {
  PyObject *module, *dict, *c_api;
  static void *ExternalAPI[SIDLLanguage_Code__API_NUM];
  struct SIDLLanguage_Code__external * (*_extFunc)(void) = NULL;
  module = Py_InitModule3((char *) "Code", _CodeModuleMethods, (char *) "// Interface for dealing with pieces of source code\n\
");
  _extFunc = (struct SIDLLanguage_Code__external * (*)(void)) SIDL_Loader__externals()->getStaticEPV()->f_lookupSymbol("SIDLLanguage_Code__externals");
  if (_extFunc) {
    _epv = (*_extFunc)();
  }
  if (!_epv) {
    PyErr_SetString(PyExc_TypeError, "Cannot load SIDL implementation for SIDLLanguage.Code");
    return;
  }
  dict = PyModule_GetDict(module);
  ExternalAPI[SIDLLanguage_Code__wrap_NUM] = SIDLLanguage_Code__wrap;
  ExternalAPI[SIDLLanguage_Code__convert_NUM] = SIDLLanguage_Code__convert;
  ExternalAPI[SIDLLanguage_Code__convert_python_array_NUM] = SIDLLanguage_Code__convert_python_array;
  ExternalAPI[SIDLLanguage_Code__convert_sidl_array_NUM] = SIDLLanguage_Code__convert_sidl_array;
  ExternalAPI[SIDLLanguage_Code__destroy_sidl_array_NUM] = SIDLLanguage_Code__destroy_sidl_array;
  ExternalAPI[SIDLLanguage_Code__weakRef_NUM] = SIDLLanguage_Code__weakRef;
  ExternalAPI[SIDLLanguage_Code__deref_NUM] = SIDLLanguage_Code__deref;
  ExternalAPI[SIDLLanguage_Code__newRef_NUM] = SIDLLanguage_Code__newRef;
  ExternalAPI[SIDLLanguage_Code__addRef_NUM] = SIDLLanguage_Code__addRef;
  import_SIDLObjA();
  if (PyErr_Occurred()) {
    PyErr_SetString(PyExc_ImportError, "Cannot import SIDLObjA module");
    return;
  }
  c_api = PyCObject_FromVoidPtr((void *) ExternalAPI, NULL);
  PyDict_SetItemString(dict, (char *) "_C_API", c_api);
  Py_XDECREF(c_api);
  if (PyErr_Occurred()) {
    PyErr_SetString(PyExc_TypeError, "Cannot initialize Python module SIDLLanguage.Code");
    return;
  }
  import_SIDLPyArrays();
  if (PyErr_Occurred()) {
    PyErr_SetString(PyExc_ImportError, "Cannot import SIDLPyArrays module");
    return;
  }
  import_array();
  if (PyErr_Occurred()) {
    PyErr_SetString(PyExc_ImportError, "Cannot import Numeric Python array module");
    return;
  }
  SIDL_NullIORException__import();
  SIDL_BaseException__import();
  SIDLLanguage_CodeGeneratorException__import();
  SIDL_BaseInterface__import();
}
