#define SIDLLanguage_Method_INTERNAL 1

#include "SIDLObjA.h"
#include "SIDLPyArrays.h"
#include "Numeric/arrayobject.h"

#ifndef included_SIDLLanguage_Method_stub
#include "SIDLLanguage/Method_Module.h"
#endif
#ifndef included_SIDLLanguage_Method_IOR
#include "SIDLLanguage/Method_IOR/Method_IOR.h"
#endif
//
// Includes for all method dependencies
//
#ifndef included_SIDL_Loader_IOR
#include "SIDL/Loader_IOR/Loader_IOR.h"
#endif
#ifndef included_SIDLLanguage_Type_stub
#include "SIDLLanguage/Type_Module.h"
#endif
#ifndef included_SIDL_NullIORException_stub
#include "SIDL/NullIORException_Module.h"
#endif
#ifndef included_SIDL_BaseException_stub
#include "SIDL/BaseException_Module.h"
#endif
#ifndef included_SIDLLanguage_Class_stub
#include "SIDLLanguage/Class_Module.h"
#endif
#ifndef included_SIDLLanguage_Visitor_stub
#include "SIDLLanguage/Visitor_Module.h"
#endif
#ifndef included_SIDLLanguage_ASTException_stub
#include "SIDLLanguage/ASTException_Module.h"
#endif
#ifndef included_SIDLLanguage_AST_stub
#include "SIDLLanguage/AST_Module.h"
#endif
#ifndef included_SIDLLanguage_Comment_stub
#include "SIDLLanguage/Comment_Module.h"
#endif
#ifndef included_SIDLLanguage_Code_stub
#include "SIDLLanguage/Code_Module.h"
#endif
#ifndef included_SIDLLanguage_CodeGeneratorException_stub
#include "SIDLLanguage/CodeGeneratorException_Module.h"
#endif
#ifndef included_SIDLLanguage_Attribute_stub
#include "SIDLLanguage/Attribute_Module.h"
#endif
#ifndef included_SIDL_BaseInterface_stub
#include "SIDL/BaseInterface_Module.h"
#endif


static const struct SIDLLanguage_Method__external * _epv = NULL;

static PyObject *
SIDLLanguage_Method_getReturnType(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Method__object *_self_ior = ((struct SIDLLanguage_Method__object *) SIDL_Cast(_self, "SIDLLanguage.Method"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDLLanguage_Type__object * _result = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for getReturnType");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in getReturnType()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_getReturnType))(_self_ior->d_object  , &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "O&",
    (void *) SIDLLanguage_Type__wrap, _result
  );
  return _return_value;
}

static PyObject *
SIDLLanguage_Method_setReturnType(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Method__object *_self_ior = ((struct SIDLLanguage_Method__object *) SIDL_Cast(_self, "SIDLLanguage.Method"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  struct SIDLLanguage_Type__object * type = NULL;
  static char *_kwlist[] = {
    (char *) "type",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "O&", _kwlist,
    (void *) SIDLLanguage_Type__convert, &type
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for setReturnType");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in setReturnType()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_setReturnType))(_self_ior->d_object  , /*in*/ type, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  SIDLLanguage_Type__deref(type);
  return _return_value;
}

static PyObject *
SIDLLanguage_Method_getExceptions(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Method__object *_self_ior = ((struct SIDLLanguage_Method__object *) SIDL_Cast(_self, "SIDLLanguage.Method"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDLLanguage_Class__array * _result = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for getExceptions");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in getExceptions()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_getExceptions))(_self_ior->d_object  , &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "O&",
    (void *) SIDLLanguage_Class__convert_sidl_array, _result
  );
  SIDLLanguage_Class__destroy_sidl_array(_result);
  return _return_value;
}

static PyObject *
SIDLLanguage_Method_setExceptions(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Method__object *_self_ior = ((struct SIDLLanguage_Method__object *) SIDL_Cast(_self, "SIDLLanguage.Method"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  struct SIDLLanguage_Class__array * exceptions = NULL;
  static char *_kwlist[] = {
    (char *) "exceptions",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "O&", _kwlist,
    (void *) SIDLLanguage_Class__convert_python_array, &exceptions
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for setExceptions");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in setExceptions()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_setExceptions))(_self_ior->d_object  , /*in*/ exceptions, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  SIDLLanguage_Class__destroy_sidl_array(exceptions);
  return _return_value;
}

static PyObject *
SIDLLanguage_Method_addExceptions(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Method__object *_self_ior = ((struct SIDLLanguage_Method__object *) SIDL_Cast(_self, "SIDLLanguage.Method"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  struct SIDLLanguage_Class__array * exceptions = NULL;
  static char *_kwlist[] = {
    (char *) "exceptions",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "O&", _kwlist,
    (void *) SIDLLanguage_Class__convert_python_array, &exceptions
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for addExceptions");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in addExceptions()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_addExceptions))(_self_ior->d_object  , /*in*/ exceptions, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  SIDLLanguage_Class__destroy_sidl_array(exceptions);
  return _return_value;
}

static PyObject *
SIDLLanguage_Method_getStatic(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Method__object *_self_ior = ((struct SIDLLanguage_Method__object *) SIDL_Cast(_self, "SIDLLanguage.Method"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  SIDL_bool _result;
  int _local__result;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for getStatic");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in getStatic()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_getStatic))(_self_ior->d_object  , &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _local__result = (_result != FALSE);
  _return_value = Py_BuildValue(
     (char *) "i",
    _local__result
  );
  return _return_value;
}

static PyObject *
SIDLLanguage_Method_setStatic(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Method__object *_self_ior = ((struct SIDLLanguage_Method__object *) SIDL_Cast(_self, "SIDLLanguage.Method"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  SIDL_bool isStatic;
  int _local_isStatic;
  static char *_kwlist[] = {
    (char *) "isStatic",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "i", _kwlist,
    &_local_isStatic
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for setStatic");
    return _return_value;
  }
  isStatic = (_local_isStatic != FALSE);
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in setStatic()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_setStatic))(_self_ior->d_object  , /*in*/ isStatic, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
SIDLLanguage_Method_getFinal(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Method__object *_self_ior = ((struct SIDLLanguage_Method__object *) SIDL_Cast(_self, "SIDLLanguage.Method"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  SIDL_bool _result;
  int _local__result;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for getFinal");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in getFinal()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_getFinal))(_self_ior->d_object  , &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _local__result = (_result != FALSE);
  _return_value = Py_BuildValue(
     (char *) "i",
    _local__result
  );
  return _return_value;
}

static PyObject *
SIDLLanguage_Method_setFinal(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Method__object *_self_ior = ((struct SIDLLanguage_Method__object *) SIDL_Cast(_self, "SIDLLanguage.Method"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  SIDL_bool isFinal;
  int _local_isFinal;
  static char *_kwlist[] = {
    (char *) "isFinal",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "i", _kwlist,
    &_local_isFinal
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for setFinal");
    return _return_value;
  }
  isFinal = (_local_isFinal != FALSE);
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in setFinal()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_setFinal))(_self_ior->d_object  , /*in*/ isFinal, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
SIDLLanguage_Method_getAbstract(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Method__object *_self_ior = ((struct SIDLLanguage_Method__object *) SIDL_Cast(_self, "SIDLLanguage.Method"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  SIDL_bool _result;
  int _local__result;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for getAbstract");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in getAbstract()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_getAbstract))(_self_ior->d_object  , &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _local__result = (_result != FALSE);
  _return_value = Py_BuildValue(
     (char *) "i",
    _local__result
  );
  return _return_value;
}

static PyObject *
SIDLLanguage_Method_setAbstract(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Method__object *_self_ior = ((struct SIDLLanguage_Method__object *) SIDL_Cast(_self, "SIDLLanguage.Method"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  SIDL_bool isAbstract;
  int _local_isAbstract;
  static char *_kwlist[] = {
    (char *) "isAbstract",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "i", _kwlist,
    &_local_isAbstract
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for setAbstract");
    return _return_value;
  }
  isAbstract = (_local_isAbstract != FALSE);
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in setAbstract()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_setAbstract))(_self_ior->d_object  , /*in*/ isAbstract, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
SIDLLanguage_Method_getInternal(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Method__object *_self_ior = ((struct SIDLLanguage_Method__object *) SIDL_Cast(_self, "SIDLLanguage.Method"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  SIDL_bool _result;
  int _local__result;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for getInternal");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in getInternal()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_getInternal))(_self_ior->d_object  , &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _local__result = (_result != FALSE);
  _return_value = Py_BuildValue(
     (char *) "i",
    _local__result
  );
  return _return_value;
}

static PyObject *
SIDLLanguage_Method_setInternal(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Method__object *_self_ior = ((struct SIDLLanguage_Method__object *) SIDL_Cast(_self, "SIDLLanguage.Method"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  SIDL_bool isInternal;
  int _local_isInternal;
  static char *_kwlist[] = {
    (char *) "isInternal",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "i", _kwlist,
    &_local_isInternal
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for setInternal");
    return _return_value;
  }
  isInternal = (_local_isInternal != FALSE);
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in setInternal()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_setInternal))(_self_ior->d_object  , /*in*/ isInternal, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
SIDLLanguage_Method_getTemplateIdentifiers(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Method__object *_self_ior = ((struct SIDLLanguage_Method__object *) SIDL_Cast(_self, "SIDLLanguage.Method"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_string__array * _result = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for getTemplateIdentifiers");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in getTemplateIdentifiers()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_getTemplateIdentifiers))(_self_ior->d_object  , &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "O&",
    (void *) SIDL_string__python_clone_array, _result
  );
  SIDL_string__array_destroy(_result);
  return _return_value;
}

static PyObject *
SIDLLanguage_Method_setTemplateIdentifiers(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Method__object *_self_ior = ((struct SIDLLanguage_Method__object *) SIDL_Cast(_self, "SIDLLanguage.Method"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  struct SIDL_string__array * templateIds = NULL;
  static char *_kwlist[] = {
    (char *) "templateIds",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "O&", _kwlist,
    (void *) SIDL_string__borrow_python_array, &templateIds
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for setTemplateIdentifiers");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in setTemplateIdentifiers()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_setTemplateIdentifiers))(_self_ior->d_object  , /*in*/ templateIds, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  SIDL_string__array_destroy(templateIds);
  return _return_value;
}

static PyObject *
SIDLLanguage_Method_accept(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Method__object *_self_ior = ((struct SIDLLanguage_Method__object *) SIDL_Cast(_self, "SIDLLanguage.Method"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  struct SIDLLanguage_Visitor__object * visitor = NULL;
  static char *_kwlist[] = {
    (char *) "visitor",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "O&", _kwlist,
    (void *) SIDLLanguage_Visitor__convert, &visitor
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for accept");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in accept()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_accept))(_self_ior->d_object  , /*in*/ visitor, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDLLanguage_ASTException__object *_ex0;
    struct SIDL_BaseException__object *_ex1;
  
    if (!found && (_ex0 = (struct SIDLLanguage_ASTException__object *) SIDL_PyExceptionCast(_exception, "SIDLLanguage.ASTException"))) {
      PyObject *obj = SIDLLanguage_ASTException__wrap(_ex0);
  
      PyErr_SetObject(SIDLLanguage_ASTException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found && (_ex1 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex1);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  SIDLLanguage_Visitor__deref(visitor);
  return _return_value;
}

static PyObject *
SIDLLanguage_Method_getIdentifier(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Method__object *_self_ior = ((struct SIDLLanguage_Method__object *) SIDL_Cast(_self, "SIDLLanguage.Method"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  char * _result;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for getIdentifier");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in getIdentifier()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_getIdentifier))(_self_ior->d_object  , &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "z",
    _result
  );
  free((void *) _result);
  return _return_value;
}

static PyObject *
SIDLLanguage_Method_setIdentifier(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Method__object *_self_ior = ((struct SIDLLanguage_Method__object *) SIDL_Cast(_self, "SIDLLanguage.Method"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  char * identifier;
  static char *_kwlist[] = {
    (char *) "identifier",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "z", _kwlist,
    &identifier
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for setIdentifier");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in setIdentifier()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_setIdentifier))(_self_ior->d_object  , /*in*/ identifier, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
SIDLLanguage_Method_getFullIdentifier(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Method__object *_self_ior = ((struct SIDLLanguage_Method__object *) SIDL_Cast(_self, "SIDLLanguage.Method"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  char * _result;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for getFullIdentifier");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in getFullIdentifier()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_getFullIdentifier))(_self_ior->d_object  , &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "z",
    _result
  );
  free((void *) _result);
  return _return_value;
}

static PyObject *
SIDLLanguage_Method_getParent(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Method__object *_self_ior = ((struct SIDLLanguage_Method__object *) SIDL_Cast(_self, "SIDLLanguage.Method"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDLLanguage_AST__object * _result = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for getParent");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in getParent()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_getParent))(_self_ior->d_object  , &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "O&",
    (void *) SIDLLanguage_AST__wrap, _result
  );
  return _return_value;
}

static PyObject *
SIDLLanguage_Method_setParent(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Method__object *_self_ior = ((struct SIDLLanguage_Method__object *) SIDL_Cast(_self, "SIDLLanguage.Method"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  struct SIDLLanguage_AST__object * parent = NULL;
  static char *_kwlist[] = {
    (char *) "parent",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "O&", _kwlist,
    (void *) SIDLLanguage_AST__convert, &parent
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for setParent");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in setParent()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_setParent))(_self_ior->d_object  , /*in*/ parent, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  SIDLLanguage_AST__deref(parent);
  return _return_value;
}

static PyObject *
SIDLLanguage_Method_getChildren(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Method__object *_self_ior = ((struct SIDLLanguage_Method__object *) SIDL_Cast(_self, "SIDLLanguage.Method"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDLLanguage_AST__array * _result = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for getChildren");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in getChildren()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_getChildren))(_self_ior->d_object  , &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "O&",
    (void *) SIDLLanguage_AST__convert_sidl_array, _result
  );
  SIDLLanguage_AST__destroy_sidl_array(_result);
  return _return_value;
}

static PyObject *
SIDLLanguage_Method_setChildren(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Method__object *_self_ior = ((struct SIDLLanguage_Method__object *) SIDL_Cast(_self, "SIDLLanguage.Method"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  struct SIDLLanguage_AST__array * children = NULL;
  static char *_kwlist[] = {
    (char *) "children",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "O&", _kwlist,
    (void *) SIDLLanguage_AST__convert_python_array, &children
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for setChildren");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in setChildren()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_setChildren))(_self_ior->d_object  , /*in*/ children, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  SIDLLanguage_AST__destroy_sidl_array(children);
  return _return_value;
}

static PyObject *
SIDLLanguage_Method_addChildren(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Method__object *_self_ior = ((struct SIDLLanguage_Method__object *) SIDL_Cast(_self, "SIDLLanguage.Method"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  struct SIDLLanguage_AST__array * children = NULL;
  static char *_kwlist[] = {
    (char *) "children",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "O&", _kwlist,
    (void *) SIDLLanguage_AST__convert_python_array, &children
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for addChildren");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in addChildren()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_addChildren))(_self_ior->d_object  , /*in*/ children, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  SIDLLanguage_AST__destroy_sidl_array(children);
  return _return_value;
}

static PyObject *
SIDLLanguage_Method_getDependencies(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Method__object *_self_ior = ((struct SIDLLanguage_Method__object *) SIDL_Cast(_self, "SIDLLanguage.Method"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDLLanguage_AST__array * _result = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for getDependencies");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in getDependencies()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_getDependencies))(_self_ior->d_object  , &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "O&",
    (void *) SIDLLanguage_AST__convert_sidl_array, _result
  );
  SIDLLanguage_AST__destroy_sidl_array(_result);
  return _return_value;
}

static PyObject *
SIDLLanguage_Method_setDependencies(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Method__object *_self_ior = ((struct SIDLLanguage_Method__object *) SIDL_Cast(_self, "SIDLLanguage.Method"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  struct SIDLLanguage_AST__array * dependencies = NULL;
  static char *_kwlist[] = {
    (char *) "dependencies",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "O&", _kwlist,
    (void *) SIDLLanguage_AST__convert_python_array, &dependencies
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for setDependencies");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in setDependencies()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_setDependencies))(_self_ior->d_object  , /*in*/ dependencies, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  SIDLLanguage_AST__destroy_sidl_array(dependencies);
  return _return_value;
}

static PyObject *
SIDLLanguage_Method_addDependency(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Method__object *_self_ior = ((struct SIDLLanguage_Method__object *) SIDL_Cast(_self, "SIDLLanguage.Method"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  struct SIDLLanguage_AST__object * dependency = NULL;
  static char *_kwlist[] = {
    (char *) "dependency",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "O&", _kwlist,
    (void *) SIDLLanguage_AST__convert, &dependency
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for addDependency");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in addDependency()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_addDependency))(_self_ior->d_object  , /*in*/ dependency, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  SIDLLanguage_AST__deref(dependency);
  return _return_value;
}

static PyObject *
SIDLLanguage_Method_getComments(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Method__object *_self_ior = ((struct SIDLLanguage_Method__object *) SIDL_Cast(_self, "SIDLLanguage.Method"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDLLanguage_Comment__array * _result = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for getComments");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in getComments()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_getComments))(_self_ior->d_object  , &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "O&",
    (void *) SIDLLanguage_Comment__convert_sidl_array, _result
  );
  SIDLLanguage_Comment__destroy_sidl_array(_result);
  return _return_value;
}

static PyObject *
SIDLLanguage_Method_setComments(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Method__object *_self_ior = ((struct SIDLLanguage_Method__object *) SIDL_Cast(_self, "SIDLLanguage.Method"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  struct SIDLLanguage_Comment__array * comments = NULL;
  static char *_kwlist[] = {
    (char *) "comments",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "O&", _kwlist,
    (void *) SIDLLanguage_Comment__convert_python_array, &comments
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for setComments");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in setComments()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_setComments))(_self_ior->d_object  , /*in*/ comments, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  SIDLLanguage_Comment__destroy_sidl_array(comments);
  return _return_value;
}

static PyObject *
SIDLLanguage_Method_addComments(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Method__object *_self_ior = ((struct SIDLLanguage_Method__object *) SIDL_Cast(_self, "SIDLLanguage.Method"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  struct SIDLLanguage_Comment__array * comments = NULL;
  static char *_kwlist[] = {
    (char *) "comments",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "O&", _kwlist,
    (void *) SIDLLanguage_Comment__convert_python_array, &comments
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for addComments");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in addComments()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_addComments))(_self_ior->d_object  , /*in*/ comments, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  SIDLLanguage_Comment__destroy_sidl_array(comments);
  return _return_value;
}

static PyObject *
SIDLLanguage_Method_getCode(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Method__object *_self_ior = ((struct SIDLLanguage_Method__object *) SIDL_Cast(_self, "SIDLLanguage.Method"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDLLanguage_Code__array * _result = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  char * language;
  static char *_kwlist[] = {
    (char *) "language",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "z", _kwlist,
    &language
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for getCode");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in getCode()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_getCode))(_self_ior->d_object  , /*in*/ language, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "O&",
    (void *) SIDLLanguage_Code__convert_sidl_array, _result
  );
  SIDLLanguage_Code__destroy_sidl_array(_result);
  return _return_value;
}

static PyObject *
SIDLLanguage_Method_setCode(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Method__object *_self_ior = ((struct SIDLLanguage_Method__object *) SIDL_Cast(_self, "SIDLLanguage.Method"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  struct SIDLLanguage_Code__array * code = NULL;
  static char *_kwlist[] = {
    (char *) "code",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "O&", _kwlist,
    (void *) SIDLLanguage_Code__convert_python_array, &code
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for setCode");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in setCode()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_setCode))(_self_ior->d_object  , /*in*/ code, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  SIDLLanguage_Code__destroy_sidl_array(code);
  return _return_value;
}

static PyObject *
SIDLLanguage_Method_addCode(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Method__object *_self_ior = ((struct SIDLLanguage_Method__object *) SIDL_Cast(_self, "SIDLLanguage.Method"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  struct SIDLLanguage_Code__object * code = NULL;
  static char *_kwlist[] = {
    (char *) "code",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "O&", _kwlist,
    (void *) SIDLLanguage_Code__convert, &code
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for addCode");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in addCode()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_addCode))(_self_ior->d_object  , /*in*/ code, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  SIDLLanguage_Code__deref(code);
  return _return_value;
}

static PyObject *
SIDLLanguage_Method_hasCodeBlock(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Method__object *_self_ior = ((struct SIDLLanguage_Method__object *) SIDL_Cast(_self, "SIDLLanguage.Method"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  SIDL_bool _result;
  int _local__result;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  char * language;
  char * label;
  static char *_kwlist[] = {
    (char *) "language",
    (char *) "label",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "zz", _kwlist,
    &language,
    &label
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for hasCodeBlock");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in hasCodeBlock()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_hasCodeBlock))(_self_ior->d_object  , /*in*/ language, /*in*/ label, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _local__result = (_result != FALSE);
  _return_value = Py_BuildValue(
     (char *) "i",
    _local__result
  );
  return _return_value;
}

static PyObject *
SIDLLanguage_Method_getCodeBlock(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Method__object *_self_ior = ((struct SIDLLanguage_Method__object *) SIDL_Cast(_self, "SIDLLanguage.Method"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDLLanguage_Code__object * _result = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  char * language;
  char * label;
  static char *_kwlist[] = {
    (char *) "language",
    (char *) "label",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "zz", _kwlist,
    &language,
    &label
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for getCodeBlock");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in getCodeBlock()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_getCodeBlock))(_self_ior->d_object  , /*in*/ language, /*in*/ label, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDLLanguage_CodeGeneratorException__object *_ex0;
    struct SIDL_BaseException__object *_ex1;
  
    if (!found && (_ex0 = (struct SIDLLanguage_CodeGeneratorException__object *) SIDL_PyExceptionCast(_exception, "SIDLLanguage.CodeGeneratorException"))) {
      PyObject *obj = SIDLLanguage_CodeGeneratorException__wrap(_ex0);
  
      PyErr_SetObject(SIDLLanguage_CodeGeneratorException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found && (_ex1 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex1);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "O&",
    (void *) SIDLLanguage_Code__wrap, _result
  );
  return _return_value;
}

static PyObject *
SIDLLanguage_Method_removeCodeBlock(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Method__object *_self_ior = ((struct SIDLLanguage_Method__object *) SIDL_Cast(_self, "SIDLLanguage.Method"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDLLanguage_Code__object * _result = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  char * language;
  char * label;
  static char *_kwlist[] = {
    (char *) "language",
    (char *) "label",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "zz", _kwlist,
    &language,
    &label
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for removeCodeBlock");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in removeCodeBlock()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_removeCodeBlock))(_self_ior->d_object  , /*in*/ language, /*in*/ label, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDLLanguage_CodeGeneratorException__object *_ex0;
    struct SIDL_BaseException__object *_ex1;
  
    if (!found && (_ex0 = (struct SIDLLanguage_CodeGeneratorException__object *) SIDL_PyExceptionCast(_exception, "SIDLLanguage.CodeGeneratorException"))) {
      PyObject *obj = SIDLLanguage_CodeGeneratorException__wrap(_ex0);
  
      PyErr_SetObject(SIDLLanguage_CodeGeneratorException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found && (_ex1 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex1);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "O&",
    (void *) SIDLLanguage_Code__wrap, _result
  );
  return _return_value;
}

static PyObject *
SIDLLanguage_Method_getAttributes(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Method__object *_self_ior = ((struct SIDLLanguage_Method__object *) SIDL_Cast(_self, "SIDLLanguage.Method"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDLLanguage_Attribute__array * _result = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for getAttributes");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in getAttributes()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_getAttributes))(_self_ior->d_object  , &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "O&",
    (void *) SIDLLanguage_Attribute__convert_sidl_array, _result
  );
  SIDLLanguage_Attribute__destroy_sidl_array(_result);
  return _return_value;
}

static PyObject *
SIDLLanguage_Method_setAttributes(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Method__object *_self_ior = ((struct SIDLLanguage_Method__object *) SIDL_Cast(_self, "SIDLLanguage.Method"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  struct SIDLLanguage_Attribute__array * attributes = NULL;
  static char *_kwlist[] = {
    (char *) "attributes",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "O&", _kwlist,
    (void *) SIDLLanguage_Attribute__convert_python_array, &attributes
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for setAttributes");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in setAttributes()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_setAttributes))(_self_ior->d_object  , /*in*/ attributes, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  SIDLLanguage_Attribute__destroy_sidl_array(attributes);
  return _return_value;
}

static PyObject *
SIDLLanguage_Method_hasAttribute(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Method__object *_self_ior = ((struct SIDLLanguage_Method__object *) SIDL_Cast(_self, "SIDLLanguage.Method"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  SIDL_bool _result;
  int _local__result;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  char * name;
  static char *_kwlist[] = {
    (char *) "name",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "z", _kwlist,
    &name
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for hasAttribute");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in hasAttribute()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_hasAttribute))(_self_ior->d_object  , /*in*/ name, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _local__result = (_result != FALSE);
  _return_value = Py_BuildValue(
     (char *) "i",
    _local__result
  );
  return _return_value;
}

static PyObject *
SIDLLanguage_Method_addAttribute(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Method__object *_self_ior = ((struct SIDLLanguage_Method__object *) SIDL_Cast(_self, "SIDLLanguage.Method"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  struct SIDLLanguage_Attribute__object * attribute = NULL;
  static char *_kwlist[] = {
    (char *) "attribute",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "O&", _kwlist,
    (void *) SIDLLanguage_Attribute__convert, &attribute
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for addAttribute");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in addAttribute()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_addAttribute))(_self_ior->d_object  , /*in*/ attribute, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDL_BaseException__object *_ex0;
  
    if (!found && (_ex0 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex0);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  SIDLLanguage_Attribute__deref(attribute);
  return _return_value;
}

static PyObject *
SIDLLanguage_Method_deleteAttribute(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Method__object *_self_ior = ((struct SIDLLanguage_Method__object *) SIDL_Cast(_self, "SIDLLanguage.Method"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDLLanguage_Attribute__object * _result = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  char * name;
  static char *_kwlist[] = {
    (char *) "name",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "z", _kwlist,
    &name
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for deleteAttribute");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in deleteAttribute()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_deleteAttribute))(_self_ior->d_object  , /*in*/ name, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDLLanguage_ASTException__object *_ex0;
    struct SIDL_BaseException__object *_ex1;
  
    if (!found && (_ex0 = (struct SIDLLanguage_ASTException__object *) SIDL_PyExceptionCast(_exception, "SIDLLanguage.ASTException"))) {
      PyObject *obj = SIDLLanguage_ASTException__wrap(_ex0);
  
      PyErr_SetObject(SIDLLanguage_ASTException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found && (_ex1 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex1);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "O&",
    (void *) SIDLLanguage_Attribute__wrap, _result
  );
  return _return_value;
}

static PyObject *
SIDLLanguage_Method_getAttribute(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Method__object *_self_ior = ((struct SIDLLanguage_Method__object *) SIDL_Cast(_self, "SIDLLanguage.Method"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDLLanguage_Attribute__object * _result = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  char * name;
  static char *_kwlist[] = {
    (char *) "name",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "z", _kwlist,
    &name
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for getAttribute");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in getAttribute()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_getAttribute))(_self_ior->d_object  , /*in*/ name, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDLLanguage_ASTException__object *_ex0;
    struct SIDL_BaseException__object *_ex1;
  
    if (!found && (_ex0 = (struct SIDLLanguage_ASTException__object *) SIDL_PyExceptionCast(_exception, "SIDLLanguage.ASTException"))) {
      PyObject *obj = SIDLLanguage_ASTException__wrap(_ex0);
  
      PyErr_SetObject(SIDLLanguage_ASTException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found && (_ex1 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex1);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "O&",
    (void *) SIDLLanguage_Attribute__wrap, _result
  );
  return _return_value;
}

static PyObject *
SIDLLanguage_Method_addReference(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Method__object *_self_ior = ((struct SIDLLanguage_Method__object *) SIDL_Cast(_self, "SIDLLanguage.Method"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for addReference");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in addReference()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_addReference))(_self_ior->d_object  );
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
SIDLLanguage_Method_deleteReference(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Method__object *_self_ior = ((struct SIDLLanguage_Method__object *) SIDL_Cast(_self, "SIDLLanguage.Method"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for deleteReference");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in deleteReference()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_deleteReference))(_self_ior->d_object  );
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
SIDLLanguage_Method_isSame(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Method__object *_self_ior = ((struct SIDLLanguage_Method__object *) SIDL_Cast(_self, "SIDLLanguage.Method"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  SIDL_bool _result;
  int _local__result;
  /* Pack arguments for dispatch to IOR */
  struct SIDL_BaseInterface__object * iobj = NULL;
  static char *_kwlist[] = {
    (char *) "iobj",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "O&", _kwlist,
    (void *) SIDL_BaseInterface__convert, &iobj
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for isSame");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in isSame()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_isSame))(_self_ior->d_object  , /*in*/ iobj);
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _local__result = (_result != FALSE);
  _return_value = Py_BuildValue(
     (char *) "i",
    _local__result
  );
  SIDL_BaseInterface__deref(iobj);
  return _return_value;
}

static PyObject *
SIDLLanguage_Method_queryInterface(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Method__object *_self_ior = ((struct SIDLLanguage_Method__object *) SIDL_Cast(_self, "SIDLLanguage.Method"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseInterface__object * _result = NULL;
  /* Pack arguments for dispatch to IOR */
  char * name;
  static char *_kwlist[] = {
    (char *) "name",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "z", _kwlist,
    &name
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for queryInterface");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in queryInterface()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_queryInterface))(_self_ior->d_object  , /*in*/ name);
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "O&",
    (void *) SIDL_BaseInterface__wrap, _result
  );
  return _return_value;
}

static PyObject *
SIDLLanguage_Method_isInstanceOf(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Method__object *_self_ior = ((struct SIDLLanguage_Method__object *) SIDL_Cast(_self, "SIDLLanguage.Method"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  SIDL_bool _result;
  int _local__result;
  /* Pack arguments for dispatch to IOR */
  char * name;
  static char *_kwlist[] = {
    (char *) "name",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "z", _kwlist,
    &name
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for isInstanceOf");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in isInstanceOf()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_isInstanceOf))(_self_ior->d_object  , /*in*/ name);
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _local__result = (_result != FALSE);
  _return_value = Py_BuildValue(
     (char *) "i",
    _local__result
  );
  return _return_value;
}

static PyObject *
SIDLLanguage_Method_Method(
  PyObject *_ignored,
  PyObject *_args,
  PyObject *_kwdict
)
{
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDLLanguage_Method__object * _result = NULL;
  /* Pack arguments for dispatch to IOR */
  struct SIDLLanguage_Method__object * optarg = NULL;
  static char *_kwlist[] = {
    (char *) "optarg",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "|O&", _kwlist,
    (void *) SIDLLanguage_Method__convert, &optarg
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for Method");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  /* Implementation code */
  if (optarg) {
    (*(optarg->d_epv->f_addReference))(optarg->d_object);
  }
  /* Since we may merely up the reference count and return the argument, add an extra reference */
  SIDLLanguage_Method__addRef(optarg);
  _result = optarg;  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "O&",
    (void *) SIDLLanguage_Method__wrap, _result
  );
  SIDLLanguage_Method__deref(optarg);
  return _return_value;
}

static PyMethodDef _MethodModuleMethods[] = {
  {(char *) "Method", (PyCFunction) SIDLLanguage_Method_Method, (METH_VARARGS | METH_KEYWORDS), (char *) "Method(in Method optarg)\n\
RETURNS\n\
  SIDLLanguage.Method _result\n\
Constructor and/or cast method for SIDLLanguage.Method\n\
"},
  {NULL, NULL}
};

static PyMethodDef _MethodObjectMethods[] = {
  {(char *) "getReturnType", (PyCFunction) SIDLLanguage_Method_getReturnType, (METH_VARARGS | METH_KEYWORDS), (char *) "getReturnType()\n\
RETURNS\n\
  SIDLLanguage.Type _result\n\
// Retrieve the return type\n\
"},
  {(char *) "setReturnType", (PyCFunction) SIDLLanguage_Method_setReturnType, (METH_VARARGS | METH_KEYWORDS), (char *) "setReturnType(in Type type)\n\
RETURNS\n\
   None\n\
// Set the return type\n\
"},
  {(char *) "getExceptions", (PyCFunction) SIDLLanguage_Method_getExceptions, (METH_VARARGS | METH_KEYWORDS), (char *) "getExceptions()\n\
RETURNS\n\
  array _result\n\
// Retrieve the exceptions thrown by the method\n\
"},
  {(char *) "setExceptions", (PyCFunction) SIDLLanguage_Method_setExceptions, (METH_VARARGS | METH_KEYWORDS), (char *) "setExceptions(in array exceptions)\n\
RETURNS\n\
   None\n\
// Set the exceptions thrown by the method\n\
"},
  {(char *) "addExceptions", (PyCFunction) SIDLLanguage_Method_addExceptions, (METH_VARARGS | METH_KEYWORDS), (char *) "addExceptions(in array exceptions)\n\
RETURNS\n\
   None\n\
// Add to the exceptions thrown by the method\n\
"},
  {(char *) "getStatic", (PyCFunction) SIDLLanguage_Method_getStatic, (METH_VARARGS | METH_KEYWORDS), (char *) "getStatic()\n\
RETURNS\n\
  bool _result\n\
// Retrieve the flag indicating whether the method is static\n\
"},
  {(char *) "setStatic", (PyCFunction) SIDLLanguage_Method_setStatic, (METH_VARARGS | METH_KEYWORDS), (char *) "setStatic(in bool isStatic)\n\
RETURNS\n\
   None\n\
// Set the flag indicating whether the method is static\n\
"},
  {(char *) "getFinal", (PyCFunction) SIDLLanguage_Method_getFinal, (METH_VARARGS | METH_KEYWORDS), (char *) "getFinal()\n\
RETURNS\n\
  bool _result\n\
// Retrieve the flag indicating whether the method is final\n\
"},
  {(char *) "setFinal", (PyCFunction) SIDLLanguage_Method_setFinal, (METH_VARARGS | METH_KEYWORDS), (char *) "setFinal(in bool isFinal)\n\
RETURNS\n\
   None\n\
// Set the flag indicating whether the method is final\n\
"},
  {(char *) "getAbstract", (PyCFunction) SIDLLanguage_Method_getAbstract, (METH_VARARGS | METH_KEYWORDS), (char *) "getAbstract()\n\
RETURNS\n\
  bool _result\n\
// Retrieve the flag indicating whether the method is abstract\n\
"},
  {(char *) "setAbstract", (PyCFunction) SIDLLanguage_Method_setAbstract, (METH_VARARGS | METH_KEYWORDS), (char *) "setAbstract(in bool isAbstract)\n\
RETURNS\n\
   None\n\
// Set the flag indicating whether the method is abstract\n\
"},
  {(char *) "getInternal", (PyCFunction) SIDLLanguage_Method_getInternal, (METH_VARARGS | METH_KEYWORDS), (char *) "getInternal()\n\
RETURNS\n\
  bool _result\n\
// Retrieve the flag indicating whether the method is not present in the SIDL interface\n\
"},
  {(char *) "setInternal", (PyCFunction) SIDLLanguage_Method_setInternal, (METH_VARARGS | METH_KEYWORDS), (char *) "setInternal(in bool isInternal)\n\
RETURNS\n\
   None\n\
// Set the flag indicating whether the method is not present in the SIDL interface\n\
"},
  {(char *) "getTemplateIdentifiers", (PyCFunction) SIDLLanguage_Method_getTemplateIdentifiers, (METH_VARARGS | METH_KEYWORDS), (char *) "getTemplateIdentifiers()\n\
RETURNS\n\
  array _result\n\
// Get the identifiers which are quantified over types\n\
"},
  {(char *) "setTemplateIdentifiers", (PyCFunction) SIDLLanguage_Method_setTemplateIdentifiers, (METH_VARARGS | METH_KEYWORDS), (char *) "setTemplateIdentifiers(in array templateIds)\n\
RETURNS\n\
   None\n\
// Set the identifiers which are quantified over types\n\
"},
  {(char *) "accept", (PyCFunction) SIDLLanguage_Method_accept, (METH_VARARGS | METH_KEYWORDS), (char *) "accept(in Visitor visitor)\n\
RETURNS\n\
   None\n\
// Support the visitor pattern for traversal.\n\
"},
  {(char *) "getIdentifier", (PyCFunction) SIDLLanguage_Method_getIdentifier, (METH_VARARGS | METH_KEYWORDS), (char *) "getIdentifier()\n\
RETURNS\n\
  string _result\n\
// Retrieve the identifier associated with this node\n\
"},
  {(char *) "setIdentifier", (PyCFunction) SIDLLanguage_Method_setIdentifier, (METH_VARARGS | METH_KEYWORDS), (char *) "setIdentifier(in string identifier)\n\
RETURNS\n\
   None\n\
// Assign the identifier associated with this node\n\
"},
  {(char *) "getFullIdentifier", (PyCFunction) SIDLLanguage_Method_getFullIdentifier, (METH_VARARGS | METH_KEYWORDS), (char *) "getFullIdentifier()\n\
RETURNS\n\
  string _result\n\
// Retrieve the fully qualified identifier associated with this node\n\
"},
  {(char *) "getParent", (PyCFunction) SIDLLanguage_Method_getParent, (METH_VARARGS | METH_KEYWORDS), (char *) "getParent()\n\
RETURNS\n\
  SIDLLanguage.AST _result\n\
// Retrieve the parent of this node\n\
"},
  {(char *) "setParent", (PyCFunction) SIDLLanguage_Method_setParent, (METH_VARARGS | METH_KEYWORDS), (char *) "setParent(in AST parent)\n\
RETURNS\n\
   None\n\
// Assign the parent of this node\n\
"},
  {(char *) "getChildren", (PyCFunction) SIDLLanguage_Method_getChildren, (METH_VARARGS | METH_KEYWORDS), (char *) "getChildren()\n\
RETURNS\n\
  array _result\n\
// Retrieve the children of this node\n\
"},
  {(char *) "setChildren", (PyCFunction) SIDLLanguage_Method_setChildren, (METH_VARARGS | METH_KEYWORDS), (char *) "setChildren(in array children)\n\
RETURNS\n\
   None\n\
// Assign the children of this node\n\
"},
  {(char *) "addChildren", (PyCFunction) SIDLLanguage_Method_addChildren, (METH_VARARGS | METH_KEYWORDS), (char *) "addChildren(in array children)\n\
RETURNS\n\
   None\n\
// Add to the children of this node (duplicates allowed)\n\
"},
  {(char *) "getDependencies", (PyCFunction) SIDLLanguage_Method_getDependencies, (METH_VARARGS | METH_KEYWORDS), (char *) "getDependencies()\n\
RETURNS\n\
  array _result\n\
// Retrieve nodes on which this node depends\n\
"},
  {(char *) "setDependencies", (PyCFunction) SIDLLanguage_Method_setDependencies, (METH_VARARGS | METH_KEYWORDS), (char *) "setDependencies(in array dependencies)\n\
RETURNS\n\
   None\n\
// Set nodes on which this node depends\n\
"},
  {(char *) "addDependency", (PyCFunction) SIDLLanguage_Method_addDependency, (METH_VARARGS | METH_KEYWORDS), (char *) "addDependency(in AST dependency)\n\
RETURNS\n\
   None\n\
// Add nodes on which this node depends\n\
"},
  {(char *) "getComments", (PyCFunction) SIDLLanguage_Method_getComments, (METH_VARARGS | METH_KEYWORDS), (char *) "getComments()\n\
RETURNS\n\
  array _result\n\
// Retrieve the comments of this node\n\
"},
  {(char *) "setComments", (PyCFunction) SIDLLanguage_Method_setComments, (METH_VARARGS | METH_KEYWORDS), (char *) "setComments(in array comments)\n\
RETURNS\n\
   None\n\
// Assign the children of this node\n\
"},
  {(char *) "addComments", (PyCFunction) SIDLLanguage_Method_addComments, (METH_VARARGS | METH_KEYWORDS), (char *) "addComments(in array comments)\n\
RETURNS\n\
   None\n\
// Add to the children of this node (duplicates allowed)\n\
"},
  {(char *) "getCode", (PyCFunction) SIDLLanguage_Method_getCode, (METH_VARARGS | METH_KEYWORDS), (char *) "getCode(in string language)\n\
RETURNS\n\
  array _result\n\
// Retrieve source code for a given language, or empty string for everything\n\
"},
  {(char *) "setCode", (PyCFunction) SIDLLanguage_Method_setCode, (METH_VARARGS | METH_KEYWORDS), (char *) "setCode(in array code)\n\
RETURNS\n\
   None\n\
// Set source code\n\
"},
  {(char *) "addCode", (PyCFunction) SIDLLanguage_Method_addCode, (METH_VARARGS | METH_KEYWORDS), (char *) "addCode(in Code code)\n\
RETURNS\n\
   None\n\
// Add source code\n\
"},
  {(char *) "hasCodeBlock", (PyCFunction) SIDLLanguage_Method_hasCodeBlock, (METH_VARARGS | METH_KEYWORDS), (char *) "hasCodeBlock(in string language, in string label)\n\
RETURNS\n\
  bool _result\n\
// Determine whether the source block with a particular label is present\n\
"},
  {(char *) "getCodeBlock", (PyCFunction) SIDLLanguage_Method_getCodeBlock, (METH_VARARGS | METH_KEYWORDS), (char *) "getCodeBlock(in string language, in string label)\n\
RETURNS\n\
  SIDLLanguage.Code _result\n\
// Get the source block with a particular label\n\
"},
  {(char *) "removeCodeBlock", (PyCFunction) SIDLLanguage_Method_removeCodeBlock, (METH_VARARGS | METH_KEYWORDS), (char *) "removeCodeBlock(in string language, in string label)\n\
RETURNS\n\
  SIDLLanguage.Code _result\n\
// Remove the source block with a particular label\n\
"},
  {(char *) "getAttributes", (PyCFunction) SIDLLanguage_Method_getAttributes, (METH_VARARGS | METH_KEYWORDS), (char *) "getAttributes()\n\
RETURNS\n\
  array _result\n\
// Get attribute list for this node\n\
"},
  {(char *) "setAttributes", (PyCFunction) SIDLLanguage_Method_setAttributes, (METH_VARARGS | METH_KEYWORDS), (char *) "setAttributes(in array attributes)\n\
RETURNS\n\
   None\n\
// Set attribute list for this node\n\
"},
  {(char *) "hasAttribute", (PyCFunction) SIDLLanguage_Method_hasAttribute, (METH_VARARGS | METH_KEYWORDS), (char *) "hasAttribute(in string name)\n\
RETURNS\n\
  bool _result\n\
// Determine whether an attribute is present on this node\n\
"},
  {(char *) "addAttribute", (PyCFunction) SIDLLanguage_Method_addAttribute, (METH_VARARGS | METH_KEYWORDS), (char *) "addAttribute(in Attribute attribute)\n\
RETURNS\n\
   None\n\
// Add attribute to this node\n\
"},
  {(char *) "deleteAttribute", (PyCFunction) SIDLLanguage_Method_deleteAttribute, (METH_VARARGS | METH_KEYWORDS), (char *) "deleteAttribute(in string name)\n\
RETURNS\n\
  SIDLLanguage.Attribute _result\n\
// Remove an attribute on this node\n\
"},
  {(char *) "getAttribute", (PyCFunction) SIDLLanguage_Method_getAttribute, (METH_VARARGS | METH_KEYWORDS), (char *) "getAttribute(in string name)\n\
RETURNS\n\
  SIDLLanguage.Attribute _result\n\
// Get an attribute on this node\n\
"},
  {(char *) "addReference", (PyCFunction) SIDLLanguage_Method_addReference, (METH_VARARGS | METH_KEYWORDS), (char *) "addReference()\n\
RETURNS\n\
   None\n\
// Add one to the intrinsic reference count in the underlying object.\n\
// Object in <code>SIDL</code> have an intrinsic reference count.\n\
// Objects continue to exist as long as the reference count is\n\
// positive. Clients should call this method whenever they\n\
// create another ongoing reference to an object or interface.\n\
// \n\
// This does not have a return value because there is no language\n\
// independent type that can refer to an interface or a\n\
// class.\n\
"},
  {(char *) "deleteReference", (PyCFunction) SIDLLanguage_Method_deleteReference, (METH_VARARGS | METH_KEYWORDS), (char *) "deleteReference()\n\
RETURNS\n\
   None\n\
// Decrease by one the intrinsic reference count in the underlying\n\
// object, and delete the object if the reference is non-positive.\n\
// Objects in <code>SIDL</code> have an intrinsic reference count.\n\
// Clients should call this method whenever they remove a\n\
// reference to an object or interface.\n\
"},
  {(char *) "isSame", (PyCFunction) SIDLLanguage_Method_isSame, (METH_VARARGS | METH_KEYWORDS), (char *) "isSame(in BaseInterface iobj)\n\
RETURNS\n\
  bool _result\n\
// Return true if and only if <code>obj</code> refers to the same\n\
// object as this object.\n\
"},
  {(char *) "queryInterface", (PyCFunction) SIDLLanguage_Method_queryInterface, (METH_VARARGS | METH_KEYWORDS), (char *) "queryInterface(in string name)\n\
RETURNS\n\
  SIDL.BaseInterface _result\n\
// Check whether the object can support the specified interface or\n\
// class.  If the <code>SIDL</code> type name in <code>name</code>\n\
// is supported, then a reference to that object is returned with the\n\
// reference count incremented.  The callee will be responsible for\n\
// calling <code>deleteReference</code> on the returned object.  If\n\
// the specified type is not supported, then a null reference is\n\
// returned.\n\
"},
  {(char *) "isInstanceOf", (PyCFunction) SIDLLanguage_Method_isInstanceOf, (METH_VARARGS | METH_KEYWORDS), (char *) "isInstanceOf(in string name)\n\
RETURNS\n\
  bool _result\n\
// Return whether this object is an instance of the specified type.\n\
// The string name must be the <code>SIDL</code> type name.  This\n\
// routine will return <code>true</code> if and only if a cast to\n\
// the string type name would succeed.\n\
"},
  {NULL, NULL}
};

SIDLLanguage_Method__wrap_RETURN
SIDLLanguage_Method__wrap SIDLLanguage_Method__wrap_PROTO {
  if (!sidlobj) {
    return Py_None;
  } else {
    return SIDL_Object_Create(sidlobj->d_epv->f__cast_ior(sidlobj->d_object, "SIDLLanguage.Method"), _MethodObjectMethods, SIDL_PyStealRef);
  }
}

SIDLLanguage_Method__weakRef_RETURN
SIDLLanguage_Method__weakRef SIDLLanguage_Method__weakRef_PROTO {
  return SIDL_Object_Create(sidlobj->d_epv->f__cast_ior(sidlobj->d_object, "SIDLLanguage.Method"), _MethodObjectMethods, SIDL_PyWeakRef);
}

SIDLLanguage_Method__deref_RETURN
SIDLLanguage_Method__deref SIDLLanguage_Method__deref_PROTO {
  if (sidlobj) {
    (*(sidlobj->d_epv->f_deleteReference))(sidlobj->d_object);
  }
}

SIDLLanguage_Method__newRef_RETURN
SIDLLanguage_Method__newRef SIDLLanguage_Method__newRef_PROTO {
  return SIDL_Object_Create(sidlobj->d_epv->f__cast_ior(sidlobj->d_object, "SIDLLanguage.Method"), _MethodObjectMethods, SIDL_PyNewRef);
}

SIDLLanguage_Method__addRef_RETURN
SIDLLanguage_Method__addRef SIDLLanguage_Method__addRef_PROTO {
  if (sidlobj) {
    (*(sidlobj->d_epv->f_addReference))(sidlobj->d_object);
  }
}

SIDLLanguage_Method__convert_RETURN
SIDLLanguage_Method__convert SIDLLanguage_Method__convert_PROTO {
  *sidlobj = SIDL_Cast(obj, "SIDLLanguage.Method");
  if (*sidlobj) {
    (*((*sidlobj)->d_epv->f_addReference))((*sidlobj)->d_object);
  } else if (obj != Py_None) {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type SIDLLanguage.Method");
    return 0;
  }
  return 1;
}

static int
_convertPython(void *sidlarray, const int *ind, PyObject *pyobj) {
  struct SIDLLanguage_Method__object *sidlobj;

  if (SIDLLanguage_Method__convert(pyobj, &sidlobj)) {
    (*_epv->setElement)((struct SIDLLanguage_Method__array *) sidlarray, ind, sidlobj);
    return 0;
  }
  return 1;
}

SIDLLanguage_Method__convert_python_array_RETURN
SIDLLanguage_Method__convert_python_array SIDLLanguage_Method__convert_python_array_PROTO {
  PyObject *pya    = PyArray_FromObject(obj, PyArray_OBJECT, 0, 0);
  int       result = 0;

  *sidlarray = NULL;
  if (pya) {
    if (PyArray_OBJECT == ((PyArrayObject *) pya)->descr->type_num) {
      int dimen, *lower, *upper, *stride;

      if (SIDL_array__extract_python_info(pya, &dimen, &lower, &upper, &stride)) {
        *sidlarray = (*_epv->createArray)(dimen, lower, upper);
        free(lower);
        free(upper);
        free(stride);
        result = SIDL_array__convert_python(pya, dimen, *sidlarray, _convertPython);
        if (*sidlarray && !result) {
          (*_epv->destroyArray)(*sidlarray);
          *sidlarray = NULL;
        }
      }
    }
    Py_DECREF(pya);
  }
  return result;
}

static int
_convertSIDL(void *sidlarray, const int *ind, PyObject **dest) {
  struct SIDLLanguage_Method__object *sidlobj = (*_epv->getElement)((struct SIDLLanguage_Method__array *) sidlarray, ind);

  *dest = SIDLLanguage_Method__wrap(sidlobj);
  return (*dest == NULL);
}

SIDLLanguage_Method__convert_sidl_array_RETURN
SIDLLanguage_Method__convert_sidl_array SIDLLanguage_Method__convert_sidl_array_PROTO {
  PyObject *pya = NULL;

  if (sidlarray) {
    const int dimen   = (*_epv->getDimen)(sidlarray);
    int      *lower   = (int *) malloc(dimen * sizeof(int));
    int      *upper   = (int *) malloc(dimen * sizeof(int));
    int      *numElem = (int *) malloc(dimen * sizeof(int));
    int       i;

    for(i = 0; i < dimen; i++) {
      lower[i]   = (*_epv->getLower)(sidlarray, i);
      upper[i]   = (*_epv->getUpper)(sidlarray, i);
      numElem[i] = upper[i] - lower[i] + 1;
    }
    pya = PyArray_FromDims(dimen, numElem, PyArray_OBJECT);;
    if (pya) {
      if (!SIDL_array__convert_sidl(pya, dimen, lower, upper, numElem, sidlarray, _convertSIDL)) {
        Py_DECREF(pya);
        pya = NULL;
      }
    }
    free(lower);
    free(upper);
    free(numElem);
  }
  return pya;
}

SIDLLanguage_Method__destroy_sidl_array_RETURN
SIDLLanguage_Method__destroy_sidl_array SIDLLanguage_Method__destroy_sidl_array_PROTO {
  if (sidlarray) {
    (*_epv->destroyArray)(sidlarray);
  }
}

void initMethod(void) {
  PyObject *module, *dict, *c_api;
  static void *ExternalAPI[SIDLLanguage_Method__API_NUM];
  struct SIDLLanguage_Method__external * (*_extFunc)(void) = NULL;
  module = Py_InitModule((char *) "Method", _MethodModuleMethods);
  _extFunc = (struct SIDLLanguage_Method__external * (*)(void)) SIDL_Loader__externals()->getStaticEPV()->f_lookupSymbol("SIDLLanguage_Method__externals");
  if (_extFunc) {
    _epv = (*_extFunc)();
  }
  if (!_epv) {
    PyErr_SetString(PyExc_TypeError, "Cannot load SIDL implementation for SIDLLanguage.Method");
    return;
  }
  dict = PyModule_GetDict(module);
  ExternalAPI[SIDLLanguage_Method__wrap_NUM] = SIDLLanguage_Method__wrap;
  ExternalAPI[SIDLLanguage_Method__convert_NUM] = SIDLLanguage_Method__convert;
  ExternalAPI[SIDLLanguage_Method__convert_python_array_NUM] = SIDLLanguage_Method__convert_python_array;
  ExternalAPI[SIDLLanguage_Method__convert_sidl_array_NUM] = SIDLLanguage_Method__convert_sidl_array;
  ExternalAPI[SIDLLanguage_Method__destroy_sidl_array_NUM] = SIDLLanguage_Method__destroy_sidl_array;
  ExternalAPI[SIDLLanguage_Method__weakRef_NUM] = SIDLLanguage_Method__weakRef;
  ExternalAPI[SIDLLanguage_Method__deref_NUM] = SIDLLanguage_Method__deref;
  ExternalAPI[SIDLLanguage_Method__newRef_NUM] = SIDLLanguage_Method__newRef;
  ExternalAPI[SIDLLanguage_Method__addRef_NUM] = SIDLLanguage_Method__addRef;
  import_SIDLObjA();
  if (PyErr_Occurred()) {
    PyErr_SetString(PyExc_ImportError, "Cannot import SIDLObjA module");
    return;
  }
  c_api = PyCObject_FromVoidPtr((void *) ExternalAPI, NULL);
  PyDict_SetItemString(dict, (char *) "_C_API", c_api);
  Py_XDECREF(c_api);
  if (PyErr_Occurred()) {
    PyErr_SetString(PyExc_TypeError, "Cannot initialize Python module SIDLLanguage.Method");
    return;
  }
  import_SIDLPyArrays();
  if (PyErr_Occurred()) {
    PyErr_SetString(PyExc_ImportError, "Cannot import SIDLPyArrays module");
    return;
  }
  import_array();
  if (PyErr_Occurred()) {
    PyErr_SetString(PyExc_ImportError, "Cannot import Numeric Python array module");
    return;
  }
  SIDLLanguage_Type__import();
  SIDL_NullIORException__import();
  SIDL_BaseException__import();
  SIDLLanguage_Class__import();
  SIDLLanguage_Visitor__import();
  SIDLLanguage_ASTException__import();
  SIDLLanguage_AST__import();
  SIDLLanguage_Comment__import();
  SIDLLanguage_Code__import();
  SIDLLanguage_CodeGeneratorException__import();
  SIDLLanguage_Attribute__import();
  SIDL_BaseInterface__import();
}
