#define SIDLLanguage_Parser_INTERNAL 1

#include "SIDLObjA.h"
#include "SIDLPyArrays.h"
#include "Numeric/arrayobject.h"

#ifndef included_SIDLLanguage_Parser_stub
#include "SIDLLanguage/Parser_Module.h"
#endif
#ifndef included_SIDLLanguage_Parser_IOR
#include "SIDLLanguage/Parser_IOR/Parser_IOR.h"
#endif
//
// Includes for all method dependencies
//
#ifndef included_SIDL_Loader_IOR
#include "SIDL/Loader_IOR/Loader_IOR.h"
#endif
#ifndef included_SIDLLanguage_AST_stub
#include "SIDLLanguage/AST_Module.h"
#endif
#ifndef included_SIDLLanguage_ParserException_stub
#include "SIDLLanguage/ParserException_Module.h"
#endif
#ifndef included_SIDL_NullIORException_stub
#include "SIDL/NullIORException_Module.h"
#endif
#ifndef included_SIDL_BaseException_stub
#include "SIDL/BaseException_Module.h"
#endif
#ifndef included_SIDL_BaseInterface_stub
#include "SIDL/BaseInterface_Module.h"
#endif


static const struct SIDLLanguage_Parser__external * _epv = NULL;

static PyObject *
SIDLLanguage_Parser_parse(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Parser__object *_self_ior = ((struct SIDLLanguage_Parser__object *) SIDL_Cast(_self, "SIDLLanguage.Parser"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDLLanguage_AST__object * _result = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  char * buf;
  static char *_kwlist[] = {
    (char *) "buf",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "z", _kwlist,
    &buf
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for parse");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in parse()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_parse))(_self_ior->d_object  , /*in*/ buf, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDLLanguage_ParserException__object *_ex0;
    struct SIDL_BaseException__object *_ex1;
  
    if (!found && (_ex0 = (struct SIDLLanguage_ParserException__object *) SIDL_PyExceptionCast(_exception, "SIDLLanguage.ParserException"))) {
      PyObject *obj = SIDLLanguage_ParserException__wrap(_ex0);
  
      PyErr_SetObject(SIDLLanguage_ParserException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found && (_ex1 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex1);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "O&",
    (void *) SIDLLanguage_AST__wrap, _result
  );
  return _return_value;
}

static PyObject *
SIDLLanguage_Parser_parseFile(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Parser__object *_self_ior = ((struct SIDLLanguage_Parser__object *) SIDL_Cast(_self, "SIDLLanguage.Parser"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDLLanguage_AST__object * _result = NULL;
  struct SIDL_BaseException__object *_exception = 0;
  /* Pack arguments for dispatch to IOR */
  char * filename;
  static char *_kwlist[] = {
    (char *) "filename",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "z", _kwlist,
    &filename
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for parseFile");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in parseFile()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_parseFile))(_self_ior->d_object  , /*in*/ filename, &_exception);
  /* Exception handling cleanup */
  if (_exception != 0) {
    int found = 0;
    struct SIDLLanguage_ParserException__object *_ex0;
    struct SIDL_BaseException__object *_ex1;
  
    if (!found && (_ex0 = (struct SIDLLanguage_ParserException__object *) SIDL_PyExceptionCast(_exception, "SIDLLanguage.ParserException"))) {
      PyObject *obj = SIDLLanguage_ParserException__wrap(_ex0);
  
      PyErr_SetObject(SIDLLanguage_ParserException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found && (_ex1 = (struct SIDL_BaseException__object *) SIDL_PyExceptionCast(_exception, "SIDL.BaseException"))) {
      PyObject *obj = SIDL_BaseException__wrap(_ex1);
  
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(obj);
      found = 1;
    }
    if (!found) {
      PyObject *module  = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict = PyModule_GetDict(module);
      PyObject *obj     = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
  
      PyObject_CallMethod(obj, (char *) "setMessage", (char *) "s", (char *) "Invalid exception thrown by implementation");
      PyErr_SetObject(SIDL_BaseException__type, obj);
      Py_XDECREF(module);
    }
    return _return_value;
  }
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "O&",
    (void *) SIDLLanguage_AST__wrap, _result
  );
  return _return_value;
}

static PyObject *
SIDLLanguage_Parser_addReference(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Parser__object *_self_ior = ((struct SIDLLanguage_Parser__object *) SIDL_Cast(_self, "SIDLLanguage.Parser"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for addReference");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in addReference()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_addReference))(_self_ior->d_object  );
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
SIDLLanguage_Parser_deleteReference(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Parser__object *_self_ior = ((struct SIDLLanguage_Parser__object *) SIDL_Cast(_self, "SIDLLanguage.Parser"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  /* Pack arguments for dispatch to IOR */
  static char *_kwlist[] = {
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "", _kwlist
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for deleteReference");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in deleteReference()");
  }
  /* Dispatch to IOR */
  (*(_self_ior->d_epv->f_deleteReference))(_self_ior->d_object  );
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_None;
  Py_INCREF(_return_value);
  return _return_value;
}

static PyObject *
SIDLLanguage_Parser_isSame(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Parser__object *_self_ior = ((struct SIDLLanguage_Parser__object *) SIDL_Cast(_self, "SIDLLanguage.Parser"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  SIDL_bool _result;
  int _local__result;
  /* Pack arguments for dispatch to IOR */
  struct SIDL_BaseInterface__object * iobj = NULL;
  static char *_kwlist[] = {
    (char *) "iobj",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "O&", _kwlist,
    (void *) SIDL_BaseInterface__convert, &iobj
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for isSame");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in isSame()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_isSame))(_self_ior->d_object  , /*in*/ iobj);
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _local__result = (_result != FALSE);
  _return_value = Py_BuildValue(
     (char *) "i",
    _local__result
  );
  SIDL_BaseInterface__deref(iobj);
  return _return_value;
}

static PyObject *
SIDLLanguage_Parser_queryInterface(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Parser__object *_self_ior = ((struct SIDLLanguage_Parser__object *) SIDL_Cast(_self, "SIDLLanguage.Parser"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDL_BaseInterface__object * _result = NULL;
  /* Pack arguments for dispatch to IOR */
  char * name;
  static char *_kwlist[] = {
    (char *) "name",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "z", _kwlist,
    &name
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for queryInterface");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in queryInterface()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_queryInterface))(_self_ior->d_object  , /*in*/ name);
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "O&",
    (void *) SIDL_BaseInterface__wrap, _result
  );
  return _return_value;
}

static PyObject *
SIDLLanguage_Parser_isInstanceOf(
  PyObject *_self,
  PyObject *_args,
  PyObject *_kwdict
)
{
  struct SIDLLanguage_Parser__object *_self_ior = ((struct SIDLLanguage_Parser__object *) SIDL_Cast(_self, "SIDLLanguage.Parser"));
  /* Return value setup */
  PyObject *_return_value = NULL;
  SIDL_bool _result;
  int _local__result;
  /* Pack arguments for dispatch to IOR */
  char * name;
  static char *_kwlist[] = {
    (char *) "name",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "z", _kwlist,
    &name
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for isInstanceOf");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  if (_self_ior == 0) {
    PyErr_SetString(PyExc_TypeError, "Null IOR pointer in isInstanceOf()");
  }
  /* Dispatch to IOR */
  _result = (*(_self_ior->d_epv->f_isInstanceOf))(_self_ior->d_object  , /*in*/ name);
  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _local__result = (_result != FALSE);
  _return_value = Py_BuildValue(
     (char *) "i",
    _local__result
  );
  return _return_value;
}

static PyObject *
SIDLLanguage_Parser_Parser(
  PyObject *_ignored,
  PyObject *_args,
  PyObject *_kwdict
)
{
  /* Return value setup */
  PyObject *_return_value = NULL;
  struct SIDLLanguage_Parser__object * _result = NULL;
  /* Pack arguments for dispatch to IOR */
  struct SIDLLanguage_Parser__object * optarg = NULL;
  static char *_kwlist[] = {
    (char *) "optarg",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict,
    (char *) "|O&", _kwlist,
    (void *) SIDLLanguage_Parser__convert, &optarg
  );
  if (_okay == 0) {
    PyErr_SetString(PyExc_TypeError, "Could not parse arguments for Parser");
    return _return_value;
  }
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _return_value;
  }
  /* Exception handling setup */
  /* Implementation code */
  if (optarg) {
    (*(optarg->d_epv->f_addReference))(optarg->d_object);
  }
  /* Since we may merely up the reference count and return the argument, add an extra reference */
  SIDLLanguage_Parser__addRef(optarg);
  _result = optarg;  /* Exception handling cleanup */
  /* Unpack arguments from dispatch to IOR */
  /* Return value cleanup */
  _return_value = Py_BuildValue(
     (char *) "O&",
    (void *) SIDLLanguage_Parser__wrap, _result
  );
  SIDLLanguage_Parser__deref(optarg);
  return _return_value;
}

static PyMethodDef _ParserModuleMethods[] = {
  {(char *) "Parser", (PyCFunction) SIDLLanguage_Parser_Parser, (METH_VARARGS | METH_KEYWORDS), (char *) "Parser(in Parser optarg)\n\
RETURNS\n\
  SIDLLanguage.Parser _result\n\
Constructor and/or cast method for SIDLLanguage.Parser\n\
"},
  {NULL, NULL}
};

static PyMethodDef _ParserObjectMethods[] = {
  {(char *) "parse", (PyCFunction) SIDLLanguage_Parser_parse, (METH_VARARGS | METH_KEYWORDS), (char *) "parse(in string buf)\n\
RETURNS\n\
  SIDLLanguage.AST _result\n\
// Parse the SIDL and return an AST object\n\
"},
  {(char *) "parseFile", (PyCFunction) SIDLLanguage_Parser_parseFile, (METH_VARARGS | METH_KEYWORDS), (char *) "parseFile(in string filename)\n\
RETURNS\n\
  SIDLLanguage.AST _result\n\
// Parse the SIDL file and return an AST object\n\
"},
  {(char *) "addReference", (PyCFunction) SIDLLanguage_Parser_addReference, (METH_VARARGS | METH_KEYWORDS), (char *) "addReference()\n\
RETURNS\n\
   None\n\
// Add one to the intrinsic reference count in the underlying object.\n\
// Object in <code>SIDL</code> have an intrinsic reference count.\n\
// Objects continue to exist as long as the reference count is\n\
// positive. Clients should call this method whenever they\n\
// create another ongoing reference to an object or interface.\n\
// \n\
// This does not have a return value because there is no language\n\
// independent type that can refer to an interface or a\n\
// class.\n\
"},
  {(char *) "deleteReference", (PyCFunction) SIDLLanguage_Parser_deleteReference, (METH_VARARGS | METH_KEYWORDS), (char *) "deleteReference()\n\
RETURNS\n\
   None\n\
// Decrease by one the intrinsic reference count in the underlying\n\
// object, and delete the object if the reference is non-positive.\n\
// Objects in <code>SIDL</code> have an intrinsic reference count.\n\
// Clients should call this method whenever they remove a\n\
// reference to an object or interface.\n\
"},
  {(char *) "isSame", (PyCFunction) SIDLLanguage_Parser_isSame, (METH_VARARGS | METH_KEYWORDS), (char *) "isSame(in BaseInterface iobj)\n\
RETURNS\n\
  bool _result\n\
// Return true if and only if <code>obj</code> refers to the same\n\
// object as this object.\n\
"},
  {(char *) "queryInterface", (PyCFunction) SIDLLanguage_Parser_queryInterface, (METH_VARARGS | METH_KEYWORDS), (char *) "queryInterface(in string name)\n\
RETURNS\n\
  SIDL.BaseInterface _result\n\
// Check whether the object can support the specified interface or\n\
// class.  If the <code>SIDL</code> type name in <code>name</code>\n\
// is supported, then a reference to that object is returned with the\n\
// reference count incremented.  The callee will be responsible for\n\
// calling <code>deleteReference</code> on the returned object.  If\n\
// the specified type is not supported, then a null reference is\n\
// returned.\n\
"},
  {(char *) "isInstanceOf", (PyCFunction) SIDLLanguage_Parser_isInstanceOf, (METH_VARARGS | METH_KEYWORDS), (char *) "isInstanceOf(in string name)\n\
RETURNS\n\
  bool _result\n\
// Return whether this object is an instance of the specified type.\n\
// The string name must be the <code>SIDL</code> type name.  This\n\
// routine will return <code>true</code> if and only if a cast to\n\
// the string type name would succeed.\n\
"},
  {NULL, NULL}
};

SIDLLanguage_Parser__wrap_RETURN
SIDLLanguage_Parser__wrap SIDLLanguage_Parser__wrap_PROTO {
  if (!sidlobj) {
    return Py_None;
  } else {
    return SIDL_Object_Create(sidlobj->d_epv->f__cast_ior(sidlobj->d_object, "SIDLLanguage.Parser"), _ParserObjectMethods, SIDL_PyStealRef);
  }
}

SIDLLanguage_Parser__weakRef_RETURN
SIDLLanguage_Parser__weakRef SIDLLanguage_Parser__weakRef_PROTO {
  return SIDL_Object_Create(sidlobj->d_epv->f__cast_ior(sidlobj->d_object, "SIDLLanguage.Parser"), _ParserObjectMethods, SIDL_PyWeakRef);
}

SIDLLanguage_Parser__deref_RETURN
SIDLLanguage_Parser__deref SIDLLanguage_Parser__deref_PROTO {
  if (sidlobj) {
    (*(sidlobj->d_epv->f_deleteReference))(sidlobj->d_object);
  }
}

SIDLLanguage_Parser__newRef_RETURN
SIDLLanguage_Parser__newRef SIDLLanguage_Parser__newRef_PROTO {
  return SIDL_Object_Create(sidlobj->d_epv->f__cast_ior(sidlobj->d_object, "SIDLLanguage.Parser"), _ParserObjectMethods, SIDL_PyNewRef);
}

SIDLLanguage_Parser__addRef_RETURN
SIDLLanguage_Parser__addRef SIDLLanguage_Parser__addRef_PROTO {
  if (sidlobj) {
    (*(sidlobj->d_epv->f_addReference))(sidlobj->d_object);
  }
}

SIDLLanguage_Parser__convert_RETURN
SIDLLanguage_Parser__convert SIDLLanguage_Parser__convert_PROTO {
  *sidlobj = SIDL_Cast(obj, "SIDLLanguage.Parser");
  if (*sidlobj) {
    (*((*sidlobj)->d_epv->f_addReference))((*sidlobj)->d_object);
  } else if (obj != Py_None) {
    PyErr_SetString(PyExc_TypeError, "Argument is not of type SIDLLanguage.Parser");
    return 0;
  }
  return 1;
}

static int
_convertPython(void *sidlarray, const int *ind, PyObject *pyobj) {
  struct SIDLLanguage_Parser__object *sidlobj;

  if (SIDLLanguage_Parser__convert(pyobj, &sidlobj)) {
    (*_epv->setElement)((struct SIDLLanguage_Parser__array *) sidlarray, ind, sidlobj);
    return 0;
  }
  return 1;
}

SIDLLanguage_Parser__convert_python_array_RETURN
SIDLLanguage_Parser__convert_python_array SIDLLanguage_Parser__convert_python_array_PROTO {
  PyObject *pya    = PyArray_FromObject(obj, PyArray_OBJECT, 0, 0);
  int       result = 0;

  *sidlarray = NULL;
  if (pya) {
    if (PyArray_OBJECT == ((PyArrayObject *) pya)->descr->type_num) {
      int dimen, *lower, *upper, *stride;

      if (SIDL_array__extract_python_info(pya, &dimen, &lower, &upper, &stride)) {
        *sidlarray = (*_epv->createArray)(dimen, lower, upper);
        free(lower);
        free(upper);
        free(stride);
        result = SIDL_array__convert_python(pya, dimen, *sidlarray, _convertPython);
        if (*sidlarray && !result) {
          (*_epv->destroyArray)(*sidlarray);
          *sidlarray = NULL;
        }
      }
    }
    Py_DECREF(pya);
  }
  return result;
}

static int
_convertSIDL(void *sidlarray, const int *ind, PyObject **dest) {
  struct SIDLLanguage_Parser__object *sidlobj = (*_epv->getElement)((struct SIDLLanguage_Parser__array *) sidlarray, ind);

  *dest = SIDLLanguage_Parser__wrap(sidlobj);
  return (*dest == NULL);
}

SIDLLanguage_Parser__convert_sidl_array_RETURN
SIDLLanguage_Parser__convert_sidl_array SIDLLanguage_Parser__convert_sidl_array_PROTO {
  PyObject *pya = NULL;

  if (sidlarray) {
    const int dimen   = (*_epv->getDimen)(sidlarray);
    int      *lower   = (int *) malloc(dimen * sizeof(int));
    int      *upper   = (int *) malloc(dimen * sizeof(int));
    int      *numElem = (int *) malloc(dimen * sizeof(int));
    int       i;

    for(i = 0; i < dimen; i++) {
      lower[i]   = (*_epv->getLower)(sidlarray, i);
      upper[i]   = (*_epv->getUpper)(sidlarray, i);
      numElem[i] = upper[i] - lower[i] + 1;
    }
    pya = PyArray_FromDims(dimen, numElem, PyArray_OBJECT);;
    if (pya) {
      if (!SIDL_array__convert_sidl(pya, dimen, lower, upper, numElem, sidlarray, _convertSIDL)) {
        Py_DECREF(pya);
        pya = NULL;
      }
    }
    free(lower);
    free(upper);
    free(numElem);
  }
  return pya;
}

SIDLLanguage_Parser__destroy_sidl_array_RETURN
SIDLLanguage_Parser__destroy_sidl_array SIDLLanguage_Parser__destroy_sidl_array_PROTO {
  if (sidlarray) {
    (*_epv->destroyArray)(sidlarray);
  }
}

void initParser(void) {
  PyObject *module, *dict, *c_api;
  static void *ExternalAPI[SIDLLanguage_Parser__API_NUM];
  struct SIDLLanguage_Parser__external * (*_extFunc)(void) = NULL;
  module = Py_InitModule((char *) "Parser", _ParserModuleMethods);
  _extFunc = (struct SIDLLanguage_Parser__external * (*)(void)) SIDL_Loader__externals()->getStaticEPV()->f_lookupSymbol("SIDLLanguage_Parser__externals");
  if (_extFunc) {
    _epv = (*_extFunc)();
  }
  if (!_epv) {
    PyErr_SetString(PyExc_TypeError, "Cannot load SIDL implementation for SIDLLanguage.Parser");
    return;
  }
  dict = PyModule_GetDict(module);
  ExternalAPI[SIDLLanguage_Parser__wrap_NUM] = SIDLLanguage_Parser__wrap;
  ExternalAPI[SIDLLanguage_Parser__convert_NUM] = SIDLLanguage_Parser__convert;
  ExternalAPI[SIDLLanguage_Parser__convert_python_array_NUM] = SIDLLanguage_Parser__convert_python_array;
  ExternalAPI[SIDLLanguage_Parser__convert_sidl_array_NUM] = SIDLLanguage_Parser__convert_sidl_array;
  ExternalAPI[SIDLLanguage_Parser__destroy_sidl_array_NUM] = SIDLLanguage_Parser__destroy_sidl_array;
  ExternalAPI[SIDLLanguage_Parser__weakRef_NUM] = SIDLLanguage_Parser__weakRef;
  ExternalAPI[SIDLLanguage_Parser__deref_NUM] = SIDLLanguage_Parser__deref;
  ExternalAPI[SIDLLanguage_Parser__newRef_NUM] = SIDLLanguage_Parser__newRef;
  ExternalAPI[SIDLLanguage_Parser__addRef_NUM] = SIDLLanguage_Parser__addRef;
  import_SIDLObjA();
  if (PyErr_Occurred()) {
    PyErr_SetString(PyExc_ImportError, "Cannot import SIDLObjA module");
    return;
  }
  c_api = PyCObject_FromVoidPtr((void *) ExternalAPI, NULL);
  PyDict_SetItemString(dict, (char *) "_C_API", c_api);
  Py_XDECREF(c_api);
  if (PyErr_Occurred()) {
    PyErr_SetString(PyExc_TypeError, "Cannot initialize Python module SIDLLanguage.Parser");
    return;
  }
  import_SIDLPyArrays();
  if (PyErr_Occurred()) {
    PyErr_SetString(PyExc_ImportError, "Cannot import SIDLPyArrays module");
    return;
  }
  import_array();
  if (PyErr_Occurred()) {
    PyErr_SetString(PyExc_ImportError, "Cannot import Numeric Python array module");
    return;
  }
  SIDLLanguage_AST__import();
  SIDLLanguage_ParserException__import();
  SIDL_NullIORException__import();
  SIDL_BaseException__import();
  SIDL_BaseInterface__import();
}
