#ifndef included_ANL_SIDLCompilerI_Cartilage_IOR
#include "ANL/SIDLCompilerI/Cartilage_IOR/Cartilage_IOR.h"
#endif

/* Static variables for managing EPV initialization */
static int s_method_initialized = 0;

static struct ANL_SIDLCompilerI_Cartilage__epv s_new__anl_sidlcompileri_cartilage;

static struct ANL_SIDLCompilerI_CodePurpose__epv s_new__anl_sidlcompileri_codepurpose;
static struct ANL_SIDLCompilerI_CodePurpose__epv * s_old__anl_sidlcompileri_codepurpose;

static struct SIDL_BaseClass__epv  s_new__sidl_baseclass;
static struct SIDL_BaseClass__epv * s_old__sidl_baseclass;

static struct SIDL_BaseInterface__epv  s_new__sidl_baseinterface;
static struct SIDL_BaseInterface__epv * s_old__sidl_baseinterface;

static struct SIDLLanguage_CodePurpose__epv s_new__sidllanguage_codepurpose;
static struct SIDLLanguage_CodePurpose__epv * s_old__sidllanguage_codepurpose;

/* Declare EPV routines defined in the skeleton */
extern void ANL_SIDLCompilerI_Cartilage__set_epv(struct ANL_SIDLCompilerI_Cartilage__epv * epv);

/* CAST: dynamic type casting support */
static void *ANL_SIDLCompilerI_Cartilage__cast_ior(
  struct ANL_SIDLCompilerI_Cartilage__object *self,
  const char *name)
{
  void *cast = NULL;
  /* We are guaranteed here that the first member in any IOR is a BaseInterface object */
  struct ANL_SIDLCompilerI_Cartilage__object *s0 = ((struct SIDL_BaseInterface__object *) self)->d_object;
  struct ANL_SIDLCompilerI_CodePurpose__object *s1 = &s0->d_anl_sidlcompileri_codepurpose;
  struct SIDL_BaseClass__object *s2 = &s1->d_sidl_baseclass;

  if (!strcmp(name, "ANL.SIDLCompilerI.Cartilage")) {
    cast = (void *) s0;
  } else if (!strcmp(name, "ANL.SIDLCompilerI.CodePurpose")) {
    cast = (void *) s1;
  } else if (!strcmp(name, "SIDL.BaseClass")) {
    cast = (void *) s2;
  } else if (!strcmp(name, "SIDL.BaseInterface")) {
    cast = (void *) &s2->d_sidl_baseinterface;
  } else if (!strcmp(name, "SIDLLanguage.CodePurpose")) {
    cast = (void *) &s1->d_sidllanguage_codepurpose;
  }

  return cast;
}

/* DELETE: call destructor and free object memory */
static void ANL_SIDLCompilerI_Cartilage__delete(
  struct ANL_SIDLCompilerI_Cartilage__object *self)
{
  struct ANL_SIDLCompilerI_Cartilage__object * s0 = self->d_epv->f__cast_ior(self, "ANL.SIDLCompilerI.Cartilage");
  ANL_SIDLCompilerI_Cartilage__fini(s0);
  memset((void *) s0, 0, sizeof(struct ANL_SIDLCompilerI_Cartilage__object));
  free((void *) s0);
}

/* INIT_EPV: create method entry point vector (EPV) structure */
static void ANL_SIDLCompilerI_Cartilage__init_epv(
  struct ANL_SIDLCompilerI_Cartilage__object *self)
{
  struct ANL_SIDLCompilerI_Cartilage__object *s0 = self;
  struct ANL_SIDLCompilerI_CodePurpose__object *s1 = &s0->d_anl_sidlcompileri_codepurpose;
  struct SIDL_BaseClass__object *s2 = &s1->d_sidl_baseclass;

  struct ANL_SIDLCompilerI_Cartilage__epv * epv = &s_new__anl_sidlcompileri_cartilage;
  struct ANL_SIDLCompilerI_CodePurpose__epv * e0 = &s_new__anl_sidlcompileri_codepurpose;
  struct SIDL_BaseClass__epv * e1 = &s_new__sidl_baseclass;
  struct SIDL_BaseInterface__epv * e2 = &s_new__sidl_baseinterface;
  struct SIDLLanguage_CodePurpose__epv * e3 = &s_new__sidllanguage_codepurpose;

  s_old__sidl_baseinterface = s2->d_sidl_baseinterface.d_epv;
  s_old__sidl_baseclass = s2->d_epv;
  s_old__sidllanguage_codepurpose = s1->d_sidllanguage_codepurpose.d_epv;
  s_old__anl_sidlcompileri_codepurpose = s1->d_epv;

  epv->f__cast_ior = ANL_SIDLCompilerI_Cartilage__cast_ior;
  epv->f__delete = ANL_SIDLCompilerI_Cartilage__delete;
  epv->f__ctor = NULL;
  epv->f__dtor = NULL;
  epv->f_addReference = (void (*)(struct ANL_SIDLCompilerI_Cartilage__object *)) s1->d_epv->f_addReference;
  epv->f_deleteReference = (void (*)(struct ANL_SIDLCompilerI_Cartilage__object *)) s1->d_epv->f_deleteReference;
  epv->f_isSame = (SIDL_bool (*)(struct ANL_SIDLCompilerI_Cartilage__object *, struct SIDL_BaseInterface__object *)) s1->d_epv->f_isSame;
  epv->f_queryInterface = (struct SIDL_BaseInterface__object * (*)(struct ANL_SIDLCompilerI_Cartilage__object *, const char *)) s1->d_epv->f_queryInterface;
  epv->f_isInstanceOf = (SIDL_bool (*)(struct ANL_SIDLCompilerI_Cartilage__object *, const char *)) s1->d_epv->f_isInstanceOf;
  epv->f_getName = (char * (*)(struct ANL_SIDLCompilerI_Cartilage__object *, struct SIDL_BaseException__object **)) s1->d_epv->f_getName;
  epv->f_setName = (void (*)(struct ANL_SIDLCompilerI_Cartilage__object *, const char *, struct SIDL_BaseException__object **)) s1->d_epv->f_setName;
  epv->f_getPathExtension = (char * (*)(struct ANL_SIDLCompilerI_Cartilage__object *, struct SIDL_BaseException__object **)) s1->d_epv->f_getPathExtension;
  epv->f_setPathExtension = (void (*)(struct ANL_SIDLCompilerI_Cartilage__object *, const char *, struct SIDL_BaseException__object **)) s1->d_epv->f_setPathExtension;
  epv->f_getEmbedded = (SIDL_bool (*)(struct ANL_SIDLCompilerI_Cartilage__object *, struct SIDL_BaseException__object **)) s1->d_epv->f_getEmbedded;
  epv->f_setEmbedded = (void (*)(struct ANL_SIDLCompilerI_Cartilage__object *, SIDL_bool, struct SIDL_BaseException__object **)) s1->d_epv->f_setEmbedded;
  epv->f_getUseSplicer = (SIDL_bool (*)(struct ANL_SIDLCompilerI_Cartilage__object *, struct SIDL_BaseException__object **)) s1->d_epv->f_getUseSplicer;
  epv->f_setUseSplicer = (void (*)(struct ANL_SIDLCompilerI_Cartilage__object *, SIDL_bool, struct SIDL_BaseException__object **)) s1->d_epv->f_setUseSplicer;
  epv->f_getGenerateMethods = (SIDL_bool (*)(struct ANL_SIDLCompilerI_Cartilage__object *, struct SIDL_BaseException__object **)) s1->d_epv->f_getGenerateMethods;
  epv->f_setGenerateMethods = (void (*)(struct ANL_SIDLCompilerI_Cartilage__object *, SIDL_bool, struct SIDL_BaseException__object **)) s1->d_epv->f_setGenerateMethods;
  epv->f_getCheckIOR = (SIDL_bool (*)(struct ANL_SIDLCompilerI_Cartilage__object *, struct SIDL_BaseException__object **)) s1->d_epv->f_getCheckIOR;
  epv->f_setCheckIOR = (void (*)(struct ANL_SIDLCompilerI_Cartilage__object *, SIDL_bool, struct SIDL_BaseException__object **)) s1->d_epv->f_setCheckIOR;
  epv->f_getUseSelf = (SIDL_bool (*)(struct ANL_SIDLCompilerI_Cartilage__object *, struct SIDL_BaseException__object **)) s1->d_epv->f_getUseSelf;
  epv->f_setUseSelf = (void (*)(struct ANL_SIDLCompilerI_Cartilage__object *, SIDL_bool, struct SIDL_BaseException__object **)) s1->d_epv->f_setUseSelf;
  epv->f_getEmulateExceptions = (SIDL_bool (*)(struct ANL_SIDLCompilerI_Cartilage__object *, struct SIDL_BaseException__object **)) s1->d_epv->f_getEmulateExceptions;
  epv->f_setEmulateExceptions = (void (*)(struct ANL_SIDLCompilerI_Cartilage__object *, SIDL_bool, struct SIDL_BaseException__object **)) s1->d_epv->f_setEmulateExceptions;
  epv->f_getIORDispatch = (SIDL_bool (*)(struct ANL_SIDLCompilerI_Cartilage__object *, struct SIDL_BaseException__object **)) s1->d_epv->f_getIORDispatch;
  epv->f_setIORDispatch = (void (*)(struct ANL_SIDLCompilerI_Cartilage__object *, SIDL_bool, struct SIDL_BaseException__object **)) s1->d_epv->f_setIORDispatch;

  ANL_SIDLCompilerI_Cartilage__set_epv(epv);

  e0->f__cast_ior = (void *(*)(struct ANL_SIDLCompilerI_CodePurpose__object *, const char *)) epv->f__cast_ior;
  e0->f__delete = (void (*)(struct ANL_SIDLCompilerI_CodePurpose__object *)) epv->f__delete;
  e0->f_addReference = (void (*)(struct ANL_SIDLCompilerI_CodePurpose__object *)) epv->f_addReference;
  e0->f_deleteReference = (void (*)(struct ANL_SIDLCompilerI_CodePurpose__object *)) epv->f_deleteReference;
  e0->f_isSame = (SIDL_bool (*)(struct ANL_SIDLCompilerI_CodePurpose__object *, struct SIDL_BaseInterface__object *)) epv->f_isSame;
  e0->f_queryInterface = (struct SIDL_BaseInterface__object * (*)(struct ANL_SIDLCompilerI_CodePurpose__object *, const char *)) epv->f_queryInterface;
  e0->f_isInstanceOf = (SIDL_bool (*)(struct ANL_SIDLCompilerI_CodePurpose__object *, const char *)) epv->f_isInstanceOf;
  e0->f_getName = (char * (*)(struct ANL_SIDLCompilerI_CodePurpose__object *, struct SIDL_BaseException__object **)) epv->f_getName;
  e0->f_setName = (void (*)(struct ANL_SIDLCompilerI_CodePurpose__object *, const char *, struct SIDL_BaseException__object **)) epv->f_setName;
  e0->f_getPathExtension = (char * (*)(struct ANL_SIDLCompilerI_CodePurpose__object *, struct SIDL_BaseException__object **)) epv->f_getPathExtension;
  e0->f_setPathExtension = (void (*)(struct ANL_SIDLCompilerI_CodePurpose__object *, const char *, struct SIDL_BaseException__object **)) epv->f_setPathExtension;
  e0->f_getEmbedded = (SIDL_bool (*)(struct ANL_SIDLCompilerI_CodePurpose__object *, struct SIDL_BaseException__object **)) epv->f_getEmbedded;
  e0->f_setEmbedded = (void (*)(struct ANL_SIDLCompilerI_CodePurpose__object *, SIDL_bool, struct SIDL_BaseException__object **)) epv->f_setEmbedded;
  e0->f_getUseSplicer = (SIDL_bool (*)(struct ANL_SIDLCompilerI_CodePurpose__object *, struct SIDL_BaseException__object **)) epv->f_getUseSplicer;
  e0->f_setUseSplicer = (void (*)(struct ANL_SIDLCompilerI_CodePurpose__object *, SIDL_bool, struct SIDL_BaseException__object **)) epv->f_setUseSplicer;
  e0->f_getGenerateMethods = (SIDL_bool (*)(struct ANL_SIDLCompilerI_CodePurpose__object *, struct SIDL_BaseException__object **)) epv->f_getGenerateMethods;
  e0->f_setGenerateMethods = (void (*)(struct ANL_SIDLCompilerI_CodePurpose__object *, SIDL_bool, struct SIDL_BaseException__object **)) epv->f_setGenerateMethods;
  e0->f_getCheckIOR = (SIDL_bool (*)(struct ANL_SIDLCompilerI_CodePurpose__object *, struct SIDL_BaseException__object **)) epv->f_getCheckIOR;
  e0->f_setCheckIOR = (void (*)(struct ANL_SIDLCompilerI_CodePurpose__object *, SIDL_bool, struct SIDL_BaseException__object **)) epv->f_setCheckIOR;
  e0->f_getUseSelf = (SIDL_bool (*)(struct ANL_SIDLCompilerI_CodePurpose__object *, struct SIDL_BaseException__object **)) epv->f_getUseSelf;
  e0->f_setUseSelf = (void (*)(struct ANL_SIDLCompilerI_CodePurpose__object *, SIDL_bool, struct SIDL_BaseException__object **)) epv->f_setUseSelf;
  e0->f_getEmulateExceptions = (SIDL_bool (*)(struct ANL_SIDLCompilerI_CodePurpose__object *, struct SIDL_BaseException__object **)) epv->f_getEmulateExceptions;
  e0->f_setEmulateExceptions = (void (*)(struct ANL_SIDLCompilerI_CodePurpose__object *, SIDL_bool, struct SIDL_BaseException__object **)) epv->f_setEmulateExceptions;
  e0->f_getIORDispatch = (SIDL_bool (*)(struct ANL_SIDLCompilerI_CodePurpose__object *, struct SIDL_BaseException__object **)) epv->f_getIORDispatch;
  e0->f_setIORDispatch = (void (*)(struct ANL_SIDLCompilerI_CodePurpose__object *, SIDL_bool, struct SIDL_BaseException__object **)) epv->f_setIORDispatch;

  e1->f__cast_ior = (void *(*)(struct SIDL_BaseClass__object *, const char *)) epv->f__cast_ior;
  e1->f__delete = (void (*)(struct SIDL_BaseClass__object *)) epv->f__delete;
  e1->f_addReference = (void (*)(struct SIDL_BaseClass__object *)) epv->f_addReference;
  e1->f_deleteReference = (void (*)(struct SIDL_BaseClass__object *)) epv->f_deleteReference;
  e1->f_isSame = (SIDL_bool (*)(struct SIDL_BaseClass__object *, struct SIDL_BaseInterface__object *)) epv->f_isSame;
  e1->f_queryInterface = (struct SIDL_BaseInterface__object * (*)(struct SIDL_BaseClass__object *, const char *)) epv->f_queryInterface;
  e1->f_isInstanceOf = (SIDL_bool (*)(struct SIDL_BaseClass__object *, const char *)) epv->f_isInstanceOf;

  e2->f__cast_ior = (void *(*)(void *, const char *)) epv->f__cast_ior;
  e2->f__delete = (void (*)(void *)) epv->f__delete;
  e2->f_addReference = (void (*)(void *)) epv->f_addReference;
  e2->f_deleteReference = (void (*)(void *)) epv->f_deleteReference;
  e2->f_isSame = (SIDL_bool (*)(void *, struct SIDL_BaseInterface__object *)) epv->f_isSame;
  e2->f_queryInterface = (struct SIDL_BaseInterface__object * (*)(void *, const char *)) epv->f_queryInterface;
  e2->f_isInstanceOf = (SIDL_bool (*)(void *, const char *)) epv->f_isInstanceOf;

  e3->f__cast_ior = (void *(*)(void *, const char *)) epv->f__cast_ior;
  e3->f__delete = (void (*)(void *)) epv->f__delete;
  e3->f_getName = (char * (*)(void *, struct SIDL_BaseException__object **)) epv->f_getName;
  e3->f_setName = (void (*)(void *, const char *, struct SIDL_BaseException__object **)) epv->f_setName;
  e3->f_getPathExtension = (char * (*)(void *, struct SIDL_BaseException__object **)) epv->f_getPathExtension;
  e3->f_setPathExtension = (void (*)(void *, const char *, struct SIDL_BaseException__object **)) epv->f_setPathExtension;
  e3->f_getEmbedded = (SIDL_bool (*)(void *, struct SIDL_BaseException__object **)) epv->f_getEmbedded;
  e3->f_setEmbedded = (void (*)(void *, SIDL_bool, struct SIDL_BaseException__object **)) epv->f_setEmbedded;
  e3->f_getUseSplicer = (SIDL_bool (*)(void *, struct SIDL_BaseException__object **)) epv->f_getUseSplicer;
  e3->f_setUseSplicer = (void (*)(void *, SIDL_bool, struct SIDL_BaseException__object **)) epv->f_setUseSplicer;
  e3->f_getGenerateMethods = (SIDL_bool (*)(void *, struct SIDL_BaseException__object **)) epv->f_getGenerateMethods;
  e3->f_setGenerateMethods = (void (*)(void *, SIDL_bool, struct SIDL_BaseException__object **)) epv->f_setGenerateMethods;
  e3->f_getCheckIOR = (SIDL_bool (*)(void *, struct SIDL_BaseException__object **)) epv->f_getCheckIOR;
  e3->f_setCheckIOR = (void (*)(void *, SIDL_bool, struct SIDL_BaseException__object **)) epv->f_setCheckIOR;
  e3->f_getUseSelf = (SIDL_bool (*)(void *, struct SIDL_BaseException__object **)) epv->f_getUseSelf;
  e3->f_setUseSelf = (void (*)(void *, SIDL_bool, struct SIDL_BaseException__object **)) epv->f_setUseSelf;
  e3->f_getEmulateExceptions = (SIDL_bool (*)(void *, struct SIDL_BaseException__object **)) epv->f_getEmulateExceptions;
  e3->f_setEmulateExceptions = (void (*)(void *, SIDL_bool, struct SIDL_BaseException__object **)) epv->f_setEmulateExceptions;
  e3->f_getIORDispatch = (SIDL_bool (*)(void *, struct SIDL_BaseException__object **)) epv->f_getIORDispatch;
  e3->f_setIORDispatch = (void (*)(void *, SIDL_bool, struct SIDL_BaseException__object **)) epv->f_setIORDispatch;
  e3->f_addReference = (void (*)(void *)) epv->f_addReference;
  e3->f_deleteReference = (void (*)(void *)) epv->f_deleteReference;
  e3->f_isSame = (SIDL_bool (*)(void *, struct SIDL_BaseInterface__object *)) epv->f_isSame;
  e3->f_queryInterface = (struct SIDL_BaseInterface__object * (*)(void *, const char *)) epv->f_queryInterface;
  e3->f_isInstanceOf = (SIDL_bool (*)(void *, const char *)) epv->f_isInstanceOf;

  s_method_initialized = 1;
}

/* NEW: allocate object and initialize it */
struct ANL_SIDLCompilerI_Cartilage__object *ANL_SIDLCompilerI_Cartilage__new()
{
  struct ANL_SIDLCompilerI_Cartilage__object *self = (struct ANL_SIDLCompilerI_Cartilage__object *) malloc(sizeof(struct ANL_SIDLCompilerI_Cartilage__object));
  ANL_SIDLCompilerI_Cartilage__init(self);
  return self;
}

/* INIT: initialize a new instance of the class object */
void ANL_SIDLCompilerI_Cartilage__init(
  struct ANL_SIDLCompilerI_Cartilage__object *self)
{
  struct ANL_SIDLCompilerI_Cartilage__object *s0 = self;
  struct ANL_SIDLCompilerI_CodePurpose__object *s1 = &s0->d_anl_sidlcompileri_codepurpose;
  struct SIDL_BaseClass__object *s2 = &s1->d_sidl_baseclass;

#if 0
  ANL_SIDLCompilerI_CodePurpose__init(s1);
#else
  void (*dll_f)(struct ANL_SIDLCompilerI_CodePurpose__object *) = (void (*)(struct ANL_SIDLCompilerI_CodePurpose__object *)) SIDL_Loader__externals()->getStaticEPV()->f_lookupSymbol("ANL_SIDLCompilerI_CodePurpose__init");

  if (!dll_f) {
    fputs("Unable to find initializer for ANL.SIDLCompilerI.CodePurpose; add to SIDL_DLL_PATH\n", stderr);
    exit(1);
  } else {
    (*dll_f)(s1);
  }
#endif

  if (!s_method_initialized) {
    ANL_SIDLCompilerI_Cartilage__init_epv(s0);
  }

  /* Setup d_epv members */
  s2->d_sidl_baseinterface.d_epv = &s_new__sidl_baseinterface;
  s2->d_epv = &s_new__sidl_baseclass;

  s1->d_sidllanguage_codepurpose.d_epv = &s_new__sidllanguage_codepurpose;
  s1->d_epv = &s_new__anl_sidlcompileri_codepurpose;

  s0->d_epv = &s_new__anl_sidlcompileri_cartilage;

  /* Setup d_object members */
  s2->d_sidl_baseinterface.d_object = self;
  s2->d_object = self;
  s1->d_sidllanguage_codepurpose.d_object = self;
  s1->d_object = self;
  s0->d_object = self;

  /* Setup d_data members */
  s0->d_data = NULL;
  (*(self->d_epv->f__ctor))(self);
}

/* FINI: deallocate a class instance (destructor) */
void ANL_SIDLCompilerI_Cartilage__fini(
  struct ANL_SIDLCompilerI_Cartilage__object *self)
{
  struct ANL_SIDLCompilerI_Cartilage__object *s0 = self;
  struct ANL_SIDLCompilerI_CodePurpose__object *s1 = &s0->d_anl_sidlcompileri_codepurpose;
  struct SIDL_BaseClass__object *s2 = &s1->d_sidl_baseclass;
#if 1
  void (*dll_f)(struct ANL_SIDLCompilerI_CodePurpose__object *) = (void (*)(struct ANL_SIDLCompilerI_CodePurpose__object *)) SIDL_Loader__externals()->getStaticEPV()->f_lookupSymbol("ANL_SIDLCompilerI_CodePurpose__fini");
#endif

  (*(self->d_epv->f__dtor))(self);

  /* Setup d_epv members */
  s2->d_sidl_baseinterface.d_epv = s_old__sidl_baseinterface;
  s2->d_epv = s_old__sidl_baseclass;

  s1->d_sidllanguage_codepurpose.d_epv = s_old__sidllanguage_codepurpose;
  s1->d_epv = s_old__anl_sidlcompileri_codepurpose;

#if 0
  ANL_SIDLCompilerI_CodePurpose__fini(s1);
#else
  if (!dll_f) {
    fputs("Unable to find finializer for ANL.SIDLCompilerI.CodePurpose; add to SIDL_DLL_PATH\n", stderr);
    exit(1);
  } else {
    (*dll_f)(s1);
  }
#endif
}

/* The IOR array structure */
/*   Macros to read this are defined in SIDLArray.h */
struct ANL_SIDLCompilerI_Cartilage__array {
  struct ANL_SIDLCompilerI_Cartilage__object ** d_firstElement;
  int32_t *d_lower;
  int32_t *d_upper;
  int32_t *d_stride;
  SIDL_bool d_borrowed;
  int32_t d_dimen;
};

static struct ANL_SIDLCompilerI_Cartilage__array *newArray(int32_t dimen, const int32_t lower[], const int32_t upper[]) {
  static const size_t arraySize = sizeof(struct ANL_SIDLCompilerI_Cartilage__array) + (sizeof(int32_t) - (sizeof(struct ANL_SIDLCompilerI_Cartilage__array)%sizeof(int32_t)))%sizeof(int32_t);
  struct ANL_SIDLCompilerI_Cartilage__array *result = (struct ANL_SIDLCompilerI_Cartilage__array *) malloc(arraySize + 3*sizeof(int32_t)*dimen);

  result->d_dimen    = dimen;
  result->d_borrowed = 0;
  result->d_lower    = (int32_t *) ((char *) result + arraySize);
  result->d_upper    = result->d_lower + dimen;
  result->d_stride   = result->d_upper + dimen;
  memcpy(result->d_lower, lower, sizeof(int32_t)*dimen);
  memcpy(result->d_upper, upper, sizeof(int32_t)*dimen);
  return result;
}

/* Create a dense array of the given dimension with specified index bounds */
/*   This array owns and manages its data */
/*   All object pointers are initialized to NULL */
struct ANL_SIDLCompilerI_Cartilage__array * ANL_SIDLCompilerI_Cartilage__iorarray_create(
  int32_t dimen,
  const int32_t lower[],
  const int32_t upper[])
{
  struct ANL_SIDLCompilerI_Cartilage__array *result = newArray(dimen, lower, upper);
  int32_t size;
  int32_t i;

  for(i = 0, size = 1; i < dimen; i++) {
    result->d_stride[i] = size;
    size *= (upper[i] - lower[i] + 1);
  }
  size *= sizeof(struct ANL_SIDLCompilerI_Cartilage__object *);
  result->d_firstElement = (struct ANL_SIDLCompilerI_Cartilage__object **) malloc((size_t) size);
  memset(result->d_firstElement, 0, (size_t) size);
  return result;
}

/* Create an array using user-provided memory */
struct ANL_SIDLCompilerI_Cartilage__array * ANL_SIDLCompilerI_Cartilage__iorarray_borrow(
  struct ANL_SIDLCompilerI_Cartilage__object ** firstElement,
  int32_t dimen,
  const int32_t lower[],
  const int32_t upper[],
  const int32_t stride[])
{
  struct ANL_SIDLCompilerI_Cartilage__array *result = newArray(dimen, lower, upper);

  memcpy(result->d_stride, stride, sizeof(int32_t)*dimen);
  result->d_firstElement = firstElement;
  result->d_borrowed     = 1;
  return result;
}

/* Destroy the array (NULL arrays are ignored) */
void ANL_SIDLCompilerI_Cartilage__iorarray_destroy(
  struct ANL_SIDLCompilerI_Cartilage__array *array)
{
  if (array) {
    const int32_t dimen = array->d_dimen;

    if (!(array->d_borrowed)) {
      if (dimen > 0) {
        struct ANL_SIDLCompilerI_Cartilage__object **start = array->d_firstElement;
        struct ANL_SIDLCompilerI_Cartilage__object **end;
        int32_t size = 1;

        if (dimen > 1) {
          size = array->d_stride[dimen-1];
        }
        size *= (array->d_upper[dimen-1] - array->d_lower[dimen-1] + 1);
        end   = start + size;
        while(start < end) {
          if (*start) {
            (*(((struct SIDL_BaseClass__object *) (*start)->d_object)->d_epv->f_deleteReference))((*start)->d_object);
            *start = NULL;
          }
          ++start;
        }
      }
      free(array->d_firstElement);
    }
    memset(array, 0, sizeof(struct ANL_SIDLCompilerI_Cartilage__array) + 3*sizeof(int32_t)*dimen);
    free(array);
  }
}

/* Return the number of dimensions in the array */
/*   If the array pointer is NULL, zero is returned */
int32_t ANL_SIDLCompilerI_Cartilage__iorarray_dimen(
  const struct ANL_SIDLCompilerI_Cartilage__array *array)
{
  return array ? array->d_dimen : 0;
}

/* Return the lower bound on dimension ind */
/*   If the array pointer is NULL or ind is not a valid dimension, zero is returned */
int32_t ANL_SIDLCompilerI_Cartilage__iorarray_lower(
  const struct ANL_SIDLCompilerI_Cartilage__array *array,
  int32_t ind)
{
  return (array && (ind < array->d_dimen) && (ind >= 0)) ? array->d_lower[ind] : 0;
}

/* Return the upper bound on dimension ind */
/*   If the array pointer is NULL or ind is not a valid dimension, -1 is returned */
int32_t ANL_SIDLCompilerI_Cartilage__iorarray_upper(
  const struct ANL_SIDLCompilerI_Cartilage__array *array,
  int32_t ind)
{
  return (array && (ind < array->d_dimen) && (ind >= 0)) ? array->d_upper[ind] : -1;
}

/* Get an element of a multi-dimensional array */
/* This will use the indices provided up to the actual dimension of the array, ignoring extra indices */
/* If the return value is non-NULL, the client owns one reference to the object/interface */
/* The client must decrement the reference count when done with the reference */
struct ANL_SIDLCompilerI_Cartilage__object * ANL_SIDLCompilerI_Cartilage__iorarray_get(
  const struct ANL_SIDLCompilerI_Cartilage__array *array,
  const int32_t indices[])
{
  struct ANL_SIDLCompilerI_Cartilage__object **result = NULL;
  if (array && (array->d_dimen > 0)) {
    int32_t i;

    result = array->d_firstElement;
    for(i = 0; i < array->d_dimen; i++) {
      if ((indices[i] >= array->d_lower[i]) && (indices[i] <= array->d_upper[i])) {
        result += (array->d_stride[i]*(indices[i] - array->d_lower[i]));
      } else {
        result = NULL;
        break;
      }
    }
  }
  if (result) {
    if (*result) {
      (*(((struct SIDL_BaseClass__object *) (*result)->d_object)->d_epv->f_addReference))((*result)->d_object);
    }
    return *result;
  } else {
    return NULL;
  }
}

/* get an element of a multi-dimensional array */
/* This will use the indices provided up to the actual dimension of the array, ignoring extra indices */
/* If the return value is non-NULL, the client owns one reference to the object/interface */
/* The client must decrement the reference count when done with the reference */
struct ANL_SIDLCompilerI_Cartilage__object * ANL_SIDLCompilerI_Cartilage__iorarray_get4(
  const struct ANL_SIDLCompilerI_Cartilage__array *array,
  int32_t i1,
  int32_t i2,
  int32_t i3,
  int32_t i4)
{
  struct ANL_SIDLCompilerI_Cartilage__object **result = NULL;
  if (array) {
    result = array->d_firstElement;
    switch(array->d_dimen) {
    case 4:
      if ((i4 >= array->d_lower[3]) && (i4 <= array->d_upper[3])) {
        result += (array->d_stride[3]*(i4 - array->d_lower[3]));
      } else {
        result = NULL;
        break;
      }
      /* fall through */
    case 3:
      if ((i3 >= array->d_lower[2]) && (i3 <= array->d_upper[2])) {
        result += (array->d_stride[2]*(i3 - array->d_lower[2]));
      } else {
        result = NULL;
        break;
      }
      /* fall through */
    case 2:
      if ((i2 >= array->d_lower[1]) && (i2 <= array->d_upper[1])) {
        result += (array->d_stride[1]*(i2 - array->d_lower[1]));
      } else {
        result = NULL;
        break;
      }
      /* fall through */
    case 1:
      if ((i1 >= array->d_lower[0]) && (i1 <= array->d_upper[0])) {
        result += (array->d_stride[0]*(i1 - array->d_lower[0]));
      } else {
        result = NULL;
        break;
      }
      break;
    default:
      result = NULL;
      break;
    }
  }
  if (result) {
    if (*result) {
      (*(((struct SIDL_BaseClass__object *) (*result)->d_object)->d_epv->f_addReference))((*result)->d_object);
    }
    return *result;
  } else {
    return NULL;
  }
}

/* Set an element of a multi-dimensional array */
/* This will use the indices provided up to the actual dimension of the array, ignoring extra indices */
/* If the incoming value is non-NULL, this function will increment the reference code of the object/interface */
/* If it is overwriting a non-NULL pointer, the reference count of the object/interface being overwritten will be decremented */
void ANL_SIDLCompilerI_Cartilage__iorarray_set(
  struct ANL_SIDLCompilerI_Cartilage__array *array,
  const int32_t indices[],
  struct ANL_SIDLCompilerI_Cartilage__object * value)
{
  struct ANL_SIDLCompilerI_Cartilage__object **result = NULL;
  if (array && (array->d_dimen > 0)) {
    int32_t i;

    result = array->d_firstElement;
    for(i = 0; i < array->d_dimen; i++) {
      if ((indices[i] >= array->d_lower[i]) && (indices[i] <= array->d_upper[i])) {
        result += (array->d_stride[i]*(indices[i] - array->d_lower[i]));
      } else {
        result = NULL;
        break;
      }
    }
    if (result) {
      if (value) {
        (*(((struct SIDL_BaseClass__object *) value->d_object)->d_epv->f_addReference))(value->d_object);
      }
      if (*result) {
        (*(((struct SIDL_BaseClass__object *) (*result)->d_object)->d_epv->f_deleteReference))((*result)->d_object);
      }
      *result = value;
    }
  }
}

/* set an element of a multi-dimensional array */
/* This will use the indices provided up to the actual dimension of the array, ignoring extra indices */
/* If the incoming value is non-NULL, this function will increment the reference code of the object/interface */
/* If it is overwriting a non-NULL pointer, the reference count of the object/interface being overwritten will be decremented */
void ANL_SIDLCompilerI_Cartilage__iorarray_set4(
  struct ANL_SIDLCompilerI_Cartilage__array *array,
  int32_t i1,
  int32_t i2,
  int32_t i3,
  int32_t i4,
  struct ANL_SIDLCompilerI_Cartilage__object * value)
{
  struct ANL_SIDLCompilerI_Cartilage__object **result = NULL;
  if (array) {
    result = array->d_firstElement;
    switch(array->d_dimen) {
    case 4:
      if ((i4 >= array->d_lower[3]) && (i4 <= array->d_upper[3])) {
        result += (array->d_stride[3]*(i4 - array->d_lower[3]));
      } else {
        result = NULL;
        break;
      }
      /* fall through */
    case 3:
      if ((i3 >= array->d_lower[2]) && (i3 <= array->d_upper[2])) {
        result += (array->d_stride[2]*(i3 - array->d_lower[2]));
      } else {
        result = NULL;
        break;
      }
      /* fall through */
    case 2:
      if ((i2 >= array->d_lower[1]) && (i2 <= array->d_upper[1])) {
        result += (array->d_stride[1]*(i2 - array->d_lower[1]));
      } else {
        result = NULL;
        break;
      }
      /* fall through */
    case 1:
      if ((i1 >= array->d_lower[0]) && (i1 <= array->d_upper[0])) {
        result += (array->d_stride[0]*(i1 - array->d_lower[0]));
      } else {
        result = NULL;
        break;
      }
      break;
    default:
      result = NULL;
      break;
    }
  }
  if (result) {
    if (value) {
      (*(((struct SIDL_BaseClass__object *) value->d_object)->d_epv->f_addReference))(value->d_object);
    }
    if (*result) {
      (*(((struct SIDL_BaseClass__object *) (*result)->d_object)->d_epv->f_deleteReference))((*result)->d_object);
    }
    *result = value;
  }
}

static const struct ANL_SIDLCompilerI_Cartilage__external s_externalEntryPoints = {
  ANL_SIDLCompilerI_Cartilage__new,
  NULL /*ANL_SIDLCompilerI_Cartilage__remote*/,
  ANL_SIDLCompilerI_Cartilage__iorarray_create,
  ANL_SIDLCompilerI_Cartilage__iorarray_borrow,
  ANL_SIDLCompilerI_Cartilage__iorarray_destroy,
  ANL_SIDLCompilerI_Cartilage__iorarray_dimen,
  ANL_SIDLCompilerI_Cartilage__iorarray_lower,
  ANL_SIDLCompilerI_Cartilage__iorarray_upper,
  ANL_SIDLCompilerI_Cartilage__iorarray_get,
  ANL_SIDLCompilerI_Cartilage__iorarray_get4,
  ANL_SIDLCompilerI_Cartilage__iorarray_set,
  ANL_SIDLCompilerI_Cartilage__iorarray_set4
};

/* This function returns a pointer to a static structure of pointers to function entry points */
/* It is called upon loading the DLL */
const struct ANL_SIDLCompilerI_Cartilage__external *ANL_SIDLCompilerI_Cartilage__externals()
{
  return &s_externalEntryPoints;
}
