#ifndef included_ANL_SIDLCompilerI_Enumeration_IOR
#include "ANL/SIDLCompilerI/Enumeration_IOR/Enumeration_IOR.h"
#endif

/* Static variables for managing EPV initialization */
static int s_method_initialized = 0;

static struct ANL_SIDLCompilerI_Enumeration__epv s_new__anl_sidlcompileri_enumeration;

static struct ANL_SIDLCompilerI_Type__epv s_new__anl_sidlcompileri_type;
static struct ANL_SIDLCompilerI_Type__epv * s_old__anl_sidlcompileri_type;

static struct ANL_SIDLCompilerI_AST__epv  s_new__anl_sidlcompileri_ast;
static struct ANL_SIDLCompilerI_AST__epv * s_old__anl_sidlcompileri_ast;

static struct SIDL_BaseClass__epv  s_new__sidl_baseclass;
static struct SIDL_BaseClass__epv * s_old__sidl_baseclass;

static struct SIDL_BaseInterface__epv  s_new__sidl_baseinterface;
static struct SIDL_BaseInterface__epv * s_old__sidl_baseinterface;

static struct SIDLLanguage_AST__epv  s_new__sidllanguage_ast;
static struct SIDLLanguage_AST__epv * s_old__sidllanguage_ast;

static struct SIDLLanguage_Type__epv s_new__sidllanguage_type;
static struct SIDLLanguage_Type__epv * s_old__sidllanguage_type;

static struct SIDLLanguage_Enumeration__epv s_new__sidllanguage_enumeration;

/* Declare EPV routines defined in the skeleton */
extern void ANL_SIDLCompilerI_Enumeration__set_epv(struct ANL_SIDLCompilerI_Enumeration__epv * epv);

/* CAST: dynamic type casting support */
static void *ANL_SIDLCompilerI_Enumeration__cast_ior(
  struct ANL_SIDLCompilerI_Enumeration__object *self,
  const char *name)
{
  void *cast = NULL;
  /* We are guaranteed here that the first member in any IOR is a BaseInterface object */
  struct ANL_SIDLCompilerI_Enumeration__object *s0 = ((struct SIDL_BaseInterface__object *) self)->d_object;
  struct ANL_SIDLCompilerI_Type__object *s1 = &s0->d_anl_sidlcompileri_type;
  struct ANL_SIDLCompilerI_AST__object *s2 = &s1->d_anl_sidlcompileri_ast;
  struct SIDL_BaseClass__object *s3 = &s2->d_sidl_baseclass;

  if (!strcmp(name, "ANL.SIDLCompilerI.Enumeration")) {
    cast = (void *) s0;
  } else if (!strcmp(name, "ANL.SIDLCompilerI.Type")) {
    cast = (void *) s1;
  } else if (!strcmp(name, "ANL.SIDLCompilerI.AST")) {
    cast = (void *) s2;
  } else if (!strcmp(name, "SIDL.BaseClass")) {
    cast = (void *) s3;
  } else if (!strcmp(name, "SIDL.BaseInterface")) {
    cast = (void *) &s3->d_sidl_baseinterface;
  } else if (!strcmp(name, "SIDLLanguage.AST")) {
    cast = (void *) &s2->d_sidllanguage_ast;
  } else if (!strcmp(name, "SIDLLanguage.Type")) {
    cast = (void *) &s1->d_sidllanguage_type;
  } else if (!strcmp(name, "SIDLLanguage.Enumeration")) {
    cast = (void *) &s0->d_sidllanguage_enumeration;
  }

  return cast;
}

/* DELETE: call destructor and free object memory */
static void ANL_SIDLCompilerI_Enumeration__delete(
  struct ANL_SIDLCompilerI_Enumeration__object *self)
{
  struct ANL_SIDLCompilerI_Enumeration__object * s0 = self->d_epv->f__cast_ior(self, "ANL.SIDLCompilerI.Enumeration");
  ANL_SIDLCompilerI_Enumeration__fini(s0);
  memset((void *) s0, 0, sizeof(struct ANL_SIDLCompilerI_Enumeration__object));
  free((void *) s0);
}

/* INIT_EPV: create method entry point vector (EPV) structure */
static void ANL_SIDLCompilerI_Enumeration__init_epv(
  struct ANL_SIDLCompilerI_Enumeration__object *self)
{
  struct ANL_SIDLCompilerI_Enumeration__object *s0 = self;
  struct ANL_SIDLCompilerI_Type__object *s1 = &s0->d_anl_sidlcompileri_type;
  struct ANL_SIDLCompilerI_AST__object *s2 = &s1->d_anl_sidlcompileri_ast;
  struct SIDL_BaseClass__object *s3 = &s2->d_sidl_baseclass;

  struct ANL_SIDLCompilerI_Enumeration__epv * epv = &s_new__anl_sidlcompileri_enumeration;
  struct ANL_SIDLCompilerI_Type__epv * e0 = &s_new__anl_sidlcompileri_type;
  struct ANL_SIDLCompilerI_AST__epv * e1 = &s_new__anl_sidlcompileri_ast;
  struct SIDL_BaseClass__epv * e2 = &s_new__sidl_baseclass;
  struct SIDL_BaseInterface__epv * e3 = &s_new__sidl_baseinterface;
  struct SIDLLanguage_AST__epv * e4 = &s_new__sidllanguage_ast;
  struct SIDLLanguage_Type__epv * e6 = &s_new__sidllanguage_type;
  struct SIDLLanguage_Enumeration__epv * e8 = &s_new__sidllanguage_enumeration;

  s_old__sidl_baseinterface = s3->d_sidl_baseinterface.d_epv;
  s_old__sidl_baseclass = s3->d_epv;
  s_old__sidllanguage_ast = s2->d_sidllanguage_ast.d_epv;
  s_old__anl_sidlcompileri_ast = s2->d_epv;
  s_old__sidllanguage_type = s1->d_sidllanguage_type.d_epv;
  s_old__anl_sidlcompileri_type = s1->d_epv;

  epv->f__cast_ior = ANL_SIDLCompilerI_Enumeration__cast_ior;
  epv->f__delete = ANL_SIDLCompilerI_Enumeration__delete;
  epv->f__ctor = NULL;
  epv->f__dtor = NULL;
  epv->f_accept = NULL;
  epv->f_getFullIdentifier = (char * (*)(struct ANL_SIDLCompilerI_Enumeration__object *, struct SIDL_BaseException__object **)) s1->d_epv->f_getFullIdentifier;
  epv->f_addReference = (void (*)(struct ANL_SIDLCompilerI_Enumeration__object *)) s1->d_epv->f_addReference;
  epv->f_deleteReference = (void (*)(struct ANL_SIDLCompilerI_Enumeration__object *)) s1->d_epv->f_deleteReference;
  epv->f_isSame = (SIDL_bool (*)(struct ANL_SIDLCompilerI_Enumeration__object *, struct SIDL_BaseInterface__object *)) s1->d_epv->f_isSame;
  epv->f_queryInterface = (struct SIDL_BaseInterface__object * (*)(struct ANL_SIDLCompilerI_Enumeration__object *, const char *)) s1->d_epv->f_queryInterface;
  epv->f_isInstanceOf = (SIDL_bool (*)(struct ANL_SIDLCompilerI_Enumeration__object *, const char *)) s1->d_epv->f_isInstanceOf;
  epv->f_getIdentifier = (char * (*)(struct ANL_SIDLCompilerI_Enumeration__object *, struct SIDL_BaseException__object **)) s1->d_epv->f_getIdentifier;
  epv->f_setIdentifier = (void (*)(struct ANL_SIDLCompilerI_Enumeration__object *, const char *, struct SIDL_BaseException__object **)) s1->d_epv->f_setIdentifier;
  epv->f_getParent = (struct SIDLLanguage_AST__object * (*)(struct ANL_SIDLCompilerI_Enumeration__object *, struct SIDL_BaseException__object **)) s1->d_epv->f_getParent;
  epv->f_setParent = (void (*)(struct ANL_SIDLCompilerI_Enumeration__object *, struct SIDLLanguage_AST__object *, struct SIDL_BaseException__object **)) s1->d_epv->f_setParent;
  epv->f_getChildren = (struct SIDLLanguage_AST__array * (*)(struct ANL_SIDLCompilerI_Enumeration__object *, struct SIDL_BaseException__object **)) s1->d_epv->f_getChildren;
  epv->f_setChildren = (void (*)(struct ANL_SIDLCompilerI_Enumeration__object *, struct SIDLLanguage_AST__array *, struct SIDL_BaseException__object **)) s1->d_epv->f_setChildren;
  epv->f_addChildren = (void (*)(struct ANL_SIDLCompilerI_Enumeration__object *, struct SIDLLanguage_AST__array *, struct SIDL_BaseException__object **)) s1->d_epv->f_addChildren;
  epv->f_getDependencies = (struct SIDLLanguage_AST__array * (*)(struct ANL_SIDLCompilerI_Enumeration__object *, struct SIDL_BaseException__object **)) s1->d_epv->f_getDependencies;
  epv->f_setDependencies = (void (*)(struct ANL_SIDLCompilerI_Enumeration__object *, struct SIDLLanguage_AST__array *, struct SIDL_BaseException__object **)) s1->d_epv->f_setDependencies;
  epv->f_addDependency = (void (*)(struct ANL_SIDLCompilerI_Enumeration__object *, struct SIDLLanguage_AST__object *, struct SIDL_BaseException__object **)) s1->d_epv->f_addDependency;
  epv->f_getComments = (struct SIDLLanguage_Comment__array * (*)(struct ANL_SIDLCompilerI_Enumeration__object *, struct SIDL_BaseException__object **)) s1->d_epv->f_getComments;
  epv->f_setComments = (void (*)(struct ANL_SIDLCompilerI_Enumeration__object *, struct SIDLLanguage_Comment__array *, struct SIDL_BaseException__object **)) s1->d_epv->f_setComments;
  epv->f_addComments = (void (*)(struct ANL_SIDLCompilerI_Enumeration__object *, struct SIDLLanguage_Comment__array *, struct SIDL_BaseException__object **)) s1->d_epv->f_addComments;
  epv->f_getCode = (struct SIDLLanguage_Code__array * (*)(struct ANL_SIDLCompilerI_Enumeration__object *, const char *, struct SIDL_BaseException__object **)) s1->d_epv->f_getCode;
  epv->f_setCode = (void (*)(struct ANL_SIDLCompilerI_Enumeration__object *, struct SIDLLanguage_Code__array *, struct SIDL_BaseException__object **)) s1->d_epv->f_setCode;
  epv->f_addCode = (void (*)(struct ANL_SIDLCompilerI_Enumeration__object *, struct SIDLLanguage_Code__object *, struct SIDL_BaseException__object **)) s1->d_epv->f_addCode;
  epv->f_hasCodeBlock = (SIDL_bool (*)(struct ANL_SIDLCompilerI_Enumeration__object *, const char *, const char *, struct SIDL_BaseException__object **)) s1->d_epv->f_hasCodeBlock;
  epv->f_getCodeBlock = (struct SIDLLanguage_Code__object * (*)(struct ANL_SIDLCompilerI_Enumeration__object *, const char *, const char *, struct SIDL_BaseException__object **)) s1->d_epv->f_getCodeBlock;
  epv->f_removeCodeBlock = (struct SIDLLanguage_Code__object * (*)(struct ANL_SIDLCompilerI_Enumeration__object *, const char *, const char *, struct SIDL_BaseException__object **)) s1->d_epv->f_removeCodeBlock;
  epv->f_getAttributes = (struct SIDLLanguage_Attribute__array * (*)(struct ANL_SIDLCompilerI_Enumeration__object *, struct SIDL_BaseException__object **)) s1->d_epv->f_getAttributes;
  epv->f_setAttributes = (void (*)(struct ANL_SIDLCompilerI_Enumeration__object *, struct SIDLLanguage_Attribute__array *, struct SIDL_BaseException__object **)) s1->d_epv->f_setAttributes;
  epv->f_hasAttribute = (SIDL_bool (*)(struct ANL_SIDLCompilerI_Enumeration__object *, const char *, struct SIDL_BaseException__object **)) s1->d_epv->f_hasAttribute;
  epv->f_addAttribute = (void (*)(struct ANL_SIDLCompilerI_Enumeration__object *, struct SIDLLanguage_Attribute__object *, struct SIDL_BaseException__object **)) s1->d_epv->f_addAttribute;
  epv->f_deleteAttribute = (struct SIDLLanguage_Attribute__object * (*)(struct ANL_SIDLCompilerI_Enumeration__object *, const char *, struct SIDL_BaseException__object **)) s1->d_epv->f_deleteAttribute;
  epv->f_getAttribute = (struct SIDLLanguage_Attribute__object * (*)(struct ANL_SIDLCompilerI_Enumeration__object *, const char *, struct SIDL_BaseException__object **)) s1->d_epv->f_getAttribute;
  epv->f_getBaseType = (SIDL_bool (*)(struct ANL_SIDLCompilerI_Enumeration__object *, struct SIDL_BaseException__object **)) s1->d_epv->f_getBaseType;
  epv->f_setBaseType = (void (*)(struct ANL_SIDLCompilerI_Enumeration__object *, SIDL_bool, struct SIDL_BaseException__object **)) s1->d_epv->f_setBaseType;

  ANL_SIDLCompilerI_Enumeration__set_epv(epv);

  e0->f__cast_ior = (void *(*)(struct ANL_SIDLCompilerI_Type__object *, const char *)) epv->f__cast_ior;
  e0->f__delete = (void (*)(struct ANL_SIDLCompilerI_Type__object *)) epv->f__delete;
  e0->f_accept = (void (*)(struct ANL_SIDLCompilerI_Type__object *, struct SIDLLanguage_Visitor__object *, struct SIDL_BaseException__object **)) epv->f_accept;
  e0->f_getFullIdentifier = (char * (*)(struct ANL_SIDLCompilerI_Type__object *, struct SIDL_BaseException__object **)) epv->f_getFullIdentifier;
  e0->f_addReference = (void (*)(struct ANL_SIDLCompilerI_Type__object *)) epv->f_addReference;
  e0->f_deleteReference = (void (*)(struct ANL_SIDLCompilerI_Type__object *)) epv->f_deleteReference;
  e0->f_isSame = (SIDL_bool (*)(struct ANL_SIDLCompilerI_Type__object *, struct SIDL_BaseInterface__object *)) epv->f_isSame;
  e0->f_queryInterface = (struct SIDL_BaseInterface__object * (*)(struct ANL_SIDLCompilerI_Type__object *, const char *)) epv->f_queryInterface;
  e0->f_isInstanceOf = (SIDL_bool (*)(struct ANL_SIDLCompilerI_Type__object *, const char *)) epv->f_isInstanceOf;
  e0->f_getIdentifier = (char * (*)(struct ANL_SIDLCompilerI_Type__object *, struct SIDL_BaseException__object **)) epv->f_getIdentifier;
  e0->f_setIdentifier = (void (*)(struct ANL_SIDLCompilerI_Type__object *, const char *, struct SIDL_BaseException__object **)) epv->f_setIdentifier;
  e0->f_getParent = (struct SIDLLanguage_AST__object * (*)(struct ANL_SIDLCompilerI_Type__object *, struct SIDL_BaseException__object **)) epv->f_getParent;
  e0->f_setParent = (void (*)(struct ANL_SIDLCompilerI_Type__object *, struct SIDLLanguage_AST__object *, struct SIDL_BaseException__object **)) epv->f_setParent;
  e0->f_getChildren = (struct SIDLLanguage_AST__array * (*)(struct ANL_SIDLCompilerI_Type__object *, struct SIDL_BaseException__object **)) epv->f_getChildren;
  e0->f_setChildren = (void (*)(struct ANL_SIDLCompilerI_Type__object *, struct SIDLLanguage_AST__array *, struct SIDL_BaseException__object **)) epv->f_setChildren;
  e0->f_addChildren = (void (*)(struct ANL_SIDLCompilerI_Type__object *, struct SIDLLanguage_AST__array *, struct SIDL_BaseException__object **)) epv->f_addChildren;
  e0->f_getDependencies = (struct SIDLLanguage_AST__array * (*)(struct ANL_SIDLCompilerI_Type__object *, struct SIDL_BaseException__object **)) epv->f_getDependencies;
  e0->f_setDependencies = (void (*)(struct ANL_SIDLCompilerI_Type__object *, struct SIDLLanguage_AST__array *, struct SIDL_BaseException__object **)) epv->f_setDependencies;
  e0->f_addDependency = (void (*)(struct ANL_SIDLCompilerI_Type__object *, struct SIDLLanguage_AST__object *, struct SIDL_BaseException__object **)) epv->f_addDependency;
  e0->f_getComments = (struct SIDLLanguage_Comment__array * (*)(struct ANL_SIDLCompilerI_Type__object *, struct SIDL_BaseException__object **)) epv->f_getComments;
  e0->f_setComments = (void (*)(struct ANL_SIDLCompilerI_Type__object *, struct SIDLLanguage_Comment__array *, struct SIDL_BaseException__object **)) epv->f_setComments;
  e0->f_addComments = (void (*)(struct ANL_SIDLCompilerI_Type__object *, struct SIDLLanguage_Comment__array *, struct SIDL_BaseException__object **)) epv->f_addComments;
  e0->f_getCode = (struct SIDLLanguage_Code__array * (*)(struct ANL_SIDLCompilerI_Type__object *, const char *, struct SIDL_BaseException__object **)) epv->f_getCode;
  e0->f_setCode = (void (*)(struct ANL_SIDLCompilerI_Type__object *, struct SIDLLanguage_Code__array *, struct SIDL_BaseException__object **)) epv->f_setCode;
  e0->f_addCode = (void (*)(struct ANL_SIDLCompilerI_Type__object *, struct SIDLLanguage_Code__object *, struct SIDL_BaseException__object **)) epv->f_addCode;
  e0->f_hasCodeBlock = (SIDL_bool (*)(struct ANL_SIDLCompilerI_Type__object *, const char *, const char *, struct SIDL_BaseException__object **)) epv->f_hasCodeBlock;
  e0->f_getCodeBlock = (struct SIDLLanguage_Code__object * (*)(struct ANL_SIDLCompilerI_Type__object *, const char *, const char *, struct SIDL_BaseException__object **)) epv->f_getCodeBlock;
  e0->f_removeCodeBlock = (struct SIDLLanguage_Code__object * (*)(struct ANL_SIDLCompilerI_Type__object *, const char *, const char *, struct SIDL_BaseException__object **)) epv->f_removeCodeBlock;
  e0->f_getAttributes = (struct SIDLLanguage_Attribute__array * (*)(struct ANL_SIDLCompilerI_Type__object *, struct SIDL_BaseException__object **)) epv->f_getAttributes;
  e0->f_setAttributes = (void (*)(struct ANL_SIDLCompilerI_Type__object *, struct SIDLLanguage_Attribute__array *, struct SIDL_BaseException__object **)) epv->f_setAttributes;
  e0->f_hasAttribute = (SIDL_bool (*)(struct ANL_SIDLCompilerI_Type__object *, const char *, struct SIDL_BaseException__object **)) epv->f_hasAttribute;
  e0->f_addAttribute = (void (*)(struct ANL_SIDLCompilerI_Type__object *, struct SIDLLanguage_Attribute__object *, struct SIDL_BaseException__object **)) epv->f_addAttribute;
  e0->f_deleteAttribute = (struct SIDLLanguage_Attribute__object * (*)(struct ANL_SIDLCompilerI_Type__object *, const char *, struct SIDL_BaseException__object **)) epv->f_deleteAttribute;
  e0->f_getAttribute = (struct SIDLLanguage_Attribute__object * (*)(struct ANL_SIDLCompilerI_Type__object *, const char *, struct SIDL_BaseException__object **)) epv->f_getAttribute;
  e0->f_getBaseType = (SIDL_bool (*)(struct ANL_SIDLCompilerI_Type__object *, struct SIDL_BaseException__object **)) epv->f_getBaseType;
  e0->f_setBaseType = (void (*)(struct ANL_SIDLCompilerI_Type__object *, SIDL_bool, struct SIDL_BaseException__object **)) epv->f_setBaseType;

  e1->f__cast_ior = (void *(*)(struct ANL_SIDLCompilerI_AST__object *, const char *)) epv->f__cast_ior;
  e1->f__delete = (void (*)(struct ANL_SIDLCompilerI_AST__object *)) epv->f__delete;
  e1->f_addReference = (void (*)(struct ANL_SIDLCompilerI_AST__object *)) epv->f_addReference;
  e1->f_deleteReference = (void (*)(struct ANL_SIDLCompilerI_AST__object *)) epv->f_deleteReference;
  e1->f_isSame = (SIDL_bool (*)(struct ANL_SIDLCompilerI_AST__object *, struct SIDL_BaseInterface__object *)) epv->f_isSame;
  e1->f_queryInterface = (struct SIDL_BaseInterface__object * (*)(struct ANL_SIDLCompilerI_AST__object *, const char *)) epv->f_queryInterface;
  e1->f_isInstanceOf = (SIDL_bool (*)(struct ANL_SIDLCompilerI_AST__object *, const char *)) epv->f_isInstanceOf;
  e1->f_accept = (void (*)(struct ANL_SIDLCompilerI_AST__object *, struct SIDLLanguage_Visitor__object *, struct SIDL_BaseException__object **)) epv->f_accept;
  e1->f_getIdentifier = (char * (*)(struct ANL_SIDLCompilerI_AST__object *, struct SIDL_BaseException__object **)) epv->f_getIdentifier;
  e1->f_setIdentifier = (void (*)(struct ANL_SIDLCompilerI_AST__object *, const char *, struct SIDL_BaseException__object **)) epv->f_setIdentifier;
  e1->f_getFullIdentifier = (char * (*)(struct ANL_SIDLCompilerI_AST__object *, struct SIDL_BaseException__object **)) epv->f_getFullIdentifier;
  e1->f_getParent = (struct SIDLLanguage_AST__object * (*)(struct ANL_SIDLCompilerI_AST__object *, struct SIDL_BaseException__object **)) epv->f_getParent;
  e1->f_setParent = (void (*)(struct ANL_SIDLCompilerI_AST__object *, struct SIDLLanguage_AST__object *, struct SIDL_BaseException__object **)) epv->f_setParent;
  e1->f_getChildren = (struct SIDLLanguage_AST__array * (*)(struct ANL_SIDLCompilerI_AST__object *, struct SIDL_BaseException__object **)) epv->f_getChildren;
  e1->f_setChildren = (void (*)(struct ANL_SIDLCompilerI_AST__object *, struct SIDLLanguage_AST__array *, struct SIDL_BaseException__object **)) epv->f_setChildren;
  e1->f_addChildren = (void (*)(struct ANL_SIDLCompilerI_AST__object *, struct SIDLLanguage_AST__array *, struct SIDL_BaseException__object **)) epv->f_addChildren;
  e1->f_getDependencies = (struct SIDLLanguage_AST__array * (*)(struct ANL_SIDLCompilerI_AST__object *, struct SIDL_BaseException__object **)) epv->f_getDependencies;
  e1->f_setDependencies = (void (*)(struct ANL_SIDLCompilerI_AST__object *, struct SIDLLanguage_AST__array *, struct SIDL_BaseException__object **)) epv->f_setDependencies;
  e1->f_addDependency = (void (*)(struct ANL_SIDLCompilerI_AST__object *, struct SIDLLanguage_AST__object *, struct SIDL_BaseException__object **)) epv->f_addDependency;
  e1->f_getComments = (struct SIDLLanguage_Comment__array * (*)(struct ANL_SIDLCompilerI_AST__object *, struct SIDL_BaseException__object **)) epv->f_getComments;
  e1->f_setComments = (void (*)(struct ANL_SIDLCompilerI_AST__object *, struct SIDLLanguage_Comment__array *, struct SIDL_BaseException__object **)) epv->f_setComments;
  e1->f_addComments = (void (*)(struct ANL_SIDLCompilerI_AST__object *, struct SIDLLanguage_Comment__array *, struct SIDL_BaseException__object **)) epv->f_addComments;
  e1->f_getCode = (struct SIDLLanguage_Code__array * (*)(struct ANL_SIDLCompilerI_AST__object *, const char *, struct SIDL_BaseException__object **)) epv->f_getCode;
  e1->f_setCode = (void (*)(struct ANL_SIDLCompilerI_AST__object *, struct SIDLLanguage_Code__array *, struct SIDL_BaseException__object **)) epv->f_setCode;
  e1->f_addCode = (void (*)(struct ANL_SIDLCompilerI_AST__object *, struct SIDLLanguage_Code__object *, struct SIDL_BaseException__object **)) epv->f_addCode;
  e1->f_hasCodeBlock = (SIDL_bool (*)(struct ANL_SIDLCompilerI_AST__object *, const char *, const char *, struct SIDL_BaseException__object **)) epv->f_hasCodeBlock;
  e1->f_getCodeBlock = (struct SIDLLanguage_Code__object * (*)(struct ANL_SIDLCompilerI_AST__object *, const char *, const char *, struct SIDL_BaseException__object **)) epv->f_getCodeBlock;
  e1->f_removeCodeBlock = (struct SIDLLanguage_Code__object * (*)(struct ANL_SIDLCompilerI_AST__object *, const char *, const char *, struct SIDL_BaseException__object **)) epv->f_removeCodeBlock;
  e1->f_getAttributes = (struct SIDLLanguage_Attribute__array * (*)(struct ANL_SIDLCompilerI_AST__object *, struct SIDL_BaseException__object **)) epv->f_getAttributes;
  e1->f_setAttributes = (void (*)(struct ANL_SIDLCompilerI_AST__object *, struct SIDLLanguage_Attribute__array *, struct SIDL_BaseException__object **)) epv->f_setAttributes;
  e1->f_hasAttribute = (SIDL_bool (*)(struct ANL_SIDLCompilerI_AST__object *, const char *, struct SIDL_BaseException__object **)) epv->f_hasAttribute;
  e1->f_addAttribute = (void (*)(struct ANL_SIDLCompilerI_AST__object *, struct SIDLLanguage_Attribute__object *, struct SIDL_BaseException__object **)) epv->f_addAttribute;
  e1->f_deleteAttribute = (struct SIDLLanguage_Attribute__object * (*)(struct ANL_SIDLCompilerI_AST__object *, const char *, struct SIDL_BaseException__object **)) epv->f_deleteAttribute;
  e1->f_getAttribute = (struct SIDLLanguage_Attribute__object * (*)(struct ANL_SIDLCompilerI_AST__object *, const char *, struct SIDL_BaseException__object **)) epv->f_getAttribute;

  e2->f__cast_ior = (void *(*)(struct SIDL_BaseClass__object *, const char *)) epv->f__cast_ior;
  e2->f__delete = (void (*)(struct SIDL_BaseClass__object *)) epv->f__delete;
  e2->f_addReference = (void (*)(struct SIDL_BaseClass__object *)) epv->f_addReference;
  e2->f_deleteReference = (void (*)(struct SIDL_BaseClass__object *)) epv->f_deleteReference;
  e2->f_isSame = (SIDL_bool (*)(struct SIDL_BaseClass__object *, struct SIDL_BaseInterface__object *)) epv->f_isSame;
  e2->f_queryInterface = (struct SIDL_BaseInterface__object * (*)(struct SIDL_BaseClass__object *, const char *)) epv->f_queryInterface;
  e2->f_isInstanceOf = (SIDL_bool (*)(struct SIDL_BaseClass__object *, const char *)) epv->f_isInstanceOf;

  e3->f__cast_ior = (void *(*)(void *, const char *)) epv->f__cast_ior;
  e3->f__delete = (void (*)(void *)) epv->f__delete;
  e3->f_addReference = (void (*)(void *)) epv->f_addReference;
  e3->f_deleteReference = (void (*)(void *)) epv->f_deleteReference;
  e3->f_isSame = (SIDL_bool (*)(void *, struct SIDL_BaseInterface__object *)) epv->f_isSame;
  e3->f_queryInterface = (struct SIDL_BaseInterface__object * (*)(void *, const char *)) epv->f_queryInterface;
  e3->f_isInstanceOf = (SIDL_bool (*)(void *, const char *)) epv->f_isInstanceOf;

  e4->f__cast_ior = (void *(*)(void *, const char *)) epv->f__cast_ior;
  e4->f__delete = (void (*)(void *)) epv->f__delete;
  e4->f_accept = (void (*)(void *, struct SIDLLanguage_Visitor__object *, struct SIDL_BaseException__object **)) epv->f_accept;
  e4->f_getIdentifier = (char * (*)(void *, struct SIDL_BaseException__object **)) epv->f_getIdentifier;
  e4->f_setIdentifier = (void (*)(void *, const char *, struct SIDL_BaseException__object **)) epv->f_setIdentifier;
  e4->f_getFullIdentifier = (char * (*)(void *, struct SIDL_BaseException__object **)) epv->f_getFullIdentifier;
  e4->f_getParent = (struct SIDLLanguage_AST__object * (*)(void *, struct SIDL_BaseException__object **)) epv->f_getParent;
  e4->f_setParent = (void (*)(void *, struct SIDLLanguage_AST__object *, struct SIDL_BaseException__object **)) epv->f_setParent;
  e4->f_getChildren = (struct SIDLLanguage_AST__array * (*)(void *, struct SIDL_BaseException__object **)) epv->f_getChildren;
  e4->f_setChildren = (void (*)(void *, struct SIDLLanguage_AST__array *, struct SIDL_BaseException__object **)) epv->f_setChildren;
  e4->f_addChildren = (void (*)(void *, struct SIDLLanguage_AST__array *, struct SIDL_BaseException__object **)) epv->f_addChildren;
  e4->f_getDependencies = (struct SIDLLanguage_AST__array * (*)(void *, struct SIDL_BaseException__object **)) epv->f_getDependencies;
  e4->f_setDependencies = (void (*)(void *, struct SIDLLanguage_AST__array *, struct SIDL_BaseException__object **)) epv->f_setDependencies;
  e4->f_addDependency = (void (*)(void *, struct SIDLLanguage_AST__object *, struct SIDL_BaseException__object **)) epv->f_addDependency;
  e4->f_getComments = (struct SIDLLanguage_Comment__array * (*)(void *, struct SIDL_BaseException__object **)) epv->f_getComments;
  e4->f_setComments = (void (*)(void *, struct SIDLLanguage_Comment__array *, struct SIDL_BaseException__object **)) epv->f_setComments;
  e4->f_addComments = (void (*)(void *, struct SIDLLanguage_Comment__array *, struct SIDL_BaseException__object **)) epv->f_addComments;
  e4->f_getCode = (struct SIDLLanguage_Code__array * (*)(void *, const char *, struct SIDL_BaseException__object **)) epv->f_getCode;
  e4->f_setCode = (void (*)(void *, struct SIDLLanguage_Code__array *, struct SIDL_BaseException__object **)) epv->f_setCode;
  e4->f_addCode = (void (*)(void *, struct SIDLLanguage_Code__object *, struct SIDL_BaseException__object **)) epv->f_addCode;
  e4->f_hasCodeBlock = (SIDL_bool (*)(void *, const char *, const char *, struct SIDL_BaseException__object **)) epv->f_hasCodeBlock;
  e4->f_getCodeBlock = (struct SIDLLanguage_Code__object * (*)(void *, const char *, const char *, struct SIDL_BaseException__object **)) epv->f_getCodeBlock;
  e4->f_removeCodeBlock = (struct SIDLLanguage_Code__object * (*)(void *, const char *, const char *, struct SIDL_BaseException__object **)) epv->f_removeCodeBlock;
  e4->f_getAttributes = (struct SIDLLanguage_Attribute__array * (*)(void *, struct SIDL_BaseException__object **)) epv->f_getAttributes;
  e4->f_setAttributes = (void (*)(void *, struct SIDLLanguage_Attribute__array *, struct SIDL_BaseException__object **)) epv->f_setAttributes;
  e4->f_hasAttribute = (SIDL_bool (*)(void *, const char *, struct SIDL_BaseException__object **)) epv->f_hasAttribute;
  e4->f_addAttribute = (void (*)(void *, struct SIDLLanguage_Attribute__object *, struct SIDL_BaseException__object **)) epv->f_addAttribute;
  e4->f_deleteAttribute = (struct SIDLLanguage_Attribute__object * (*)(void *, const char *, struct SIDL_BaseException__object **)) epv->f_deleteAttribute;
  e4->f_getAttribute = (struct SIDLLanguage_Attribute__object * (*)(void *, const char *, struct SIDL_BaseException__object **)) epv->f_getAttribute;
  e4->f_addReference = (void (*)(void *)) epv->f_addReference;
  e4->f_deleteReference = (void (*)(void *)) epv->f_deleteReference;
  e4->f_isSame = (SIDL_bool (*)(void *, struct SIDL_BaseInterface__object *)) epv->f_isSame;
  e4->f_queryInterface = (struct SIDL_BaseInterface__object * (*)(void *, const char *)) epv->f_queryInterface;
  e4->f_isInstanceOf = (SIDL_bool (*)(void *, const char *)) epv->f_isInstanceOf;

  e6->f__cast_ior = (void *(*)(void *, const char *)) epv->f__cast_ior;
  e6->f__delete = (void (*)(void *)) epv->f__delete;
  e6->f_getBaseType = (SIDL_bool (*)(void *, struct SIDL_BaseException__object **)) epv->f_getBaseType;
  e6->f_setBaseType = (void (*)(void *, SIDL_bool, struct SIDL_BaseException__object **)) epv->f_setBaseType;
  e6->f_accept = (void (*)(void *, struct SIDLLanguage_Visitor__object *, struct SIDL_BaseException__object **)) epv->f_accept;
  e6->f_getIdentifier = (char * (*)(void *, struct SIDL_BaseException__object **)) epv->f_getIdentifier;
  e6->f_setIdentifier = (void (*)(void *, const char *, struct SIDL_BaseException__object **)) epv->f_setIdentifier;
  e6->f_getFullIdentifier = (char * (*)(void *, struct SIDL_BaseException__object **)) epv->f_getFullIdentifier;
  e6->f_getParent = (struct SIDLLanguage_AST__object * (*)(void *, struct SIDL_BaseException__object **)) epv->f_getParent;
  e6->f_setParent = (void (*)(void *, struct SIDLLanguage_AST__object *, struct SIDL_BaseException__object **)) epv->f_setParent;
  e6->f_getChildren = (struct SIDLLanguage_AST__array * (*)(void *, struct SIDL_BaseException__object **)) epv->f_getChildren;
  e6->f_setChildren = (void (*)(void *, struct SIDLLanguage_AST__array *, struct SIDL_BaseException__object **)) epv->f_setChildren;
  e6->f_addChildren = (void (*)(void *, struct SIDLLanguage_AST__array *, struct SIDL_BaseException__object **)) epv->f_addChildren;
  e6->f_getDependencies = (struct SIDLLanguage_AST__array * (*)(void *, struct SIDL_BaseException__object **)) epv->f_getDependencies;
  e6->f_setDependencies = (void (*)(void *, struct SIDLLanguage_AST__array *, struct SIDL_BaseException__object **)) epv->f_setDependencies;
  e6->f_addDependency = (void (*)(void *, struct SIDLLanguage_AST__object *, struct SIDL_BaseException__object **)) epv->f_addDependency;
  e6->f_getComments = (struct SIDLLanguage_Comment__array * (*)(void *, struct SIDL_BaseException__object **)) epv->f_getComments;
  e6->f_setComments = (void (*)(void *, struct SIDLLanguage_Comment__array *, struct SIDL_BaseException__object **)) epv->f_setComments;
  e6->f_addComments = (void (*)(void *, struct SIDLLanguage_Comment__array *, struct SIDL_BaseException__object **)) epv->f_addComments;
  e6->f_getCode = (struct SIDLLanguage_Code__array * (*)(void *, const char *, struct SIDL_BaseException__object **)) epv->f_getCode;
  e6->f_setCode = (void (*)(void *, struct SIDLLanguage_Code__array *, struct SIDL_BaseException__object **)) epv->f_setCode;
  e6->f_addCode = (void (*)(void *, struct SIDLLanguage_Code__object *, struct SIDL_BaseException__object **)) epv->f_addCode;
  e6->f_hasCodeBlock = (SIDL_bool (*)(void *, const char *, const char *, struct SIDL_BaseException__object **)) epv->f_hasCodeBlock;
  e6->f_getCodeBlock = (struct SIDLLanguage_Code__object * (*)(void *, const char *, const char *, struct SIDL_BaseException__object **)) epv->f_getCodeBlock;
  e6->f_removeCodeBlock = (struct SIDLLanguage_Code__object * (*)(void *, const char *, const char *, struct SIDL_BaseException__object **)) epv->f_removeCodeBlock;
  e6->f_getAttributes = (struct SIDLLanguage_Attribute__array * (*)(void *, struct SIDL_BaseException__object **)) epv->f_getAttributes;
  e6->f_setAttributes = (void (*)(void *, struct SIDLLanguage_Attribute__array *, struct SIDL_BaseException__object **)) epv->f_setAttributes;
  e6->f_hasAttribute = (SIDL_bool (*)(void *, const char *, struct SIDL_BaseException__object **)) epv->f_hasAttribute;
  e6->f_addAttribute = (void (*)(void *, struct SIDLLanguage_Attribute__object *, struct SIDL_BaseException__object **)) epv->f_addAttribute;
  e6->f_deleteAttribute = (struct SIDLLanguage_Attribute__object * (*)(void *, const char *, struct SIDL_BaseException__object **)) epv->f_deleteAttribute;
  e6->f_getAttribute = (struct SIDLLanguage_Attribute__object * (*)(void *, const char *, struct SIDL_BaseException__object **)) epv->f_getAttribute;
  e6->f_addReference = (void (*)(void *)) epv->f_addReference;
  e6->f_deleteReference = (void (*)(void *)) epv->f_deleteReference;
  e6->f_isSame = (SIDL_bool (*)(void *, struct SIDL_BaseInterface__object *)) epv->f_isSame;
  e6->f_queryInterface = (struct SIDL_BaseInterface__object * (*)(void *, const char *)) epv->f_queryInterface;
  e6->f_isInstanceOf = (SIDL_bool (*)(void *, const char *)) epv->f_isInstanceOf;

  e8->f__cast_ior = (void *(*)(void *, const char *)) epv->f__cast_ior;
  e8->f__delete = (void (*)(void *)) epv->f__delete;
  e8->f_getBaseType = (SIDL_bool (*)(void *, struct SIDL_BaseException__object **)) epv->f_getBaseType;
  e8->f_setBaseType = (void (*)(void *, SIDL_bool, struct SIDL_BaseException__object **)) epv->f_setBaseType;
  e8->f_accept = (void (*)(void *, struct SIDLLanguage_Visitor__object *, struct SIDL_BaseException__object **)) epv->f_accept;
  e8->f_getIdentifier = (char * (*)(void *, struct SIDL_BaseException__object **)) epv->f_getIdentifier;
  e8->f_setIdentifier = (void (*)(void *, const char *, struct SIDL_BaseException__object **)) epv->f_setIdentifier;
  e8->f_getFullIdentifier = (char * (*)(void *, struct SIDL_BaseException__object **)) epv->f_getFullIdentifier;
  e8->f_getParent = (struct SIDLLanguage_AST__object * (*)(void *, struct SIDL_BaseException__object **)) epv->f_getParent;
  e8->f_setParent = (void (*)(void *, struct SIDLLanguage_AST__object *, struct SIDL_BaseException__object **)) epv->f_setParent;
  e8->f_getChildren = (struct SIDLLanguage_AST__array * (*)(void *, struct SIDL_BaseException__object **)) epv->f_getChildren;
  e8->f_setChildren = (void (*)(void *, struct SIDLLanguage_AST__array *, struct SIDL_BaseException__object **)) epv->f_setChildren;
  e8->f_addChildren = (void (*)(void *, struct SIDLLanguage_AST__array *, struct SIDL_BaseException__object **)) epv->f_addChildren;
  e8->f_getDependencies = (struct SIDLLanguage_AST__array * (*)(void *, struct SIDL_BaseException__object **)) epv->f_getDependencies;
  e8->f_setDependencies = (void (*)(void *, struct SIDLLanguage_AST__array *, struct SIDL_BaseException__object **)) epv->f_setDependencies;
  e8->f_addDependency = (void (*)(void *, struct SIDLLanguage_AST__object *, struct SIDL_BaseException__object **)) epv->f_addDependency;
  e8->f_getComments = (struct SIDLLanguage_Comment__array * (*)(void *, struct SIDL_BaseException__object **)) epv->f_getComments;
  e8->f_setComments = (void (*)(void *, struct SIDLLanguage_Comment__array *, struct SIDL_BaseException__object **)) epv->f_setComments;
  e8->f_addComments = (void (*)(void *, struct SIDLLanguage_Comment__array *, struct SIDL_BaseException__object **)) epv->f_addComments;
  e8->f_getCode = (struct SIDLLanguage_Code__array * (*)(void *, const char *, struct SIDL_BaseException__object **)) epv->f_getCode;
  e8->f_setCode = (void (*)(void *, struct SIDLLanguage_Code__array *, struct SIDL_BaseException__object **)) epv->f_setCode;
  e8->f_addCode = (void (*)(void *, struct SIDLLanguage_Code__object *, struct SIDL_BaseException__object **)) epv->f_addCode;
  e8->f_hasCodeBlock = (SIDL_bool (*)(void *, const char *, const char *, struct SIDL_BaseException__object **)) epv->f_hasCodeBlock;
  e8->f_getCodeBlock = (struct SIDLLanguage_Code__object * (*)(void *, const char *, const char *, struct SIDL_BaseException__object **)) epv->f_getCodeBlock;
  e8->f_removeCodeBlock = (struct SIDLLanguage_Code__object * (*)(void *, const char *, const char *, struct SIDL_BaseException__object **)) epv->f_removeCodeBlock;
  e8->f_getAttributes = (struct SIDLLanguage_Attribute__array * (*)(void *, struct SIDL_BaseException__object **)) epv->f_getAttributes;
  e8->f_setAttributes = (void (*)(void *, struct SIDLLanguage_Attribute__array *, struct SIDL_BaseException__object **)) epv->f_setAttributes;
  e8->f_hasAttribute = (SIDL_bool (*)(void *, const char *, struct SIDL_BaseException__object **)) epv->f_hasAttribute;
  e8->f_addAttribute = (void (*)(void *, struct SIDLLanguage_Attribute__object *, struct SIDL_BaseException__object **)) epv->f_addAttribute;
  e8->f_deleteAttribute = (struct SIDLLanguage_Attribute__object * (*)(void *, const char *, struct SIDL_BaseException__object **)) epv->f_deleteAttribute;
  e8->f_getAttribute = (struct SIDLLanguage_Attribute__object * (*)(void *, const char *, struct SIDL_BaseException__object **)) epv->f_getAttribute;
  e8->f_addReference = (void (*)(void *)) epv->f_addReference;
  e8->f_deleteReference = (void (*)(void *)) epv->f_deleteReference;
  e8->f_isSame = (SIDL_bool (*)(void *, struct SIDL_BaseInterface__object *)) epv->f_isSame;
  e8->f_queryInterface = (struct SIDL_BaseInterface__object * (*)(void *, const char *)) epv->f_queryInterface;
  e8->f_isInstanceOf = (SIDL_bool (*)(void *, const char *)) epv->f_isInstanceOf;

  s_method_initialized = 1;
}

/* NEW: allocate object and initialize it */
struct ANL_SIDLCompilerI_Enumeration__object *ANL_SIDLCompilerI_Enumeration__new()
{
  struct ANL_SIDLCompilerI_Enumeration__object *self = (struct ANL_SIDLCompilerI_Enumeration__object *) malloc(sizeof(struct ANL_SIDLCompilerI_Enumeration__object));
  ANL_SIDLCompilerI_Enumeration__init(self);
  return self;
}

/* INIT: initialize a new instance of the class object */
void ANL_SIDLCompilerI_Enumeration__init(
  struct ANL_SIDLCompilerI_Enumeration__object *self)
{
  struct ANL_SIDLCompilerI_Enumeration__object *s0 = self;
  struct ANL_SIDLCompilerI_Type__object *s1 = &s0->d_anl_sidlcompileri_type;
  struct ANL_SIDLCompilerI_AST__object *s2 = &s1->d_anl_sidlcompileri_ast;
  struct SIDL_BaseClass__object *s3 = &s2->d_sidl_baseclass;

#if 0
  ANL_SIDLCompilerI_Type__init(s1);
#else
  void (*dll_f)(struct ANL_SIDLCompilerI_Type__object *) = (void (*)(struct ANL_SIDLCompilerI_Type__object *)) SIDL_Loader__externals()->getStaticEPV()->f_lookupSymbol("ANL_SIDLCompilerI_Type__init");

  if (!dll_f) {
    fputs("Unable to find initializer for ANL.SIDLCompilerI.Type; add to SIDL_DLL_PATH\n", stderr);
    exit(1);
  } else {
    (*dll_f)(s1);
  }
#endif

  if (!s_method_initialized) {
    ANL_SIDLCompilerI_Enumeration__init_epv(s0);
  }

  /* Setup d_epv members */
  s3->d_sidl_baseinterface.d_epv = &s_new__sidl_baseinterface;
  s3->d_epv = &s_new__sidl_baseclass;

  s2->d_sidllanguage_ast.d_epv = &s_new__sidllanguage_ast;
  s2->d_epv = &s_new__anl_sidlcompileri_ast;

  s1->d_sidllanguage_type.d_epv = &s_new__sidllanguage_type;
  s1->d_epv = &s_new__anl_sidlcompileri_type;

  s0->d_sidllanguage_enumeration.d_epv = &s_new__sidllanguage_enumeration;
  s0->d_epv = &s_new__anl_sidlcompileri_enumeration;

  /* Setup d_object members */
  s3->d_sidl_baseinterface.d_object = self;
  s3->d_object = self;
  s2->d_sidllanguage_ast.d_object = self;
  s2->d_object = self;
  s1->d_sidllanguage_type.d_object = self;
  s1->d_object = self;
  s0->d_sidllanguage_enumeration.d_object = self;
  s0->d_object = self;

  /* Setup d_data members */
  s0->d_data = NULL;
  (*(self->d_epv->f__ctor))(self);
}

/* FINI: deallocate a class instance (destructor) */
void ANL_SIDLCompilerI_Enumeration__fini(
  struct ANL_SIDLCompilerI_Enumeration__object *self)
{
  struct ANL_SIDLCompilerI_Enumeration__object *s0 = self;
  struct ANL_SIDLCompilerI_Type__object *s1 = &s0->d_anl_sidlcompileri_type;
  struct ANL_SIDLCompilerI_AST__object *s2 = &s1->d_anl_sidlcompileri_ast;
  struct SIDL_BaseClass__object *s3 = &s2->d_sidl_baseclass;
#if 1
  void (*dll_f)(struct ANL_SIDLCompilerI_Type__object *) = (void (*)(struct ANL_SIDLCompilerI_Type__object *)) SIDL_Loader__externals()->getStaticEPV()->f_lookupSymbol("ANL_SIDLCompilerI_Type__fini");
#endif

  (*(self->d_epv->f__dtor))(self);

  /* Setup d_epv members */
  s3->d_sidl_baseinterface.d_epv = s_old__sidl_baseinterface;
  s3->d_epv = s_old__sidl_baseclass;

  s2->d_sidllanguage_ast.d_epv = s_old__sidllanguage_ast;
  s2->d_epv = s_old__anl_sidlcompileri_ast;

  s1->d_sidllanguage_type.d_epv = s_old__sidllanguage_type;
  s1->d_epv = s_old__anl_sidlcompileri_type;

#if 0
  ANL_SIDLCompilerI_Type__fini(s1);
#else
  if (!dll_f) {
    fputs("Unable to find finializer for ANL.SIDLCompilerI.Type; add to SIDL_DLL_PATH\n", stderr);
    exit(1);
  } else {
    (*dll_f)(s1);
  }
#endif
}

/* The IOR array structure */
/*   Macros to read this are defined in SIDLArray.h */
struct ANL_SIDLCompilerI_Enumeration__array {
  struct ANL_SIDLCompilerI_Enumeration__object ** d_firstElement;
  int32_t *d_lower;
  int32_t *d_upper;
  int32_t *d_stride;
  SIDL_bool d_borrowed;
  int32_t d_dimen;
};

static struct ANL_SIDLCompilerI_Enumeration__array *newArray(int32_t dimen, const int32_t lower[], const int32_t upper[]) {
  static const size_t arraySize = sizeof(struct ANL_SIDLCompilerI_Enumeration__array) + (sizeof(int32_t) - (sizeof(struct ANL_SIDLCompilerI_Enumeration__array)%sizeof(int32_t)))%sizeof(int32_t);
  struct ANL_SIDLCompilerI_Enumeration__array *result = (struct ANL_SIDLCompilerI_Enumeration__array *) malloc(arraySize + 3*sizeof(int32_t)*dimen);

  result->d_dimen    = dimen;
  result->d_borrowed = 0;
  result->d_lower    = (int32_t *) ((char *) result + arraySize);
  result->d_upper    = result->d_lower + dimen;
  result->d_stride   = result->d_upper + dimen;
  memcpy(result->d_lower, lower, sizeof(int32_t)*dimen);
  memcpy(result->d_upper, upper, sizeof(int32_t)*dimen);
  return result;
}

/* Create a dense array of the given dimension with specified index bounds */
/*   This array owns and manages its data */
/*   All object pointers are initialized to NULL */
struct ANL_SIDLCompilerI_Enumeration__array * ANL_SIDLCompilerI_Enumeration__iorarray_create(
  int32_t dimen,
  const int32_t lower[],
  const int32_t upper[])
{
  struct ANL_SIDLCompilerI_Enumeration__array *result = newArray(dimen, lower, upper);
  int32_t size;
  int32_t i;

  for(i = 0, size = 1; i < dimen; i++) {
    result->d_stride[i] = size;
    size *= (upper[i] - lower[i] + 1);
  }
  size *= sizeof(struct ANL_SIDLCompilerI_Enumeration__object *);
  result->d_firstElement = (struct ANL_SIDLCompilerI_Enumeration__object **) malloc((size_t) size);
  memset(result->d_firstElement, 0, (size_t) size);
  return result;
}

/* Create an array using user-provided memory */
struct ANL_SIDLCompilerI_Enumeration__array * ANL_SIDLCompilerI_Enumeration__iorarray_borrow(
  struct ANL_SIDLCompilerI_Enumeration__object ** firstElement,
  int32_t dimen,
  const int32_t lower[],
  const int32_t upper[],
  const int32_t stride[])
{
  struct ANL_SIDLCompilerI_Enumeration__array *result = newArray(dimen, lower, upper);

  memcpy(result->d_stride, stride, sizeof(int32_t)*dimen);
  result->d_firstElement = firstElement;
  result->d_borrowed     = 1;
  return result;
}

/* Destroy the array (NULL arrays are ignored) */
void ANL_SIDLCompilerI_Enumeration__iorarray_destroy(
  struct ANL_SIDLCompilerI_Enumeration__array *array)
{
  if (array) {
    const int32_t dimen = array->d_dimen;

    if (!(array->d_borrowed)) {
      if (dimen > 0) {
        struct ANL_SIDLCompilerI_Enumeration__object **start = array->d_firstElement;
        struct ANL_SIDLCompilerI_Enumeration__object **end;
        int32_t size = 1;

        if (dimen > 1) {
          size = array->d_stride[dimen-1];
        }
        size *= (array->d_upper[dimen-1] - array->d_lower[dimen-1] + 1);
        end   = start + size;
        while(start < end) {
          if (*start) {
            (*(((struct SIDL_BaseClass__object *) (*start)->d_object)->d_epv->f_deleteReference))((*start)->d_object);
            *start = NULL;
          }
          ++start;
        }
      }
      free(array->d_firstElement);
    }
    memset(array, 0, sizeof(struct ANL_SIDLCompilerI_Enumeration__array) + 3*sizeof(int32_t)*dimen);
    free(array);
  }
}

/* Return the number of dimensions in the array */
/*   If the array pointer is NULL, zero is returned */
int32_t ANL_SIDLCompilerI_Enumeration__iorarray_dimen(
  const struct ANL_SIDLCompilerI_Enumeration__array *array)
{
  return array ? array->d_dimen : 0;
}

/* Return the lower bound on dimension ind */
/*   If the array pointer is NULL or ind is not a valid dimension, zero is returned */
int32_t ANL_SIDLCompilerI_Enumeration__iorarray_lower(
  const struct ANL_SIDLCompilerI_Enumeration__array *array,
  int32_t ind)
{
  return (array && (ind < array->d_dimen) && (ind >= 0)) ? array->d_lower[ind] : 0;
}

/* Return the upper bound on dimension ind */
/*   If the array pointer is NULL or ind is not a valid dimension, -1 is returned */
int32_t ANL_SIDLCompilerI_Enumeration__iorarray_upper(
  const struct ANL_SIDLCompilerI_Enumeration__array *array,
  int32_t ind)
{
  return (array && (ind < array->d_dimen) && (ind >= 0)) ? array->d_upper[ind] : -1;
}

/* Get an element of a multi-dimensional array */
/* This will use the indices provided up to the actual dimension of the array, ignoring extra indices */
/* If the return value is non-NULL, the client owns one reference to the object/interface */
/* The client must decrement the reference count when done with the reference */
struct ANL_SIDLCompilerI_Enumeration__object * ANL_SIDLCompilerI_Enumeration__iorarray_get(
  const struct ANL_SIDLCompilerI_Enumeration__array *array,
  const int32_t indices[])
{
  struct ANL_SIDLCompilerI_Enumeration__object **result = NULL;
  if (array && (array->d_dimen > 0)) {
    int32_t i;

    result = array->d_firstElement;
    for(i = 0; i < array->d_dimen; i++) {
      if ((indices[i] >= array->d_lower[i]) && (indices[i] <= array->d_upper[i])) {
        result += (array->d_stride[i]*(indices[i] - array->d_lower[i]));
      } else {
        result = NULL;
        break;
      }
    }
  }
  if (result) {
    if (*result) {
      (*(((struct SIDL_BaseClass__object *) (*result)->d_object)->d_epv->f_addReference))((*result)->d_object);
    }
    return *result;
  } else {
    return NULL;
  }
}

/* get an element of a multi-dimensional array */
/* This will use the indices provided up to the actual dimension of the array, ignoring extra indices */
/* If the return value is non-NULL, the client owns one reference to the object/interface */
/* The client must decrement the reference count when done with the reference */
struct ANL_SIDLCompilerI_Enumeration__object * ANL_SIDLCompilerI_Enumeration__iorarray_get4(
  const struct ANL_SIDLCompilerI_Enumeration__array *array,
  int32_t i1,
  int32_t i2,
  int32_t i3,
  int32_t i4)
{
  struct ANL_SIDLCompilerI_Enumeration__object **result = NULL;
  if (array) {
    result = array->d_firstElement;
    switch(array->d_dimen) {
    case 4:
      if ((i4 >= array->d_lower[3]) && (i4 <= array->d_upper[3])) {
        result += (array->d_stride[3]*(i4 - array->d_lower[3]));
      } else {
        result = NULL;
        break;
      }
      /* fall through */
    case 3:
      if ((i3 >= array->d_lower[2]) && (i3 <= array->d_upper[2])) {
        result += (array->d_stride[2]*(i3 - array->d_lower[2]));
      } else {
        result = NULL;
        break;
      }
      /* fall through */
    case 2:
      if ((i2 >= array->d_lower[1]) && (i2 <= array->d_upper[1])) {
        result += (array->d_stride[1]*(i2 - array->d_lower[1]));
      } else {
        result = NULL;
        break;
      }
      /* fall through */
    case 1:
      if ((i1 >= array->d_lower[0]) && (i1 <= array->d_upper[0])) {
        result += (array->d_stride[0]*(i1 - array->d_lower[0]));
      } else {
        result = NULL;
        break;
      }
      break;
    default:
      result = NULL;
      break;
    }
  }
  if (result) {
    if (*result) {
      (*(((struct SIDL_BaseClass__object *) (*result)->d_object)->d_epv->f_addReference))((*result)->d_object);
    }
    return *result;
  } else {
    return NULL;
  }
}

/* Set an element of a multi-dimensional array */
/* This will use the indices provided up to the actual dimension of the array, ignoring extra indices */
/* If the incoming value is non-NULL, this function will increment the reference code of the object/interface */
/* If it is overwriting a non-NULL pointer, the reference count of the object/interface being overwritten will be decremented */
void ANL_SIDLCompilerI_Enumeration__iorarray_set(
  struct ANL_SIDLCompilerI_Enumeration__array *array,
  const int32_t indices[],
  struct ANL_SIDLCompilerI_Enumeration__object * value)
{
  struct ANL_SIDLCompilerI_Enumeration__object **result = NULL;
  if (array && (array->d_dimen > 0)) {
    int32_t i;

    result = array->d_firstElement;
    for(i = 0; i < array->d_dimen; i++) {
      if ((indices[i] >= array->d_lower[i]) && (indices[i] <= array->d_upper[i])) {
        result += (array->d_stride[i]*(indices[i] - array->d_lower[i]));
      } else {
        result = NULL;
        break;
      }
    }
    if (result) {
      if (value) {
        (*(((struct SIDL_BaseClass__object *) value->d_object)->d_epv->f_addReference))(value->d_object);
      }
      if (*result) {
        (*(((struct SIDL_BaseClass__object *) (*result)->d_object)->d_epv->f_deleteReference))((*result)->d_object);
      }
      *result = value;
    }
  }
}

/* set an element of a multi-dimensional array */
/* This will use the indices provided up to the actual dimension of the array, ignoring extra indices */
/* If the incoming value is non-NULL, this function will increment the reference code of the object/interface */
/* If it is overwriting a non-NULL pointer, the reference count of the object/interface being overwritten will be decremented */
void ANL_SIDLCompilerI_Enumeration__iorarray_set4(
  struct ANL_SIDLCompilerI_Enumeration__array *array,
  int32_t i1,
  int32_t i2,
  int32_t i3,
  int32_t i4,
  struct ANL_SIDLCompilerI_Enumeration__object * value)
{
  struct ANL_SIDLCompilerI_Enumeration__object **result = NULL;
  if (array) {
    result = array->d_firstElement;
    switch(array->d_dimen) {
    case 4:
      if ((i4 >= array->d_lower[3]) && (i4 <= array->d_upper[3])) {
        result += (array->d_stride[3]*(i4 - array->d_lower[3]));
      } else {
        result = NULL;
        break;
      }
      /* fall through */
    case 3:
      if ((i3 >= array->d_lower[2]) && (i3 <= array->d_upper[2])) {
        result += (array->d_stride[2]*(i3 - array->d_lower[2]));
      } else {
        result = NULL;
        break;
      }
      /* fall through */
    case 2:
      if ((i2 >= array->d_lower[1]) && (i2 <= array->d_upper[1])) {
        result += (array->d_stride[1]*(i2 - array->d_lower[1]));
      } else {
        result = NULL;
        break;
      }
      /* fall through */
    case 1:
      if ((i1 >= array->d_lower[0]) && (i1 <= array->d_upper[0])) {
        result += (array->d_stride[0]*(i1 - array->d_lower[0]));
      } else {
        result = NULL;
        break;
      }
      break;
    default:
      result = NULL;
      break;
    }
  }
  if (result) {
    if (value) {
      (*(((struct SIDL_BaseClass__object *) value->d_object)->d_epv->f_addReference))(value->d_object);
    }
    if (*result) {
      (*(((struct SIDL_BaseClass__object *) (*result)->d_object)->d_epv->f_deleteReference))((*result)->d_object);
    }
    *result = value;
  }
}

static const struct ANL_SIDLCompilerI_Enumeration__external s_externalEntryPoints = {
  ANL_SIDLCompilerI_Enumeration__new,
  NULL /*ANL_SIDLCompilerI_Enumeration__remote*/,
  ANL_SIDLCompilerI_Enumeration__iorarray_create,
  ANL_SIDLCompilerI_Enumeration__iorarray_borrow,
  ANL_SIDLCompilerI_Enumeration__iorarray_destroy,
  ANL_SIDLCompilerI_Enumeration__iorarray_dimen,
  ANL_SIDLCompilerI_Enumeration__iorarray_lower,
  ANL_SIDLCompilerI_Enumeration__iorarray_upper,
  ANL_SIDLCompilerI_Enumeration__iorarray_get,
  ANL_SIDLCompilerI_Enumeration__iorarray_get4,
  ANL_SIDLCompilerI_Enumeration__iorarray_set,
  ANL_SIDLCompilerI_Enumeration__iorarray_set4
};

/* This function returns a pointer to a static structure of pointers to function entry points */
/* It is called upon loading the DLL */
const struct ANL_SIDLCompilerI_Enumeration__external *ANL_SIDLCompilerI_Enumeration__externals()
{
  return &s_externalEntryPoints;
}
