# DO-NOT-DELETE splicer.begin(_initial)
# Put your code here...
pass
# DO-NOT-DELETE splicer.end(_initial)

import SIDL.NullIORException
import SIDL.BaseInterface
import SIDLLanguage.Visitor
import SIDLLanguage.ASTException
import SIDL.BaseException
import SIDLLanguage.AST
import SIDLLanguage.Comment
import SIDLLanguage.Code
import SIDLLanguage.CodeGeneratorException
import SIDLLanguage.Attribute

# DO-NOT-DELETE splicer.begin(_before_type)
import sys
# DO-NOT-DELETE splicer.end(_before_type)

class AST:
  # All calls to SIDL methods should use __IORself

  def __init__(self, IORself):
    self.__IORself = IORself
    # DO-NOT-DELETE splicer.begin(__init__)
    self.identifier   = None
    self.parent       = None
    self.children     = []
    self.dependencies = []
    self.comments     = []
    self.attributes   = {}
    self.code         = {}
    # DO-NOT-DELETE splicer.end(__init__)

  def accept(self, visitor):
    '''
    // Support the visitor pattern for traversal.
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # visitor SIDLLanguage.Visitor
    # DO-NOT-DELETE splicer.begin(accept)
    try:
      visitor.visitAST(self.__IORself)
    except SIDLLanguage.VisitorException.Exception, ex:
      e = SIDLLanguage.ASTException.ASTException()
      e.setMessage(ex.getMessage())
      e.addToStackTrace(ex.getStackTrace().strip())
      e.addToTrace(__file__, sys._getframe().f_lineno, sys._getframe().f_code.co_name)
      raise SIDLLanguage.ASTException.Exception, e
    # DO-NOT-DELETE splicer.end(accept)

  def getIdentifier(self):
    '''
    // Retrieve the identifier associated with this node
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # string _return
    # DO-NOT-DELETE splicer.begin(getIdentifier)
    return self.identifier
    # DO-NOT-DELETE splicer.end(getIdentifier)

  def setIdentifier(self, identifier):
    '''
    // Assign the identifier associated with this node
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # identifier string
    # DO-NOT-DELETE splicer.begin(setIdentifier)
    self.identifier = identifier
    # DO-NOT-DELETE splicer.end(setIdentifier)

  def getFullIdentifier(self):
    '''
    // Retrieve the fully qualified identifier associated with this node
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # string _return
    # DO-NOT-DELETE splicer.begin(getFullIdentifier)
    return self.identifier
    # DO-NOT-DELETE splicer.end(getFullIdentifier)

  def getParent(self):
    '''
    // Retrieve the parent of this node
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # SIDLLanguage.AST _return
    # DO-NOT-DELETE splicer.begin(getParent)
    return self.parent
    # DO-NOT-DELETE splicer.end(getParent)

  def setParent(self, parent):
    '''
    // Assign the parent of this node
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # parent SIDLLanguage.AST
    # DO-NOT-DELETE splicer.begin(setParent)
    self.parent = parent
    # DO-NOT-DELETE splicer.end(setParent)

  def getChildren(self):
    '''
    // Retrieve the children of this node
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # array _return
    # DO-NOT-DELETE splicer.begin(getChildren)
    return self.children
    # DO-NOT-DELETE splicer.end(getChildren)

  def setChildren(self, children):
    '''
    // Assign the children of this node
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # children array
    # DO-NOT-DELETE splicer.begin(setChildren)
    self.children = list(children)
    for child in children:
      child.setParent(self.__IORself)
    # DO-NOT-DELETE splicer.end(setChildren)

  def addChildren(self, children):
    '''
    // Add to the children of this node (duplicates allowed)
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # children array
    # DO-NOT-DELETE splicer.begin(addChildren)
    self.children.extend(children)
    for child in children:
      child.setParent(self.__IORself)
    # DO-NOT-DELETE splicer.end(addChildren)

  def getDependencies(self):
    '''
    // Retrieve nodes on which this node depends
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # array _return
    # DO-NOT-DELETE splicer.begin(getDependencies)
    return self.dependencies
    # DO-NOT-DELETE splicer.end(getDependencies)

  def setDependencies(self, dependencies):
    '''
    // Set nodes on which this node depends
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # dependencies array
    # DO-NOT-DELETE splicer.begin(setDependencies)
    self.dependencies = dependencies
    # DO-NOT-DELETE splicer.end(setDependencies)

  def addDependency(self, dependency):
    '''
    // Add nodes on which this node depends
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # dependency SIDLLanguage.AST
    # DO-NOT-DELETE splicer.begin(addDependency)
    if dependency.isSame(self.__IORself): return
    for dep in self.dependencies:
      if dep.isSame(dependency): return
    self.dependencies.append(dependency)
    # DO-NOT-DELETE splicer.end(addDependency)

  def getComments(self):
    '''
    // Retrieve the comments of this node
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # array _return
    # DO-NOT-DELETE splicer.begin(getComments)
    return self.comments
    # DO-NOT-DELETE splicer.end(getComments)

  def setComments(self, comments):
    '''
    // Assign the children of this node
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # comments array
    # DO-NOT-DELETE splicer.begin(setComments)
    self.comments = comments
    # DO-NOT-DELETE splicer.end(setComments)

  def addComments(self, comments):
    '''
    // Add to the children of this node (duplicates allowed)
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # comments array
    # DO-NOT-DELETE splicer.begin(addComments)
    self.comments.extend(comments)
    # DO-NOT-DELETE splicer.end(addComments)

  def getCode(self, language):
    '''
    // Retrieve source code for a given language, or empty string for everything
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # language string
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # array _return
    # DO-NOT-DELETE splicer.begin(getCode)
    if self.code.has_key(language):
      return self.code[language].values()
    else:
      return []
    # DO-NOT-DELETE splicer.end(getCode)

  def setCode(self, code):
    '''
    // Set source code
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # code array
    # DO-NOT-DELETE splicer.begin(setCode)
    self.code = {}
    for c in code:
      language = c.getLanguage()
      if not self.code.has_key(language):
        self.code[language] = {}
      self.code[language][c.getLabel()] = c
    # DO-NOT-DELETE splicer.end(setCode)

  def addCode(self, code):
    '''
    // Add source code
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # code SIDLLanguage.Code
    # DO-NOT-DELETE splicer.begin(addCode)
    language = code.getLanguage()
    if not self.code.has_key(language):
      self.code[language] = {}
    self.code[language][code.getLabel()] = code
    # DO-NOT-DELETE splicer.end(addCode)

  def hasCodeBlock(self, language, label):
    '''
    // Determine whether the source block with a particular label is present
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # language string
    # label string
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # bool _return
    # DO-NOT-DELETE splicer.begin(hasCodeBlock)
    if self.code.has_key(language):
      if self.code[language].has_key(label):
        return 1
      else:
        return 0
    else:
      return 0
    # DO-NOT-DELETE splicer.end(hasCodeBlock)

  def getCodeBlock(self, language, label):
    '''
    // Get the source block with a particular label
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # language string
    # label string
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # SIDLLanguage.Code _return
    # DO-NOT-DELETE splicer.begin(getCodeBlock)
    try:
      return self.code[language][label]
    except KeyError:
      e = SIDLLanguage.CodeGeneratorException.CodeGeneratorException()
      if self.code.has_key(language):
        e.setMessage('No code for '+language+' called '+label+' in '+str(self.code[language].keys()))
      else:
        e.setMessage('No code for '+language)
      e.addToTrace(__file__, sys._getframe().f_lineno, sys._getframe().f_code.co_name)
      raise SIDLLanguage.CodeGeneratorException.Exception, e
    # DO-NOT-DELETE splicer.end(getCodeBlock)

  def removeCodeBlock(self, language, label):
    '''
    // Remove the source block with a particular label
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # language string
    # label string
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # SIDLLanguage.Code _return
    # DO-NOT-DELETE splicer.begin(removeCodeBlock)
    try:
      del self.code[language][label]
    except KeyError:
      e = SIDLLanguage.CodeGeneratorException.CodeGeneratorException()
      if self.code.has_key(language):
        e.setMessage('No code for '+language+' called '+label+' in '+str(self.code[language].keys()))
      else:
        e.setMessage('No code for '+language)
      e.addToTrace(__file__, sys._getframe().f_lineno, sys._getframe().f_code.co_name)
      raise SIDLLanguage.CodeGeneratorException.Exception, e
    # DO-NOT-DELETE splicer.end(removeCodeBlock)

  def getAttributes(self):
    '''
    // Get attribute list for this node
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # array _return
    # DO-NOT-DELETE splicer.begin(getAttributes)
    return self.attributes.values()
    # DO-NOT-DELETE splicer.end(getAttributes)

  def setAttributes(self, attributes):
    '''
    // Set attribute list for this node
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # attributes array
    # DO-NOT-DELETE splicer.begin(setAttributes)
    self.attributes.clear()
    for attribute in attributes:
      self.addAttribute(attribute)
    # DO-NOT-DELETE splicer.end(setAttributes)

  def hasAttribute(self, name):
    '''
    // Determine whether an attribute is present on this node
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # name string
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # bool _return
    # DO-NOT-DELETE splicer.begin(hasAttribute)
    return self.attributes.has_key(name)
    # DO-NOT-DELETE splicer.end(hasAttribute)

  def addAttribute(self, attribute):
    '''
    // Add attribute to this node
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # attribute SIDLLanguage.Attribute
    # DO-NOT-DELETE splicer.begin(addAttribute)
    self.attributes[attribute.getName()] = attribute
    # DO-NOT-DELETE splicer.end(addAttribute)

  def deleteAttribute(self, name):
    '''
    // Remove an attribute on this node
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # name string
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # SIDLLanguage.Attribute _return
    # DO-NOT-DELETE splicer.begin(deleteAttribute)
    del self.attributes[name]
    # DO-NOT-DELETE splicer.end(deleteAttribute)

  def getAttribute(self, name):
    '''
    // Get an attribute on this node
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # name string
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # SIDLLanguage.Attribute _return
    # DO-NOT-DELETE splicer.begin(getAttribute)
    return self.attributes[name]
    # DO-NOT-DELETE splicer.end(getAttribute)

# DO-NOT-DELETE splicer.begin(_final)
# Put your code here...
pass
# DO-NOT-DELETE splicer.end(_final)

