# DO-NOT-DELETE splicer.begin(_initial)
# Put your code here...
pass
# DO-NOT-DELETE splicer.end(_initial)

import SIDLLanguage.Visitor
import SIDLLanguage.ASTException
import SIDL.NullIORException
import SIDL.BaseException
import SIDL.BaseInterface
import SIDLLanguage.AST
import SIDLLanguage.Comment
import SIDLLanguage.Code
import SIDLLanguage.CodeGeneratorException
import SIDLLanguage.Attribute
import SIDLLanguage.Interface
import SIDLLanguage.Method

# DO-NOT-DELETE splicer.begin(_before_type)
import sys
# DO-NOT-DELETE splicer.end(_before_type)

class Class:
  # All calls to SIDL methods should use __IORself

  def __init__(self, IORself):
    self.__IORself = IORself
    # DO-NOT-DELETE splicer.begin(__init__)
    self.isAbstract  = 0
    self.interfaces  = []
    self.implMethods = []
    # DO-NOT-DELETE splicer.end(__init__)

  def accept(self, visitor):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # visitor SIDLLanguage.Visitor
    # DO-NOT-DELETE splicer.begin(accept)
    try:
      visitor.visitClass(self.__IORself)
    except SIDLLanguage.VisitorException.Exception, ex:
      e = SIDLLanguage.ASTException.ASTException()
      e.setMessage(ex.getMessage())
      e.addToStackTrace(ex.getStackTrace().strip())
      e.addToTrace(__file__, sys._getframe().f_lineno, sys._getframe().f_code.co_name)
      raise SIDLLanguage.ASTException.Exception, e
    # DO-NOT-DELETE splicer.end(accept)

  def getAbstract(self):
    '''
    // Retrieve the flag indicating whether the class is abstract
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # bool _return
    # DO-NOT-DELETE splicer.begin(getAbstract)
    return self.isAbstract
    # DO-NOT-DELETE splicer.end(getAbstract)

  def setAbstract(self, isAbstract):
    '''
    // Set the flag indicating whether the class is abstract
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # isAbstract bool
    # DO-NOT-DELETE splicer.begin(setAbstract)
    self.isAbstract = isAbstract
    # DO-NOT-DELETE splicer.end(setAbstract)

  def getInterfaces(self):
    '''
    // Retrieve the interfaces implemented by this class
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # array _return
    # DO-NOT-DELETE splicer.begin(getInterfaces)
    return self.interfaces
    # DO-NOT-DELETE splicer.end(getInterfaces)

  def setInterfaces(self, interfaces):
    '''
    // Set the interfaces implemented by this class
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # interfaces array
    # DO-NOT-DELETE splicer.begin(setInterfaces)
    self.interfaces = list(interfaces)
    # DO-NOT-DELETE splicer.end(setInterfaces)

  def addInterfaces(self, interfaces):
    '''
    // Add to the interfaces implemented by this class
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # interfaces array
    # DO-NOT-DELETE splicer.begin(addInterfaces)
    self.interfaces.extend(interfaces)
    # DO-NOT-DELETE splicer.end(addInterfaces)

  def getImplementedMethods(self):
    '''
    // Retrieve the set of methods implemented by this class
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # array _return
    # DO-NOT-DELETE splicer.begin(getImplementedMethods)
    return self.implMethods
    # DO-NOT-DELETE splicer.end(getImplementedMethods)

  def setImplementedMethods(self, methods):
    '''
    // Set the set of methods implemented by this class
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # methods array
    # DO-NOT-DELETE splicer.begin(setImplementedMethods)
    self.implMethods = list(interfaces)
    # DO-NOT-DELETE splicer.end(setImplementedMethods)

  def addImplementedMethods(self, methods):
    '''
    // Add to the set of methods implemented by this class
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # methods array
    # DO-NOT-DELETE splicer.begin(addImplementedMethods)
    # Check for duplicates
    for method in methods:
      same = 0
      for m in self.implMethods:
        if m.getIdentifier() == method.getIdentifier():
          same = 1
      if not same:
        self.implMethods.append(method)
    # DO-NOT-DELETE splicer.end(addImplementedMethods)

# DO-NOT-DELETE splicer.begin(_final)
# Put your code here...
pass
# DO-NOT-DELETE splicer.end(_final)

