# DO-NOT-DELETE splicer.begin(_initial)
pass
# DO-NOT-DELETE splicer.end(_initial)

import SIDL.NullIORException
import SIDL.BaseInterface
import SIDL.BaseException
import SIDLLanguage.CodeGeneratorException

# DO-NOT-DELETE splicer.begin(_before_type)
import OpaqueObject
# DO-NOT-DELETE splicer.end(_before_type)

class CodeArgDB:
  '''
  // Source code stored in the argument database
  //   The opaque access returns the argument database
  '''
  # All calls to SIDL methods should use __IORself

  def __init__(self, IORself):
    self.__IORself = IORself
    # DO-NOT-DELETE splicer.begin(__init__)
    self.language = ''
    self.label    = ''
    self.argDB    = None
    self.code     = None
    # DO-NOT-DELETE splicer.end(__init__)

  def getLanguage(self):
    '''
    // Retrieve the source language
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # string _return
    # DO-NOT-DELETE splicer.begin(getLanguage)
    return self.language
    # DO-NOT-DELETE splicer.end(getLanguage)

  def setLanguage(self, language):
    '''
    // Set the source language
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # language string
    # DO-NOT-DELETE splicer.begin(setLanguage)
    self.language = language
    # DO-NOT-DELETE splicer.end(setLanguage)

  def getLabel(self):
    '''
    // Retrieve the code block label
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # string _return
    # DO-NOT-DELETE splicer.begin(getLabel)
    return self.label
    # DO-NOT-DELETE splicer.end(getLabel)

  def setLabel(self, label):
    '''
    // Set the code block label
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # label string
    # DO-NOT-DELETE splicer.begin(setLabel)
    if not self.code is None:
      self.close()
    self.label = label
    self.code  = SIDLLanguage.Code.Code(SIDL.Loader.createClass('ANL.SIDLCompilerI.Code'))
    # DO-NOT-DELETE splicer.end(setLabel)

  def getSource(self):
    '''
    // Retrieve the source itself
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # string _return
    # DO-NOT-DELETE splicer.begin(getSource)
    if self.code is None:
      return ''
    else:
      return self.code.getSource()
    # DO-NOT-DELETE splicer.end(getSource)

  def setSource(self, source):
    '''
    // Set the source itself
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # source string
    # DO-NOT-DELETE splicer.begin(setSource)
    if not self.code is None: self.code.setSource()
    # DO-NOT-DELETE splicer.end(setSource)

  def getTabLevel(self):
    '''
    // Retrieve the current number of tabs
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # int _return
    # DO-NOT-DELETE splicer.begin(getTabLevel)
    if self.code is None:
      return ''
    else:
      return self.code.getTabLevel()
    # DO-NOT-DELETE splicer.end(getTabLevel)

  def setTabLevel(self, tabLevel):
    '''
    // Set the current number of tabs
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # tabLevel int
    # DO-NOT-DELETE splicer.begin(setTabLevel)
    if not self.code is None: self.code.setTabLevel(tabLevel)
    # DO-NOT-DELETE splicer.end(setTabLevel)

  def increaseTabLevel(self):
    '''
    // Increase the current number of tabs by one
    '''
    # DO-NOT-DELETE splicer.begin(increaseTabLevel)
    if not self.code is None: self.code.increaseTabLevel()
    # DO-NOT-DELETE splicer.end(increaseTabLevel)

  def decreaseTabLevel(self):
    '''
    // Decrease the current number of tabs by one
    '''
    # DO-NOT-DELETE splicer.begin(decreaseTabLevel)
    if not self.code is None: self.code.decreaseTabLevel()
    # DO-NOT-DELETE splicer.end(decreaseTabLevel)

  def indent(self):
    '''
    // Write the current indenting
    '''
    # DO-NOT-DELETE splicer.begin(indent)
    if not self.code is None: self.code.indent()
    # DO-NOT-DELETE splicer.end(indent)

  def write(self, s):
    '''
    // Write the string with no indenting
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # s string
    # DO-NOT-DELETE splicer.begin(write)
    if not self.code is None: self.code.write(s)
    # DO-NOT-DELETE splicer.end(write)

  def println(self, s):
    '''
    // Write the string with indenting and a newline
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # s string
    # DO-NOT-DELETE splicer.begin(println)
    if not self.code is None: self.code.println(s)
    # DO-NOT-DELETE splicer.end(println)

  def close(self):
    '''
    // Close the code stream, releasing any resources it might be using
    '''
    # DO-NOT-DELETE splicer.begin(close)
    if self.code is None or self.argDB is None: return
    self.argDB[self.label] = self.code.getSource()
    # DO-NOT-DELETE splicer.end(close)

  def getInt(self):
    '''
    // Get an integer representing the underlying object
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # int _return
    # DO-NOT-DELETE splicer.begin(getInt)
    if self.argDB is None: return 0
    return OpaqueObject.set(self.argDB)
    # DO-NOT-DELETE splicer.end(getInt)

  def setInt(self, value):
    '''
    // Set the integer representing the underlying object
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # value int
    # DO-NOT-DELETE splicer.begin(setInt)
    if not self.code is None:
      self.close()
    self.argDB = OpaqueObject.get(value)
    # DO-NOT-DELETE splicer.end(setInt)

# DO-NOT-DELETE splicer.begin(_final)
pass
# DO-NOT-DELETE splicer.end(_final)

