# DO-NOT-DELETE splicer.begin(_initial)
# Put your code here...
pass
# DO-NOT-DELETE splicer.end(_initial)

import SIDL.NullIORException
import SIDL.BaseInterface
import SIDL.BaseException
import SIDLLanguage.CodeGeneratorException

# DO-NOT-DELETE splicer.begin(_before_type)
import sys
# DO-NOT-DELETE splicer.end(_before_type)

class Code:
  '''
  // Source code stored in an object
  '''
  # All calls to SIDL methods should use __IORself

  def __init__(self, IORself):
    self.__IORself = IORself
    # DO-NOT-DELETE splicer.begin(__init__)
    self.language = ''
    self.label    = ''
    self.source   = ''
    self.tab      = '  '
    self.tabLevel = 0
    # DO-NOT-DELETE splicer.end(__init__)

  def getLanguage(self):
    '''
    // Retrieve the source language
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # string _return
    # DO-NOT-DELETE splicer.begin(getLanguage)
    return self.language
    # DO-NOT-DELETE splicer.end(getLanguage)

  def setLanguage(self, language):
    '''
    // Set the source language
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # language string
    # DO-NOT-DELETE splicer.begin(setLanguage)
    self.language = language
    # DO-NOT-DELETE splicer.end(setLanguage)

  def getLabel(self):
    '''
    // Retrieve the code block label
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # string _return
    # DO-NOT-DELETE splicer.begin(getLabel)
    return self.label
    # DO-NOT-DELETE splicer.end(getLabel)

  def setLabel(self, label):
    '''
    // Set the code block label
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # label string
    # DO-NOT-DELETE splicer.begin(setLabel)
    self.label = label
    # DO-NOT-DELETE splicer.end(setLabel)

  def getSource(self):
    '''
    // Retrieve the source itself
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # string _return
    # DO-NOT-DELETE splicer.begin(getSource)
    return self.source
    # DO-NOT-DELETE splicer.end(getSource)

  def setSource(self, source):
    '''
    // Set the source itself
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # source string
    # DO-NOT-DELETE splicer.begin(setSource)
    self.source = source
    # DO-NOT-DELETE splicer.end(setSource)

  def getTabLevel(self):
    '''
    // Retrieve the current number of tabs
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # int _return
    # DO-NOT-DELETE splicer.begin(getTabLevel)
    return self.tabLevel
    # DO-NOT-DELETE splicer.end(getTabLevel)

  def setTabLevel(self, tabLevel):
    '''
    // Set the current number of tabs
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # tabLevel int
    # DO-NOT-DELETE splicer.begin(setTabLevel)
    self.tabLevel = tabLevel
    # DO-NOT-DELETE splicer.end(setTabLevel)

  def increaseTabLevel(self):
    '''
    // Increase the current number of tabs by one
    '''
    # DO-NOT-DELETE splicer.begin(increaseTabLevel)
    self.tabLevel += 1
    # DO-NOT-DELETE splicer.end(increaseTabLevel)

  def decreaseTabLevel(self):
    '''
    // Decrease the current number of tabs by one
    '''
    # DO-NOT-DELETE splicer.begin(decreaseTabLevel)
    self.tabLevel -= 1
    if self.tabLevel < 0:
      e = SIDLLanguage.CodeGeneratorException.CodeGeneratorException()
      e.setMessage('Tab level decreased below zero: '+str(self.tabLevel))
      e.addToTrace(__file__, sys._getframe().f_lineno, sys._getframe().f_code.co_name)
      raise SIDLLanguage.CodeGeneratorException.Exception, e
    # DO-NOT-DELETE splicer.end(decreaseTabLevel)

  def indent(self):
    '''
    // Write the current indenting
    '''
    # DO-NOT-DELETE splicer.begin(indent)
    for i in range(self.tabLevel):
      self.write(self.tab)
    # DO-NOT-DELETE splicer.end(indent)

  def write(self, s):
    '''
    // Write the string with no indenting
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # s string
    # DO-NOT-DELETE splicer.begin(write)
    self.source += s
    # DO-NOT-DELETE splicer.end(write)

  def println(self, s):
    '''
    // Write the string with indenting and a newline
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # s string
    # DO-NOT-DELETE splicer.begin(println)
    if s:
      self.indent()
      self.write(s)
    self.write('\n')
    # DO-NOT-DELETE splicer.end(println)

  def close(self):
    '''
    // Close the code stream, releasing any resources it might be using
    '''
    # DO-NOT-DELETE splicer.begin(close)
    pass
    # DO-NOT-DELETE splicer.end(close)

# DO-NOT-DELETE splicer.begin(_final)
# Put your code here...
pass
# DO-NOT-DELETE splicer.end(_final)

