# DO-NOT-DELETE splicer.begin(_initial)
# Put your code here...
pass
# DO-NOT-DELETE splicer.end(_initial)

import SIDLLanguage.Visitor
import SIDLLanguage.ASTException
import SIDL.NullIORException
import SIDL.BaseException
import SIDL.BaseInterface
import SIDLLanguage.AST
import SIDLLanguage.Comment
import SIDLLanguage.Code
import SIDLLanguage.CodeGeneratorException
import SIDLLanguage.Attribute
import SIDLLanguage.Interface
import SIDLLanguage.Method

# DO-NOT-DELETE splicer.begin(_before_type)
import sys
# DO-NOT-DELETE splicer.end(_before_type)

class Interface:
  # All calls to SIDL methods should use __IORself

  def __init__(self, IORself):
    self.__IORself = IORself
    # DO-NOT-DELETE splicer.begin(__init__)
    self.parents = []
    self.methods = []
    # DO-NOT-DELETE splicer.end(__init__)

  def accept(self, visitor):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # visitor SIDLLanguage.Visitor
    # DO-NOT-DELETE splicer.begin(accept)
    try:
      visitor.visitInterface(self.__IORself)
    except SIDLLanguage.VisitorException.Exception, ex:
      e = SIDLLanguage.ASTException.ASTException()
      e.setMessage(ex.getMessage())
      e.addToStackTrace(ex.getStackTrace().strip())
      e.addToTrace(__file__, sys._getframe().f_lineno, sys._getframe().f_code.co_name)
      raise SIDLLanguage.ASTException.Exception, e
    # DO-NOT-DELETE splicer.end(accept)

  def getParents(self):
    '''
    // Retrieve the superinterfaces of this interface
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # array _return
    # DO-NOT-DELETE splicer.begin(getParents)
    return self.parents
    # DO-NOT-DELETE splicer.end(getParents)

  def setParents(self, parents):
    '''
    // Set the superinterfaces of this interface
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # parents array
    # DO-NOT-DELETE splicer.begin(setParents)
    self.parents = list(parents)
    # DO-NOT-DELETE splicer.end(setParents)

  def addParents(self, parents):
    '''
    // Add superinterfaces to this interface
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # parents array
    # DO-NOT-DELETE splicer.begin(addParents)
    self.parents.extend(parents)
    # DO-NOT-DELETE splicer.end(addParents)

  def getMethods(self):
    '''
    // Retrieve the union of all methods supported by this interface
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # array _return
    # DO-NOT-DELETE splicer.begin(getMethods)
    return self.methods
    # DO-NOT-DELETE splicer.end(getMethods)

  def setMethods(self, methods):
    '''
    // Set the union of all methods supported by this interface
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # methods array
    # DO-NOT-DELETE splicer.begin(setMethods)
    self.methods = methods
    # DO-NOT-DELETE splicer.end(setMethods)

  def addMethods(self, methods):
    '''
    // Add to the union of all methods supported by this interface
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # methods array
    # DO-NOT-DELETE splicer.begin(addMethods)
    for method in methods:
      same = 0
      for m in self.methods:
        if m.getIdentifier() == method.getIdentifier():
          same = 1
          break
      if not same: self.methods.append(method)
    # DO-NOT-DELETE splicer.end(addMethods)

# DO-NOT-DELETE splicer.begin(_final)
# Put your code here...
pass
# DO-NOT-DELETE splicer.end(_final)

