# DO-NOT-DELETE splicer.begin(_initial)
# Put your code here...
pass
# DO-NOT-DELETE splicer.end(_initial)

import SIDLLanguage.Visitor
import SIDLLanguage.ASTException
import SIDL.NullIORException
import SIDL.BaseException
import SIDL.BaseInterface
import SIDLLanguage.AST
import SIDLLanguage.Comment
import SIDLLanguage.Code
import SIDLLanguage.CodeGeneratorException
import SIDLLanguage.Attribute
import SIDLLanguage.Type
import SIDLLanguage.Class

# DO-NOT-DELETE splicer.begin(_before_type)
import sys
# DO-NOT-DELETE splicer.end(_before_type)

class Method:
  # All calls to SIDL methods should use __IORself

  def __init__(self, IORself):
    self.__IORself = IORself
    # DO-NOT-DELETE splicer.begin(__init__)
    self.returnType = None
    self.exceptions = []
    self.isStatic   = 0
    self.isFinal    = 0
    self.isAbstract = 0
    self.isInternal = 0
    self.templateIdentifiers = []
    # DO-NOT-DELETE splicer.end(__init__)

  def accept(self, visitor):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # visitor SIDLLanguage.Visitor
    # DO-NOT-DELETE splicer.begin(accept)
    try:
      visitor.visitMethod(self.__IORself)
    except SIDLLanguage.VisitorException.Exception, ex:
      e = SIDLLanguage.ASTException.ASTException()
      e.setMessage(ex.getMessage())
      e.addToStackTrace(ex.getStackTrace().strip())
      e.addToTrace(__file__, sys._getframe().f_lineno, sys._getframe().f_code.co_name)
      raise SIDLLanguage.ASTException.Exception, e
    # DO-NOT-DELETE splicer.end(accept)

  def getFullIdentifier(self):
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # string _return
    # DO-NOT-DELETE splicer.begin(getFullIdentifier)
    fullName = self.__IORself.getIdentifier()
    parent   = self.__IORself.getParent()
    while parent.isInstanceOf('SIDLLanguage.Package') or parent.isInstanceOf('SIDLLanguage.Interface'):
      fullName = parent.getIdentifier()+'.'+fullName
      parent   = parent.getParent()
    return fullName
    # DO-NOT-DELETE splicer.end(getFullIdentifier)

  def getReturnType(self):
    '''
    // Retrieve the return type
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # SIDLLanguage.Type _return
    # DO-NOT-DELETE splicer.begin(getReturnType)
    return self.returnType
    # DO-NOT-DELETE splicer.end(getReturnType)

  def setReturnType(self, type):
    '''
    // Set the return type
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # type SIDLLanguage.Type
    # DO-NOT-DELETE splicer.begin(setReturnType)
    self.returnType = type
    # DO-NOT-DELETE splicer.end(setReturnType)

  def getExceptions(self):
    '''
    // Retrieve the exceptions thrown by the method
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # array _return
    # DO-NOT-DELETE splicer.begin(getExceptions)
    return self.exceptions
    # DO-NOT-DELETE splicer.end(getExceptions)

  def setExceptions(self, exceptions):
    '''
    // Set the exceptions thrown by the method
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # exceptions array
    # DO-NOT-DELETE splicer.begin(setExceptions)
    self.exceptions = exceptions
    # DO-NOT-DELETE splicer.end(setExceptions)

  def addExceptions(self, exceptions):
    '''
    // Add to the exceptions thrown by the method
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # exceptions array
    # DO-NOT-DELETE splicer.begin(addExceptions)
    self.exceptions.extend(exceptions)
    # DO-NOT-DELETE splicer.end(addExceptions)

  def getStatic(self):
    '''
    // Retrieve the flag indicating whether the method is static
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # bool _return
    # DO-NOT-DELETE splicer.begin(getStatic)
    return self.isStatic
    # DO-NOT-DELETE splicer.end(getStatic)

  def setStatic(self, isStatic):
    '''
    // Set the flag indicating whether the method is static
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # isStatic bool
    # DO-NOT-DELETE splicer.begin(setStatic)
    self.isStatic = isStatic
    # DO-NOT-DELETE splicer.end(setStatic)

  def getFinal(self):
    '''
    // Retrieve the flag indicating whether the method is final
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # bool _return
    # DO-NOT-DELETE splicer.begin(getFinal)
    return self.isFinal
    # DO-NOT-DELETE splicer.end(getFinal)

  def setFinal(self, isFinal):
    '''
    // Set the flag indicating whether the method is final
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # isFinal bool
    # DO-NOT-DELETE splicer.begin(setFinal)
    self.isFinal = isFinal
    # DO-NOT-DELETE splicer.end(setFinal)

  def getAbstract(self):
    '''
    // Retrieve the flag indicating whether the method is abstract
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # bool _return
    # DO-NOT-DELETE splicer.begin(getAbstract)
    return self.isAbstract
    # DO-NOT-DELETE splicer.end(getAbstract)

  def setAbstract(self, isAbstract):
    '''
    // Set the flag indicating whether the method is abstract
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # isAbstract bool
    # DO-NOT-DELETE splicer.begin(setAbstract)
    self.isAbstract = isAbstract
    # DO-NOT-DELETE splicer.end(setAbstract)

  def getInternal(self):
    '''
    // Retrieve the flag indicating whether the method is not present in the SIDL interface
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # bool _return
    # DO-NOT-DELETE splicer.begin(getInternal)
    return self.isInternal
    # DO-NOT-DELETE splicer.end(getInternal)

  def setInternal(self, isInternal):
    '''
    // Set the flag indicating whether the method is not present in the SIDL interface
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # isInternal bool
    # DO-NOT-DELETE splicer.begin(setInternal)
    self.isInternal = isInternal
    # DO-NOT-DELETE splicer.end(setInternal)

  def getTemplateIdentifiers(self):
    '''
    // Get the identifiers which are quantified over types
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # array _return
    # DO-NOT-DELETE splicer.begin(getTemplateIdentifiers)
    return self.templateIdentifiers
    # DO-NOT-DELETE splicer.end(getTemplateIdentifiers)

  def setTemplateIdentifiers(self, templateIds):
    '''
    // Set the identifiers which are quantified over types
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # templateIds array
    # DO-NOT-DELETE splicer.begin(setTemplateIdentifiers)
    self.templateIdentifiers = templateIds
    # DO-NOT-DELETE splicer.end(setTemplateIdentifiers)

# DO-NOT-DELETE splicer.begin(_final)
# Put your code here...
pass
# DO-NOT-DELETE splicer.end(_final)

