# DO-NOT-DELETE splicer.begin(_initial)
# Put your code here...
pass
# DO-NOT-DELETE splicer.end(_initial)

import SIDLLanguage.Visitor
import SIDLLanguage.ASTException
import SIDL.NullIORException
import SIDL.BaseException
import SIDL.BaseInterface
import SIDLLanguage.AST
import SIDLLanguage.Comment
import SIDLLanguage.Code
import SIDLLanguage.CodeGeneratorException
import SIDLLanguage.Attribute
import SIDLLanguage.Type
import SIDLLanguage.ParameterAccessMode

# DO-NOT-DELETE splicer.begin(_before_type)
import sys
# DO-NOT-DELETE splicer.end(_before_type)

class Parameter:
  # All calls to SIDL methods should use __IORself

  def __init__(self, IORself):
    self.__IORself = IORself
    # DO-NOT-DELETE splicer.begin(__init__)
    self.type       = None
    self.accessMode = None
    self.isRequired = 0
    self.isCopy     = 0
    # DO-NOT-DELETE splicer.end(__init__)

  def accept(self, visitor):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # visitor SIDLLanguage.Visitor
    # DO-NOT-DELETE splicer.begin(accept)
    try:
      visitor.visitParameter(self.__IORself)
    except SIDLLanguage.VisitorException.Exception, ex:
      e = SIDLLanguage.ASTException.ASTException()
      e.setMessage(ex.getMessage())
      e.addToStackTrace(ex.getStackTrace().strip())
      e.addToTrace(__file__, sys._getframe().f_lineno, sys._getframe().f_code.co_name)
      raise SIDLLanguage.ASTException.Exception, e
    # DO-NOT-DELETE splicer.end(accept)

  def getType(self):
    '''
    // Retrieve the parameter type
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # SIDLLanguage.Type _return
    # DO-NOT-DELETE splicer.begin(getType)
    return self.type
    # DO-NOT-DELETE splicer.end(getType)

  def setType(self, type):
    '''
    // Set the parameter type
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # type SIDLLanguage.Type
    # DO-NOT-DELETE splicer.begin(setType)
    self.type = type
    # DO-NOT-DELETE splicer.end(setType)

  def getAccessMode(self):
    '''
    // Retrieve the parameter access mode 
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # SIDLLanguage.ParameterAccessMode _return
    # DO-NOT-DELETE splicer.begin(getAccessMode)
    return self.accessMode
    # DO-NOT-DELETE splicer.end(getAccessMode)

  def setAccessMode(self, mode):
    '''
    // Set the parameter access mode 
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # mode SIDLLanguage.ParameterAccessMode
    # DO-NOT-DELETE splicer.begin(setAccessMode)
    self.accessMode = mode
    # DO-NOT-DELETE splicer.end(setAccessMode)

  def getRequired(self):
    '''
    // Retrieve the flag indicating whether the parameter is required in a call
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # bool _return
    # DO-NOT-DELETE splicer.begin(getRequired)
    return self.isRequired
    # DO-NOT-DELETE splicer.end(getRequired)

  def setRequired(self, isRequired):
    '''
    // Set the flag indicating whether the parameter is required in a call
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # isRequired bool
    # DO-NOT-DELETE splicer.begin(setRequired)
    self.isRequired = isRequired
    # DO-NOT-DELETE splicer.end(setRequired)

  def getCopy(self):
    '''
    // Retrieve the flag indicating whether the parameter is copied during marshalling
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # bool _return
    # DO-NOT-DELETE splicer.begin(getCopy)
    return self.isCopy
    # DO-NOT-DELETE splicer.end(getCopy)

  def setCopy(self, isCopy):
    '''
    // Set the flag indicating whether the parameter is copied during marshalling
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # isCopy bool
    # DO-NOT-DELETE splicer.begin(setCopy)
    self.isCopy = isCopy
    # DO-NOT-DELETE splicer.end(setCopy)

# DO-NOT-DELETE splicer.begin(_final)
# Put your code here...
pass
# DO-NOT-DELETE splicer.end(_final)

