#include "SIDLObjA.h"
#include "SIDLPyArrays.h"
#define  NO_IMPORT_ARRAY
#include "Numeric/arrayobject.h"

/* The SIDL Runtime function which spawns the interpreter */
void SIDL_Python_Init(void);

#ifndef included_ANL_SIDLCompilerI_AST_IOR
#include "ANL/SIDLCompilerI/AST_IOR/AST_IOR.h"
#endif
#ifndef included_ANL_SIDLCompilerI_AST_stub
#include "ANL/SIDLCompilerI/AST_Module.h"
#endif
//
// Includes for all method dependencies
//
#ifndef included_SIDL_Loader_IOR
#include "SIDL/Loader_IOR/Loader_IOR.h"
#endif
#ifndef included_SIDL_NullIORException_stub
#include "SIDL/NullIORException_Module.h"
#endif
#ifndef included_SIDL_BaseInterface_stub
#include "SIDL/BaseInterface_Module.h"
#endif
#ifndef included_SIDLLanguage_Visitor_stub
#include "SIDLLanguage/Visitor_Module.h"
#endif
#ifndef included_SIDLLanguage_ASTException_stub
#include "SIDLLanguage/ASTException_Module.h"
#endif
#ifndef included_SIDL_BaseException_stub
#include "SIDL/BaseException_Module.h"
#endif
#ifndef included_SIDLLanguage_AST_stub
#include "SIDLLanguage/AST_Module.h"
#endif
#ifndef included_SIDLLanguage_Comment_stub
#include "SIDLLanguage/Comment_Module.h"
#endif
#ifndef included_SIDLLanguage_Code_stub
#include "SIDLLanguage/Code_Module.h"
#endif
#ifndef included_SIDLLanguage_CodeGeneratorException_stub
#include "SIDLLanguage/CodeGeneratorException_Module.h"
#endif
#ifndef included_SIDLLanguage_Attribute_stub
#include "SIDLLanguage/Attribute_Module.h"
#endif

static void
initImplementation(void) {
  static int notInitialized = 1;

  if (notInitialized) {
    notInitialized = 0;
    SIDL_Python_Init();
  }
}

static void _importModules(void) {
  static int _import = 1;
  PyObject *module;

  if (_import) {
    _import = 0;
    module = PyImport_ImportModule((char *) "user");
    module = PyImport_ImportModule((char *) "importer");
    if (PyErr_Occurred()) {PyErr_Print();}
    import_SIDLObjA();
    import_SIDLPyArrays();
    ANL_SIDLCompilerI_AST__import();
    SIDL_NullIORException__import();
    SIDL_BaseInterface__import();
    SIDLLanguage_Visitor__import();
    SIDLLanguage_ASTException__import();
    SIDL_BaseException__import();
    SIDLLanguage_AST__import();
    SIDLLanguage_Comment__import();
    SIDLLanguage_Code__import();
    SIDLLanguage_CodeGeneratorException__import();
    SIDLLanguage_Attribute__import();
  }
}

static void
ANL_SIDLCompilerI_AST_accept_skel(
  struct ANL_SIDLCompilerI_AST__object *self,
  /*in*/ struct SIDLLanguage_Visitor__object * visitor,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "(O&)",
    (void *) SIDLLanguage_Visitor__newRef, visitor
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.AST.accept");
    return;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "accept");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDLLanguage_ASTException__type)) {
      struct SIDLLanguage_ASTException__object *_local_exception;
  
      (void) SIDLLanguage_ASTException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDLLanguage_ASTException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  _okay = (_return_value == Py_None);
  if (!_okay) {
    printf("Invalid return from void function accept\n");
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return;
}

static char *
ANL_SIDLCompilerI_AST_getIdentifier_skel(
  struct ANL_SIDLCompilerI_AST__object *self,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  char * _result = NULL;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "()"
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.AST.getIdentifier");
    return _result;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "getIdentifier");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  if (_return_value) {
    PyObject *_tmp = PyTuple_New(1);
  
    PyTuple_SET_ITEM(_tmp, 0, _return_value);
    _return_value = _tmp;
    _okay   = PyArg_ParseTuple(_return_value,
      (char *) "z",
      &_result
    );
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  _result = (_result ? strcpy(malloc(strlen(_result)+1), _result) : NULL);
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return _result;
}

static void
ANL_SIDLCompilerI_AST_setIdentifier_skel(
  struct ANL_SIDLCompilerI_AST__object *self,
  /*in*/ const char * identifier,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "(z)",
    identifier
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.AST.setIdentifier");
    return;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "setIdentifier");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  _okay = (_return_value == Py_None);
  if (!_okay) {
    printf("Invalid return from void function setIdentifier\n");
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return;
}

static char *
ANL_SIDLCompilerI_AST_getFullIdentifier_skel(
  struct ANL_SIDLCompilerI_AST__object *self,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  char * _result = NULL;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "()"
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.AST.getFullIdentifier");
    return _result;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "getFullIdentifier");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  if (_return_value) {
    PyObject *_tmp = PyTuple_New(1);
  
    PyTuple_SET_ITEM(_tmp, 0, _return_value);
    _return_value = _tmp;
    _okay   = PyArg_ParseTuple(_return_value,
      (char *) "z",
      &_result
    );
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  _result = (_result ? strcpy(malloc(strlen(_result)+1), _result) : NULL);
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return _result;
}

static struct SIDLLanguage_AST__object *
ANL_SIDLCompilerI_AST_getParent_skel(
  struct ANL_SIDLCompilerI_AST__object *self,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  struct SIDLLanguage_AST__object * _result;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "()"
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.AST.getParent");
    return _result;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "getParent");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  if (_return_value) {
    PyObject *_tmp = PyTuple_New(1);
  
    PyTuple_SET_ITEM(_tmp, 0, _return_value);
    _return_value = _tmp;
    _okay   = PyArg_ParseTuple(_return_value,
      (char *) "O&",
      (void *) SIDLLanguage_AST__convert, &_result
    );
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return _result;
}

static void
ANL_SIDLCompilerI_AST_setParent_skel(
  struct ANL_SIDLCompilerI_AST__object *self,
  /*in*/ struct SIDLLanguage_AST__object * parent,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "(O&)",
    (void *) SIDLLanguage_AST__newRef, parent
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.AST.setParent");
    return;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "setParent");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  _okay = (_return_value == Py_None);
  if (!_okay) {
    printf("Invalid return from void function setParent\n");
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return;
}

static struct SIDLLanguage_AST__array *
ANL_SIDLCompilerI_AST_getChildren_skel(
  struct ANL_SIDLCompilerI_AST__object *self,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  struct SIDLLanguage_AST__array * _result;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "()"
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.AST.getChildren");
    return _result;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "getChildren");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  if (_return_value) {
    PyObject *_tmp = PyTuple_New(1);
  
    PyTuple_SET_ITEM(_tmp, 0, _return_value);
    _return_value = _tmp;
    _okay   = PyArg_ParseTuple(_return_value,
      (char *) "O&",
      (void *) SIDLLanguage_AST__convert_python_array, &_result
    );
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return _result;
}

static void
ANL_SIDLCompilerI_AST_setChildren_skel(
  struct ANL_SIDLCompilerI_AST__object *self,
  /*in*/ struct SIDLLanguage_AST__array * children,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "(O&)",
    (void *) SIDLLanguage_AST__convert_sidl_array, children
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.AST.setChildren");
    return;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "setChildren");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  _okay = (_return_value == Py_None);
  if (!_okay) {
    printf("Invalid return from void function setChildren\n");
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return;
}

static void
ANL_SIDLCompilerI_AST_addChildren_skel(
  struct ANL_SIDLCompilerI_AST__object *self,
  /*in*/ struct SIDLLanguage_AST__array * children,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "(O&)",
    (void *) SIDLLanguage_AST__convert_sidl_array, children
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.AST.addChildren");
    return;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "addChildren");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  _okay = (_return_value == Py_None);
  if (!_okay) {
    printf("Invalid return from void function addChildren\n");
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return;
}

static struct SIDLLanguage_AST__array *
ANL_SIDLCompilerI_AST_getDependencies_skel(
  struct ANL_SIDLCompilerI_AST__object *self,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  struct SIDLLanguage_AST__array * _result;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "()"
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.AST.getDependencies");
    return _result;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "getDependencies");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  if (_return_value) {
    PyObject *_tmp = PyTuple_New(1);
  
    PyTuple_SET_ITEM(_tmp, 0, _return_value);
    _return_value = _tmp;
    _okay   = PyArg_ParseTuple(_return_value,
      (char *) "O&",
      (void *) SIDLLanguage_AST__convert_python_array, &_result
    );
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return _result;
}

static void
ANL_SIDLCompilerI_AST_setDependencies_skel(
  struct ANL_SIDLCompilerI_AST__object *self,
  /*in*/ struct SIDLLanguage_AST__array * dependencies,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "(O&)",
    (void *) SIDLLanguage_AST__convert_sidl_array, dependencies
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.AST.setDependencies");
    return;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "setDependencies");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  _okay = (_return_value == Py_None);
  if (!_okay) {
    printf("Invalid return from void function setDependencies\n");
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return;
}

static void
ANL_SIDLCompilerI_AST_addDependency_skel(
  struct ANL_SIDLCompilerI_AST__object *self,
  /*in*/ struct SIDLLanguage_AST__object * dependency,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "(O&)",
    (void *) SIDLLanguage_AST__newRef, dependency
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.AST.addDependency");
    return;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "addDependency");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  _okay = (_return_value == Py_None);
  if (!_okay) {
    printf("Invalid return from void function addDependency\n");
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return;
}

static struct SIDLLanguage_Comment__array *
ANL_SIDLCompilerI_AST_getComments_skel(
  struct ANL_SIDLCompilerI_AST__object *self,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  struct SIDLLanguage_Comment__array * _result;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "()"
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.AST.getComments");
    return _result;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "getComments");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  if (_return_value) {
    PyObject *_tmp = PyTuple_New(1);
  
    PyTuple_SET_ITEM(_tmp, 0, _return_value);
    _return_value = _tmp;
    _okay   = PyArg_ParseTuple(_return_value,
      (char *) "O&",
      (void *) SIDLLanguage_Comment__convert_python_array, &_result
    );
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return _result;
}

static void
ANL_SIDLCompilerI_AST_setComments_skel(
  struct ANL_SIDLCompilerI_AST__object *self,
  /*in*/ struct SIDLLanguage_Comment__array * comments,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "(O&)",
    (void *) SIDLLanguage_Comment__convert_sidl_array, comments
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.AST.setComments");
    return;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "setComments");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  _okay = (_return_value == Py_None);
  if (!_okay) {
    printf("Invalid return from void function setComments\n");
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return;
}

static void
ANL_SIDLCompilerI_AST_addComments_skel(
  struct ANL_SIDLCompilerI_AST__object *self,
  /*in*/ struct SIDLLanguage_Comment__array * comments,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "(O&)",
    (void *) SIDLLanguage_Comment__convert_sidl_array, comments
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.AST.addComments");
    return;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "addComments");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  _okay = (_return_value == Py_None);
  if (!_okay) {
    printf("Invalid return from void function addComments\n");
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return;
}

static struct SIDLLanguage_Code__array *
ANL_SIDLCompilerI_AST_getCode_skel(
  struct ANL_SIDLCompilerI_AST__object *self,
  /*in*/ const char * language,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  struct SIDLLanguage_Code__array * _result;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "(z)",
    language
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.AST.getCode");
    return _result;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "getCode");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  if (_return_value) {
    PyObject *_tmp = PyTuple_New(1);
  
    PyTuple_SET_ITEM(_tmp, 0, _return_value);
    _return_value = _tmp;
    _okay   = PyArg_ParseTuple(_return_value,
      (char *) "O&",
      (void *) SIDLLanguage_Code__convert_python_array, &_result
    );
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return _result;
}

static void
ANL_SIDLCompilerI_AST_setCode_skel(
  struct ANL_SIDLCompilerI_AST__object *self,
  /*in*/ struct SIDLLanguage_Code__array * code,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "(O&)",
    (void *) SIDLLanguage_Code__convert_sidl_array, code
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.AST.setCode");
    return;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "setCode");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  _okay = (_return_value == Py_None);
  if (!_okay) {
    printf("Invalid return from void function setCode\n");
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return;
}

static void
ANL_SIDLCompilerI_AST_addCode_skel(
  struct ANL_SIDLCompilerI_AST__object *self,
  /*in*/ struct SIDLLanguage_Code__object * code,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "(O&)",
    (void *) SIDLLanguage_Code__newRef, code
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.AST.addCode");
    return;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "addCode");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  _okay = (_return_value == Py_None);
  if (!_okay) {
    printf("Invalid return from void function addCode\n");
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return;
}

static SIDL_bool
ANL_SIDLCompilerI_AST_hasCodeBlock_skel(
  struct ANL_SIDLCompilerI_AST__object *self,
  /*in*/ const char * language,
  /*in*/ const char * label,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  SIDL_bool _result = FALSE;
  int _local__result;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "(zz)",
    language,
    label
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.AST.hasCodeBlock");
    return _result;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "hasCodeBlock");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  if (_return_value) {
    PyObject *_tmp = PyTuple_New(1);
  
    PyTuple_SET_ITEM(_tmp, 0, _return_value);
    _return_value = _tmp;
    _okay   = PyArg_ParseTuple(_return_value,
      (char *) "i",
      &_local__result
    );
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  _result = (_local__result ? TRUE : FALSE);
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return _result;
}

static struct SIDLLanguage_Code__object *
ANL_SIDLCompilerI_AST_getCodeBlock_skel(
  struct ANL_SIDLCompilerI_AST__object *self,
  /*in*/ const char * language,
  /*in*/ const char * label,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  struct SIDLLanguage_Code__object * _result;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "(zz)",
    language,
    label
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.AST.getCodeBlock");
    return _result;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "getCodeBlock");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDLLanguage_CodeGeneratorException__type)) {
      struct SIDLLanguage_CodeGeneratorException__object *_local_exception;
  
      (void) SIDLLanguage_CodeGeneratorException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDLLanguage_CodeGeneratorException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  if (_return_value) {
    PyObject *_tmp = PyTuple_New(1);
  
    PyTuple_SET_ITEM(_tmp, 0, _return_value);
    _return_value = _tmp;
    _okay   = PyArg_ParseTuple(_return_value,
      (char *) "O&",
      (void *) SIDLLanguage_Code__convert, &_result
    );
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return _result;
}

static struct SIDLLanguage_Code__object *
ANL_SIDLCompilerI_AST_removeCodeBlock_skel(
  struct ANL_SIDLCompilerI_AST__object *self,
  /*in*/ const char * language,
  /*in*/ const char * label,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  struct SIDLLanguage_Code__object * _result;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "(zz)",
    language,
    label
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.AST.removeCodeBlock");
    return _result;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "removeCodeBlock");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDLLanguage_CodeGeneratorException__type)) {
      struct SIDLLanguage_CodeGeneratorException__object *_local_exception;
  
      (void) SIDLLanguage_CodeGeneratorException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDLLanguage_CodeGeneratorException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  if (_return_value) {
    PyObject *_tmp = PyTuple_New(1);
  
    PyTuple_SET_ITEM(_tmp, 0, _return_value);
    _return_value = _tmp;
    _okay   = PyArg_ParseTuple(_return_value,
      (char *) "O&",
      (void *) SIDLLanguage_Code__convert, &_result
    );
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return _result;
}

static struct SIDLLanguage_Attribute__array *
ANL_SIDLCompilerI_AST_getAttributes_skel(
  struct ANL_SIDLCompilerI_AST__object *self,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  struct SIDLLanguage_Attribute__array * _result;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "()"
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.AST.getAttributes");
    return _result;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "getAttributes");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  if (_return_value) {
    PyObject *_tmp = PyTuple_New(1);
  
    PyTuple_SET_ITEM(_tmp, 0, _return_value);
    _return_value = _tmp;
    _okay   = PyArg_ParseTuple(_return_value,
      (char *) "O&",
      (void *) SIDLLanguage_Attribute__convert_python_array, &_result
    );
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return _result;
}

static void
ANL_SIDLCompilerI_AST_setAttributes_skel(
  struct ANL_SIDLCompilerI_AST__object *self,
  /*in*/ struct SIDLLanguage_Attribute__array * attributes,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "(O&)",
    (void *) SIDLLanguage_Attribute__convert_sidl_array, attributes
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.AST.setAttributes");
    return;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "setAttributes");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  _okay = (_return_value == Py_None);
  if (!_okay) {
    printf("Invalid return from void function setAttributes\n");
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return;
}

static SIDL_bool
ANL_SIDLCompilerI_AST_hasAttribute_skel(
  struct ANL_SIDLCompilerI_AST__object *self,
  /*in*/ const char * name,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  SIDL_bool _result = FALSE;
  int _local__result;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "(z)",
    name
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.AST.hasAttribute");
    return _result;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "hasAttribute");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  if (_return_value) {
    PyObject *_tmp = PyTuple_New(1);
  
    PyTuple_SET_ITEM(_tmp, 0, _return_value);
    _return_value = _tmp;
    _okay   = PyArg_ParseTuple(_return_value,
      (char *) "i",
      &_local__result
    );
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  _result = (_local__result ? TRUE : FALSE);
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return _result;
}

static void
ANL_SIDLCompilerI_AST_addAttribute_skel(
  struct ANL_SIDLCompilerI_AST__object *self,
  /*in*/ struct SIDLLanguage_Attribute__object * attribute,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "(O&)",
    (void *) SIDLLanguage_Attribute__newRef, attribute
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.AST.addAttribute");
    return;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "addAttribute");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  _okay = (_return_value == Py_None);
  if (!_okay) {
    printf("Invalid return from void function addAttribute\n");
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return;
}

static struct SIDLLanguage_Attribute__object *
ANL_SIDLCompilerI_AST_deleteAttribute_skel(
  struct ANL_SIDLCompilerI_AST__object *self,
  /*in*/ const char * name,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  struct SIDLLanguage_Attribute__object * _result;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "(z)",
    name
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.AST.deleteAttribute");
    return _result;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "deleteAttribute");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDLLanguage_ASTException__type)) {
      struct SIDLLanguage_ASTException__object *_local_exception;
  
      (void) SIDLLanguage_ASTException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDLLanguage_ASTException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  if (_return_value) {
    PyObject *_tmp = PyTuple_New(1);
  
    PyTuple_SET_ITEM(_tmp, 0, _return_value);
    _return_value = _tmp;
    _okay   = PyArg_ParseTuple(_return_value,
      (char *) "O&",
      (void *) SIDLLanguage_Attribute__convert, &_result
    );
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return _result;
}

static struct SIDLLanguage_Attribute__object *
ANL_SIDLCompilerI_AST_getAttribute_skel(
  struct ANL_SIDLCompilerI_AST__object *self,
  /*in*/ const char * name,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  struct SIDLLanguage_Attribute__object * _result;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "(z)",
    name
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.AST.getAttribute");
    return _result;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "getAttribute");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDLLanguage_ASTException__type)) {
      struct SIDLLanguage_ASTException__object *_local_exception;
  
      (void) SIDLLanguage_ASTException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDLLanguage_ASTException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  if (_return_value) {
    PyObject *_tmp = PyTuple_New(1);
  
    PyTuple_SET_ITEM(_tmp, 0, _return_value);
    _return_value = _tmp;
    _okay   = PyArg_ParseTuple(_return_value,
      (char *) "O&",
      (void *) SIDLLanguage_Attribute__convert, &_result
    );
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return _result;
}

static void ANL_SIDLCompilerI_AST__ctor_skel(struct ANL_SIDLCompilerI_AST__object *self) {
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_result;

  _context = PyImport_ImportModule((char *) "ANL.SIDLCompilerI_impl.AST_impl");
  if (!_context) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "AST");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    Py_DECREF(_context);
    return;
  }
  _args = Py_BuildValue((char *) "(O&)", (void *) ANL_SIDLCompilerI_AST__weakRef, self);
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    Py_DECREF(_pfunc);
    Py_DECREF(_context);
    return;
  }
  _result = PyInstance_New(_pfunc, _args, NULL);
  if (_result) {
    self->d_data = _result;
  } else {
    if (PyErr_Occurred()) PyErr_Print();
  }
  Py_DECREF(_args);
  Py_DECREF(_pfunc);
  Py_DECREF(_context);
}

static void ANL_SIDLCompilerI_AST__dtor_skel(struct ANL_SIDLCompilerI_AST__object *self) {
  /* Remove only reference to Python object */
  Py_XDECREF(((PyObject *) self->d_data));
}

void ANL_SIDLCompilerI_AST__set_epv(struct ANL_SIDLCompilerI_AST__epv * epv);
void
ANL_SIDLCompilerI_AST__set_epv(struct ANL_SIDLCompilerI_AST__epv * epv) {
  initImplementation();
  _importModules();
  /* Initialize constructor and destructor */
  epv->f__ctor = ANL_SIDLCompilerI_AST__ctor_skel;
  epv->f__dtor = ANL_SIDLCompilerI_AST__dtor_skel;
  /* Initialize user methods */
  epv->f_accept = ANL_SIDLCompilerI_AST_accept_skel;
  epv->f_getIdentifier = ANL_SIDLCompilerI_AST_getIdentifier_skel;
  epv->f_setIdentifier = ANL_SIDLCompilerI_AST_setIdentifier_skel;
  epv->f_getFullIdentifier = ANL_SIDLCompilerI_AST_getFullIdentifier_skel;
  epv->f_getParent = ANL_SIDLCompilerI_AST_getParent_skel;
  epv->f_setParent = ANL_SIDLCompilerI_AST_setParent_skel;
  epv->f_getChildren = ANL_SIDLCompilerI_AST_getChildren_skel;
  epv->f_setChildren = ANL_SIDLCompilerI_AST_setChildren_skel;
  epv->f_addChildren = ANL_SIDLCompilerI_AST_addChildren_skel;
  epv->f_getDependencies = ANL_SIDLCompilerI_AST_getDependencies_skel;
  epv->f_setDependencies = ANL_SIDLCompilerI_AST_setDependencies_skel;
  epv->f_addDependency = ANL_SIDLCompilerI_AST_addDependency_skel;
  epv->f_getComments = ANL_SIDLCompilerI_AST_getComments_skel;
  epv->f_setComments = ANL_SIDLCompilerI_AST_setComments_skel;
  epv->f_addComments = ANL_SIDLCompilerI_AST_addComments_skel;
  epv->f_getCode = ANL_SIDLCompilerI_AST_getCode_skel;
  epv->f_setCode = ANL_SIDLCompilerI_AST_setCode_skel;
  epv->f_addCode = ANL_SIDLCompilerI_AST_addCode_skel;
  epv->f_hasCodeBlock = ANL_SIDLCompilerI_AST_hasCodeBlock_skel;
  epv->f_getCodeBlock = ANL_SIDLCompilerI_AST_getCodeBlock_skel;
  epv->f_removeCodeBlock = ANL_SIDLCompilerI_AST_removeCodeBlock_skel;
  epv->f_getAttributes = ANL_SIDLCompilerI_AST_getAttributes_skel;
  epv->f_setAttributes = ANL_SIDLCompilerI_AST_setAttributes_skel;
  epv->f_hasAttribute = ANL_SIDLCompilerI_AST_hasAttribute_skel;
  epv->f_addAttribute = ANL_SIDLCompilerI_AST_addAttribute_skel;
  epv->f_deleteAttribute = ANL_SIDLCompilerI_AST_deleteAttribute_skel;
  epv->f_getAttribute = ANL_SIDLCompilerI_AST_getAttribute_skel;
}

