#include "SIDLObjA.h"
#include "SIDLPyArrays.h"
#define  NO_IMPORT_ARRAY
#include "Numeric/arrayobject.h"

/* The SIDL Runtime function which spawns the interpreter */
void SIDL_Python_Init(void);

#ifndef included_ANL_SIDLCompilerI_CodePurpose_IOR
#include "ANL/SIDLCompilerI/CodePurpose_IOR/CodePurpose_IOR.h"
#endif
#ifndef included_ANL_SIDLCompilerI_CodePurpose_stub
#include "ANL/SIDLCompilerI/CodePurpose_Module.h"
#endif
//
// Includes for all method dependencies
//
#ifndef included_SIDL_Loader_IOR
#include "SIDL/Loader_IOR/Loader_IOR.h"
#endif
#ifndef included_SIDL_NullIORException_stub
#include "SIDL/NullIORException_Module.h"
#endif
#ifndef included_SIDL_BaseInterface_stub
#include "SIDL/BaseInterface_Module.h"
#endif
#ifndef included_SIDL_BaseException_stub
#include "SIDL/BaseException_Module.h"
#endif

static void
initImplementation(void) {
  static int notInitialized = 1;

  if (notInitialized) {
    notInitialized = 0;
    SIDL_Python_Init();
  }
}

static void _importModules(void) {
  static int _import = 1;
  PyObject *module;

  if (_import) {
    _import = 0;
    module = PyImport_ImportModule((char *) "user");
    module = PyImport_ImportModule((char *) "importer");
    if (PyErr_Occurred()) {PyErr_Print();}
    import_SIDLObjA();
    import_SIDLPyArrays();
    ANL_SIDLCompilerI_CodePurpose__import();
    SIDL_NullIORException__import();
    SIDL_BaseInterface__import();
    SIDL_BaseException__import();
  }
}

static char *
ANL_SIDLCompilerI_CodePurpose_getName_skel(
  struct ANL_SIDLCompilerI_CodePurpose__object *self,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  char * _result = NULL;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "()"
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.CodePurpose.getName");
    return _result;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "getName");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  if (_return_value) {
    PyObject *_tmp = PyTuple_New(1);
  
    PyTuple_SET_ITEM(_tmp, 0, _return_value);
    _return_value = _tmp;
    _okay   = PyArg_ParseTuple(_return_value,
      (char *) "z",
      &_result
    );
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  _result = (_result ? strcpy(malloc(strlen(_result)+1), _result) : NULL);
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return _result;
}

static void
ANL_SIDLCompilerI_CodePurpose_setName_skel(
  struct ANL_SIDLCompilerI_CodePurpose__object *self,
  /*in*/ const char * name,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "(z)",
    name
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.CodePurpose.setName");
    return;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "setName");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  _okay = (_return_value == Py_None);
  if (!_okay) {
    printf("Invalid return from void function setName\n");
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return;
}

static char *
ANL_SIDLCompilerI_CodePurpose_getPathExtension_skel(
  struct ANL_SIDLCompilerI_CodePurpose__object *self,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  char * _result = NULL;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "()"
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.CodePurpose.getPathExtension");
    return _result;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "getPathExtension");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  if (_return_value) {
    PyObject *_tmp = PyTuple_New(1);
  
    PyTuple_SET_ITEM(_tmp, 0, _return_value);
    _return_value = _tmp;
    _okay   = PyArg_ParseTuple(_return_value,
      (char *) "z",
      &_result
    );
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  _result = (_result ? strcpy(malloc(strlen(_result)+1), _result) : NULL);
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return _result;
}

static void
ANL_SIDLCompilerI_CodePurpose_setPathExtension_skel(
  struct ANL_SIDLCompilerI_CodePurpose__object *self,
  /*in*/ const char * pathExtension,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "(z)",
    pathExtension
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.CodePurpose.setPathExtension");
    return;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "setPathExtension");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  _okay = (_return_value == Py_None);
  if (!_okay) {
    printf("Invalid return from void function setPathExtension\n");
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return;
}

static SIDL_bool
ANL_SIDLCompilerI_CodePurpose_getEmbedded_skel(
  struct ANL_SIDLCompilerI_CodePurpose__object *self,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  SIDL_bool _result = FALSE;
  int _local__result;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "()"
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.CodePurpose.getEmbedded");
    return _result;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "getEmbedded");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  if (_return_value) {
    PyObject *_tmp = PyTuple_New(1);
  
    PyTuple_SET_ITEM(_tmp, 0, _return_value);
    _return_value = _tmp;
    _okay   = PyArg_ParseTuple(_return_value,
      (char *) "i",
      &_local__result
    );
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  _result = (_local__result ? TRUE : FALSE);
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return _result;
}

static void
ANL_SIDLCompilerI_CodePurpose_setEmbedded_skel(
  struct ANL_SIDLCompilerI_CodePurpose__object *self,
  /*in*/ SIDL_bool isEmbedded,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  /* Pack arguments for dispatch to implementation */
  int _local_isEmbedded;
  _local_isEmbedded = (isEmbedded != FALSE);
  _args = Py_BuildValue(
     (char *) "(i)",
    _local_isEmbedded
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.CodePurpose.setEmbedded");
    return;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "setEmbedded");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  _okay = (_return_value == Py_None);
  if (!_okay) {
    printf("Invalid return from void function setEmbedded\n");
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return;
}

static SIDL_bool
ANL_SIDLCompilerI_CodePurpose_getUseSplicer_skel(
  struct ANL_SIDLCompilerI_CodePurpose__object *self,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  SIDL_bool _result = FALSE;
  int _local__result;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "()"
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.CodePurpose.getUseSplicer");
    return _result;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "getUseSplicer");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  if (_return_value) {
    PyObject *_tmp = PyTuple_New(1);
  
    PyTuple_SET_ITEM(_tmp, 0, _return_value);
    _return_value = _tmp;
    _okay   = PyArg_ParseTuple(_return_value,
      (char *) "i",
      &_local__result
    );
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  _result = (_local__result ? TRUE : FALSE);
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return _result;
}

static void
ANL_SIDLCompilerI_CodePurpose_setUseSplicer_skel(
  struct ANL_SIDLCompilerI_CodePurpose__object *self,
  /*in*/ SIDL_bool useSplicer,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  /* Pack arguments for dispatch to implementation */
  int _local_useSplicer;
  _local_useSplicer = (useSplicer != FALSE);
  _args = Py_BuildValue(
     (char *) "(i)",
    _local_useSplicer
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.CodePurpose.setUseSplicer");
    return;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "setUseSplicer");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  _okay = (_return_value == Py_None);
  if (!_okay) {
    printf("Invalid return from void function setUseSplicer\n");
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return;
}

static SIDL_bool
ANL_SIDLCompilerI_CodePurpose_getGenerateMethods_skel(
  struct ANL_SIDLCompilerI_CodePurpose__object *self,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  SIDL_bool _result = FALSE;
  int _local__result;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "()"
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.CodePurpose.getGenerateMethods");
    return _result;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "getGenerateMethods");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  if (_return_value) {
    PyObject *_tmp = PyTuple_New(1);
  
    PyTuple_SET_ITEM(_tmp, 0, _return_value);
    _return_value = _tmp;
    _okay   = PyArg_ParseTuple(_return_value,
      (char *) "i",
      &_local__result
    );
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  _result = (_local__result ? TRUE : FALSE);
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return _result;
}

static void
ANL_SIDLCompilerI_CodePurpose_setGenerateMethods_skel(
  struct ANL_SIDLCompilerI_CodePurpose__object *self,
  /*in*/ SIDL_bool generateMethods,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  /* Pack arguments for dispatch to implementation */
  int _local_generateMethods;
  _local_generateMethods = (generateMethods != FALSE);
  _args = Py_BuildValue(
     (char *) "(i)",
    _local_generateMethods
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.CodePurpose.setGenerateMethods");
    return;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "setGenerateMethods");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  _okay = (_return_value == Py_None);
  if (!_okay) {
    printf("Invalid return from void function setGenerateMethods\n");
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return;
}

static SIDL_bool
ANL_SIDLCompilerI_CodePurpose_getCheckIOR_skel(
  struct ANL_SIDLCompilerI_CodePurpose__object *self,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  SIDL_bool _result = FALSE;
  int _local__result;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "()"
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.CodePurpose.getCheckIOR");
    return _result;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "getCheckIOR");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  if (_return_value) {
    PyObject *_tmp = PyTuple_New(1);
  
    PyTuple_SET_ITEM(_tmp, 0, _return_value);
    _return_value = _tmp;
    _okay   = PyArg_ParseTuple(_return_value,
      (char *) "i",
      &_local__result
    );
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  _result = (_local__result ? TRUE : FALSE);
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return _result;
}

static void
ANL_SIDLCompilerI_CodePurpose_setCheckIOR_skel(
  struct ANL_SIDLCompilerI_CodePurpose__object *self,
  /*in*/ SIDL_bool checkIOR,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  /* Pack arguments for dispatch to implementation */
  int _local_checkIOR;
  _local_checkIOR = (checkIOR != FALSE);
  _args = Py_BuildValue(
     (char *) "(i)",
    _local_checkIOR
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.CodePurpose.setCheckIOR");
    return;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "setCheckIOR");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  _okay = (_return_value == Py_None);
  if (!_okay) {
    printf("Invalid return from void function setCheckIOR\n");
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return;
}

static SIDL_bool
ANL_SIDLCompilerI_CodePurpose_getUseSelf_skel(
  struct ANL_SIDLCompilerI_CodePurpose__object *self,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  SIDL_bool _result = FALSE;
  int _local__result;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "()"
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.CodePurpose.getUseSelf");
    return _result;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "getUseSelf");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  if (_return_value) {
    PyObject *_tmp = PyTuple_New(1);
  
    PyTuple_SET_ITEM(_tmp, 0, _return_value);
    _return_value = _tmp;
    _okay   = PyArg_ParseTuple(_return_value,
      (char *) "i",
      &_local__result
    );
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  _result = (_local__result ? TRUE : FALSE);
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return _result;
}

static void
ANL_SIDLCompilerI_CodePurpose_setUseSelf_skel(
  struct ANL_SIDLCompilerI_CodePurpose__object *self,
  /*in*/ SIDL_bool useSelf,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  /* Pack arguments for dispatch to implementation */
  int _local_useSelf;
  _local_useSelf = (useSelf != FALSE);
  _args = Py_BuildValue(
     (char *) "(i)",
    _local_useSelf
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.CodePurpose.setUseSelf");
    return;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "setUseSelf");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  _okay = (_return_value == Py_None);
  if (!_okay) {
    printf("Invalid return from void function setUseSelf\n");
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return;
}

static SIDL_bool
ANL_SIDLCompilerI_CodePurpose_getEmulateExceptions_skel(
  struct ANL_SIDLCompilerI_CodePurpose__object *self,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  SIDL_bool _result = FALSE;
  int _local__result;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "()"
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.CodePurpose.getEmulateExceptions");
    return _result;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "getEmulateExceptions");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  if (_return_value) {
    PyObject *_tmp = PyTuple_New(1);
  
    PyTuple_SET_ITEM(_tmp, 0, _return_value);
    _return_value = _tmp;
    _okay   = PyArg_ParseTuple(_return_value,
      (char *) "i",
      &_local__result
    );
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  _result = (_local__result ? TRUE : FALSE);
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return _result;
}

static void
ANL_SIDLCompilerI_CodePurpose_setEmulateExceptions_skel(
  struct ANL_SIDLCompilerI_CodePurpose__object *self,
  /*in*/ SIDL_bool emulateExceptions,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  /* Pack arguments for dispatch to implementation */
  int _local_emulateExceptions;
  _local_emulateExceptions = (emulateExceptions != FALSE);
  _args = Py_BuildValue(
     (char *) "(i)",
    _local_emulateExceptions
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.CodePurpose.setEmulateExceptions");
    return;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "setEmulateExceptions");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  _okay = (_return_value == Py_None);
  if (!_okay) {
    printf("Invalid return from void function setEmulateExceptions\n");
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return;
}

static SIDL_bool
ANL_SIDLCompilerI_CodePurpose_getIORDispatch_skel(
  struct ANL_SIDLCompilerI_CodePurpose__object *self,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  SIDL_bool _result = FALSE;
  int _local__result;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "()"
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.CodePurpose.getIORDispatch");
    return _result;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "getIORDispatch");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  if (_return_value) {
    PyObject *_tmp = PyTuple_New(1);
  
    PyTuple_SET_ITEM(_tmp, 0, _return_value);
    _return_value = _tmp;
    _okay   = PyArg_ParseTuple(_return_value,
      (char *) "i",
      &_local__result
    );
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  _result = (_local__result ? TRUE : FALSE);
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return _result;
}

static void
ANL_SIDLCompilerI_CodePurpose_setIORDispatch_skel(
  struct ANL_SIDLCompilerI_CodePurpose__object *self,
  /*in*/ SIDL_bool iorDispatch,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  /* Pack arguments for dispatch to implementation */
  int _local_iorDispatch;
  _local_iorDispatch = (iorDispatch != FALSE);
  _args = Py_BuildValue(
     (char *) "(i)",
    _local_iorDispatch
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.CodePurpose.setIORDispatch");
    return;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "setIORDispatch");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  _okay = (_return_value == Py_None);
  if (!_okay) {
    printf("Invalid return from void function setIORDispatch\n");
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return;
}

static void ANL_SIDLCompilerI_CodePurpose__ctor_skel(struct ANL_SIDLCompilerI_CodePurpose__object *self) {
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_result;

  _context = PyImport_ImportModule((char *) "ANL.SIDLCompilerI_impl.CodePurpose_impl");
  if (!_context) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "CodePurpose");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    Py_DECREF(_context);
    return;
  }
  _args = Py_BuildValue((char *) "(O&)", (void *) ANL_SIDLCompilerI_CodePurpose__weakRef, self);
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    Py_DECREF(_pfunc);
    Py_DECREF(_context);
    return;
  }
  _result = PyInstance_New(_pfunc, _args, NULL);
  if (_result) {
    self->d_data = _result;
  } else {
    if (PyErr_Occurred()) PyErr_Print();
  }
  Py_DECREF(_args);
  Py_DECREF(_pfunc);
  Py_DECREF(_context);
}

static void ANL_SIDLCompilerI_CodePurpose__dtor_skel(struct ANL_SIDLCompilerI_CodePurpose__object *self) {
  /* Remove only reference to Python object */
  Py_XDECREF(((PyObject *) self->d_data));
}

void ANL_SIDLCompilerI_CodePurpose__set_epv(struct ANL_SIDLCompilerI_CodePurpose__epv * epv);
void
ANL_SIDLCompilerI_CodePurpose__set_epv(struct ANL_SIDLCompilerI_CodePurpose__epv * epv) {
  initImplementation();
  _importModules();
  /* Initialize constructor and destructor */
  epv->f__ctor = ANL_SIDLCompilerI_CodePurpose__ctor_skel;
  epv->f__dtor = ANL_SIDLCompilerI_CodePurpose__dtor_skel;
  /* Initialize user methods */
  epv->f_getName = ANL_SIDLCompilerI_CodePurpose_getName_skel;
  epv->f_setName = ANL_SIDLCompilerI_CodePurpose_setName_skel;
  epv->f_getPathExtension = ANL_SIDLCompilerI_CodePurpose_getPathExtension_skel;
  epv->f_setPathExtension = ANL_SIDLCompilerI_CodePurpose_setPathExtension_skel;
  epv->f_getEmbedded = ANL_SIDLCompilerI_CodePurpose_getEmbedded_skel;
  epv->f_setEmbedded = ANL_SIDLCompilerI_CodePurpose_setEmbedded_skel;
  epv->f_getUseSplicer = ANL_SIDLCompilerI_CodePurpose_getUseSplicer_skel;
  epv->f_setUseSplicer = ANL_SIDLCompilerI_CodePurpose_setUseSplicer_skel;
  epv->f_getGenerateMethods = ANL_SIDLCompilerI_CodePurpose_getGenerateMethods_skel;
  epv->f_setGenerateMethods = ANL_SIDLCompilerI_CodePurpose_setGenerateMethods_skel;
  epv->f_getCheckIOR = ANL_SIDLCompilerI_CodePurpose_getCheckIOR_skel;
  epv->f_setCheckIOR = ANL_SIDLCompilerI_CodePurpose_setCheckIOR_skel;
  epv->f_getUseSelf = ANL_SIDLCompilerI_CodePurpose_getUseSelf_skel;
  epv->f_setUseSelf = ANL_SIDLCompilerI_CodePurpose_setUseSelf_skel;
  epv->f_getEmulateExceptions = ANL_SIDLCompilerI_CodePurpose_getEmulateExceptions_skel;
  epv->f_setEmulateExceptions = ANL_SIDLCompilerI_CodePurpose_setEmulateExceptions_skel;
  epv->f_getIORDispatch = ANL_SIDLCompilerI_CodePurpose_getIORDispatch_skel;
  epv->f_setIORDispatch = ANL_SIDLCompilerI_CodePurpose_setIORDispatch_skel;
}

