#include "SIDLObjA.h"
#include "SIDLPyArrays.h"
#define  NO_IMPORT_ARRAY
#include "Numeric/arrayobject.h"

/* The SIDL Runtime function which spawns the interpreter */
void SIDL_Python_Init(void);

#ifndef included_ANL_SIDLCompilerI_Implementation_IOR
#include "ANL/SIDLCompilerI/Implementation_IOR/Implementation_IOR.h"
#endif
#ifndef included_ANL_SIDLCompilerI_Implementation_stub
#include "ANL/SIDLCompilerI/Implementation_Module.h"
#endif
//
// Includes for all method dependencies
//
#ifndef included_SIDL_Loader_IOR
#include "SIDL/Loader_IOR/Loader_IOR.h"
#endif
#ifndef included_SIDL_NullIORException_stub
#include "SIDL/NullIORException_Module.h"
#endif
#ifndef included_SIDL_BaseInterface_stub
#include "SIDL/BaseInterface_Module.h"
#endif
#ifndef included_SIDL_BaseException_stub
#include "SIDL/BaseException_Module.h"
#endif

static void
initImplementation(void) {
  static int notInitialized = 1;

  if (notInitialized) {
    notInitialized = 0;
    SIDL_Python_Init();
  }
}

static void _importModules(void) {
  static int _import = 1;
  PyObject *module;

  if (_import) {
    _import = 0;
    module = PyImport_ImportModule((char *) "user");
    module = PyImport_ImportModule((char *) "importer");
    if (PyErr_Occurred()) {PyErr_Print();}
    import_SIDLObjA();
    import_SIDLPyArrays();
    ANL_SIDLCompilerI_Implementation__import();
    SIDL_NullIORException__import();
    SIDL_BaseInterface__import();
    SIDL_BaseException__import();
  }
}

static void ANL_SIDLCompilerI_Implementation__ctor_skel(struct ANL_SIDLCompilerI_Implementation__object *self) {
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_result;

  _context = PyImport_ImportModule((char *) "ANL.SIDLCompilerI_impl.Implementation_impl");
  if (!_context) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "Implementation");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    Py_DECREF(_context);
    return;
  }
  _args = Py_BuildValue((char *) "(O&)", (void *) ANL_SIDLCompilerI_Implementation__weakRef, self);
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    Py_DECREF(_pfunc);
    Py_DECREF(_context);
    return;
  }
  _result = PyInstance_New(_pfunc, _args, NULL);
  if (_result) {
    self->d_data = _result;
  } else {
    if (PyErr_Occurred()) PyErr_Print();
  }
  Py_DECREF(_args);
  Py_DECREF(_pfunc);
  Py_DECREF(_context);
}

static void ANL_SIDLCompilerI_Implementation__dtor_skel(struct ANL_SIDLCompilerI_Implementation__object *self) {
  /* Remove only reference to Python object */
  Py_XDECREF(((PyObject *) self->d_data));
}

void ANL_SIDLCompilerI_Implementation__set_epv(struct ANL_SIDLCompilerI_Implementation__epv * epv);
void
ANL_SIDLCompilerI_Implementation__set_epv(struct ANL_SIDLCompilerI_Implementation__epv * epv) {
  initImplementation();
  _importModules();
  /* Initialize constructor and destructor */
  epv->f__ctor = ANL_SIDLCompilerI_Implementation__ctor_skel;
  epv->f__dtor = ANL_SIDLCompilerI_Implementation__dtor_skel;
}

