#include "SIDLObjA.h"
#include "SIDLPyArrays.h"
#define  NO_IMPORT_ARRAY
#include "Numeric/arrayobject.h"

/* The SIDL Runtime function which spawns the interpreter */
void SIDL_Python_Init(void);

#ifndef included_ANL_SIDLCompilerI_Interface_IOR
#include "ANL/SIDLCompilerI/Interface_IOR/Interface_IOR.h"
#endif
#ifndef included_ANL_SIDLCompilerI_Interface_stub
#include "ANL/SIDLCompilerI/Interface_Module.h"
#endif
//
// Includes for all method dependencies
//
#ifndef included_SIDL_Loader_IOR
#include "SIDL/Loader_IOR/Loader_IOR.h"
#endif
#ifndef included_SIDLLanguage_Visitor_stub
#include "SIDLLanguage/Visitor_Module.h"
#endif
#ifndef included_SIDLLanguage_ASTException_stub
#include "SIDLLanguage/ASTException_Module.h"
#endif
#ifndef included_SIDL_NullIORException_stub
#include "SIDL/NullIORException_Module.h"
#endif
#ifndef included_SIDL_BaseException_stub
#include "SIDL/BaseException_Module.h"
#endif
#ifndef included_SIDL_BaseInterface_stub
#include "SIDL/BaseInterface_Module.h"
#endif
#ifndef included_SIDLLanguage_AST_stub
#include "SIDLLanguage/AST_Module.h"
#endif
#ifndef included_SIDLLanguage_Comment_stub
#include "SIDLLanguage/Comment_Module.h"
#endif
#ifndef included_SIDLLanguage_Code_stub
#include "SIDLLanguage/Code_Module.h"
#endif
#ifndef included_SIDLLanguage_CodeGeneratorException_stub
#include "SIDLLanguage/CodeGeneratorException_Module.h"
#endif
#ifndef included_SIDLLanguage_Attribute_stub
#include "SIDLLanguage/Attribute_Module.h"
#endif
#ifndef included_SIDLLanguage_Interface_stub
#include "SIDLLanguage/Interface_Module.h"
#endif
#ifndef included_SIDLLanguage_Method_stub
#include "SIDLLanguage/Method_Module.h"
#endif

static void
initImplementation(void) {
  static int notInitialized = 1;

  if (notInitialized) {
    notInitialized = 0;
    SIDL_Python_Init();
  }
}

static void _importModules(void) {
  static int _import = 1;
  PyObject *module;

  if (_import) {
    _import = 0;
    module = PyImport_ImportModule((char *) "user");
    module = PyImport_ImportModule((char *) "importer");
    if (PyErr_Occurred()) {PyErr_Print();}
    import_SIDLObjA();
    import_SIDLPyArrays();
    ANL_SIDLCompilerI_Interface__import();
    SIDLLanguage_Visitor__import();
    SIDLLanguage_ASTException__import();
    SIDL_NullIORException__import();
    SIDL_BaseException__import();
    SIDL_BaseInterface__import();
    SIDLLanguage_AST__import();
    SIDLLanguage_Comment__import();
    SIDLLanguage_Code__import();
    SIDLLanguage_CodeGeneratorException__import();
    SIDLLanguage_Attribute__import();
    SIDLLanguage_Interface__import();
    SIDLLanguage_Method__import();
  }
}

static void
ANL_SIDLCompilerI_Interface_accept_skel(
  struct ANL_SIDLCompilerI_Interface__object *self,
  /*in*/ struct SIDLLanguage_Visitor__object * visitor,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "(O&)",
    (void *) SIDLLanguage_Visitor__newRef, visitor
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for ANL.SIDLCompilerI.Interface.accept");
    return;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "accept");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDLLanguage_ASTException__type)) {
      struct SIDLLanguage_ASTException__object *_local_exception;
  
      (void) SIDLLanguage_ASTException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDLLanguage_ASTException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  _okay = (_return_value == Py_None);
  if (!_okay) {
    printf("Invalid return from void function accept\n");
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return;
}

static struct SIDLLanguage_Interface__array *
ANL_SIDLCompilerI_Interface_getParents_skel(
  struct ANL_SIDLCompilerI_Interface__object *self,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  struct SIDLLanguage_Interface__array * _result;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "()"
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.Interface.getParents");
    return _result;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "getParents");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  if (_return_value) {
    PyObject *_tmp = PyTuple_New(1);
  
    PyTuple_SET_ITEM(_tmp, 0, _return_value);
    _return_value = _tmp;
    _okay   = PyArg_ParseTuple(_return_value,
      (char *) "O&",
      (void *) SIDLLanguage_Interface__convert_python_array, &_result
    );
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return _result;
}

static void
ANL_SIDLCompilerI_Interface_setParents_skel(
  struct ANL_SIDLCompilerI_Interface__object *self,
  /*in*/ struct SIDLLanguage_Interface__array * parents,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "(O&)",
    (void *) SIDLLanguage_Interface__convert_sidl_array, parents
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.Interface.setParents");
    return;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "setParents");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  _okay = (_return_value == Py_None);
  if (!_okay) {
    printf("Invalid return from void function setParents\n");
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return;
}

static void
ANL_SIDLCompilerI_Interface_addParents_skel(
  struct ANL_SIDLCompilerI_Interface__object *self,
  /*in*/ struct SIDLLanguage_Interface__array * parents,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "(O&)",
    (void *) SIDLLanguage_Interface__convert_sidl_array, parents
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.Interface.addParents");
    return;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "addParents");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  _okay = (_return_value == Py_None);
  if (!_okay) {
    printf("Invalid return from void function addParents\n");
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return;
}

static struct SIDLLanguage_Method__array *
ANL_SIDLCompilerI_Interface_getMethods_skel(
  struct ANL_SIDLCompilerI_Interface__object *self,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  struct SIDLLanguage_Method__array * _result;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "()"
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.Interface.getMethods");
    return _result;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "getMethods");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  if (_return_value) {
    PyObject *_tmp = PyTuple_New(1);
  
    PyTuple_SET_ITEM(_tmp, 0, _return_value);
    _return_value = _tmp;
    _okay   = PyArg_ParseTuple(_return_value,
      (char *) "O&",
      (void *) SIDLLanguage_Method__convert_python_array, &_result
    );
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return _result;
}

static void
ANL_SIDLCompilerI_Interface_setMethods_skel(
  struct ANL_SIDLCompilerI_Interface__object *self,
  /*in*/ struct SIDLLanguage_Method__array * methods,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "(O&)",
    (void *) SIDLLanguage_Method__convert_sidl_array, methods
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.Interface.setMethods");
    return;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "setMethods");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  _okay = (_return_value == Py_None);
  if (!_okay) {
    printf("Invalid return from void function setMethods\n");
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return;
}

static void
ANL_SIDLCompilerI_Interface_addMethods_skel(
  struct ANL_SIDLCompilerI_Interface__object *self,
  /*in*/ struct SIDLLanguage_Method__array * methods,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "(O&)",
    (void *) SIDLLanguage_Method__convert_sidl_array, methods
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.Interface.addMethods");
    return;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "addMethods");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  _okay = (_return_value == Py_None);
  if (!_okay) {
    printf("Invalid return from void function addMethods\n");
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return;
}

static void ANL_SIDLCompilerI_Interface__ctor_skel(struct ANL_SIDLCompilerI_Interface__object *self) {
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_result;

  _context = PyImport_ImportModule((char *) "ANL.SIDLCompilerI_impl.Interface_impl");
  if (!_context) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "Interface");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    Py_DECREF(_context);
    return;
  }
  _args = Py_BuildValue((char *) "(O&)", (void *) ANL_SIDLCompilerI_Interface__weakRef, self);
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    Py_DECREF(_pfunc);
    Py_DECREF(_context);
    return;
  }
  _result = PyInstance_New(_pfunc, _args, NULL);
  if (_result) {
    self->d_data = _result;
  } else {
    if (PyErr_Occurred()) PyErr_Print();
  }
  Py_DECREF(_args);
  Py_DECREF(_pfunc);
  Py_DECREF(_context);
}

static void ANL_SIDLCompilerI_Interface__dtor_skel(struct ANL_SIDLCompilerI_Interface__object *self) {
  /* Remove only reference to Python object */
  Py_XDECREF(((PyObject *) self->d_data));
}

void ANL_SIDLCompilerI_Interface__set_epv(struct ANL_SIDLCompilerI_Interface__epv * epv);
void
ANL_SIDLCompilerI_Interface__set_epv(struct ANL_SIDLCompilerI_Interface__epv * epv) {
  initImplementation();
  _importModules();
  /* Initialize constructor and destructor */
  epv->f__ctor = ANL_SIDLCompilerI_Interface__ctor_skel;
  epv->f__dtor = ANL_SIDLCompilerI_Interface__dtor_skel;
  /* Initialize user methods */
  epv->f_accept = ANL_SIDLCompilerI_Interface_accept_skel;
  epv->f_getParents = ANL_SIDLCompilerI_Interface_getParents_skel;
  epv->f_setParents = ANL_SIDLCompilerI_Interface_setParents_skel;
  epv->f_addParents = ANL_SIDLCompilerI_Interface_addParents_skel;
  epv->f_getMethods = ANL_SIDLCompilerI_Interface_getMethods_skel;
  epv->f_setMethods = ANL_SIDLCompilerI_Interface_setMethods_skel;
  epv->f_addMethods = ANL_SIDLCompilerI_Interface_addMethods_skel;
}

