#include "SIDLObjA.h"
#include "SIDLPyArrays.h"
#define  NO_IMPORT_ARRAY
#include "Numeric/arrayobject.h"

/* The SIDL Runtime function which spawns the interpreter */
void SIDL_Python_Init(void);

#ifndef included_ANL_SIDLCompilerI_Method_IOR
#include "ANL/SIDLCompilerI/Method_IOR/Method_IOR.h"
#endif
#ifndef included_ANL_SIDLCompilerI_Method_stub
#include "ANL/SIDLCompilerI/Method_Module.h"
#endif
//
// Includes for all method dependencies
//
#ifndef included_SIDL_Loader_IOR
#include "SIDL/Loader_IOR/Loader_IOR.h"
#endif
#ifndef included_SIDLLanguage_Visitor_stub
#include "SIDLLanguage/Visitor_Module.h"
#endif
#ifndef included_SIDLLanguage_ASTException_stub
#include "SIDLLanguage/ASTException_Module.h"
#endif
#ifndef included_SIDL_NullIORException_stub
#include "SIDL/NullIORException_Module.h"
#endif
#ifndef included_SIDL_BaseException_stub
#include "SIDL/BaseException_Module.h"
#endif
#ifndef included_SIDL_BaseInterface_stub
#include "SIDL/BaseInterface_Module.h"
#endif
#ifndef included_SIDLLanguage_AST_stub
#include "SIDLLanguage/AST_Module.h"
#endif
#ifndef included_SIDLLanguage_Comment_stub
#include "SIDLLanguage/Comment_Module.h"
#endif
#ifndef included_SIDLLanguage_Code_stub
#include "SIDLLanguage/Code_Module.h"
#endif
#ifndef included_SIDLLanguage_CodeGeneratorException_stub
#include "SIDLLanguage/CodeGeneratorException_Module.h"
#endif
#ifndef included_SIDLLanguage_Attribute_stub
#include "SIDLLanguage/Attribute_Module.h"
#endif
#ifndef included_SIDLLanguage_Type_stub
#include "SIDLLanguage/Type_Module.h"
#endif
#ifndef included_SIDLLanguage_Class_stub
#include "SIDLLanguage/Class_Module.h"
#endif

static void
initImplementation(void) {
  static int notInitialized = 1;

  if (notInitialized) {
    notInitialized = 0;
    SIDL_Python_Init();
  }
}

static void _importModules(void) {
  static int _import = 1;
  PyObject *module;

  if (_import) {
    _import = 0;
    module = PyImport_ImportModule((char *) "user");
    module = PyImport_ImportModule((char *) "importer");
    if (PyErr_Occurred()) {PyErr_Print();}
    import_SIDLObjA();
    import_SIDLPyArrays();
    ANL_SIDLCompilerI_Method__import();
    SIDLLanguage_Visitor__import();
    SIDLLanguage_ASTException__import();
    SIDL_NullIORException__import();
    SIDL_BaseException__import();
    SIDL_BaseInterface__import();
    SIDLLanguage_AST__import();
    SIDLLanguage_Comment__import();
    SIDLLanguage_Code__import();
    SIDLLanguage_CodeGeneratorException__import();
    SIDLLanguage_Attribute__import();
    SIDLLanguage_Type__import();
    SIDLLanguage_Class__import();
  }
}

static void
ANL_SIDLCompilerI_Method_accept_skel(
  struct ANL_SIDLCompilerI_Method__object *self,
  /*in*/ struct SIDLLanguage_Visitor__object * visitor,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "(O&)",
    (void *) SIDLLanguage_Visitor__newRef, visitor
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for ANL.SIDLCompilerI.Method.accept");
    return;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "accept");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDLLanguage_ASTException__type)) {
      struct SIDLLanguage_ASTException__object *_local_exception;
  
      (void) SIDLLanguage_ASTException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDLLanguage_ASTException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  _okay = (_return_value == Py_None);
  if (!_okay) {
    printf("Invalid return from void function accept\n");
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return;
}

static char *
ANL_SIDLCompilerI_Method_getFullIdentifier_skel(
  struct ANL_SIDLCompilerI_Method__object *self,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  char * _result = NULL;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "()"
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for ANL.SIDLCompilerI.Method.getFullIdentifier");
    return _result;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "getFullIdentifier");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  if (_return_value) {
    PyObject *_tmp = PyTuple_New(1);
  
    PyTuple_SET_ITEM(_tmp, 0, _return_value);
    _return_value = _tmp;
    _okay   = PyArg_ParseTuple(_return_value,
      (char *) "z",
      &_result
    );
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  _result = (_result ? strcpy(malloc(strlen(_result)+1), _result) : NULL);
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return _result;
}

static struct SIDLLanguage_Type__object *
ANL_SIDLCompilerI_Method_getReturnType_skel(
  struct ANL_SIDLCompilerI_Method__object *self,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  struct SIDLLanguage_Type__object * _result;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "()"
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.Method.getReturnType");
    return _result;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "getReturnType");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  if (_return_value) {
    PyObject *_tmp = PyTuple_New(1);
  
    PyTuple_SET_ITEM(_tmp, 0, _return_value);
    _return_value = _tmp;
    _okay   = PyArg_ParseTuple(_return_value,
      (char *) "O&",
      (void *) SIDLLanguage_Type__convert, &_result
    );
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return _result;
}

static void
ANL_SIDLCompilerI_Method_setReturnType_skel(
  struct ANL_SIDLCompilerI_Method__object *self,
  /*in*/ struct SIDLLanguage_Type__object * type,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "(O&)",
    (void *) SIDLLanguage_Type__newRef, type
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.Method.setReturnType");
    return;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "setReturnType");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  _okay = (_return_value == Py_None);
  if (!_okay) {
    printf("Invalid return from void function setReturnType\n");
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return;
}

static struct SIDLLanguage_Class__array *
ANL_SIDLCompilerI_Method_getExceptions_skel(
  struct ANL_SIDLCompilerI_Method__object *self,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  struct SIDLLanguage_Class__array * _result;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "()"
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.Method.getExceptions");
    return _result;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "getExceptions");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  if (_return_value) {
    PyObject *_tmp = PyTuple_New(1);
  
    PyTuple_SET_ITEM(_tmp, 0, _return_value);
    _return_value = _tmp;
    _okay   = PyArg_ParseTuple(_return_value,
      (char *) "O&",
      (void *) SIDLLanguage_Class__convert_python_array, &_result
    );
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return _result;
}

static void
ANL_SIDLCompilerI_Method_setExceptions_skel(
  struct ANL_SIDLCompilerI_Method__object *self,
  /*in*/ struct SIDLLanguage_Class__array * exceptions,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "(O&)",
    (void *) SIDLLanguage_Class__convert_sidl_array, exceptions
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.Method.setExceptions");
    return;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "setExceptions");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  _okay = (_return_value == Py_None);
  if (!_okay) {
    printf("Invalid return from void function setExceptions\n");
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return;
}

static void
ANL_SIDLCompilerI_Method_addExceptions_skel(
  struct ANL_SIDLCompilerI_Method__object *self,
  /*in*/ struct SIDLLanguage_Class__array * exceptions,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "(O&)",
    (void *) SIDLLanguage_Class__convert_sidl_array, exceptions
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.Method.addExceptions");
    return;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "addExceptions");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  _okay = (_return_value == Py_None);
  if (!_okay) {
    printf("Invalid return from void function addExceptions\n");
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return;
}

static SIDL_bool
ANL_SIDLCompilerI_Method_getStatic_skel(
  struct ANL_SIDLCompilerI_Method__object *self,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  SIDL_bool _result = FALSE;
  int _local__result;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "()"
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.Method.getStatic");
    return _result;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "getStatic");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  if (_return_value) {
    PyObject *_tmp = PyTuple_New(1);
  
    PyTuple_SET_ITEM(_tmp, 0, _return_value);
    _return_value = _tmp;
    _okay   = PyArg_ParseTuple(_return_value,
      (char *) "i",
      &_local__result
    );
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  _result = (_local__result ? TRUE : FALSE);
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return _result;
}

static void
ANL_SIDLCompilerI_Method_setStatic_skel(
  struct ANL_SIDLCompilerI_Method__object *self,
  /*in*/ SIDL_bool isStatic,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  /* Pack arguments for dispatch to implementation */
  int _local_isStatic;
  _local_isStatic = (isStatic != FALSE);
  _args = Py_BuildValue(
     (char *) "(i)",
    _local_isStatic
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.Method.setStatic");
    return;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "setStatic");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  _okay = (_return_value == Py_None);
  if (!_okay) {
    printf("Invalid return from void function setStatic\n");
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return;
}

static SIDL_bool
ANL_SIDLCompilerI_Method_getFinal_skel(
  struct ANL_SIDLCompilerI_Method__object *self,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  SIDL_bool _result = FALSE;
  int _local__result;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "()"
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.Method.getFinal");
    return _result;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "getFinal");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  if (_return_value) {
    PyObject *_tmp = PyTuple_New(1);
  
    PyTuple_SET_ITEM(_tmp, 0, _return_value);
    _return_value = _tmp;
    _okay   = PyArg_ParseTuple(_return_value,
      (char *) "i",
      &_local__result
    );
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  _result = (_local__result ? TRUE : FALSE);
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return _result;
}

static void
ANL_SIDLCompilerI_Method_setFinal_skel(
  struct ANL_SIDLCompilerI_Method__object *self,
  /*in*/ SIDL_bool isFinal,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  /* Pack arguments for dispatch to implementation */
  int _local_isFinal;
  _local_isFinal = (isFinal != FALSE);
  _args = Py_BuildValue(
     (char *) "(i)",
    _local_isFinal
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.Method.setFinal");
    return;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "setFinal");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  _okay = (_return_value == Py_None);
  if (!_okay) {
    printf("Invalid return from void function setFinal\n");
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return;
}

static SIDL_bool
ANL_SIDLCompilerI_Method_getAbstract_skel(
  struct ANL_SIDLCompilerI_Method__object *self,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  SIDL_bool _result = FALSE;
  int _local__result;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "()"
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.Method.getAbstract");
    return _result;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "getAbstract");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  if (_return_value) {
    PyObject *_tmp = PyTuple_New(1);
  
    PyTuple_SET_ITEM(_tmp, 0, _return_value);
    _return_value = _tmp;
    _okay   = PyArg_ParseTuple(_return_value,
      (char *) "i",
      &_local__result
    );
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  _result = (_local__result ? TRUE : FALSE);
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return _result;
}

static void
ANL_SIDLCompilerI_Method_setAbstract_skel(
  struct ANL_SIDLCompilerI_Method__object *self,
  /*in*/ SIDL_bool isAbstract,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  /* Pack arguments for dispatch to implementation */
  int _local_isAbstract;
  _local_isAbstract = (isAbstract != FALSE);
  _args = Py_BuildValue(
     (char *) "(i)",
    _local_isAbstract
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.Method.setAbstract");
    return;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "setAbstract");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  _okay = (_return_value == Py_None);
  if (!_okay) {
    printf("Invalid return from void function setAbstract\n");
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return;
}

static SIDL_bool
ANL_SIDLCompilerI_Method_getInternal_skel(
  struct ANL_SIDLCompilerI_Method__object *self,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  SIDL_bool _result = FALSE;
  int _local__result;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "()"
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.Method.getInternal");
    return _result;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "getInternal");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  if (_return_value) {
    PyObject *_tmp = PyTuple_New(1);
  
    PyTuple_SET_ITEM(_tmp, 0, _return_value);
    _return_value = _tmp;
    _okay   = PyArg_ParseTuple(_return_value,
      (char *) "i",
      &_local__result
    );
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  _result = (_local__result ? TRUE : FALSE);
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return _result;
}

static void
ANL_SIDLCompilerI_Method_setInternal_skel(
  struct ANL_SIDLCompilerI_Method__object *self,
  /*in*/ SIDL_bool isInternal,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  /* Pack arguments for dispatch to implementation */
  int _local_isInternal;
  _local_isInternal = (isInternal != FALSE);
  _args = Py_BuildValue(
     (char *) "(i)",
    _local_isInternal
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.Method.setInternal");
    return;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "setInternal");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  _okay = (_return_value == Py_None);
  if (!_okay) {
    printf("Invalid return from void function setInternal\n");
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return;
}

static struct SIDL_string__array *
ANL_SIDLCompilerI_Method_getTemplateIdentifiers_skel(
  struct ANL_SIDLCompilerI_Method__object *self,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  struct SIDL_string__array * _result;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "()"
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.Method.getTemplateIdentifiers");
    return _result;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "getTemplateIdentifiers");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  if (_return_value) {
    PyObject *_tmp = PyTuple_New(1);
  
    PyTuple_SET_ITEM(_tmp, 0, _return_value);
    _return_value = _tmp;
    _okay   = PyArg_ParseTuple(_return_value,
      (char *) "O&",
      (void *) SIDL_string__clone_python_array, &_result
    );
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return _result;
}

static void
ANL_SIDLCompilerI_Method_setTemplateIdentifiers_skel(
  struct ANL_SIDLCompilerI_Method__object *self,
  /*in*/ struct SIDL_string__array * templateIds,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "(O&)",
    (void *) SIDL_string__python_borrow_array, templateIds
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for SIDLLanguage.Method.setTemplateIdentifiers");
    return;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "setTemplateIdentifiers");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  _okay = (_return_value == Py_None);
  if (!_okay) {
    printf("Invalid return from void function setTemplateIdentifiers\n");
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return;
}

static void ANL_SIDLCompilerI_Method__ctor_skel(struct ANL_SIDLCompilerI_Method__object *self) {
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_result;

  _context = PyImport_ImportModule((char *) "ANL.SIDLCompilerI_impl.Method_impl");
  if (!_context) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "Method");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    Py_DECREF(_context);
    return;
  }
  _args = Py_BuildValue((char *) "(O&)", (void *) ANL_SIDLCompilerI_Method__weakRef, self);
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    Py_DECREF(_pfunc);
    Py_DECREF(_context);
    return;
  }
  _result = PyInstance_New(_pfunc, _args, NULL);
  if (_result) {
    self->d_data = _result;
  } else {
    if (PyErr_Occurred()) PyErr_Print();
  }
  Py_DECREF(_args);
  Py_DECREF(_pfunc);
  Py_DECREF(_context);
}

static void ANL_SIDLCompilerI_Method__dtor_skel(struct ANL_SIDLCompilerI_Method__object *self) {
  /* Remove only reference to Python object */
  Py_XDECREF(((PyObject *) self->d_data));
}

void ANL_SIDLCompilerI_Method__set_epv(struct ANL_SIDLCompilerI_Method__epv * epv);
void
ANL_SIDLCompilerI_Method__set_epv(struct ANL_SIDLCompilerI_Method__epv * epv) {
  initImplementation();
  _importModules();
  /* Initialize constructor and destructor */
  epv->f__ctor = ANL_SIDLCompilerI_Method__ctor_skel;
  epv->f__dtor = ANL_SIDLCompilerI_Method__dtor_skel;
  /* Initialize user methods */
  epv->f_accept = ANL_SIDLCompilerI_Method_accept_skel;
  epv->f_getFullIdentifier = ANL_SIDLCompilerI_Method_getFullIdentifier_skel;
  epv->f_getReturnType = ANL_SIDLCompilerI_Method_getReturnType_skel;
  epv->f_setReturnType = ANL_SIDLCompilerI_Method_setReturnType_skel;
  epv->f_getExceptions = ANL_SIDLCompilerI_Method_getExceptions_skel;
  epv->f_setExceptions = ANL_SIDLCompilerI_Method_setExceptions_skel;
  epv->f_addExceptions = ANL_SIDLCompilerI_Method_addExceptions_skel;
  epv->f_getStatic = ANL_SIDLCompilerI_Method_getStatic_skel;
  epv->f_setStatic = ANL_SIDLCompilerI_Method_setStatic_skel;
  epv->f_getFinal = ANL_SIDLCompilerI_Method_getFinal_skel;
  epv->f_setFinal = ANL_SIDLCompilerI_Method_setFinal_skel;
  epv->f_getAbstract = ANL_SIDLCompilerI_Method_getAbstract_skel;
  epv->f_setAbstract = ANL_SIDLCompilerI_Method_setAbstract_skel;
  epv->f_getInternal = ANL_SIDLCompilerI_Method_getInternal_skel;
  epv->f_setInternal = ANL_SIDLCompilerI_Method_setInternal_skel;
  epv->f_getTemplateIdentifiers = ANL_SIDLCompilerI_Method_getTemplateIdentifiers_skel;
  epv->f_setTemplateIdentifiers = ANL_SIDLCompilerI_Method_setTemplateIdentifiers_skel;
}

