#ifndef included_SIDLLanguage_Attribute_IOR
#define included_SIDLLanguage_Attribute_IOR

#ifndef NULL
#define NULL 0
#endif

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#ifdef __cplusplus
extern "C" {
#endif

/* Symbol SIDLLanguage.Attribute */

/* These structures are defined in this header */
struct SIDLLanguage_Attribute__object;

/* Forward declarations for array structure and external classes and interfaces */
struct SIDLLanguage_Attribute__array;
struct SIDL_Loader__object;
struct SIDL_Loader__array;
struct SIDL_NullIORException__object;
struct SIDL_NullIORException__array;
struct SIDL_BaseException__object;
struct SIDL_BaseException__array;
struct SIDL_BaseInterface__object;
struct SIDL_BaseInterface__array;
struct SIDL_BaseException__object;
struct SIDL_BaseException__array;

#ifndef included_SIDL_header_h
#include "SIDL_header.h"
#endif

/* Declare the method entry point vector */
struct SIDLLanguage_Attribute__epv {
  /* Builtin methods */
  void *(*f__cast_ior)(
    void *self,
    const char *name);
  void (*f__delete)(
    void *self);
  /* Methods contributed by SIDLLanguage.Attribute */
  char * (*f_getName)(
    void *self,
    struct SIDL_BaseException__object **_exception);
  void (*f_setName)(
    void *self,
    /*in*/ const char * name,
    struct SIDL_BaseException__object **_exception);
  /* Methods contributed by SIDL.BaseInterface */
  void (*f_addReference)(
    void *self);
  void (*f_deleteReference)(
    void *self);
  SIDL_bool (*f_isSame)(
    void *self,
    /*in*/ struct SIDL_BaseInterface__object * iobj);
  struct SIDL_BaseInterface__object * (*f_queryInterface)(
    void *self,
    /*in*/ const char * name);
  SIDL_bool (*f_isInstanceOf)(
    void *self,
    /*in*/ const char * name);
};

/* Define the object structure */
struct SIDLLanguage_Attribute__object {
  struct SIDLLanguage_Attribute__epv * d_epv;
  void *d_object;
};

/* Create a dense array of the given dimension with specified index bounds */
/*   This array owns and manages its data */
/*   All object pointers are initialized to NULL */
struct SIDLLanguage_Attribute__array * SIDLLanguage_Attribute__iorarray_create(
  int32_t dimen,
  const int32_t lower[],
  const int32_t upper[]);

/* Create an array using user-provided memory */
struct SIDLLanguage_Attribute__array * SIDLLanguage_Attribute__iorarray_borrow(
  struct SIDLLanguage_Attribute__object ** firstElement,
  int32_t dimen,
  const int32_t lower[],
  const int32_t upper[],
  const int32_t stride[]);

/* Destroy the array (NULL arrays are ignored) */
void SIDLLanguage_Attribute__iorarray_destroy(
  struct SIDLLanguage_Attribute__array *array);

/* Return the number of dimensions in the array */
/*   If the array pointer is NULL, zero is returned */
int32_t SIDLLanguage_Attribute__iorarray_dimen(
  const struct SIDLLanguage_Attribute__array *array);

/* Return the lower bound on dimension ind */
/*   If the array pointer is NULL or ind is not a valid dimension, zero is returned */
int32_t SIDLLanguage_Attribute__iorarray_lower(
  const struct SIDLLanguage_Attribute__array *array,
  int32_t ind);

/* Return the upper bound on dimension ind */
/*   If the array pointer is NULL or ind is not a valid dimension, -1 is returned */
int32_t SIDLLanguage_Attribute__iorarray_upper(
  const struct SIDLLanguage_Attribute__array *array,
  int32_t ind);

/* Get an element of a multi-dimensional array */
/* This will use the indices provided up to the actual dimension of the array, ignoring extra indices */
/* If the return value is non-NULL, the client owns one reference to the object/interface */
/* The client must decrement the reference count when done with the reference */
struct SIDLLanguage_Attribute__object * SIDLLanguage_Attribute__iorarray_get(
  const struct SIDLLanguage_Attribute__array *array,
  const int32_t indices[]);

/* get an element of a multi-dimensional array */
/* This will use the indices provided up to the actual dimension of the array, ignoring extra indices */
/* If the return value is non-NULL, the client owns one reference to the object/interface */
/* The client must decrement the reference count when done with the reference */
struct SIDLLanguage_Attribute__object * SIDLLanguage_Attribute__iorarray_get4(
  const struct SIDLLanguage_Attribute__array *array,
  int32_t i1,
  int32_t i2,
  int32_t i3,
  int32_t i4);

/* Set an element of a multi-dimensional array */
/* This will use the indices provided up to the actual dimension of the array, ignoring extra indices */
/* If the incoming value is non-NULL, this function will increment the reference code of the object/interface */
/* If it is overwriting a non-NULL pointer, the reference count of the object/interface being overwritten will be decremented */
void SIDLLanguage_Attribute__iorarray_set(
  struct SIDLLanguage_Attribute__array *array,
  const int32_t indices[],
  struct SIDLLanguage_Attribute__object * value);

/* set an element of a multi-dimensional array */
/* This will use the indices provided up to the actual dimension of the array, ignoring extra indices */
/* If the incoming value is non-NULL, this function will increment the reference code of the object/interface */
/* If it is overwriting a non-NULL pointer, the reference count of the object/interface being overwritten will be decremented */
void SIDLLanguage_Attribute__iorarray_set4(
  struct SIDLLanguage_Attribute__array *array,
  int32_t i1,
  int32_t i2,
  int32_t i3,
  int32_t i4,
  struct SIDLLanguage_Attribute__object * value);

struct SIDLLanguage_Attribute__external {
  struct SIDLLanguage_Attribute__array * (*createArray)  (
    int32_t dimen,
    const int32_t lower[],
    const int32_t upper[]);
  struct SIDLLanguage_Attribute__array * (*borrowArray)  (
    struct SIDLLanguage_Attribute__object ** firstElement,
    int32_t dimen,
    const int32_t lower[],
    const int32_t upper[],
    const int32_t stride[]);
  void (*destroyArray)  (
    struct SIDLLanguage_Attribute__array *array);
  int32_t (*getDimen)  (
    const struct SIDLLanguage_Attribute__array *array);
  int32_t (*getLower)  (
    const struct SIDLLanguage_Attribute__array *array,
    int32_t ind);
  int32_t (*getUpper)  (
    const struct SIDLLanguage_Attribute__array *array,
    int32_t ind);
  struct SIDLLanguage_Attribute__object * (*getElement)  (
    const struct SIDLLanguage_Attribute__array *array,
    const int32_t indices[]);
  struct SIDLLanguage_Attribute__object * (*getElement4)  (
    const struct SIDLLanguage_Attribute__array *array,
    int32_t i1,
    int32_t i2,
    int32_t i3,
    int32_t i4);
  void (*setElement)  (
    struct SIDLLanguage_Attribute__array *array,
    const int32_t indices[],
    struct SIDLLanguage_Attribute__object * value);
  void (*setElement4)  (
    struct SIDLLanguage_Attribute__array *array,
    int32_t i1,
    int32_t i2,
    int32_t i3,
    int32_t i4,
    struct SIDLLanguage_Attribute__object * value);
};

/* This function returns a pointer to a static structure of pointers to function entry points */
/* It is called upon loading the DLL */
const struct SIDLLanguage_Attribute__external *SIDLLanguage_Attribute__externals(void);
#ifdef __cplusplus
}
#endif

#endif /* included_SIDLLanguage_Attribute_IOR */
