#ifndef included_SIDLLanguage_Class_IOR
#define included_SIDLLanguage_Class_IOR

#ifndef NULL
#define NULL 0
#endif

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#ifdef __cplusplus
extern "C" {
#endif

/* Symbol SIDLLanguage.Class */

/* These structures are defined in this header */
struct SIDLLanguage_Class__object;

/* Forward declarations for array structure and external classes and interfaces */
struct SIDLLanguage_Class__array;
struct SIDL_Loader__object;
struct SIDL_Loader__array;
struct SIDL_NullIORException__object;
struct SIDL_NullIORException__array;
struct SIDL_BaseException__object;
struct SIDL_BaseException__array;
struct SIDLLanguage_Interface__object;
struct SIDLLanguage_Interface__array;
struct SIDLLanguage_Method__object;
struct SIDLLanguage_Method__array;
struct SIDLLanguage_Visitor__object;
struct SIDLLanguage_Visitor__array;
struct SIDLLanguage_ASTException__object;
struct SIDLLanguage_ASTException__array;
struct SIDLLanguage_AST__object;
struct SIDLLanguage_AST__array;
struct SIDLLanguage_Comment__object;
struct SIDLLanguage_Comment__array;
struct SIDLLanguage_Code__object;
struct SIDLLanguage_Code__array;
struct SIDLLanguage_CodeGeneratorException__object;
struct SIDLLanguage_CodeGeneratorException__array;
struct SIDLLanguage_Attribute__object;
struct SIDLLanguage_Attribute__array;
struct SIDL_BaseInterface__object;
struct SIDL_BaseInterface__array;
struct SIDL_BaseException__object;
struct SIDL_BaseException__array;

#ifndef included_SIDL_header_h
#include "SIDL_header.h"
#endif

/* Declare the method entry point vector */
struct SIDLLanguage_Class__epv {
  /* Builtin methods */
  void *(*f__cast_ior)(
    void *self,
    const char *name);
  void (*f__delete)(
    void *self);
  /* Methods contributed by SIDLLanguage.Class */
  SIDL_bool (*f_getAbstract)(
    void *self,
    struct SIDL_BaseException__object **_exception);
  void (*f_setAbstract)(
    void *self,
    /*in*/ SIDL_bool isAbstract,
    struct SIDL_BaseException__object **_exception);
  struct SIDLLanguage_Interface__array * (*f_getInterfaces)(
    void *self,
    struct SIDL_BaseException__object **_exception);
  void (*f_setInterfaces)(
    void *self,
    /*in*/ struct SIDLLanguage_Interface__array * interfaces,
    struct SIDL_BaseException__object **_exception);
  void (*f_addInterfaces)(
    void *self,
    /*in*/ struct SIDLLanguage_Interface__array * interfaces,
    struct SIDL_BaseException__object **_exception);
  struct SIDLLanguage_Method__array * (*f_getImplementedMethods)(
    void *self,
    struct SIDL_BaseException__object **_exception);
  void (*f_setImplementedMethods)(
    void *self,
    /*in*/ struct SIDLLanguage_Method__array * methods,
    struct SIDL_BaseException__object **_exception);
  void (*f_addImplementedMethods)(
    void *self,
    /*in*/ struct SIDLLanguage_Method__array * methods,
    struct SIDL_BaseException__object **_exception);
  /* Methods contributed by SIDLLanguage.Interface */
  struct SIDLLanguage_Interface__array * (*f_getParents)(
    void *self,
    struct SIDL_BaseException__object **_exception);
  void (*f_setParents)(
    void *self,
    /*in*/ struct SIDLLanguage_Interface__array * parents,
    struct SIDL_BaseException__object **_exception);
  void (*f_addParents)(
    void *self,
    /*in*/ struct SIDLLanguage_Interface__array * parents,
    struct SIDL_BaseException__object **_exception);
  struct SIDLLanguage_Method__array * (*f_getMethods)(
    void *self,
    struct SIDL_BaseException__object **_exception);
  void (*f_setMethods)(
    void *self,
    /*in*/ struct SIDLLanguage_Method__array * methods,
    struct SIDL_BaseException__object **_exception);
  void (*f_addMethods)(
    void *self,
    /*in*/ struct SIDLLanguage_Method__array * methods,
    struct SIDL_BaseException__object **_exception);
  /* Methods contributed by SIDLLanguage.Type */
  SIDL_bool (*f_getBaseType)(
    void *self,
    struct SIDL_BaseException__object **_exception);
  void (*f_setBaseType)(
    void *self,
    /*in*/ SIDL_bool baseType,
    struct SIDL_BaseException__object **_exception);
  /* Methods contributed by SIDLLanguage.AST */
  void (*f_accept)(
    void *self,
    /*in*/ struct SIDLLanguage_Visitor__object * visitor,
    struct SIDL_BaseException__object **_exception);
  char * (*f_getIdentifier)(
    void *self,
    struct SIDL_BaseException__object **_exception);
  void (*f_setIdentifier)(
    void *self,
    /*in*/ const char * identifier,
    struct SIDL_BaseException__object **_exception);
  char * (*f_getFullIdentifier)(
    void *self,
    struct SIDL_BaseException__object **_exception);
  struct SIDLLanguage_AST__object * (*f_getParent)(
    void *self,
    struct SIDL_BaseException__object **_exception);
  void (*f_setParent)(
    void *self,
    /*in*/ struct SIDLLanguage_AST__object * parent,
    struct SIDL_BaseException__object **_exception);
  struct SIDLLanguage_AST__array * (*f_getChildren)(
    void *self,
    struct SIDL_BaseException__object **_exception);
  void (*f_setChildren)(
    void *self,
    /*in*/ struct SIDLLanguage_AST__array * children,
    struct SIDL_BaseException__object **_exception);
  void (*f_addChildren)(
    void *self,
    /*in*/ struct SIDLLanguage_AST__array * children,
    struct SIDL_BaseException__object **_exception);
  struct SIDLLanguage_AST__array * (*f_getDependencies)(
    void *self,
    struct SIDL_BaseException__object **_exception);
  void (*f_setDependencies)(
    void *self,
    /*in*/ struct SIDLLanguage_AST__array * dependencies,
    struct SIDL_BaseException__object **_exception);
  void (*f_addDependency)(
    void *self,
    /*in*/ struct SIDLLanguage_AST__object * dependency,
    struct SIDL_BaseException__object **_exception);
  struct SIDLLanguage_Comment__array * (*f_getComments)(
    void *self,
    struct SIDL_BaseException__object **_exception);
  void (*f_setComments)(
    void *self,
    /*in*/ struct SIDLLanguage_Comment__array * comments,
    struct SIDL_BaseException__object **_exception);
  void (*f_addComments)(
    void *self,
    /*in*/ struct SIDLLanguage_Comment__array * comments,
    struct SIDL_BaseException__object **_exception);
  struct SIDLLanguage_Code__array * (*f_getCode)(
    void *self,
    /*in*/ const char * language,
    struct SIDL_BaseException__object **_exception);
  void (*f_setCode)(
    void *self,
    /*in*/ struct SIDLLanguage_Code__array * code,
    struct SIDL_BaseException__object **_exception);
  void (*f_addCode)(
    void *self,
    /*in*/ struct SIDLLanguage_Code__object * code,
    struct SIDL_BaseException__object **_exception);
  SIDL_bool (*f_hasCodeBlock)(
    void *self,
    /*in*/ const char * language,
    /*in*/ const char * label,
    struct SIDL_BaseException__object **_exception);
  struct SIDLLanguage_Code__object * (*f_getCodeBlock)(
    void *self,
    /*in*/ const char * language,
    /*in*/ const char * label,
    struct SIDL_BaseException__object **_exception);
  struct SIDLLanguage_Code__object * (*f_removeCodeBlock)(
    void *self,
    /*in*/ const char * language,
    /*in*/ const char * label,
    struct SIDL_BaseException__object **_exception);
  struct SIDLLanguage_Attribute__array * (*f_getAttributes)(
    void *self,
    struct SIDL_BaseException__object **_exception);
  void (*f_setAttributes)(
    void *self,
    /*in*/ struct SIDLLanguage_Attribute__array * attributes,
    struct SIDL_BaseException__object **_exception);
  SIDL_bool (*f_hasAttribute)(
    void *self,
    /*in*/ const char * name,
    struct SIDL_BaseException__object **_exception);
  void (*f_addAttribute)(
    void *self,
    /*in*/ struct SIDLLanguage_Attribute__object * attribute,
    struct SIDL_BaseException__object **_exception);
  struct SIDLLanguage_Attribute__object * (*f_deleteAttribute)(
    void *self,
    /*in*/ const char * name,
    struct SIDL_BaseException__object **_exception);
  struct SIDLLanguage_Attribute__object * (*f_getAttribute)(
    void *self,
    /*in*/ const char * name,
    struct SIDL_BaseException__object **_exception);
  /* Methods contributed by SIDL.BaseInterface */
  void (*f_addReference)(
    void *self);
  void (*f_deleteReference)(
    void *self);
  SIDL_bool (*f_isSame)(
    void *self,
    /*in*/ struct SIDL_BaseInterface__object * iobj);
  struct SIDL_BaseInterface__object * (*f_queryInterface)(
    void *self,
    /*in*/ const char * name);
  SIDL_bool (*f_isInstanceOf)(
    void *self,
    /*in*/ const char * name);
};

/* Define the object structure */
struct SIDLLanguage_Class__object {
  struct SIDLLanguage_Class__epv * d_epv;
  void *d_object;
};

/* Create a dense array of the given dimension with specified index bounds */
/*   This array owns and manages its data */
/*   All object pointers are initialized to NULL */
struct SIDLLanguage_Class__array * SIDLLanguage_Class__iorarray_create(
  int32_t dimen,
  const int32_t lower[],
  const int32_t upper[]);

/* Create an array using user-provided memory */
struct SIDLLanguage_Class__array * SIDLLanguage_Class__iorarray_borrow(
  struct SIDLLanguage_Class__object ** firstElement,
  int32_t dimen,
  const int32_t lower[],
  const int32_t upper[],
  const int32_t stride[]);

/* Destroy the array (NULL arrays are ignored) */
void SIDLLanguage_Class__iorarray_destroy(
  struct SIDLLanguage_Class__array *array);

/* Return the number of dimensions in the array */
/*   If the array pointer is NULL, zero is returned */
int32_t SIDLLanguage_Class__iorarray_dimen(
  const struct SIDLLanguage_Class__array *array);

/* Return the lower bound on dimension ind */
/*   If the array pointer is NULL or ind is not a valid dimension, zero is returned */
int32_t SIDLLanguage_Class__iorarray_lower(
  const struct SIDLLanguage_Class__array *array,
  int32_t ind);

/* Return the upper bound on dimension ind */
/*   If the array pointer is NULL or ind is not a valid dimension, -1 is returned */
int32_t SIDLLanguage_Class__iorarray_upper(
  const struct SIDLLanguage_Class__array *array,
  int32_t ind);

/* Get an element of a multi-dimensional array */
/* This will use the indices provided up to the actual dimension of the array, ignoring extra indices */
/* If the return value is non-NULL, the client owns one reference to the object/interface */
/* The client must decrement the reference count when done with the reference */
struct SIDLLanguage_Class__object * SIDLLanguage_Class__iorarray_get(
  const struct SIDLLanguage_Class__array *array,
  const int32_t indices[]);

/* get an element of a multi-dimensional array */
/* This will use the indices provided up to the actual dimension of the array, ignoring extra indices */
/* If the return value is non-NULL, the client owns one reference to the object/interface */
/* The client must decrement the reference count when done with the reference */
struct SIDLLanguage_Class__object * SIDLLanguage_Class__iorarray_get4(
  const struct SIDLLanguage_Class__array *array,
  int32_t i1,
  int32_t i2,
  int32_t i3,
  int32_t i4);

/* Set an element of a multi-dimensional array */
/* This will use the indices provided up to the actual dimension of the array, ignoring extra indices */
/* If the incoming value is non-NULL, this function will increment the reference code of the object/interface */
/* If it is overwriting a non-NULL pointer, the reference count of the object/interface being overwritten will be decremented */
void SIDLLanguage_Class__iorarray_set(
  struct SIDLLanguage_Class__array *array,
  const int32_t indices[],
  struct SIDLLanguage_Class__object * value);

/* set an element of a multi-dimensional array */
/* This will use the indices provided up to the actual dimension of the array, ignoring extra indices */
/* If the incoming value is non-NULL, this function will increment the reference code of the object/interface */
/* If it is overwriting a non-NULL pointer, the reference count of the object/interface being overwritten will be decremented */
void SIDLLanguage_Class__iorarray_set4(
  struct SIDLLanguage_Class__array *array,
  int32_t i1,
  int32_t i2,
  int32_t i3,
  int32_t i4,
  struct SIDLLanguage_Class__object * value);

struct SIDLLanguage_Class__external {
  struct SIDLLanguage_Class__array * (*createArray)  (
    int32_t dimen,
    const int32_t lower[],
    const int32_t upper[]);
  struct SIDLLanguage_Class__array * (*borrowArray)  (
    struct SIDLLanguage_Class__object ** firstElement,
    int32_t dimen,
    const int32_t lower[],
    const int32_t upper[],
    const int32_t stride[]);
  void (*destroyArray)  (
    struct SIDLLanguage_Class__array *array);
  int32_t (*getDimen)  (
    const struct SIDLLanguage_Class__array *array);
  int32_t (*getLower)  (
    const struct SIDLLanguage_Class__array *array,
    int32_t ind);
  int32_t (*getUpper)  (
    const struct SIDLLanguage_Class__array *array,
    int32_t ind);
  struct SIDLLanguage_Class__object * (*getElement)  (
    const struct SIDLLanguage_Class__array *array,
    const int32_t indices[]);
  struct SIDLLanguage_Class__object * (*getElement4)  (
    const struct SIDLLanguage_Class__array *array,
    int32_t i1,
    int32_t i2,
    int32_t i3,
    int32_t i4);
  void (*setElement)  (
    struct SIDLLanguage_Class__array *array,
    const int32_t indices[],
    struct SIDLLanguage_Class__object * value);
  void (*setElement4)  (
    struct SIDLLanguage_Class__array *array,
    int32_t i1,
    int32_t i2,
    int32_t i3,
    int32_t i4,
    struct SIDLLanguage_Class__object * value);
};

/* This function returns a pointer to a static structure of pointers to function entry points */
/* It is called upon loading the DLL */
const struct SIDLLanguage_Class__external *SIDLLanguage_Class__externals(void);
#ifdef __cplusplus
}
#endif

#endif /* included_SIDLLanguage_Class_IOR */
