#ifndef included_SIDLLanguage_ParameterAccessMode_IOR
#define included_SIDLLanguage_ParameterAccessMode_IOR

#ifndef NULL
#define NULL 0
#endif

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#ifdef __cplusplus
extern "C" {
#endif

/* Symbol SIDLLanguage.ParameterAccessMode */

/* Forward declarations for array structure and external classes and interfaces */
struct SIDLLanguage_ParameterAccessMode__array;

#ifndef included_SIDL_header_h
#include "SIDL_header.h"
#endif

enum SIDLLanguage_ParameterAccessMode__enum {
  IN = 0,
  OUT = 1,
  INOUT = 2
};

/* Create a dense array of the given dimension with specified index bounds */
/*   This array owns and manages its data */
/*   All object pointers are initialized to NULL */
struct SIDLLanguage_ParameterAccessMode__array * SIDLLanguage_ParameterAccessMode__iorarray_create(
  int32_t dimen,
  const int32_t lower[],
  const int32_t upper[]);

/* Create an array using user-provided memory */
struct SIDLLanguage_ParameterAccessMode__array * SIDLLanguage_ParameterAccessMode__iorarray_borrow(
  enum SIDLLanguage_ParameterAccessMode__enum* firstElement,
  int32_t dimen,
  const int32_t lower[],
  const int32_t upper[],
  const int32_t stride[]);

/* Destroy the array (NULL arrays are ignored) */
void SIDLLanguage_ParameterAccessMode__iorarray_destroy(
  struct SIDLLanguage_ParameterAccessMode__array *array);

/* Return the number of dimensions in the array */
/*   If the array pointer is NULL, zero is returned */
int32_t SIDLLanguage_ParameterAccessMode__iorarray_dimen(
  const struct SIDLLanguage_ParameterAccessMode__array *array);

/* Return the lower bound on dimension ind */
/*   If the array pointer is NULL or ind is not a valid dimension, zero is returned */
int32_t SIDLLanguage_ParameterAccessMode__iorarray_lower(
  const struct SIDLLanguage_ParameterAccessMode__array *array,
  int32_t ind);

/* Return the upper bound on dimension ind */
/*   If the array pointer is NULL or ind is not a valid dimension, -1 is returned */
int32_t SIDLLanguage_ParameterAccessMode__iorarray_upper(
  const struct SIDLLanguage_ParameterAccessMode__array *array,
  int32_t ind);

/* Get an element of a multi-dimensional array */
/* This will use the indices provided up to the actual dimension of the array, ignoring extra indices */
/* If the return value is non-NULL, the client owns one reference to the object/interface */
/* The client must decrement the reference count when done with the reference */
enum SIDLLanguage_ParameterAccessMode__enum SIDLLanguage_ParameterAccessMode__iorarray_get(
  const struct SIDLLanguage_ParameterAccessMode__array *array,
  const int32_t indices[]);

/* get an element of a multi-dimensional array */
/* This will use the indices provided up to the actual dimension of the array, ignoring extra indices */
/* If the return value is non-NULL, the client owns one reference to the object/interface */
/* The client must decrement the reference count when done with the reference */
enum SIDLLanguage_ParameterAccessMode__enum SIDLLanguage_ParameterAccessMode__iorarray_get4(
  const struct SIDLLanguage_ParameterAccessMode__array *array,
  int32_t i1,
  int32_t i2,
  int32_t i3,
  int32_t i4);

/* Set an element of a multi-dimensional array */
/* This will use the indices provided up to the actual dimension of the array, ignoring extra indices */
/* If the incoming value is non-NULL, this function will increment the reference code of the object/interface */
/* If it is overwriting a non-NULL pointer, the reference count of the object/interface being overwritten will be decremented */
void SIDLLanguage_ParameterAccessMode__iorarray_set(
  struct SIDLLanguage_ParameterAccessMode__array *array,
  const int32_t indices[],
  enum SIDLLanguage_ParameterAccessMode__enum value);

/* set an element of a multi-dimensional array */
/* This will use the indices provided up to the actual dimension of the array, ignoring extra indices */
/* If the incoming value is non-NULL, this function will increment the reference code of the object/interface */
/* If it is overwriting a non-NULL pointer, the reference count of the object/interface being overwritten will be decremented */
void SIDLLanguage_ParameterAccessMode__iorarray_set4(
  struct SIDLLanguage_ParameterAccessMode__array *array,
  int32_t i1,
  int32_t i2,
  int32_t i3,
  int32_t i4,
  enum SIDLLanguage_ParameterAccessMode__enum value);

#ifdef __cplusplus
}
#endif

#endif /* included_SIDLLanguage_ParameterAccessMode_IOR */
