# DO-NOT-DELETE splicer.begin(_initial)
import SIDL.Loader
import SIDLLanguage.Splicer
import SIDLLanguage.CodePurpose
# DO-NOT-DELETE splicer.end(_initial)

import SIDL.NullIORException
import SIDL.BaseInterface
import SIDL.BaseException
import SIDLLanguage.VisitorException
import SIDLLanguage.Splicer
import SIDLLanguage.Code
import SIDLLanguage.AST
import SIDLLanguage.Specification
import SIDLLanguage.Version
import SIDLLanguage.Package
import SIDLLanguage.Interface
import SIDLLanguage.Class
import SIDLLanguage.Method
import SIDLLanguage.Type
import SIDLLanguage.Enumeration
import SIDLLanguage.Enumerator
import SIDLLanguage.Array
import SIDLLanguage.Parameter
import SIDLLanguage.Comment

# DO-NOT-DELETE splicer.begin(_before_type)
import os
import sys
# DO-NOT-DELETE splicer.end(_before_type)

class FileOutput:
  '''
  // This class outputs all C++ code onto the filesystem
  '''
  # All calls to SIDL methods should use __IORself

  def __init__(self, IORself):
    self.__IORself = IORself
    # DO-NOT-DELETE splicer.begin(__init__)
    self.language       = 'C++'
    self.indentString   = '  '
    self.markName       = 'cxxFileOutputMark'
    self.defaultRoot    = os.path.join(os.getcwd(), 'test-'+self.language.lower())
    self.roots          = {}
    self.outputSource   = 1
    self.outputFiles    = []
    self.codeOutput     = SIDLLanguage.Code.Code(SIDL.Loader.createClass('ANL.SIDLCompilerI.CodeFile'))
    self.splicer        = SIDLLanguage.Splicer.Splicer(SIDL.Loader.createClass('ANL.SplicerI.Splicer'))
    self.stub           = SIDLLanguage.CodePurpose.CodePurpose(SIDL.Loader.createClass('ANL.SIDLCompilerI.Stub'))
    self.IOR            = SIDLLanguage.CodePurpose.CodePurpose(SIDL.Loader.createClass('ANL.SIDLCompilerI.IOR'))
    self.skeleton       = SIDLLanguage.CodePurpose.CodePurpose(SIDL.Loader.createClass('ANL.SIDLCompilerI.Skeleton'))
    self.implementation = SIDLLanguage.CodePurpose.CodePurpose(SIDL.Loader.createClass('ANL.SIDLCompilerI.Implementation'))
    # DO-NOT-DELETE splicer.end(__init__)

  def getRoot(self, purpose):
    '''
    // Get the root directory for output
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # purpose string
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # string _return
    # DO-NOT-DELETE splicer.begin(getRoot)
    if self.roots.has_key(purpose):
      return self.roots[purpose]
    else:
      return self.defaultRoot
    # DO-NOT-DELETE splicer.end(getRoot)

  def setRoot(self, purpose, path):
    '''
    // Set the root directory for output
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # purpose string
    # path string
    # DO-NOT-DELETE splicer.begin(setRoot)
    self.roots[purpose] = path
    # DO-NOT-DELETE splicer.end(setRoot)

  def getOutputSource(self):
    '''
    // Get the flag determining whether source is output
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # bool _return
    # DO-NOT-DELETE splicer.begin(getOutputSource)
    return self.outputSource
    # DO-NOT-DELETE splicer.end(getOutputSource)

  def setOutputSource(self, outputSource):
    '''
    // Set the flag determining whether source is output
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # outputSource bool
    # DO-NOT-DELETE splicer.begin(setOutputSource)
    self.outputSource = outputSource
    # DO-NOT-DELETE splicer.end(setOutputSource)

  def getSplicer(self):
    '''
    // Retrieve the splicer used for preserving implementation blocks
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # SIDLLanguage.Splicer _return
    # DO-NOT-DELETE splicer.begin(getSplicer)
    # Put your code here...
    return self.splicer
    # DO-NOT-DELETE splicer.end(getSplicer)

  def setSplicer(self, splicer):
    '''
    // Set the splicer used for preserving implementation blocks
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # splicer SIDLLanguage.Splicer
    # DO-NOT-DELETE splicer.begin(setSplicer)
    # Put your code here...
    self.splicer = splicer
    # DO-NOT-DELETE splicer.end(setSplicer)

  def getCodeOutput(self):
    '''
    // Retrieve the Code object used for output
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # SIDLLanguage.Code _return
    # DO-NOT-DELETE splicer.begin(getCodeOutput)
    return self.codeOutput
    # DO-NOT-DELETE splicer.end(getCodeOutput)

  def setCodeOutput(self, output):
    '''
    // Set the Code object used for output
    //   Obviously here we need a persistent object which can output many source blocks
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # output SIDLLanguage.Code
    # DO-NOT-DELETE splicer.begin(setCodeOutput)
    self.codeOutput = output
    # DO-NOT-DELETE splicer.end(setCodeOutput)

  def getOutputFiles(self):
    '''
    // Retrieve all the created files
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # array _return
    # DO-NOT-DELETE splicer.begin(getOutputFiles)
    return self.outputFiles
    # DO-NOT-DELETE splicer.end(getOutputFiles)

  def clearOutputFiles(self):
    '''
    // Clear the list of created files
    '''
    # DO-NOT-DELETE splicer.begin(clearOutputFiles)
    self.outputFiles = []
    # DO-NOT-DELETE splicer.end(clearOutputFiles)

  def getRepository(self):
    '''
    // Retrieve auxilliary ASTs
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # array _return
    # DO-NOT-DELETE splicer.begin(getRepository)
    return []
    # DO-NOT-DELETE splicer.end(getRepository)

  def setRepository(self, repository):
    '''
    // Set auxilliary ASTs
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # repository array
    # DO-NOT-DELETE splicer.begin(setRepository)
    # Put your code here...
    pass
    # DO-NOT-DELETE splicer.end(setRepository)

  def visitAST(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.AST
    # DO-NOT-DELETE splicer.begin(visitAST)
    # Put your code here...
    pass
    # DO-NOT-DELETE splicer.end(visitAST)

  def visitSpecification(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Specification
    # DO-NOT-DELETE splicer.begin(visitSpecification)
    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitSpecification)

  def visitVersion(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Version
    # DO-NOT-DELETE splicer.begin(visitVersion)
    # Put your code here...
    pass
    # DO-NOT-DELETE splicer.end(visitVersion)

  def visitPackage(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Package
    # DO-NOT-DELETE splicer.begin(visitPackage)
    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitPackage)

  def visitInterface(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Interface
    # DO-NOT-DELETE splicer.begin(visitInterface)
    if self.isMarked(node): return
    self.markNode(node)

    try:
      self.outputHeader(node, self.stub)
      if self.outputSource:
        self.outputStubMethods(node)
    except Exception, e:
      import traceback
      self.raiseVisitorException(str(e), traceback.format_tb(sys.exc_info()[2]))
    # DO-NOT-DELETE splicer.end(visitInterface)

  def visitClass(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Class
    # DO-NOT-DELETE splicer.begin(visitClass)
    if self.isMarked(node): return
    self.markNode(node)

    try:
      self.outputHeader(node, self.stub)
      self.outputHeader(node, self.implementation)
      if self.outputSource:
        self.outputStubMethods(node)
        self.outputSkelMethods(node)
        self.outputImplMethods(node)
    except Exception, e:
      import traceback
      self.raiseVisitorException(str(e), traceback.format_tb(sys.exc_info()[2]))
    # DO-NOT-DELETE splicer.end(visitClass)

  def visitMethod(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Method
    # DO-NOT-DELETE splicer.begin(visitMethod)
    # Put your code here...
    pass
    # DO-NOT-DELETE splicer.end(visitMethod)

  def visitType(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Type
    # DO-NOT-DELETE splicer.begin(visitType)
    # Put your code here...
    pass
    # DO-NOT-DELETE splicer.end(visitType)

  def visitEnumeration(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Enumeration
    # DO-NOT-DELETE splicer.begin(visitEnumeration)
    if self.isMarked(node): return
    self.markNode(node)

    self.outputHeader(node, self.stub)
    # DO-NOT-DELETE splicer.end(visitEnumeration)

  def visitEnumerator(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Enumerator
    # DO-NOT-DELETE splicer.begin(visitEnumerator)
    # Put your code here...
    pass
    # DO-NOT-DELETE splicer.end(visitEnumerator)

  def visitArray(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Array
    # DO-NOT-DELETE splicer.begin(visitArray)
    # Put your code here...
    pass
    # DO-NOT-DELETE splicer.end(visitArray)

  def visitParameter(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Parameter
    # DO-NOT-DELETE splicer.begin(visitParameter)
    # Put your code here...
    pass
    # DO-NOT-DELETE splicer.end(visitParameter)

  def visitComment(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Comment
    # DO-NOT-DELETE splicer.begin(visitComment)
    # Put your code here...
    pass
    # DO-NOT-DELETE splicer.end(visitComment)

# DO-NOT-DELETE splicer.begin(_final)
  ##########################
  # Basic Visitor Operations
  def raiseVisitorException(self, message, trace = ''):
    e = SIDLLanguage.VisitorException.VisitorException()
    e.setMessage(message)
    if isinstance(trace, list):
      for line in trace: e.addToStackTrace(line.strip())
    elif trace:
      e.addToStackTrace(trace)
    e.addToTrace(__file__, sys._getframe(1).f_lineno, sys._getframe().f_code.co_name)
    raise SIDLLanguage.VisitorException.Exception, e

  def defaultVisit(self, ast):
    try:
      for child in ast.getChildren():
        child.accept(self.__IORself)
    except SIDLLanguage.ASTException.Exception, e:
      self.raiseVisitorException(e.getMessage(), e.getStackTrace().strip())
    return

  def isMarked(self, node):
    return node.hasAttribute(self.markName)

  def markNode(self, node):
    seen = SIDLLanguage.Attribute.Attribute(SIDL.Loader.createClass('ANL.SIDLCompilerI.Attribute'))
    seen.setName(self.markName)
    node.addAttribute(seen)
    return

  #########################
  # IOR specific methods
  def getIORName(self, node):
    return node.getFullIdentifier().replace('.', '_')

  ##################################
  # Basic Code Generation Operations
  def getCode(self, label = '', language = ''):
    code = SIDLLanguage.Code.Code(SIDL.Loader.createClass('ANL.SIDLCompilerI.Code'))
    if language:
      code.setLanguage(language)
    else:
      code.setLanguage(self.language)
    if label:
      code.setLabel(label)
    return code

  def getBaseException(self, exception):
    if exception.getFullIdentifier() == 'SIDL.BaseException':
      return exception
    for sclass in exception.getParents():
      base = self.getBaseException(sclass)
      if base: return base
    return None

  def getIORExceptions(self, method):
    exceptions = []
    for exception in method.getExceptions():
      if not exception.getFullIdentifier() == 'SIDL.NullIORException':
        exceptions.append(exception)
    return exceptions

  def hasExceptions(self, interface):
    for method in interface.getMethods():
      exceptions = self.getIORExceptions(method)
      if len(exceptions):
        return exceptions[0]
    return None

  #########################
  # Should go in Code class
  def composeCode(self, parent, node, label, fail = 1, forceBreak = 0):
    if node.hasCodeBlock(self.language, label):
      return self.composeCodeBlock(parent, node.getCodeBlock(self.language, label), forceBreak)
    elif fail:
      self.raiseVisitorException('Unable to find code block "'+label+'" in '+node.getFullIdentifier())
    return None

  def composeCodeBlock(self, parent, code, forceBreak = 0):
    self.composeSourceBlock(parent, code.getSource(), forceBreak)
    return code

  def composeSourceBlock(self, parent, source, forceBreak = 0):
    indent = ''
    for i in range(parent.getTabLevel()):
      indent += self.indentString
    if indent and (source.find('\n') >= 0 or forceBreak):
      # Indent start and all newlines
      source = indent+source.replace('\n', '\n'+indent)
      # Remove extra space from the end
      index  = 0
      while source[index-1] == ' ': index -= 1
      if index < 0:
        source = source[:index]
    if forceBreak and not source[-1] == '\n':
      source = source+'\n'
    parent.write(source)
    return

  ##################################
  # Path Operations
  def getDirectory(self, node, purpose, root = None, pathExt = '', makeDirectory = 0, fullExt = 0):
    if pathExt: pathExt = '_'+pathExt
    if fullExt:
      dext = pathExt
    else:
      dext = ''
    directory = node.getIdentifier()+pathExt
    parent    = node.getParent()
    while parent.isInstanceOf('SIDLLanguage.Package'):
      directory = os.path.join(parent.getIdentifier()+dext, directory)
      parent   = parent.getParent()
    if root:
      directory = os.path.join(root, directory)
    elif root is None:
      directory = os.path.join(self.getRoot(purpose.getName()), directory)
    if makeDirectory and not os.path.exists(directory):
      os.makedirs(directory)
    return directory

  def getFile(self, interface, node, purpose, root = None, extension = '', makeDirectory = 0):
    name    = node.getIdentifier()
    pathExt = purpose.getPathExtension()
    if pathExt and not node.isInstanceOf('SIDLLanguage.Method'):
      name = name+'_'+pathExt
    if extension:
      name = name+'.'+extension
    return os.path.join(self.getDirectory(interface, purpose, root, pathExt, makeDirectory), name)

  def getHeader(self, interface, purpose, root = None, makeDirectory = 0):
    if purpose.isInstanceOf('ANL.SIDLCompilerI.IOR'):
      extension = 'h'
    else:
      extension = 'hh'
    return self.getFile(interface, interface, purpose, root, extension, makeDirectory)

  def getSource(self, interface, node, purpose, root = None, makeDirectory = 0):
    if purpose.isInstanceOf('ANL.SIDLCompilerI.IOR'):
      extension = 'c'
    else:
      extension = 'cc'
    return self.getFile(interface, node, purpose, root, extension, makeDirectory)

  ##################################
  # Output Operations
  def outputSplicerBlock(self, f, node, purpose, code, name, defaultCode):
    if purpose.getUseSplicer():
      oldLevel = f.getTabLevel()
      f.setTabLevel(code.getTabLevel())
      lines = self.splicer.splice(node, self.language, name, defaultCode).split('\n')
      f.println(lines[0])
      for line in lines[1:-2]:
        if line == defaultCode:
          f.println(line)
        else:
          f.write(line+'\n')
      f.println(lines[-2])
      f.println(lines[-1])
      f.setTabLevel(oldLevel)
    return

  def outputInclude(self, f, node, purpose):
    f.write('#ifndef included_'+self.getIORName(node)+'_'+purpose.getName()+'\n')
    f.write('#include "'+self.getHeader(node, purpose, root = '')+'"\n')
    f.write('#endif\n')
    return

  def outputDependencyIncludes(self, f, sclass, purpose):
    f.write('//\n')
    f.write('// Includes for all method dependencies\n')
    f.write('//\n')
    for dep in sclass.getDependencies():
      self.outputInclude(f, dep, self.stub)
    if purpose.isInstanceOf('ANL.SIDLCompilerI.Implementation'):
      self.outputInclude(f, sclass, self.stub)
    f.write('\n')
    return

  def outputHeader(self, sclass, purpose):
    if not sclass.hasCodeBlock(self.language, purpose.getName()+' class definition: begin header'): return

    filename = self.getHeader(sclass, purpose, self.getRoot(purpose.getName()), 1)
    if purpose.getUseSplicer():
      self.splicer.parse(filename, self.language, sclass)
    print 'Creating '+filename
    self.outputFiles.append(filename)
    self.codeOutput.setLabel(filename)
    self.composeCode(self.codeOutput, sclass, purpose.getName()+' class definition: default includes', 0)
    self.outputInclude(self.codeOutput, sclass, self.IOR)
    self.codeOutput.println('')
    self.composeCode(self.codeOutput, sclass, purpose.getName()+' class definition: forward declarations', 0)
    code = self.composeCode(self.codeOutput, sclass, purpose.getName()+' class definition: begin header')
    self.outputDependencyIncludes(self.codeOutput, sclass, purpose)
    self.outputSplicerBlock(self.codeOutput, sclass, purpose, code, sclass.getFullIdentifier()+'._includes', '// Put additional includes here...')
    self.composeCode(self.codeOutput, sclass, purpose.getName()+' class definition: begin class', 0)
    code = self.composeCode(self.codeOutput, sclass, purpose.getName()+' class definition: data members', 0)
    self.outputSplicerBlock(self.codeOutput, sclass, purpose, code, sclass.getFullIdentifier()+'._implementation', '// Put additional implementation details here...')
    self.composeCode(self.codeOutput, sclass, purpose.getName()+' class definition: static constructor', 0)
    self.composeCode(self.codeOutput, sclass, purpose.getName()+' class definition: constructors', 0)
    self.composeCode(self.codeOutput, sclass, purpose.getName()+' class definition: default methods', 0)
    code = self.composeCode(self.codeOutput, sclass, purpose.getName()+' class definition: user methods', 0)
    # Exclude enumerations
    if sclass.isInstanceOf('SIDLLanguage.Interface'):
      self.codeOutput.setTabLevel(code.getTabLevel())
      for method in sclass.getMethods():
        self.composeCode(self.codeOutput, sclass, purpose.getName()+' method declaration '+method.getIdentifier(), 0)
      self.codeOutput.setTabLevel(0)
    code = self.composeCode(self.codeOutput, sclass, purpose.getName()+' class definition: end class', 0)
    self.outputSplicerBlock(self.codeOutput, sclass, purpose, code, sclass.getFullIdentifier()+'._misc', '// Put miscellaneous things here...')
    self.composeCode(self.codeOutput, sclass, purpose.getName()+' class definition: array specialization', 0)
    self.composeCode(self.codeOutput, sclass, purpose.getName()+' class definition: end header')
    self.codeOutput.close()
    return

  def outputStubMethods(self, interface):
    purpose = self.stub
    if not interface.hasCodeBlock(self.language, purpose.getName()+' method definition _get_ext'): return

    methods  = interface.getMethods()
    filename = self.getSource(interface, interface, purpose, makeDirectory = 1)
    print 'Creating '+filename
    self.outputFiles.append(filename)
    self.codeOutput.setLabel(filename)
    self.outputInclude(self.codeOutput, interface, purpose)
    self.codeOutput.println('')
    for method in methods:
      self.composeCode(self.codeOutput, interface, purpose.getName()+' method definition begin '+method.getIdentifier())
      self.composeCode(self.codeOutput, interface, purpose.getName()+' method definition end '+method.getIdentifier())
    self.composeCode(self.codeOutput, interface, purpose.getName()+' method definition _get_ext')
    self.codeOutput.close()
    return

  def outputSkelMethods(self, sclass):
    purpose = self.skeleton
    if not sclass.hasCodeBlock(self.language, purpose.getName()+' method definition _ctor'): return

    filename = self.getSource(sclass, sclass, purpose, makeDirectory = 1)
    print 'Creating '+filename
    self.outputFiles.append(filename)
    self.codeOutput.setLabel(filename)
    self.outputInclude(self.codeOutput, sclass, self.implementation)
    self.outputInclude(self.codeOutput, sclass, self.IOR)
    exception = self.hasExceptions(sclass)
    if exception:
      self.outputInclude(self.codeOutput, self.getBaseException(exception), self.stub)
    self.codeOutput.println('')
    self.composeCode(self.codeOutput, sclass, purpose.getName()+' begin linkage')
    self.codeOutput.increaseTabLevel()
    for method in sclass.getImplementedMethods():
      self.composeCode(self.codeOutput, sclass, purpose.getName()+' method definition begin '+method.getIdentifier())
      self.composeCode(self.codeOutput, sclass, purpose.getName()+' method definition end '+method.getIdentifier())
    self.composeCode(self.codeOutput, sclass, purpose.getName()+' method definition _ctor')
    self.composeCode(self.codeOutput, sclass, purpose.getName()+' method definition _dtor')
    self.composeCode(self.codeOutput, sclass, purpose.getName()+' method definition _set_epv')
    self.composeCode(self.codeOutput, sclass, purpose.getName()+' method definition _set_sepv', 0)
    self.codeOutput.decreaseTabLevel()
    self.composeCode(self.codeOutput, sclass, purpose.getName()+' end linkage')
    self.codeOutput.close()
    return

  def outputImplMethods(self, sclass):
    purpose = self.implementation
    if not sclass.hasCodeBlock(self.language, purpose.getName()+' method definition begin _ctor'): return

    for method in sclass.getMethods():
      if sclass.hasCodeBlock(self.language, purpose.getName()+' method definition begin '+method.getIdentifier()):
        filename    = self.getSource(sclass, method, purpose, makeDirectory = 1)
        splicerName = sclass.getFullIdentifier()+'.'+method.getIdentifier()
        if purpose.getUseSplicer():
          self.splicer.parse(filename, self.language, method)
        print 'Creating '+filename
        self.outputFiles.append(filename)
        self.codeOutput.setLabel(filename)
        self.outputInclude(self.codeOutput, sclass, purpose)
        self.codeOutput.println('')
        self.outputSplicerBlock(self.codeOutput, method, purpose, self.codeOutput, splicerName+'._includes', '// Put additional includes or other arbitrary code here...')
        code = self.composeCode(self.codeOutput, sclass, purpose.getName()+' method definition begin '+method.getIdentifier())
        self.outputSplicerBlock(self.codeOutput, method, purpose, code, splicerName, '// Insert implementation here...')
        self.composeCode(self.codeOutput, sclass, purpose.getName()+' method definition end '+method.getIdentifier())
        self.codeOutput.close()

    # TODO: We need these in Methods nodes
    filename= os.path.join(self.getDirectory(sclass, purpose, pathExt = purpose.getPathExtension(), makeDirectory = 1), '_ctor.cc')
    if purpose.getUseSplicer():
      self.splicer.parse(filename, self.language, sclass)
    print 'Creating '+filename
    self.outputFiles.append(filename)
    self.codeOutput.setLabel(filename)
    self.outputInclude(self.codeOutput, sclass, purpose)
    self.codeOutput.println('')
    self.outputSplicerBlock(self.codeOutput, sclass, purpose, self.codeOutput, sclass.getFullIdentifier()+'._ctor._includes', '// Put additional includes or other arbitrary code here...')
    code = self.composeCode(self.codeOutput, sclass, purpose.getName()+' method definition begin _ctor')
    self.outputSplicerBlock(self.codeOutput, sclass, purpose, code, sclass.getFullIdentifier()+'._ctor', '// Add construction details here...')
    self.composeCode(self.codeOutput, sclass, purpose.getName()+' method definition end _ctor')
    self.codeOutput.close()

    filename= os.path.join(self.getDirectory(sclass, purpose, pathExt = purpose.getPathExtension(), makeDirectory = 1), '_dtor.cc')
    if purpose.getUseSplicer():
      self.splicer.parse(filename, self.language, sclass)
    print 'Creating '+filename
    self.outputFiles.append(filename)
    self.codeOutput.setLabel(filename)
    self.outputInclude(self.codeOutput, sclass, purpose)
    self.codeOutput.println('')
    self.outputSplicerBlock(self.codeOutput, sclass, purpose, self.codeOutput, sclass.getFullIdentifier()+'._dtor._includes', '// Put additional includes or other arbitrary code here...')
    code = self.composeCode(self.codeOutput, sclass, purpose.getName()+' method definition begin _dtor')
    self.outputSplicerBlock(self.codeOutput, sclass, purpose, code, sclass.getFullIdentifier()+'._dtor', '// Add destruction details here...')
    self.composeCode(self.codeOutput, sclass, purpose.getName()+' method definition end _dtor')
    self.codeOutput.close()
    return
# DO-NOT-DELETE splicer.end(_final)

