# DO-NOT-DELETE splicer.begin(_initial)
import SIDL.Loader
import SIDLLanguage.CodePurpose
# DO-NOT-DELETE splicer.end(_initial)

import SIDL.NullIORException
import SIDL.BaseInterface
import SIDL.BaseException
import SIDLLanguage.AST
import SIDLLanguage.VisitorException
import SIDLLanguage.Specification
import SIDLLanguage.Version
import SIDLLanguage.Package
import SIDLLanguage.Interface
import SIDLLanguage.Class
import SIDLLanguage.Method
import SIDLLanguage.Type
import SIDLLanguage.Enumeration
import SIDLLanguage.Enumerator
import SIDLLanguage.Array
import SIDLLanguage.Parameter
import SIDLLanguage.Comment

# DO-NOT-DELETE splicer.begin(_before_type)
import SIDLLanguage.Code

import sys
# DO-NOT-DELETE splicer.end(_before_type)

class Generator:
  '''
  // This class generates all code for C++
  '''
  # All calls to SIDL methods should use __IORself

  def __init__(self, IORself):
    self.__IORself = IORself
    # DO-NOT-DELETE splicer.begin(__init__)
    self.language       = 'C++'
    self.indentString   = '  '
    self.markName       = 'cxxGeneratorMark'
    self.typeOnly       = [0]
    self.purposeActive  = {'stub': [0],
                           'IOR':  [0],
                           'skel': [0],
                           'impl': [0]}
    self.declActive     = 0
    self.defnActive     = 0
    self.stub           = SIDLLanguage.CodePurpose.CodePurpose(SIDL.Loader.createClass('ANL.SIDLCompilerI.Stub'))
    self.skeleton       = SIDLLanguage.CodePurpose.CodePurpose(SIDL.Loader.createClass('ANL.SIDLCompilerI.Skeleton'))
    self.implementation = SIDLLanguage.CodePurpose.CodePurpose(SIDL.Loader.createClass('ANL.SIDLCompilerI.Implementation'))
    # Map SIDL types to C++ types
    self.typeMap = {"bool":     "bool",
                    "char":     "char",
                    "dcomplex": "std::complex<double>",
                    "double":   "double",
                    "fcomplex": "std::complex<float>",
                    "float":    "float",
                    "int":      "int32_t",
                    "long":     "int64_t",
                    "opaque":   "void*",
                    "string":   "std::string",
                    "void":     "void"}
    # DO-NOT-DELETE splicer.end(__init__)

  def getPurposeActive(self, purpose):
    '''
    // Get the activity state of the given generation purpose
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # purpose string
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # bool _return
    # DO-NOT-DELETE splicer.begin(getPurposeActive)
    return self.purposeActive[purpose][-1]
    # DO-NOT-DELETE splicer.end(getPurposeActive)

  def setPurposeActive(self, purpose, isActive):
    '''
    // Set the activity state of the given generation purpose
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # purpose string
    # isActive bool
    # DO-NOT-DELETE splicer.begin(setPurposeActive)
    if self.purposeActive.has_key(purpose):
      self.purposeActive[purpose][-1] = isActive
    else:
      self.purposeActive[purpose] = [isActive]
    # DO-NOT-DELETE splicer.end(setPurposeActive)

  def getDeclarationActive(self):
    '''
    // Get the flag determining whether to generate declarations (headers)
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # bool _return
    # DO-NOT-DELETE splicer.begin(getDeclarationActive)
    return self.declActive
    # DO-NOT-DELETE splicer.end(getDeclarationActive)

  def setDeclarationActive(self, isActive):
    '''
    // Set the flag determining whether to generate declarations (headers)
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # isActive bool
    # DO-NOT-DELETE splicer.begin(setDeclarationActive)
    self.declActive = isActive
    # DO-NOT-DELETE splicer.end(setDeclarationActive)

  def getDefinitionActive(self):
    '''
    // Get the flag determining whether to generate definitions (source)
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # bool _return
    # DO-NOT-DELETE splicer.begin(getDefinitionActive)
    return self.defnActive
    # DO-NOT-DELETE splicer.end(getDefinitionActive)

  def setDefinitionActive(self, isActive):
    '''
    // Set the flag determining whether to generate definitions (source)
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # isActive bool
    # DO-NOT-DELETE splicer.begin(setDefinitionActive)
    self.defnActive = isActive
    # DO-NOT-DELETE splicer.end(setDefinitionActive)

  def getRepository(self):
    '''
    // Retrieve auxilliary ASTs
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # array _return
    # DO-NOT-DELETE splicer.begin(getRepository)
    return []
    # DO-NOT-DELETE splicer.end(getRepository)

  def setRepository(self, repository):
    '''
    // Set auxilliary ASTs
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # repository array
    # DO-NOT-DELETE splicer.begin(setRepository)
    # Put your code here...
    pass
    # DO-NOT-DELETE splicer.end(setRepository)

  def visitAST(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.AST
    # DO-NOT-DELETE splicer.begin(visitAST)
    # Put your code here...
    pass
    # DO-NOT-DELETE splicer.end(visitAST)

  def visitSpecification(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Specification
    # DO-NOT-DELETE splicer.begin(visitSpecification)
    if self.isMarked(node): return
    self.markNode(node)

    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitSpecification)

  def visitVersion(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Version
    # DO-NOT-DELETE splicer.begin(visitVersion)
    # Put your code here...
    pass
    # DO-NOT-DELETE splicer.end(visitVersion)

  def visitPackage(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Package
    # DO-NOT-DELETE splicer.begin(visitPackage)
    if self.isMarked(node): return
    self.markNode(node)

    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitPackage)

  def visitInterface(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Interface
    # DO-NOT-DELETE splicer.begin(visitInterface)
    try:
      cxxType = self.getCode('cxx type')
      cxxType.write(self.getTypeName(node.getFullIdentifier()))
      node.addCode(cxxType)
      self.marshallReturnType(node, node)
    except SIDLLanguage.CodeGeneratorException.Exception, e:
      self.raiseVisitorException('In '+node.getIdentifier()+': '+e.getMessage(), e.getStackTrace().strip())

    if self.typeOnly[-1]: return
    if self.isMarked(node): return
    self.markNode(node)

    self.defaultVisit(node)
    # All method code must be generated
    try:
      for interface in node.getParents():
        interface.accept(self.__IORself)
    except SIDLLanguage.ASTException.Exception, e:
      self.raiseVisitorException(e.getMessage(), e.getStackTrace().strip())

    try:
      purpose = self.stub
      if self.getPurposeActive(purpose.getName()):
        self.generateStubHeader(node)
        self.generateMethods(node, purpose)
    except SIDLLanguage.CodeGeneratorException.Exception, e:
      self.raiseVisitorException('In '+node.getIdentifier()+': '+e.getMessage(), e.getStackTrace().strip())
    except Exception, e:
      import traceback
      self.raiseVisitorException(str(e), traceback.format_tb(sys.exc_info()[2]))
    # DO-NOT-DELETE splicer.end(visitInterface)

  def visitClass(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Class
    # DO-NOT-DELETE splicer.begin(visitClass)
    try:
      cxxType = self.getCode('cxx type')
      cxxType.write(self.getTypeName(node.getFullIdentifier()))
      node.addCode(cxxType)
      self.marshallReturnType(node, node)
    except SIDLLanguage.CodeGeneratorException.Exception, e:
      self.raiseVisitorException('In '+node.getIdentifier()+': '+e.getMessage(), e.getStackTrace().strip())

    if self.typeOnly[-1]: return
    if self.isMarked(node): return
    self.markNode(node)

    self.defaultVisit(node)
    # All method code must be generated
    try:
      for interface in node.getInterfaces():
        interface.accept(self.__IORself)
      for interface in node.getParents():
        interface.accept(self.__IORself)
    except SIDLLanguage.ASTException.Exception, e:
      self.raiseVisitorException(e.getMessage(), e.getStackTrace().strip())

    try:
      purpose = self.stub
      if self.getPurposeActive(purpose.getName()):
        self.generateStubHeader(node)
        self.generateMethods(node, purpose)
      purpose = self.skeleton
      if self.getPurposeActive(purpose.getName()):
        self.generateSkelSource(node)
        self.generateMethods(node, purpose)
      purpose = self.implementation
      if self.getPurposeActive(purpose.getName()):
        self.generateImplHeader(node)
        self.generateMethods(node, purpose)
    except Exception, e:
      import traceback
      self.raiseVisitorException(str(e), traceback.format_tb(sys.exc_info()[2]))
    # DO-NOT-DELETE splicer.end(visitClass)

  def visitMethod(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Method
    # DO-NOT-DELETE splicer.begin(visitMethod)
    if self.isMarked(node): return
    self.markNode(node)

    try:
      self.typeOnly.append(1)
      node.getReturnType().accept(self.__IORself)
      self.typeOnly.pop()
    except SIDLLanguage.ASTException.Exception, e:
      self.raiseVisitorException(e.getMessage(), e.getStackTrace().strip())

    self.defaultVisit(node)
    try:
      self.generateMethodComponents(node, self.stub)
      self.generateMethodComponents(node, self.skeleton)
      self.generateMethodComponents(node, self.implementation)
    except SIDLLanguage.CodeGeneratorException.Exception, e:
      self.raiseVisitorException(e.getMessage(), e.getStackTrace().strip())
    except Exception, e:
      import traceback
      self.raiseVisitorException(str(e), traceback.format_tb(sys.exc_info()[2]))
    # DO-NOT-DELETE splicer.end(visitMethod)

  def visitType(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Type
    # DO-NOT-DELETE splicer.begin(visitType)
    if self.isMarked(node): return
    self.markNode(node)

    cxxType = self.getCode('cxx type')
    try:
      cxxType.write(self.typeMap[node.getIdentifier()])
    except KeyError:
      self.raiseVisitorException('No base type: '+str(node.getIdentifier()))
    node.addCode(cxxType)
    self.marshallReturnType(node, node)
    # DO-NOT-DELETE splicer.end(visitType)

  def visitEnumeration(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Enumeration
    # DO-NOT-DELETE splicer.begin(visitEnumeration)
    cxxType = self.getCode('cxx type')
    cxxType.write(self.getTypeName(node.getFullIdentifier()+'__enum'))
    node.addCode(cxxType)
    self.marshallReturnType(node, node)

    if self.typeOnly[-1]: return
    if self.isMarked(node): return
    self.markNode(node)

    purpose = self.stub
    if self.getPurposeActive(purpose.getName()):
      self.generateDefaultIncludes(node, purpose)
      self.generateHeaderBegin(node, purpose)
      self.generateStubEnumerationBegin(node, purpose)
      self.generateEnumerationEnd(node, purpose)
      self.generateHeaderEnd(node, purpose)
    # DO-NOT-DELETE splicer.end(visitEnumeration)

  def visitEnumerator(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Enumerator
    # DO-NOT-DELETE splicer.begin(visitEnumerator)
    # Put your code here...
    pass
    # DO-NOT-DELETE splicer.end(visitEnumerator)

  def visitArray(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Array
    # DO-NOT-DELETE splicer.begin(visitArray)
    if self.isMarked(node): return
    self.markNode(node)

    try:
      self.typeOnly.append(1)
      node.getType().accept(self.__IORself)
      self.typeOnly.pop()
    except SIDLLanguage.ASTException.Exception, e:
      self.raiseVisitorException(e.getMessage(), e.getStackTrace().strip())

    cxxType = self.getCode('cxx type')
    cxxType.write('::SIDL::array< ')
    self.composeCode(cxxType, node.getType(), 'cxx type')
    if node.getType().getCodeBlock(self.language, 'cxx type').getSource()[-1] == '>':
      cxxType.write(' ')
    cxxType.write(' >')
    node.addCode(cxxType)
    self.marshallReturnType(node, node)
    # DO-NOT-DELETE splicer.end(visitArray)

  def visitParameter(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Parameter
    # DO-NOT-DELETE splicer.begin(visitParameter)
    if self.isMarked(node): return
    self.markNode(node)

    try:
      self.typeOnly.append(1)
      node.getType().accept(self.__IORself)
      self.typeOnly.pop()
    except SIDLLanguage.ASTException.Exception, e:
      self.raiseVisitorException(e.getMessage(), e.getStackTrace().strip())

    name = node.getIdentifier()
    mode = node.getAccessMode()

    cxxParam = self.getCode('cxx parameter')
    cxxParam.write(self.getModeComment(mode))
    self.composeCode(cxxParam, node.getType(), 'cxx type')
    if self.isOut(mode):
      cxxParam.write('&')
    cxxParam.write(' '+name)
    node.addCode(cxxParam)

    self.marshallType(node, node.getType(), name, mode)
    # DO-NOT-DELETE splicer.end(visitParameter)

  def visitComment(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Comment
    # DO-NOT-DELETE splicer.begin(visitComment)
    # Put your code here...
    pass
    # DO-NOT-DELETE splicer.end(visitComment)

# DO-NOT-DELETE splicer.begin(_final)
  ##########################
  # Basic Visitor Operations
  def raiseVisitorException(self, message, trace = ''):
    e = SIDLLanguage.VisitorException.VisitorException()
    e.setMessage(message)
    if isinstance(trace, list):
      for line in trace: e.addToStackTrace(line.strip())
    elif trace:
      e.addToStackTrace(trace)
    e.addToTrace(__file__, sys._getframe(1).f_lineno, sys._getframe().f_code.co_name)
    raise SIDLLanguage.VisitorException.Exception, e

  def defaultVisit(self, ast):
    try:
      for child in ast.getChildren():
        child.accept(self.__IORself)
    except SIDLLanguage.ASTException.Exception, e:
      self.raiseVisitorException(e.getMessage(), e.getStackTrace().strip())
    return

  def isMarked(self, node):
    return node.hasAttribute(self.markName)

  def markNode(self, node):
    seen = SIDLLanguage.Attribute.Attribute(SIDL.Loader.createClass('ANL.SIDLCompilerI.Attribute'))
    seen.setName(self.markName)
    node.addAttribute(seen)
    return

  ##################################
  # Basic Code Generation Operations
  def getCode(self, label = '', language = ''):
    code = SIDLLanguage.Code.Code(SIDL.Loader.createClass('ANL.SIDLCompilerI.Code'))
    if language:
      code.setLanguage(language)
    else:
      code.setLanguage(self.language)
    if label:
      code.setLabel(label)
    return code

  def isIn(self, mode):
    return mode == SIDLLanguage.ParameterAccessMode.IN or mode == SIDLLanguage.ParameterAccessMode.INOUT

  def isOut(self, mode):
    return mode == SIDLLanguage.ParameterAccessMode.OUT or mode == SIDLLanguage.ParameterAccessMode.INOUT

  def isBase(self, interface):
    return interface.getFullIdentifier() in ['SIDL.BaseInterface', 'SIDL.BaseClass', 'SIDL.BaseException', 'SIDL.NullIORException', 'SIDL.Loader', 'SIDL.DLL']

  def hasStaticMethod(self, interface):
    for method in interface.getMethods():
      if method.getStatic():
        return 1
    return 0

  def getBaseException(self, exception):
    if exception.getFullIdentifier() == 'SIDL.BaseException':
      return exception
    for sclass in exception.getParents():
      base = self.getBaseException(sclass)
      if base: return base
    return None

  def getIORExceptions(self, method):
    exceptions = []
    for exception in method.getExceptions():
      if not exception.getFullIdentifier() == 'SIDL.NullIORException':
        exceptions.append(exception)
    return exceptions

  ###################
  # IOR naming scheme
  def getIORCastMethod(self):
    return 'f__cast_ior'

  def getIORStructName(self, interface, name):
    if not interface.isInstanceOf('SIDLLanguage.Class'):
      return name+'->d_object'
    else:
      return name

  #############################
  # C++ specific code structures
  def getTypeName(self, sidlType, ext = ''):
    typeName = sidlType.replace('.', ext+'::')
    if sidlType.find('.') >= 0:
      typeName = '::'+typeName
    return typeName+ext

  def getModeComment(self, mode):
    if mode == SIDLLanguage.ParameterAccessMode.IN:
      return '/*in*/ '
    elif mode == SIDLLanguage.ParameterAccessMode.INOUT:
      return '/*inout*/ '
    elif mode == SIDLLanguage.ParameterAccessMode.OUT:
      return '/*out*/ '
    else:
      self.raiseVisitorException('Invalid parameter access mode: '+str(mode))

  def constCast(self, type, obj):
    return 'const_cast< '+type+' >('+obj+')'

  def reinterpretCast(self, type, obj):
    return 'reinterpret_cast< '+type+' >('+obj+')'

  #########################
  # Should go in Code class
  def composeCode(self, parent, node, label, fail = 1, forceBreak = 0, language = None):
    if not language: language = self.language
    if node.hasCodeBlock(language, label):
      self.composeCodeBlock(parent, node.getCodeBlock(language, label), forceBreak)
    elif fail:
      self.raiseVisitorException('Unable to find code block "'+label+'" in '+node.getFullIdentifier())
    return

  def composeCodeBlock(self, parent, code, forceBreak = 0):
    indent = ''
    for i in range(parent.getTabLevel()):
      indent += self.indentString
    source = code.getSource()
    if indent and (source.find('\n') >= 0 or forceBreak):
      # Indent start and all newlines
      source = indent+source.replace('\n', '\n'+indent)
      # Remove extra space from the end
      index  = 0
      while source[index-1] == ' ': index -= 1
      if index < 0:
        source = source[:index]
    if forceBreak and not source[-1] == '\n':
      source = source+'\n'
    parent.write(source)
    return parent

  #############
  # Marshalling
  def needLocalVariable(self, type):
    if type.getBaseType():
      if type.getIdentifier() in ['bool', 'dcomplex', 'fcomplex', 'string']:
        useLocal = 1
      else:
        useLocal = 0
    elif type.isInstanceOf('SIDLLanguage.Enumeration'):
      useLocal = 0
    elif type.isInstanceOf('SIDLLanguage.Array'):
      useLocal = 1
    else:
      useLocal = 1
    return useLocal

  def hasIOR(self, type):
    if type.getBaseType() or type.isInstanceOf('SIDLLanguage.Enumeration'):
      return 0
    return 1

  def marshallReturnType(self, node, type):
    return self.marshallType(node, type, '_result', SIDLLanguage.ParameterAccessMode.OUT, isReturn = 1)

  def marshallType(self, node, type, name, mode, isReturn = 0):
    cxxPackArg   = self.getCode('cxx argument packing')
    cxxUnpackArg = self.getCode('cxx argument unpacking')
    iorPackArg   = self.getCode('ior argument packing')
    iorUnpackArg = self.getCode('ior argument unpacking')

    if type.getBaseType():
      self.marshallBaseType(type, name, mode, cxxPackArg, cxxUnpackArg, iorPackArg, iorUnpackArg, isReturn)
    elif type.isInstanceOf('SIDLLanguage.Array'):
      self.marshallArray(SIDLLanguage.Array.Array(type), name, mode, cxxPackArg, cxxUnpackArg, iorPackArg, iorUnpackArg, isReturn)
    elif type.isInstanceOf('SIDLLanguage.Enumeration'):
      pass
    else:
      self.marshallInterface(type, name, mode, cxxPackArg, cxxUnpackArg, iorPackArg, iorUnpackArg, isReturn)

    node.addCode(cxxPackArg)
    node.addCode(cxxUnpackArg)
    node.addCode(iorPackArg)
    node.addCode(iorUnpackArg)
    return

  def outputStringDup(self, code, stringType, source, dest, defineDest = 0):
    if defineDest:
      code.println(stringType+dest+' = NULL;')
    else:
      code.println(dest+' = NULL;')
    code.println('if ('+source+') {')
    code.increaseTabLevel()
    code.println(dest+' = ('+stringType+') malloc(strlen('+source+')+1);')
    code.println('strcpy('+dest+', '+source+');')
    code.decreaseTabLevel()
    code.println('}')
    return

  def marshallBaseType(self, type, name, mode, cxxPackArg, cxxUnpackArg, iorPackArg, iorUnpackArg, isReturn):
    typeName = type.getIdentifier()
    iorType  = type.getCodeBlock('C', 'ior type').getSource()
    cxxType  = self.typeMap[typeName]
    if self.isOut(mode) and not isReturn:
      iorName = '*'+name
    else:
      iorName = name
    localName = '_local_'+name

    if typeName == 'void': return
    if self.needLocalVariable(type):
      if not self.isIn(mode):
        cxxPackArg.println(iorType+' '+localName+';')
        iorPackArg.println(cxxType+' '+localName+';')
      if typeName == 'bool':
        if self.isIn(mode):
          cxxPackArg.println(iorType+' '+localName+' = ('+name+' != FALSE);')
          iorPackArg.println(cxxType+' '+localName+' = ('+iorName+' != FALSE);')
        if self.isOut(mode):
          cxxUnpackArg.println(name+' = ('+localName+' != FALSE);')
          iorUnpackArg.println(iorName+' = ('+localName+' ? TRUE : FALSE);')
      elif typeName == 'fcomplex' or typeName == 'dcomplex':
        if self.isIn(mode):
          cxxPackArg.println(iorType+' '+localName+' = {'+name+'.real(), '+name+'.imag()};')
          iorPackArg.println(cxxType+' '+localName+'(('+iorName+').real, ('+iorName+').imaginary);')
        if self.isOut(mode):
          cxxUnpackArg.println(name+' = '+self.reinterpretCast(cxxType+'&', localName)+';')
          iorUnpackArg.println('('+iorName+').real      = '+localName+'.real();')
          iorUnpackArg.println('('+iorName+').imaginary = '+localName+'.imag();')
      elif typeName == 'string':
        if self.isIn(mode):
          self.outputStringDup(cxxPackArg, iorType, name+'.c_str()', localName, defineDest = 1)
          iorPackArg.println(cxxType+' '+localName+'('+iorName+');')
        if self.isOut(mode):
          cxxUnpackArg.println(name+' = '+localName+';')
          if self.isIn(mode):
            iorUnpackArg.println('if (strlen('+iorName+') >= '+localName+'.length()) {')
            iorUnpackArg.increaseTabLevel()
            iorUnpackArg.println(localName+'.copy('+iorName+', std::string::npos);')
            iorUnpackArg.println('('+iorName+')['+localName+'.length()] = 0;')
            iorUnpackArg.decreaseTabLevel()
            iorUnpackArg.println('} else {')
            iorUnpackArg.increaseTabLevel()
            iorUnpackArg.println('if ('+iorName+') {::free((void *) '+iorName+');}')
            self.outputStringDup(iorUnpackArg, iorType, localName+'.c_str()', iorName)
            iorUnpackArg.decreaseTabLevel()
            iorUnpackArg.println('}')
          else:
            self.outputStringDup(iorUnpackArg, iorType, localName+'.c_str()', iorName)
        cxxUnpackArg.println('if ('+localName+') {::free((void *) '+localName+');}')
    return

  def marshallArray(self, array, name, mode, cxxPackArg, cxxUnpackArg, iorPackArg, iorUnpackArg, isReturn):
    cxxType = array.getCodeBlock(self.language, 'cxx type').getSource()
    iorType = array.getCodeBlock('C', 'ior type').getSource()
    if self.isOut(mode) and not isReturn:
      iorName = '*'+name
    else:
      iorName = name
    localName = '_local_'+name

    if self.isOut(mode):
      if self.isIn(mode):
        cxxPackArg.println(iorType+' '+localName+' = '+name+'._get_ior();')
        iorPackArg.println(cxxType+' '+localName+'(('+iorName+'));')
      else:
        cxxPackArg.println(iorType+' '+localName+';')
        iorPackArg.println(cxxType+' '+localName+';')
      cxxUnpackArg.println(name+'._set_ior('+localName+');')
      iorUnpackArg.println(iorName+' = '+localName+'._get_ior();')
    else:
      iorPackArg.println(cxxType+' '+localName+'('+iorName+');')
    return

  def marshallInterface(self, interface, name, mode, cxxPackArg, cxxUnpackArg, iorPackArg, iorUnpackArg, isReturn):
    cxxType = interface.getCodeBlock(self.language, 'cxx type').getSource()
    iorType = interface.getCodeBlock('C', 'ior type').getSource()
    if self.isOut(mode) and not isReturn:
      iorName = '*'+name
    else:
      iorName = name
    localName = '_local_'+name

    if self.isOut(mode):
      if self.isIn(mode):
        cxxPackArg.println(name+'.addReference();')
        cxxPackArg.println(iorType+' '+localName+' = '+name+'._get_ior();')
        iorPackArg.println(cxxType+' '+localName+'(('+iorName+'));')
      else:
        cxxPackArg.println(iorType+' '+localName+';')
        iorPackArg.println(cxxType+' '+localName+';')
      cxxUnpackArg.println(name+' = '+cxxType+'('+localName+');')
      cxxUnpackArg.println('if ('+name+'._not_nil()) {')
      cxxUnpackArg.increaseTabLevel()
      cxxUnpackArg.println(name+'.deleteReference();')
      cxxUnpackArg.decreaseTabLevel()
      cxxUnpackArg.println('}')
      iorUnpackArg.println('if ('+localName+'._not_nil()) {')
      iorUnpackArg.increaseTabLevel()
      iorUnpackArg.println(localName+'.addReference();')
      iorUnpackArg.decreaseTabLevel()
      iorUnpackArg.println('}')
      if self.isIn(mode):
        iorUnpackArg.println('(*(('+iorName+')->d_epv->f_deleteReference))('+iorName+');')
      iorUnpackArg.println(iorName+' = '+localName+'._get_ior();')
    else:
      iorPackArg.println(cxxType+' '+localName+'('+iorName+');')
    return

  ###################
  # Header generation
  def generateDefaultIncludes(self, sclass, purpose):
    code = self.getCode(purpose.getName()+' class definition: default includes')

    fullName = sclass.getFullIdentifier()

    # TODO: Get rid of this crap
    if purpose.isInstanceOf('ANL.SIDLCompilerI.Stub'):
      code.println('// Get rid of this crap')
      code.write('#include "sidl_config.h"\n')
      code.println('')

    code.write('#ifndef included_SIDL_cxx_hh\n')
    code.write('#include "SIDL_cxx.hh"\n')
    code.write('#endif\n')

    code.println('')
    sclass.addCode(code)
    return

  def generateForwardDeclarations(self, sclass, purpose):
    defn = self.getCode(purpose.getName()+' class definition: forward declarations')

    parent  = sclass.getParent()
    parents = []
    while parent.isInstanceOf('SIDLLanguage.Package'):
      parents.append(parent)
      parent = parent.getParent()

    fullName  = sclass.getFullIdentifier()
    typeName  = self.getTypeName(fullName)
    className = sclass.getIdentifier()

    defn.println('// Forward declaration')
    parents.reverse()
    for parent in parents:
      defn.println('namespace '+parent.getIdentifier()+' {')
      defn.increaseTabLevel()
    defn.println('// Symbol "'+fullName+'"')
    defn.println('class '+className+';')
    parents.reverse()
    for parent in parents:
      defn.decreaseTabLevel()
      defn.println('} // end namespace '+parent.getIdentifier())
    defn.println('')

    defn.println('// Array specialization')
    defn.println('namespace SIDL {')
    defn.increaseTabLevel()
    defn.println('template<>')
    defn.println('class array< '+typeName+' >;')
    defn.decreaseTabLevel()
    defn.println('} // end namespace SIDL')
    defn.println('')

    sclass.addCode(defn)
    return

  def generateHeaderBegin(self, sclass, purpose):
    defn = self.getCode(purpose.getName()+' class definition: begin header')

    fullName = sclass.getFullIdentifier()
    guard    = 'included_'+fullName.replace('.', '_')+'_'+purpose.getName()

    defn.write('#ifndef '+guard+'\n')
    defn.write('#define '+guard+'\n')
    defn.println('')

    sclass.addCode(defn)
    return

  def generateStubClassBegin(self, interface, purpose):
    fullName  = interface.getFullIdentifier()
    className = interface.getIdentifier()
    iorStruct = interface.getCodeBlock('C', 'ior type struct').getSource()
    vtable    = interface.getCodeBlock('C', 'ior function table type struct').getSource()

    parent  = interface.getParent()
    parents = []
    while parent.isInstanceOf('SIDLLanguage.Package'):
      parents.append(parent)
      parent = parent.getParent()

    code = self.getCode(purpose.getName()+' class definition: begin class')
    parents.reverse()
    for parent in parents:
      code.println('namespace '+parent.getIdentifier()+' {')
      code.increaseTabLevel()

    code.println('// Symbol "'+fullName+'"')
    code.println('class '+className+' : public ::SIDL::StubBase {')
    code.println('')

    code.println('// Type definitions ')
    code.println('public:')
    code.increaseTabLevel()
    code.println('typedef '+iorStruct+' ior_t;')
    code.println('typedef '+vtable+' ext_t;')
    if interface.isInstanceOf('SIDLLanguage.Class'):
      svtable = interface.getCodeBlock('C', 'ior static function table type struct').getSource()
      code.println('typedef '+svtable+' sepv_t;')
    code.println('')
    code.decreaseTabLevel()

    interface.addCode(code)
    return

  def generateImplClassBegin(self, sclass, purpose):
    defn = self.getCode(purpose.getName()+' class definition: begin class')

    fullName  = sclass.getFullIdentifier()
    className = sclass.getIdentifier()+'_'+purpose.getName()

    parent  = sclass.getParent()
    parents = []
    while parent.isInstanceOf('SIDLLanguage.Package'):
      parents.append(parent)
      parent = parent.getParent()

    parents.reverse()
    for parent in parents:
      defn.println('namespace '+parent.getIdentifier()+' {')
      defn.increaseTabLevel()

    defn.println('// Symbol "'+fullName+'"')
    defn.println('class '+className+' {')

    sclass.addCode(defn)
    return

  def generateStubEnumerationBegin(self, enum, purpose):
    cxxType = enum.getCodeBlock(self.language, 'cxx type').getSource()
    iorType = enum.getCodeBlock('C', 'ior type').getSource()
    index   = cxxType.rfind('::')+2

    parent  = enum.getParent()
    parents = []
    while parent.isInstanceOf('SIDLLanguage.Package'):
      parents.append(parent)
      parent = parent.getParent()

    code = self.getCode(purpose.getName()+' class definition: begin class')
    parents.reverse()
    for parent in parents:
      code.println('namespace '+parent.getIdentifier()+' {')
      code.increaseTabLevel()
    code.println('// Symbol "'+enum.getFullIdentifier()+'"')
    code.println('typedef '+iorType+' '+cxxType[index:]+';')
    enum.addCode(code)
    return

  def generateStubDataMembers(self, sclass, purpose):
    defn = self.getCode(purpose.getName()+' class definition: data members')

    parent  = sclass.getParent()
    parents = []
    while parent.isInstanceOf('SIDLLanguage.Package'):
      parents.append(parent)
      parent = parent.getParent()

    for i in range(len(parents)):
      defn.increaseTabLevel()

    defn.println('private:')
    defn.increaseTabLevel()
    defn.println('// Pointer to IOR')
    defn.println('ior_t *d_self;')
    defn.println('')
    defn.println('// Weak references which do not add/deleteRef() (used by Impl)')
    defn.println('bool d_weak_reference;')
    defn.println('')
    defn.println('// Pointer to function table (DLL loadable symbols) which is shared among instances')
    defn.println('static const ext_t *s_ext;')
    defn.println('')
    defn.decreaseTabLevel()

    sclass.addCode(defn)
    return

  def generateImplDataMembers(self, sclass, purpose):
    defn = self.getCode(purpose.getName()+' class definition: data members')

    fullName = sclass.getFullIdentifier()
    stubName = sclass.getIdentifier()

    parent  = sclass.getParent()
    parents = []
    while parent.isInstanceOf('SIDLLanguage.Package'):
      parents.append(parent)
      parent = parent.getParent()

    for i in range(len(parents)):
      defn.increaseTabLevel()

    defn.println('private:')
    defn.increaseTabLevel()
    defn.println('// Pointer back to IOR')
    defn.println('// Use this to dispatch back through IOR vtable')
    defn.println(stubName+' self;')
    defn.println('')

    sclass.addCode(defn)
    return

  def generateStaticConstructor(self, sclass, purpose):
    if sclass.getAbstract(): return
    defn = self.getCode(purpose.getName()+' class definition: static constructor')

    fullName = sclass.getFullIdentifier()
    typeName = self.getTypeName(fullName)

    parent  = sclass.getParent()
    parents = []
    while parent.isInstanceOf('SIDLLanguage.Package'):
      parents.append(parent)
      parent = parent.getParent()

    for i in range(len(parents)):
      defn.increaseTabLevel()

    defn.println('// Static constructor')
    defn.println('public:')
    defn.increaseTabLevel()
    defn.println('static '+typeName+' _create() {')
    defn.increaseTabLevel()
    defn.println(typeName+' self((*_get_ext()->createObject)());')
    defn.println('// The reference count is now 2')
    defn.println('//   1 from createObject()')
    defn.println('//   1 from IOR to C++ conversion')
    defn.println('// Decrement this count back down to one')
    defn.println('self.deleteReference();')
    defn.println('return self;')
    defn.decreaseTabLevel()
    defn.println('}')
    defn.println('')
    defn.decreaseTabLevel()

    sclass.addCode(defn)
    return

  def generateStubConstructors(self, sclass, purpose):
    defn = self.getCode(purpose.getName()+' class definition: constructors')

    fullName      = sclass.getFullIdentifier()
    className     = sclass.getIdentifier()
    objectTypedef = className+'::ior_t'

    parent  = sclass.getParent()
    parents = []
    while parent.isInstanceOf('SIDLLanguage.Package'):
      parents.append(parent)
      parent = parent.getParent()

    for i in range(len(parents)):
      defn.increaseTabLevel()

    defn.println('// Constructors/Destructors ')
    defn.println('public:')
    defn.increaseTabLevel()

    defn.println('// Default constructor')
    defn.println(className+'() : d_self(0), d_weak_reference(false) {}')
    defn.println('')

    defn.println('// Default destructor')
    defn.println('virtual ~'+className+'() {')
    defn.increaseTabLevel()
    defn.println('if (d_self != 0) {')
    defn.increaseTabLevel()
    defn.println('deleteReference();')
    defn.decreaseTabLevel()
    defn.println('}')
    defn.decreaseTabLevel()
    defn.println('}')
    defn.println('')

    defn.println('// Copy constructor')
    defn.println(className+'(const '+className+'& original) {')
    defn.increaseTabLevel()
    defn.println('d_self = '+self.constCast('ior_t *', 'original.d_self')+';')
    defn.println('d_weak_reference = original.d_weak_reference;')
    defn.println('if (d_self != 0) {')
    defn.increaseTabLevel()
    defn.println('addReference();')
    defn.decreaseTabLevel()
    defn.println('}')
    defn.decreaseTabLevel()
    defn.println('}')
    defn.println('')

    defn.println('// Assignment operator')
    defn.println(className+'& operator=(const '+className+'& rhs) {')
    defn.increaseTabLevel()
    defn.println('if (d_self != rhs.d_self) {')
    defn.increaseTabLevel()
    defn.println('if (d_self != 0) {')
    defn.increaseTabLevel()
    defn.println('deleteReference();')
    defn.decreaseTabLevel()
    defn.println('}')
    defn.println('d_self = '+self.constCast('ior_t *', 'rhs.d_self')+';')
    defn.println('d_weak_reference = rhs.d_weak_reference;')
    defn.println('if (d_self != 0) {')
    defn.increaseTabLevel()
    defn.println('addReference();')
    defn.decreaseTabLevel()
    defn.println('}')
    defn.decreaseTabLevel()
    defn.println('}')
    defn.println('return *this;')
    defn.decreaseTabLevel()
    defn.println('}')
    defn.println('')
    defn.decreaseTabLevel()

    defn.println('// Casting Operators ')
    defn.println('public:')
    defn.increaseTabLevel()
    defn.println('// Conversion from IOR to C++ class')
    defn.println(className+'('+objectTypedef+' *ior) : d_self(ior), d_weak_reference(false) {')
    defn.increaseTabLevel()
    defn.println('if (d_self != 0) {')
    defn.increaseTabLevel()
    defn.println('addReference();')
    defn.decreaseTabLevel()
    defn.println('}')
    defn.decreaseTabLevel()
    defn.println('}')
    defn.println('')

    defn.println('// Alternate constructor which does not call addReference()')
    defn.println('//   also sets d_weak_reference = isWeak')
    defn.println('//   used by Impl (fixes bug #275)')
    defn.println(className+'('+objectTypedef+' *ior, bool isWeak) : d_self(ior), d_weak_reference(isWeak) {}')
    defn.println('')

    defn.println('// Conversion from a StubBase')
    defn.println(className+'(const ::SIDL::StubBase& base) {')
    defn.increaseTabLevel()
    defn.println('d_self = '+self.reinterpretCast('ior_t *', 'base._cast("'+fullName+'")')+';')
    defn.println('d_weak_reference = false;')
    defn.println('if (d_self != 0) {')
    defn.increaseTabLevel()
    defn.println('addReference();')
    defn.decreaseTabLevel()
    defn.println('}')
    defn.decreaseTabLevel()
    defn.println('}')
    defn.println('')

    defn.decreaseTabLevel()
    sclass.addCode(defn)
    return

  def generateImplConstructors(self, sclass, purpose):
    defn = self.getCode(purpose.getName()+' class definition: constructors')

    fullName  = sclass.getFullIdentifier()
    typeName  = self.getTypeName(fullName)
    className = sclass.getIdentifier()+'_'+purpose.getName()
    iorType   = sclass.getCodeBlock('C', 'ior type').getSource()

    parent  = sclass.getParent()
    parents = []
    while parent.isInstanceOf('SIDLLanguage.Package'):
      parents.append(parent)
      parent = parent.getParent()

    for i in range(len(parents)):
      defn.increaseTabLevel()

    defn.println('// Constructors/Destructors ')
    defn.println('private:')
    defn.increaseTabLevel()

    defn.println('// private default constructor (required)')
    defn.println(className+'() {}')
    defn.println('')
    defn.decreaseTabLevel()

    defn.println('public:')
    defn.increaseTabLevel()

    defn.println('// SIDL constructor (required)')
    defn.println('// Note: alternate Skel constructor does not call addref()')
    defn.println('// (fixes bug #275)')
    defn.println(className+'('+iorType+'s) : self(s, true) {_ctor();}')
    defn.println('')

    defn.println('// virtual destructor (required)')
    defn.println('virtual ~'+className+'() {_dtor();}')
    defn.println('')
    defn.decreaseTabLevel()

    sclass.addCode(defn)
    return

  def generateDefaultMethods(self, sclass, purpose):
    defn = self.getCode(purpose.getName()+' class definition: default methods')

    parent  = sclass.getParent()
    parents = []
    while parent.isInstanceOf('SIDLLanguage.Package'):
      parents.append(parent)
      parent = parent.getParent()

    for i in range(len(parents)):
      defn.increaseTabLevel()

    defn.println('// Binding specific methods ')
    defn.println('public:')
    defn.increaseTabLevel()

    defn.println('ior_t *_get_ior() {return d_self;}')
    defn.println('')

    defn.println('const ior_t *_get_ior() const {return d_self;}')
    defn.println('')

    defn.println('bool _is_nil() const {return(d_self == 0);}')
    defn.println('')

    defn.println('bool _not_nil() const {return(d_self != 0);}')
    defn.println('')

    defn.println('bool operator!() const {return(d_self == 0);}')
    defn.println('')

    if self.isBase(sclass):
      defn.println('static const ext_t *_get_ext() throw ();')
    else:
      defn.println('static const ext_t *_get_ext() throw (::SIDL::NullIORException);')
    defn.println('')

    if self.hasStaticMethod(sclass):
      if self.isBase(sclass):
        defn.println('static const sepv_t *_get_sepv() throw () {')
      else:
        defn.println('static const sepv_t *_get_sepv() throw (::SIDL::NullIORException) {')
      defn.increaseTabLevel()
      defn.println('return (*(_get_ext()->getStaticEPV))();')
      defn.decreaseTabLevel()
      defn.println('}')
      defn.println('')

    defn.decreaseTabLevel()
    defn.println('public:')
    defn.increaseTabLevel()
    defn.println('virtual void *_cast(const char *type) const {')
    defn.increaseTabLevel()
    defn.println('void *ptr = 0;')
    defn.println('')
    defn.println('if (d_self != 0) {')
    defn.increaseTabLevel()
    defn.println('ptr = '+self.reinterpretCast('void *', '(*d_self->d_epv->'+self.getIORCastMethod()+')('+self.getIORStructName(sclass, 'd_self')+', type)')+';')
    defn.decreaseTabLevel()
    defn.println('}')
    defn.println('return ptr;')
    defn.decreaseTabLevel()
    defn.println('}')
    defn.println('')

    defn.decreaseTabLevel()
    sclass.addCode(defn)
    return

  def generateUserMethods(self, sclass, purpose):
    defn = self.getCode(purpose.getName()+' class definition: user methods')

    parent  = sclass.getParent()
    parents = []
    while parent.isInstanceOf('SIDLLanguage.Package'):
      parents.append(parent)
      parent = parent.getParent()

    for i in range(len(parents)):
      defn.increaseTabLevel()

    defn.println('// User defined methods ')
    defn.println('public:')
    defn.increaseTabLevel()

    sclass.addCode(defn)
    return

  def generateClassEnd(self, sclass, purpose):
    defn = self.getCode(purpose.getName()+' class definition: end class')

    fullName  = sclass.getFullIdentifier()
    className = sclass.getIdentifier()
    if purpose.getPathExtension():
      className += '_'+purpose.getPathExtension()

    parent  = sclass.getParent()
    parents = []
    while parent.isInstanceOf('SIDLLanguage.Package'):
      parents.append(parent)
      parent = parent.getParent()

    for i in range(len(parents)):
      defn.increaseTabLevel()

    defn.println('}; // end class '+className);

    for parent in parents:
      defn.decreaseTabLevel()
      defn.println('} // end namespace '+parent.getIdentifier())
    defn.println('')

    sclass.addCode(defn)
    return

  def generateEnumerationEnd(self, enum, purpose):
    defn = self.getCode(purpose.getName()+' class definition: end class')

    parent  = enum.getParent()
    parents = []
    while parent.isInstanceOf('SIDLLanguage.Package'):
      parents.append(parent)
      parent = parent.getParent()

    for i in range(len(parents)):
      defn.increaseTabLevel()

    for parent in parents:
      defn.decreaseTabLevel()
      defn.println('} // end namespace '+parent.getIdentifier())
    defn.println('')

    enum.addCode(defn)
    return

  def generateArraySpecialization(self, sclass, purpose):
    defn = self.getCode(purpose.getName()+' class definition: array specialization')

    cxxType       = self.getTypeName(sclass.getFullIdentifier())
    iorType       = sclass.getCodeBlock('C', 'ior type').getSource()
    arrayType     = sclass.getCodeBlock('C', 'ior array struct').getSource()
    arrayTemplate = 'array_mixin<'+arrayType+', '+iorType+', '+cxxType+'>'

    defn.println('// Array specialization')
    defn.println('namespace SIDL {')
    defn.increaseTabLevel()
    defn.println('template <>')
    defn.println('class array< '+cxxType+' > : public '+arrayTemplate+' {')
    defn.println('public:')
    defn.increaseTabLevel()
    defn.println('// Default constructor')
    defn.println('array() : '+arrayTemplate+'() {}')
    defn.println('')
    defn.println('// Constructor/Casting operator')
    defn.println('array('+arrayType+' *src) : '+arrayTemplate+'(src) {}')
    defn.decreaseTabLevel()
    defn.println('};')
    defn.decreaseTabLevel()
    defn.println('}')
    defn.println('')

    sclass.addCode(defn)
    return

  def generateHeaderEnd(self, sclass, purpose):
    code = self.getCode(purpose.getName()+' class definition: end header')

    fullName = sclass.getFullIdentifier()
    guard    = 'included_'+fullName.replace('.', '_')+'_'+purpose.getName()

    code.println('#endif /*'+guard+'*/')

    sclass.addCode(code)
    return

  def generateStubHeader(self, sclass):
    if not self.declActive: return
    purpose = self.stub
    self.generateDefaultIncludes(sclass, purpose)
    self.generateForwardDeclarations(sclass, purpose)
    self.generateHeaderBegin(sclass, purpose)
    self.generateStubClassBegin(sclass, purpose)
    self.generateStubDataMembers(sclass, purpose)
    if sclass.isInstanceOf('SIDLLanguage.Class'):
      self.generateStaticConstructor(sclass, purpose)
    self.generateStubConstructors(sclass, purpose)
    self.generateDefaultMethods(sclass, purpose)
    self.generateUserMethods(sclass, purpose)
    self.generateClassEnd(sclass, purpose)
    self.generateArraySpecialization(sclass, purpose)
    self.generateHeaderEnd(sclass, purpose)
    return

  def generateImplHeader(self, sclass):
    if not self.declActive: return
    purpose = self.implementation
    self.generateDefaultIncludes(sclass, purpose)
    self.generateHeaderBegin(sclass, purpose)
    self.generateImplClassBegin(sclass, purpose)
    self.generateImplDataMembers(sclass, purpose)
    self.generateImplConstructors(sclass, purpose)
    self.generateUserMethods(sclass, purpose)
    self.generateClassEnd(sclass, purpose)
    self.generateHeaderEnd(sclass, purpose)
    return

  ###################
  # Source generation
  def generateLinkageBegin(self, sclass, purpose):
    code = self.getCode(purpose.getName()+' begin linkage')
    code.println('extern "C" {')
    code.println('')
    sclass.addCode(code)
    return

  def generateLinkageEnd(self, sclass, purpose):
    code = self.getCode(purpose.getName()+' end linkage')
    code.println('} // end extern "C"')
    code.println('')
    sclass.addCode(code)
    return

  def generateSkelSource(self, sclass):
    if not self.defnActive: return
    purpose = self.skeleton
    self.generateLinkageBegin(sclass, purpose)
    self.generateLinkageEnd(sclass, purpose)
    return

  ###################
  # Method Generation
  def createConstructorMethod(self, sclass):
    method = SIDLLanguage.Method.Method(SIDL.Loader.createClass('ANL.SIDLCompilerI.Method'))
    void   = SIDLLanguage.Type.Type(SIDL.Loader.createClass('ANL.SIDLCompilerI.Type'))
    void.setBaseType(1)
    void.setIdentifier('void')
    method.setReturnType(void)
    method.setIdentifier('_ctor')
    method.setAbstract(0)
    method.setStatic(0)
    method.setParent(sclass)
    return method

  def createDestructorMethod(self, sclass):
    method = SIDLLanguage.Method.Method(SIDL.Loader.createClass('ANL.SIDLCompilerI.Method'))
    void   = SIDLLanguage.Type.Type(SIDL.Loader.createClass('ANL.SIDLCompilerI.Type'))
    void.setBaseType(1)
    void.setIdentifier('void')
    method.setReturnType(void)
    method.setIdentifier('_dtor')
    method.setAbstract(0)
    method.setStatic(0)
    method.setParent(sclass)
    return method

  def generateMethodReturnType(self, method, purpose):
    decl = self.getCode(purpose.getName()+' declaration return type')
    decl.indent()
    if method.getStatic():
      decl.write('static ')
    if purpose.getIORDispatch():
      self.composeCode(decl, method.getReturnType(), 'cxx type', forceBreak = 1)
    else:
      self.composeCode(decl, method.getReturnType(), 'ior type', forceBreak = 1, language = 'C')
    method.addCode(decl)

    if not purpose.getEmbedded():
      defn = self.getCode(purpose.getName()+' definition return type')
      defn.indent()
      if purpose.getIORDispatch():
        self.composeCode(defn, method.getReturnType(), 'cxx type', forceBreak = 1)
      else:
        self.composeCode(defn, method.getReturnType(), 'ior type', forceBreak = 1, language = 'C')
      method.addCode(defn)
    return

  def generateMethodBegin(self, method, purpose):
    if purpose.getEmbedded():
      code = self.getCode(purpose.getName()+' declaration begin')
    else:
      code = self.getCode(purpose.getName()+' definition begin')
    code.println('{')
    code.increaseTabLevel()
    method.addCode(code)
    return

  def generateMethodIORCheck(self, method, purpose):
    if not purpose.getGenerateMethods() or not purpose.getCheckIOR() or method.getStatic(): return
    if purpose.getEmbedded():
      code = self.getCode(purpose.getName()+' declaration IOR check')
    else:
      code = self.getCode(purpose.getName()+' definition IOR check')

    code.println('if (d_self == 0) {')
    code.increaseTabLevel()
    code.println('::SIDL::NullIORException e = ::SIDL::NullIORException::_create();')
    code.println('')
    code.println('e.setMessage("Null IOR pointer in '+self.getTypeName(method.getFullIdentifier())+'()");')
    code.println('throw e;')
    code.decreaseTabLevel()
    code.println('}')
    method.addCode(code)
    return

  def generateMethodWeakReferenceCheck(self, method, purpose):
    if not purpose.getGenerateMethods() or (not method.getIdentifier() == 'addReference' and not method.getIdentifier() == 'deleteReference'): return

    # TODO: This sucks
    if not purpose.isInstanceOf('ANL.SIDLCompilerI.Stub'): return
    if purpose.getEmbedded():
      code = self.getCode(purpose.getName()+' declaration weak reference check')
    else:
      code = self.getCode(purpose.getName()+' definition weak reference check')
    code.println('if (d_weak_reference) return;')
    method.addCode(code)
    return

  def generateMethodReturnSetup(self, method, purpose):
    if not purpose.getGenerateMethods(): return

    if purpose.getEmbedded():
      code = self.getCode(purpose.getName()+' declaration return setup')
    else:
      code = self.getCode(purpose.getName()+' definition return setup')
    code.println('// Return value setup')
    type = method.getReturnType()
    if purpose.getIORDispatch():
      if not type.getIdentifier() == 'void':
        code.println(type.getCodeBlock(self.language, 'cxx type').getSource()+' _result;')
      self.composeCode(code, method.getReturnType(), 'cxx argument packing')
    else:
      if not type.getIdentifier() == 'void':
        code.println(type.getCodeBlock('C', 'ior type').getSource()+' _result;')
      self.composeCode(code, method.getReturnType(), 'ior argument packing')
    method.addCode(code)
    return

  def generateMethodArgumentPacking(self, method, purpose):
    if not purpose.getGenerateMethods(): return

    if purpose.getEmbedded():
      code = self.getCode(purpose.getName()+' declaration argument packing')
    else:
      code = self.getCode(purpose.getName()+' definition argument packing')
    if purpose.getIORDispatch():
      code.println('// Pack arguments for dispatch to IOR')
      for parameter in method.getChildren():
        self.composeCode(code, parameter, 'cxx argument packing')
    else:
      code.println('// Pack arguments for dispatch to implementation')
      for parameter in method.getChildren():
        self.composeCode(code, parameter, 'ior argument packing')
    method.addCode(code)
    return

  def generateMethodExceptionSetup(self, method, purpose):
    if not purpose.getGenerateMethods(): return

    if purpose.getEmbedded():
      code = self.getCode(purpose.getName()+' declaration exception setup')
    else:
      code = self.getCode(purpose.getName()+' definition exception setup')
    code.println('// Exception handling setup')
    if len(self.getIORExceptions(method)):
      if purpose.getEmulateExceptions():
        code.println('*_exception = 0;')
      else:
        code.println('SIDL_BaseException__object *_exception = 0;')
    method.addCode(code)
    return

  def generateMethodIORDispatchBegin(self, method, purpose):
    if not purpose.getGenerateMethods(): return

    if purpose.getEmbedded():
      code = self.getCode(purpose.getName()+' declaration IOR dispatch begin')
    else:
      code = self.getCode(purpose.getName()+' definition IOR dispatch begin')
    code.println('// Dispatch to IOR')
    code.indent()
    if not method.getReturnType().getIdentifier() == 'void':
      if self.needLocalVariable(method.getReturnType()):
        code.write('_local__result = ')
      else:
        code.write('_result = ')
    if method.getStatic():
      code.write('(_get_sepv()->f_'+method.getIdentifier()+')(')
    else:
      code.write('(*(d_self->d_epv->f_'+method.getIdentifier()+'))(')
    method.addCode(code)
    return

  def generateMethodIORDispatchEnd(self, method, purpose):
    if not purpose.getGenerateMethods(): return

    if purpose.getEmbedded():
      code = self.getCode(purpose.getName()+' declaration IOR dispatch end')
    else:
      code = self.getCode(purpose.getName()+' definition IOR dispatch end')

    parameters = method.getChildren()
    exceptions = self.getIORExceptions(method)

    if not method.getStatic() and len(parameters) > 0:
      code.write(', ')
    for p in range(len(parameters)):
      param = SIDLLanguage.Parameter.Parameter(parameters[p])
      name = param.getIdentifier()
      mode = param.getAccessMode()
      type = param.getType()

      code.write(self.getModeComment(mode))
      if self.isOut(mode):
        code.write('&')
      if self.needLocalVariable(type):
        if not self.isOut(mode) and self.hasIOR(type):
          code.write(name+'._get_ior()')
        else:
          code.write('_local_'+name)
      else:
        code.write(name)
      if (p < len(parameters)-1): code.write(', ')
    if len(exceptions):
      if not method.getStatic() or len(parameters) > 0:
        code.write(', ')
      code.write('&_exception')
    code.write(');')

    method.addCode(code)
    return

  def generateMethodImplDispatchBegin(self, method, purpose):
    if not purpose.getGenerateMethods(): return

    if purpose.getEmbedded():
      code = self.getCode(purpose.getName()+' declaration impl dispatch begin')
    else:
      code = self.getCode(purpose.getName()+' definition impl dispatch begin')
    code.println('// Dispatch to implementation')
    if len(self.getIORExceptions(method)):
      code.println('try {')
      code.increaseTabLevel()
    code.indent()
    if not method.getReturnType().getIdentifier() == 'void':
      if self.needLocalVariable(method.getReturnType()):
        code.write('_local__result = ')
      else:
        code.write('_result = ')
    if not method.getStatic():
      code.write('_this->'+method.getIdentifier()+'(')
    method.addCode(code)
    return

  def generateMethodImplDispatchEnd(self, method, purpose):
    if not purpose.getGenerateMethods(): return

    if purpose.getEmbedded():
      code = self.getCode(purpose.getName()+' declaration impl dispatch end')
    else:
      code = self.getCode(purpose.getName()+' definition impl dispatch end')

    parameters = method.getChildren()
    exceptions = self.getIORExceptions(method)

    for p in range(len(parameters)):
      param = SIDLLanguage.Parameter.Parameter(parameters[p])
      name = param.getIdentifier()
      mode = param.getAccessMode()
      type = param.getType()

      code.write(self.getModeComment(mode))
      if self.needLocalVariable(type):
        code.write('_local_'+name)
      elif self.isOut(mode):
        code.write('*'+name)
      else:
        code.write(name)
      if (p < len(parameters)-1): code.write(', ')
    code.write(');')
    if len(exceptions):
      code.write('\n')
      code.println('} catch (::SIDL::StubBase& _sb) {')
      code.increaseTabLevel()
      code.println('::SIDL::BaseException _ex(_sb);')
      code.println('_ex.addReference();')
      code.println('*_exception = _ex._get_ior();')
      code.decreaseTabLevel()
      code.println('}')

    method.addCode(code)
    return

  def generateMethodExceptionCleanup(self, method, purpose):
    if not purpose.getGenerateMethods(): return

    if purpose.getEmbedded():
      code = self.getCode(purpose.getName()+' declaration exception cleanup')
    else:
      code = self.getCode(purpose.getName()+' definition exception cleanup')

    exceptions = self.getIORExceptions(method)

    code.println('// Exception handling cleanup')
    if purpose.getIORDispatch() and len(exceptions):
      code.println('if (_exception != 0) {')
      code.increaseTabLevel()
      code.println('void *_p;')
      code.println('')
      for exception in exceptions:
        exceptionName = exception.getFullIdentifier()
        iorType       = exception.getCodeBlock('C', 'ior type').getSource()

        code.println('if ((_p = (*(_exception->d_epv->'+self.getIORCastMethod()+'))(_exception, "'+exceptionName+'")) != 0) {')
        code.increaseTabLevel()
        code.println(iorType+'_realtype = '+self.reinterpretCast(iorType, '_p')+';')
        code.println('// Note that this alternate constructor does not increment the reference count')
        code.println('throw '+self.getTypeName(exceptionName)+'(_realtype, false);')
        code.decreaseTabLevel()
        code.println('}')
      code.decreaseTabLevel()
      code.println('}')

    method.addCode(code)
    return

  def generateMethodArgumentUnpacking(self, method, purpose):
    if not purpose.getGenerateMethods(): return

    if purpose.getEmbedded():
      code = self.getCode(purpose.getName()+' declaration argument unpacking')
    else:
      code = self.getCode(purpose.getName()+' definition argument unpacking')

    parameters = method.getChildren()
    if purpose.getIORDispatch():
      code.println('// Unpack arguments from dispatch to IOR')
      for parameter in parameters:
        self.composeCode(code, parameter, 'cxx argument unpacking')
    else:
      code.println('// Unpack arguments from dispatch to implementation')
      for parameter in parameters:
        self.composeCode(code, parameter, 'ior argument unpacking')
    method.addCode(code)
    return

  def generateMethodReturnCleanup(self, method, purpose):
    if not purpose.getGenerateMethods(): return

    if purpose.getEmbedded():
      code = self.getCode(purpose.getName()+' declaration return cleanup')
    else:
      code = self.getCode(purpose.getName()+' definition return cleanup')

    code.println('// Return value cleanup')
    if not method.getReturnType().getIdentifier() == 'void':
      if purpose.getIORDispatch():
        self.composeCode(code, method.getReturnType(), 'cxx argument unpacking')
      else:
        self.composeCode(code, method.getReturnType(), 'ior argument unpacking')
      code.println('return _result;')
    method.addCode(code)
    return

  def generateMethodEnd(self, method, purpose):
    if purpose.getEmbedded():
      code = self.getCode(purpose.getName()+' declaration end')
    else:
      code = self.getCode(purpose.getName()+' definition end')
    code.println('}')
    method.addCode(code)
    return

  def generateMethodComponents(self, method, purpose, isDeclaration = 1):
    self.generateMethodReturnType(method, purpose)
    self.generateMethodBegin(method, purpose)
    self.generateMethodIORCheck(method, purpose)
    self.generateMethodWeakReferenceCheck(method, purpose)
    self.generateMethodReturnSetup(method, purpose)
    self.generateMethodArgumentPacking(method, purpose)
    self.generateMethodExceptionSetup(method, purpose)
    if purpose.getIORDispatch():
      self.generateMethodIORDispatchBegin(method, purpose)
      self.generateMethodIORDispatchEnd(method, purpose)
    else:
      self.generateMethodImplDispatchBegin(method, purpose)
      self.generateMethodImplDispatchEnd(method, purpose)
    self.generateMethodExceptionCleanup(method, purpose)
    self.generateMethodArgumentUnpacking(method, purpose)
    self.generateMethodReturnCleanup(method, purpose)
    self.generateMethodEnd(method, purpose)
    return

  def generateFunctionTableAccessor(self, interface, purpose):
    fullName    = interface.getFullIdentifier()
    typeName    = self.getTypeName(fullName)
    iorAccessor = interface.getCodeBlock('C', 'ior function table accessor').getSource()

    code = self.getCode(purpose.getName()+' method definition _get_ext')
    code.println('const '+typeName+'::ext_t *'+typeName+'::s_ext;')
    code.println('')
    if self.isBase(interface):
      code.println('const '+typeName+'::ext_t *'+typeName+'::_get_ext() throw () {')
    else:
      code.println('const '+typeName+'::ext_t *'+typeName+'::_get_ext() throw (::SIDL::NullIORException) {')
    code.increaseTabLevel()
    code.println('if (!s_ext) {')
    code.increaseTabLevel()
    if not self.isBase(interface):
      code.write('#ifdef SIDL_STATIC_LIBRARY\n')
      code.increaseTabLevel()
      code.println('s_ext = '+iorAccessor+'();')
      code.decreaseTabLevel()
      code.write('#else\n')
      code.increaseTabLevel()
      code.println('const ext_t *(*dll_f)(void) = (const ext_t *(*)(void)) ::SIDL::Loader::lookupSymbol("'+iorAccessor+'");')
      code.println('')
      code.println('s_ext = (dll_f ? (*dll_f)() : NULL);')
      code.println('if (!s_ext) {')
      code.increaseTabLevel()
      code.println('::SIDL::NullIORException e = ::SIDL::NullIORException::_create();')
      code.println('')
      code.println('e.setMessage("Cannot find implementation for '+fullName+'; add library to SIDL_DLL_PATH");')
      code.println('throw e;')
      code.decreaseTabLevel()
      code.println('}')
      code.decreaseTabLevel()
      code.write('#endif\n')
    else:
      code.println('s_ext = '+iorAccessor+'();')
    code.decreaseTabLevel()
    code.println('}')
    code.println('return s_ext;')
    code.decreaseTabLevel()
    code.println('}')
    code.println('')
    interface.addCode(code)
    return

  def generateImplBuiltins(self, interface, purpose):
    fullName = interface.getFullIdentifier()
    typeName = self.getTypeName(fullName)+'_'+purpose.getName()

    defn = interface.getCodeBlock(self.language, purpose.getName()+' class definition: constructors')
    defn.println('// User Constructors/Destructors ')
    defn.println('public:')
    defn.increaseTabLevel()

    defn.println('void _ctor();')
    ctor = self.getCode(purpose.getName()+' method definition begin _ctor')
    ctor.println('void '+typeName+'::_ctor() {')
    ctor.increaseTabLevel()
    interface.addCode(ctor)
    ctor = self.getCode(purpose.getName()+' method definition end _ctor')
    ctor.println('}')
    ctor.println('')
    interface.addCode(ctor)

    defn.println('void _dtor();')
    dtor = self.getCode(purpose.getName()+' method definition begin _dtor')
    dtor.println('void '+typeName+'::_dtor() {')
    dtor.increaseTabLevel()
    interface.addCode(dtor)
    dtor = self.getCode(purpose.getName()+' method definition end _dtor')
    dtor.println('}')
    dtor.println('')
    interface.addCode(dtor)
    defn.println('')
    return

  def generateSkelConstructors(self, sclass, purpose):
    fullName = sclass.getFullIdentifier()
    typeName = self.getTypeName(fullName)+'_impl'
    iorType  = sclass.getCodeBlock('C', 'ior type').getSource()

    code = self.getCode(purpose.getName()+' method definition _ctor')
    code.println('void '+fullName.replace('.', '_')+'__ctor_skel('+iorType+'self) {')
    code.increaseTabLevel()
    code.println('self->d_data = '+self.reinterpretCast('void *', 'new '+typeName+'(self)')+';')
    code.decreaseTabLevel()
    code.println('}')
    code.println('')
    sclass.addCode(code)

    code = self.getCode(purpose.getName()+' method definition _dtor')
    code.println('void '+fullName.replace('.', '_')+'__dtor_skel('+iorType+'self) {')
    code.increaseTabLevel()
    code.println('delete('+self.reinterpretCast(typeName+' *', 'self->d_data')+');')
    code.decreaseTabLevel()
    code.println('}')
    code.println('')
    sclass.addCode(code)
    return

  def generateFunctionTableEntry(self, code, sclass, method, purpose):
    if method.getStatic():
      table = 'sepv'
    else:
      table = 'epv'
    if method.getAbstract():
      code.println(table+'->f_'+method.getIdentifier()+' = NULL;')
    else:
      code.println(table+'->f_'+method.getIdentifier()+' = '+self.getMethodName(sclass, method, purpose)+';')
    return

  def generateFunctionTableSetup(self, sclass, purpose):
    iorName = sclass.getFullIdentifier().replace('.', '_')
    vtable  = sclass.getCodeBlock('C', 'ior epv table type').getSource()
    stable  = sclass.getCodeBlock('C', 'ior static function table type').getSource()

    code = self.getCode(purpose.getName()+' method definition _set_epv')
    code.println('void')
    code.println(iorName+'__set_epv('+vtable+' epv) {')
    code.increaseTabLevel()
    code.println('// Initialize constructor and destructor')
    self.generateFunctionTableEntry(code, sclass, self.createConstructorMethod(sclass), purpose)
    self.generateFunctionTableEntry(code, sclass, self.createDestructorMethod(sclass), purpose)
    methods = sclass.getImplementedMethods()
    header  = 0
    for method in methods:
      if not method.getStatic():
        if not header:
          code.println('// Initialize user methods')
          header = 1
        self.generateFunctionTableEntry(code, sclass, method, purpose)
    code.decreaseTabLevel()
    code.println('}')
    code.println('')
    sclass.addCode(code)

    if not self.hasStaticMethod(sclass): return
    code = self.getCode(purpose.getName()+' method definition _set_sepv')
    code.println('void')
    code.println(iorName+'__set_sepv('+stable+' sepv) {')
    code.increaseTabLevel()
    methods = sclass.getImplementedMethods()
    code.println('// Initialize user methods')
    for method in methods:
      if method.getStatic():
        self.generateFunctionTableEntry(code, sclass, method, purpose)
    code.decreaseTabLevel()
    code.println('}')
    code.println('')
    sclass.addCode(code)
    return

  def getMethodName(self, interface, method, purpose):
    pathExt = purpose.getPathExtension()
    if purpose.getIORDispatch():
      # C++ naming
      if purpose.getEmbedded():
        methodName = method.getIdentifier()
      else:
        methodName = interface.getFullIdentifier().replace('.', '::')
        if pathExt: methodName = methodName+'_'+pathExt
        methodName = methodName+'::'+method.getIdentifier()
    else:
      # C naming
      methodName = interface.getFullIdentifier().replace('.', '_')+'_'+method.getIdentifier()
      if pathExt: methodName = methodName+'_'+pathExt
    return methodName

  def generateMethodParameters(self, interface, method, purpose, code):
    parameters    = method.getChildren()
    hasExceptions = purpose.getEmulateExceptions() and len(self.getIORExceptions(method))
    hasArgs       = purpose.getUseSelf() or len(parameters) or hasExceptions
    if hasArgs:
      code.println('(')
      code.increaseTabLevel()
      if purpose.getUseSelf() and not method.getStatic():
        code.indent()
        self.composeCode(code, interface, 'ior type', language = 'C')
        code.write('self')
        if len(parameters) or hasExceptions: code.write(',\n')
      for p in range(len(parameters)):
        code.indent()
        if purpose.getIORDispatch():
          self.composeCode(code, parameters[p], 'cxx parameter')
        else:
          self.composeCode(code, parameters[p], 'ior parameter', language = 'C')
        if p < len(parameters)-1 or hasExceptions: code.write(',\n')
      if purpose.getEmulateExceptions():
        self.generateMethodExceptions(interface, method, purpose, code)
      code.decreaseTabLevel()
      code.println(')')
    else:
      code.println('()')
    return

  def generateMethodExceptions(self, interface, method, purpose, code):
    if purpose.getEmulateExceptions():
      exceptions = self.getIORExceptions(method)
      if len(exceptions):
        code.indent()
        self.composeCode(code, self.getBaseException(exceptions[0]), 'ior type', language = 'C')
        code.write('*_exception')
    else:
      if self.isBase(interface):
        exceptions = self.getIORExceptions(method)
      else:
        exceptions = method.getExceptions()

      if len(exceptions):
        code.println('throw (')
        code.increaseTabLevel()
        for e in range(len(exceptions)):
          fullName = exceptions[e].getFullIdentifier()
          code.indent()
          code.write(self.getTypeName(fullName))
          if e < len(exceptions)-1: code.write(',\n')
        code.decreaseTabLevel()
        code.println(')')
      else:
        code.println('throw ()')
    return

  def generateMethod(self, interface, method, purpose, use):
    pre        = purpose.getName()+' '+use
    methodName = self.getMethodName(interface, method, purpose)
    if use == 'declaration':
      code      = self.getCode(purpose.getName()+' method '+use+' '+method.getIdentifier())
    else:
      codeBegin = self.getCode(purpose.getName()+' method '+use+' begin '+method.getIdentifier())
      codeEnd   = self.getCode(purpose.getName()+' method '+use+' end '+method.getIdentifier())
      code      = codeBegin

    # Create method signature
    if not method.hasCodeBlock(self.language, pre+' return type'): return
    self.composeCode(code, method, pre+' return type')
    code.write(methodName)
    self.generateMethodParameters(interface, method, purpose, code)
    if not purpose.getEmulateExceptions():
      self.generateMethodExceptions(interface, method, purpose, code)
    if use == 'declaration' and not purpose.getEmbedded():
      code.println(';')

    # Create method body
    self.composeCode(code, method, pre+' begin', 0)
    code.increaseTabLevel()
    if use == 'definition':
      interface.addCode(code)
      code = codeEnd
      code.increaseTabLevel()
    if not self.isBase(interface):
      self.composeCode(code, method, pre+' IOR check', 0)
    self.composeCode(code, method, pre+' weak reference check', 0)
    self.composeCode(code, method, pre+' return setup', 0)
    self.composeCode(code, method, pre+' argument packing', 0)
    self.composeCode(code, method, pre+' exception setup', 0)
    if method.hasCodeBlock(self.language, pre+' IOR dispatch begin'):
      self.composeCode(code, method, pre+' IOR dispatch begin', 0)
      if not method.getStatic():
        code.write(self.getIORStructName(interface, 'd_self'))
      self.composeCode(code, method, pre+' IOR dispatch end', 0)
      code.write('\n')
    if method.hasCodeBlock(self.language, pre+' impl dispatch begin'):
      typeName = self.getTypeName(interface.getFullIdentifier())+'_impl'
      if not method.getStatic():
        code.println('// Get implementation')
        code.println(typeName+' *_this = '+self.reinterpretCast(typeName+' *', 'self->d_data')+';')
      self.composeCode(code, method, pre+' impl dispatch begin', 0)
      if method.getStatic():
        code.write(typeName+'::'+method.getIdentifier()+'(')
      self.composeCode(code, method, pre+' impl dispatch end', 0)
      code.write('\n')
    self.composeCode(code, method, pre+' exception cleanup', 0)
    self.composeCode(code, method, pre+' argument unpacking', 0)
    self.composeCode(code, method, pre+' return cleanup', 0)
    code.decreaseTabLevel()
    self.composeCode(code, method, pre+' end', 0)
    code.println('')
    interface.addCode(code)
    return

  def generateMethods(self, interface, purpose):
    if not self.defnActive: return
    isImpl     = purpose.isInstanceOf('ANL.SIDLCompilerI.Implementation')
    isAbstract = interface.isInstanceOf('SIDLLanguage.Class') and interface.getAbstract()
    if isImpl and isAbstract:
      for child in interface.getChildren():
        method = SIDLLanguage.Method.Method(child)
        self.generateMethod(interface, method, purpose, 'declaration')
        self.generateMethod(interface, method, purpose, 'definition')
    else:
      methods = []
      for parent in interface.getParents():
        methods.extend(parent.getMethods())
      for method in interface.getMethods():
        same = 0
        for m in methods:
          if m.isSame(method):
            same = 1
            break
        if not isImpl or not same:
          self.generateMethod(interface, method, purpose, 'declaration')
          self.generateMethod(interface, method, purpose, 'definition')
    # Special methods
    if purpose.isInstanceOf('ANL.SIDLCompilerI.Stub'):
      self.generateFunctionTableAccessor(interface, purpose)
    elif purpose.isInstanceOf('ANL.SIDLCompilerI.Skeleton'):
      self.generateSkelConstructors(interface, purpose)
      self.generateFunctionTableSetup(interface, purpose)
    elif purpose.isInstanceOf('ANL.SIDLCompilerI.Implementation'):
      self.generateImplBuiltins(interface, purpose)
    return
# DO-NOT-DELETE splicer.end(_final)

