#ifndef included_SIDLLanguage_CodeGenerator_IOR
#define included_SIDLLanguage_CodeGenerator_IOR

#ifndef NULL
#define NULL 0
#endif

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#ifdef __cplusplus
extern "C" {
#endif

/* Symbol SIDLLanguage.CodeGenerator */

/* These structures are defined in this header */
struct SIDLLanguage_CodeGenerator__object;

/* Forward declarations for array structure and external classes and interfaces */
struct SIDLLanguage_CodeGenerator__array;
struct SIDL_Loader__object;
struct SIDL_Loader__array;
struct SIDL_NullIORException__object;
struct SIDL_NullIORException__array;
struct SIDL_BaseException__object;
struct SIDL_BaseException__array;
struct SIDLLanguage_AST__object;
struct SIDLLanguage_AST__array;
struct SIDLLanguage_VisitorException__object;
struct SIDLLanguage_VisitorException__array;
struct SIDLLanguage_Specification__object;
struct SIDLLanguage_Specification__array;
struct SIDLLanguage_Version__object;
struct SIDLLanguage_Version__array;
struct SIDLLanguage_Package__object;
struct SIDLLanguage_Package__array;
struct SIDLLanguage_Interface__object;
struct SIDLLanguage_Interface__array;
struct SIDLLanguage_Class__object;
struct SIDLLanguage_Class__array;
struct SIDLLanguage_Method__object;
struct SIDLLanguage_Method__array;
struct SIDLLanguage_Type__object;
struct SIDLLanguage_Type__array;
struct SIDLLanguage_Enumeration__object;
struct SIDLLanguage_Enumeration__array;
struct SIDLLanguage_Enumerator__object;
struct SIDLLanguage_Enumerator__array;
struct SIDLLanguage_Array__object;
struct SIDLLanguage_Array__array;
struct SIDLLanguage_Parameter__object;
struct SIDLLanguage_Parameter__array;
struct SIDLLanguage_Comment__object;
struct SIDLLanguage_Comment__array;
struct SIDL_BaseInterface__object;
struct SIDL_BaseInterface__array;
struct SIDL_BaseException__object;
struct SIDL_BaseException__array;

#ifndef included_SIDL_header_h
#include "SIDL_header.h"
#endif

/* Declare the method entry point vector */
struct SIDLLanguage_CodeGenerator__epv {
  /* Builtin methods */
  void *(*f__cast_ior)(
    void *self,
    const char *name);
  void (*f__delete)(
    void *self);
  /* Methods contributed by SIDLLanguage.CodeGenerator */
  SIDL_bool (*f_getPurposeActive)(
    void *self,
    /*in*/ const char * purpose,
    struct SIDL_BaseException__object **_exception);
  void (*f_setPurposeActive)(
    void *self,
    /*in*/ const char * purpose,
    /*in*/ SIDL_bool isActive,
    struct SIDL_BaseException__object **_exception);
  SIDL_bool (*f_getDeclarationActive)(
    void *self,
    struct SIDL_BaseException__object **_exception);
  void (*f_setDeclarationActive)(
    void *self,
    /*in*/ SIDL_bool isActive,
    struct SIDL_BaseException__object **_exception);
  SIDL_bool (*f_getDefinitionActive)(
    void *self,
    struct SIDL_BaseException__object **_exception);
  void (*f_setDefinitionActive)(
    void *self,
    /*in*/ SIDL_bool isActive,
    struct SIDL_BaseException__object **_exception);
  /* Methods contributed by SIDLLanguage.Visitor */
  struct SIDLLanguage_AST__array * (*f_getRepository)(
    void *self,
    struct SIDL_BaseException__object **_exception);
  void (*f_setRepository)(
    void *self,
    /*in*/ struct SIDLLanguage_AST__array * repository,
    struct SIDL_BaseException__object **_exception);
  void (*f_visitAST)(
    void *self,
    /*in*/ struct SIDLLanguage_AST__object * node,
    struct SIDL_BaseException__object **_exception);
  void (*f_visitSpecification)(
    void *self,
    /*in*/ struct SIDLLanguage_Specification__object * node,
    struct SIDL_BaseException__object **_exception);
  void (*f_visitVersion)(
    void *self,
    /*in*/ struct SIDLLanguage_Version__object * node,
    struct SIDL_BaseException__object **_exception);
  void (*f_visitPackage)(
    void *self,
    /*in*/ struct SIDLLanguage_Package__object * node,
    struct SIDL_BaseException__object **_exception);
  void (*f_visitInterface)(
    void *self,
    /*in*/ struct SIDLLanguage_Interface__object * node,
    struct SIDL_BaseException__object **_exception);
  void (*f_visitClass)(
    void *self,
    /*in*/ struct SIDLLanguage_Class__object * node,
    struct SIDL_BaseException__object **_exception);
  void (*f_visitMethod)(
    void *self,
    /*in*/ struct SIDLLanguage_Method__object * node,
    struct SIDL_BaseException__object **_exception);
  void (*f_visitType)(
    void *self,
    /*in*/ struct SIDLLanguage_Type__object * node,
    struct SIDL_BaseException__object **_exception);
  void (*f_visitEnumeration)(
    void *self,
    /*in*/ struct SIDLLanguage_Enumeration__object * node,
    struct SIDL_BaseException__object **_exception);
  void (*f_visitEnumerator)(
    void *self,
    /*in*/ struct SIDLLanguage_Enumerator__object * node,
    struct SIDL_BaseException__object **_exception);
  void (*f_visitArray)(
    void *self,
    /*in*/ struct SIDLLanguage_Array__object * node,
    struct SIDL_BaseException__object **_exception);
  void (*f_visitParameter)(
    void *self,
    /*in*/ struct SIDLLanguage_Parameter__object * node,
    struct SIDL_BaseException__object **_exception);
  void (*f_visitComment)(
    void *self,
    /*in*/ struct SIDLLanguage_Comment__object * node,
    struct SIDL_BaseException__object **_exception);
  /* Methods contributed by SIDL.BaseInterface */
  void (*f_addReference)(
    void *self);
  void (*f_deleteReference)(
    void *self);
  SIDL_bool (*f_isSame)(
    void *self,
    /*in*/ struct SIDL_BaseInterface__object * iobj);
  struct SIDL_BaseInterface__object * (*f_queryInterface)(
    void *self,
    /*in*/ const char * name);
  SIDL_bool (*f_isInstanceOf)(
    void *self,
    /*in*/ const char * name);
};

/* Define the object structure */
struct SIDLLanguage_CodeGenerator__object {
  struct SIDLLanguage_CodeGenerator__epv * d_epv;
  void *d_object;
};

/* Create a dense array of the given dimension with specified index bounds */
/*   This array owns and manages its data */
/*   All object pointers are initialized to NULL */
struct SIDLLanguage_CodeGenerator__array * SIDLLanguage_CodeGenerator__iorarray_create(
  int32_t dimen,
  const int32_t lower[],
  const int32_t upper[]);

/* Create an array using user-provided memory */
struct SIDLLanguage_CodeGenerator__array * SIDLLanguage_CodeGenerator__iorarray_borrow(
  struct SIDLLanguage_CodeGenerator__object ** firstElement,
  int32_t dimen,
  const int32_t lower[],
  const int32_t upper[],
  const int32_t stride[]);

/* Destroy the array (NULL arrays are ignored) */
void SIDLLanguage_CodeGenerator__iorarray_destroy(
  struct SIDLLanguage_CodeGenerator__array *array);

/* Return the number of dimensions in the array */
/*   If the array pointer is NULL, zero is returned */
int32_t SIDLLanguage_CodeGenerator__iorarray_dimen(
  const struct SIDLLanguage_CodeGenerator__array *array);

/* Return the lower bound on dimension ind */
/*   If the array pointer is NULL or ind is not a valid dimension, zero is returned */
int32_t SIDLLanguage_CodeGenerator__iorarray_lower(
  const struct SIDLLanguage_CodeGenerator__array *array,
  int32_t ind);

/* Return the upper bound on dimension ind */
/*   If the array pointer is NULL or ind is not a valid dimension, -1 is returned */
int32_t SIDLLanguage_CodeGenerator__iorarray_upper(
  const struct SIDLLanguage_CodeGenerator__array *array,
  int32_t ind);

/* Get an element of a multi-dimensional array */
/* This will use the indices provided up to the actual dimension of the array, ignoring extra indices */
/* If the return value is non-NULL, the client owns one reference to the object/interface */
/* The client must decrement the reference count when done with the reference */
struct SIDLLanguage_CodeGenerator__object * SIDLLanguage_CodeGenerator__iorarray_get(
  const struct SIDLLanguage_CodeGenerator__array *array,
  const int32_t indices[]);

/* get an element of a multi-dimensional array */
/* This will use the indices provided up to the actual dimension of the array, ignoring extra indices */
/* If the return value is non-NULL, the client owns one reference to the object/interface */
/* The client must decrement the reference count when done with the reference */
struct SIDLLanguage_CodeGenerator__object * SIDLLanguage_CodeGenerator__iorarray_get4(
  const struct SIDLLanguage_CodeGenerator__array *array,
  int32_t i1,
  int32_t i2,
  int32_t i3,
  int32_t i4);

/* Set an element of a multi-dimensional array */
/* This will use the indices provided up to the actual dimension of the array, ignoring extra indices */
/* If the incoming value is non-NULL, this function will increment the reference code of the object/interface */
/* If it is overwriting a non-NULL pointer, the reference count of the object/interface being overwritten will be decremented */
void SIDLLanguage_CodeGenerator__iorarray_set(
  struct SIDLLanguage_CodeGenerator__array *array,
  const int32_t indices[],
  struct SIDLLanguage_CodeGenerator__object * value);

/* set an element of a multi-dimensional array */
/* This will use the indices provided up to the actual dimension of the array, ignoring extra indices */
/* If the incoming value is non-NULL, this function will increment the reference code of the object/interface */
/* If it is overwriting a non-NULL pointer, the reference count of the object/interface being overwritten will be decremented */
void SIDLLanguage_CodeGenerator__iorarray_set4(
  struct SIDLLanguage_CodeGenerator__array *array,
  int32_t i1,
  int32_t i2,
  int32_t i3,
  int32_t i4,
  struct SIDLLanguage_CodeGenerator__object * value);

struct SIDLLanguage_CodeGenerator__external {
  struct SIDLLanguage_CodeGenerator__array * (*createArray)  (
    int32_t dimen,
    const int32_t lower[],
    const int32_t upper[]);
  struct SIDLLanguage_CodeGenerator__array * (*borrowArray)  (
    struct SIDLLanguage_CodeGenerator__object ** firstElement,
    int32_t dimen,
    const int32_t lower[],
    const int32_t upper[],
    const int32_t stride[]);
  void (*destroyArray)  (
    struct SIDLLanguage_CodeGenerator__array *array);
  int32_t (*getDimen)  (
    const struct SIDLLanguage_CodeGenerator__array *array);
  int32_t (*getLower)  (
    const struct SIDLLanguage_CodeGenerator__array *array,
    int32_t ind);
  int32_t (*getUpper)  (
    const struct SIDLLanguage_CodeGenerator__array *array,
    int32_t ind);
  struct SIDLLanguage_CodeGenerator__object * (*getElement)  (
    const struct SIDLLanguage_CodeGenerator__array *array,
    const int32_t indices[]);
  struct SIDLLanguage_CodeGenerator__object * (*getElement4)  (
    const struct SIDLLanguage_CodeGenerator__array *array,
    int32_t i1,
    int32_t i2,
    int32_t i3,
    int32_t i4);
  void (*setElement)  (
    struct SIDLLanguage_CodeGenerator__array *array,
    const int32_t indices[],
    struct SIDLLanguage_CodeGenerator__object * value);
  void (*setElement4)  (
    struct SIDLLanguage_CodeGenerator__array *array,
    int32_t i1,
    int32_t i2,
    int32_t i3,
    int32_t i4,
    struct SIDLLanguage_CodeGenerator__object * value);
};

/* This function returns a pointer to a static structure of pointers to function entry points */
/* It is called upon loading the DLL */
const struct SIDLLanguage_CodeGenerator__external *SIDLLanguage_CodeGenerator__externals(void);
#ifdef __cplusplus
}
#endif

#endif /* included_SIDLLanguage_CodeGenerator_IOR */
