# DO-NOT-DELETE splicer.begin(_initial)
import SIDL.Loader
import SIDLLanguage.CodePurpose
# DO-NOT-DELETE splicer.end(_initial)

import SIDL.NullIORException
import SIDL.BaseInterface
import SIDL.BaseException
import SIDLLanguage.VisitorException
import SIDLLanguage.Splicer
import SIDLLanguage.Code
import SIDLLanguage.AST
import SIDLLanguage.Specification
import SIDLLanguage.Version
import SIDLLanguage.Package
import SIDLLanguage.Interface
import SIDLLanguage.Class
import SIDLLanguage.Method
import SIDLLanguage.Type
import SIDLLanguage.Enumeration
import SIDLLanguage.Enumerator
import SIDLLanguage.Array
import SIDLLanguage.Parameter
import SIDLLanguage.Comment

# DO-NOT-DELETE splicer.begin(_before_type)
import os
import sys
# DO-NOT-DELETE splicer.end(_before_type)

class FileOutput:
  '''
  // This class outputs all IOR code onto the filesystem
  '''
  # All calls to SIDL methods should use __IORself

  def __init__(self, IORself):
    self.__IORself = IORself
    # DO-NOT-DELETE splicer.begin(__init__)
    self.language     = 'C'
    self.indentString = '  '
    self.markName     = 'iorFileOutputMark'
    self.headerMark   = 'headerIORFileOutputMark'
    self.sourceMark   = 'sourceIORFileOutputMark'
    self.headerOnly   = [0]
    self.defaultRoot  = os.path.join(os.getcwd(), 'test-'+self.language.lower())
    self.roots        = {}
    self.outputFiles  = []
    self.codeOutput   = SIDLLanguage.Code.Code(SIDL.Loader.createClass('ANL.SIDLCompilerI.CodeFile'))
    self.IOR          = SIDLLanguage.CodePurpose.CodePurpose(SIDL.Loader.createClass('ANL.SIDLCompilerI.IOR'))
    # DO-NOT-DELETE splicer.end(__init__)

  def getRoot(self, purpose):
    '''
    // Get the root directory for output
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # purpose string
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # string _return
    # DO-NOT-DELETE splicer.begin(getRoot)
    if self.roots.has_key(purpose):
      return self.roots[purpose]
    else:
      return self.defaultRoot
    # DO-NOT-DELETE splicer.end(getRoot)

  def setRoot(self, purpose, path):
    '''
    // Set the root directory for output
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # purpose string
    # path string
    # DO-NOT-DELETE splicer.begin(setRoot)
    self.roots[purpose] = path
    # DO-NOT-DELETE splicer.end(setRoot)

  def getOutputSource(self):
    '''
    // Get the flag determining whether source is output
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # bool _return
    # DO-NOT-DELETE splicer.begin(getOutputSource)
    return not self.headerOnly[-1]
    # DO-NOT-DELETE splicer.end(getOutputSource)

  def setOutputSource(self, outputSource):
    '''
    // Set the flag determining whether source is output
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # outputSource bool
    # DO-NOT-DELETE splicer.begin(setOutputSource)
    self.headerOnly[-1] = not outputSource
    # DO-NOT-DELETE splicer.end(setOutputSource)

  def getSplicer(self):
    '''
    // Retrieve the splicer used for preserving implementation blocks
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # SIDLLanguage.Splicer _return
    # DO-NOT-DELETE splicer.begin(getSplicer)
    # Put your code here...
    return self.splicer
    # DO-NOT-DELETE splicer.end(getSplicer)

  def setSplicer(self, splicer):
    '''
    // Set the splicer used for preserving implementation blocks
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # splicer SIDLLanguage.Splicer
    # DO-NOT-DELETE splicer.begin(setSplicer)
    # Put your code here...
    self.splicer = splicer
    # DO-NOT-DELETE splicer.end(setSplicer)

  def getCodeOutput(self):
    '''
    // Retrieve the Code object used for output
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # SIDLLanguage.Code _return
    # DO-NOT-DELETE splicer.begin(getCodeOutput)
    return self.codeOutput
    # DO-NOT-DELETE splicer.end(getCodeOutput)

  def setCodeOutput(self, output):
    '''
    // Set the Code object used for output
    //   Obviously here we need a persistent object which can output many source blocks
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # output SIDLLanguage.Code
    # DO-NOT-DELETE splicer.begin(setCodeOutput)
    self.codeOutput = output
    # DO-NOT-DELETE splicer.end(setCodeOutput)

  def getOutputFiles(self):
    '''
    // Retrieve all the created files
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # array _return
    # DO-NOT-DELETE splicer.begin(getOutputFiles)
    return self.outputFiles
    # DO-NOT-DELETE splicer.end(getOutputFiles)

  def clearOutputFiles(self):
    '''
    // Clear the list of created files
    '''
    # DO-NOT-DELETE splicer.begin(clearOutputFiles)
    self.outputFiles = []
    # DO-NOT-DELETE splicer.end(clearOutputFiles)

  def getRepository(self):
    '''
    // Retrieve auxilliary ASTs
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # array _return
    # DO-NOT-DELETE splicer.begin(getRepository)
    return []
    # DO-NOT-DELETE splicer.end(getRepository)

  def setRepository(self, repository):
    '''
    // Set auxilliary ASTs
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # repository array
    # DO-NOT-DELETE splicer.begin(setRepository)
    # Put your code here...
    pass
    # DO-NOT-DELETE splicer.end(setRepository)

  def visitAST(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.AST
    # DO-NOT-DELETE splicer.begin(visitAST)
    # Put your code here...
    pass
    # DO-NOT-DELETE splicer.end(visitAST)

  def visitSpecification(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Specification
    # DO-NOT-DELETE splicer.begin(visitSpecification)
    self.defaultVisit(node)
    self.unmarkTree(node, self.headerMark)
    self.unmarkTree(node, self.sourceMark)
    # DO-NOT-DELETE splicer.end(visitSpecification)

  def visitVersion(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Version
    # DO-NOT-DELETE splicer.begin(visitVersion)
    # Put your code here...
    pass
    # DO-NOT-DELETE splicer.end(visitVersion)

  def visitPackage(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Package
    # DO-NOT-DELETE splicer.begin(visitPackage)
    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitPackage)

  def visitInterface(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Interface
    # DO-NOT-DELETE splicer.begin(visitInterface)
    try:
      self.outputHeader(node)
      if not self.headerOnly[-1]:
        self.outputSource(node)

      self.headerOnly.append(1)
      for inf in node.getParents():
        inf.accept(self.__IORself)
      for dep in node.getDependencies():
        if dep.isInstanceOf('SIDLLanguage.Enumeration'):
          dep.accept(self.__IORself)
      self.headerOnly.pop()
    except Exception, e:
      import traceback
      self.raiseVisitorException(str(e), traceback.format_tb(sys.exc_info()[2]))
    # DO-NOT-DELETE splicer.end(visitInterface)

  def visitClass(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Class
    # DO-NOT-DELETE splicer.begin(visitClass)
    try:
      self.outputHeader(node)
      if not self.headerOnly[-1]:
        self.outputSource(node)

      self.headerOnly.append(1)
      for cls in node.getParents():
        cls.accept(self.__IORself)
      for interface in node.getInterfaces():
        interface.accept(self.__IORself)
      for dep in node.getDependencies():
        if dep.isInstanceOf('SIDLLanguage.Enumeration'):
          dep.accept(self.__IORself)
      self.headerOnly.pop()
    except Exception, e:
      import traceback
      self.raiseVisitorException(str(e), traceback.format_tb(sys.exc_info()[2]))
    # DO-NOT-DELETE splicer.end(visitClass)

  def visitMethod(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Method
    # DO-NOT-DELETE splicer.begin(visitMethod)
    # Put your code here...
    pass
    # DO-NOT-DELETE splicer.end(visitMethod)

  def visitType(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Type
    # DO-NOT-DELETE splicer.begin(visitType)
    # Put your code here...
    pass
    # DO-NOT-DELETE splicer.end(visitType)

  def visitEnumeration(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Enumeration
    # DO-NOT-DELETE splicer.begin(visitEnumeration)
    try:
      self.outputHeader(node)
      if not self.headerOnly[-1]:
        self.outputSource(node)
    except Exception, e:
      import traceback
      self.raiseVisitorException(str(e), traceback.format_tb(sys.exc_info()[2]))
    # DO-NOT-DELETE splicer.end(visitEnumeration)

  def visitEnumerator(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Enumerator
    # DO-NOT-DELETE splicer.begin(visitEnumerator)
    # Put your code here...
    pass
    # DO-NOT-DELETE splicer.end(visitEnumerator)

  def visitArray(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Array
    # DO-NOT-DELETE splicer.begin(visitArray)
    # Put your code here...
    pass
    # DO-NOT-DELETE splicer.end(visitArray)

  def visitParameter(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Parameter
    # DO-NOT-DELETE splicer.begin(visitParameter)
    # Put your code here...
    pass
    # DO-NOT-DELETE splicer.end(visitParameter)

  def visitComment(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Comment
    # DO-NOT-DELETE splicer.begin(visitComment)
    # Put your code here...
    pass
    # DO-NOT-DELETE splicer.end(visitComment)

# DO-NOT-DELETE splicer.begin(_final)
  ##########################
  # Basic Visitor Operations
  def raiseVisitorException(self, message, trace = ''):
    e = SIDLLanguage.VisitorException.VisitorException()
    e.setMessage(message)
    if isinstance(trace, list):
      for line in trace: e.addToStackTrace(line.strip())
    elif trace:
      e.addToStackTrace(trace)
    e.addToTrace(__file__, sys._getframe(1).f_lineno, sys._getframe().f_code.co_name)
    raise SIDLLanguage.VisitorException.Exception, e

  def defaultVisit(self, ast):
    try:
      for child in ast.getChildren():
        child.accept(self.__IORself)
    except SIDLLanguage.ASTException.Exception, e:
      self.raiseVisitorException(e.getMessage(), e.getStackTrace().strip())
    return

  def isMarked(self, node, name = ''):
    if not name: name = self.markName
    return node.hasAttribute(name)

  def markNode(self, node, name = ''):
    if not name: name = self.markName
    seen = SIDLLanguage.Attribute.Attribute(SIDL.Loader.createClass('ANL.SIDLCompilerI.Attribute'))
    seen.setName(name)
    node.addAttribute(seen)
    return

  def unmarkNode(self, node, name = ''):
    if not name: name = self.markName
    if node.hasAttribute(name):
      node.deleteAttribute(name)
    return

  def unmarkNetwork(self, node, name = ''):
    self.unmarkNode(node, name)
    for interface in node.getParents():
      self.unmarkNetwork(interface, name)
    if node.isInstanceOf('SIDLLanguage.Class'):
      for interface in SIDLLanguage.Class.Class(node).getInterfaces():
        self.unmarkNetwork(interface, name)
    return

  def unmarkTree(self, node, name = ''):
    self.unmarkNode(node, name)
    for child in node.getChildren():
      self.unmarkTree(child, name)
    return

  #########################
  # IOR specific methods
  def getIORName(self, node):
    return node.getFullIdentifier().replace('.', '_')

  def isBase(self, interface):
    return interface.getFullIdentifier() in ['SIDL.BaseInterface', 'SIDL.BaseClass', 'SIDL.BaseException', 'SIDL.NullIORException', 'SIDL.Loader', 'SIDL.DLL']

  def getBaseObject(self, node, identifier):
    # Recurse to parents
    for interface in node.getParents():
      base = self.getBaseObject(interface, identifier)
      if base: return base
    # Find SIDL package
    parent = node.getParent()
    if parent.isInstanceOf('SIDLLanguage.Package') and parent.getFullIdentifier() == 'SIDL':
      for child in parent.getChildren():
        if child.getFullIdentifier() == 'SIDL.'+identifier:
          return child
    return None

  ##################################
  # Basic Code Generation Operations
  def getCode(self, label = '', language = ''):
    code = SIDLLanguage.Code.Code(SIDL.Loader.createClass('ANL.SIDLCompilerI.Code'))
    if language:
      code.setLanguage(language)
    else:
      code.setLanguage(self.language)
    if label:
      code.setLabel(label)
    return code

  #########################
  # Should go in Code class
  def composeCode(self, parent, node, label, fail = 1, forceBreak = 0):
    if node.hasCodeBlock(self.language, label):
      return self.composeCodeBlock(parent, node.getCodeBlock(self.language, label), forceBreak)
    elif fail:
      self.raiseVisitorException('Unable to find code block "'+label+'" in '+node.getFullIdentifier())
    return None

  def composeCodeBlock(self, parent, code, forceBreak = 0):
    indent = ''
    for i in range(parent.getTabLevel()):
      indent += self.indentString
    source = code.getSource()
    if indent and (source.find('\n') >= 0 or forceBreak):
      # Indent start and all newlines
      source = indent+source.replace('\n', '\n'+indent)
      # Remove extra space from the end
      index  = 0
      while source[index-1] == ' ': index -= 1
      if index < 0:
        source = source[:index]
    if forceBreak and not source[-1] == '\n':
      source = source+'\n'
    parent.write(source)
    return code

  ##################################
  # Path Operations
  def getDirectory(self, node, root = '', pathExt = '', makeDirectory = 0, fullExt = 0):
    if pathExt: pathExt = '_'+pathExt
    if fullExt:
      dext = pathExt
    else:
      dext = ''
    directory = node.getIdentifier()+pathExt
    parent    = node.getParent()
    while parent.isInstanceOf('SIDLLanguage.Package'):
      directory = os.path.join(parent.getIdentifier()+dext, directory)
      parent   = parent.getParent()
    if root: directory = os.path.join(root, directory)
    if makeDirectory and not os.path.exists(directory):
      os.makedirs(directory)
    return directory

  def getFile(self, interface, purpose, root = '', extension = '', makeDirectory = 0):
    name    = interface.getIdentifier()
    pathExt = purpose.getPathExtension()
    if pathExt:
      name = name+'_'+pathExt
    if extension:
      name = name+'.'+extension
    return os.path.join(self.getDirectory(interface, root, pathExt, makeDirectory), name)

  def getHeader(self, interface, purpose, root = '', makeDirectory = 0):
    return self.getFile(interface, purpose, root, 'h', makeDirectory)

  def getSource(self, interface, purpose, root = '', makeDirectory = 0):
    return self.getFile(interface, purpose, root, 'c', makeDirectory)

  ##################################
  # Output Operations
  def outputInclude(self, f, node, purpose):
    f.write('#ifndef included_'+self.getIORName(node)+'_'+purpose.getName()+'\n')
    f.write('#include "'+self.getHeader(node, purpose)+'"\n')
    f.write('#endif\n')
    return

  def outputClassIncludes(self, f, sclass, level, markName):
    if self.isMarked(sclass, name = markName): return
    self.markNode(sclass, name = markName)

    if level == 1: self.outputInclude(f, sclass, self.IOR)

    for cls in sclass.getParents():
      self.outputClassIncludes(f, SIDLLanguage.Class.Class(cls), level+1, markName)
    for interface in sclass.getInterfaces():
      self.outputInterfaceIncludes(f, interface, level, markName)
    return

  def outputInterfaceIncludes(self, f, interface, level, markName):
    if self.isMarked(interface, name = markName): return
    self.markNode(interface, name = markName)

    if level == 0: self.outputInclude(f, interface, self.IOR)

    for inf in interface.getParents():
      self.outputInterfaceIncludes(f, inf, level, markName)
    return

  def outputDependencyIncludes(self, f, interface):
    # TODO: Remove this bad include soon
    f.write('#ifndef included_SIDL_header_h\n')
    f.write('#include "SIDL_header.h"\n')
    f.write('#endif\n')
    if interface.isInstanceOf('SIDLLanguage.Class'):
      sclass = SIDLLanguage.Class.Class(interface)
      f.println('//')
      f.println('// Includes for all interface and class dependencies')
      f.println('//')
      markName = interface.getFullIdentifier()+'.incMark'
      self.outputClassIncludes(f, sclass, 0, markName)
      self.unmarkNetwork(interface, markName)
      for cls in sclass.getParents():
        if not self.isBase(cls):
          self.outputInclude(f, self.getBaseObject(cls, 'Loader'), self.IOR)
          break
    for dep in interface.getDependencies():
      if dep.isInstanceOf('SIDLLanguage.Enumeration'):
        self.outputInclude(f, dep, self.IOR)
    f.println('')
    return

  def outputHeader(self, interface):
    if not interface.hasCodeBlock(self.language, 'IOR begin header'): return
    if self.isMarked(interface, self.headerMark): return
    self.markNode(interface, self.headerMark)

    purpose  = self.IOR
    filename = self.getHeader(interface, purpose, self.getRoot(purpose.getName()), 1)
    print 'Creating '+filename
    self.outputFiles.append(filename)
    self.codeOutput.setLabel(filename)
    self.composeCode(self.codeOutput, interface, 'IOR begin header')
    self.composeCode(self.codeOutput, interface, 'IOR defines')
    self.composeCode(self.codeOutput, interface, 'IOR includes')
    self.composeCode(self.codeOutput, interface, 'IOR begin extern')
    self.composeCode(self.codeOutput, interface, 'IOR exports', fail = 0)
    self.composeCode(self.codeOutput, interface, 'IOR forward declarations', fail = 0)
    self.outputDependencyIncludes(self.codeOutput, interface)
    self.composeCode(self.codeOutput, interface, 'IOR sepv declaration', fail = 0)
    self.composeCode(self.codeOutput, interface, 'IOR epv declaration', fail = 0)
    self.composeCode(self.codeOutput, interface, 'IOR object declaration', fail = 0)
    self.composeCode(self.codeOutput, interface, 'IOR enumeration declaration', fail = 0)
    self.composeCode(self.codeOutput, interface, 'ior array constructor declaration')
    self.composeCode(self.codeOutput, interface, 'ior array borrow declaration')
    self.composeCode(self.codeOutput, interface, 'ior array destructor declaration')
    self.composeCode(self.codeOutput, interface, 'ior array dimension declaration')
    self.composeCode(self.codeOutput, interface, 'ior array lower declaration')
    self.composeCode(self.codeOutput, interface, 'ior array upper declaration')
    self.composeCode(self.codeOutput, interface, 'ior array get declaration')
    self.composeCode(self.codeOutput, interface, 'ior array fast get declaration')
    self.composeCode(self.codeOutput, interface, 'ior array set declaration')
    self.composeCode(self.codeOutput, interface, 'ior array fast set declaration')
    self.composeCode(self.codeOutput, interface, 'ior external entry points declaration', fail = 0)
    self.composeCode(self.codeOutput, interface, 'IOR end extern')
    self.composeCode(self.codeOutput, interface, 'IOR end header')
    self.codeOutput.close()
    return

  def outputSource(self, interface):
    if not interface.hasCodeBlock(self.language, 'ior array structure'): return
    if self.isMarked(interface, self.sourceMark): return
    self.markNode(interface, self.sourceMark)

    purpose  = self.IOR
    filename = self.getSource(interface, purpose, self.getRoot(purpose.getName()), 1)
    print 'Creating '+filename
    self.outputFiles.append(filename)
    self.codeOutput.setLabel(filename)
    self.outputInclude(self.codeOutput, interface, purpose)
    if not interface.isInstanceOf('SIDLLanguage.Class') and not interface.isInstanceOf('SIDLLanguage.Enumeration'):
      self.outputInclude(self.codeOutput, self.getBaseObject(interface, 'BaseClass'), purpose)
    self.codeOutput.println('')
    self.composeCode(self.codeOutput, interface, 'ior static variables', fail = 0)
    self.composeCode(self.codeOutput, interface, 'ior skeleton declarations', fail = 0)
    self.composeCode(self.codeOutput, interface, 'ior cast definition', fail = 0)
    self.composeCode(self.codeOutput, interface, 'ior delete definition', fail = 0)
    self.composeCode(self.codeOutput, interface, 'ior epv initialization definition', fail = 0)
    self.composeCode(self.codeOutput, interface, 'ior static epv initialization definition', fail = 0)
    self.composeCode(self.codeOutput, interface, 'ior static accessor definition', fail = 0)
    self.composeCode(self.codeOutput, interface, 'ior new definition', fail = 0)
    self.composeCode(self.codeOutput, interface, 'ior init definition', fail = 0)
    self.composeCode(self.codeOutput, interface, 'ior fini definition', fail = 0)
    self.composeCode(self.codeOutput, interface, 'ior array structure')
    self.composeCode(self.codeOutput, interface, 'ior array allocator')
    self.composeCode(self.codeOutput, interface, 'ior array constructor')
    self.composeCode(self.codeOutput, interface, 'ior array borrow')
    self.composeCode(self.codeOutput, interface, 'ior array destructor')
    self.composeCode(self.codeOutput, interface, 'ior array dimension')
    self.composeCode(self.codeOutput, interface, 'ior array lower')
    self.composeCode(self.codeOutput, interface, 'ior array upper')
    self.composeCode(self.codeOutput, interface, 'ior array get')
    self.composeCode(self.codeOutput, interface, 'ior array fast get')
    self.composeCode(self.codeOutput, interface, 'ior array set')
    self.composeCode(self.codeOutput, interface, 'ior array fast set')
    self.composeCode(self.codeOutput, interface, 'ior external entry points', fail = 0)
    self.codeOutput.close()
    return
# DO-NOT-DELETE splicer.end(_final)

