# DO-NOT-DELETE splicer.begin(_initial)
pass
# DO-NOT-DELETE splicer.end(_initial)

import SIDL.NullIORException
import SIDL.BaseInterface
import SIDL.BaseException
import SIDLLanguage.VisitorException
import SIDLLanguage.Splicer
import SIDLLanguage.Code
import SIDLLanguage.AST
import SIDLLanguage.Specification
import SIDLLanguage.Version
import SIDLLanguage.Package
import SIDLLanguage.Interface
import SIDLLanguage.Class
import SIDLLanguage.Method
import SIDLLanguage.Type
import SIDLLanguage.Enumeration
import SIDLLanguage.Enumerator
import SIDLLanguage.Array
import SIDLLanguage.Parameter
import SIDLLanguage.Comment

# DO-NOT-DELETE splicer.begin(_before_type)
import os
# DO-NOT-DELETE splicer.end(_before_type)

class FileReport:
  '''
  // This class reports the files which would be output for the IOR
  '''
  # All calls to SIDL methods should use __IORself

  def __init__(self, IORself):
    self.__IORself = IORself
    # DO-NOT-DELETE splicer.begin(__init__)
    import SIDLLanguage.CodePurpose
    self.language     = 'C'
    self.headerMark   = 'headerIORFileOutputMark'
    self.sourceMark   = 'sourceIORFileOutputMark'
    self.headerOnly   = [0]
    self.defaultRoot  = os.path.join(os.getcwd(), 'test-'+self.language.lower())
    self.roots        = {}
    self.outputFiles  = []
    self.IOR          = SIDLLanguage.CodePurpose.CodePurpose(SIDL.Loader.createClass('ANL.SIDLCompilerI.IOR'))
    # DO-NOT-DELETE splicer.end(__init__)

  def getRoot(self, purpose):
    '''
    // Get the root directory for output
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # purpose string
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # string _return
    # DO-NOT-DELETE splicer.begin(getRoot)
    if self.roots.has_key(purpose):
      return self.roots[purpose]
    else:
      return self.defaultRoot
    # DO-NOT-DELETE splicer.end(getRoot)

  def setRoot(self, purpose, path):
    '''
    // Set the root directory for output
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # purpose string
    # path string
    # DO-NOT-DELETE splicer.begin(setRoot)
    self.roots[purpose] = path
    # DO-NOT-DELETE splicer.end(setRoot)

  def getOutputSource(self):
    '''
    // Get the flag determining whether source is output
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # bool _return
    # DO-NOT-DELETE splicer.begin(getOutputSource)
    return not self.headerOnly[-1]
    # DO-NOT-DELETE splicer.end(getOutputSource)

  def setOutputSource(self, outputSource):
    '''
    // Set the flag determining whether source is output
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # outputSource bool
    # DO-NOT-DELETE splicer.begin(setOutputSource)
    self.headerOnly[-1] = not outputSource
    # DO-NOT-DELETE splicer.end(setOutputSource)

  def getSplicer(self):
    '''
    // Retrieve the splicer used for preserving implementation blocks
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # SIDLLanguage.Splicer _return
    # DO-NOT-DELETE splicer.begin(getSplicer)
    return
    # DO-NOT-DELETE splicer.end(getSplicer)

  def setSplicer(self, splicer):
    '''
    // Set the splicer used for preserving implementation blocks
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # splicer SIDLLanguage.Splicer
    # DO-NOT-DELETE splicer.begin(setSplicer)
    return
    # DO-NOT-DELETE splicer.end(setSplicer)

  def getCodeOutput(self):
    '''
    // Retrieve the Code object used for output
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # SIDLLanguage.Code _return
    # DO-NOT-DELETE splicer.begin(getCodeOutput)
    return
    # DO-NOT-DELETE splicer.end(getCodeOutput)

  def setCodeOutput(self, output):
    '''
    // Set the Code object used for output
    //   Obviously here we need a persistent object which can output many source blocks
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # output SIDLLanguage.Code
    # DO-NOT-DELETE splicer.begin(setCodeOutput)
    return
    # DO-NOT-DELETE splicer.end(setCodeOutput)

  def getOutputFiles(self):
    '''
    // Retrieve all the created files
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # array _return
    # DO-NOT-DELETE splicer.begin(getOutputFiles)
    return self.outputFiles
    # DO-NOT-DELETE splicer.end(getOutputFiles)

  def clearOutputFiles(self):
    '''
    // Clear the list of created files
    '''
    # DO-NOT-DELETE splicer.begin(clearOutputFiles)
    self.outputFiles = []
    # DO-NOT-DELETE splicer.end(clearOutputFiles)

  def getRepository(self):
    '''
    // Retrieve auxilliary ASTs
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # array _return
    # DO-NOT-DELETE splicer.begin(getRepository)
    return []
    # DO-NOT-DELETE splicer.end(getRepository)

  def setRepository(self, repository):
    '''
    // Set auxilliary ASTs
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # repository array
    # DO-NOT-DELETE splicer.begin(setRepository)
    return
    # DO-NOT-DELETE splicer.end(setRepository)

  def visitAST(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.AST
    # DO-NOT-DELETE splicer.begin(visitAST)
    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitAST)

  def visitSpecification(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Specification
    # DO-NOT-DELETE splicer.begin(visitSpecification)
    self.defaultVisit(node)
    self.unmarkTree(node, self.headerMark)
    self.unmarkTree(node, self.sourceMark)
    # DO-NOT-DELETE splicer.end(visitSpecification)

  def visitVersion(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Version
    # DO-NOT-DELETE splicer.begin(visitVersion)
    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitVersion)

  def visitPackage(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Package
    # DO-NOT-DELETE splicer.begin(visitPackage)
    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitPackage)

  def visitInterface(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Interface
    # DO-NOT-DELETE splicer.begin(visitInterface)
    if not self.isMarked(node, self.headerMark):
      self.markNode(node, self.headerMark)
      self.outputFiles.append(self.getHeader(node, self.IOR, self.getRoot(self.IOR.getName()), 1))
    if not self.headerOnly[-1]:
      if not self.isMarked(node, self.sourceMark):
        self.markNode(node, self.sourceMark)
        self.outputFiles.append(self.getSource(node, self.IOR, self.getRoot(self.IOR.getName()), 1))

    self.headerOnly.append(1)
    for inf in node.getParents():
      inf.accept(self.__IORself)
    for dep in node.getDependencies():
      if dep.isInstanceOf('SIDLLanguage.Enumeration'):
        dep.accept(self.__IORself)
    self.headerOnly.pop()

    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitInterface)

  def visitClass(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Class
    # DO-NOT-DELETE splicer.begin(visitClass)
    if not self.isMarked(node, self.headerMark):
      self.markNode(node, self.headerMark)
      self.outputFiles.append(self.getHeader(node, self.IOR, self.getRoot(self.IOR.getName()), 1))
    if not self.headerOnly[-1]:
      if not self.isMarked(node, self.sourceMark):
        self.markNode(node, self.sourceMark)
        self.outputFiles.append(self.getSource(node, self.IOR, self.getRoot(self.IOR.getName()), 1))

    self.headerOnly.append(1)
    for cls in node.getParents():
      cls.accept(self.__IORself)
    for interface in node.getInterfaces():
      interface.accept(self.__IORself)
    for dep in node.getDependencies():
      if dep.isInstanceOf('SIDLLanguage.Enumeration'):
        dep.accept(self.__IORself)
    self.headerOnly.pop()

    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitClass)

  def visitMethod(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Method
    # DO-NOT-DELETE splicer.begin(visitMethod)
    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitMethod)

  def visitType(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Type
    # DO-NOT-DELETE splicer.begin(visitType)
    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitType)

  def visitEnumeration(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Enumeration
    # DO-NOT-DELETE splicer.begin(visitEnumeration)
    if not self.isMarked(node, self.headerMark):
      self.markNode(node, self.headerMark)
      self.outputFiles.append(self.getHeader(node, self.IOR, self.getRoot(self.IOR.getName()), 1))
    if not self.headerOnly[-1]:
      if not self.isMarked(node, self.sourceMark):
        self.markNode(node, self.sourceMark)
        self.outputFiles.append(self.getSource(node, self.IOR, self.getRoot(self.IOR.getName()), 1))
    # DO-NOT-DELETE splicer.end(visitEnumeration)

  def visitEnumerator(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Enumerator
    # DO-NOT-DELETE splicer.begin(visitEnumerator)
    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitEnumerator)

  def visitArray(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Array
    # DO-NOT-DELETE splicer.begin(visitArray)
    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitArray)

  def visitParameter(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Parameter
    # DO-NOT-DELETE splicer.begin(visitParameter)
    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitParameter)

  def visitComment(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Comment
    # DO-NOT-DELETE splicer.begin(visitComment)
    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitComment)

# DO-NOT-DELETE splicer.begin(_final)
  def raiseVisitorException(self, message, trace = ''):
    import sys
    e = SIDLLanguage.VisitorException.VisitorException()
    e.setMessage(message)
    if isinstance(trace, list):
      for line in trace: e.addToStackTrace(line.strip())
    elif trace:
      e.addToStackTrace(trace)
    e.addToTrace(__file__, sys._getframe(1).f_lineno, sys._getframe().f_code.co_name)
    raise SIDLLanguage.VisitorException.Exception, e

  def defaultVisit(self, ast):
    try:
      for child in ast.getChildren():
        child.accept(self.__IORself)
    except SIDLLanguage.ASTException.Exception, e:
      self.raiseVisitorException(e.getMessage(), e.getStackTrace().strip())
    return

  def isMarked(self, node, name = ''):
    if not name: name = self.markName
    return node.hasAttribute(name)

  def markNode(self, node, name = ''):
    if not name: name = self.markName
    seen = SIDLLanguage.Attribute.Attribute(SIDL.Loader.createClass('ANL.SIDLCompilerI.Attribute'))
    seen.setName(name)
    node.addAttribute(seen)
    return

  def unmarkNode(self, node, name = ''):
    if not name: name = self.markName
    if node.hasAttribute(name):
      node.deleteAttribute(name)
    return

  def unmarkTree(self, node, name = ''):
    self.unmarkNode(node, name)
    for child in node.getChildren():
      self.unmarkTree(child, name)
    return

  ##########################
  # SECTION: Path Operations
  def getDirectory(self, node, root = '', pathExt = '', makeDirectory = 0, fullExt = 0):
    if pathExt: pathExt = '_'+pathExt
    if fullExt:
      dext = pathExt
    else:
      dext = ''
    directory = node.getIdentifier()+pathExt
    parent    = node.getParent()
    while parent.isInstanceOf('SIDLLanguage.Package'):
      directory = os.path.join(parent.getIdentifier()+dext, directory)
      parent   = parent.getParent()
    if root: directory = os.path.join(root, directory)
    if makeDirectory and not os.path.exists(directory):
      os.makedirs(directory)
    return directory

  def getFile(self, interface, purpose, root = '', extension = '', makeDirectory = 0):
    name    = interface.getIdentifier()
    pathExt = purpose.getPathExtension()
    if pathExt:
      name = name+'_'+pathExt
    if extension:
      name = name+'.'+extension
    return os.path.join(self.getDirectory(interface, root, pathExt, makeDirectory), name)

  def getHeader(self, interface, purpose, root = '', makeDirectory = 0):
    return self.getFile(interface, purpose, root, 'h', makeDirectory)

  def getSource(self, interface, purpose, root = '', makeDirectory = 0):
    return self.getFile(interface, purpose, root, 'c', makeDirectory)
# DO-NOT-DELETE splicer.end(_final)

