# DO-NOT-DELETE splicer.begin(_initial)
import SIDLLanguage.CodePurpose
import SIDLLanguage.Splicer
# DO-NOT-DELETE splicer.end(_initial)

import SIDL.NullIORException
import SIDL.BaseInterface
import SIDL.BaseException
import SIDLLanguage.VisitorException
import SIDLLanguage.Splicer
import SIDLLanguage.Code
import SIDLLanguage.AST
import SIDLLanguage.Specification
import SIDLLanguage.Version
import SIDLLanguage.Package
import SIDLLanguage.Interface
import SIDLLanguage.Class
import SIDLLanguage.Method
import SIDLLanguage.Type
import SIDLLanguage.Enumeration
import SIDLLanguage.Enumerator
import SIDLLanguage.Array
import SIDLLanguage.Parameter
import SIDLLanguage.Comment

# DO-NOT-DELETE splicer.begin(_before_type)
import os
import sys
# DO-NOT-DELETE splicer.end(_before_type)

class FileOutput:
  '''
  // This class outputs all Python code onto the filesystem
  '''
  # All calls to SIDL methods should use __IORself

  def __init__(self, IORself):
    self.__IORself = IORself
    # DO-NOT-DELETE splicer.begin(__init__)
    self.language     = 'Python'
    self.indentString = '  '
    self.defaultRoot  = os.path.join(os.getcwd(), 'test-'+self.language.lower())
    self.roots        = {}
    self.outputSource = 1
    self.outputFiles  = []
    self.codeOutput   = SIDLLanguage.Code.Code(SIDL.Loader.createClass('ANL.SIDLCompilerI.CodeFile'))
    self.splicer      = SIDLLanguage.Splicer.Splicer(SIDL.Loader.createClass('ANL.SplicerI.Splicer'))
    self.stub         = SIDLLanguage.CodePurpose.CodePurpose(SIDL.Loader.createClass('ANL.SIDLCompilerI.Stub'))
    self.IOR          = SIDLLanguage.CodePurpose.CodePurpose(SIDL.Loader.createClass('ANL.SIDLCompilerI.IOR'))
    self.skel         = SIDLLanguage.CodePurpose.CodePurpose(SIDL.Loader.createClass('ANL.SIDLCompilerI.Skeleton'))
    self.impl         = SIDLLanguage.CodePurpose.CodePurpose(SIDL.Loader.createClass('ANL.SIDLCompilerI.Implementation'))
    # DO-NOT-DELETE splicer.end(__init__)

  def getRoot(self, purpose):
    '''
    // Get the root directory for output
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # purpose string
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # string _return
    # DO-NOT-DELETE splicer.begin(getRoot)
    if self.roots.has_key(purpose):
      return self.roots[purpose]
    else:
      return self.defaultRoot
    # DO-NOT-DELETE splicer.end(getRoot)

  def setRoot(self, purpose, path):
    '''
    // Set the root directory for output
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # purpose string
    # path string
    # DO-NOT-DELETE splicer.begin(setRoot)
    self.roots[purpose] = path
    # DO-NOT-DELETE splicer.end(setRoot)

  def getOutputSource(self):
    '''
    // Get the flag determining whether source is output
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # bool _return
    # DO-NOT-DELETE splicer.begin(getOutputSource)
    return self.outputSource
    # DO-NOT-DELETE splicer.end(getOutputSource)

  def setOutputSource(self, outputSource):
    '''
    // Set the flag determining whether source is output
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # outputSource bool
    # DO-NOT-DELETE splicer.begin(setOutputSource)
    self.outputSource = outputSource
    # DO-NOT-DELETE splicer.end(setOutputSource)

  def getSplicer(self):
    '''
    // Retrieve the splicer used for preserving implementation blocks
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # SIDLLanguage.Splicer _return
    # DO-NOT-DELETE splicer.begin(getSplicer)
    # Put your code here...
    return self.splicer
    # DO-NOT-DELETE splicer.end(getSplicer)

  def setSplicer(self, splicer):
    '''
    // Set the splicer used for preserving implementation blocks
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # splicer SIDLLanguage.Splicer
    # DO-NOT-DELETE splicer.begin(setSplicer)
    # Put your code here...
    self.splicer = splicer
    # DO-NOT-DELETE splicer.end(setSplicer)

  def getCodeOutput(self):
    '''
    // Retrieve the Code object used for output
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # SIDLLanguage.Code _return
    # DO-NOT-DELETE splicer.begin(getCodeOutput)
    return self.codeOutput
    # DO-NOT-DELETE splicer.end(getCodeOutput)

  def setCodeOutput(self, output):
    '''
    // Set the Code object used for output
    //   Obviously here we need a persistent object which can output many source blocks
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # output SIDLLanguage.Code
    # DO-NOT-DELETE splicer.begin(setCodeOutput)
    self.codeOutput = output
    # DO-NOT-DELETE splicer.end(setCodeOutput)

  def getOutputFiles(self):
    '''
    // Retrieve all the created files
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # array _return
    # DO-NOT-DELETE splicer.begin(getOutputFiles)
    return self.outputFiles
    # DO-NOT-DELETE splicer.end(getOutputFiles)

  def clearOutputFiles(self):
    '''
    // Clear the list of created files
    '''
    # DO-NOT-DELETE splicer.begin(clearOutputFiles)
    self.outputFiles = []
    # DO-NOT-DELETE splicer.end(clearOutputFiles)

  def getRepository(self):
    '''
    // Retrieve auxilliary ASTs
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # array _return
    # DO-NOT-DELETE splicer.begin(getRepository)
    return []
    # DO-NOT-DELETE splicer.end(getRepository)

  def setRepository(self, repository):
    '''
    // Set auxilliary ASTs
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # repository array
    # DO-NOT-DELETE splicer.begin(setRepository)
    # Put your code here...
    pass
    # DO-NOT-DELETE splicer.end(setRepository)

  def visitAST(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.AST
    # DO-NOT-DELETE splicer.begin(visitAST)
    # Put your code here...
    pass
    # DO-NOT-DELETE splicer.end(visitAST)

  def visitSpecification(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Specification
    # DO-NOT-DELETE splicer.begin(visitSpecification)
    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitSpecification)

  def visitVersion(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Version
    # DO-NOT-DELETE splicer.begin(visitVersion)
    # Put your code here...
    pass
    # DO-NOT-DELETE splicer.end(visitVersion)

  def visitPackage(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Package
    # DO-NOT-DELETE splicer.begin(visitPackage)
    if self.outputSource:
      self.outputPackage(node, self.stub)
      self.outputPackage(node, self.impl)
    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitPackage)

  def visitInterface(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Interface
    # DO-NOT-DELETE splicer.begin(visitInterface)
    if self.outputSource:
      self.outputInterfaceStub(node, self.stub)
    # DO-NOT-DELETE splicer.end(visitInterface)

  def visitClass(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Class
    # DO-NOT-DELETE splicer.begin(visitClass)
    if self.outputSource:
      self.outputInterfaceStub(node, self.stub)
      self.outputClassSkel(node, self.skel)
      self.outputClassImpl(node, self.impl)
    # DO-NOT-DELETE splicer.end(visitClass)

  def visitMethod(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Method
    # DO-NOT-DELETE splicer.begin(visitMethod)
    # Put your code here...
    pass
    # DO-NOT-DELETE splicer.end(visitMethod)

  def visitType(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Type
    # DO-NOT-DELETE splicer.begin(visitType)
    # Put your code here...
    pass
    # DO-NOT-DELETE splicer.end(visitType)

  def visitEnumeration(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Enumeration
    # DO-NOT-DELETE splicer.begin(visitEnumeration)
    if self.outputSource:
      self.outputEnumeration(node, self.stub)
    # DO-NOT-DELETE splicer.end(visitEnumeration)

  def visitEnumerator(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Enumerator
    # DO-NOT-DELETE splicer.begin(visitEnumerator)
    # Put your code here...
    pass
    # DO-NOT-DELETE splicer.end(visitEnumerator)

  def visitArray(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Array
    # DO-NOT-DELETE splicer.begin(visitArray)
    # Put your code here...
    pass
    # DO-NOT-DELETE splicer.end(visitArray)

  def visitParameter(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Parameter
    # DO-NOT-DELETE splicer.begin(visitParameter)
    # Put your code here...
    pass
    # DO-NOT-DELETE splicer.end(visitParameter)

  def visitComment(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Comment
    # DO-NOT-DELETE splicer.begin(visitComment)
    # Put your code here...
    pass
    # DO-NOT-DELETE splicer.end(visitComment)

# DO-NOT-DELETE splicer.begin(_final)
  ##########################
  # Basic Visitor Operations
  def raiseVisitorException(self, message, trace = ''):
    e = SIDLLanguage.VisitorException.VisitorException()
    e.setMessage(message)
    if isinstance(trace, list):
      for line in trace: e.addToStackTrace(line.strip())
    elif trace:
      e.addToStackTrace(trace)
    e.addToTrace(__file__, sys._getframe(1).f_lineno, sys._getframe().f_code.co_name)
    raise SIDLLanguage.VisitorException.Exception, e

  def defaultVisit(self, ast):
    try:
      for child in ast.getChildren():
        child.accept(self.__IORself)
    except SIDLLanguage.ASTException.Exception, e:
      self.raiseVisitorException(e.getMessage(), e.getStackTrace().strip())
    return

  #########################
  # Should go in Code class
  def composeCode(self, parent, node, label, fail = 1, forceBreak = 0, language = None):
    if not language: language = self.language
    if node.hasCodeBlock(language, label):
      return self.composeCodeBlock(parent, node.getCodeBlock(language, label), forceBreak)
    elif fail:
      self.raiseVisitorException('Unable to find code block "'+label+'" in '+node.getFullIdentifier())
    return None

  def composeCodeBlock(self, parent, code, forceBreak = 0):
    self.composeSourceBlock(parent, code.getSource(), forceBreak)
    return code

  def composeSourceBlock(self, parent, source, forceBreak = 0):
    indent = ''
    for i in range(parent.getTabLevel()):
      indent += self.indentString
    if indent and (source.find('\n') >= 0 or forceBreak):
      # Indent start and all newlines
      source = indent+source.replace('\n', '\n'+indent)
      # Remove extra space from the end
      index  = 0
      while source[index-1] == ' ': index -= 1
      if index < 0:
        source = source[:index]
    if forceBreak and not source[-1] == '\n':
      source = source+'\n'
    parent.write(source)
    return

  #########################
  # IOR specific methods
  def getIORName(self, node):
    return node.getFullIdentifier().replace('.', '_')

  ######################
  # Generic code methods
  def hasStaticMethod(self, interface):
    for method in interface.getMethods():
      if method.getStatic():
        return 1
    return 0

  ##################################
  # Path Operations
  def getDirectory(self, node, purpose, root = None, pathExt = '', makeDirectory = 0, fullExt = 0):
    if pathExt: pathExt = '_'+pathExt
    if fullExt:
      dext = pathExt
    else:
      dext = ''
    directory = node.getIdentifier()+pathExt
    parent    = node.getParent()
    while parent.isInstanceOf('SIDLLanguage.Package'):
      directory = os.path.join(parent.getIdentifier()+dext, directory)
      parent   = parent.getParent()
    if root:
      directory = os.path.join(root, directory)
    elif root is None:
      directory = os.path.join(self.getRoot(purpose.getName()), directory)
    if makeDirectory and not os.path.exists(directory):
      os.makedirs(directory)
    return directory

  def getFile(self, interface, node, purpose, root = None, extension = '', makeDirectory = 0, isPython = 0):
    name    = node.getIdentifier()
    pathExt = purpose.getPathExtension()
    if not isPython and purpose.isInstanceOf('ANL.SIDLCompilerI.Stub'):
      name = name+'_Module'
    if pathExt:
      name = name+'_'+pathExt
    if extension:
      name = name+'.'+extension
    return os.path.join(self.getDirectory(interface, purpose, root, pathExt, makeDirectory), name)

  def getHeader(self, interface, node, purpose, root = None, makeDirectory = 0):
    extension = 'h'
    return self.getFile(interface, node, purpose, root, extension, makeDirectory)

  def getSource(self, interface, node, purpose, root = None, makeDirectory = 0, isPython = 0):
    if isPython:
      extension = 'py'
    else:
      extension = 'c'
    return self.getFile(interface, node, purpose, root, extension, makeDirectory, isPython)

  def getPackage(self, interface, purpose, root = None, makeDirectory = 0):
    name    = '__init__.py'
    pathExt = purpose.getPathExtension()
    return os.path.join(self.getDirectory(interface, purpose, root, pathExt, makeDirectory), name)

  ##################################
  # Output Operations
  def outputSplicerBlock(self, f, node, purpose, code, name, defaultCode):
    if purpose.getUseSplicer():
      oldLevel = f.getTabLevel()
      f.setTabLevel(code.getTabLevel())
      lines = self.splicer.splice(node, self.language, name, defaultCode).split('\n')
      f.println(lines[0])
      for line in lines[1:-2]:
        if line == defaultCode:
          f.println(line)
        else:
          f.write(line+'\n')
      f.println(lines[-2])
      f.println(lines[-1])
      f.setTabLevel(oldLevel)
    return

  def outputInclude(self, f, node, purpose):
    f.write('#ifndef included_'+self.getIORName(node)+'_'+purpose.getName()+'\n')
    if purpose.isInstanceOf('ANL.SIDLCompilerI.IOR'):
      f.write('#include "'+self.getHeader(node, node, purpose, root = '')+'"\n')
    else:
      f.write('#include "'+self.getHeader(node.getParent(), node, purpose, root = '')+'"\n')
    f.write('#endif\n')
    return

  def outputDependencyIncludes(self, f, interface, purpose):
    f.write('//\n')
    f.write('// Includes for all method dependencies\n')
    f.write('//\n')
    for dep in interface.getDependencies():
      if dep.isInstanceOf('SIDLLanguage.Enumeration'): continue
      if dep.getFullIdentifier() == 'SIDL.Loader':
        self.outputInclude(f, dep, self.IOR)
      else:
        self.outputInclude(f, dep, self.stub)
    f.write('\n')
    return

  def outputPackage(self, package, purpose):
    if not package.hasCodeBlock(self.language, purpose.getName()+' contents'): return
    filename = self.getPackage(package, purpose, self.getRoot(purpose.getName()), 1)
    print 'Creating '+filename
    self.outputFiles.append(filename)
    self.codeOutput.setLabel(filename)
    self.codeOutput.write(package.getCodeBlock(self.language, purpose.getName()+' contents').getSource())
    self.codeOutput.close()
    if purpose.isInstanceOf('ANL.SIDLCompilerI.Implementation'):
      # Must also put __init__.py into the intermediate parts of the implementation path
      filename = self.getPackage(package, self.stub, self.getRoot(purpose.getName()), 1)
      print 'Creating '+filename
      self.outputFiles.append(filename)
      self.codeOutput.setLabel(filename)
      self.codeOutput.write(package.getCodeBlock(self.language, purpose.getName()+' contents').getSource())
      self.codeOutput.close()
    return

  def outputEnumeration(self, enum, purpose):
    if not enum.hasCodeBlock(self.language, purpose.getName()+' contents'): return
    filename = self.getSource(enum.getParent(), enum, purpose, self.getRoot(purpose.getName()), 1, isPython = 1)
    print 'Creating '+filename
    self.outputFiles.append(filename)
    self.codeOutput.setLabel(filename)
    self.codeOutput.write(enum.getCodeBlock(self.language, purpose.getName()+' contents').getSource())
    self.codeOutput.close()
    return

  def outputInterfaceStub(self, interface, purpose):
    if interface.hasCodeBlock(self.language, purpose.getName()+' header includes'):
      filename = self.getHeader(interface.getParent(), interface, purpose, self.getRoot(purpose.getName()), 1)
      print 'Creating '+filename
      self.outputFiles.append(filename)
      self.codeOutput.setLabel(filename)
      self.composeCode(self.codeOutput, interface, purpose.getName()+' begin header')
      self.composeCode(self.codeOutput, interface, purpose.getName()+' header includes')
      self.composeCode(self.codeOutput, interface, purpose.getName()+' begin extern')
      self.composeCode(self.codeOutput, interface, purpose.getName()+' forward declarations')
      self.composeCode(self.codeOutput, interface, purpose.getName()+' header shared defines')
      self.composeCode(self.codeOutput, interface, purpose.getName()+' header client defines')
      self.composeCode(self.codeOutput, interface, purpose.getName()+' internal declarations')
      self.composeCode(self.codeOutput, interface, purpose.getName()+' end extern')
      self.composeCode(self.codeOutput, interface, purpose.getName()+' end header')
      self.codeOutput.close()

    if interface.hasCodeBlock(self.language, purpose.getName()+' source includes'):
      filename = self.getSource(interface.getParent(), interface, purpose, self.getRoot(purpose.getName()), 1)
      print 'Creating '+filename
      self.outputFiles.append(filename)
      self.codeOutput.setLabel(filename)
      self.composeCode(self.codeOutput, interface, purpose.getName()+' source defines')
      self.composeCode(self.codeOutput, interface, purpose.getName()+' source includes')
      self.outputInclude(self.codeOutput, interface, purpose)
      self.outputInclude(self.codeOutput, interface, self.IOR)
      self.outputDependencyIncludes(self.codeOutput, interface, purpose)
      self.codeOutput.println('')
      self.composeCode(self.codeOutput, interface, purpose.getName()+' epv definition')
      for method in interface.getMethods():
        self.composeCode(self.codeOutput, interface, purpose.getName()+' method definition begin '+method.getIdentifier())
        self.composeCode(self.codeOutput, interface, purpose.getName()+' method definition end '+method.getIdentifier())
      # Special methods
      if purpose.isInstanceOf('ANL.SIDLCompilerI.Stub'):
        self.composeCode(self.codeOutput, interface, purpose.getName()+' method definition begin '+interface.getIdentifier())
        self.composeCode(self.codeOutput, interface, purpose.getName()+' method definition end '+interface.getIdentifier())
      elif purpose.isInstanceOf('ANL.SIDLCompilerI.Skeleton'):
        pass
      elif purpose.isInstanceOf('ANL.SIDLCompilerI.Implementation'):
        pass
      self.composeCode(self.codeOutput, interface, purpose.getName()+' static virtual table')
      self.composeCode(self.codeOutput, interface, purpose.getName()+' virtual table')
      self.composeCode(self.codeOutput, interface, purpose.getName()+' method definition wrapper')
      self.composeCode(self.codeOutput, interface, purpose.getName()+' method definition weakRef')
      self.composeCode(self.codeOutput, interface, purpose.getName()+' method definition deref')
      self.composeCode(self.codeOutput, interface, purpose.getName()+' method definition newRef')
      self.composeCode(self.codeOutput, interface, purpose.getName()+' method definition addRef')
      self.composeCode(self.codeOutput, interface, purpose.getName()+' method definition convert')
      self.composeCode(self.codeOutput, interface, purpose.getName()+' method definition convertToElement')
      self.composeCode(self.codeOutput, interface, purpose.getName()+' method definition convertToArray')
      self.composeCode(self.codeOutput, interface, purpose.getName()+' method definition convertFromElement')
      self.composeCode(self.codeOutput, interface, purpose.getName()+' method definition convertFromArray')
      self.composeCode(self.codeOutput, interface, purpose.getName()+' method definition destroyArray')
      self.composeCode(self.codeOutput, interface, purpose.getName()+' method definition initModule')
      self.codeOutput.close()
    return

  def outputClassSkel(self, sclass, purpose):
    if not sclass.hasCodeBlock(self.language, purpose.getName()+' source includes'): return

    filename = self.getSource(sclass.getParent(), sclass, purpose, self.getRoot(purpose.getName()), 1)
    print 'Creating '+filename
    self.outputFiles.append(filename)
    self.codeOutput.setLabel(filename)
    self.composeCode(self.codeOutput, sclass, purpose.getName()+' source includes')
    self.outputInclude(self.codeOutput, sclass, self.IOR)
    self.outputInclude(self.codeOutput, sclass, self.stub)
    self.outputDependencyIncludes(self.codeOutput, sclass, self.stub)
    self.composeCode(self.codeOutput, sclass, purpose.getName()+' method definition initImplementation')
    self.composeCode(self.codeOutput, sclass, purpose.getName()+' method definition _importModules')
    for method in sclass.getImplementedMethods():
      self.composeCode(self.codeOutput, sclass, purpose.getName()+' method definition begin '+method.getIdentifier(), fail = 0)
      self.composeCode(self.codeOutput, sclass, purpose.getName()+' method definition end '+method.getIdentifier(), fail = 0)
    self.composeCode(self.codeOutput, sclass, purpose.getName()+' method definition _ctor')
    self.composeCode(self.codeOutput, sclass, purpose.getName()+' method definition _dtor')
    self.composeCode(self.codeOutput, sclass, purpose.getName()+' method definition _set_epv')
    self.composeCode(self.codeOutput, sclass, purpose.getName()+' method definition _set_sepv', 0)
    self.codeOutput.close()
    return

  def outputClassImpl(self, sclass, purpose):
    if not sclass.hasCodeBlock(self.language, purpose.getName()+' class begin'): return

    filename = self.getSource(sclass.getParent(), sclass, purpose, self.getRoot(purpose.getName()), 1, isPython = 1)
    if purpose.getUseSplicer():
      self.splicer.parse(filename, self.language, sclass)
    print 'Creating '+filename
    self.outputFiles.append(filename)
    self.codeOutput.setLabel(filename)
    self.outputSplicerBlock(self.codeOutput, sclass, purpose, self.codeOutput, '_initial', 'pass')
    for dep in sclass.getDependencies():
      if not dep.getFullIdentifier() == 'SIDL.Loader':
        self.codeOutput.println('import '+dep.getFullIdentifier())
    self.codeOutput.println('')
    if self.hasStaticMethod(sclass):
      self.outputSplicerBlock(self.codeOutput, sclass, purpose, self.codeOutput, '_before_static', 'pass')
      for method in sclass.getImplementedMethods():
        label = purpose.getName()+' method definition begin '+method.getIdentifier()
        if method.getStatic() and sclass.hasCodeBlock(self.language, label):
          self.composeCode(self.codeOutput, sclass, label, fail = 0)
          self.codeOutput.increaseTabLevel()
          self.outputSplicerBlock(self.codeOutput, sclass, purpose, self.codeOutput, method.getIdentifier(), 'pass')
          self.codeOutput.decreaseTabLevel()
    self.outputSplicerBlock(self.codeOutput, sclass, purpose, self.codeOutput, '_before_type', 'pass')
    self.composeCode(self.codeOutput, sclass, purpose.getName()+' class begin')
    self.codeOutput.increaseTabLevel()
    self.composeCode(self.codeOutput, sclass, purpose.getName()+' method definition begin __init__')
    self.codeOutput.increaseTabLevel()
    self.outputSplicerBlock(self.codeOutput, sclass, purpose, self.codeOutput, '__init__', 'pass')
    self.codeOutput.decreaseTabLevel()

    for method in sclass.getImplementedMethods():
      label = purpose.getName()+' method definition begin '+method.getIdentifier()
      if not method.getStatic() and sclass.hasCodeBlock(self.language, label):
        self.composeCode(self.codeOutput, sclass, purpose.getName()+' method definition begin '+method.getIdentifier(), fail = 0)
        self.codeOutput.increaseTabLevel()
        self.outputSplicerBlock(self.codeOutput, sclass, purpose, self.codeOutput, method.getIdentifier(), 'pass')
        self.codeOutput.decreaseTabLevel()
    self.codeOutput.decreaseTabLevel()
    self.outputSplicerBlock(self.codeOutput, sclass, purpose, self.codeOutput, '_final', 'pass')
    self.codeOutput.close()
    return
# DO-NOT-DELETE splicer.end(_final)

