# DO-NOT-DELETE splicer.begin(_initial)
pass
# DO-NOT-DELETE splicer.end(_initial)

import SIDL.NullIORException
import SIDL.BaseException
import SIDLLanguage.Package
import SIDLLanguage.VisitorException
import SIDL.BaseInterface
import SIDLLanguage.AST
import SIDLLanguage.Specification
import SIDLLanguage.Version
import SIDLLanguage.Interface
import SIDLLanguage.Class
import SIDLLanguage.Method
import SIDLLanguage.Type
import SIDLLanguage.Enumeration
import SIDLLanguage.Enumerator
import SIDLLanguage.Array
import SIDLLanguage.Parameter
import SIDLLanguage.Comment

# DO-NOT-DELETE splicer.begin(_before_type)
pass
# DO-NOT-DELETE splicer.end(_before_type)

class PackageLocator:
  '''
  // A PackageLocator detects the presence of a package in the tree, and returns the last occurence
  '''
  # All calls to SIDL methods should use __IORself

  def __init__(self, IORself):
    self.__IORself = IORself
    # DO-NOT-DELETE splicer.begin(__init__)
    self.identifier = ''
    self.package    = None
    # DO-NOT-DELETE splicer.end(__init__)

  def setPackageIdentifier(self, identifier):
    '''
    // Set the search package full identifier
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # identifier string
    # DO-NOT-DELETE splicer.begin(setPackageIdentifier)
    self.identifier = identifier
    self.package    = None
    # DO-NOT-DELETE splicer.end(setPackageIdentifier)

  def getPackageIdentifier(self):
    '''
    // Retrieve the search package full identifier
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # string _return
    # DO-NOT-DELETE splicer.begin(getPackageIdentifier)
    return self.identifier
    # DO-NOT-DELETE splicer.end(getPackageIdentifier)

  def hasPackage(self):
    '''
    // Retrieve the flag indicating whether the package was found
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # bool _return
    # DO-NOT-DELETE splicer.begin(hasPackage)
    return not self.package is None
    # DO-NOT-DELETE splicer.end(hasPackage)

  def getPackage(self):
    '''
    // Retrieve the package if it was found, otherwise throw an exception
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # SIDLLanguage.Package _return
    # DO-NOT-DELETE splicer.begin(getPackage)
    if self.package is None:
      self.raiseVisitorException('Package '+self.identifier+' not found')
    return self.package
    # DO-NOT-DELETE splicer.end(getPackage)

  def visitPackage(self, node):
    '''
    // Visit a Package
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Package
    # DO-NOT-DELETE splicer.begin(visitPackage)
    if node.getFullIdentifier() == self.identifier:
      self.package = node
    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitPackage)

# DO-NOT-DELETE splicer.begin(_final)
  def raiseVisitorException(self, message, trace = ''):
    e = SIDLLanguage.VisitorException.VisitorException()
    e.setMessage(message)
    if isinstance(trace, list):
      for line in trace: e.addToStackTrace(line.strip())
    elif trace:
      e.addToStackTrace(trace)
    e.addToTrace(__file__, sys._getframe(1).f_lineno, sys._getframe().f_code.co_name)
    raise SIDLLanguage.VisitorException.Exception, e

  def defaultVisit(self, ast):
    try:
      for child in ast.getChildren():
        child.accept(self.__IORself)
    except SIDLLanguage.ASTException.Exception, e:
      self.raiseVisitorException(e.getMessage(), e.getStackTrace().strip())
    return
# DO-NOT-DELETE splicer.end(_final)

