#include "SIDLObjA.h"
#include "SIDLPyArrays.h"
#define  NO_IMPORT_ARRAY
#include "Numeric/arrayobject.h"

/* The SIDL Runtime function which spawns the interpreter */
void SIDL_Python_Init(void);

#ifndef included_ANL_SIDL_Query_PackageLocator_IOR
#include "ANL/SIDL/Query/PackageLocator_IOR/PackageLocator_IOR.h"
#endif
#ifndef included_ANL_SIDL_Query_PackageLocator_stub
#include "ANL/SIDL/Query/PackageLocator_Module.h"
#endif
//
// Includes for all method dependencies
//
#ifndef included_SIDL_Loader_IOR
#include "SIDL/Loader_IOR/Loader_IOR.h"
#endif
#ifndef included_SIDL_NullIORException_stub
#include "SIDL/NullIORException_Module.h"
#endif
#ifndef included_SIDL_BaseException_stub
#include "SIDL/BaseException_Module.h"
#endif
#ifndef included_SIDLLanguage_Package_stub
#include "SIDLLanguage/Package_Module.h"
#endif
#ifndef included_SIDLLanguage_VisitorException_stub
#include "SIDLLanguage/VisitorException_Module.h"
#endif
#ifndef included_SIDL_BaseInterface_stub
#include "SIDL/BaseInterface_Module.h"
#endif
#ifndef included_SIDLLanguage_AST_stub
#include "SIDLLanguage/AST_Module.h"
#endif
#ifndef included_SIDLLanguage_Specification_stub
#include "SIDLLanguage/Specification_Module.h"
#endif
#ifndef included_SIDLLanguage_Version_stub
#include "SIDLLanguage/Version_Module.h"
#endif
#ifndef included_SIDLLanguage_Interface_stub
#include "SIDLLanguage/Interface_Module.h"
#endif
#ifndef included_SIDLLanguage_Class_stub
#include "SIDLLanguage/Class_Module.h"
#endif
#ifndef included_SIDLLanguage_Method_stub
#include "SIDLLanguage/Method_Module.h"
#endif
#ifndef included_SIDLLanguage_Type_stub
#include "SIDLLanguage/Type_Module.h"
#endif
#ifndef included_SIDLLanguage_Enumeration_stub
#include "SIDLLanguage/Enumeration_Module.h"
#endif
#ifndef included_SIDLLanguage_Enumerator_stub
#include "SIDLLanguage/Enumerator_Module.h"
#endif
#ifndef included_SIDLLanguage_Array_stub
#include "SIDLLanguage/Array_Module.h"
#endif
#ifndef included_SIDLLanguage_Parameter_stub
#include "SIDLLanguage/Parameter_Module.h"
#endif
#ifndef included_SIDLLanguage_Comment_stub
#include "SIDLLanguage/Comment_Module.h"
#endif

static void
initImplementation(void) {
  static int notInitialized = 1;

  if (notInitialized) {
    notInitialized = 0;
    SIDL_Python_Init();
  }
}

static void _importModules(void) {
  static int _import = 1;
  PyObject *module;

  if (_import) {
    _import = 0;
    module = PyImport_ImportModule((char *) "user");
    module = PyImport_ImportModule((char *) "importer");
    if (PyErr_Occurred()) {PyErr_Print();}
    import_SIDLObjA();
    import_SIDLPyArrays();
    ANL_SIDL_Query_PackageLocator__import();
    SIDL_NullIORException__import();
    SIDL_BaseException__import();
    SIDLLanguage_Package__import();
    SIDLLanguage_VisitorException__import();
    SIDL_BaseInterface__import();
    SIDLLanguage_AST__import();
    SIDLLanguage_Specification__import();
    SIDLLanguage_Version__import();
    SIDLLanguage_Interface__import();
    SIDLLanguage_Class__import();
    SIDLLanguage_Method__import();
    SIDLLanguage_Type__import();
    SIDLLanguage_Enumeration__import();
    SIDLLanguage_Enumerator__import();
    SIDLLanguage_Array__import();
    SIDLLanguage_Parameter__import();
    SIDLLanguage_Comment__import();
  }
}

static void
ANL_SIDL_Query_PackageLocator_setPackageIdentifier_skel(
  struct ANL_SIDL_Query_PackageLocator__object *self,
  /*in*/ const char * identifier,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "(z)",
    identifier
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for ANL.SIDL.Query.PackageLocator.setPackageIdentifier");
    return;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "setPackageIdentifier");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  _okay = (_return_value == Py_None);
  if (!_okay) {
    printf("Invalid return from void function setPackageIdentifier\n");
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return;
}

static char *
ANL_SIDL_Query_PackageLocator_getPackageIdentifier_skel(
  struct ANL_SIDL_Query_PackageLocator__object *self,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  char * _result = NULL;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "()"
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for ANL.SIDL.Query.PackageLocator.getPackageIdentifier");
    return _result;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "getPackageIdentifier");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  if (_return_value) {
    PyObject *_tmp = PyTuple_New(1);
  
    PyTuple_SET_ITEM(_tmp, 0, _return_value);
    _return_value = _tmp;
    _okay   = PyArg_ParseTuple(_return_value,
      (char *) "z",
      &_result
    );
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  _result = (_result ? strcpy(malloc(strlen(_result)+1), _result) : NULL);
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return _result;
}

static SIDL_bool
ANL_SIDL_Query_PackageLocator_hasPackage_skel(
  struct ANL_SIDL_Query_PackageLocator__object *self,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  SIDL_bool _result = FALSE;
  int _local__result;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "()"
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for ANL.SIDL.Query.PackageLocator.hasPackage");
    return _result;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "hasPackage");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  if (_return_value) {
    PyObject *_tmp = PyTuple_New(1);
  
    PyTuple_SET_ITEM(_tmp, 0, _return_value);
    _return_value = _tmp;
    _okay   = PyArg_ParseTuple(_return_value,
      (char *) "i",
      &_local__result
    );
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  _result = (_local__result ? TRUE : FALSE);
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return _result;
}

static struct SIDLLanguage_Package__object *
ANL_SIDL_Query_PackageLocator_getPackage_skel(
  struct ANL_SIDL_Query_PackageLocator__object *self,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  struct SIDLLanguage_Package__object * _result;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "()"
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for ANL.SIDL.Query.PackageLocator.getPackage");
    return _result;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "getPackage");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return _result;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDLLanguage_VisitorException__type)) {
      struct SIDLLanguage_VisitorException__object *_local_exception;
  
      (void) SIDLLanguage_VisitorException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDLLanguage_VisitorException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  if (_return_value) {
    PyObject *_tmp = PyTuple_New(1);
  
    PyTuple_SET_ITEM(_tmp, 0, _return_value);
    _return_value = _tmp;
    _okay   = PyArg_ParseTuple(_return_value,
      (char *) "O&",
      (void *) SIDLLanguage_Package__convert, &_result
    );
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return _result;
}

static void
ANL_SIDL_Query_PackageLocator_visitPackage_skel(
  struct ANL_SIDL_Query_PackageLocator__object *self,
  /*in*/ struct SIDLLanguage_Package__object * node,
  struct SIDL_BaseException__object **_exception)
{
  /* Return value setup */
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_return_value;
  int       _okay = 0;
  /* Pack arguments for dispatch to implementation */
  _args = Py_BuildValue(
     (char *) "(O&)",
    (void *) SIDLLanguage_Package__newRef, node
  );
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  /* Exception handling setup */
  *_exception = 0;
  /* Dispatch to implementation */
  _context = (self ? self->d_data : NULL);
  if (!_context) {
    fprintf(stderr, "Null implementation object for ANL.SIDL.Query.PackageLocator.visitPackage");
    return;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "visitPackage");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  _return_value = PyObject_CallObject(_pfunc, _args);
  Py_DECREF(_pfunc);
  /* Exception handling cleanup */
  if (PyErr_Occurred()) {
    PyObject *_exType;
    PyObject *_exValue;
    PyObject *_exTrace;
  
    PyErr_Fetch(&_exType, &_exValue, &_exTrace);
    if (PyErr_GivenExceptionMatches(_exType, SIDLLanguage_VisitorException__type)) {
      struct SIDLLanguage_VisitorException__object *_local_exception;
  
      (void) SIDLLanguage_VisitorException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDLLanguage_VisitorException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else if (PyErr_GivenExceptionMatches(_exType, SIDL_BaseException__type)) {
      struct SIDL_BaseException__object *_local_exception;
  
      (void) SIDL_BaseException__convert(_exValue, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
    } else {
      PyObject *module         = PyImport_ImportModule((char *) "SIDL.BaseException");
      PyObject *modDict        = PyModule_GetDict(module);
      PyObject *msg            = PyObject_Str(_exValue);
      char     *message        = PyString_AsString(msg);
      PyObject *_new_exception = PyObject_CallFunction(PyDict_GetItemString(modDict, (char *) "BaseException"), (char *) "");
      struct SIDL_BaseException__object *_local_exception;
  
      PyObject_CallMethod(_new_exception, (char *) "setMessage", (char *) "s", message);
      Py_XDECREF(msg);
      (void) SIDL_BaseException__convert(_new_exception, &_local_exception);
      if (_local_exception) {
        SIDL_BaseException__addRef(_local_exception);
        *_exception = (struct SIDL_BaseException__object *) _local_exception;
      }
      Py_XDECREF(_new_exception);
      Py_XDECREF(module);
    }
    Py_XDECREF(_exType);
    Py_XDECREF(_exValue);
    Py_XDECREF(_exTrace);
    PyErr_Clear();
  }
  /* Unpack arguments from dispatch to implementation */
  _okay = (_return_value == Py_None);
  if (!_okay) {
    printf("Invalid return from void function visitPackage\n");
  }
  Py_DECREF(_args);
  if (PyErr_Occurred()) {
  PyErr_Print();
  }
  /* Return value cleanup */
  if (_return_value && _return_value != Py_None) {Py_DECREF(_return_value);}
  return;
}

static void ANL_SIDL_Query_PackageLocator__ctor_skel(struct ANL_SIDL_Query_PackageLocator__object *self) {
  PyObject *_context;
  PyObject *_pfunc;
  PyObject *_args;
  PyObject *_result;

  _context = PyImport_ImportModule((char *) "ANL.SIDL.Query_impl.PackageLocator_impl");
  if (!_context) {
    if (PyErr_Occurred()) PyErr_Print();
    return;
  }
  _pfunc = PyObject_GetAttrString(_context, (char *) "PackageLocator");
  if (!_pfunc) {
    if (PyErr_Occurred()) PyErr_Print();
    Py_DECREF(_context);
    return;
  }
  _args = Py_BuildValue((char *) "(O&)", (void *) ANL_SIDL_Query_PackageLocator__weakRef, self);
  if (!_args) {
    if (PyErr_Occurred()) PyErr_Print();
    Py_DECREF(_pfunc);
    Py_DECREF(_context);
    return;
  }
  _result = PyInstance_New(_pfunc, _args, NULL);
  if (_result) {
    self->d_data = _result;
  } else {
    if (PyErr_Occurred()) PyErr_Print();
  }
  Py_DECREF(_args);
  Py_DECREF(_pfunc);
  Py_DECREF(_context);
}

static void ANL_SIDL_Query_PackageLocator__dtor_skel(struct ANL_SIDL_Query_PackageLocator__object *self) {
  /* Remove only reference to Python object */
  Py_XDECREF(((PyObject *) self->d_data));
}

void ANL_SIDL_Query_PackageLocator__set_epv(struct ANL_SIDL_Query_PackageLocator__epv * epv);
void
ANL_SIDL_Query_PackageLocator__set_epv(struct ANL_SIDL_Query_PackageLocator__epv * epv) {
  initImplementation();
  _importModules();
  /* Initialize constructor and destructor */
  epv->f__ctor = ANL_SIDL_Query_PackageLocator__ctor_skel;
  epv->f__dtor = ANL_SIDL_Query_PackageLocator__dtor_skel;
  /* Initialize user methods */
  epv->f_setPackageIdentifier = ANL_SIDL_Query_PackageLocator_setPackageIdentifier_skel;
  epv->f_getPackageIdentifier = ANL_SIDL_Query_PackageLocator_getPackageIdentifier_skel;
  epv->f_hasPackage = ANL_SIDL_Query_PackageLocator_hasPackage_skel;
  epv->f_getPackage = ANL_SIDL_Query_PackageLocator_getPackage_skel;
  epv->f_visitPackage = ANL_SIDL_Query_PackageLocator_visitPackage_skel;
}

