# DO-NOT-DELETE splicer.begin(_initial)
# Put your code here...
pass
# DO-NOT-DELETE splicer.end(_initial)

import SIDL.NullIORException
import SIDL.BaseInterface
import SIDLLanguage.AST
import SIDL.BaseException
import SIDLLanguage.VisitorException
import SIDLLanguage.Specification
import SIDLLanguage.Version
import SIDLLanguage.Package
import SIDLLanguage.Interface
import SIDLLanguage.Class
import SIDLLanguage.Method
import SIDLLanguage.Type
import SIDLLanguage.Enumeration
import SIDLLanguage.Enumerator
import SIDLLanguage.Array
import SIDLLanguage.Parameter
import SIDLLanguage.Comment

# DO-NOT-DELETE splicer.begin(_before_type)
# Put your code here...
pass
# DO-NOT-DELETE splicer.end(_before_type)

class DependencyAnalyzer:
  '''
  // Calculates dependencies for AST nodes
  '''
  # All calls to SIDL methods should use __IORself

  def __init__(self, IORself):
    self.__IORself = IORself
    # DO-NOT-DELETE splicer.begin(__init__)
    # We could cut down on recursion by putting in a flag that indicated the node had been visited already
    self.repository = []
    self.markName   = 'dependencyMark'
    # DO-NOT-DELETE splicer.end(__init__)

  def getRepository(self):
    '''
    // Retrieve auxilliary ASTs
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # array _return
    # DO-NOT-DELETE splicer.begin(getRepository)
    return self.repository
    # DO-NOT-DELETE splicer.end(getRepository)

  def setRepository(self, repository):
    '''
    // Set auxilliary ASTs
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # repository array
    # DO-NOT-DELETE splicer.begin(setRepository)
    self.repository = repository
    # DO-NOT-DELETE splicer.end(setRepository)

  def visitAST(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.AST
    # DO-NOT-DELETE splicer.begin(visitAST)
    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitAST)

  def visitSpecification(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Specification
    # DO-NOT-DELETE splicer.begin(visitSpecification)
    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitSpecification)

  def visitVersion(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Version
    # DO-NOT-DELETE splicer.begin(visitVersion)
    # Put your code here...
    pass
    # DO-NOT-DELETE splicer.end(visitVersion)

  def visitPackage(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Package
    # DO-NOT-DELETE splicer.begin(visitPackage)
    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitPackage)

  def visitInterface(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Interface
    # DO-NOT-DELETE splicer.begin(visitInterface)
    if self.isMarked(node): return
    self.markNode(node)

    self.defaultVisit(node)

    node.addMethods(node.getChildren())

    for interface in node.getParents():
      interface.accept(self.__IORself)
      node.addMethods(interface.getMethods())

    for method in node.getMethods():
      for dependency in method.getDependencies():
        if not self.isBase(node) or not dependency.getFullIdentifier() == 'SIDL.NullIORException':
          node.addDependency(dependency)
    # DO-NOT-DELETE splicer.end(visitInterface)

  def visitClass(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Class
    # DO-NOT-DELETE splicer.begin(visitClass)
    if self.isMarked(node): return
    self.markNode(node)

    self.defaultVisit(node)

    node.addMethods(node.getChildren())
    node.addImplementedMethods(node.getChildren())

    for sclass in node.getParents():
      sclass.accept(self.__IORself)
      node.addMethods(sclass.getMethods())

    classMethods = node.getMethods()
    for interface in node.getInterfaces():
      interface.accept(self.__IORself)
      node.addMethods(interface.getMethods())
      if not node.getAbstract():
        implMethods = []
        for method in interface.getMethods():
          same = 0
          for m in classMethods:
            if m.getIdentifier() == method.getIdentifier():
              same = 1
              break
          if not same: implMethods.append(method)
        node.addImplementedMethods(implMethods)

    for method in node.getMethods():
      for dependency in method.getDependencies():
        if not self.isBase(node) or not dependency.getFullIdentifier() == 'SIDL.NullIORException':
          node.addDependency(dependency)
    # DO-NOT-DELETE splicer.end(visitClass)

  def visitMethod(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Method
    # DO-NOT-DELETE splicer.begin(visitMethod)
    self.addTypeDependency(node, node.getReturnType())
    for child in node.getChildren():
      self.addTypeDependency(node, SIDLLanguage.Parameter.Parameter(child).getType())
    for exception in node.getExceptions():
      node.addDependency(exception)
    # DO-NOT-DELETE splicer.end(visitMethod)

  def visitType(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Type
    # DO-NOT-DELETE splicer.begin(visitType)
    # Put your code here...
    pass
    # DO-NOT-DELETE splicer.end(visitType)

  def visitEnumeration(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Enumeration
    # DO-NOT-DELETE splicer.begin(visitEnumeration)
    # Put your code here...
    pass
    # DO-NOT-DELETE splicer.end(visitEnumeration)

  def visitEnumerator(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Enumerator
    # DO-NOT-DELETE splicer.begin(visitEnumerator)
    # Put your code here...
    pass
    # DO-NOT-DELETE splicer.end(visitEnumerator)

  def visitArray(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Array
    # DO-NOT-DELETE splicer.begin(visitArray)
    # Put your code here...
    pass
    # DO-NOT-DELETE splicer.end(visitArray)

  def visitParameter(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Parameter
    # DO-NOT-DELETE splicer.begin(visitParameter)
    # Put your code here...
    pass
    # DO-NOT-DELETE splicer.end(visitParameter)

  def visitComment(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Comment
    # DO-NOT-DELETE splicer.begin(visitComment)
    # Put your code here...
    pass
    # DO-NOT-DELETE splicer.end(visitComment)

# DO-NOT-DELETE splicer.begin(_final)
  def defaultVisit(self, ast):
    for child in ast.getChildren():
      child.accept(self.__IORself)
    return

  def addTypeDependency(self, node, type):
    if type.isInstanceOf('SIDLLanguage.Array'):
      array = SIDLLanguage.Array.Array(type)
      self.addTypeDependency(node, array.getType())
    elif not type.getBaseType():
      node.addDependency(type)
    return

  def isMarked(self, node):
    return node.hasAttribute(self.markName)

  def markNode(self, node):
    seen = SIDLLanguage.Attribute.Attribute(SIDL.Loader.createClass('ANL.SIDLCompilerI.Attribute'))
    seen.setName(self.markName)
    node.addAttribute(seen)
    return

  def isBase(self, interface):
    return interface.getFullIdentifier() in ['SIDL.BaseInterface', 'SIDL.BaseClass', 'SIDL.BaseException', 'SIDL.NullIORException', 'SIDL.Loader', 'SIDL.DLL']
# DO-NOT-DELETE splicer.end(_final)

