# DO-NOT-DELETE splicer.begin(_initial)
pass
# DO-NOT-DELETE splicer.end(_initial)

import SIDL.NullIORException
import SIDL.BaseInterface
import SIDLLanguage.AST
import SIDL.BaseException
import SIDLLanguage.VisitorException
import SIDLLanguage.Specification
import SIDLLanguage.Version
import SIDLLanguage.Package
import SIDLLanguage.Interface
import SIDLLanguage.Class
import SIDLLanguage.Method
import SIDLLanguage.Type
import SIDLLanguage.Enumeration
import SIDLLanguage.Enumerator
import SIDLLanguage.Array
import SIDLLanguage.Parameter
import SIDLLanguage.Comment

# DO-NOT-DELETE splicer.begin(_before_type)
pass
# DO-NOT-DELETE splicer.end(_before_type)

class InitConstructor:
  '''
  // Add constructor and initializer methods to each Interface
  '''
  # All calls to SIDL methods should use __IORself

  def __init__(self, IORself):
    self.__IORself = IORself
    # DO-NOT-DELETE splicer.begin(__init__)
    self.markName = 'initConstructorMark'
    # DO-NOT-DELETE splicer.end(__init__)

  def getRepository(self):
    '''
    // Retrieve auxilliary ASTs
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # array _return
    # DO-NOT-DELETE splicer.begin(getRepository)
    return []
    # DO-NOT-DELETE splicer.end(getRepository)

  def setRepository(self, repository):
    '''
    // Set auxilliary ASTs
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # repository array
    # DO-NOT-DELETE splicer.begin(setRepository)
    return
    # DO-NOT-DELETE splicer.end(setRepository)

  def visitAST(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.AST
    # DO-NOT-DELETE splicer.begin(visitAST)
    return
    # DO-NOT-DELETE splicer.end(visitAST)

  def visitSpecification(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Specification
    # DO-NOT-DELETE splicer.begin(visitSpecification)
    if self.isMarked(node): return
    self.markNode(node)

    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitSpecification)

  def visitVersion(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Version
    # DO-NOT-DELETE splicer.begin(visitVersion)
    return
    # DO-NOT-DELETE splicer.end(visitVersion)

  def visitPackage(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Package
    # DO-NOT-DELETE splicer.begin(visitPackage)
    if self.isMarked(node): return
    self.markNode(node)

    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitPackage)

  def visitInterface(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Interface
    # DO-NOT-DELETE splicer.begin(visitInterface)
    if self.isMarked(node): return
    self.markNode(node)

    methods = [self.createInitMethod(node), self.createCastMethod(node)]
    node.addChildren(methods)
    node.addMethods(methods)
    # DO-NOT-DELETE splicer.end(visitInterface)

  def visitClass(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Class
    # DO-NOT-DELETE splicer.begin(visitClass)
    self.visitInterface(node)

    methods = [self.createCtorMethod(node), self.createDtorMethod(node)]
    node.addChildren(methods)
    node.addImplementedMethods(methods)
    # DO-NOT-DELETE splicer.end(visitClass)

  def visitMethod(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Method
    # DO-NOT-DELETE splicer.begin(visitMethod)
    return
    # DO-NOT-DELETE splicer.end(visitMethod)

  def visitType(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Type
    # DO-NOT-DELETE splicer.begin(visitType)
    return
    # DO-NOT-DELETE splicer.end(visitType)

  def visitEnumeration(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Enumeration
    # DO-NOT-DELETE splicer.begin(visitEnumeration)
    return
    # DO-NOT-DELETE splicer.end(visitEnumeration)

  def visitEnumerator(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Enumerator
    # DO-NOT-DELETE splicer.begin(visitEnumerator)
    return
    # DO-NOT-DELETE splicer.end(visitEnumerator)

  def visitArray(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Array
    # DO-NOT-DELETE splicer.begin(visitArray)
    return
    # DO-NOT-DELETE splicer.end(visitArray)

  def visitParameter(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Parameter
    # DO-NOT-DELETE splicer.begin(visitParameter)
    return
    # DO-NOT-DELETE splicer.end(visitParameter)

  def visitComment(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Comment
    # DO-NOT-DELETE splicer.begin(visitComment)
    return
    # DO-NOT-DELETE splicer.end(visitComment)

# DO-NOT-DELETE splicer.begin(_final)
  ###################################
  # SECTION: Basic Visitor Operations
  def raiseVisitorException(self, message, trace = ''):
    e = SIDLLanguage.VisitorException.VisitorException()
    e.setMessage(message)
    if isinstance(trace, list):
      for line in trace: e.addToStackTrace(line.strip())
    elif trace:
      e.addToStackTrace(trace)
    e.addToTrace(__file__, sys._getframe(1).f_lineno, sys._getframe().f_code.co_name)
    raise SIDLLanguage.VisitorException.Exception, e

  def defaultVisit(self, ast):
    try:
      for child in ast.getChildren():
        child.accept(self.__IORself)
    except SIDLLanguage.ASTException.Exception, e:
      self.raiseVisitorException(e.getMessage(), e.getStackTrace().strip())
    return

  def isMarked(self, node, name = ''):
    if not name: name = self.markName
    return node.hasAttribute(name)

  def markNode(self, node, name = ''):
    if not name: name = self.markName
    seen = SIDLLanguage.Attribute.Attribute(SIDL.Loader.createClass('ANL.SIDLCompilerI.Attribute'))
    seen.setName(name)
    node.addAttribute(seen)
    return

  def unmarkNode(self, node, name = ''):
    if not name: name = self.markName
    if node.hasAttribute(name):
      node.deleteAttribute(name)
    return

  def unmarkNetwork(self, node, name = ''):
    self.unmarkNode(node, name)
    for interface in node.getParents():
      self.unmarkNetwork(interface, name)
    if node.isInstanceOf('SIDLLanguage.Class'):
      for interface in SIDLLanguage.Class.Class(node).getInterfaces():
        self.unmarkNetwork(interface, name)
    return

  #####################################
  # SECTION: Method Creation Operations
  def createInitMethod(self, interface):
    '''Creates module initialization method:
         static void Initialization_<interface>(void)'''
    method = SIDLLanguage.Method.Method(SIDL.Loader.createClass('ANL.SIDLCompilerI.Method'))
    returnType = SIDLLanguage.Type.Type(SIDL.Loader.createClass('ANL.SIDLCompilerI.Type'))
    returnType.setIdentifier('void')
    returnType.setBaseType(1)
    returnType.setParent(method)
    method.setReturnType(returnType)
    method.setIdentifier('Initialization_'+interface.getIdentifier())
    method.setAbstract(0)
    method.setStatic(1)
    method.setInternal(1)
    comment = SIDLLanguage.Comment.Comment(SIDL.Loader.createClass('ANL.SIDLCompilerI.Comment'))
    comment.setComment('Module initialization method for '+interface.getFullIdentifier())
    method.addComments([comment])
    return method

  def createCastMethod(self, interface):
    '''Creates constructor/cast method:
         static <interface> <interface>(optional <interface> obj)'''
    method = SIDLLanguage.Method.Method(SIDL.Loader.createClass('ANL.SIDLCompilerI.Method'))
    method.setReturnType(interface)
    method.setIdentifier(interface.getIdentifier())
    method.setAbstract(0)
    method.setStatic(1)
    method.setInternal(1)
    parameter = SIDLLanguage.Parameter.Parameter(SIDL.Loader.createClass('ANL.SIDLCompilerI.Parameter'))
    parameter.setIdentifier('obj')
    parameter.setType(interface)
    parameter.setAccessMode(SIDLLanguage.ParameterAccessMode.IN)
    parameter.setRequired(0)
    method.addChildren([parameter])
    comment = SIDLLanguage.Comment.Comment(SIDL.Loader.createClass('ANL.SIDLCompilerI.Comment'))
    comment.setComment('Constructor and/or cast method for '+interface.getFullIdentifier())
    method.addComments([comment])
    return method

  def createCtorMethod(self, sclass):
    '''Creates class constructor method:
         static <class> self _ctor(void)'''
    method = SIDLLanguage.Method.Method(SIDL.Loader.createClass('ANL.SIDLCompilerI.Method'))
    method.setReturnType(sclass)
    method.setIdentifier('_ctor')
    method.setAbstract(0)
    method.setStatic(0)
    method.setInternal(1)
    comment = SIDLLanguage.Comment.Comment(SIDL.Loader.createClass('ANL.SIDLCompilerI.Comment'))
    comment.setComment('Class constructor method for '+sclass.getFullIdentifier())
    method.addComments([comment])
    return method

  def createDtorMethod(self, sclass):
    '''Creates class destructor method:
         static void _dtor(<class> self)'''
    method = SIDLLanguage.Method.Method(SIDL.Loader.createClass('ANL.SIDLCompilerI.Method'))
    returnType = SIDLLanguage.Type.Type(SIDL.Loader.createClass('ANL.SIDLCompilerI.Type'))
    returnType.setIdentifier('void')
    returnType.setBaseType(1)
    returnType.setParent(method)
    method.setReturnType(returnType)
    method.setIdentifier('_dtor')
    method.setAbstract(0)
    method.setStatic(0)
    method.setInternal(1)
    comment = SIDLLanguage.Comment.Comment(SIDL.Loader.createClass('ANL.SIDLCompilerI.Comment'))
    comment.setComment('Class destructor method for '+sclass.getFullIdentifier())
    method.addComments([comment])
    return method
# DO-NOT-DELETE splicer.end(_final)

