#ifndef included_ANL_SplicerI_TransferMode_IOR
#define included_ANL_SplicerI_TransferMode_IOR

#ifndef NULL
#define NULL 0
#endif

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#ifdef __cplusplus
extern "C" {
#endif

/* Symbol ANL.SplicerI.TransferMode */

/* Forward declarations for array structure and external classes and interfaces */
struct ANL_SplicerI_TransferMode__array;

#ifndef included_SIDL_header_h
#include "SIDL_header.h"
#endif

enum ANL_SplicerI_TransferMode__enum {
  SCANDAL_TO_BABEL = 0,
  BABEL_TO_SCANDAL = 1
};

/* Create a dense array of the given dimension with specified index bounds */
/*   This array owns and manages its data */
/*   All object pointers are initialized to NULL */
struct ANL_SplicerI_TransferMode__array * ANL_SplicerI_TransferMode__iorarray_create(
  int32_t dimen,
  const int32_t lower[],
  const int32_t upper[]);

/* Create an array using user-provided memory */
struct ANL_SplicerI_TransferMode__array * ANL_SplicerI_TransferMode__iorarray_borrow(
  enum ANL_SplicerI_TransferMode__enum* firstElement,
  int32_t dimen,
  const int32_t lower[],
  const int32_t upper[],
  const int32_t stride[]);

/* Destroy the array (NULL arrays are ignored) */
void ANL_SplicerI_TransferMode__iorarray_destroy(
  struct ANL_SplicerI_TransferMode__array *array);

/* Return the number of dimensions in the array */
/*   If the array pointer is NULL, zero is returned */
int32_t ANL_SplicerI_TransferMode__iorarray_dimen(
  const struct ANL_SplicerI_TransferMode__array *array);

/* Return the lower bound on dimension ind */
/*   If the array pointer is NULL or ind is not a valid dimension, zero is returned */
int32_t ANL_SplicerI_TransferMode__iorarray_lower(
  const struct ANL_SplicerI_TransferMode__array *array,
  int32_t ind);

/* Return the upper bound on dimension ind */
/*   If the array pointer is NULL or ind is not a valid dimension, -1 is returned */
int32_t ANL_SplicerI_TransferMode__iorarray_upper(
  const struct ANL_SplicerI_TransferMode__array *array,
  int32_t ind);

/* Get an element of a multi-dimensional array */
/* This will use the indices provided up to the actual dimension of the array, ignoring extra indices */
/* If the return value is non-NULL, the client owns one reference to the object/interface */
/* The client must decrement the reference count when done with the reference */
enum ANL_SplicerI_TransferMode__enum ANL_SplicerI_TransferMode__iorarray_get(
  const struct ANL_SplicerI_TransferMode__array *array,
  const int32_t indices[]);

/* get an element of a multi-dimensional array */
/* This will use the indices provided up to the actual dimension of the array, ignoring extra indices */
/* If the return value is non-NULL, the client owns one reference to the object/interface */
/* The client must decrement the reference count when done with the reference */
enum ANL_SplicerI_TransferMode__enum ANL_SplicerI_TransferMode__iorarray_get4(
  const struct ANL_SplicerI_TransferMode__array *array,
  int32_t i1,
  int32_t i2,
  int32_t i3,
  int32_t i4);

/* Set an element of a multi-dimensional array */
/* This will use the indices provided up to the actual dimension of the array, ignoring extra indices */
/* If the incoming value is non-NULL, this function will increment the reference code of the object/interface */
/* If it is overwriting a non-NULL pointer, the reference count of the object/interface being overwritten will be decremented */
void ANL_SplicerI_TransferMode__iorarray_set(
  struct ANL_SplicerI_TransferMode__array *array,
  const int32_t indices[],
  enum ANL_SplicerI_TransferMode__enum value);

/* set an element of a multi-dimensional array */
/* This will use the indices provided up to the actual dimension of the array, ignoring extra indices */
/* If the incoming value is non-NULL, this function will increment the reference code of the object/interface */
/* If it is overwriting a non-NULL pointer, the reference count of the object/interface being overwritten will be decremented */
void ANL_SplicerI_TransferMode__iorarray_set4(
  struct ANL_SplicerI_TransferMode__array *array,
  int32_t i1,
  int32_t i2,
  int32_t i3,
  int32_t i4,
  enum ANL_SplicerI_TransferMode__enum value);

#ifdef __cplusplus
}
#endif

#endif /* included_ANL_SplicerI_TransferMode_IOR */
