# DO-NOT-DELETE splicer.begin(_initial)
pass
# DO-NOT-DELETE splicer.end(_initial)

import SIDL.NullIORException
import SIDL.BaseInterface
import SIDLLanguage.AST
import SIDL.BaseException
import SIDLLanguage.VisitorException
import SIDLLanguage.Specification
import SIDLLanguage.Version
import SIDLLanguage.Package
import SIDLLanguage.Interface
import SIDLLanguage.Class
import SIDLLanguage.Method
import SIDLLanguage.Type
import SIDLLanguage.Enumeration
import SIDLLanguage.Enumerator
import SIDLLanguage.Array
import SIDLLanguage.Parameter
import SIDLLanguage.Comment

# DO-NOT-DELETE splicer.begin(_before_type)
import SIDL.Loader
# DO-NOT-DELETE splicer.end(_before_type)

class Templater:
  '''
  // Replaces dummy types with specified base types
  '''
  # All calls to SIDL methods should use __IORself

  def __init__(self, IORself):
    self.__IORself = IORself
    # DO-NOT-DELETE splicer.begin(__init__)
    self.markName = 'templaterMark'
    # Used in Method walk
    self.templateParameter = None
    self.templateType      = None
    # DO-NOT-DELETE splicer.end(__init__)

  def getRepository(self):
    '''
    // Retrieve auxilliary ASTs
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # array _return
    # DO-NOT-DELETE splicer.begin(getRepository)
    return []
    # DO-NOT-DELETE splicer.end(getRepository)

  def setRepository(self, repository):
    '''
    // Set auxilliary ASTs
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # repository array
    # DO-NOT-DELETE splicer.begin(setRepository)
    return
    # DO-NOT-DELETE splicer.end(setRepository)

  def visitAST(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.AST
    # DO-NOT-DELETE splicer.begin(visitAST)
    return
    # DO-NOT-DELETE splicer.end(visitAST)

  def visitSpecification(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Specification
    # DO-NOT-DELETE splicer.begin(visitSpecification)
    if self.isMarked(node): return
    self.markNode(node)

    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitSpecification)

  def visitVersion(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Version
    # DO-NOT-DELETE splicer.begin(visitVersion)
    return
    # DO-NOT-DELETE splicer.end(visitVersion)

  def visitPackage(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Package
    # DO-NOT-DELETE splicer.begin(visitPackage)
    if self.isMarked(node): return
    self.markNode(node)

    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitPackage)

  def visitInterface(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Interface
    # DO-NOT-DELETE splicer.begin(visitInterface)
    if self.isMarked(node): return
    self.markNode(node)

    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitInterface)

  def visitClass(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Class
    # DO-NOT-DELETE splicer.begin(visitClass)
    if self.isMarked(node): return
    self.markNode(node)

    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitClass)

  def visitMethod(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Method
    # DO-NOT-DELETE splicer.begin(visitMethod)
    if self.isMarked(node): return
    self.markNode(node)
    templateParameters = node.getTemplateIdentifiers()
    if len(templateParameters) == 0: return
    parent   = node.getParent()
    children = list(parent.getChildren())
    #print '  Templating method '+node.getFullIdentifier()

    if not (self.templateParameter is None and self.templateType is None):
      self.raiseVisitorException('Error in '+node.getFullIdentifier()+': Template iteration already in progress')
    for templateParameter in templateParameters:
      self.templateParameter = templateParameter
      for typeName in ['char', 'int', 'double', 'dcomplex']:
        self.templateType = SIDLLanguage.Type.Type(SIDL.Loader.createClass('ANL.SIDLCompilerI.Type'))
        self.templateType.setIdentifier(typeName)
        self.templateType.setBaseType(1)

        # Make a copy of this method
        method = self.copyMethod(node)
        method.setIdentifier(node.getIdentifier()+'_'+typeName)
        method.setParent(node)

        method.getReturnType().accept(self.__IORself)
        self.defaultVisit(method)
        children.append(method)
    # Remove this node from the tree
    children.remove(node)
    parent.setChildren(children)
    # Terminate template iteration
    self.templateParameter = None
    self.templateType      = None
    # DO-NOT-DELETE splicer.end(visitMethod)

  def visitType(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Type
    # DO-NOT-DELETE splicer.begin(visitType)
    if node.getIdentifier() == self.templateParameter:
      node.setIdentifier(self.templateType.getIdentifier())
      node.setBaseType(self.templateType.getBaseType())
      #print 'Replaced '+self.templateParameter+' by '+node.getIdentifier()
    # DO-NOT-DELETE splicer.end(visitType)

  def visitEnumeration(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Enumeration
    # DO-NOT-DELETE splicer.begin(visitEnumeration)
    return
    # DO-NOT-DELETE splicer.end(visitEnumeration)

  def visitEnumerator(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Enumerator
    # DO-NOT-DELETE splicer.begin(visitEnumerator)
    return
    # DO-NOT-DELETE splicer.end(visitEnumerator)

  def visitArray(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Array
    # DO-NOT-DELETE splicer.begin(visitArray)
    node.getType().accept(self.__IORself)
    # DO-NOT-DELETE splicer.end(visitArray)

  def visitParameter(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Parameter
    # DO-NOT-DELETE splicer.begin(visitParameter)
    node.getType().accept(self.__IORself)
    # DO-NOT-DELETE splicer.end(visitParameter)

  def visitComment(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Comment
    # DO-NOT-DELETE splicer.begin(visitComment)
    return
    # DO-NOT-DELETE splicer.end(visitComment)

# DO-NOT-DELETE splicer.begin(_final)
  ##########################
  # Basic Visitor Operations
  def raiseVisitorException(self, message, trace = ''):
    import sys

    e = SIDLLanguage.VisitorException.VisitorException()
    e.setMessage(message)
    if isinstance(trace, list):
      for line in trace: e.addToStackTrace(line.strip())
    elif trace:
      e.addToStackTrace(trace)
    e.addToTrace(__file__, sys._getframe(1).f_lineno, sys._getframe().f_code.co_name)
    raise SIDLLanguage.VisitorException.Exception, e

  def defaultVisit(self, node):
    try:
      for child in node.getChildren():
        child.accept(self.__IORself)
    except SIDLLanguage.ASTException.Exception, e:
      self.raiseVisitorException('In '+str(node.getIdentifier())+': '+e.getMessage(), e.getStackTrace().strip())
    return

  def isMarked(self, node, name = ''):
    if not name: name = self.markName
    return node.hasAttribute(name)

  def markNode(self, node, name = ''):
    if not name: name = self.markName
    seen = SIDLLanguage.Attribute.Attribute(SIDL.Loader.createClass('ANL.SIDLCompilerI.Attribute'))
    seen.setName(name)
    node.addAttribute(seen)
    return

  def unmarkNode(self, node, name = ''):
    if not name: name = self.markName
    if node.hasAttribute(name):
      node.deleteAttribute(name)
    return

  #######################
  # Templating Operations
  def copyMethod(self, m):
    method = SIDLLanguage.Method.Method(SIDL.Loader.createClass('ANL.SIDLCompilerI.Method'))
    method.setIdentifier(m.getIdentifier())
    method.setStatic(m.getStatic())
    method.setFinal(m.getFinal())
    method.setAbstract(m.getAbstract())
    method.setInternal(m.getInternal())

    method.setReturnType(self.copyType(m.getReturnType()))
    method.getReturnType().setParent(method)
    method.setExceptions(map(self.copyException, m.getExceptions()))
    map(lambda e: e.setParent(method), method.getExceptions())
    method.setChildren(map(self.copyParameter, m.getChildren()))
    return method

  def copyException(self, e):
    exception = SIDLLanguage.Class.Class(SIDL.Loader.createClass('ANL.SIDLCompilerI.Class'))
    exception.setIdentifier(e.getIdentifier())
    exception.setBaseType(e.getBaseType())
    return exception

  def copyParameter(self, p):
    p = SIDLLanguage.Parameter.Parameter(p)
    parameter = SIDLLanguage.Parameter.Parameter(SIDL.Loader.createClass('ANL.SIDLCompilerI.Parameter'))
    parameter.setIdentifier(p.getIdentifier())
    parameter.setType(self.copyType(p.getType()))
    parameter.getType().setParent(parameter)
    parameter.setAccessMode(p.getAccessMode())
    parameter.setRequired(p.getRequired())
    parameter.setCopy(p.getCopy())
    return parameter

  def copyType(self, t):
    if t.isInstanceOf('ANL.SIDLCompilerI.Array'):
      t = SIDLLanguage.Array.Array(t)
      type = SIDLLanguage.Array.Array(SIDL.Loader.createClass('ANL.SIDLCompilerI.Array'))
      type.setIdentifier(t.getIdentifier())
      type.setBaseType(t.getBaseType())
      type.setType(self.copyType(t.getType()))
      type.getType().setParent(type)
    else:
      type = SIDLLanguage.Type.Type(SIDL.Loader.createClass('ANL.SIDLCompilerI.Type'))
      type.setIdentifier(t.getIdentifier())
      type.setBaseType(t.getBaseType())
    return type
# DO-NOT-DELETE splicer.end(_final)

