# DO-NOT-DELETE splicer.begin(_initial)
# Put your code here...
pass
# DO-NOT-DELETE splicer.end(_initial)

import SIDL.NullIORException
import SIDL.BaseInterface
import SIDLLanguage.AST
import SIDL.BaseException
import SIDLLanguage.VisitorException
import SIDLLanguage.Specification
import SIDLLanguage.Version
import SIDLLanguage.Package
import SIDLLanguage.Interface
import SIDLLanguage.Class
import SIDLLanguage.Method
import SIDLLanguage.Type
import SIDLLanguage.Enumeration
import SIDLLanguage.Enumerator
import SIDLLanguage.Array
import SIDLLanguage.Parameter
import SIDLLanguage.Comment

# DO-NOT-DELETE splicer.begin(_before_type)
import re
import sys
# DO-NOT-DELETE splicer.end(_before_type)

class ASTVerifier:
  '''
  // Calculates dependencies for AST nodes
  '''
  # All calls to SIDL methods should use __IORself

  def __init__(self, IORself):
    self.__IORself = IORself
    # DO-NOT-DELETE splicer.begin(__init__)
    self.sidlTypes = ["bool", "char", "dcomplex", "double", "fcomplex", "float", "int", "long", "opaque", "string", "void"]
    # DO-NOT-DELETE splicer.end(__init__)

  def getRepository(self):
    '''
    // Retrieve auxilliary ASTs
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # array _return
    # DO-NOT-DELETE splicer.begin(getRepository)
    return []
    # DO-NOT-DELETE splicer.end(getRepository)

  def setRepository(self, repository):
    '''
    // Set auxilliary ASTs
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # repository array
    # DO-NOT-DELETE splicer.begin(setRepository)
    # Put your code here...
    pass
    # DO-NOT-DELETE splicer.end(setRepository)

  def visitAST(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.AST
    # DO-NOT-DELETE splicer.begin(visitAST)
    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitAST)

  def visitSpecification(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Specification
    # DO-NOT-DELETE splicer.begin(visitSpecification)
    if node.getParent():
      self.raiseVisitorException('Specification must be at the root')
    for child in node.getChildren():
      if not child.isInstanceOf('SIDLLanguage.Package') and not child.isInstanceOf('SIDLLanguage.Version'):
        self.raiseVisitorException('Illegal child for Specification node')
    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitSpecification)

  def visitVersion(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Version
    # DO-NOT-DELETE splicer.begin(visitVersion)
    if not node.getParent().isInstanceOf('SIDLLanguage.Specification'):
      self.raiseVisitorException('Illegal parent for Version node')
    if not re.match(r'\d+(\.\d+)*', node.getNumber()):
      self.raiseVisitorException('Invalid version number '+node.getNumber())
    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitVersion)

  def visitPackage(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Package
    # DO-NOT-DELETE splicer.begin(visitPackage)
    if not node.getParent().isInstanceOf('SIDLLanguage.Specification') and not node.getParent().isInstanceOf('SIDLLanguage.Package'):
      self.raiseVisitorException('Illegal parent for Package node')
    for child in node.getChildren():
      if not child.isInstanceOf('SIDLLanguage.Package') and not child.isInstanceOf('SIDLLanguage.Interface') and not child.isInstanceOf('SIDLLanguage.Class') and not child.isInstanceOf('SIDLLanguage.Enumeration'):
        self.raiseVisitorException('Illegal child for Package node: '+str(child.getIdentifier()))
    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitPackage)

  def visitInterface(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Interface
    # DO-NOT-DELETE splicer.begin(visitInterface)
    if not node.getParent().isInstanceOf('SIDLLanguage.Package'):
      self.raiseVisitorException('Illegal parent for Interface node')
    if node.getBaseType():
      self.raiseVisitorException('Interface cannot be base type')
    for parent in node.getParents():
      if not parent.isInstanceOf('SIDLLanguage.Interface'):
        self.raiseVisitorException('Illegal superinterface for Interface node')
    for child in node.getChildren():
      if not child.isInstanceOf('SIDLLanguage.Method'):
        self.raiseVisitorException('Illegal child for Interface node')
    for method in node.getMethods():
      if method.getStatic():
        self.raiseVisitorException('Interfaces may not contain static methods')
      if method.getAbstract():
        self.raiseVisitorException('Interfaces may not contain abstract methods')
    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitInterface)

  def visitClass(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Class
    # DO-NOT-DELETE splicer.begin(visitClass)
    if not node.getParent().isInstanceOf('SIDLLanguage.Package'):
      self.raiseVisitorException('Illegal parent for Class node')
    if node.getBaseType():
      self.raiseVisitorException('Class cannot be base type')
    for parent in node.getParents():
      if not parent.isInstanceOf('SIDLLanguage.Class'):
        self.raiseVisitorException('Illegal superclass for Class node')
    for interface in node.getInterfaces():
      if not interface.isInstanceOf('SIDLLanguage.Interface'):
        self.raiseVisitorException('Illegal interface for Class node')
    for method in node.getMethods():
      if not method.isInstanceOf('SIDLLanguage.Method'):
        self.raiseVisitorException('Illegal method for Class node')
    isAbstract = 0
    for child in node.getChildren():
      if not child.isInstanceOf('SIDLLanguage.Method'):
        self.raiseVisitorException('Illegal child for Class node')
      method     = SIDLLanguage.Method.Method(child)
      isAbstract = method.getAbstract() or isAbstract
    if isAbstract and not node.getAbstract():
      self.raiseVisitorException('Concrete class cannot have abstract methods')
    if not isAbstract and node.getAbstract():
      self.raiseVisitorException('Abstract class must have abstract methods')
    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitClass)

  def visitMethod(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Method
    # DO-NOT-DELETE splicer.begin(visitMethod)
    if not node.getParent().isInstanceOf('SIDLLanguage.Interface') and not node.getParent().isInstanceOf('SIDLLanguage.Class'):
      self.raiseVisitorException('Illegal parent for Method node')
    for exception in node.getExceptions():
      if not exception.isInstanceOf('SIDLLanguage.Class'):
        self.raiseVisitorException('Illegal exception for Method node')
    for child in node.getChildren():
      if not child.isInstanceOf('SIDLLanguage.Parameter'):
        self.raiseVisitorException('Illegal child for Method node')
    if node.getAbstract() and node.getStatic():
      self.raiseVisitorException('A method cannot be both abstract and static')
    if node.getAbstract() and node.getFinal():
      self.raiseVisitorException('A method cannot be both abstract and final')
    self.visitType(node.getReturnType())
    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitMethod)

  def visitType(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Type
    # DO-NOT-DELETE splicer.begin(visitType)
    if node.getBaseType() and not node.getIdentifier() in self.sidlTypes:
      self.raiseVisitorException('Invalid base type '+node.getIdentifier())
    # DO-NOT-DELETE splicer.end(visitType)

  def visitEnumeration(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Enumeration
    # DO-NOT-DELETE splicer.begin(visitEnumeration)
    if not node.getParent().isInstanceOf('SIDLLanguage.Package'):
      self.raiseVisitorException('Illegal parent for Enumeration node')
    values = []
    for child in node.getChildren():
      if not child.isInstanceOf('SIDLLanguage.Enumerator'):
        self.raiseVisitorException('Illegal child for Enumeration node')
      enumerator = SIDLLanguage.Enumerator.Enumerator(child)
      value      = enumerator.getValue()
      if value in values:
        self.raiseVisitorException('Enumeration contains duplicate value '+str(value)+' for '+enumerator.getIdentifier())
      values.append(value)
    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitEnumeration)

  def visitEnumerator(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Enumerator
    # DO-NOT-DELETE splicer.begin(visitEnumerator)
    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitEnumerator)

  def visitArray(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Array
    # DO-NOT-DELETE splicer.begin(visitArray)
    if node.getDimension() < 0:
      self.raiseVisitorException('Arrays cannot have negative dimension')
    self.visitType(node.getType())
    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitArray)

  def visitParameter(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Parameter
    # DO-NOT-DELETE splicer.begin(visitParameter)
    if not node.getParent().isInstanceOf('SIDLLanguage.Method'):
      self.raiseVisitorException('Illegal parent for Parameter node')
    if node.getCopy():
      self.raiseVisitorException('The "copy" flag is currently not implemented for parameters')
    self.visitType(node.getType())
    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitParameter)

  def visitComment(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Comment
    # DO-NOT-DELETE splicer.begin(visitComment)
    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitComment)

# DO-NOT-DELETE splicer.begin(_final)
  def raiseVisitorException(self, message, trace = ''):
    e = SIDLLanguage.VisitorException.VisitorException()
    e.setMessage(message)
    if isinstance(trace, list):
      for line in trace: e.addToStackTrace(line.strip())
    elif trace:
      e.addToStackTrace(trace)
    e.addToTrace(__file__, sys._getframe(1).f_lineno, sys._getframe().f_code.co_name)
    raise SIDLLanguage.VisitorException.Exception, e

  def defaultVisit(self, ast):
    try:
      for child in ast.getChildren():
        child.accept(self.__IORself)
    except SIDLLanguage.ASTException.Exception, e:
      self.raiseVisitorException(e.getMessage(), e.getStackTrace().strip())
    return
# DO-NOT-DELETE splicer.end(_final)

