#ifndef included_ANL_SIDL_PrettyPrinter_IOR
#include "ANL/SIDL/PrettyPrinter_IOR/PrettyPrinter_IOR.h"
#endif

/* Static variables for managing EPV initialization */
static int s_method_initialized = 0;

static struct ANL_SIDL_PrettyPrinter__epv s_new__anl_sidl_prettyprinter;

static struct SIDL_BaseClass__epv s_new__sidl_baseclass;
static struct SIDL_BaseClass__epv * s_old__sidl_baseclass;

static struct SIDL_BaseInterface__epv s_new__sidl_baseinterface;
static struct SIDL_BaseInterface__epv * s_old__sidl_baseinterface;

static struct SIDLLanguage_FileOutput__epv s_new__sidllanguage_fileoutput;

static struct SIDLLanguage_Visitor__epv s_new__sidllanguage_visitor;

/* Declare EPV routines defined in the skeleton */
extern void ANL_SIDL_PrettyPrinter__set_epv(struct ANL_SIDL_PrettyPrinter__epv * epv);

/* CAST: dynamic type casting support */
static void *ANL_SIDL_PrettyPrinter__cast_ior(
  struct ANL_SIDL_PrettyPrinter__object *self,
  const char *name)
{
  void *cast = NULL;
  /* We are guaranteed here that the first member in any IOR is a BaseInterface object */
  struct ANL_SIDL_PrettyPrinter__object *s0 = ((struct SIDL_BaseInterface__object *) self)->d_object;
  struct SIDL_BaseClass__object *s1 = &s0->d_sidl_baseclass;

  if (!strcmp(name, "ANL.SIDL.PrettyPrinter")) {
    cast = (void *) s0;
  } else if (!strcmp(name, "SIDL.BaseClass")) {
    cast = (void *) s1;
  } else if (!strcmp(name, "SIDL.BaseInterface")) {
    cast = (void *) &s1->d_sidl_baseinterface;
  } else if (!strcmp(name, "SIDLLanguage.FileOutput")) {
    cast = (void *) &s0->d_sidllanguage_fileoutput;
  } else if (!strcmp(name, "SIDLLanguage.Visitor")) {
    cast = (void *) &s0->d_sidllanguage_visitor;
  }

  return cast;
}

/* DELETE: call destructor and free object memory */
static void ANL_SIDL_PrettyPrinter__delete(
  struct ANL_SIDL_PrettyPrinter__object *self)
{
  struct ANL_SIDL_PrettyPrinter__object * s0 = self->d_epv->f__cast_ior(self, "ANL.SIDL.PrettyPrinter");
  ANL_SIDL_PrettyPrinter__fini(s0);
  memset((void *) s0, 0, sizeof(struct ANL_SIDL_PrettyPrinter__object));
  free((void *) s0);
}

/* INIT_EPV: create method entry point vector (EPV) structure */
static void ANL_SIDL_PrettyPrinter__init_epv(
  struct ANL_SIDL_PrettyPrinter__object *self)
{
  struct ANL_SIDL_PrettyPrinter__object *s0 = self;
  struct SIDL_BaseClass__object *s1 = &s0->d_sidl_baseclass;

  struct ANL_SIDL_PrettyPrinter__epv * epv = &s_new__anl_sidl_prettyprinter;
  struct SIDL_BaseClass__epv * e0 = &s_new__sidl_baseclass;
  struct SIDL_BaseInterface__epv * e1 = &s_new__sidl_baseinterface;
  struct SIDLLanguage_FileOutput__epv * e2 = &s_new__sidllanguage_fileoutput;
  struct SIDLLanguage_Visitor__epv * e3 = &s_new__sidllanguage_visitor;

  s_old__sidl_baseinterface = s1->d_sidl_baseinterface.d_epv;
  s_old__sidl_baseclass = s1->d_epv;

  epv->f__cast_ior = ANL_SIDL_PrettyPrinter__cast_ior;
  epv->f__delete = ANL_SIDL_PrettyPrinter__delete;
  epv->f__ctor = NULL;
  epv->f__dtor = NULL;
  epv->f_setFilename = NULL;
  epv->f_addReference = (void (*)(struct ANL_SIDL_PrettyPrinter__object *)) s1->d_epv->f_addReference;
  epv->f_deleteReference = (void (*)(struct ANL_SIDL_PrettyPrinter__object *)) s1->d_epv->f_deleteReference;
  epv->f_isSame = (SIDL_bool (*)(struct ANL_SIDL_PrettyPrinter__object *, struct SIDL_BaseInterface__object *)) s1->d_epv->f_isSame;
  epv->f_queryInterface = (struct SIDL_BaseInterface__object * (*)(struct ANL_SIDL_PrettyPrinter__object *, const char *)) s1->d_epv->f_queryInterface;
  epv->f_isInstanceOf = (SIDL_bool (*)(struct ANL_SIDL_PrettyPrinter__object *, const char *)) s1->d_epv->f_isInstanceOf;
  epv->f_getRoot = NULL;
  epv->f_setRoot = NULL;
  epv->f_getOutputSource = NULL;
  epv->f_setOutputSource = NULL;
  epv->f_getSplicer = NULL;
  epv->f_setSplicer = NULL;
  epv->f_getCodeOutput = NULL;
  epv->f_setCodeOutput = NULL;
  epv->f_getOutputFiles = NULL;
  epv->f_clearOutputFiles = NULL;
  epv->f_getRepository = NULL;
  epv->f_setRepository = NULL;
  epv->f_visitAST = NULL;
  epv->f_visitSpecification = NULL;
  epv->f_visitVersion = NULL;
  epv->f_visitPackage = NULL;
  epv->f_visitInterface = NULL;
  epv->f_visitClass = NULL;
  epv->f_visitMethod = NULL;
  epv->f_visitType = NULL;
  epv->f_visitEnumeration = NULL;
  epv->f_visitEnumerator = NULL;
  epv->f_visitArray = NULL;
  epv->f_visitParameter = NULL;
  epv->f_visitComment = NULL;

  ANL_SIDL_PrettyPrinter__set_epv(epv);

  e0->f__cast_ior = (void *(*)(struct SIDL_BaseClass__object *, const char *)) epv->f__cast_ior;
  e0->f__delete = (void (*)(struct SIDL_BaseClass__object *)) epv->f__delete;
  e0->f_addReference = (void (*)(struct SIDL_BaseClass__object *)) epv->f_addReference;
  e0->f_deleteReference = (void (*)(struct SIDL_BaseClass__object *)) epv->f_deleteReference;
  e0->f_isSame = (SIDL_bool (*)(struct SIDL_BaseClass__object *, struct SIDL_BaseInterface__object *)) epv->f_isSame;
  e0->f_queryInterface = (struct SIDL_BaseInterface__object * (*)(struct SIDL_BaseClass__object *, const char *)) epv->f_queryInterface;
  e0->f_isInstanceOf = (SIDL_bool (*)(struct SIDL_BaseClass__object *, const char *)) epv->f_isInstanceOf;

  e1->f__cast_ior = (void *(*)(void *, const char *)) epv->f__cast_ior;
  e1->f__delete = (void (*)(void *)) epv->f__delete;
  e1->f_addReference = (void (*)(void *)) epv->f_addReference;
  e1->f_deleteReference = (void (*)(void *)) epv->f_deleteReference;
  e1->f_isSame = (SIDL_bool (*)(void *, struct SIDL_BaseInterface__object *)) epv->f_isSame;
  e1->f_queryInterface = (struct SIDL_BaseInterface__object * (*)(void *, const char *)) epv->f_queryInterface;
  e1->f_isInstanceOf = (SIDL_bool (*)(void *, const char *)) epv->f_isInstanceOf;

  e2->f__cast_ior = (void *(*)(void *, const char *)) epv->f__cast_ior;
  e2->f__delete = (void (*)(void *)) epv->f__delete;
  e2->f_getRoot = (char * (*)(void *, const char *, struct SIDL_BaseException__object **)) epv->f_getRoot;
  e2->f_setRoot = (void (*)(void *, const char *, const char *, struct SIDL_BaseException__object **)) epv->f_setRoot;
  e2->f_getOutputSource = (SIDL_bool (*)(void *, struct SIDL_BaseException__object **)) epv->f_getOutputSource;
  e2->f_setOutputSource = (void (*)(void *, SIDL_bool, struct SIDL_BaseException__object **)) epv->f_setOutputSource;
  e2->f_getSplicer = (struct SIDLLanguage_Splicer__object * (*)(void *, struct SIDL_BaseException__object **)) epv->f_getSplicer;
  e2->f_setSplicer = (void (*)(void *, struct SIDLLanguage_Splicer__object *, struct SIDL_BaseException__object **)) epv->f_setSplicer;
  e2->f_getCodeOutput = (struct SIDLLanguage_Code__object * (*)(void *, struct SIDL_BaseException__object **)) epv->f_getCodeOutput;
  e2->f_setCodeOutput = (void (*)(void *, struct SIDLLanguage_Code__object *, struct SIDL_BaseException__object **)) epv->f_setCodeOutput;
  e2->f_getOutputFiles = (struct SIDL_string__array * (*)(void *, struct SIDL_BaseException__object **)) epv->f_getOutputFiles;
  e2->f_clearOutputFiles = (void (*)(void *, struct SIDL_BaseException__object **)) epv->f_clearOutputFiles;
  e2->f_getRepository = (struct SIDLLanguage_AST__array * (*)(void *, struct SIDL_BaseException__object **)) epv->f_getRepository;
  e2->f_setRepository = (void (*)(void *, struct SIDLLanguage_AST__array *, struct SIDL_BaseException__object **)) epv->f_setRepository;
  e2->f_visitAST = (void (*)(void *, struct SIDLLanguage_AST__object *, struct SIDL_BaseException__object **)) epv->f_visitAST;
  e2->f_visitSpecification = (void (*)(void *, struct SIDLLanguage_Specification__object *, struct SIDL_BaseException__object **)) epv->f_visitSpecification;
  e2->f_visitVersion = (void (*)(void *, struct SIDLLanguage_Version__object *, struct SIDL_BaseException__object **)) epv->f_visitVersion;
  e2->f_visitPackage = (void (*)(void *, struct SIDLLanguage_Package__object *, struct SIDL_BaseException__object **)) epv->f_visitPackage;
  e2->f_visitInterface = (void (*)(void *, struct SIDLLanguage_Interface__object *, struct SIDL_BaseException__object **)) epv->f_visitInterface;
  e2->f_visitClass = (void (*)(void *, struct SIDLLanguage_Class__object *, struct SIDL_BaseException__object **)) epv->f_visitClass;
  e2->f_visitMethod = (void (*)(void *, struct SIDLLanguage_Method__object *, struct SIDL_BaseException__object **)) epv->f_visitMethod;
  e2->f_visitType = (void (*)(void *, struct SIDLLanguage_Type__object *, struct SIDL_BaseException__object **)) epv->f_visitType;
  e2->f_visitEnumeration = (void (*)(void *, struct SIDLLanguage_Enumeration__object *, struct SIDL_BaseException__object **)) epv->f_visitEnumeration;
  e2->f_visitEnumerator = (void (*)(void *, struct SIDLLanguage_Enumerator__object *, struct SIDL_BaseException__object **)) epv->f_visitEnumerator;
  e2->f_visitArray = (void (*)(void *, struct SIDLLanguage_Array__object *, struct SIDL_BaseException__object **)) epv->f_visitArray;
  e2->f_visitParameter = (void (*)(void *, struct SIDLLanguage_Parameter__object *, struct SIDL_BaseException__object **)) epv->f_visitParameter;
  e2->f_visitComment = (void (*)(void *, struct SIDLLanguage_Comment__object *, struct SIDL_BaseException__object **)) epv->f_visitComment;
  e2->f_addReference = (void (*)(void *)) epv->f_addReference;
  e2->f_deleteReference = (void (*)(void *)) epv->f_deleteReference;
  e2->f_isSame = (SIDL_bool (*)(void *, struct SIDL_BaseInterface__object *)) epv->f_isSame;
  e2->f_queryInterface = (struct SIDL_BaseInterface__object * (*)(void *, const char *)) epv->f_queryInterface;
  e2->f_isInstanceOf = (SIDL_bool (*)(void *, const char *)) epv->f_isInstanceOf;

  e3->f__cast_ior = (void *(*)(void *, const char *)) epv->f__cast_ior;
  e3->f__delete = (void (*)(void *)) epv->f__delete;
  e3->f_getRepository = (struct SIDLLanguage_AST__array * (*)(void *, struct SIDL_BaseException__object **)) epv->f_getRepository;
  e3->f_setRepository = (void (*)(void *, struct SIDLLanguage_AST__array *, struct SIDL_BaseException__object **)) epv->f_setRepository;
  e3->f_visitAST = (void (*)(void *, struct SIDLLanguage_AST__object *, struct SIDL_BaseException__object **)) epv->f_visitAST;
  e3->f_visitSpecification = (void (*)(void *, struct SIDLLanguage_Specification__object *, struct SIDL_BaseException__object **)) epv->f_visitSpecification;
  e3->f_visitVersion = (void (*)(void *, struct SIDLLanguage_Version__object *, struct SIDL_BaseException__object **)) epv->f_visitVersion;
  e3->f_visitPackage = (void (*)(void *, struct SIDLLanguage_Package__object *, struct SIDL_BaseException__object **)) epv->f_visitPackage;
  e3->f_visitInterface = (void (*)(void *, struct SIDLLanguage_Interface__object *, struct SIDL_BaseException__object **)) epv->f_visitInterface;
  e3->f_visitClass = (void (*)(void *, struct SIDLLanguage_Class__object *, struct SIDL_BaseException__object **)) epv->f_visitClass;
  e3->f_visitMethod = (void (*)(void *, struct SIDLLanguage_Method__object *, struct SIDL_BaseException__object **)) epv->f_visitMethod;
  e3->f_visitType = (void (*)(void *, struct SIDLLanguage_Type__object *, struct SIDL_BaseException__object **)) epv->f_visitType;
  e3->f_visitEnumeration = (void (*)(void *, struct SIDLLanguage_Enumeration__object *, struct SIDL_BaseException__object **)) epv->f_visitEnumeration;
  e3->f_visitEnumerator = (void (*)(void *, struct SIDLLanguage_Enumerator__object *, struct SIDL_BaseException__object **)) epv->f_visitEnumerator;
  e3->f_visitArray = (void (*)(void *, struct SIDLLanguage_Array__object *, struct SIDL_BaseException__object **)) epv->f_visitArray;
  e3->f_visitParameter = (void (*)(void *, struct SIDLLanguage_Parameter__object *, struct SIDL_BaseException__object **)) epv->f_visitParameter;
  e3->f_visitComment = (void (*)(void *, struct SIDLLanguage_Comment__object *, struct SIDL_BaseException__object **)) epv->f_visitComment;
  e3->f_addReference = (void (*)(void *)) epv->f_addReference;
  e3->f_deleteReference = (void (*)(void *)) epv->f_deleteReference;
  e3->f_isSame = (SIDL_bool (*)(void *, struct SIDL_BaseInterface__object *)) epv->f_isSame;
  e3->f_queryInterface = (struct SIDL_BaseInterface__object * (*)(void *, const char *)) epv->f_queryInterface;
  e3->f_isInstanceOf = (SIDL_bool (*)(void *, const char *)) epv->f_isInstanceOf;

  s_method_initialized = 1;
}

/* NEW: allocate object and initialize it */
struct ANL_SIDL_PrettyPrinter__object *ANL_SIDL_PrettyPrinter__new()
{
  struct ANL_SIDL_PrettyPrinter__object *self = (struct ANL_SIDL_PrettyPrinter__object *) malloc(sizeof(struct ANL_SIDL_PrettyPrinter__object));
  ANL_SIDL_PrettyPrinter__init(self);
  return self;
}

/* INIT: initialize a new instance of the class object */
void ANL_SIDL_PrettyPrinter__init(
  struct ANL_SIDL_PrettyPrinter__object *self)
{
  struct ANL_SIDL_PrettyPrinter__object *s0 = self;
  struct SIDL_BaseClass__object *s1 = &s0->d_sidl_baseclass;

#if 1
  SIDL_BaseClass__init(s1);
#else
  void (*dll_f)(struct SIDL_BaseClass__object *) = (void (*)(struct SIDL_BaseClass__object *)) SIDL_Loader__externals()->getStaticEPV()->f_lookupSymbol("SIDL_BaseClass__init");

  if (!dll_f) {
    fputs("Unable to find initializer for SIDL.BaseClass; add to SIDL_DLL_PATH\n", stderr);
    exit(1);
  } else {
    (*dll_f)(s1);
  }
#endif

  if (!s_method_initialized) {
    ANL_SIDL_PrettyPrinter__init_epv(s0);
  }

  /* Setup d_epv members */
  s1->d_sidl_baseinterface.d_epv = &s_new__sidl_baseinterface;
  s1->d_epv = &s_new__sidl_baseclass;

  s0->d_sidllanguage_visitor.d_epv = &s_new__sidllanguage_visitor;
  s0->d_sidllanguage_fileoutput.d_epv = &s_new__sidllanguage_fileoutput;
  s0->d_epv = &s_new__anl_sidl_prettyprinter;

  /* Setup d_object members */
  s1->d_sidl_baseinterface.d_object = self;
  s1->d_object = self;
  s0->d_sidllanguage_visitor.d_object = self;
  s0->d_sidllanguage_fileoutput.d_object = self;
  s0->d_object = self;

  /* Setup d_data members */
  s0->d_data = NULL;
  (*(self->d_epv->f__ctor))(self);
}

/* FINI: deallocate a class instance (destructor) */
void ANL_SIDL_PrettyPrinter__fini(
  struct ANL_SIDL_PrettyPrinter__object *self)
{
  struct ANL_SIDL_PrettyPrinter__object *s0 = self;
  struct SIDL_BaseClass__object *s1 = &s0->d_sidl_baseclass;
#if 0
  void (*dll_f)(struct SIDL_BaseClass__object *) = (void (*)(struct SIDL_BaseClass__object *)) SIDL_Loader__externals()->getStaticEPV()->f_lookupSymbol("SIDL_BaseClass__fini");
#endif

  (*(self->d_epv->f__dtor))(self);

  /* Setup d_epv members */
  s1->d_sidl_baseinterface.d_epv = s_old__sidl_baseinterface;
  s1->d_epv = s_old__sidl_baseclass;

#if 1
  SIDL_BaseClass__fini(s1);
#else
  if (!dll_f) {
    fputs("Unable to find finializer for SIDL.BaseClass; add to SIDL_DLL_PATH\n", stderr);
    exit(1);
  } else {
    (*dll_f)(s1);
  }
#endif
}

/* The IOR array structure */
/*   Macros to read this are defined in SIDLArray.h */
struct ANL_SIDL_PrettyPrinter__array {
  struct ANL_SIDL_PrettyPrinter__object ** d_firstElement;
  int32_t *d_lower;
  int32_t *d_upper;
  int32_t *d_stride;
  SIDL_bool d_borrowed;
  int32_t d_dimen;
};

static struct ANL_SIDL_PrettyPrinter__array *newArray(int32_t dimen, const int32_t lower[], const int32_t upper[]) {
  static const size_t arraySize = sizeof(struct ANL_SIDL_PrettyPrinter__array) + (sizeof(int32_t) - (sizeof(struct ANL_SIDL_PrettyPrinter__array)%sizeof(int32_t)))%sizeof(int32_t);
  struct ANL_SIDL_PrettyPrinter__array *result = (struct ANL_SIDL_PrettyPrinter__array *) malloc(arraySize + 3*sizeof(int32_t)*dimen);

  result->d_dimen    = dimen;
  result->d_borrowed = 0;
  result->d_lower    = (int32_t *) ((char *) result + arraySize);
  result->d_upper    = result->d_lower + dimen;
  result->d_stride   = result->d_upper + dimen;
  memcpy(result->d_lower, lower, sizeof(int32_t)*dimen);
  memcpy(result->d_upper, upper, sizeof(int32_t)*dimen);
  return result;
}

/* Create a dense array of the given dimension with specified index bounds */
/*   This array owns and manages its data */
/*   All object pointers are initialized to NULL */
struct ANL_SIDL_PrettyPrinter__array * ANL_SIDL_PrettyPrinter__iorarray_create(
  int32_t dimen,
  const int32_t lower[],
  const int32_t upper[])
{
  struct ANL_SIDL_PrettyPrinter__array *result = newArray(dimen, lower, upper);
  int32_t size;
  int32_t i;

  for(i = 0, size = 1; i < dimen; i++) {
    result->d_stride[i] = size;
    size *= (upper[i] - lower[i] + 1);
  }
  size *= sizeof(struct ANL_SIDL_PrettyPrinter__object *);
  result->d_firstElement = (struct ANL_SIDL_PrettyPrinter__object **) malloc((size_t) size);
  memset(result->d_firstElement, 0, (size_t) size);
  return result;
}

/* Create an array using user-provided memory */
struct ANL_SIDL_PrettyPrinter__array * ANL_SIDL_PrettyPrinter__iorarray_borrow(
  struct ANL_SIDL_PrettyPrinter__object ** firstElement,
  int32_t dimen,
  const int32_t lower[],
  const int32_t upper[],
  const int32_t stride[])
{
  struct ANL_SIDL_PrettyPrinter__array *result = newArray(dimen, lower, upper);

  memcpy(result->d_stride, stride, sizeof(int32_t)*dimen);
  result->d_firstElement = firstElement;
  result->d_borrowed     = 1;
  return result;
}

/* Destroy the array (NULL arrays are ignored) */
void ANL_SIDL_PrettyPrinter__iorarray_destroy(
  struct ANL_SIDL_PrettyPrinter__array *array)
{
  if (array) {
    const int32_t dimen = array->d_dimen;

    if (!(array->d_borrowed)) {
      if (dimen > 0) {
        struct ANL_SIDL_PrettyPrinter__object **start = array->d_firstElement;
        struct ANL_SIDL_PrettyPrinter__object **end;
        int32_t size = 1;

        if (dimen > 1) {
          size = array->d_stride[dimen-1];
        }
        size *= (array->d_upper[dimen-1] - array->d_lower[dimen-1] + 1);
        end   = start + size;
        while(start < end) {
          if (*start) {
            (*(((struct SIDL_BaseClass__object *) (*start)->d_object)->d_epv->f_deleteReference))((*start)->d_object);
            *start = NULL;
          }
          ++start;
        }
      }
      free(array->d_firstElement);
    }
    memset(array, 0, sizeof(struct ANL_SIDL_PrettyPrinter__array) + 3*sizeof(int32_t)*dimen);
    free(array);
  }
}

/* Return the number of dimensions in the array */
/*   If the array pointer is NULL, zero is returned */
int32_t ANL_SIDL_PrettyPrinter__iorarray_dimen(
  const struct ANL_SIDL_PrettyPrinter__array *array)
{
  return array ? array->d_dimen : 0;
}

/* Return the lower bound on dimension ind */
/*   If the array pointer is NULL or ind is not a valid dimension, zero is returned */
int32_t ANL_SIDL_PrettyPrinter__iorarray_lower(
  const struct ANL_SIDL_PrettyPrinter__array *array,
  int32_t ind)
{
  return (array && (ind < array->d_dimen) && (ind >= 0)) ? array->d_lower[ind] : 0;
}

/* Return the upper bound on dimension ind */
/*   If the array pointer is NULL or ind is not a valid dimension, -1 is returned */
int32_t ANL_SIDL_PrettyPrinter__iorarray_upper(
  const struct ANL_SIDL_PrettyPrinter__array *array,
  int32_t ind)
{
  return (array && (ind < array->d_dimen) && (ind >= 0)) ? array->d_upper[ind] : -1;
}

/* Get an element of a multi-dimensional array */
/* This will use the indices provided up to the actual dimension of the array, ignoring extra indices */
/* If the return value is non-NULL, the client owns one reference to the object/interface */
/* The client must decrement the reference count when done with the reference */
struct ANL_SIDL_PrettyPrinter__object * ANL_SIDL_PrettyPrinter__iorarray_get(
  const struct ANL_SIDL_PrettyPrinter__array *array,
  const int32_t indices[])
{
  struct ANL_SIDL_PrettyPrinter__object **result = NULL;
  if (array && (array->d_dimen > 0)) {
    int32_t i;

    result = array->d_firstElement;
    for(i = 0; i < array->d_dimen; i++) {
      if ((indices[i] >= array->d_lower[i]) && (indices[i] <= array->d_upper[i])) {
        result += (array->d_stride[i]*(indices[i] - array->d_lower[i]));
      } else {
        result = NULL;
        break;
      }
    }
  }
  if (result) {
    if (*result) {
      (*(((struct SIDL_BaseClass__object *) (*result)->d_object)->d_epv->f_addReference))((*result)->d_object);
    }
    return *result;
  } else {
    return NULL;
  }
}

/* get an element of a multi-dimensional array */
/* This will use the indices provided up to the actual dimension of the array, ignoring extra indices */
/* If the return value is non-NULL, the client owns one reference to the object/interface */
/* The client must decrement the reference count when done with the reference */
struct ANL_SIDL_PrettyPrinter__object * ANL_SIDL_PrettyPrinter__iorarray_get4(
  const struct ANL_SIDL_PrettyPrinter__array *array,
  int32_t i1,
  int32_t i2,
  int32_t i3,
  int32_t i4)
{
  struct ANL_SIDL_PrettyPrinter__object **result = NULL;
  if (array) {
    result = array->d_firstElement;
    switch(array->d_dimen) {
    case 4:
      if ((i4 >= array->d_lower[3]) && (i4 <= array->d_upper[3])) {
        result += (array->d_stride[3]*(i4 - array->d_lower[3]));
      } else {
        result = NULL;
        break;
      }
      /* fall through */
    case 3:
      if ((i3 >= array->d_lower[2]) && (i3 <= array->d_upper[2])) {
        result += (array->d_stride[2]*(i3 - array->d_lower[2]));
      } else {
        result = NULL;
        break;
      }
      /* fall through */
    case 2:
      if ((i2 >= array->d_lower[1]) && (i2 <= array->d_upper[1])) {
        result += (array->d_stride[1]*(i2 - array->d_lower[1]));
      } else {
        result = NULL;
        break;
      }
      /* fall through */
    case 1:
      if ((i1 >= array->d_lower[0]) && (i1 <= array->d_upper[0])) {
        result += (array->d_stride[0]*(i1 - array->d_lower[0]));
      } else {
        result = NULL;
        break;
      }
      break;
    default:
      result = NULL;
      break;
    }
  }
  if (result) {
    if (*result) {
      (*(((struct SIDL_BaseClass__object *) (*result)->d_object)->d_epv->f_addReference))((*result)->d_object);
    }
    return *result;
  } else {
    return NULL;
  }
}

/* Set an element of a multi-dimensional array */
/* This will use the indices provided up to the actual dimension of the array, ignoring extra indices */
/* If the incoming value is non-NULL, this function will increment the reference code of the object/interface */
/* If it is overwriting a non-NULL pointer, the reference count of the object/interface being overwritten will be decremented */
void ANL_SIDL_PrettyPrinter__iorarray_set(
  struct ANL_SIDL_PrettyPrinter__array *array,
  const int32_t indices[],
  struct ANL_SIDL_PrettyPrinter__object * value)
{
  struct ANL_SIDL_PrettyPrinter__object **result = NULL;
  if (array && (array->d_dimen > 0)) {
    int32_t i;

    result = array->d_firstElement;
    for(i = 0; i < array->d_dimen; i++) {
      if ((indices[i] >= array->d_lower[i]) && (indices[i] <= array->d_upper[i])) {
        result += (array->d_stride[i]*(indices[i] - array->d_lower[i]));
      } else {
        result = NULL;
        break;
      }
    }
    if (result) {
      if (value) {
        (*(((struct SIDL_BaseClass__object *) value->d_object)->d_epv->f_addReference))(value->d_object);
      }
      if (*result) {
        (*(((struct SIDL_BaseClass__object *) (*result)->d_object)->d_epv->f_deleteReference))((*result)->d_object);
      }
      *result = value;
    }
  }
}

/* set an element of a multi-dimensional array */
/* This will use the indices provided up to the actual dimension of the array, ignoring extra indices */
/* If the incoming value is non-NULL, this function will increment the reference code of the object/interface */
/* If it is overwriting a non-NULL pointer, the reference count of the object/interface being overwritten will be decremented */
void ANL_SIDL_PrettyPrinter__iorarray_set4(
  struct ANL_SIDL_PrettyPrinter__array *array,
  int32_t i1,
  int32_t i2,
  int32_t i3,
  int32_t i4,
  struct ANL_SIDL_PrettyPrinter__object * value)
{
  struct ANL_SIDL_PrettyPrinter__object **result = NULL;
  if (array) {
    result = array->d_firstElement;
    switch(array->d_dimen) {
    case 4:
      if ((i4 >= array->d_lower[3]) && (i4 <= array->d_upper[3])) {
        result += (array->d_stride[3]*(i4 - array->d_lower[3]));
      } else {
        result = NULL;
        break;
      }
      /* fall through */
    case 3:
      if ((i3 >= array->d_lower[2]) && (i3 <= array->d_upper[2])) {
        result += (array->d_stride[2]*(i3 - array->d_lower[2]));
      } else {
        result = NULL;
        break;
      }
      /* fall through */
    case 2:
      if ((i2 >= array->d_lower[1]) && (i2 <= array->d_upper[1])) {
        result += (array->d_stride[1]*(i2 - array->d_lower[1]));
      } else {
        result = NULL;
        break;
      }
      /* fall through */
    case 1:
      if ((i1 >= array->d_lower[0]) && (i1 <= array->d_upper[0])) {
        result += (array->d_stride[0]*(i1 - array->d_lower[0]));
      } else {
        result = NULL;
        break;
      }
      break;
    default:
      result = NULL;
      break;
    }
  }
  if (result) {
    if (value) {
      (*(((struct SIDL_BaseClass__object *) value->d_object)->d_epv->f_addReference))(value->d_object);
    }
    if (*result) {
      (*(((struct SIDL_BaseClass__object *) (*result)->d_object)->d_epv->f_deleteReference))((*result)->d_object);
    }
    *result = value;
  }
}

static const struct ANL_SIDL_PrettyPrinter__external s_externalEntryPoints = {
  ANL_SIDL_PrettyPrinter__new,
  NULL /*ANL_SIDL_PrettyPrinter__remote*/,
  ANL_SIDL_PrettyPrinter__iorarray_create,
  ANL_SIDL_PrettyPrinter__iorarray_borrow,
  ANL_SIDL_PrettyPrinter__iorarray_destroy,
  ANL_SIDL_PrettyPrinter__iorarray_dimen,
  ANL_SIDL_PrettyPrinter__iorarray_lower,
  ANL_SIDL_PrettyPrinter__iorarray_upper,
  ANL_SIDL_PrettyPrinter__iorarray_get,
  ANL_SIDL_PrettyPrinter__iorarray_get4,
  ANL_SIDL_PrettyPrinter__iorarray_set,
  ANL_SIDL_PrettyPrinter__iorarray_set4
};

/* This function returns a pointer to a static structure of pointers to function entry points */
/* It is called upon loading the DLL */
const struct ANL_SIDL_PrettyPrinter__external *ANL_SIDL_PrettyPrinter__externals()
{
  return &s_externalEntryPoints;
}
