# DO-NOT-DELETE splicer.begin(_initial)
pass
# DO-NOT-DELETE splicer.end(_initial)

import SIDL.NullIORException
import SIDL.BaseInterface
import SIDLLanguage.AST
import SIDL.BaseException
import SIDLLanguage.VisitorException
import SIDLLanguage.Specification
import SIDLLanguage.Version
import SIDLLanguage.Package
import SIDLLanguage.Interface
import SIDLLanguage.Class
import SIDLLanguage.Method
import SIDLLanguage.Type
import SIDLLanguage.Enumeration
import SIDLLanguage.Enumerator
import SIDLLanguage.Array
import SIDLLanguage.Parameter
import SIDLLanguage.Comment

# DO-NOT-DELETE splicer.begin(_before_type)
pass
# DO-NOT-DELETE splicer.end(_before_type)

class IndexerHTML:
  '''
  // Output an index for the AST as HTML
  //   By default, this appends to any existing index
  '''
  # All calls to SIDL methods should use __IORself

  def __init__(self, IORself):
    self.__IORself = IORself
    # DO-NOT-DELETE splicer.begin(__init__)
    self.repository = []
    self.tab        = '&nbsp;&nbsp;&nbsp;&nbsp;'
    self.tabLevel   = 0
    self.fd         = None
    # DO-NOT-DELETE splicer.end(__init__)

  def getRepository(self):
    '''
    // Retrieve auxilliary ASTs
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # array _return
    # DO-NOT-DELETE splicer.begin(getRepository)
    return self.repository
    # DO-NOT-DELETE splicer.end(getRepository)

  def setRepository(self, repository):
    '''
    // Set auxilliary ASTs
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # repository array
    # DO-NOT-DELETE splicer.begin(setRepository)
    self.repository = repository
    # DO-NOT-DELETE splicer.end(setRepository)

  def visitAST(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.AST
    # DO-NOT-DELETE splicer.begin(visitAST)
    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitAST)

  def visitSpecification(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Specification
    # DO-NOT-DELETE splicer.begin(visitSpecification)
    if not len(filter(lambda child: child.isInstanceOf('SIDLLanguage.Package'), node.getChildren())): return
    try:
      filename = 'package-index.html'
      print 'Adding to '+filename
      self.fd = file(filename, 'a')
      if self.fd.tell() == 0:
        self.println('<h1>Package Index</h1>')
      for child in node.getChildren():
        if not len(child.getChildren()): continue
        child.accept(self.__IORself)
      self.fd.close()
    except SIDLLanguage.ASTException.Exception, e:
      self.raiseVisitorException(e.getMessage(), e.getStackTrace().strip())
    # DO-NOT-DELETE splicer.end(visitSpecification)

  def visitVersion(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Version
    # DO-NOT-DELETE splicer.begin(visitVersion)
    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitVersion)

  def visitPackage(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Package
    # DO-NOT-DELETE splicer.begin(visitPackage)
    self.defaultVisitComment(node)
    self.println('<a href="'+self.getURI(node)+'">'+node.getIdentifier()+'</a>')
    self.increaseTabLevel()
    self.defaultVisit(node)
    self.decreaseTabLevel()
    # DO-NOT-DELETE splicer.end(visitPackage)

  def visitInterface(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Interface
    # DO-NOT-DELETE splicer.begin(visitInterface)
    self.println('<a href="'+self.getURI(node)+'"><font color="green">'+node.getIdentifier()+'</font></a>')
    self.increaseTabLevel()
    self.defaultVisit(node)
    self.decreaseTabLevel()
    # DO-NOT-DELETE splicer.end(visitInterface)

  def visitClass(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Class
    # DO-NOT-DELETE splicer.begin(visitClass)
    self.println('<a href="'+self.getURI(node)+'"><font color="black">'+node.getIdentifier()+'</font></a>')
    self.increaseTabLevel()
    self.defaultVisit(node)
    self.decreaseTabLevel()
    # DO-NOT-DELETE splicer.end(visitClass)

  def visitMethod(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Method
    # DO-NOT-DELETE splicer.begin(visitMethod)
    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitMethod)

  def visitType(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Type
    # DO-NOT-DELETE splicer.begin(visitType)
    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitType)

  def visitEnumeration(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Enumeration
    # DO-NOT-DELETE splicer.begin(visitEnumeration)
    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitEnumeration)

  def visitEnumerator(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Enumerator
    # DO-NOT-DELETE splicer.begin(visitEnumerator)
    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitEnumerator)

  def visitArray(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Array
    # DO-NOT-DELETE splicer.begin(visitArray)
    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitArray)

  def visitParameter(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Parameter
    # DO-NOT-DELETE splicer.begin(visitParameter)
    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitParameter)

  def visitComment(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Comment
    # DO-NOT-DELETE splicer.begin(visitComment)
    import re
    comment = re.sub('<p>',  '', node.getComment())
    comment = re.sub('</p>', '', comment)
    comment = re.sub('<br>', '', comment)
    for comment in comment.split('\n'):
      self.println('<font color="red">'+comment+'</font>');
    # DO-NOT-DELETE splicer.end(visitComment)

# DO-NOT-DELETE splicer.begin(_final)
  def raiseVisitorException(self, message, trace = ''):
    e = SIDLLanguage.VisitorException.VisitorException()
    e.setMessage(message)
    if isinstance(trace, list):
      for line in trace: e.addToStackTrace(line.strip())
    elif trace:
      e.addToStackTrace(trace)
    e.addToTrace(__file__, sys._getframe(1).f_lineno, sys._getframe().f_code.co_name)
    raise SIDLLanguage.VisitorException.Exception, e

  def defaultVisit(self, ast):
    try:
      for child in ast.getChildren():
        child.accept(self.__IORself)
    except SIDLLanguage.ASTException.Exception, e:
      self.raiseVisitorException(e.getMessage(), e.getStackTrace().strip())
    return

  def defaultVisitComment(self, ast):
    try:
      for comment in ast.getComments():
        comment.accept(self.__IORself)
    except SIDLLanguage.ASTException.Exception, e:
      self.raiseVisitorException(e.getMessage(), e.getStackTrace().strip())
    return

  def increaseTabLevel(self, inc = 1):
    if inc < 0: self.raiseVisitorException('Invalid tab level increase: '+str(inc))
    self.tabLevel += inc
    return self.tabLevel

  def decreaseTabLevel(self, inc = 1):
    if inc < 0: self.raiseVisitorException('Invalid tab level decrease: '+str(inc))
    self.tabLevel -= inc
    if self.tabLevel < 0: self.raiseVisitorException('Tab level decreased below zero: '+str(self.tabLevel))
    return self.tabLevel

  def indent(self):
    for i in range(self.tabLevel):
      self.write(self.tab)
    return

  def write(self, str):
    self.fd.write(str)
    return

  def println(self, str):
    self.indent()
    self.write(str+'<br>\n')
    return

  def getRootURI(self, node):
    return node.getFullIdentifier().split('.')[0]+'.html'

  def getURI(self, node):
    return self.getRootURI(node)+'#'+node.getFullIdentifier()
# DO-NOT-DELETE splicer.end(_final)

