# DO-NOT-DELETE splicer.begin(_initial)
pass
# DO-NOT-DELETE splicer.end(_initial)

import SIDLLanguage.Specification
import SIDLLanguage.VisitorException
import SIDL.NullIORException
import SIDL.BaseException
import SIDLLanguage.Package
import SIDL.BaseInterface
import SIDLLanguage.AST
import SIDLLanguage.Version
import SIDLLanguage.Interface
import SIDLLanguage.Class
import SIDLLanguage.Method
import SIDLLanguage.Type
import SIDLLanguage.Enumeration
import SIDLLanguage.Enumerator
import SIDLLanguage.Array
import SIDLLanguage.Parameter
import SIDLLanguage.Comment

# DO-NOT-DELETE splicer.begin(_before_type)
pass
# DO-NOT-DELETE splicer.end(_before_type)

class PackageMerge:
  '''
  // Merge the given AST into the repository in this visitor, combining identical packages
  //   The final result can be retrieved using getRepository()
  //   Currently, this alters the ASTs which are visited
  '''
  # All calls to SIDL methods should use __IORself

  def __init__(self, IORself):
    self.__IORself = IORself
    # DO-NOT-DELETE splicer.begin(__init__)
    import ANL.SIDL.Query.PackageLocator

    self.locator = ANL.SIDL.Query.PackageLocator.PackageLocator()
    # DO-NOT-DELETE splicer.end(__init__)

  def visitSpecification(self, node):
    '''
    // Visit a Specification
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Specification
    # DO-NOT-DELETE splicer.begin(visitSpecification)
    self.defaultVisit(node)
    repository = self.__IORself.getRepository()
    if not len(repository):
      self.__IORself.setRepository([node])
    elif len(repository) == 1:
      repository[0].addChildren(node.getChildren())
      node.setChildren([])
    else:
      raise RuntimeError('Repository must be a single tree after merging')
    # DO-NOT-DELETE splicer.end(visitSpecification)

  def visitPackage(self, node):
    '''
    // Visit a Package
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Package
    # DO-NOT-DELETE splicer.begin(visitPackage)
    self.defaultVisit(node)

    self.locator.setPackageIdentifier(node.getFullIdentifier())
    for root in self.__IORself.getRepository():
      root.accept(self.locator)
      if self.locator.hasPackage():
        # Transfer children to package in repository, removing duplicates
        package  = self.locator.getPackage()
        children = list(node.getChildren())
        for child in list(node.getChildren()): # cannot use in children here with remove below!
          for c in package.getChildren():
            if child.getIdentifier() == c.getIdentifier():
              children.remove(child)
              break
        package.addChildren(children)
        # Copy comments, if they are not present
        comments = list(node.getComments())
        for comment in list(node.getComments()): # cannot use in comments here with remove below!
          for c in package.getComments():
            if c.getComment().find(comment.getComment()) >= 0:
              comments.remove(comment)
              break
        package.addComments(comments)
        # Delete it from previous parent
        parent   = node.getParent()
        children = list(parent.getChildren())
        children.remove(node)
        parent.setChildren(children)
        return
    # DO-NOT-DELETE splicer.end(visitPackage)

# DO-NOT-DELETE splicer.begin(_final)
  def raiseVisitorException(self, message, trace = ''):
    e = SIDLLanguage.VisitorException.VisitorException()
    e.setMessage(message)
    if isinstance(trace, list):
      for line in trace: e.addToStackTrace(line.strip())
    elif trace:
      e.addToStackTrace(trace)
    e.addToTrace(__file__, sys._getframe(1).f_lineno, sys._getframe().f_code.co_name)
    raise SIDLLanguage.VisitorException.Exception, e

  def defaultVisit(self, ast):
    try:
      for child in ast.getChildren():
        child.accept(self.__IORself)
    except SIDLLanguage.ASTException.Exception, e:
      self.raiseVisitorException(e.getMessage(), e.getStackTrace().strip())
    return
# DO-NOT-DELETE splicer.end(_final)

