# DO-NOT-DELETE splicer.begin(_initial)
import sys
import os
# DO-NOT-DELETE splicer.end(_initial)

import SIDL.NullIORException
import SIDL.BaseException
import SIDL.BaseInterface
import SIDLLanguage.VisitorException
import SIDLLanguage.Splicer
import SIDLLanguage.Code
import SIDLLanguage.AST
import SIDLLanguage.Specification
import SIDLLanguage.Version
import SIDLLanguage.Package
import SIDLLanguage.Interface
import SIDLLanguage.Class
import SIDLLanguage.Method
import SIDLLanguage.Type
import SIDLLanguage.Enumeration
import SIDLLanguage.Enumerator
import SIDLLanguage.Array
import SIDLLanguage.Parameter
import SIDLLanguage.Comment

# DO-NOT-DELETE splicer.begin(_before_type)
import SIDLLanguage.ParameterAccessMode
# DO-NOT-DELETE splicer.end(_before_type)

class PrettyPrinterBabel:
  '''
  // Print the SIDL in a format that Babel can understand
  '''
  # All calls to SIDL methods should use __IORself

  def __init__(self, IORself):
    self.__IORself = IORself
    # DO-NOT-DELETE splicer.begin(__init__)
    self.tab             = '  '
    self.tabLevel        = 0
    self.currentPackage  = None
    self.previousPackage = None
    self.roots           = {}
    self.outputFiles     = []
    self.file            = sys.stdout
    self.markName        = 'PrettyPrinterBabelMarked'
    # DO-NOT-DELETE splicer.end(__init__)

  def setFilename(self, filename):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # filename string
    # DO-NOT-DELETE splicer.begin(setFilename)
    self.file = open(filename,'w')
    # DO-NOT-DELETE splicer.end(setFilename)

  def getRoot(self, purpose):
    '''
    // Get the root directory for output
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # purpose string
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # string _return
    # DO-NOT-DELETE splicer.begin(getRoot)
    if self.roots.has_key(purpose):
      return self.roots[purpose]
    else:
      return None
    # DO-NOT-DELETE splicer.end(getRoot)

  def setRoot(self, purpose, path):
    '''
    // Set the root directory for output
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # purpose string
    # path string
    # DO-NOT-DELETE splicer.begin(setRoot)
    self.roots[purpose] = path
    # DO-NOT-DELETE splicer.end(setRoot)

  def getOutputSource(self):
    '''
    // Get the flag determining whether source is output
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # bool _return
    # DO-NOT-DELETE splicer.begin(getOutputSource)
    return 0
    # DO-NOT-DELETE splicer.end(getOutputSource)

  def setOutputSource(self, outputSource):
    '''
    // Set the flag determining whether source is output
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # outputSource bool
    # DO-NOT-DELETE splicer.begin(setOutputSource)
    return
    # DO-NOT-DELETE splicer.end(setOutputSource)

  def getSplicer(self):
    '''
    // Retrieve the splicer used for preserving implementation blocks
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # SIDLLanguage.Splicer _return
    # DO-NOT-DELETE splicer.begin(getSplicer)
    return
    # DO-NOT-DELETE splicer.end(getSplicer)

  def setSplicer(self, splicer):
    '''
    // Set the splicer used for preserving implementation blocks
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # splicer SIDLLanguage.Splicer
    # DO-NOT-DELETE splicer.begin(setSplicer)
    return
    # DO-NOT-DELETE splicer.end(setSplicer)

  def getCodeOutput(self):
    '''
    // Retrieve the Code object used for output
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # SIDLLanguage.Code _return
    # DO-NOT-DELETE splicer.begin(getCodeOutput)
    return
    # DO-NOT-DELETE splicer.end(getCodeOutput)

  def setCodeOutput(self, output):
    '''
    // Set the Code object used for output
    //   Obviously here we need a persistent object which can output many source blocks
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # output SIDLLanguage.Code
    # DO-NOT-DELETE splicer.begin(setCodeOutput)
    return
    # DO-NOT-DELETE splicer.end(setCodeOutput)

  def getOutputFiles(self):
    '''
    // Retrieve all the created files
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # array _return
    # DO-NOT-DELETE splicer.begin(getOutputFiles)
    return self.outputFiles
    # DO-NOT-DELETE splicer.end(getOutputFiles)

  def clearOutputFiles(self):
    '''
    // Clear the list of created files
    '''
    # DO-NOT-DELETE splicer.begin(clearOutputFiles)
    self.outputFiles = []
    # DO-NOT-DELETE splicer.end(clearOutputFiles)

  def getRepository(self):
    '''
    // Retrieve auxilliary ASTs
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # array _return
    # DO-NOT-DELETE splicer.begin(getRepository)
    return []
    # DO-NOT-DELETE splicer.end(getRepository)

  def setRepository(self, repository):
    '''
    // Set auxilliary ASTs
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # repository array
    # DO-NOT-DELETE splicer.begin(setRepository)
    # Put your code here...
    pass
    # DO-NOT-DELETE splicer.end(setRepository)

  def visitAST(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.AST
    # DO-NOT-DELETE splicer.begin(visitAST)
    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitAST)

  def visitSpecification(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Specification
    # DO-NOT-DELETE splicer.begin(visitSpecification)
    packages    = []
    nonpackages = []
    for c in node.getChildren():
      try:
        c1 = SIDLLanguage.Package.Package(c)
        packages.append(c)
      except:
        nonpackages.append(c)

    packages = self.sortPackages(packages)
    
    
    for child in packages+nonpackages:
      child.accept(self.__IORself)

    self.file.close()
    # DO-NOT-DELETE splicer.end(visitSpecification)

  def visitVersion(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Version
    # DO-NOT-DELETE splicer.begin(visitVersion)
    self.defaultVisitComment(node)
    self.println('//version '+node.getIdentifier()+' '+node.getNumber())
    # DO-NOT-DELETE splicer.end(visitVersion)

  def visitPackage(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Package
    # DO-NOT-DELETE splicer.begin(visitPackage)
    classes      = []
    interfaces   = []
    enumerations = []
    packages     = []
    
    for c in node.getChildren():
      try:
        c1 = SIDLLanguage.Class.Class(c)
        if c1: classes.append(c)
      except:
        try:
          c1 = SIDLLanguage.Interface.Interface(c)
          if c1: interfaces.append(c)
        except:
          try:
            c1 = SIDLLanguage.Enumeration.Enumeration(c)
            if c1: enumerations.append(c)
          except:
            packages.append(c)

    packages    = self.sortPackages(packages)
    classes     = self.sortClasses(classes+interfaces)
    interfaces  = [] # self.sortInterfaces(interfaces)
    
    self.println('')
    self.previousPackage = self.currentPackage
    self.currentPackage  = node.getFullIdentifier()
    self.defaultVisitComment(node)
    #
    #  Babel won't let you name a package SIDL
    #
    if node.getFullIdentifier() == 'SIDL': packagename = 'SIDLASE'
    else:                                  packagename = node.getIdentifier()
    
    self.println('package '+packagename+' version 1.0 '+' {')
    self.increaseTabLevel()

    try:
      for child in enumerations+interfaces+classes+packages:
        child.accept(self.__IORself)
    except SIDLLanguage.ASTException.Exception, e:
      self.raiseVisitorException(e.getMessage(), e.getStackTrace().strip())
    
    self.decreaseTabLevel()
    self.println('}')
    self.currentPackage = self.previousPackage
    # DO-NOT-DELETE splicer.end(visitPackage)

  def visitInterface(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Interface
    # DO-NOT-DELETE splicer.begin(visitInterface)
    #
    #  Do NOT print builtin SIDL interfaces
    #
    if node.getFullIdentifier() == 'SIDL.BaseInterface': return

    self.println('')
    self.defaultVisitComment(node)
    decl    = 'interface '+node.getIdentifier()
    parents = node.getParents()
    if len(parents):
      decl += ' extends '
      for i in range(len(parents)):
        if i > 0: decl += ', '
        decl += self.getFullIdentifier(parents[i])
    decl += ' {'
    self.println(decl)
    self.increaseTabLevel()
    self.defaultVisit(node)
    self.decreaseTabLevel()
    self.println('}')
    # DO-NOT-DELETE splicer.end(visitInterface)

  def visitClass(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Class
    # DO-NOT-DELETE splicer.begin(visitClass)
    #
    #  Do NOT print builtin SIDL classes
    #
    if self.isMarked(node): return
    self.markNode(node)

    if node.getFullIdentifier() == 'SIDL.BaseClass': return
    if node.getFullIdentifier() == 'SIDL.BaseException': return
    if node.getFullIdentifier() == 'SIDL.DLL': return
    if node.getFullIdentifier() == 'SIDL.Loader': return
    if node.getFullIdentifier() == 'SIDL.ClassInfoI': return
    if node.getFullIdentifier() == 'SIDL.NullIORException': return
    
    self.println('')
    self.defaultVisitComment(node)
    decl    = 'class '+node.getIdentifier()
    parents = node.getParents()
    if len(parents):
      decl += ' extends '
      for i in range(len(parents)):
        if i > 0: decl += ', '
        decl += self.getFullIdentifier(parents[i])
    interfaces = node.getInterfaces()
    if len(interfaces):
      #
      #  FIX: how do we know when it should be implements and implements-all?
      #
      decl += ' implements-all '
      for i in range(len(interfaces)):
        if i > 0: decl += ', '
        decl += self.getFullIdentifier(interfaces[i])
    decl += ' {'
    self.println(decl)
    self.increaseTabLevel()
    self.defaultVisit(node)
    self.decreaseTabLevel()
    self.println('}')
    # DO-NOT-DELETE splicer.end(visitClass)

  def visitMethod(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Method
    # DO-NOT-DELETE splicer.begin(visitMethod)
    if self.isMarked(node): return
    self.markNode(node)
    self.println('')
    self.defaultVisitComment(node)
    self.indent()
    if node.getStatic():
      self.write('static ')
    self.defaultVisitType(node.getReturnType())
    self.write(' '+node.getIdentifier()+'(')
    children = node.getChildren()
    try:
      for c in range(len(children)):
        if c > 0: self.write(', ')
        children[c].accept(self.__IORself)
    except SIDLLanguage.ASTException.Exception, e:
      self.raiseVisitorException(e.getMessage(), e.getStackTrace().strip())
    self.write(')')
    exceptions = self.getIORExceptions(node)
    if len(exceptions) > 0:
      self.write(' throws ')
      for e in range(len(exceptions)):
        if e > 0: self.write(', ')
        self.write(self.getFullIdentifier(exceptions[e]))
    self.write(';\n')
    # DO-NOT-DELETE splicer.end(visitMethod)

  def visitType(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Type
    # DO-NOT-DELETE splicer.begin(visitType)
    if node.getBaseType():
      self.write(node.getIdentifier())
    else:
      self.write(self.getQualifiedName(node,self.currentPackage))
    # DO-NOT-DELETE splicer.end(visitType)

  def visitEnumeration(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Enumeration
    # DO-NOT-DELETE splicer.begin(visitEnumeration)
    if self.isMarked(node): return
    self.markNode(node)
    self.println('')
    self.defaultVisitComment(node)
    self.indent()
    self.write('enum '+node.getIdentifier())
    children = node.getChildren()
    try:
      if len(children) > 0:
        self.write(' {')
        for e in range(len(children)):
          if e > 0: self.write(', ')
          children[e].accept(self.__IORself)
    except SIDLLanguage.ASTException.Exception, e:
      self.raiseVisitorException(e.getMessage(), e.getStackTrace().strip())
    self.write('}')
    self.write(';\n')
    # DO-NOT-DELETE splicer.end(visitEnumeration)

  def visitEnumerator(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Enumerator
    # DO-NOT-DELETE splicer.begin(visitEnumerator)
    if node.getInitialized():
      self.write(node.getIdentifier()+' = '+str(node.getValue()))
    else:
      self.write(node.getIdentifier())
    # DO-NOT-DELETE splicer.end(visitEnumerator)

  def visitArray(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Array
    # DO-NOT-DELETE splicer.begin(visitArray)
    self.write('array<')
    self.defaultVisitType(node.getType())
    if node.getDimension() > 0:
      self.write(', '+str(node.getDimension())+'>')
    else:
      self.write('>')
    # DO-NOT-DELETE splicer.end(visitArray)

  def visitParameter(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Parameter
    # DO-NOT-DELETE splicer.begin(visitParameter)
    if node.getCopy(): self.write(' copy ')
    mode = node.getAccessMode()
    if mode == SIDLLanguage.ParameterAccessMode.IN:
      self.write('in ')
    elif mode == SIDLLanguage.ParameterAccessMode.INOUT:
      self.write('inout ')
    elif mode == SIDLLanguage.ParameterAccessMode.OUT:
      self.write('out ')
    else:
      self.raiseVisitorException('Invalid parameter access mode: '+str(mode))
    self.defaultVisitType(node.getType())
    self.write(' '+node.getIdentifier())
    # DO-NOT-DELETE splicer.end(visitParameter)

  def visitComment(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Comment
    # DO-NOT-DELETE splicer.begin(visitComment)
    self.println(node.getComment());
    # DO-NOT-DELETE splicer.end(visitComment)

# DO-NOT-DELETE splicer.begin(_final)
  def raiseVisitorException(self, message, trace = ''):
    e = SIDLLanguage.VisitorException.VisitorException()
    e.setMessage(message)
    if isinstance(trace, list):
      for line in trace: e.addToStackTrace(line.strip())
    elif trace:
      e.addToStackTrace(trace)
    e.addToTrace(__file__, sys._getframe(1).f_lineno, sys._getframe().f_code.co_name)
    raise SIDLLanguage.VisitorException.Exception, e

  def defaultVisit(self, ast):
    try:
      for child in ast.getChildren():
        child.accept(self.__IORself)
    except SIDLLanguage.ASTException.Exception, e:
      self.raiseVisitorException(e.getMessage(), e.getStackTrace().strip())
    return

  def defaultVisitType(self, type):
    if type.isInstanceOf('SIDLLanguage.Array'):
      self.visitArray(SIDLLanguage.Array.Array(type))
    else:
      self.visitType(type)
    return

  def defaultVisitComment(self, ast):
    try:
      for comment in ast.getComments():
        comment.accept(self.__IORself)
    except SIDLLanguage.ASTException.Exception, e:
      self.raiseVisitorException(e.getMessage(), e.getStackTrace().strip())
    return

  def increaseTabLevel(self, inc = 1):
    if inc < 0: self.raiseVisitorException('Invalid tab level increase: '+str(inc))
    self.tabLevel += inc
    return self.tabLevel

  def decreaseTabLevel(self, inc = 1):
    if inc < 0: self.raiseVisitorException('Invalid tab level decrease: '+str(inc))
    self.tabLevel -= inc
    if self.tabLevel < 0: self.raiseVisitorException('Tab level decreased below zero: '+str(self.tabLevel))
    return self.tabLevel

  def indent(self):
    for i in range(self.tabLevel):
      self.write(self.tab)
    return

  def write(self, str):
    self.file.write(str)
    return

  def println(self, str):
    self.indent()
    self.write(str)
    self.write('\n')
    return

  def getFullIdentifier(self, node):
    qualifiedName = node.getFullIdentifier()

    # Convert our SIDL classes to SIDLASE
    if qualifiedName == 'SIDL.ProjectState': qualifiedName = 'SIDLASE.ProjectState'
    if qualifiedName == 'SIDL.Args':         qualifiedName = 'SIDLASE.Args'
    
    return qualifiedName

  def getQualifiedName(self, node, packageName):
    qualifiedName = self.getFullIdentifier(node)
    if qualifiedName.startswith(packageName):
      qualifiedName = node.getIdentifier()
    return qualifiedName

  def getIORExceptions(self, method):
    exceptions = []
    for exception in method.getExceptions():
      if not exception.getFullIdentifier() == 'SIDL.NullIORException':
        exceptions.append(exception)
    return exceptions

  def isMarked(self, node, name = ''):
    if not name: name = self.markName
    return node.hasAttribute(name)

  def markNode(self, node, name = ''):
    if not name: name = self.markName
    seen = SIDLLanguage.Attribute.Attribute(SIDL.Loader.createClass('ANL.SIDLCompilerI.Attribute'))
    seen.setName(name)
    node.addAttribute(seen)
    return

  def sortPackages(self, packages):
    ''' build dependencies for packages and sort on that'''
    import build.buildGraph
    graph = build.buildGraph.BuildGraph(packages)

    for p in packages:
      for c in p.getChildren():
        # if child is a class then get all packages it depends on
        try:
          c1 = SIDLLanguage.Class.Class(c)
          if len(c1.getParents()) > 0:
            for pp in c1.getParents():
              if pp.getParent() in graph.vertices: graph.addEdges(p,[pp.getParent()])
          if len(c1.getInterfaces()) > 0:
            for pp in c1.getInterfaces():
               if pp.getParent() in graph.vertices: graph.addEdges(p,[pp.getParent()])
        except:
          pass

    vertices = [vertex for vertex in build.buildGraph.BuildGraph.depthFirstSearch(graph, returnFinished = 1)]
    vertices.reverse()
    return vertices
  
  def sortClasses(self, classes):
    ''' build dependencies for classes and sort on that'''
    #print 'Start unsorted classes/interfaces  ------'
    for d in classes: print d.getFullIdentifier()
    #print 'End unsorted classes/interfaces  ------'

    dclasses = {}
    for d in classes:
      dclasses[d.getFullIdentifier()] = d
      
    import build.buildGraph
    graph = build.buildGraph.BuildGraph(classes)

    for p in classes:
      try:
        c = SIDLLanguage.Class.Class(p)
        #print 'Class '+p.getFullIdentifier()
        for pp in c.getParents():
          if dclasses.has_key(pp.getFullIdentifier()):
            #print '   Parent class '+pp.getFullIdentifier()
            graph.addEdges(p,[dclasses[pp.getFullIdentifier()]])
        for pp in c.getInterfaces():
          if dclasses.has_key(pp.getFullIdentifier()):
            #print '   Parent interface '+pp.getFullIdentifier()
            graph.addEdges(p,[dclasses[pp.getFullIdentifier()]])
        for pp in c.getChildren():
          try:
            d = SIDLLanguage.Method.Method(pp)
          except: pass
      except:
        #print 'Interface '+p.getFullIdentifier()
        c = SIDLLanguage.Interface.Interface(p)
        for pp in c.getParents():
          if dclasses.has_key(pp.getFullIdentifier()):
            #print '   Parents '+pp.getFullIdentifier()
            graph.addEdges(p,[dclasses[pp.getFullIdentifier()]])
        for pp in c.getChildren():
          try:
            d = SIDLLanguage.Method.Method(pp)
            for e in self.getIORExceptions(d):
#              print 'interface '+pp.getFullIdentifier()+' '+e.getFullIdentifier()
              if dclasses.has_key(e.getFullIdentifier()):
                graph.addEdges(p,[dclasses[e.getFullIdentifier()]])
          except: pass

    vertices = [vertex for vertex in build.buildGraph.BuildGraph.depthFirstSearch(graph, returnFinished = 1)]
    vertices.reverse()

    #print 'Start sorted classes/interfaces  ------'
    #for d in vertices: print d.getFullIdentifier()
    #print 'End sorted classes/interfaces  ------'
    return vertices

# DO-NOT-DELETE splicer.end(_final)

