# DO-NOT-DELETE splicer.begin(_initial)
import sys
# DO-NOT-DELETE splicer.end(_initial)

import SIDL.NullIORException
import SIDL.BaseInterface
import SIDL.BaseException
import SIDLLanguage.VisitorException
import SIDLLanguage.Splicer
import SIDLLanguage.Code
import SIDLLanguage.AST
import SIDLLanguage.Specification
import SIDLLanguage.Version
import SIDLLanguage.Package
import SIDLLanguage.Interface
import SIDLLanguage.Class
import SIDLLanguage.Method
import SIDLLanguage.Type
import SIDLLanguage.Enumeration
import SIDLLanguage.Enumerator
import SIDLLanguage.Array
import SIDLLanguage.Parameter
import SIDLLanguage.Comment

# DO-NOT-DELETE splicer.begin(_before_type)
import SIDLLanguage.ParameterAccessMode
import re
# DO-NOT-DELETE splicer.end(_before_type)

class PrettyPrinterHTML:
  '''
  // Print the AST to a file as HTML
  '''
  # All calls to SIDL methods should use __IORself

  def __init__(self, IORself):
    self.__IORself = IORself
    # DO-NOT-DELETE splicer.begin(__init__)
    self.repository      = []
    self.tab             = '&nbsp;&nbsp;&nbsp;&nbsp;'
    self.tabLevel        = 0
    self.fd              = None
    self.currentPackage  = None
    self.previousPackage = None
    self.roots           = {}
    self.outputFiles     = []
    # DO-NOT-DELETE splicer.end(__init__)

  def getRoot(self, purpose):
    '''
    // Get the root directory for output
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # purpose string
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # string _return
    # DO-NOT-DELETE splicer.begin(getRoot)
    if self.roots.has_key(purpose):
      return self.roots[purpose]
    else:
      self.raiseVisitorException('No root set for purpose '+purpose)
    # DO-NOT-DELETE splicer.end(getRoot)

  def setRoot(self, purpose, path):
    '''
    // Set the root directory for output
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # purpose string
    # path string
    # DO-NOT-DELETE splicer.begin(setRoot)
    self.roots[purpose] = path
    # DO-NOT-DELETE splicer.end(setRoot)

  def getOutputSource(self):
    '''
    // Get the flag determining whether source is output
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # bool _return
    # DO-NOT-DELETE splicer.begin(getOutputSource)
    return
    # DO-NOT-DELETE splicer.end(getOutputSource)

  def setOutputSource(self, outputSource):
    '''
    // Set the flag determining whether source is output
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # outputSource bool
    # DO-NOT-DELETE splicer.begin(setOutputSource)
    return
    # DO-NOT-DELETE splicer.end(setOutputSource)

  def getSplicer(self):
    '''
    // Retrieve the splicer used for preserving implementation blocks
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # SIDLLanguage.Splicer _return
    # DO-NOT-DELETE splicer.begin(getSplicer)
    return
    # DO-NOT-DELETE splicer.end(getSplicer)

  def setSplicer(self, splicer):
    '''
    // Set the splicer used for preserving implementation blocks
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # splicer SIDLLanguage.Splicer
    # DO-NOT-DELETE splicer.begin(setSplicer)
    return
    # DO-NOT-DELETE splicer.end(setSplicer)

  def getCodeOutput(self):
    '''
    // Retrieve the Code object used for output
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # SIDLLanguage.Code _return
    # DO-NOT-DELETE splicer.begin(getCodeOutput)
    return
    # DO-NOT-DELETE splicer.end(getCodeOutput)

  def setCodeOutput(self, output):
    '''
    // Set the Code object used for output
    //   Obviously here we need a persistent object which can output many source blocks
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # output SIDLLanguage.Code
    # DO-NOT-DELETE splicer.begin(setCodeOutput)
    return
    # DO-NOT-DELETE splicer.end(setCodeOutput)

  def getOutputFiles(self):
    '''
    // Retrieve all the created files
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # array _return
    # DO-NOT-DELETE splicer.begin(getOutputFiles)
    return self.outputFiles
    # DO-NOT-DELETE splicer.end(getOutputFiles)

  def clearOutputFiles(self):
    '''
    // Clear the list of created files
    '''
    # DO-NOT-DELETE splicer.begin(clearOutputFiles)
    self.outputFiles = []
    # DO-NOT-DELETE splicer.end(clearOutputFiles)

  def getRepository(self):
    '''
    // Retrieve auxilliary ASTs
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # array _return
    # DO-NOT-DELETE splicer.begin(getRepository)
    return self.repository
    # DO-NOT-DELETE splicer.end(getRepository)

  def setRepository(self, repository):
    '''
    // Set auxilliary ASTs
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # repository array
    # DO-NOT-DELETE splicer.begin(setRepository)
    # Put your code here...
    self.repository = repository
    # DO-NOT-DELETE splicer.end(setRepository)

  def visitAST(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.AST
    # DO-NOT-DELETE splicer.begin(visitAST)
    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitAST)

  def visitSpecification(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Specification
    # DO-NOT-DELETE splicer.begin(visitSpecification)
    if not len(filter(lambda child: child.isInstanceOf('SIDLLanguage.Package'), node.getChildren())): return
    try:
      for child in node.getChildren():
        if not len(child.getChildren()): continue
        filename = self.getRootURI(child)
        print 'Creating '+filename
        self.outputFiles.append(filename)
        self.fd = file(filename, 'w')
        self.write('<table border="0" width="100%">\n')
        child.accept(self.__IORself)
        self.write('</table>\n')
        self.fd.close()
    except SIDLLanguage.ASTException.Exception, e:
      self.raiseVisitorException(e.getMessage(), e.getStackTrace().strip())
    # DO-NOT-DELETE splicer.end(visitSpecification)

  def visitVersion(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Version
    # DO-NOT-DELETE splicer.begin(visitVersion)
    self.defaultVisitComment(node)
    self.println(self.getHTMLReservedWord('version')+' '+node.getIdentifier()+' '+node.getNumber())
    # DO-NOT-DELETE splicer.end(visitVersion)

  def visitPackage(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Package
    # DO-NOT-DELETE splicer.begin(visitPackage)
    self.previousPackage = self.currentPackage
    self.currentPackage  = node.getFullIdentifier()
    self.defaultVisitComment(node)

    self.println(self.getHTMLReservedWord('package')+'<a name="'+node.getFullIdentifier()+'"> '+self.getHTMLIdentifier(node.getIdentifier())+' {')
    self.increaseTabLevel()
    self.defaultVisit(node)
    self.decreaseTabLevel()
    self.println('}')
    self.currentPackage = self.previousPackage
    # DO-NOT-DELETE splicer.end(visitPackage)

  def visitInterface(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Interface
    # DO-NOT-DELETE splicer.begin(visitInterface)
    self.defaultVisitComment(node)
    decl    = self.getHTMLReservedWord('interface')+'<a name="'+node.getFullIdentifier()+'"> '+self.getHTMLIdentifier(node.getIdentifier())
    parents = []
    for p in node.getParents():
      if not p.getFullIdentifier() == 'SIDL.BaseInterface':
        parents.append(p)
    
    if len(parents):
      decl += ' '+self.getHTMLReservedWord('extends')+' '
    for i in range(len(parents)):
      if i > 0: decl += ', '
      decl +=  '<a href="'+self.getURI(parents[i])+'">'+self.getQualifiedName(parents[i], self.currentPackage)+'</a>'
    if len(node.getChildren()) > 0:
      decl += ' {'
    else:
      decl += ' {}'
    self.println(decl)
    if len(node.getChildren()) > 0:
      self.increaseTabLevel()
      self.defaultVisit(node)
      self.decreaseTabLevel()
      self.println('}')
    # DO-NOT-DELETE splicer.end(visitInterface)

  def visitClass(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Class
    # DO-NOT-DELETE splicer.begin(visitClass)
    self.defaultVisitComment(node)
    decl    = self.getHTMLReservedWord('class')+'<a name="'+node.getFullIdentifier()+'"> '+self.getHTMLIdentifier(node.getIdentifier())
    parents = []
    for p in node.getParents():
      if not p.getFullIdentifier() == 'SIDL.BaseClass':
        parents.append(p)

    if len(parents):
      decl += ' '+self.getHTMLReservedWord('extends')+' '
    for i in range(len(parents)):
      if i > 0: decl += ', '
      decl +=  '<a href="'+self.getURI(parents[i])+'">'+self.getQualifiedName(parents[i], self.currentPackage)+'</a>'
    interfaces = node.getInterfaces()
    if len(interfaces):
      decl += ' '+self.getHTMLReservedWord('implements')+' '
      for i in range(len(interfaces)):
        if i > 0: decl += ', '
        decl += '<a href="'+self.getURI(interfaces[i])+'">'+self.getQualifiedName(interfaces[i], self.currentPackage)+'</a>'
    if len(node.getChildren()) > 0:
      decl += ' {'
    else:
      decl += ' {}'
    self.println(decl)
    if len(node.getChildren()) > 0:
      self.increaseTabLevel()
      self.defaultVisit(node)
      self.decreaseTabLevel()
      self.println('}')
    # DO-NOT-DELETE splicer.end(visitClass)

  def visitMethod(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Method
    # DO-NOT-DELETE splicer.begin(visitMethod)
    self.defaultVisitComment(node)
    self.indent()
    if node.getStatic():
      self.write('static ')
    self.visitType(node.getReturnType())
    self.write(' <font color="blue"><a name="'+node.getFullIdentifier()+'">'+node.getIdentifier()+'</font>(')
    children = node.getChildren()
    try:
      for c in range(len(children)):
        if c > 0: self.write(', ')
        children[c].accept(self.__IORself)
    except SIDLLanguage.ASTException.Exception, e:
      self.raiseVisitorException(e.getMessage(), e.getStackTrace().strip())
    self.write(')')
    exceptions = self.getIORExceptions(node)
    if len(exceptions) > 0:
      self.write(' '+self.getHTMLReservedWord('throws')+' ')
      for e in range(len(exceptions)):
        if e > 0: self.write(', ')
        self.write('<a href="'+self.getURI(exceptions[e])+'">'+self.getQualifiedName(exceptions[e], self.currentPackage)+'</a>')
    self.write(';')
    self.write('<br>\n')
    # DO-NOT-DELETE splicer.end(visitMethod)

  def visitType(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Type
    # DO-NOT-DELETE splicer.begin(visitType)
    if node.getBaseType():
      self.write('<font color="darkgreen">'+node.getIdentifier()+'</font>')
    elif node.isInstanceOf('SIDLLanguage.Array'):
      # This is necessary since I call visitType() myself to avoid recursion with visitInterface/Class/Enumeration
      node.accept(self.__IORself)
    else:
      self.write('<a href="'+self.getURI(node)+'">'+self.getQualifiedName(node, self.currentPackage)+'</a>')
    # DO-NOT-DELETE splicer.end(visitType)

  def visitEnumeration(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Enumeration
    # DO-NOT-DELETE splicer.begin(visitEnumeration)
    self.defaultVisitComment(node)
    self.indent()
    self.write(self.getHTMLReservedWord('enum')+'<a name="'+node.getFullIdentifier()+'"> '+self.getHTMLIdentifier(node.getIdentifier()))
    children = node.getChildren()
    try:
      if len(children) > 0:
        self.write(' {')
        for e in range(len(children)):
          if e > 0: self.write(', ')
          children[e].accept(self.__IORself)
    except SIDLLanguage.ASTException.Exception, e:
      self.raiseVisitorException(e.getMessage(), e.getStackTrace().strip())
    self.write('}')
    self.write(';<br>\n')
    # DO-NOT-DELETE splicer.end(visitEnumeration)

  def visitEnumerator(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Enumerator
    # DO-NOT-DELETE splicer.begin(visitEnumerator)
    if node.getInitialized():
      self.write('<a name="'+node.getFullIdentifier()+'">'+node.getIdentifier()+' = '+str(node.getValue()))
    else:
      self.write('<a name="'+node.getFullIdentifier()+'">'+node.getIdentifier())
    # DO-NOT-DELETE splicer.end(visitEnumerator)

  def visitArray(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Array
    # DO-NOT-DELETE splicer.begin(visitArray)
    self.write('array&lt;')
    self.visitType(node.getType())
    if node.getDimension() > 0:
      self.write(', '+str(node.getDimension())+'&gt;')
    else:
      self.write('&gt;')
    # DO-NOT-DELETE splicer.end(visitArray)

  def visitParameter(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Parameter
    # DO-NOT-DELETE splicer.begin(visitParameter)
    if node.getCopy():
      self.write(' '+self.getHTMLReservedWord('copy')+' ')
    mode = node.getAccessMode()
    if mode == SIDLLanguage.ParameterAccessMode.IN:
      self.write(self.getHTMLReservedWord('in')+' ')
    elif mode == SIDLLanguage.ParameterAccessMode.INOUT:
      self.write(self.getHTMLReservedWord('inout')+' ')
    elif mode == SIDLLanguage.ParameterAccessMode.OUT:
      self.write(self.getHTMLReservedWord('out')+' ')
    else:
      self.raiseVisitorException('Invalid parameter access mode: '+str(mode))
    self.visitType(node.getType())
    self.write(' '+node.getIdentifier())
    # DO-NOT-DELETE splicer.end(visitParameter)

  def visitComment(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Comment
    # DO-NOT-DELETE splicer.begin(visitComment)
    # strip <p>, </p> and <br> from comments
    comment = re.sub('<p>',  '', node.getComment())
    comment = re.sub('</p>', '', comment)
    comment = re.sub('<br>', '', comment)
    # print each line of multiline comments seperately
    for comment in comment.split('\n'):
      self.println('<font color="red">'+comment+'</font>');
    # DO-NOT-DELETE splicer.end(visitComment)

# DO-NOT-DELETE splicer.begin(_final)
  def raiseVisitorException(self, message, trace = ''):
    e = SIDLLanguage.VisitorException.VisitorException()
    e.setMessage(message)
    if isinstance(trace, list):
      for line in trace: e.addToStackTrace(line.strip())
    elif trace:
      e.addToStackTrace(trace)
    e.addToTrace(__file__, sys._getframe(1).f_lineno, sys._getframe().f_code.co_name)
    raise SIDLLanguage.VisitorException.Exception, e

  def defaultVisit(self, ast):
    try:
      for child in ast.getChildren():
        child.accept(self.__IORself)
    except SIDLLanguage.ASTException.Exception, e:
      self.raiseVisitorException(e.getMessage(), e.getStackTrace().strip())
    return

  def defaultVisitComment(self, ast):
    try:
      for comment in ast.getComments():
        comment.accept(self.__IORself)
    except SIDLLanguage.ASTException.Exception, e:
      self.raiseVisitorException(e.getMessage(), e.getStackTrace().strip())
    return

  def getHTMLReservedWord(self, word):
    return '<font color="darkgreen">'+word+'</font>'

  def getHTMLIdentifier(self, word):
    return '<b>'+word+'</b>'

  def increaseTabLevel(self, inc = 1):
    if inc < 0: self.raiseVisitorException('Invalid tab level increase: '+str(inc))
    self.tabLevel += inc
    return self.tabLevel

  def decreaseTabLevel(self, inc = 1):
    if inc < 0: self.raiseVisitorException('Invalid tab level decrease: '+str(inc))
    self.tabLevel -= inc
    if self.tabLevel < 0: self.raiseVisitorException('Tab level decreased below zero: '+str(self.tabLevel))
    return self.tabLevel

  def indent(self):
    for i in range(self.tabLevel):
      self.write(self.tab)
    return

  def write(self, str):
    self.fd.write(str)
    return

  def println(self, str):
    self.indent()
    self.write(str+'<br>\n')
    return

  def getRootURI(self, node):
    return node.getFullIdentifier().split('.')[0]+'.html'

  def getURI(self, node):
    return self.getRootURI(node)+'#'+node.getFullIdentifier()

  def getQualifiedName(self, node, packageName):
    qualifiedName = node.getFullIdentifier()
    if qualifiedName.startswith(packageName):
      qualifiedName = node.getIdentifier()
    return qualifiedName

  def getIORExceptions(self, method):
    exceptions = []
    for exception in method.getExceptions():
      if not exception.getFullIdentifier() == 'SIDL.NullIORException' and not exception.getFullIdentifier() == 'SIDL.BaseException':
        exceptions.append(exception)
    return exceptions
# DO-NOT-DELETE splicer.end(_final)

