# DO-NOT-DELETE splicer.begin(_initial)
import sys
import os
# DO-NOT-DELETE splicer.end(_initial)

import SIDL.NullIORException
import SIDL.BaseException
import SIDL.BaseInterface
import SIDLLanguage.VisitorException
import SIDLLanguage.Splicer
import SIDLLanguage.Code
import SIDLLanguage.AST
import SIDLLanguage.Specification
import SIDLLanguage.Version
import SIDLLanguage.Package
import SIDLLanguage.Interface
import SIDLLanguage.Class
import SIDLLanguage.Method
import SIDLLanguage.Type
import SIDLLanguage.Enumeration
import SIDLLanguage.Enumerator
import SIDLLanguage.Array
import SIDLLanguage.Parameter
import SIDLLanguage.Comment

# DO-NOT-DELETE splicer.begin(_before_type)
import SIDLLanguage.ParameterAccessMode
# DO-NOT-DELETE splicer.end(_before_type)

class PrettyPrinter:
  '''
  // Print the AST to stdout as SIDL
  '''
  # All calls to SIDL methods should use __IORself

  def __init__(self, IORself):
    self.__IORself = IORself
    # DO-NOT-DELETE splicer.begin(__init__)
    self.tab             = '  '
    self.tabLevel        = 0
    self.currentPackage  = None
    self.previousPackage = None
    self.roots           = {}
    self.outputFiles     = []
    self.file            = sys.stdout
    # DO-NOT-DELETE splicer.end(__init__)

  def setFilename(self, filename):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # filename string
    # DO-NOT-DELETE splicer.begin(setFilename)
    self.file = open(filename,'w')
    # DO-NOT-DELETE splicer.end(setFilename)

  def getRoot(self, purpose):
    '''
    // Get the root directory for output
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # purpose string
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # string _return
    # DO-NOT-DELETE splicer.begin(getRoot)
    if self.roots.has_key(purpose):
      return self.roots[purpose]
    else:
      return None
    # DO-NOT-DELETE splicer.end(getRoot)

  def setRoot(self, purpose, path):
    '''
    // Set the root directory for output
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # purpose string
    # path string
    # DO-NOT-DELETE splicer.begin(setRoot)
    self.roots[purpose] = path
    # DO-NOT-DELETE splicer.end(setRoot)

  def getOutputSource(self):
    '''
    // Get the flag determining whether source is output
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # bool _return
    # DO-NOT-DELETE splicer.begin(getOutputSource)
    return 0
    # DO-NOT-DELETE splicer.end(getOutputSource)

  def setOutputSource(self, outputSource):
    '''
    // Set the flag determining whether source is output
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # outputSource bool
    # DO-NOT-DELETE splicer.begin(setOutputSource)
    return
    # DO-NOT-DELETE splicer.end(setOutputSource)

  def getSplicer(self):
    '''
    // Retrieve the splicer used for preserving implementation blocks
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # SIDLLanguage.Splicer _return
    # DO-NOT-DELETE splicer.begin(getSplicer)
    return
    # DO-NOT-DELETE splicer.end(getSplicer)

  def setSplicer(self, splicer):
    '''
    // Set the splicer used for preserving implementation blocks
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # splicer SIDLLanguage.Splicer
    # DO-NOT-DELETE splicer.begin(setSplicer)
    return
    # DO-NOT-DELETE splicer.end(setSplicer)

  def getCodeOutput(self):
    '''
    // Retrieve the Code object used for output
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # SIDLLanguage.Code _return
    # DO-NOT-DELETE splicer.begin(getCodeOutput)
    return
    # DO-NOT-DELETE splicer.end(getCodeOutput)

  def setCodeOutput(self, output):
    '''
    // Set the Code object used for output
    //   Obviously here we need a persistent object which can output many source blocks
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # output SIDLLanguage.Code
    # DO-NOT-DELETE splicer.begin(setCodeOutput)
    return
    # DO-NOT-DELETE splicer.end(setCodeOutput)

  def getOutputFiles(self):
    '''
    // Retrieve all the created files
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # array _return
    # DO-NOT-DELETE splicer.begin(getOutputFiles)
    return self.outputFiles
    # DO-NOT-DELETE splicer.end(getOutputFiles)

  def clearOutputFiles(self):
    '''
    // Clear the list of created files
    '''
    # DO-NOT-DELETE splicer.begin(clearOutputFiles)
    self.outputFiles = []
    # DO-NOT-DELETE splicer.end(clearOutputFiles)

  def getRepository(self):
    '''
    // Retrieve auxilliary ASTs
    '''
    # SIDL EXPECTED RETURN TYPES (returned as a tuple or single value)
    # ================================================================
    # array _return
    # DO-NOT-DELETE splicer.begin(getRepository)
    return []
    # DO-NOT-DELETE splicer.end(getRepository)

  def setRepository(self, repository):
    '''
    // Set auxilliary ASTs
    '''
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # repository array
    # DO-NOT-DELETE splicer.begin(setRepository)
    # Put your code here...
    pass
    # DO-NOT-DELETE splicer.end(setRepository)

  def visitAST(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.AST
    # DO-NOT-DELETE splicer.begin(visitAST)
    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitAST)

  def visitSpecification(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Specification
    # DO-NOT-DELETE splicer.begin(visitSpecification)
    self.defaultVisit(node)
    # DO-NOT-DELETE splicer.end(visitSpecification)

  def visitVersion(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Version
    # DO-NOT-DELETE splicer.begin(visitVersion)
    self.defaultVisitComment(node)
    self.println('//version '+node.getIdentifier()+' '+node.getNumber())
    # DO-NOT-DELETE splicer.end(visitVersion)

  def visitPackage(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Package
    # DO-NOT-DELETE splicer.begin(visitPackage)
    self.println('')
    self.previousPackage = self.currentPackage
    self.currentPackage  = node.getFullIdentifier()
    self.defaultVisitComment(node)
    self.println('package '+node.getIdentifier()+' {')
    self.increaseTabLevel()
    self.defaultVisit(node)
    self.decreaseTabLevel()
    self.println('}')
    self.currentPackage = self.previousPackage
    # DO-NOT-DELETE splicer.end(visitPackage)

  def visitInterface(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Interface
    # DO-NOT-DELETE splicer.begin(visitInterface)
    self.println('')
    self.defaultVisitComment(node)
    decl    = 'interface '+node.getIdentifier()
    parents = node.getParents()
    if len(parents):
      decl += ' extends '
      for i in range(len(parents)):
        if i > 0: decl += ', '
        decl += self.getQualifiedName(parents[i], self.currentPackage)
    decl += ' {'
    self.println(decl)
    self.increaseTabLevel()
    self.defaultVisit(node)
    self.decreaseTabLevel()
    self.println('}')
    # DO-NOT-DELETE splicer.end(visitInterface)

  def visitClass(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Class
    # DO-NOT-DELETE splicer.begin(visitClass)
    self.println('')
    self.defaultVisitComment(node)
    decl    = 'class '+node.getIdentifier()
    parents = node.getParents()
    if len(parents):
      decl += ' extends '
      for i in range(len(parents)):
        if i > 0: decl += ', '
        decl += self.getQualifiedName(parents[i], self.currentPackage)
    interfaces = node.getInterfaces()
    if len(interfaces):
      decl += ' implements '
      for i in range(len(interfaces)):
        if i > 0: decl += ', '
        decl += self.getQualifiedName(interfaces[i], self.currentPackage)
    decl += ' {'
    self.println(decl)
    self.increaseTabLevel()
    self.defaultVisit(node)
    self.decreaseTabLevel()
    self.println('}')
    # DO-NOT-DELETE splicer.end(visitClass)

  def visitMethod(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Method
    # DO-NOT-DELETE splicer.begin(visitMethod)
    self.println('')
    self.defaultVisitComment(node)
    self.indent()
    if node.getStatic():
      self.write('static ')
    self.defaultVisitType(node.getReturnType())
    self.write(' '+node.getIdentifier()+'(')
    children = node.getChildren()
    try:
      for c in range(len(children)):
        if c > 0: self.write(', ')
        children[c].accept(self.__IORself)
    except SIDLLanguage.ASTException.Exception, e:
      self.raiseVisitorException(e.getMessage(), e.getStackTrace().strip())
    self.write(')')
    exceptions = self.getIORExceptions(node)
    if len(exceptions) > 0:
      self.write(' throws ')
      for e in range(len(exceptions)):
        if e > 0: self.write(', ')
        self.write(self.getQualifiedName(exceptions[e], self.currentPackage))
    self.write(';\n')
    # DO-NOT-DELETE splicer.end(visitMethod)

  def visitType(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Type
    # DO-NOT-DELETE splicer.begin(visitType)
    if node.getBaseType():
      self.write(node.getIdentifier())
    else:
      self.write(self.getQualifiedName(node, self.currentPackage))
    # DO-NOT-DELETE splicer.end(visitType)

  def visitEnumeration(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Enumeration
    # DO-NOT-DELETE splicer.begin(visitEnumeration)
    self.println('')
    self.defaultVisitComment(node)
    self.indent()
    self.write('enum '+node.getIdentifier())
    children = node.getChildren()
    try:
      if len(children) > 0:
        self.write(' {')
        for e in range(len(children)):
          if e > 0: self.write(', ')
          children[e].accept(self.__IORself)
    except SIDLLanguage.ASTException.Exception, e:
      self.raiseVisitorException(e.getMessage(), e.getStackTrace().strip())
    self.write('}')
    self.write(';\n')
    # DO-NOT-DELETE splicer.end(visitEnumeration)

  def visitEnumerator(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Enumerator
    # DO-NOT-DELETE splicer.begin(visitEnumerator)
    if node.getInitialized():
      self.write(node.getIdentifier()+' = '+str(node.getValue()))
    else:
      self.write(node.getIdentifier())
    # DO-NOT-DELETE splicer.end(visitEnumerator)

  def visitArray(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Array
    # DO-NOT-DELETE splicer.begin(visitArray)
    self.write('array<')
    self.defaultVisitType(node.getType())
    if node.getDimension() > 0:
      self.write(', '+str(node.getDimension())+'>')
    else:
      self.write('>')
    # DO-NOT-DELETE splicer.end(visitArray)

  def visitParameter(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Parameter
    # DO-NOT-DELETE splicer.begin(visitParameter)
    if node.getCopy(): self.write(' copy ')
    mode = node.getAccessMode()
    if mode == SIDLLanguage.ParameterAccessMode.IN:
      self.write('in ')
    elif mode == SIDLLanguage.ParameterAccessMode.INOUT:
      self.write('inout ')
    elif mode == SIDLLanguage.ParameterAccessMode.OUT:
      self.write('out ')
    else:
      self.raiseVisitorException('Invalid parameter access mode: '+str(mode))
    self.defaultVisitType(node.getType())
    self.write(' '+node.getIdentifier())
    # DO-NOT-DELETE splicer.end(visitParameter)

  def visitComment(self, node):
    # SIDL EXPECTED INCOMING TYPES
    # ============================
    # node SIDLLanguage.Comment
    # DO-NOT-DELETE splicer.begin(visitComment)
    self.println(node.getComment());
    # DO-NOT-DELETE splicer.end(visitComment)

# DO-NOT-DELETE splicer.begin(_final)
  def raiseVisitorException(self, message, trace = ''):
    e = SIDLLanguage.VisitorException.VisitorException()
    e.setMessage(message)
    if isinstance(trace, list):
      for line in trace: e.addToStackTrace(line.strip())
    elif trace:
      e.addToStackTrace(trace)
    e.addToTrace(__file__, sys._getframe(1).f_lineno, sys._getframe().f_code.co_name)
    raise SIDLLanguage.VisitorException.Exception, e

  def defaultVisit(self, ast):
    try:
      for child in ast.getChildren():
        child.accept(self.__IORself)
    except SIDLLanguage.ASTException.Exception, e:
      self.raiseVisitorException(e.getMessage(), e.getStackTrace().strip())
    return

  def defaultVisitType(self, type):
    if type.isInstanceOf('SIDLLanguage.Array'):
      self.visitArray(SIDLLanguage.Array.Array(type))
    else:
      self.visitType(type)
    return

  def defaultVisitComment(self, ast):
    try:
      for comment in ast.getComments():
        comment.accept(self.__IORself)
    except SIDLLanguage.ASTException.Exception, e:
      self.raiseVisitorException(e.getMessage(), e.getStackTrace().strip())
    return

  def increaseTabLevel(self, inc = 1):
    if inc < 0: self.raiseVisitorException('Invalid tab level increase: '+str(inc))
    self.tabLevel += inc
    return self.tabLevel

  def decreaseTabLevel(self, inc = 1):
    if inc < 0: self.raiseVisitorException('Invalid tab level decrease: '+str(inc))
    self.tabLevel -= inc
    if self.tabLevel < 0: self.raiseVisitorException('Tab level decreased below zero: '+str(self.tabLevel))
    return self.tabLevel

  def indent(self):
    for i in range(self.tabLevel):
      self.write(self.tab)
    return

  def write(self, str):
    self.file.write(str)
    return

  def println(self, str):
    self.indent()
    self.write(str)
    self.write('\n')
    return

  def getQualifiedName(self, node, packageName):
    qualifiedName = node.getFullIdentifier()
    if qualifiedName.startswith(packageName):
      qualifiedName = node.getIdentifier()
    return qualifiedName

  def getIORExceptions(self, method):
    exceptions = []
    for exception in method.getExceptions():
      if not exception.getFullIdentifier() == 'SIDL.NullIORException':
        exceptions.append(exception)
    return exceptions
# DO-NOT-DELETE splicer.end(_final)

